Package: medfate
Type: Package
Title: Mediterranean Forest Simulation
Version: 5.1.0
Date: 2026-09-02
Authors@R: c(
	person('Miquel', 'De Cáceres', role=c('aut','cre', 'cph'),
	email='miquelcaceres@gmail.com', comment = c(ORCID = "0000-0001-7132-2080")),
	person('Nicolas', 'Martin-StPaul', role=c('aut'), comment = c(ORCID = "0000-0001-7574-0108")),
	person('Víctor', 'Granda', role='aut', comment = c(ORCID = "0000-0002-0469-1991")),
	person('Antoine', 'Cabon', role='aut', comment = c(ORCID = "0000-0001-6426-1726")),
  person('Arsène', 'Druel', role='aut', comment = c(ORCID = "0000-0002-3938-0085")),
	person('Julien', 'Ruffault', role='aut', comment = c(ORCID = "0000-0003-3647-8172")),
  person('Jordi', 'Martínez-Vilalta', role='ctb', comment = c(ORCID = "0000-0002-2332-7298")),
	person('Maurizio', 'Mencuccini', role='ctb', comment = c(ORCID = "0000-0003-0840-1477")),
	person('François', 'Pimont', role='ctb', comment = c(ORCID = "0000-0002-9842-6207")),
	person('Hervé', 'Cochard', role='ctb', comment = c(ORCID = "0000-0002-2727-7072")),
	person('Aitor', 'Améztegui', role='ctb', comment = c(ORCID = "0000-0003-2006-1559")),
	person('Léa', 'Veuillen', role='ctb', comment = c(ORCID = "0000-0002-2790-3627")),
	person('Shengli', 'Huang', role='ctb', comment = c(ORCID = "0000-0003-3927-7042")),
	person('John', 'Burkardt', role='cph', comment = c("Copyright holder of C++ code in 'incgamma.cpp'"))
	)
Description: Simulate Mediterranean forest functioning and dynamics using cohort-based description of vegetation [De Caceres et al. (2015) <doi:10.1016/j.agrformet.2015.06.012>; De Caceres et al. (2021) <doi:10.1016/j.agrformet.2020.108233>].
License: GPL (>= 2) | LGPL (>= 3)
URL: https://emf-creaf.github.io/medfate/,
        https://github.com/emf-creaf/medfate
BugReports: https://github.com/emf-creaf/medfate/issues
LazyLoad: yes
Depends: R (>= 3.5.0)
Imports: ggplot2 (>= 3.0.0), meteoland (>= 2.2.6), methods, Rcpp (>=
        1.0.6), RcppParallel, shiny, units
Suggests: testthat (>= 3.0.0), rlang, knitr, rmarkdown
LinkingTo: Rcpp, RcppArmadillo, RcppParallel, meteoland
SystemRequirements: GNU make
Encoding: UTF-8
NeedsCompilation: yes
Config/testthat/edition: 3
LazyData: true
Config/roxygen2/version: 8.0.0
Packaged: 2026-09-02 15:14:30 UTC; miquel
Author: Miquel De Cáceres [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0001-7132-2080>),
  Nicolas Martin-StPaul [aut] (ORCID:
    <https://orcid.org/0000-0001-7574-0108>),
  Víctor Granda [aut] (ORCID: <https://orcid.org/0000-0002-0469-1991>),
  Antoine Cabon [aut] (ORCID: <https://orcid.org/0000-0001-6426-1726>),
  Arsène Druel [aut] (ORCID: <https://orcid.org/0000-0002-3938-0085>),
  Julien Ruffault [aut] (ORCID: <https://orcid.org/0000-0003-3647-8172>),
  Jordi Martínez-Vilalta [ctb] (ORCID:
    <https://orcid.org/0000-0002-2332-7298>),
  Maurizio Mencuccini [ctb] (ORCID:
    <https://orcid.org/0000-0003-0840-1477>),
  François Pimont [ctb] (ORCID: <https://orcid.org/0000-0002-9842-6207>),
  Hervé Cochard [ctb] (ORCID: <https://orcid.org/0000-0002-2727-7072>),
  Aitor Améztegui [ctb] (ORCID: <https://orcid.org/0000-0003-2006-1559>),
  Léa Veuillen [ctb] (ORCID: <https://orcid.org/0000-0002-2790-3627>),
  Shengli Huang [ctb] (ORCID: <https://orcid.org/0000-0003-3927-7042>),
  John Burkardt [cph] (Copyright holder of C++ code in 'incgamma.cpp')
Maintainer: Miquel De Cáceres <miquelcaceres@gmail.com>
Repository: CRAN
Date/Publication: 2026-09-03 05:20:19 UTC
Built: R 4.5.2; aarch64-apple-darwin20; 2026-09-03 08:06:19 UTC; unix
Archs: medfate.so.dSYM

import(ggplot2)
import(shiny)
import(methods)
importFrom("RcppParallel", "RcppParallelLibs")
importFrom("meteoland", "utils_atmosphericPressure", "utils_averageDailyVP",
           "utils_saturationVP", "penman")
importFrom("stats", "aggregate","filter","median",
           "cor","quantile", "dnorm", "Gamma", "glm", "predict",
           "rpois", "rbinom", "runif", "uniroot")
importFrom("grDevices", "rainbow")
importFrom("graphics", "axis", "abline", "barplot", "legend", "lines", "matplot","mtext",
           "matlines", "par", "polygon","axis.Date")
importFrom("utils", "data", "setTxtProgressBar", "txtProgressBar")
useDynLib(medfate, .registration = TRUE)
exportPattern("^[[:alpha:]]+")

importFrom(Rcpp, evalCpp)
S3method(plot,pwb)
S3method(plot,pwb_day)
S3method(plot,aspwb)
S3method(plot,spwb)
S3method(plot,spwb_day)
S3method(plot,growth)
S3method(plot,growth_day)
S3method(plot,fordyn)
S3method(plot,forest)
S3method(plot,soil)

S3method(shinyplot,pwb)
S3method(shinyplot,pwb_day)
S3method(shinyplot,aspwb)
S3method(shinyplot,spwb)
S3method(shinyplot,spwb_day)
S3method(shinyplot,growth)
S3method(shinyplot,growth_day)
S3method(shinyplot,fordyn)
S3method(shinyplot,forest)

S3method(summary, pwb)
S3method(summary, aspwb)
S3method(summary, spwb)
S3method(summary, growth)
S3method(summary, forest)
S3method(summary, fordyn)
S3method(print, summary.forest)
S3method(summary, soil)

.forest_plot_choices<-function(){
  c("LeafAreaDensity", "RootDistribution", "FuelBulkDensity",
    "PARExtinction", "SWRExtinction", "WindExtinction")
}

#' Plot forest attributes
#'
#' Function for plotting vertical forest profiles.
#'
#' @param x An object of class \code{\link{forest}}.
#' @param SpParams A data frame with species parameters (see \code{\link{SpParamsMED}}).
#' @param type A string of the plot type: "LeafAreaDensity", "RootDistribution", "FuelBulkDensity", "PARExtinction", "SWRExtinction" or "WindExtinction". 
#' @param byCohorts A logical flag to separate profiles for each cohort.
#' @param bySpecies A logical flag to aggregate results by species.
#' @param includeHerbs A logical flag to include herbaceous layer in the profile.
#' @param \dots Additional parameters to vertical profiles
#' 
#' @return A ggplot or a shiny application, depending on the function.
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @details
#' The function is a common wrapper to specialized internal functions (see \code{\link{vprofile_leafAreaDensity}}).
#' 
#' @seealso \code{\link{forest}}, \code{\link{summary.forest}}, \code{\link{vprofile_leafAreaDensity}}
#' 
#' @examples 
#' data(exampleforest)
#' data(SpParamsMED)
#' plot(exampleforest, SpParamsMED)
#' 
#' @name plot.forest
plot.forest<-function(x, SpParams, type = "LeafAreaDensity", byCohorts = FALSE, bySpecies = FALSE, includeHerbs = FALSE, ...) {
  type = match.arg(type, .forest_plot_choices())
  if(type=="LeafAreaDensity") return(vprofile_leafAreaDensity(x, SpParams = SpParams, draw = TRUE, 
                                                              byCohorts = byCohorts, bySpecies = bySpecies,
                                                              includeHerbs = includeHerbs, ...))
  else if(type=="RootDistribution") return(vprofile_rootDistribution(x, SpParams = SpParams,  draw = TRUE, 
                                                                     bySpecies = bySpecies, ...))
  else if(type=="FuelBulkDensity") return(vprofile_fuelBulkDensity(x, SpParams = SpParams,  draw = TRUE, ...))
  else if(type=="PARExtinction") return(vprofile_PARExtinction(x, SpParams = SpParams,  draw = TRUE,
                                                               includeHerbs = includeHerbs, ...))
  else if(type=="SWRExtinction") return(vprofile_SWRExtinction(x, SpParams = SpParams,  draw = TRUE,
                                                               includeHerbs = includeHerbs, ...))
  else if(type=="WindExtinction") return(vprofile_windExtinction(x, SpParams = SpParams,  draw = TRUE,
                                                                 includeHerbs = includeHerbs, ...))
}


#' @rdname plot.forest
shinyplot.forest<-function(x, SpParams, ...){
  plot_main_choices = .forest_plot_choices()

  ui <- fluidPage(
    sidebarLayout(
      sidebarPanel(
        selectInput(
          inputId = "plot_main_type",
          label = "Category",
          choices = plot_main_choices,
          selected = plot_main_choices[1]
        ),
        checkboxInput(
          inputId = "bycohort_check",
          label = "Distinguish cohorts",
          value = FALSE
        ),
        checkboxInput(
          inputId = "byspecies_check",
          label = "Aggregation by species",
          value = FALSE
        ),
        checkboxInput(
          inputId = "includeherbs_check",
          label = "Include herbaceous layer",
          value = FALSE
        )
      ),
      mainPanel(
        plotOutput("forest_plot")
      )
    ),
    h4("Summary"),
    verbatimTextOutput("summary")
  )
  server <- function(input, output, session) {
    output$forest_plot <- renderPlot({
      plot(x, SpParams = SpParams, 
           type = input$plot_main_type, 
           byCohorts = input$bycohort_check,
           bySpecies = input$byspecies_check,
           includeHerbs = input$includeherbs_check)
    })
    output$summary <- renderPrint({
      summary(x, SpParams)
    })
  }
  
  shinyApp(ui = ui, server = server)
}

#' Control parameters for simulation models
#'
#' Creates a list control parameters default values for simulations
#' 
#' @param transpirationMode String containing transpiration model (either 'Granier', 'Sperry' or 'Sureau'). See \code{\link{spwbInput}}.
#' @param soilDomains String containing soil hydrology model (either 'buckets', 'single', 'dual' or 'none'). Option 'none' is meant to be used when flows in the bulk soil are dealt with externally. For the remaining options, see \code{\link{hydrology_soilWaterBalance}}.
#' @param rhizosphereOverlap String indicating the assumption with respect to rhizosphere overlap:
#'   \itemize{
#'      \item{\code{total}: All plants extract water from the same pools.}
#'      \item{\code{partial}: Plants partially share water pools, depending on soil moisture.}
#'      \item{\code{none}: Plants extract water from totally-independent water pools.}
#'   }
#' 
#' @details The function returns a list with default parameters. 
#' Users can change those defaults that need to be set to other values and use the list as input for model functions. 
#' The relevant parameters are different for each model function.
#' 
#' @return 
#' A list, with the following options (default values in brackets):
#' \itemize{
#'   \bold{General}:
#'     \itemize{
#'       \item{\code{verbose [= TRUE]}: Boolean flag to indicate console output during calculations. In function \code{fordyn} \code{verbose} is always set to FALSE.}
#'       \item{\code{fillMissingRootParams [= TRUE]}: Boolean flag to indicate that initializing functions should provide estimates for Z50 and Z95 if these are missing in the forest data. Note that if \code{fillMissingRootParams} is set to \code{FALSE} then simulations may fail if the user does not provide values for Z50 and Z95 in tree or shrub data.}
#'       \item{\code{fillMissingSpParams [= TRUE]}: Boolean flag to indicate that initializing functions should provide estimates for functional parameters if these are missing in the species parameter table \code{\link{SpParams}}. Note that if \code{fillMissingSpParams} is set to \code{FALSE} then simulations may fail if the user does not provide values for required parameters.}
#'       \item{\code{fillMissingWithGenusParams [=TRUE]}: Boolean flag to indicate that initializing functions should provide estimates from genus value, if species-level values are missing in the species parameter table \code{\link{SpParams}} but genus-level ones are not.}
#'       \item{\code{standResults [= TRUE]}: Boolean flag to keep stand-level results (in a data frame called 'Stand').}
#'       \item{\code{soilResults [= TRUE]}: Boolean flag to keep soil-level results (in a list called 'Soil').}
#'       \item{\code{soilPoolResults [= FALSE]}: Boolean flag to keep soil pool-level results (in a list called 'SoilPools'), if \code{rhizosphereOverlap!="total"}.}
#'       \item{\code{snowResults [= TRUE]}: Boolean flag to keep snow results (in a data frame called 'Snow').}
#'       \item{\code{plantResults [= TRUE]}: Boolean flag to keep plant-level water/energy/photosynthesis results (in a list called 'Plants').}
#'       \item{\code{labileCarbonBalanceResults [= TRUE]}: Boolean flag to keep plant-level labile carbon balance results (in a list called 'LabileCarbonBalance').}
#'       \item{\code{plantStructureResults [= TRUE]}: Boolean flag to keep plant-level structure results (in a list called 'PlantStructure').}
#'       \item{\code{growthMortalityResults [= TRUE]}: Boolean flag to keep plant-level growth and mortality results (in a list called 'GrowthMortality').}
#'       \item{\code{decompositionPoolResults [= TRUE]}: Boolean flag to keep decomposition pool results (in a data frame called 'DecompositionPools').}
#'       \item{\code{leafResults [= TRUE]}: Boolean flag to keep leaf-level results (in elements called 'SunlitLeaves' and 'ShadeLeaves').}
#'       \item{\code{temperatureResults [= TRUE]}: Boolean flag to keep temperature results (in elements called 'Temperature' and 'TemperatureLayers').}
#'       \item{\code{subdailyResults [= FALSE]}: Boolean flag to force subdaily results to be stored (as a list called 'subdaily' of \code{\link{spwb_day}} objects, one by simulated date) in calls to \code{\link{spwb}}. In function \code{fordyn} \code{subdailyResults} is always set to FALSE.}
#'       \item{\code{fireHazardResults [= FALSE]}: Boolean flag to force calculation of daily fire hazard.}
#'       \item{\code{fireHazardStandardWind [= NA]}: Wind speed (in m/s) for fire-hazard estimation. If missing, actual wind-speed is used.}
#'       \item{\code{fireHazardStandardDFMC [= NA]}: Dead fuel moisture content for fire-hazard estimation. If missing, estimation from current weather is used.}
#'     }
#'   \bold{Water balance} (functions \code{\link{spwb}}, \code{\link{pwb}} or \code{\link{spwb_day}}):
#'     \itemize{
#'       \item{\code{transpirationMode [= "Granier"]}: Transpiration model (either 'Granier', 'Sperry' or 'Sureau'). See \code{\link{spwbInput}}.}
#'       \item{\code{soilFunctions [= "VG"]}: Soil water retention curve and conductivity functions, either 'SX' (for Saxton) or 'VG' (for Van Genuchten). 
#'                  If \code{transpirationMode} is 'Sperry' or 'Sureau' then soilFunctions is forced to \code{'VG'}.
#'                  Only simulations with 'Granier' are allowed to use Saxton functions.}
#'       \item{\code{truncateRootDistribution [= FALSE]}: Boolean flag to indicate that fine root distribution is to be truncated (i.e. Z100 is estimated from Z95 when not provided).}
#'       \item{\code{VG_PTF}: String indicating the pedotransfer functions for van Genuchten parameters (either 'Toth' or 'Carsel').}
#'       \item{\code{ndailysteps [= 24]}: Number of steps into which each day is divided for determination of soil water balance, stomatal conductance, transpiration and photosynthesis (24 equals 1-hour intervals).}
#'       \item{\code{max_nsubsteps_soil [= 300]}: Maximum number of substeps for soil water balance solving.}
#'       \item{\code{defaultWindSpeed [= 2.5]}: Default wind speed value (in m/s) to be used when missing from data. }
#'       \item{\code{defaultCO2 [= 386]}: Default atmospheric (abovecanopy) CO2 concentration (in micromol·mol-1 = ppm). This value will be used whenever CO2 concentration is not specified in the weather input. }
#'       \item{\code{defaultRainfallIntensityPerMonth [= c(1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 5.6, 5.6, 5.6, 5.6, 5.6, 1.5)]}: A vector of twelve values indicating the rainfall intensity (mm/h) per month. 
#'       By default synoptic storms (1.5 mm/h) are assumed between December and June, and convective storms (5.6 mm/h) are assumed between July and November.}
#'       \item{\code{leafPhenology [= TRUE]}: Boolean flag to indicate the simulation of leaf phenology for winter-deciduous species.}
#'       \item{\code{bareSoilEvaporation [= TRUE]}: Boolean flag to indicate the simulation of evaporation from bare soil.}
#'       \item{\code{unlimitedSoilWater [= FALSE]}: Boolean flag to indicate the simulation of plant transpiration assuming that soil water is always at field capacity.}
#'       \item{\code{unfoldingDD [= 300]}: Degree-days for complete leaf unfolding after budburst has occurred.}
#'       \item{\code{interceptionMode [= "Gash1995"]}: Infiltration model, either "Gash1995" or "Liu2001".}
#'       \item{\code{infiltrationMode [= "GreenAmpt1911"]}: Infiltration model, either "GreenAmpt1911" or "Boughton1989".}
#'       \item{\code{infiltrationCorrection [= 5.0]}: Factor to correct infiltration amount in the GreenAmpt1911 model in single-domain simulations.}
#'       \item{\code{soilDomains [= "buckets"]}: Either 'buckets' (for multi-bucket model), 'single' (for single-domain Richards model) or 'dual' (for dual-permeability model). See \code{\link{hydrology_soilWaterBalance}}.}
#'       \item{\code{rhizosphereOverlap [= "partial"]}: A string indicating the degree of rhizosphere spatial overlap between plant cohorts:
#'           \itemize{
#'             \item{"none" - no overlap (independent water pools).}
#'             \item{"partial" - plants partially share water pools, depending on soil moisture.}
#'             \item{"total" - total overlap (plants extract from common soil pools).}
#'           }
#'       }
#'       \item{\code{fullRhizosphereOverlapConductivity [= 0.01]}: The minimum soil hydraulic conductivity (in cm/day) allowing a full connectivity of water pools, when \code{rhizosphereOverlap = "partial"}.}
#'       \item{\code{verticalLayerSize [= 100]}: Size of vertical layers (in cm) for the calculation of light extinction (and photosynthesis).}
#'       \item{\code{windMeasurementHeight [= 200]}: Height (in cm) over the canopy corresponding to wind measurements.}
#'       \item{\code{segmentedXylemVulnerability [= TRUE/FALSE]}: If \code{FALSE} leaf and root vulnerability curves will be equal to those of stem. By default, \code{segmentedXylemVulnerability = TRUE} for \code{transpirationMode = "Sperry"} and \code{segmentedXylemVulnerability = FALSE} for \code{transpirationMode = "Sureau"}.}
#'       \item{\code{leafCavitationEffects, stemCavitationEffects [= FALSE/TRUE]}: A flag indicating whether cavitation effects on conductance of leaves and stem are applied. Only relevant for \code{transpirationMode = "Sperry"}.}
#'       \item{\code{leafCavitationRecovery, stemCavitationRecovery [= "rate"]}: A string indicating how recovery of previous cavitation leaf/stem xylem is done (only relevant for functions \code{\link{spwb}} and \code{\link{spwb_day}}):
#'           \itemize{
#'             \item{"none" - no recovery.}
#'             \item{"annual" - every first day of the year.}
#'             \item{"rate" - following a rate of new leaf or sapwood formation.}
#'             \item{"total" - instantaneous complete recovery.}
#'           }
#'       }
#'       \item{\code{cavitationRecoveryMaximumRate [= 0.05]}: Maximum rate of daily refilling of embolized conduits as sapwood area per leaf area (in cm2·m-2·day-1).}
#'       \item{\code{cavitationInducedDefoliation [= TRUE]}: Whether leaf hydraulic impairment induces defoliation (88 % PLC will correspond to 50 % defoliation).}
#'       \item{\code{lfmcComponent [= "fine"]}: Plant component used to estimate LFMC, either "leaf" or "fine" (for fine fuel).}
#'     }
#'   \bold{Water balance} (functions \code{\link{spwb}}, \code{\link{pwb}} or \code{\link{spwb_day}} when \code{traspirationMode = "Granier"} only):
#'     \itemize{
#'       \item{\code{hydraulicRedistributionFraction [= 0.1]}: Fraction of plant transpiration corresponding to hydraulic redistribution.}
#'     }
#'   \bold{Water balance} (functions \code{\link{spwb}}, \code{\link{pwb}} or \code{\link{spwb_day}} when \code{traspirationMode = "Sperry"} or \code{traspirationMode = "Sureau"}):
#'     \itemize{
#'       \item{\code{nsubsteps_canopy [= 3600]}: Number of substeps into which each step is divided for multi-layer canopy energy balance solving.}
#'       \item{\code{multiLayerBalance [= FALSE]}: Flag to indicate multiple canopy energy balance. If \code{FALSE}, canopy is considered a single layer for energy balance.}
#'       \item{\code{sapFluidityVariation [= TRUE]}: Flag to indicate that temperature affects sap fluidity (and indirectly plant conductance).}
#'       \item{\code{TPhase_gmin [= 37.5]}: Temperature for transition phase of gmin.}
#'       \item{\code{Q10_1_gmin [= 1.2]}: Temperature dependance of gmin when T less than or equal to TPhase.}
#'       \item{\code{Q10_2_gmin [= 4.8]}: Temperature dependance of gmin when T greater than TPhase.}
#'       \item{\code{taper [= TRUE]}: Whether taper of xylem conduits is accounted for when calculating aboveground stem conductance from xylem conductivity.}
#'       \item{\code{thermalCapacityLAI [= 1000000]}: Thermal canopy capacitance per LAI unit.}
#'       \item{\code{rootRadialConductance [= 4]}: Radial conductance in roots (mmol·s-1·m-2·MPa-1).}
#'       \item{\code{averageFracRhizosphereResistance [= 0.15]}: Fraction to total continuum (leaf+stem+root+rhizosphere) resistance that corresponds to rhizosphere (averaged across soil water potential values).}
#'       \item{\code{boundaryLayerSize [= 2000]}: Size of the boundary layer (in cm) over the canopy (relevant for multi-layer canopy energy balance).}
#'     }
#'   
#'   \bold{Water balance} (functions \code{\link{spwb}}, \code{\link{pwb}} or \code{\link{spwb_day}} when \code{traspirationMode = "Sperry"} only):
#'     \itemize{
#'       \item{\code{numericParams}: A list with the following elements:
#'           \itemize{
#'             \item{\code{maxNsteps [= 400]}: Maximum number of steps in supply function.}
#'             \item{\code{ntrial [= 200]}: Number of iteration trials when finding root of equation system.}
#'             \item{\code{psiTol [= 0.0001]}: Tolerance value for water potential.}
#'             \item{\code{ETol [= 0.0001]}: Tolerance value for flow.}
#'           }
#'       }
#'     }
#'     
#'   \bold{Water balance} (functions \code{\link{spwb}}, \code{\link{pwb}} or \code{\link{spwb_day}} when \code{traspirationMode = "Sureau"} only):
#'     \itemize{
#'       \item{\code{plantCapacitance [= TRUE]}: Whether the effect of (symplasmic) plant water compartments is considered in simulations.}
#'       \item{\code{cavitationFlux [= TRUE]}: Whether the effect of water flux generated by cavitation of apoplasmic tissues is considered in simulations.}
#'       \item{\code{leafCuticularTranspiration [= TRUE]}: Whether the effect of leaf cuticular transpiration is considered in simulations.}
#'       \item{\code{stemCuticularTranspiration [= FALSE]}: Whether the effect of stem cuticular transpiration is considered in simulations.}
#'       \item{\code{C_SApoInit [= 2.0e-5]}: Maximum capacitance of the stem apoplasm (mmol·m-2).}
#'       \item{\code{C_LApoInit [= 1.0e-5]}: Maximum capacitance of the leaf apoplasm (mmol·m-2).}
#'       \item{\code{k_SSym [= 0.26]}: Conductance from stem apoplasm to stem symplasm (mmol·s-1·m-2·MPa-1).}
#'       \item{\code{fractionLeafSymplasm [= 0.5]}: Fraction of the leaf resistance from leaf apoplasm to leaf symplasm (\[0-1\]).}
#'       \item{\code{gs_NightFrac [= 0.05]}: Stomatal conductance at night as fraction of maximum stomatal conductance (\[0-1\]).}
#'       \item{\code{stomatalSubmodel [= "Baldocchi"]}: Stomatal regulation sub-model, either "Jarvis" or "Baldocchi".}
#'       \item{\code{JarvisPAR [= 0.003]}: Parameter regulating the response of stomatal conductance to light (PAR) in the Jarvis model.}
#'       \item{\code{fTRBToLeaf [= 0.8]}: Fraction of surface of bark exposed to air per leaf area.}
#'     }
#'     
#'   \bold{Forest growth} (functions \code{\link{growth}} or \code{\link{growth_day}}):
#'     \itemize{
#'       \item{\code{subdailyCarbonBalance [= FALSE]}: Boolean flag to indicate that labile carbon balance should be conducted at sub-daily steps (applies only to transpirationMode = "Sperry").}
#'       \item{\code{allowDessication [= TRUE]}: Boolean flag to indicate that mortality by dessication is allowed.}
#'       \item{\code{allowStarvation [= TRUE]}: Boolean flag to indicate that mortality by starvation is allowed.}
#'       \item{\code{sinkLimitation [= TRUE]}: Boolean flag to indicate that temperature and turgor limitations to growth are applied.}
#'       \item{\code{shrubDynamics [= TRUE]}: Boolean flag to allow the application of demographic processes to shrubs.}
#'       \item{\code{herbDynamics [= TRUE]}: Boolean flag to allow dynamic herb leaf area as a function of shading due to leaf area of woody cohorts.}
#'       \item{\code{allocationStrategy [= "Al2As"]}: Strategy for allocation (either "Plant_kmax", for constant maximum plant conductance, or "Al2As" for constant Huber value).}
#'       \item{\code{phloemConductanceFactor [= 0.2])}: Factor to transform stem xylem conductance to stem phloem conductance (only for transpirationMode = "Sperry").}
#'       \item{\code{nonSugarConcentration [= 0.25]}: Non-sugar (inorganic) solute concentration  (mol·l-1) in cells.}
#'       \item{\code{equilibriumOsmoticConcentration [=  c(leaf = 0.8, sapwood = 0.6)]}: Equilibrium osmotic concentrations (mol·l-1) for leaf and sapwood cells. The difference between leaf and sapwood values helps maintaining phloem transport. The equilibrium sugar concentration is \code{equilibriumOsmoticConcentration - nonSugarConcentration} defaults to \code{[= c(leaf = 0.55, sapwood = 0.35)]}. }
#'       \item{\code{minimumRelativeStarchForGrowth [= 0.50]}: Default minimum concentration of storage carbon (starch), relative to the maximum storage capacity, for sapwood growth to occur, when not specified via SpParams (\code{RSSG}). }
#'       \item{\code{constructionCosts [= c(leaf = 1.5, sapwood = 1.47, fineroot = 1.30)]}: Default construction costs, including respiration and structural carbon, per dry weight of new tissue (g gluc · g dry -1) when not specified via SpParams (\code{CCleaf}, \code{CCsapwood} and \code{CCfineroot}).}
#'       \item{\code{senescenceRates [= c(sapwood = 0.0001261398, fineroot = 0.001897231)]}: Default senescence rates (day-1) for sapwood and fineroots when not specified via SpParams (\code{SRsapwood} and \code{SRfineroot}). Defaults are equivalent to 9%, 5% and 50% annual turnover for gymnosperm sapwood, angiosperm sapwood and fine roots, respectively.}
#'       \item{\code{maximumRelativeGrowthRates [=   c(leaf = 0.09, cambium = 0.005, sapwood = 0.002, fineroot = 0.1)]}: Default maximum relative growth rates for leaves (m2 leaf ·cm-2 sapwood· day-1), tree sapwood (cm2 sapwood· cm-1 cambium · day-1), shrub sapwood (cm2 sapwood ·cm-2 sapwood· day-1) and fine roots (g dw · g dw -1 · day -1) when not specified via SpParams (\code{RGRleafmax}, \code{RGRcambiummax} , \code{RGRsapwoodmax} and \code{RGRfinerootmax}, respectively).}
#'       \item{\code{mortalityMode [= "density/deterministic"]}: String describing how mortality is applied. Current accepted values are combinations of "cohort" vs "density" (for whole-cohort mortality vs reduction of stem density) and "deterministic" vs. "stochastic".}
#'       \item{\code{mortalityBaselineRate [= 0.0015]}: Default deterministic proportion or probability specifying the baseline reduction of cohort's density occurring in a year (for \code{mortalityMode = "density/deterministic" or "density/stochastic").}}
#'       \item{\code{mortalityRelativeSugarThreshold [= 0.4]}: Threshold of stem sugar concentration relative to the equilibrium sugar concentration, resulting in an increased starvation mortality rate/probability whenever levels are below.}
#'       \item{\code{mortalityRWCThreshold [= 0.4]}: Threshold of stem relative water content resulting in increased mortality rate/probability whenever levels are below.}
#'       \item{\code{recrTreeDBH [= 1]}: Default DBH (cm) for recruited trees  (when species parameter \code{RecrTreeDBH} is missing).}
#'       \item{\code{recrTreeDensity [= 3000]}: Default density (ind·ha-1) for recruited trees  (when species parameter \code{RecrTreeDensity} is missing).}
#'       \item{\code{ingrowthTreeDBH [= 7.5]}: Default DBH (cm) for ingrowth trees  (when species parameter \code{IngrowthTreeDBH} is missing).}
#'       \item{\code{ingrowthTreeDensity [= 127]}: Default density (ind·ha-1) for ingrowth trees  (when species parameter \code{IngrowthTreeDensity} is missing).}
#'       \item{\code{decompositionAnnualBaseRates}: Vector of base annual decomposition rates (in yr-1) for different pools.}
#'       \item{\code{decompositionAnnualTurnoverRate [= 0.1]}: Annual turnover time for biome in the CENTURY model.}
#'    }
#'   \bold{Forest dynamics} (function \code{\link{fordyn}}):
#'    \itemize{
#'      \item{\code{allowSeedBankDynamics [= TRUE]}: Boolean flag to indicate that seed production and seed bank dynamics is simulated.}
#'      \item{\code{allowRecruitment [= TRUE]}: Boolean flag to indicate that recruitment from seeds is allowed.}
#'      \item{\code{allowResprouting [= TRUE]}: Boolean flag to indicate that resprouting is allowed.}
#'      \item{\code{recruitmentMode [= "annual/stochastic"]}: String describing how recruitment from seeds is applied. Current accepted values are "annual/deterministic", "annual/stochastic", "daily/deterministic" or "daily/stochastic".}
#'      \item{\code{removeEmptyCohorts [= TRUE]}: Boolean flag to indicate the removal of cohorts whose density is too low.}
#'      \item{\code{minimumTreeCohortDensity [= 1]}: Threshold of tree density resulting in cohort removal.}
#'      \item{\code{minimumShrubCohortCover [= 0.01]}: Threshold of shrub cover resulting in cohort removal.}
#'      \item{\code{dynamicallyMergeCohorts [= TRUE]}: Boolean flag to indicate that cohorts should be merged when possible. This option speeds up calculations but results in a loss of cohort identity and reinitialization of many state variables.}
#'      \item{\code{keepCohortsWithID [= TRUE]}: Boolean flag to indicate that cohorts having a non-missing value in a column \code{"ID"} (if present) should not be merged or removed.}
#'      \item{\code{seedRain [= NULL]}: Vector of species names whose seed rain is to be added to seed bank, regardless of local seed production.}
#'      \item{\code{seedProductionTreeHeight [= 300]}: Default minimum tree height for producing seeds (when species parameter \code{SeedProductionHeight} is missing).}
#'      \item{\code{seedProductionShrubHeight [= 30]}: Default minimum shrub height for producing seeds (when species parameter \code{SeedProductionHeight} is missing).}
#'      \item{\code{probRecr [= 0.05]}: Default annual probability of seed-recruitment (when species parameter \code{ProbRecr} is missing).}
#'      \item{\code{minTempRecr [= 0]}: Default threshold of minimum average temperature of the coldest month necessary for recruiting from seeds (when species parameter \code{MinTempRecr} is missing).} 
#'      \item{\code{minMoistureRecr [= 0.3]}: Default threshold of minimum moisture index (annual precipitation over annual ETP) necessary for seed-recruiting (when species parameter \code{MinMoistureRecr} is missing).} 
#'      \item{\code{minFPARRecr [= 10]}: Default threshold of minimum fraction of PAR (in %)  reaching the ground necessary for recruiting (when species parameter \code{MinFPARRecr} is missing).} 
#'      \item{\code{recrAge [= 5]}: Default recruitment age (in yrs).}
#'      \item{\code{recrTreeHeight [= 620]}: Default height (cm) for recruited trees  (when species parameter \code{RecrTreeHeight} is missing).}
#'      \item{\code{recrShrubCover [= 1]}: Default cover (%) for shrubs recruited from seed  (when species parameter \code{RecrShrubCover} is missing).}
#'      \item{\code{recrShrubHeight [= 25]}: Default height (cm) for recruited shrubs  (when species parameter \code{RecrShrubHeight} is missing).}
#'   }
#' }
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso \code{\link{spwbInput}}, \code{\link{spwb}}, \code{\link{growth}}, \code{\link{fordyn}}
#' 
#' @name defaultControl
defaultControl<-function(transpirationMode = "Granier", 
                         soilDomains = "buckets", 
                         rhizosphereOverlap = "partial") {
  transpirationMode <- match.arg(transpirationMode, c("Granier", "Sperry", "Cochard", "Sureau"))
  if(transpirationMode=="Cochard") transpirationMode = "Sureau"
  soilDomains <- match.arg(soilDomains, c("buckets", "single", "dual", "none"))
  rhizosphereOverlap <- match.arg(rhizosphereOverlap, c("total", "partial", "none"))
  l <- list(
    #For all functions
    fillMissingRootParams = TRUE,
    fillMissingSpParams = TRUE,
    fillMissingWithGenusParams = TRUE,
    verbose = TRUE,
    subdailyResults = FALSE,
    standResults = TRUE,
    soilResults = TRUE,
    soilPoolResults = FALSE,
    snowResults = TRUE,
    plantResults = TRUE,
    labileCarbonBalanceResults = TRUE,
    plantStructureResults = TRUE,
    growthMortalityResults = TRUE,
    decompositionPoolResults  = TRUE,
    leafResults = TRUE,
    temperatureResults = TRUE,
    fireHazardResults = FALSE,
    fireHazardStandardWind = NA,
    fireHazardStandardDFMC = NA,

    # For water balance
    transpirationMode = transpirationMode,
    soilDomains = soilDomains,
    rhizosphereOverlap = rhizosphereOverlap,
    truncateRootDistribution = FALSE,
    fullRhizosphereOverlapConductivity = 0.01,
    soilFunctions = "VG",
    VG_PTF = "Toth",
    ndailysteps = 24,
    max_nsubsteps_soil = 300,
    defaultWindSpeed = 2.5, #m/s
    defaultCO2 = 386, #ppm
    defaultRainfallIntensityPerMonth = c(1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 5.6, 5.6, 5.6, 5.6, 5.6, 1.5),
    leafPhenology = TRUE,
    bareSoilEvaporation = TRUE,
    unlimitedSoilWater = FALSE,
    interceptionMode = "Gash1995",
    infiltrationMode = "GreenAmpt1911",
    infiltrationCorrection = 5.0,
    unfoldingDD = 300,
    verticalLayerSize = 100,
    windMeasurementHeight = 200,
    segmentedXylemVulnerability = TRUE,
    stemCavitationRecovery = "rate",
    leafCavitationRecovery = "rate",
    lfmcComponent = "fine",
    cavitationInducedDefoliation = TRUE,
    
    #spwb with granier
    hydraulicRedistributionFraction = 0.1,
    
    #spwb with sperry/sureau
    nsubsteps_canopy = 3600,
    taper = TRUE,
    multiLayerBalance = FALSE,
    sapFluidityVariation = TRUE,
    TPhase_gmin = 37.5,
    Q10_1_gmin = 1.2,
    Q10_2_gmin = 4.8,
    rootRadialConductance = 4,
    averageFracRhizosphereResistance = 0.15,
    thermalCapacityLAI = 1000000,
    boundaryLayerSize = 2000,
    cavitationRecoveryMaximumRate = 0.05,
    sunlitShade = TRUE,

    #spwb with sperry
    numericParams=list(maxNsteps = 400, ntrial = 200, psiTol = 0.0001, ETol = 0.0000001),
    leafCavitationEffects = FALSE,
    stemCavitationEffects = TRUE,
    
    #spwb with sureau
    stomatalSubmodel = "Baldocchi",
    plantCapacitance = TRUE,
    cavitationFlux = TRUE,
    leafCuticularTranspiration = TRUE,
    stemCuticularTranspiration = FALSE,
    C_SApoInit = 2.0e-05,
    C_LApoInit = 1.0e-05,
    k_SSym = 0.26,
    fractionLeafSymplasm = 0.5,
    gs_NightFrac = 0.05,
    JarvisPAR = 0.003,
    fTRBToLeaf = 0.8,
    
    # growth/mortality
    subdailyCarbonBalance = FALSE,
    allowDessication = TRUE,
    allowStarvation = TRUE,
    sinkLimitation = TRUE,
    shrubDynamics = TRUE,
    herbDynamics = TRUE,
    allocationStrategy = "Al2As",
    phloemConductanceFactor = 0.2, # phloem conductance per leaf area basis (l*m-2*MPa-1*s-1)
    nonSugarConcentration = 0.25, # mol · l-1
    equilibriumOsmoticConcentration = list(leaf = 0.8, sapwood = 0.6),  # (Paljakka et al. 2017)
    minimumRelativeStarchForGrowth = 0.50,
    constructionCosts = list(leaf = 1.5, 
                             sapwood = 1.47, 
                             fineroot = 1.30), #  g gluc · g dw -1
    senescenceRates = list(sapwood = 0.000135, # day-1 Equivalent to annual 4.8% 1-(1-0.048)^(1.0/365)
                      fineroot = 0.001897231), #day-1 Equivalent to annual 50% 1-(1-0.5)^(1.0/365)
    maximumRelativeGrowthRates = list(leaf = 0.09, # m2 leaf ·cm-2 sapwood· day-1
                                      cambium = 0.0025, # cm2 sapwood ·cm-1 cambium· day-1
                                      sapwood = 0.002, # cm2 sapwood ·cm-2 sapwood· day-1
                                      fineroot = 0.1), # g dw · g dw -1 · day -1
    mortalityMode = "density/deterministic",
    mortalityBaselineRate = 0.0015,
    mortalityRelativeSugarThreshold = 0.4,
    mortalityRWCThreshold = 0.4,
    recrTreeDBH = 1,
    recrTreeDensity = 3000,
    ingrowthTreeDBH = 7.5,
    ingrowthTreeDensity = 127,
    decompositionAnnualBaseRates = c("SurfaceMetabolic" = 8.0, 
                                     "BelowgroundMetabolic" = 18.5, 
                                     "Leaves" = 2.0, 
                                     "FineRoots" = 4.9,
                                     "Twigs" =  1.8, 
                                     "SmallBranches" =  1.5, 
                                     "LargeWood" = 0.02, 
                                     "CoarseRoots" = 0.1, 
                                     "SurfaceActive" = 6.0, 
                                     "BelowgroundActive" = 11.0, 
                                     "SurfaceSlow" = 0.08, 
                                     "BelowgroundSlow" = 0.4, 
                                     "BelowgroundPassive" = 0.0033),
    decompositionAnnualTurnoverRate = 0.10,
    #dynamics
    allowSeedBankDynamics = TRUE,
    allowRecruitment = TRUE,
    allowResprouting = TRUE,
    recruitmentMode = "annual/stochastic",
    removeEmptyCohorts=TRUE,
    minimumTreeCohortDensity = 1,
    minimumShrubCohortCover = 0.01,
    dynamicallyMergeCohorts = TRUE,
    keepCohortsWithObsID = FALSE,
    seedRain = NULL,
    seedProductionTreeHeight = 300,
    seedProductionShrubHeight = 30,
    probRecr = 0.05,
    minTempRecr	= 0,
    minMoistureRecr	= 0.3,
    minFPARRecr = 10,
    recrAge = 5,
    recrTreeHeight = 620,
    recrShrubCover = 1,
    recrShrubHeight = 25
  )
  if(transpirationMode=="Sureau") l$segmentedXylemVulnerability = FALSE
  return(l)
}

library(medfate)

data(exampleforest)
data(SpParamsMED)


forest_herbs <- exampleforest
forest_herbs$herbData <- forest_herbs$shrubData

data(examplemeteo)
#Prepare a two-year meteorological data with half precipitation during 
#the second year
meteo2001 <- examplemeteo
meteo2002 <- examplemeteo
meteo2002$Precipitation <- meteo2002$Precipitation/2
meteo2002$dates <- seq(as.Date("2002-01-01"), 
                       as.Date("2002-12-31"), by="day")
meteo_01_02 <- rbind(meteo2001, meteo2002)
meteo_01_02_B <- meteo_01_02
meteo_01_02_B$dates <- as.Date(meteo_01_02_B$dates)
row.names(meteo_01_02_B) <- NULL

#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Initialize control parameters
control <- defaultControl("Granier")
control$verbose <- FALSE

#Initialize soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

test_that("fordyn can be run and continued in example, herbs and empty forests",{
  fd <- fordyn(exampleforest, examplesoil, 
               SpParamsMED, meteo_01_02, control,
               latitude = 41.82592, elevation = 100)
  expect_s3_class(fd, "fordyn")
  expect_s3_class(fordyn(fd, examplesoil, 
                         SpParamsMED, meteo_01_02, control,
                         latitude = 41.82592, elevation = 100), "fordyn")
  expect_s3_class(fordyn(forest_herbs, examplesoil,
                         SpParamsMED, meteo_01_02, control,
                         latitude = 41.82592, elevation = 100), "fordyn")
  expect_s3_class(fordyn(emptyforest(), examplesoil,
                         SpParamsMED, meteo_01_02, control,
                         latitude = 41.82592, elevation = 100), "fordyn")
})

test_that("fordyn can be run using species codes",{
  f <- exampleforest
  f$treeData$Species <- c(148, 168)
  f$shrubData$Species <- 165
  expect_s3_class(fordyn(f, examplesoil,
                         SpParamsMED, meteo_01_02, control,
                         latitude = 41.82592, elevation = 100), "fordyn")
})
test_that("fordyn can be run using single soilDomains",{
  control_single <- control
  control_single$soilDomains <- "single"
  expect_s3_class(fordyn(exampleforest, examplesoil,
                         SpParamsMED, meteo_01_02, control_single,
                         latitude = 41.82592, elevation = 100), "fordyn")
})

test_that("fordyn can be run using dual soilDomains",{
  control_dual <- control
  control_dual$soilDomains <- "dual"
  expect_s3_class(fordyn(exampleforest, examplesoil,
                         SpParamsMED, meteo_01_02, control_dual,
                         latitude = 41.82592, elevation = 100), "fordyn")
})

test_that("fordyn can be run using partial rhizosphere overlap",{
  control_partial_overlap <- control
  control_partial_overlap$rhizosphereOverlap <- "partial"
  expect_s3_class(fordyn(exampleforest, examplesoil,
                         SpParamsMED, meteo_01_02, control_partial_overlap,
                         latitude = 41.82592, elevation = 100), "fordyn")
})

test_that("fordyn can be run using different recruitment modes",{
  control_recr <- control
  for(mode in c("annual/stochastic", "annual/deterministic", "daily/stochastic", "daily/deterministic")) {
    control_recr$recruitmentMode <- mode
    expect_s3_class(fordyn(exampleforest, examplesoil,
                           SpParamsMED, meteo_01_02, control_recr,
                           latitude = 41.82592, elevation = 100), "fordyn")
  }
})

test_that("fordyn can be run in example, herbs and empty forests using management",{
  expect_s3_class(fordyn(exampleforest, examplesoil,
                         SpParamsMED, meteo_01_02, control,
                         latitude = 41.82592, elevation = 100,
                         management_function = defaultManagementFunction,
                         management_args = defaultManagementArguments()), "fordyn")
  expect_s3_class(fordyn(forest_herbs, examplesoil,
                         SpParamsMED, meteo_01_02, control,
                         latitude = 41.82592, elevation = 100,
                         management_function = defaultManagementFunction,
                         management_args = defaultManagementArguments()), "fordyn")
  expect_s3_class(fordyn(emptyforest(), examplesoil,
                         SpParamsMED, meteo_01_02, control,
                         latitude = 41.82592, elevation = 100,
                         management_function = defaultManagementFunction,
                         management_args = defaultManagementArguments()), "fordyn")
})
test_that("fordyn can be run with fire hazard results",{
  expect_s3_class(fordyn(exampleforest, examplesoil,
                         SpParamsMED, meteo_01_02, control,
                         latitude = 41.82592, elevation = 100), "fordyn")
})
test_that("fordyn can be run using dates as columns",{
  control_fh <- control
  control_fh$fireHazardResults <- TRUE
  expect_s3_class(fordyn(exampleforest, examplesoil,
                         SpParamsMED, meteo_01_02_B, control_fh,
                         latitude = 41.82592, elevation = 100), "fordyn")
})

library(medfate)

data(exampleforest)
data(SpParamsMED)
data(examplemeteo)
examplemeteo2 <- examplemeteo
row.names(examplemeteo2) <- as.character(examplemeteo2$dates)
examplemeteo2$dates <- NULL
d <- 100
meteovec <- unlist(examplemeteo[d,-1])
date <- as.character(examplemeteo$dates[d])

control_granier <- defaultControl("Granier")
control_granier$verbose <- FALSE

#Initialize soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

oldVer <- "4.8.3"
test_that("spwb can be run with missing or older versions", {
  x_granier <- spwbInput(exampleforest, examplesoil, SpParamsMED, control_granier)
  x_granier$version <- oldVer
  s <- spwb(x_granier, 
            examplemeteo[1:10,],
            latitude = 41.82592, elevation = 100)
  expect_s3_class(s, "spwb")
  expect_equal(s$spwbOutput$version, as.character(packageVersion("medfate")))
  x_granier$version <- NULL
  s <- spwb(x_granier, 
            examplemeteo[1:10,],
            latitude = 41.82592, elevation = 100)
  expect_s3_class(s, "spwb")
  expect_equal(s$spwbOutput$version, as.character(packageVersion("medfate")))
})

test_that("spwb_day can be run with missing or older versions", {
  x_granier <- spwbInput(exampleforest, examplesoil, SpParamsMED, control_granier)
  x_granier$version <- oldVer
  s <- medfate::spwb_day(x_granier, date, meteovec, latitude = 41.82592, elevation = 100, slope=0, aspect=0, modifyInput = FALSE)
  expect_s3_class(s, "spwb_day")
  expect_equal(x_granier$version, as.character(packageVersion("medfate")))
  x_granier <- spwbInput(exampleforest, examplesoil, SpParamsMED, control_granier)
  x_granier$version <- NULL
  s <- medfate::spwb_day(x_granier, date, meteovec, latitude = 41.82592, elevation = 100, slope=0, aspect=0, modifyInput = FALSE)
  expect_s3_class(s, "spwb_day")
  # If new field is added, then the pointer is new
  # expect_equal(x_granier, as.character(packageVersion("medfate")))
})

test_that("growth can be run with missing or older versions", {
  x_granier <- growthInput(exampleforest, examplesoil, SpParamsMED, control_granier)
  x_granier$version <- oldVer
  s <- growth(x_granier, 
            examplemeteo[1:10,],
            latitude = 41.82592, elevation = 100)
  expect_s3_class(s, "growth")
  expect_equal(s$growthOutput$version, as.character(packageVersion("medfate")))
  x_granier$version <- NULL
  s <- growth(x_granier, 
            examplemeteo[1:10,],
            latitude = 41.82592, elevation = 100)
  expect_s3_class(s, "growth")
  expect_equal(s$growthOutput$version, as.character(packageVersion("medfate")))
})
test_that("growth_day can be run with missing or older versions", {
  x_granier <- growthInput(exampleforest, examplesoil, SpParamsMED, control_granier)
  x_granier$version <- oldVer
  s <- medfate::growth_day(x_granier, date, meteovec, latitude = 41.82592, elevation = 100, slope=0, aspect=0, modifyInput = FALSE)
  expect_s3_class(s, "growth_day")
  expect_equal(x_granier$version, as.character(packageVersion("medfate")))
  x_granier <- growthInput(exampleforest, examplesoil, SpParamsMED, control_granier)
  x_granier$version <- NULL
  s <- medfate::growth_day(x_granier, date, meteovec, latitude = 41.82592, elevation = 100, slope=0, aspect=0, modifyInput = FALSE)
  expect_s3_class(s, "growth_day")
  # If new field is added, then the pointer is new
  # expect_equal(x_granier, as.character(packageVersion("medfate")))
})

#Load example plot plant data
data(exampleforest)

# Example of aboveground parameters taken from a forest
# described using LAI and crown ratio
data(exampleforest2)

#Default species parameterization
data(SpParamsMED)


# Define soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

d <- 100
meteovec <- unlist(examplemeteo[d,-1])
date <- as.character(examplemeteo$dates[d])

test_that("single_runner initializes and runs correctly for aspwb", {
  xa <- aspwbInput(0.75, defaultControl(), examplesoil)
  W_ini <- rlang::duplicate(xa$soil$W)
  # builds runner
  mfra <- new(runners$single_runner, xa, 41.82592, 100, 0, 0)
  expect_s4_class(mfra, "Rcpp_single_runner")
  # runs and gets output
  mfra$run_day(date, meteovec, 0, NULL, NA)
  sa <- mfra$get_output()
  expect_s3_class(sa, "aspwb_day")
  mfra$update_input(xa)
  # Check that W has changed
  expect_false(all(xa$soil$W == W_ini))
  # Check that result is equal to a stand-alone run
  xa2 <- aspwbInput(0.75, defaultControl(), examplesoil)
  sa2 <- aspwb_day(xa2, date, meteovec, 41.82592, 100, 0, 0, modifyInput = TRUE)
  expect_equal(xa2, xa)
  expect_equal(sa2, sa)
})

test_that("single_runner initializes and runs correctly for spwb", {
  for(transpirationMode in c("Granier", "Sperry", "Sureau")) {
    for(soilDomains in c("buckets", "single", "dual")) {
      ctl <- defaultControl(transpirationMode, soilDomains)
      x1 <- spwbInput(exampleforest, examplesoil, SpParamsMED, ctl)
      W_ini <- rlang::duplicate(x1$soil$W)
      # builds runner
      mfr1 <- new(runners$single_runner, x1, 41.82592, 100, 0, 0)
      expect_s4_class(mfr1, "Rcpp_single_runner")
      # runs and gets output
      mfr1$run_day(date, meteovec, 0, NULL, NA)
      s1 <- mfr1$get_output()
      expect_s3_class(s1, "spwb_day")
      # Check that W has changed
      mfr1$update_input(x1)
      expect_false(all(x1$soil$W == W_ini))
      # Check that result is equal to a stand-alone run
      x12 <- spwbInput(exampleforest, examplesoil, SpParamsMED, ctl)
      s12 <- spwb_day(x12, date, meteovec, 41.82592, 100, 0, 0, modifyInput = TRUE)
      expect_equal(x12, x1)
      expect_equal(s12, s1)
    }
  }
})

test_that("single_runner initializes and runs correctly for growth", {
  for(transpirationMode in c("Granier", "Sperry", "Sureau")) {
    for(soilDomains in c("buckets", "single", "dual")) {
      ctl <- defaultControl(transpirationMode)
      x1 <- growthInput(exampleforest, examplesoil, SpParamsMED, ctl)
      W_ini <- rlang::duplicate(x1$soil$W)
      # builds runner
      mfr1 <- new(runners$single_runner, x1, 41.82592, 100, 0, 0)
      expect_s4_class(mfr1, "Rcpp_single_runner")
      # runs and gets output
      mfr1$run_day(date, meteovec, 0, NULL, NA)
      s1 <- mfr1$get_output()
      expect_s3_class(s1, "growth_day")
      # # Check that W has changed
      mfr1$update_input(x1)
      expect_false(all(x1$soil$W == W_ini))
      # # Check that result is equal to a stand-alone run
      x12 <- growthInput(exampleforest, examplesoil, SpParamsMED, ctl)
      s12 <- growth_day(x12, date, meteovec, 41.82592, 100, 0, 0, modifyInput = TRUE)
      expect_equal(x12, x1)
      expect_equal(s12, s1)
    }
  }
})


n <- 50
d <- 100
meteovec1 <- unlist(examplemeteo[d,-1])
meteo_vec <- vector("list", n)
date <- as.character(examplemeteo$dates[d])
for(i in 1:n) meteo_vec[[i]] = rlang::duplicate(meteovec1)
x_vec <- vector("list", n)
latitude_vec <- rep(41.82592, n)
elevation_vec <- rep(100, n)
slope_vec <- rep(0, n)
aspect_vec <- rep(0, n)

test_that("multiple_runner initializes and runs correctly with agriculture", {
  parallelize = FALSE
  xa <- aspwbInput(0.75, defaultControl(), examplesoil)
  W_ini <- rlang::duplicate(xa$soil$W)
  for(i in 1:n) x_vec[[i]] = rlang::duplicate(xa)
  # Build runner
  mfmr <- new(runners$multiple_runner, x_vec, latitude_vec, elevation_vec, slope_vec, aspect_vec)
  expect_s4_class(mfmr, "Rcpp_multiple_runner")
  # Run without parallelization
  mfmr$run_day(date, meteo_vec, parallelize)
  expect_s3_class(mfmr$get_output_at(1), "aspwb_day")
  expect_s3_class(mfmr$get_output_at(2), "aspwb_day")
  sa <- mfmr$get_output_at(2)
  # Check that W has changed
  mfmr$update_input_at(2, x_vec[[2]])
  expect_false(all(x_vec[[2]]$soil$W == W_ini))
  # Check that result is equal to a stand-alone run
  xa2 <- rlang::duplicate(xa)
  sa2 <- aspwb_day(xa2, date, meteovec1, 41.82592, 100, 0, 0, modifyInput = TRUE)
  expect_equal(xa2, x_vec[[2]])
  expect_equal(sa2, sa)
})

test_that("multiple_runner initializes and runs correctly for spwb", {
  parallelize = FALSE
  for(transpirationMode in c("Granier", "Sperry", "Sureau")) {
    ctl <- defaultControl(transpirationMode)
    x1 <- spwbInput(exampleforest, examplesoil, SpParamsMED, ctl)
    W_ini <- rlang::duplicate(x1$soil$W)
    for(i in 1:n) x_vec[[i]] = rlang::duplicate(x1)
    # Build runner
    mfmr <- new(runners$multiple_runner, x_vec, latitude_vec, elevation_vec, slope_vec, aspect_vec)
    expect_s4_class(mfmr, "Rcpp_multiple_runner")
    # Run without parallelization
    mfmr$run_day(date, meteo_vec, parallelize)
    expect_s3_class(mfmr$get_output_at(1), "spwb_day")
    expect_s3_class(mfmr$get_output_at(2), "spwb_day")
    s1 <- mfmr$get_output_at(2)
    # Check that W has changed
    mfmr$update_input_at(2, x_vec[[2]])
    expect_false(all(x_vec[[2]]$soil$W == W_ini))
    # Check that result is equal to a stand-alone run
    x12 <- rlang::duplicate(x1)
    s12 <- spwb_day(x12, date, meteovec1, 41.82592, 100, 0, 0, modifyInput = TRUE)
    expect_equal(x12, x_vec[[2]])
    expect_equal(s12, s1)
  }
})

test_that("multiple_runner initializes and runs correctly for growth", {
  testthat::skip_on_cran()
  testthat::skip_on_ci()
  parallelize = FALSE
  for(transpirationMode in c("Granier", "Sperry", "Sureau")) {
    ctl <- defaultControl(transpirationMode)
    x1 <- growthInput(exampleforest, examplesoil, SpParamsMED, ctl)
    W_ini <- rlang::duplicate(x1$soil$W)
    for(i in 1:n) x_vec[[i]] = rlang::duplicate(x1)
    # Build runner
    mfmr <- new(runners$multiple_runner, x_vec, latitude_vec, elevation_vec, slope_vec, aspect_vec)
    expect_s4_class(mfmr, "Rcpp_multiple_runner")
    # Run without parallelization
    mfmr$run_day(date, meteo_vec, parallelize)
    expect_s3_class(mfmr$get_output_at(1), "growth_day")
    expect_s3_class(mfmr$get_output_at(2), "growth_day")
    s1 <- mfmr$get_output_at(2)
    # Check that W has changed
    mfmr$update_input_at(2, x_vec[[2]])
    expect_false(all(x_vec[[2]]$soil$W == W_ini))
    # Check that result is equal to a stand-alone run
    x12 <- rlang::duplicate(x1)
    s12 <- growth_day(x12, date, meteovec1, 41.82592, 100, 0, 0, modifyInput = TRUE)
    expect_equal(x12, x_vec[[2]])
    expect_equal(s12, s1)
    
  }
})

test_that("multiple_runner initializes and runs correctly with agriculture and parallelization", {
  testthat::skip_on_cran()
  testthat::skip_on_ci()
  parallelize = TRUE
  xa <- aspwbInput(0.75, defaultControl(), examplesoil)
  W_ini <- rlang::duplicate(xa$soil$W)
  for(i in 1:n) x_vec[[i]] = rlang::duplicate(xa)
  # Build runner
  mfmr <- new(runners$multiple_runner, x_vec, latitude_vec, elevation_vec, slope_vec, aspect_vec)
  expect_s4_class(mfmr, "Rcpp_multiple_runner")
  # Run with parallelization
  Sys.setenv(ARMA_NUM_THREADS = "1")
  mfmr$run_day(date, meteo_vec, parallelize)
  expect_s3_class(mfmr$get_output_at(1), "aspwb_day")
  expect_s3_class(mfmr$get_output_at(2), "aspwb_day")
  sa <- mfmr$get_output_at(2)
  # Check that W has changed
  mfmr$update_input_at(2, x_vec[[2]])
  expect_false(all(x_vec[[2]]$soil$W == W_ini))
  # Check that result is equal to a stand-alone run
  xa2 <- rlang::duplicate(xa)
  sa2 <- aspwb_day(xa2, date, meteovec1, 41.82592, 100, 0, 0, modifyInput = TRUE)
  expect_equal(xa2, x_vec[[2]])
  expect_equal(sa2, sa)
})

test_that("multiple_runner initializes and runs correctly for spwb and parallelization", {
  testthat::skip_on_cran()
  testthat::skip_on_ci()
  parallelize = TRUE
  for(transpirationMode in c("Granier", "Sperry", "Sureau")) {
    ctl <- defaultControl(transpirationMode)
    x1 <- spwbInput(exampleforest, examplesoil, SpParamsMED, ctl)
    W_ini <- rlang::duplicate(x1$soil$W)
    for(i in 1:n) x_vec[[i]] = rlang::duplicate(x1)
    # Build runner
    mfmr <- new(runners$multiple_runner, x_vec, latitude_vec, elevation_vec, slope_vec, aspect_vec)
    expect_s4_class(mfmr, "Rcpp_multiple_runner")
    # Run with parallelization
    Sys.setenv(ARMA_NUM_THREADS = "1")
    mfmr$run_day(date, meteo_vec, parallelize)
    expect_s3_class(mfmr$get_output_at(1), "spwb_day")
    expect_s3_class(mfmr$get_output_at(2), "spwb_day")
    s1 <- mfmr$get_output_at(2)
    # Check that W has changed
    mfmr$update_input_at(2, x_vec[[2]])
    expect_false(all(x_vec[[2]]$soil$W == W_ini))
    # Check that result is equal to a stand-alone run
    x12 <- rlang::duplicate(x1)
    s12 <- spwb_day(x12, date, meteovec1, 41.82592, 100, 0, 0, modifyInput = TRUE)
    expect_equal(x12, x_vec[[2]])
    expect_equal(s12, s1)
  }
})

test_that("multiple_runner initializes and runs correctly for growth and parallelization", {
  testthat::skip_on_cran()
  testthat::skip_on_ci()
  parallelize = TRUE
  for(transpirationMode in c("Granier", "Sperry", "Sureau")) {
    ctl <- defaultControl(transpirationMode)
    x1 <- growthInput(exampleforest, examplesoil, SpParamsMED, ctl)
    W_ini <- rlang::duplicate(x1$soil$W)
    for(i in 1:n) x_vec[[i]] = rlang::duplicate(x1)
    # Build runner
    mfmr <- new(runners$multiple_runner, x_vec, latitude_vec, elevation_vec, slope_vec, aspect_vec)
    expect_s4_class(mfmr, "Rcpp_multiple_runner")
    # Run with parallelization
    Sys.setenv(ARMA_NUM_THREADS = "1")
    mfmr$run_day(date, meteo_vec, parallelize)
    expect_s3_class(mfmr$get_output_at(1), "growth_day")
    expect_s3_class(mfmr$get_output_at(2), "growth_day")
    s1 <- mfmr$get_output_at(2)
    # Check that W has changed
    mfmr$update_input_at(2, x_vec[[2]])
    expect_false(all(x_vec[[2]]$soil$W == W_ini))
    # Check that result is equal to a stand-alone run
    x12 <- rlang::duplicate(x1)
    s12 <- growth_day(x12, date, meteovec1, 41.82592, 100, 0, 0, modifyInput = TRUE)
    expect_equal(x12, x_vec[[2]])
    expect_equal(s12, s1)

  }
})

library(medfate)

data(exampleforest)


forest_herbs <- exampleforest
forest_herbs$herbData <- forest_herbs$shrubData


forest_single <- exampleforest
forest_single$treeData <- forest_single$treeData[1,,drop = FALSE]
forest_single$shrubData <- forest_single$shrubData[numeric(0),]


data(SpParamsMED)
data(examplemeteo)
examplemeteo2 <- examplemeteo
row.names(examplemeteo2) <- as.character(examplemeteo2$dates)
examplemeteo2$dates <- NULL
d <- 100
meteovec <- unlist(examplemeteo[d,-1])
date <- as.character(examplemeteo$dates[d])

control_granier <- defaultControl("Granier")
control_granier$verbose <- FALSE
control_sperry <- defaultControl("Sperry")
control_sperry$verbose <- FALSE
control_sureau <- defaultControl("Sureau")
control_sureau$verbose <- FALSE

#Initialize soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

test_that("growth can be run in example, herbs and empty forests",{
  expect_s3_class(growth(growthInput(exampleforest, examplesoil, SpParamsMED, control_granier), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(exampleforest, examplesoil, SpParamsMED, control_sperry), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(exampleforest, examplesoil, SpParamsMED, control_sureau), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(emptyforest(), examplesoil, SpParamsMED, control_granier), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(emptyforest(), examplesoil, SpParamsMED, control_sperry), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(emptyforest(), examplesoil, SpParamsMED, control_sureau), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(forest_herbs, examplesoil, SpParamsMED, control_granier), 
                         examplemeteo[1:10,],
                         latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(forest_herbs, examplesoil, SpParamsMED, control_sperry), 
                         examplemeteo[1:10,],
                         latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(forest_herbs, examplesoil, SpParamsMED, control_sureau), 
                         examplemeteo[1:10,],
                         latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(forest_single, examplesoil, SpParamsMED, control_granier), 
                         examplemeteo[1:10,],
                         latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(forest_single, examplesoil, SpParamsMED, control_sperry), 
                         examplemeteo[1:10,],
                         latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(forest_single, examplesoil, SpParamsMED, control_sureau), 
                         examplemeteo[1:10,],
                         latitude = 41.82592, elevation = 100), "growth")
})

test_that("growth can be run using dates as columns",{
  expect_s3_class(growth(growthInput(exampleforest, examplesoil, SpParamsMED, control_granier), 
                       examplemeteo2[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(exampleforest, examplesoil, SpParamsMED, control_sperry), 
                       examplemeteo2[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(exampleforest, examplesoil, SpParamsMED, control_sureau), 
                       examplemeteo2[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
})

test_that("growth can be run using species codes",{
  f <- exampleforest
  f$treeData$Species <- c(148, 168)
  f$shrubData$Species <- 165
  expect_s3_class(growth(growthInput(f, examplesoil, SpParamsMED, control_granier), 
                       examplemeteo2[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(f, examplesoil, SpParamsMED, control_sperry), 
                       examplemeteo2[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(f, examplesoil, SpParamsMED, control_sureau), 
                       examplemeteo2[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
  
})

test_that("growth can be run using single soilDomains",{
  control_granier_single <- control_granier
  control_granier_single$soilDomains <- "single"
  control_sperry_single <- control_sperry
  control_sperry_single$soilDomains <- "single"
  control_sureau_single <- control_sureau
  control_sureau_single$soilDomains <- "single"
  expect_s3_class(growth(growthInput(exampleforest, examplesoil, SpParamsMED, control_granier_single), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(exampleforest, examplesoil, SpParamsMED, control_sperry_single), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(exampleforest, examplesoil, SpParamsMED, control_sureau_single), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
})

test_that("growth can be run using dual soilDomains",{
  control_granier_dual <- control_granier
  control_granier_dual$soilDomains <- "dual"
  control_sperry_dual <- control_sperry
  control_sperry_dual$soilDomains <- "dual"
  control_sureau_dual <- control_sureau
  control_sureau_dual$soilDomains <- "dual"
  expect_s3_class(growth(growthInput(exampleforest, examplesoil, SpParamsMED, control_granier_dual), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(exampleforest, examplesoil, SpParamsMED, control_sperry_dual), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(exampleforest, examplesoil, SpParamsMED, control_sureau_dual), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
})
test_that("growth can be run using partial rhizosphere overlap",{
  control_granier_partial_overlap <- control_granier
  control_granier_partial_overlap$rhizosphereOverlap <- "partial"
  control_sperry_partial_overlap <- control_sperry
  control_sperry_partial_overlap$rhizosphereOverlap <- "partial"
  control_sureau_partial_overlap <- control_sureau
  control_sureau_partial_overlap$rhizosphereOverlap <- "partial"
  expect_s3_class(growth(growthInput(exampleforest, examplesoil, SpParamsMED, control_granier_partial_overlap), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(exampleforest, examplesoil, SpParamsMED, control_sperry_partial_overlap), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
  expect_s3_class(growth(growthInput(exampleforest, examplesoil, SpParamsMED, control_sureau_partial_overlap), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "growth")
})

test_that("growth can be run with fire hazard results",{
  control_fh <- control_granier
  control_fh$fireHazardResults <- TRUE
  expect_s3_class(growth(growthInput(exampleforest, examplesoil, SpParamsMED, control_fh), 
                       examplemeteo[1:2,],
                       latitude = 41.82592, elevation = 100), "growth")
})

test_that("growth can be run disabling output",{
  control <- control_granier
  control$soilResults <- FALSE
  control$snowResults <- FALSE
  control$standResults <- FALSE
  control$temperatureResults <- FALSE
  control$leafResults <- FALSE
  control$plantResults <- FALSE
  control$plantLabileCarbonBalanceResults  <- FALSE
  control$plantStructureResults  <- FALSE
  control$growthMortalityResults  <- FALSE
  expect_s3_class(growth(growthInput(exampleforest, examplesoil, SpParamsMED, control), 
                         examplemeteo[1:10,],
                         latitude = 41.82592, elevation = 100), "growth")
  
  expect_s3_class(medfate::growth_day(growthInput(exampleforest, examplesoil, SpParamsMED, control), 
                                      date, meteovec, latitude = 41.82592, elevation = 100, 
                                      slope=0, aspect=0, modifyInput = FALSE), "growth_day")
  
  control <- control_sperry
  control$soilResults <- FALSE
  control$snowResults <- FALSE
  control$standResults <- FALSE
  control$temperatureResults <- FALSE
  control$leafResults <- FALSE
  control$plantResults <- FALSE
  control$plantLabileCarbonBalanceResults  <- FALSE
  control$plantStructureResults  <- FALSE
  control$growthMortalityResults  <- FALSE
  expect_s3_class(growth(growthInput(exampleforest, examplesoil, SpParamsMED, control), 
                         examplemeteo[1:10,],
                         latitude = 41.82592, elevation = 100), "growth")
  
  expect_s3_class(medfate::growth_day(growthInput(exampleforest, examplesoil, SpParamsMED, control), 
                                      date, meteovec, latitude = 41.82592, elevation = 100, 
                                      slope=0, aspect=0, modifyInput = FALSE), "growth_day")
  
})

library(medfate)

data(exampleforest)

forest_herbs <- exampleforest
forest_herbs$herbData <- forest_herbs$shrubData

forest_single <- exampleforest
forest_single$treeData <- forest_single$treeData[1,,drop = FALSE]
forest_single$shrubData <- forest_single$shrubData[numeric(0),]


data(SpParamsMED)
data(examplemeteo)
examplemeteo2 <- examplemeteo
row.names(examplemeteo2) <- as.character(examplemeteo2$dates)
examplemeteo2$dates <- NULL
d <- 100
meteovec <- unlist(examplemeteo[d,-1])
date <- as.character(examplemeteo$dates[d])

control_granier <- defaultControl("Granier")
control_granier$verbose <- FALSE
control_sperry <- defaultControl("Sperry")
control_sperry$verbose <- FALSE
control_sureau <- defaultControl("Sureau")
control_sureau$verbose <- FALSE


#Initialize soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

test_that("spwb can be run in example, herbs and empty forests",{
  expect_s3_class(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_granier), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_sperry), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_sureau), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(exampleforest2, examplesoil, SpParamsMED, control_granier), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(exampleforest2, examplesoil, SpParamsMED, control_sperry), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(exampleforest2, examplesoil, SpParamsMED, control_sureau), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(emptyforest(), examplesoil, SpParamsMED, control_granier), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(emptyforest(), examplesoil, SpParamsMED, control_sperry), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(emptyforest(), examplesoil, SpParamsMED, control_sureau), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(forest_herbs, examplesoil, SpParamsMED, control_granier), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(forest_herbs, examplesoil, SpParamsMED, control_sperry), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(forest_herbs, examplesoil, SpParamsMED, control_sureau), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(forest_single, examplesoil, SpParamsMED, control_granier), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(forest_single, examplesoil, SpParamsMED, control_sperry), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(forest_single, examplesoil, SpParamsMED, control_sureau), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
})

test_that("pwb can be run in example and empty forests",{
  x1 <- spwbInput(exampleforest, examplesoil, SpParamsMED, control_granier)
  S1 <- spwb(x1, examplemeteo[1:10,], latitude = 41.82592, elevation = 100)
  expect_s3_class(pwb(x1, examplemeteo[1:10,], W = as.matrix(S1$Soil$SWC[,1:4]), 
                       latitude = 41.82592, elevation = 100), "pwb")
})

test_that("spwb can be run with missing values columns",{
  examplemeteo_missing <- examplemeteo[1:2, ]
  examplemeteo_missing$Radiation <- NA
  expect_s3_class(suppressWarnings(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_granier), 
                                        examplemeteo_missing,
                                        latitude = 41.82592, elevation = 100)), "spwb")
  examplemeteo_missing$MinRelativeHumidity <- NA
  examplemeteo_missing$MaxRelativeHumidity <- NA
  expect_s3_class(suppressWarnings(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_granier), 
                                        examplemeteo_missing,
                                        latitude = 41.82592, elevation = 100)), "spwb")
  examplemeteo_missing$MaxTemperature <- NA
  expect_error(suppressWarnings(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_granier), 
                                        examplemeteo_missing,
                                        latitude = 41.82592, elevation = 100)))
})

test_that("spwb can be run using dates as columns",{
  expect_s3_class(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_granier), 
                       examplemeteo2[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_sperry), 
                       examplemeteo2[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_sureau), 
                       examplemeteo2[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
})

test_that("spwb can be run using species codes",{
  f <- exampleforest
  f$treeData$Species <- c(148, 168)
  f$shrubData$Species <- 165
  expect_s3_class(spwb(spwbInput(f, examplesoil, SpParamsMED, control_granier), 
                       examplemeteo2[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(f, examplesoil, SpParamsMED, control_sperry), 
                       examplemeteo2[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(f, examplesoil, SpParamsMED, control_sureau), 
                       examplemeteo2[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
})

test_that("spwb can be run using single soilDomains",{
  control_granier_single <- control_granier
  control_granier_single$soilDomains <- "single"
  control_sperry_single <- control_sperry
  control_sperry_single$soilDomains <- "single"
  control_sureau_single <- control_sureau
  control_sureau_single$soilDomains <- "single"
  expect_s3_class(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_granier_single), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_sperry_single), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_sureau_single), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
})

test_that("spwb can be run using dual soilDomains",{
  control_granier_dual <- control_granier
  control_granier_dual$soilDomains <- "dual"
  control_sperry_dual <- control_sperry
  control_sperry_dual$soilDomains <- "dual"
  control_sureau_dual <- control_sureau
  control_sureau_dual$soilDomains <- "dual"
  expect_s3_class(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_granier_dual), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_sperry_dual), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_sureau_dual), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
})
test_that("spwb can be run using partial rhizosphere overlap",{
  control_granier_partial_overlap <- control_granier
  control_granier_partial_overlap$rhizosphereOverlap <- "partial"
  control_sperry_partial_overlap <- control_sperry
  control_sperry_partial_overlap$rhizosphereOverlap <- "partial"
  control_sureau_partial_overlap <- control_sureau
  control_sureau_partial_overlap$rhizosphereOverlap <- "partial"
  expect_s3_class(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_granier_partial_overlap), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_sperry_partial_overlap), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
  expect_s3_class(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_sureau_partial_overlap), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "spwb")
})

test_that("spwb can be run with fire hazard results",{
  control_fh <- control_granier
  control_fh$fireHazardResults <- TRUE
  expect_s3_class(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_fh), 
                       examplemeteo[1:2,],
                       latitude = 41.82592, elevation = 100), "spwb")
})

test_that("spwb can be run with less output",{
  control_less <- control_granier
  control_less$standResults <- FALSE
  control_less$soilResults <- FALSE
  control_less$plantResults <- FALSE
  expect_s3_class(spwb(spwbInput(exampleforest, examplesoil, SpParamsMED, control_less), 
                       examplemeteo[1:2,],
                       latitude = 41.82592, elevation = 100), "spwb")
})

library(medfate)

data(examplemeteo)

control <- defaultControl("Granier")
control$verbose <- FALSE

#Initialize soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)
examplemeteo2 <- examplemeteo
row.names(examplemeteo2) <- as.character(examplemeteo2$dates)
examplemeteo2$dates <- NULL
d <- 100
meteovec <- unlist(examplemeteo[d,-1])
date <- as.character(examplemeteo$dates[d])

test_that("aspwb can be run in example data",{
  x1 <- aspwbInput(0.75, control, examplesoil)
  W_ini <- rlang::duplicate(x1$soil$W)
  expect_s3_class(aspwb_day(x1, 
                            date, meteovec,
                            latitude = 41.82592, elevation = 100, modifyInput = FALSE), "aspwb_day")
  expect_equal(W_ini, x1$soil$W)
  expect_s3_class(aspwb_day(x1, 
                            date, meteovec,
                            latitude = 41.82592, elevation = 100, modifyInput = TRUE), "aspwb_day")
  expect_false(all(W_ini == x1$soil$W))
  expect_s3_class(aspwb(aspwbInput(0.75, control, examplesoil), 
                       examplemeteo[1:10,],
                       latitude = 41.82592, elevation = 100), "aspwb")
})

# Default parameters
df_soil <- defaultSoilParams()

# Initializes soil
s <- soil(df_soil)

#Initialize input
control <- defaultControl("Granier")
x1 <- spwbInput(exampleforest,s, SpParamsMED, control)

test_that("rainfall intensity routine", {
  control <- defaultControl()
  expect_type(hydrology_rainfallIntensity(10, 5, control$defaultRainfallIntensityPerMonth), "double")
})
test_that("infiltration routines", {
  expect_type(hydrology_infiltrationAmount(20, 4, s, "VG", "GreenAmpt1911"), "double")
  expect_type(hydrology_infiltrationAmount(20, 4, s, "VG", "Boughton1989"), "double")
  expect_type(hydrology_infiltrationRepartition(100, s$widths, s$macro), "double")
  expect_type(hydrology_infiltrationBoughton(100, 30), "double")
})

test_that("soil evaporation routine", {
  W_ini_1 <- s$W[1]
  expect_type(hydrology_soilEvaporation(s, 0.0, "VG", 10, 50, FALSE), "double")
  expect_true(s$W[1] == W_ini_1) # Check that soil water content has not changed
  expect_type(hydrology_soilEvaporation(s, 0.0, "VG", 10, 50, TRUE), "double")
  expect_false(s$W[1] == W_ini_1) # Check that soil water content has changed
  expect_type(hydrology_soilEvaporationAmount(5, 10, 2), "double")
})

test_that("herbaceous transpiration routine", {
  W_ini <- rlang::duplicate(s$W)
  expect_type(hydrology_herbaceousTranspiration(10, 100.0, 1, s, "VG", FALSE), "double")
  expect_equal(s$W, W_ini) # Check that soil water content has not changed
  expect_type(hydrology_herbaceousTranspiration(10, 100.0, 1, s, "VG", TRUE), "double")
  expect_false(s$W[1] == W_ini[1]) # Check that soil water content has changed
})

test_that("snow melting routine", {
  expect_type(hydrology_snowMelt(5, 2, 100,100), "double")
  expect_error(hydrology_snowMelt(5, NA, 100,100))
  expect_error(hydrology_snowMelt(5, 2, 100,NA))
})

test_that("water inputs routine", {
  x1$snowpack <- 5
  snowpack_ini <- x1$snowpack
  expect_type(hydrology_waterInputs(x1, 10, 4, 10, 15, 30, 100, 2, 100, 100, FALSE), "double")
  expect_equal(x1$snowpack, snowpack_ini) # Check that snowpack has not changed
  expect_type(hydrology_waterInputs(x1, 10, 4, 10, 15, 30, 100, 2, 100, 100, TRUE), "double")
  expect_false(x1$snowpack == snowpack_ini) # Check that snowpack has changed
})

test_that("soil water balance routine (buckets)", {
  s <- soil(df_soil)
  W_ini <- rlang::duplicate(s$W)
  expect_type(hydrology_soilWaterBalance(s, "VG", 10, 5, 0, c(-1,-1,-1,-1), 
                                         soilDomains = "buckets", modifySoil = FALSE), "double")
  expect_equal(s$W, W_ini) # Check that soil water content has not changed
  expect_type(hydrology_soilWaterBalance(s, "VG", 10, 5, 0, c(-1,-1,-1,-1), 
                                         soilDomains = "buckets", modifySoil = TRUE), "double")
  expect_false(all(s$W == W_ini)) # Check that soil water content has changed
})

test_that("soil water balance routine (single)", {
  s <- soil(df_soil)
  W_ini <- rlang::duplicate(s$W)
  expect_type(hydrology_soilWaterBalance(s, "VG", 10, 5, 0, c(-1,-1,-1,-1),
                                         soilDomains = "single", modifySoil = FALSE), "double")
  expect_equal(s$W, W_ini) # Check that soil water content has not changed
  expect_type(hydrology_soilWaterBalance(s, "VG", 10, 5, 0, c(-1,-1,-1,-1),
                                         soilDomains = "single", modifySoil = TRUE), "double")
  expect_false(all(s$W == W_ini)) # Check that soil water content has changed
})

test_that("soil water balance routine (dual)", {
  s <- soil(df_soil)
  W_ini <- rlang::duplicate(s$W)
  expect_type(hydrology_soilWaterBalance(s, "VG", 10, 5, 0, c(-1,-1,-1,-1),
                                         soilDomains = "dual", modifySoil = FALSE), "double")
  expect_equal(s$W, W_ini) # Check that soil water content has not changed
  expect_type(hydrology_soilWaterBalance(s, "VG", 10, 5, 0, c(-1,-1,-1,-1),
                                         soilDomains = "dual", modifySoil = TRUE), "double")
  expect_false(all(s$W == W_ini)) # Check that soil water content has changed
})

library(medfate)

#' Transforms Rcentury output for soil temperature and soil moisture from month to day resolution
env_daily<-function(out, yearIni = 2000) {
  yearMax <- yearIni + max(out$time) - 1
  dateIni <- as.Date(paste0(yearIni, "-01-01"))
  dateFin <- as.Date(paste0(yearMax, "-12-31"))
  days <- seq(dateIni, dateFin, by="day")
  months <- cut(days, breaks="months")
  unique_months <- unique(months)
  # Trim out to the complete years
  out <- out[1:length(unique_months), , drop = FALSE]
  df <- data.frame(date = days, Step = 1:length(days), SoilMoisture = NA, SoilTemperature = NA,
                   AirTemperature = NA, AirRelativeHumidity = NA)
  rel_mois <- out$asmos.1./ max(out$asmos.1.)
  for(i in 1:length(unique_months)) {
    sel_i <- months == unique_months[i]
    df$SoilMoisture[sel_i] <- rel_mois[i]
    df$SoilTemperature[sel_i] <- out$stemp[i]
  }
  return(df)
}

prd_daily_new<-function(out, rcentury_tree, yearIni = 2000) {
  decid <- rcentury_tree$df[rcentury_tree$df[,2]=="DECID",1]
  species <- rcentury_tree$label
  yearMax <- yearIni + max(out$time) - 1
  dateIni <- as.Date(paste0(yearIni, "-01-01"))
  dateFin <- as.Date(paste0(yearMax, "-12-31"))
  days <- seq(dateIni, dateFin, by="day")
  months <- cut(days, breaks="months")
  unique_months <- unique(months)
  leafdr <- c(rcentury_tree$df[rcentury_tree$df[,2]=="LEAFDR(1)",1],
              rcentury_tree$df[rcentury_tree$df[,2]=="LEAFDR(2)",1],
              rcentury_tree$df[rcentury_tree$df[,2]=="LEAFDR(3)",1],
              rcentury_tree$df[rcentury_tree$df[,2]=="LEAFDR(4)",1],
              rcentury_tree$df[rcentury_tree$df[,2]=="LEAFDR(5)",1],
              rcentury_tree$df[rcentury_tree$df[,2]=="LEAFDR(6)",1],
              rcentury_tree$df[rcentury_tree$df[,2]=="LEAFDR(7)",1],
              rcentury_tree$df[rcentury_tree$df[,2]=="LEAFDR(8)",1],
              rcentury_tree$df[rcentury_tree$df[,2]=="LEAFDR(9)",1],
              rcentury_tree$df[rcentury_tree$df[,2]=="LEAFDR(10)",1],
              rcentury_tree$df[rcentury_tree$df[,2]=="LEAFDR(11)",1],
              rcentury_tree$df[rcentury_tree$df[,2]=="LEAFDR(12)",1])
  wooddr1 <- rcentury_tree$df[rcentury_tree$df[,2]=="WOODDR(1)",1] #fraction of forest which is deciduous; the fraction of leaves which fall during senescence month or at the end of the growing season, used when decid = 1 or 2
  wooddr2 <- rcentury_tree$df[rcentury_tree$df[,2]=="WOODDR(2)",1] #monthly death rate fraction for fine root component
  wooddr3 <- rcentury_tree$df[rcentury_tree$df[,2]=="WOODDR(3)",1] #monthly death rate fraction for fine branch component
  wooddr4 <- rcentury_tree$df[rcentury_tree$df[,2]=="WOODDR(4)",1] #monthly death rate fraction for large wood component
  wooddr5 <- rcentury_tree$df[rcentury_tree$df[,2]=="WOODDR(5)",1] #monthly death rate fraction for coarse root component
  # Trim out to the complete years
  out <- out[1:length(unique_months), , drop = FALSE]
  # fbrchc -> C in forest system fine branch component (g m-2).
  # crootc -> C in forest system coarse root component (g m-2).
  # rlwodc -> C in forest system large wood component (g m-2).
  # frootc -> C in forest system fine root component (g m-2).
  # rleavc -> C in forest system leaf component (g m-2).
  # print(wooddr1)
  df <- data.frame(date = days, Step = 1:length(days), Species = species, Leaves = NA, Twigs = NA, SmallBranches = NA, LargeWood = NA, CoarseRoots = NA, FineRoots = NA)
  for(i in 1:length(unique_months)) {
    sel_i <- months == unique_months[i]
    nmonth_days <- sum(sel_i)
    month_number <- as.numeric(format(days[sel_i], "%m")[1])
    if(decid == 0) {
      df$Leaves[sel_i] <- out$rleavc[i]*leafdr[month_number]/nmonth_days
    } else {
      if((i %% 12)==10) df$Leaves[sel_i] <- out$rleavc[i]*wooddr1/nmonth_days
      else df$Leaves[sel_i] <- 0
    }
    df$Twigs[sel_i] <- 0
    df$SmallBranches[sel_i] <- out$fbrchc[i]*wooddr3/nmonth_days
    df$LargeWood[sel_i] <- out$rlwodc[i]*wooddr4/nmonth_days
    df$CoarseRoots[sel_i] <- out$crootc[i]*wooddr5/nmonth_days
    df$FineRoots[sel_i] <- out$frootc[i]*wooddr2/nmonth_days
  }
  return(df)
}

sp_params <- function(rcentury_tree) {
  # % lignin leaves tree$`1`$df$WDLIG(1)
  # % lignin fine roots tree$`1`$df$WDLIG(2)
  # % lignin branches tree$`1`$df$WDLIG(3)
  # % lignin large wood tree$`1`$df$WDLIG(4)
  # % lignin coarse roots tree$`1`$df$WDLIG(5)
  # average 3-5 for sapwood lignin
  
  # read lignin/N ratios from
  # tree$cerfor(3,1,1) C/
  wdlig1 <- rcentury_tree$df[rcentury_tree$df[,2]=="WDLIG(1)",1]
  wdlig2 <- rcentury_tree$df[rcentury_tree$df[,2]=="WDLIG(2)",1]
  wdlig3 <- rcentury_tree$df[rcentury_tree$df[,2]=="WDLIG(3)",1]
  wdlig4 <- rcentury_tree$df[rcentury_tree$df[,2]=="WDLIG(4)",1]
  wdlig5 <- rcentury_tree$df[rcentury_tree$df[,2]=="WDLIG(5)",1]
  cn_leaves <- rcentury_tree$df[rcentury_tree$df[,2]=="CERFOR(3,1,1)",1]
  cn_fineroots <- rcentury_tree$df[rcentury_tree$df[,2]=="CERFOR(3,2,1)",1]
  cn_branches <- rcentury_tree$df[rcentury_tree$df[,2]=="CERFOR(3,3,1)",1]
  cn_largewood <- rcentury_tree$df[rcentury_tree$df[,2]=="CERFOR(3,4,1)",1]
  cn_coarseroots <- rcentury_tree$df[rcentury_tree$df[,2]=="CERFOR(3,5,1)",1]
  cn_wood <- mean(c(cn_branches, cn_largewood, cn_coarseroots))
  leaf_c <- 0.5
  wood_c <- 0.5
  fineroot_c <- 0.5
  n_leaves <- (1/cn_leaves)*leaf_c
  n_fineroot <- (1/cn_fineroots)*fineroot_c
  n_wood <- (1/cn_wood)*wood_c
  df <- data.frame(Species  = rcentury_tree$label,
                   LeafLignin = wdlig1*100, # %
                   WoodLignin = mean(wdlig3, wdlig4, wdlig5)*100,# %
                   FineRootLignin = wdlig2*100,# %
                   Nleaf = n_leaves*1000, # mg / g
                   Nsapwood = n_wood*1000, # mg / g
                   Nfineroot = n_fineroot*1000) # mg / g
  return(df)
}

test_that("DAYCENT can be run", {
  skip_on_ci()
  skip_on_cran()
  
  load("/home/miquel/OneDrive/mcaceres_work/model_development/medfate_evaluation/RcenturyBenchmark/Rdata/RC2m_Process.RData")
  duke_tree <- tree$`3`
  
  environmentalConditions <- env_daily(out_duke)
  litterProduction <- prd_daily_new(out_duke, duke_tree)
  
  paramsLitterDecomposition <- sp_params(duke_tree)
  paramsAnatomy <- paramsLitterDecomposition[,c("Species"), drop = FALSE]
  paramsAnatomy$WoodDensity <- 0.5
  litterProduction$Species <- paramsLitterDecomposition$Species[1]
  
  nlitter <- 1
  litterData <- data.frame(Species = as.character(rep(paramsLitterDecomposition$Species[1], nlitter)),
                           Leaves = as.numeric(rep(0, nlitter)),
                           Twigs = as.numeric(rep(0, nlitter)),
                           SmallBranches = as.numeric(rep(0, nlitter)),
                           LargeWood = as.numeric(rep(0, nlitter)),
                           CoarseRoots = as.numeric(rep(0, nlitter)),
                           FineRoots = as.numeric(rep(0, nlitter)))
  
  nsnag <- 0
  snagData<- data.frame(Species = as.character(rep(NA, nsnag)),
                        DBH = as.numeric(rep(NA, nsnag)),
                        Height = as.numeric(rep(NA, nsnag)),
                        DeathAge = as.numeric(rep(NA, nsnag)),
                        SmallBranches = as.numeric(rep(NA, nsnag)),
                        LargeWood = as.numeric(rep(NA, nsnag)))
  
  SOCData <- c(SurfaceMetabolic = 0, BelowgroundMetabolic = 0, SurfaceActive = 0, BelowgroundActive = 0,
               SurfaceSlow = 0, BelowgroundSlow = 0, BelowgroundPassive = 0)
  
  control <- defaultControl()
  baseAnnualRates <- control$decompositionAnnualBaseRates
  annualTurnoverRate <- control$decompositionAnnualTurnoverRate
  
  l <- decomposition_DAYCENT(snagData, litterData, SOCData,
                             paramsLitterDecomposition,
                             paramsAnatomy,
                             baseAnnualRates,
                             annualTurnoverRate,
                             environmentalConditions,
                             litterProduction,
                             sand = 30,
                             clay = 20,
                             soilPH = 7, balanceCheck = FALSE)  
  expect_type(l, "list")
})

library(medfate)

data(exampleforest)
data(SpParamsMED)
data(examplemeteo)
d <- 100
meteovec <- unlist(examplemeteo[d,-1])
date <- as.character(examplemeteo$dates[d])

current_version <- as.character(packageVersion("medfate"))
older_versions <- c("4.8.3","4.8.4", "4.8.5")

test_that("spwb(_day) and growth(_day) can be run from stored inputs coming from older versions",{
  testthat::skip_on_cran()
  testthat::skip_on_ci()
  
  # Generate current version objects 
  data(exampleforest)
  data(SpParamsMED)
  examplesoil <- defaultSoilParams(4)
  control <- defaultControl("Granier")
  control$verbose <- FALSE
  x1 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)
  saveRDS(x1, file = paste0("initialized_objects/spwbInput_", current_version,".rds"))
  x1 <- growthInput(exampleforest, examplesoil, SpParamsMED, control)
  saveRDS(x1, file = paste0("initialized_objects/growthInput_", current_version,".rds"))
  
  # Test older version objects 
  for(ver in older_versions) {
    x1 <- readRDS(paste0("initialized_objects/spwbInput_", ver,".rds"))  
    S1 <- spwb(x1, 
               examplemeteo[1:10,],
               latitude = 41.82592, elevation = 100)
    expect_s3_class(S1, "spwb")
    expect_equal(S1$spwbOutput$version, as.character(packageVersion("medfate")))
    
    x1 <- readRDS(paste0("initialized_objects/growthInput_", ver,".rds")) 
    G1 <- growth(x1,
                 examplemeteo[1:10,],
                 latitude = 41.82592, elevation = 100)
    expect_s3_class(G1, "growth")
    expect_equal(G1$growthOutput$version, as.character(packageVersion("medfate")))
  }
  
  for(ver in older_versions) {
    x1 <- readRDS(paste0("initialized_objects/spwbInput_", ver,".rds"))  
    s1 <- medfate::spwb_day(x1, date, meteovec, latitude = 41.82592, elevation = 100, slope=0, aspect=0, modifyInput = FALSE)
    expect_s3_class(s1, "spwb_day")
    
    x1 <- readRDS(paste0("initialized_objects/growthInput_", ver,".rds")) 
    g1 <- medfate::growth_day(x1, date, meteovec, latitude = 41.82592, elevation = 100, slope=0, aspect=0, modifyInput = FALSE)
    expect_s3_class(g1, "growth_day")
  }
})

library(medfate)

data(exampleforest)

data(SpParamsMED)
data(examplemeteo)

#Define soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

d <- 100
meteovec <- unlist(examplemeteo[d,-1])
date <- as.character(examplemeteo$dates[d])

control_sperry <- defaultControl("Sperry")
control_sperry$verbose <- FALSE
control_sureau <- defaultControl("Sureau")
control_sureau$verbose <- FALSE

#Initialize input

test_that("transpiration granier can be run ",{
  control_granier <- defaultControl("Granier")
  control_granier$verbose <- FALSE
  x1 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control_granier)
  Psi_ini <- rlang::duplicate(x1$internalWater$PlantPsi)
  expect_type(transp_transpirationGranier(x1, examplemeteo, 1, 
                                          latitude = 41.82592, elevation = 100, slope = 0, aspect = 0, 
                                          modifyInput = FALSE), "list")
  expect_equal(x1$internalWater$PlantPsi, Psi_ini) # Check that psi has not changed
  expect_type(transp_transpirationGranier(x1, examplemeteo, 1, 
                                          latitude = 41.82592, elevation = 100, slope = 0, aspect = 0, 
                                          modifyInput = TRUE), "list")
  expect_false(all(x1$internalWater$PlantPsi == Psi_ini)) # Check that psi has changed
  control_granier$rhizosphereOverlap <- "partial"
  x1 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control_granier)
  Psi_ini <- rlang::duplicate(x1$internalWater$PlantPsi)
  expect_type(transp_transpirationGranier(x1, examplemeteo, 1, 
                                          latitude = 41.82592, elevation = 100, slope = 0, aspect = 0, 
                                          modifyInput = FALSE), "list")
  expect_equal(x1$internalWater$PlantPsi, Psi_ini) # Check that psi has not changed
  expect_type(transp_transpirationGranier(x1, examplemeteo, 1, 
                                          latitude = 41.82592, elevation = 100, slope = 0, aspect = 0, 
                                          modifyInput = TRUE), "list")
  expect_false(all(x1$internalWater$PlantPsi == Psi_ini)) # Check that psi has changed
})
# test_that("transpiration granier can be run with medfateland example ",{
#   testthat::skip_if_not_installed("medfateland")
#   control_granier <- defaultControl("Granier")
#   control_granier$verbose <- FALSE
#   library(medfateland)
#   f <- example_ifn$forest[[1]]
#   x1 <- spwbInput(f,examplesoil, SpParamsMED, control_granier)
#   expect_type(transp_transpirationGranier(x1, examplemeteo, 1, 
#                                           latitude = 41.82592, elevation = 100, slope = 0, aspect = 0, 
#                                           modifyInput = FALSE), "list")
# })

test_that("transpiration sperry can be run ",{
  control_sperry <- defaultControl("Sperry")
  control_sperry$verbose <- FALSE
  x1 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control_sperry)
  expect_type(transp_transpirationSperry(x1, examplemeteo, 1, 
                                         latitude = 41.82592, elevation = 100, slope = 0, aspect = 0, 
                                         modifyInput = FALSE), "list")
  control_sperry$rhizosphereOverlap <- "partial" 
  x1 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control_sperry)
  expect_type(transp_transpirationSperry(x1, examplemeteo, 1, 
                                         latitude = 41.82592, elevation = 100, slope = 0, aspect = 0, 
                                         modifyInput = FALSE), "list")
})

# test_that("transpiration sperry can be run with medfateland example ",{
#   testthat::skip_if_not_installed("medfateland")
#   control_sperry <- defaultControl("Sperry")
#   control_sperry$verbose <- FALSE
#   library(medfateland)
#   f <- example_ifn$forest[[1]]
#   x1 <- spwbInput(f,examplesoil, SpParamsMED, control_sperry)
#   expect_type(transp_transpirationSperry(x1, examplemeteo, 1, 
#                                           latitude = 41.82592, elevation = 100, slope = 0, aspect = 0, 
#                                           modifyInput = FALSE), "list")
# })

test_that("transpiration sureau can be run ",{
  control_sureau <- defaultControl("Sureau")
  control_sureau$verbose <- FALSE
  x1 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control_sureau)
  Psi_ini <- rlang::duplicate(x1$internalWater$StemPsi)
  t1 <- transp_transpirationSureau(x1, examplemeteo, 1, 
                                   latitude = 41.82592, elevation = 100, slope = 0, aspect = 0, 
                                   modifyInput = FALSE)
  expect_type(t1, "list")
  expect_equal(x1$internalWater$StemPsi, Psi_ini) # Check that psi has not changed
  t1 <- transp_transpirationSureau(x1, examplemeteo, 1, 
                                   latitude = 41.82592, elevation = 100, slope = 0, aspect = 0, 
                                   modifyInput = TRUE)
  expect_type(t1, "list")
  expect_false(all(x1$internalWater$StemPsi == Psi_ini)) # Check that psi has changed
  
  
  control_sureau$rhizosphereOverlap <- "partial" 
  x1 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control_sureau)
  Psi_ini <- rlang::duplicate(x1$internalWater$StemPsi)
  t1 <- transp_transpirationSureau(x1, examplemeteo, 1, 
                                   latitude = 41.82592, elevation = 100, slope = 0, aspect = 0, 
                                   modifyInput = FALSE)
  expect_type(t1, "list")
  expect_equal(x1$internalWater$StemPsi, Psi_ini) # Check that psi has not changed
  t1 <- transp_transpirationSureau(x1, examplemeteo, 1, 
                                   latitude = 41.82592, elevation = 100, slope = 0, aspect = 0, 
                                   modifyInput = TRUE)
  expect_type(t1, "list")
  expect_false(all(x1$internalWater$StemPsi == Psi_ini)) # Check that psi has changed
})


# test_that("transpiration sureau can be run with medfateland example ",{
#   testthat::skip_if_not_installed("medfateland")
#   control_sureau <- defaultControl("Sureau")
#   control_sureau$verbose <- FALSE
#   library(medfateland)
#   f <- example_ifn$forest[[1]]
#   x1 <- spwbInput(f,examplesoil, SpParamsMED, control_sureau)
#   expect_type(transp_transpirationSureau(x1, examplemeteo, 1, 
#                                           latitude = 41.82592, elevation = 100, slope = 0, aspect = 0, 
#                                           modifyInput = FALSE), "list")
# })

library(medfate)

data(exampleforest)
data(SpParamsMED)
data(examplemeteo)
#Initialize soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

test_that("rock optimization can be run in example and empty forests",{
  testthat::expect_vector(utils_rockOptimization(exampleforest, examplesoil, SpParamsMED, defaultControl(), 
                                         meteo = examplemeteo,
                                         latitude = 41.82592, elevation = 100))
  testthat::expect_vector(utils_rockOptimization(emptyforest(), examplesoil, SpParamsMED, defaultControl(), 
                                                 meteo = examplemeteo,
                                                 latitude = 41.82592, elevation = 100))
})

library(medfate)

data(exampleforest)
data(SpParamsMED)

control_granier <- defaultControl("Granier")
control_granier$verbose <- FALSE
control_sperry <- defaultControl("Sperry")
control_sperry$verbose <- FALSE
control_sureau <- defaultControl("Sureau")
control_sureau$verbose <- FALSE

#Define soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

test_that("pressure-volume curves can be shown",{
  x1 <- spwbInput(exampleforest, examplesoil, SpParamsMED, control_granier)
  expect_s3_class(moisture_pressureVolumeCurvePlot(x1, "stem"), "ggplot")
  x2 <- spwbInput(exampleforest, examplesoil, SpParamsMED, control_sperry)
  expect_s3_class(moisture_pressureVolumeCurvePlot(x2, "stem"), "ggplot")
  expect_s3_class(moisture_pressureVolumeCurvePlot(x2, "leaf"), "ggplot")
  x3 <- spwbInput(exampleforest, examplesoil, SpParamsMED, control_sureau)
  expect_s3_class(moisture_pressureVolumeCurvePlot(x3, "stem"), "ggplot")
  expect_s3_class(moisture_pressureVolumeCurvePlot(x3, "leaf"), "ggplot")
})

test_that("hydraulic vulnerability curves can be shown",{
  x2 <- spwbInput(exampleforest, examplesoil, SpParamsMED, control_sperry)
  expect_s3_class(hydraulics_vulnerabilityCurvePlot(x2, type = "leaf"), "ggplot")
  expect_s3_class(hydraulics_vulnerabilityCurvePlot(x2, type = "stem"), "ggplot")
  expect_s3_class(hydraulics_vulnerabilityCurvePlot(x2, type = "root"), "ggplot")
  expect_null(hydraulics_vulnerabilityCurvePlot(x2, soil = examplesoil, type = "rhizosphere"))
  
  x3 <- spwbInput(exampleforest, examplesoil, SpParamsMED, control_sureau)
  expect_s3_class(hydraulics_vulnerabilityCurvePlot(x3, type = "leaf", vulnerabilityFunction = "Sigmoid"), "ggplot")
  expect_s3_class(hydraulics_vulnerabilityCurvePlot(x3, type = "stem", vulnerabilityFunction = "Sigmoid"), "ggplot")
  expect_s3_class(hydraulics_vulnerabilityCurvePlot(x3, type = "root", vulnerabilityFunction = "Sigmoid"), "ggplot")
  expect_null(hydraulics_vulnerabilityCurvePlot(x3, soil = examplesoil, type = "rhizosphere"))
})

test_that("hydraulic supply functions can be shown",{
  x2 <- spwbInput(exampleforest, examplesoil, SpParamsMED, control_sperry)
  expect_s3_class(hydraulics_supplyFunctionPlot(x2, type = "E"), "ggplot")
  expect_s3_class(hydraulics_supplyFunctionPlot(x2, type = "ERhizo"), "ggplot")
  expect_s3_class(hydraulics_supplyFunctionPlot(x2, type = "StemPsi"), "ggplot")
  expect_s3_class(hydraulics_supplyFunctionPlot(x2, type = "dEdP"), "ggplot")
})

# test_that("Stomatal regulation plot can be shown",{
#   d = 100
#   x2 <- spwbInput(exampleforest, examplesoil, SpParamsMED, control_sperry)
#   expect_s3_class(transp_stomatalRegulationPlot(x2, examplemeteo, day = d, timestep=12,
#                                 latitude = 41.82592, elevation = 100, type="E"), "ggplot")
# })

#Load example plot plant data
data(exampleforest)

# Example of aboveground parameters taken from a forest
# described using LAI and crown ratio
data(exampleforest2)

#Default species parameterization
data(SpParamsMED)


# Define soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)


test_that("Control parameter Rcpp structures can be copied to C++ structures",{
  expect_type(medfate:::.testControlListToStructure(defaultControl()), "integer")
})
test_that("Model input Rcpp structures can be copied to C++ structures",{
  controlGranier <- defaultControl("Granier")
  controlSperry <- defaultControl("Sperry")
  controlSureau <- defaultControl("Sureau")
  expect_type(medfate:::.testModelInputToStructure(spwbInput(exampleforest, examplesoil, SpParamsMED, controlGranier)), "double")
  expect_type(medfate:::.testModelInputToStructure(spwbInput(exampleforest, examplesoil, SpParamsMED, controlSperry)), "double")
  expect_type(medfate:::.testModelInputToStructure(spwbInput(exampleforest, examplesoil, SpParamsMED, controlSureau)), "double")
  expect_type(medfate:::.testModelInputToStructure(growthInput(exampleforest, examplesoil, SpParamsMED, controlGranier)), "double")
  expect_type(medfate:::.testModelInputToStructure(growthInput(exampleforest, examplesoil, SpParamsMED, controlSperry)), "double")
  expect_type(medfate:::.testModelInputToStructure(growthInput(exampleforest, examplesoil, SpParamsMED, controlSureau)), "double")
})

library(medfate)

data(exampleforest)

forest_herbs <- exampleforest
forest_herbs$herbData <- forest_herbs$shrubData

data(SpParamsMED)
data(examplemeteo)
examplemeteo2 <- examplemeteo
row.names(examplemeteo2) <- as.character(examplemeteo2$dates)
examplemeteo2$dates <- NULL
d <- 100
meteovec <- unlist(examplemeteo[d,-1])
date <- as.character(examplemeteo$dates[d])

control_granier <- defaultControl("Granier")
control_granier$verbose <- FALSE
control_sperry <- defaultControl("Sperry")
control_sperry$verbose <- FALSE
control_sureau <- defaultControl("Sureau")
control_sureau$verbose <- FALSE


#Initialize soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

test_that("growth_day can be run with missing meteo data",{
  
  meteovec_mis <- meteovec
  meteovec_mis[4:7] <- NA
  
  expect_s3_class(suppressWarnings(medfate::growth_day(growthInput(exampleforest, examplesoil, SpParamsMED, control_granier), 
                                    date, meteovec_mis, latitude = 41.82592, elevation = 100, slope=0, aspect=0)), "growth_day")
  expect_s3_class(suppressWarnings(medfate::growth_day(growthInput(exampleforest, examplesoil, SpParamsMED, control_sperry), 
                                    date, meteovec_mis, latitude = 41.82592, elevation = 100, slope=0, aspect=0)), "growth_day")
  expect_s3_class(suppressWarnings(medfate::growth_day(growthInput(exampleforest, examplesoil, SpParamsMED, control_sureau), 
                                    date, meteovec_mis, latitude = 41.82592, elevation = 100, slope=0, aspect=0)), "growth_day")
  
  meteovec_mis2 <- meteovec_mis
  meteovec_mis2["MinTemperature"] <- NA
  expect_error(medfate::growth_day(growthInput(exampleforest, examplesoil, SpParamsMED, control_granier), 
                                    date, meteovec_mis2, latitude = 41.82592, elevation = 100, slope=0, aspect=0))
  meteovec_mis2 <- meteovec_mis
  meteovec_mis2["MaxTemperature"] <- NA
  expect_error(medfate::growth_day(growthInput(exampleforest, examplesoil, SpParamsMED, control_granier), 
                                 date, meteovec_mis2, latitude = 41.82592, elevation = 100, slope=0, aspect=0))
  meteovec_mis2 <- meteovec_mis
  meteovec_mis2["Precipitation"] <- NA
  expect_error(medfate::growth_day(growthInput(exampleforest, examplesoil, SpParamsMED, control_granier), 
                                 date, meteovec_mis2, latitude = 41.82592, elevation = 100, slope=0, aspect=0))
})

# test_that("growth_day can be run with medfateland examples", {
#   testthat::skip_if_not_installed("medfateland")
#   library(medfateland)
#   f <- example_ifn$forest[[1]]
#   expect_s3_class(suppressWarnings(medfate::growth_day(growthInput(f, examplesoil, SpParamsMED, control_granier),
#                                    date, meteovec, latitude = 41.82592, elevation = 100, slope=0, aspect=0)), "growth_day")
#   expect_s3_class(suppressWarnings(medfate::growth_day(growthInput(f, examplesoil, SpParamsMED, control_sperry),
#                                                      date, meteovec, latitude = 41.82592, elevation = 100, slope=0, aspect=0)), "growth_day")
#   expect_s3_class(suppressWarnings(medfate::growth_day(growthInput(f, examplesoil, SpParamsMED, control_sureau),
#                                                      date, meteovec, latitude = 41.82592, elevation = 100, slope=0, aspect=0)), "growth_day")
# })

test_that("growth_day can be run with truncated root distribution",{
  exampleforest$shrubData$Z50 <- 100
  exampleforest$shrubData$Z95 <- 200
  control_granier$truncateRootDistribution<- TRUE
  x1 <- growthInput(exampleforest, examplesoil, SpParamsMED, control_granier)
  expect_s3_class(growth_day(x1, date, meteovec,
                           latitude = 41.82592, elevation = 100, slope=0, aspect=0), "growth_day")
  control_sperry$truncateRootDistribution<- TRUE
  x2 <- growthInput(exampleforest, examplesoil, SpParamsMED, control_sperry)
  expect_s3_class(growth_day(x2, date, meteovec,
                           latitude = 41.82592, elevation = 100, slope=0, aspect=0), "growth_day")
  control_sureau$truncateRootDistribution<- TRUE
  x3 <- growthInput(exampleforest, examplesoil, SpParamsMED, control_sureau)
  expect_s3_class(growth_day(x3, date, meteovec,
                           latitude = 41.82592, elevation = 100, slope=0, aspect=0), "growth_day")
})

test_that("growth_day can be run with truncated root distribution and rhizosphere overlap",{
  exampleforest$shrubData$Z50 <- 100
  exampleforest$shrubData$Z95 <- 200
  control_granier$truncateRootDistribution<- TRUE
  control_granier$rhizosphereOverlap <- "partial"
  x1 <- growthInput(exampleforest, examplesoil, SpParamsMED, control_granier)
  expect_s3_class(growth_day(x1, date, meteovec,
                           latitude = 41.82592, elevation = 100, slope=0, aspect=0), "growth_day")
  control_sperry$truncateRootDistribution<- TRUE
  control_sperry$rhizosphereOverlap <- "partial"
  x2 <- growthInput(exampleforest, examplesoil, SpParamsMED, control_sperry)
  expect_s3_class(growth_day(x2, date, meteovec,
                           latitude = 41.82592, elevation = 100, slope=0, aspect=0), "growth_day")
  control_sureau$truncateRootDistribution<- TRUE
  control_sureau$rhizosphereOverlap <- "partial"
  x3 <- growthInput(exampleforest, examplesoil, SpParamsMED, control_sureau)
  expect_s3_class(growth_day(x3, date, meteovec,
                           latitude = 41.82592, elevation = 100, slope=0, aspect=0), "growth_day")
})



  

#' Maximum transpiration vs. LAI
#' 
#' Builds a model of maximum transpiration (Tmax) over potential evapotranspiration (PET) for increasing leaf area index (LAI) values for each plant cohort.
#' 
#' @param x An object of class \code{\link{spwbInput}}, built using the 'Sperry' transpiration mode.
#' @param meteo A data frame with daily meteorological data series.
#' @param latitude Latitude (in degrees).
#' @param elevation,slope,aspect Elevation above sea level (in m), slope (in degrees) and aspect (in degrees from North). 
#' @param LAI_seq Sequence of stand LAI values to be tested.
#' @param draw Logical flag to indicate plotting of results.
#' 
#' @details This function performs a meta-modelling exercise using the Sperry transpiration model, with the aim to estimate coefficients 
#' for the equation used in the Granier transpiration model (Granier et al. 1999). The model to be fitted is: \code{y ~ a*LAI + b*LAI^2}, 
#' where \code{y} is the ratio between maximum transpiration (Tmax) and Penman's potential evapotranspiration (PET) and \code{LAI} is the stand LAI. 
#' Unlike the original equation of Granier et al. (1999), we fit a zero intercept model so that LAI = 0 translates into zero plant transpiration. 
#' 
#' The function fits the model for each cohort separately, assuming it represents the whole stand. 
#' For each stand LAI value in the input sequence, the function uses simulations with Sperry transpiration and the input weather to estimate \code{y = Tmax/PET} 
#' as a function of stand's LAI (deciduous stands include leaf phenology). 
#' Once simulations have been conducted for each stand LAI value, the function fits a Generalized Linear Model with the above equation, 
#' assuming a Gamma distribution of residuals and an identity link.
#' 
#' The coefficients of the model can be used to parametrize Granier's transpiration, 
#' since coefficients \code{a} and \code{b} in the equation above correspond to parameters \code{Tmax_LAI} and \code{Tmax_LAIsq}, 
#' respectively (see \code{\link{SpParamsMED}}).
#' 
#' @return Returns a list with as many elements as plant cohorts, each element being a \code{\link{glm}} model.
#'
#' @references 
#' Granier A, \enc{Bréda}{Breda} N, Biron P, Villette S (1999) A lumped water balance model to evaluate duration and intensity of drought constraints in forest stands. Ecol Modell 116:269–283. https://doi.org/10.1016/S0304-3800(98)00205-1. 
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso \code{\link{spwb}}, \code{\link{transp_transpirationGranier}}, \code{\link{transp_transpirationSperry}}, \code{\link{SpParamsMED}}
#' 
#' @keywords internal
#' @examples 
#' \donttest{
#' #Load example daily meteorological data
#' data(examplemeteo)
#' 
#' # Load example plot plant data
#' data(exampleforest)
#' 
#' # Load default species parameters
#' data(SpParamsMED)
#'
#' # Define soil with default soil params
#' examplesoil <- defaultSoilParams(4)
#' 
#' # Initialize control parameters for 'Sperry' transpiration mode
#' control <- defaultControl(transpirationMode="Sperry")
#' 
#' # Initialize input
#' x2 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)
#' 
#' # Estimate maximum transpiration ratio models for each cohort
#' # Weather is subset to speed-up results
#' m <- transp_maximumTranspirationModel(x2, examplemeteo[1:10,], 
#'                                      41.82592, elevation = 100, 
#'                                      slope = 0, aspect = 0)
#' 
#' # Inspect the model for first cohort
#' m[[1]]
#' }
#' 
transp_maximumTranspirationModel<-function(x, meteo, latitude, elevation, slope, aspect,
                                           LAI_seq = c(0.1,0.25, seq(0.5, 10, by=0.5)),
                                           draw = TRUE) {
  
  
  if("dates" %in% names(meteo)) {
    dates <- meteo$dates
  } else {
    dates <- row.names(meteo)
  }
  #Calculate PET using penman
  if("PET" %in% names(meteo)) meteo$PET = NULL
  PET <- numeric(nrow(meteo))
  
  for (i in 1:length(meteo[['MinTemperature']])) {
    PET[i] <- meteoland::penman(
      latrad = latitude*pi/180,
      elevation = elevation,
      slorad = slope*pi/180,
      asprad = aspect*pi/180,
      J = meteoland::radiation_dateStringToJulianDays(dates[i]),
      Tmin = meteo[['MinTemperature']][i],
      Tmax = meteo[['MaxTemperature']][i],
      RHmin = meteo[['MinRelativeHumidity']][i],
      RHmax = meteo[['MaxRelativeHumidity']][i],
      R_s = meteo[['Radiation']][i],
      u = meteo[['WindSpeed']][i],
      z = 2
    )
  }
  
  #Exclude days without PET
  meteo = meteo[!is.na(PET), ]
  PET = PET[!is.na(PET)]

  #Subsample days from PET
  # PET_cut = cut(PET,breaks = seq(0, max(PET), length.out = 20))
  # nPET = table(PET_cut)
  # PETw = as.numeric(1/nPET[PET_cut])
  # PETw = PETw/sum(PETw)
  # s = sample(1:nrow(meteo),ndays,replace = TRUE, prob = PETw)
  # s = s[order(PET[s])]
  # meteo = meteo[s,]
  # PET =PET[s]
  
  ncoh = nrow(x$above)
  ndays = nrow(meteo)
  nlai = length(LAI_seq)
  
  cohnames <- row.names(x$cohorts)
  LAItotal <- sum(x$above$LAI_live)
  
  xIni = x
  xIni$control$modifyInput = FALSE
  xIni$control$unlimitedSoilWater = TRUE
  xIni$control$stemCavitationRecovery = "total"
  xIni$control$leafCavitationRecovery = "total"
  xIni$control$verbose = FALSE
  Tmax = matrix(NA, nrow=ndays, ncol = nlai)  
  colnames(Tmax) = LAI_seq
  rownames(Tmax) = row.names(meteo)
  LAI = matrix(NA, nrow=ndays, ncol = nlai)  
  colnames(LAI) = LAI_seq
  rownames(LAI) = row.names(meteo)
  
  s_res = vector("list", nlai)
  pb = txtProgressBar(0, nlai, style=3)
  for(j in 1:nlai) {
    customParams = LAI_seq[j]*(x$above$LAI_live/LAItotal)
    names(customParams) = paste0(cohnames,"/LAI_live")
    xlai = modifyInputParams(xIni, customParams, FALSE)
    s_res[[j]] = spwb(xlai, meteo,
                      latitude = latitude, 
                      elevation = elevation, slope = slope, aspect = aspect)
    Tmax[,j] = s_res[[j]]$WaterBalance$Transpiration
    LAI[,j] = s_res[[j]]$Stand$LAI
    setTxtProgressBar(pb, j)
  }
  TmaxRatio = sweep(Tmax,1,PET,"/")
  Tmaxratiovec = as.vector(TmaxRatio)
  laivec = as.vector(LAI)
  df = data.frame(y=Tmaxratiovec, LAI = laivec, Prec = meteo$Precipitation)
  df = df[df$Prec==0,] #Exclude precipitation days
  df = df[!is.na(df$y),, drop=FALSE] # Exclude missing ratio
  df = df[(df$y > 0.0) & (df$y < 1.0),, drop=FALSE] # Exclude extreme ratio
  mod <- glm(y ~ -1 + LAI + I(LAI^2), 
                   start = c(0.134,-0.006),
                   data =df, family=Gamma(link="identity"))
  if(draw==TRUE) {
    TmaxPETGranier = -0.006*(LAI_seq^2)+0.134*LAI_seq
    plot(LAI_seq, TmaxPETGranier, type="l", col="gray", lwd=2, 
         xlab = "Stand's Leaf Area Index", ylab = "Tmax/PET", ylim=c(0,1))
    df2<-data.frame(LAI = LAI_seq)
    lines(df2$LAI, predict(mod, newdata = df2), col="black", lwd=2)
    legend("topright", legend=c("Granier's equation", "Forest stand"),
           lwd=2, lty=1, col=c("gray", "black"),bty="n", cex =0.8)
  }
  return(mod)
}

.quadraticMeanTreeDiameter<-function(n, dbh, minDBH = 7.5){
  if(length(n)<1) return(NA)
  tba = .treeBasalArea(n, dbh)
  ba = sum(tba[dbh>=minDBH])
  return(2.0*sqrt(10000*ba/(pi*sum(n[dbh>=minDBH]))))
}

.dominantTreeHeight<-function(n, h, dbh, minDBH = 7.5) {
  if(length(n)<1) return(NA)
  o <-order(h, decreasing=TRUE)
  dbh = dbh[o]
  h = h[o]
  n = n[o]
  n = n[dbh>=minDBH]
  h = h[dbh>=minDBH]
  if(length(n)>0) {
    ncum = 0
    for(i in 1:length(h)) {
      ncum = ncum + n[i]
      if(ncum>100) return(sum(h[1:i]*n[1:i])/sum(n[1:i]))
    }
    return(sum(h*n)/sum(n))
  }
  return(NA)
}

.dominantTreeDiameter<-function(n, dbh, minDBH = 7.5) {
  if(length(n)<1) return(NA)
  o <-order(dbh, decreasing=TRUE)
  dbh = dbh[o]
  n = n[o]
  n = n[dbh>=minDBH]
  dbh = dbh[dbh>=minDBH]
  dtd = NA
  if(length(dbh)>0) {
    ncum = 0
    for(i in 1:length(dbh)) {
      ncum = ncum + n[i]
      if(ncum>100) return(sum(dbh[1:i]*n[1:i])/sum(n[1:i]))
    }
    dtd  = sum(dbh*n)/sum(n)
  }
  return(dtd)
}

.hartBeckingIndex<-function(n,h, dbh, minDBH = 7.5) {
  return((10000/.dominantTreeHeight(n,h, dbh, minDBH))*sqrt(10000/sum(n[dbh>=minDBH])))
}

#' Stand values
#' 
#' Functions to calculate stand attributes of a \code{\link{forest}} object.
#' 
#' @param x An object of class \code{\link{forest}}.
#' @param minDBH Minimum diameter at breast height (in cm) to include in estimation.
#' @param SpParams A data frame with species parameters (see \code{\link{SpParamsMED}}).
#' @param gdd Growth degree days (to account for leaf phenology effects).
#' @param includeDead A flag to indicate that standing dead fuels (dead branches) are included.
#' @param bounded A boolean flag to indicate that extreme values should be prevented (maximum tree LAI = 7 and maximum shrub LAI = 3)
#' 
#' @return 
#' \itemize{
#' \item{\code{stand_basalArea}: Stand basal area (m2/ha).}
#' \item{\code{stand_treeDensity}: Stand tree density (in ind/ha).}
#' \item{\code{stand_dominantTreeDiameter}: Dominant tree diameter, i.e the average diameter of the 100 widest trees (in cm).}
#' \item{\code{stand_quadraticMeanTreeDiameter}: Quadratic mean tree diameter, i.e. the diameter value corresponding to the current basal area and density.}
#' \item{\code{stand_meanTreeHeight}: Mean tree height (in cm).}
#' \item{\code{stand_dominantTreeHeight}: Dominant tree height, i.e the average height of the 100 tallest trees (in cm).}
#' \item{\code{stand_dominantTreeSpecies}: Dominant tree species name, determined in terms of basal area (and considering all tree sizes).}
#' \item{\code{stand_hartBeckingIndex}: Hart-Becking index.}
#' \item{\code{stand_foliarBiomass}: Standing biomass of leaves (in kg/m2).}
#' \item{\code{stand_fuel}: Stand fine fuel load (in kg/m2).}
#' \item{\code{stand_LAI}: Stand leaf area index (m2/m2).}
#' \item{\code{stand_shrubVolume}: Stand shrub phytovolume (m3/m2).}
#' }
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso \code{\link{forest}}, \code{\link{plant_basalArea}}, \code{\link{summary.forest}}
#' 
#' @examples
#' #Default species parameterization
#' data(SpParamsMED)
#'   
#' #Load example plot
#' data(exampleforest)
#'     
#' #A short way to obtain total basal area
#' stand_basalArea(exampleforest)
#'     
#' @name stand_values
#' @keywords internal
stand_dominantTreeDiameter<-function(x, minDBH = 7.5) {
  if(nrow(x$treeData)>0) {
    if(any(is.na(x$treeData$N))) stop("Missing values in N")
    if(any(is.na(x$treeData$DBH))) stop("Missing values in DBH")
    return(.dominantTreeDiameter(n = x$treeData$N, dbh = x$treeData$DBH, minDBH = minDBH))
  }
  return(as.numeric(NA))
}

#' @rdname stand_values
#' @keywords internal
stand_treeDensity<-function(x, minDBH = 7.5) {
  N <- as.numeric(NA)
  if(nrow(x$treeData)>0) {
    if(any(is.na(x$treeData$N))) stop("Missing values in N")
    if(any(is.na(x$treeData$DBH))) stop("Missing values in DBH")
    N <- sum(x$treeData$N[x$treeData$DBH>minDBH])
  }
  return(N)
}

#' @rdname stand_values
#' @keywords internal
stand_meanTreeHeight<-function(x, minDBH = 7.5) {
  MTH <- as.numeric(NA)
  if(nrow(x$treeData)>0) {
    if(any(is.na(x$treeData$N))) stop("Missing values in N")
    if(any(is.na(x$treeData$DBH))) stop("Missing values in DBH")
    if(any(is.na(x$treeData$Height))) stop("Missing values in Height")
    h = x$treeData$Height[x$treeData$DBH>minDBH]
    n = x$treeData$N[x$treeData$DBH>minDBH]
    if(length(h)>0) {
      MTH <- sum(h*n)/sum(n)
    }
  }
  return(MTH)
}

#' @rdname stand_values
#' @keywords internal
stand_dominantTreeHeight<-function(x, minDBH = 7.5) {
  if(nrow(x$treeData)>0) {
    if(any(is.na(x$treeData$N))) stop("Missing values in N")
    if(any(is.na(x$treeData$DBH))) stop("Missing values in DBH")
    if(any(is.na(x$treeData$Height))) stop("Missing values in Height")
    return(.dominantTreeHeight(n = x$treeData$N, h = x$treeData$Height, dbh = x$treeData$DBH, minDBH = minDBH))
  }
  return( as.numeric(NA))
}

#' @rdname stand_values
#' @keywords internal
stand_hartBeckingIndex<-function(x, minDBH = 7.5) {
  if(nrow(x$treeData)>0) {
    if(any(is.na(x$treeData$N))) stop("Missing values in N")
    if(any(is.na(x$treeData$DBH))) stop("Missing values in DBH")
    if(any(is.na(x$treeData$Height))) stop("Missing values in Height")
    return(.hartBeckingIndex(n = x$treeData$N, h = x$treeData$Height, dbh = x$treeData$DBH, minDBH = minDBH))
  }
  return( as.numeric(NA))
}

#' @rdname stand_values
#' @keywords internal
stand_quadraticMeanTreeDiameter<-function(x, minDBH = 7.5) {
  if(nrow(x$treeData)>0) {
    if(any(is.na(x$treeData$N))) stop("Missing values in N")
    if(any(is.na(x$treeData$DBH))) stop("Missing values in DBH")
    return(.quadraticMeanTreeDiameter(n = x$treeData$N, dbh = x$treeData$DBH, minDBH = 7.5))
  }
  return( as.numeric(NA))
}

#' @rdname stand_values
#' @keywords internal
stand_dominantTreeSpecies <-function(x, SpParams) {
  s<-species_basalArea(x, SpParams)
  s<-s[!is.na(s)]
  s<-s[s>0.0]
  if(length(s)>0) {
    return(names(s)[which.max(s)])
  }
  return(as.character(NA))
}

library(medfate)

data(exampleforest)
data(SpParamsMED)
data(poblet_trees)

exampleforest_minimal <- exampleforest
exampleforest_minimal$shrubData <- exampleforest_minimal$shrubData[numeric(0),,drop = FALSE]
exampleforest_minimal$herbCover <- NULL
exampleforest_minimal$herbHeight <- NULL
exampleforest_minimal$seedBank <- NULL
exampleforest_minimal$seedlingBank <- NULL

emptyforest <- emptyforest()

forest_herbs <- exampleforest
forest_herbs$herbData <- forest_herbs$shrubData

test_that("Empty forests can be created",{
  expect_s3_class(emptyforest(), "forest")
  expect_s3_class(emptyforest(addcolumns = "LAI"), "forest")
  expect_s3_class(emptyforest(addcolumns = c("LAI", "Age")), "forest")
  expect_error(emptyforest(addcolumns = "kk"))
})

test_that("Forest object can be build from data frames",{
  f <- emptyforest()
  x <- subset(poblet_trees, Plot.Code=="POBL_CTL")
  sampled_area <- pi*15^2
  mapping_x <- c("Species.name" = "Species", "DBH" = "Diameter.cm")
  species <- c("Erica arborea","Cistus albidus", "Erica arborea", "Cistus albidus", "Cistus albidus")
  H <- c(200,50,100,40,30)
  D1 <- c(140,40,100, 35,30)
  D2 <- D1
  y <- data.frame(species, H, D1, D2)
  mapping_y <- c("Species.name"= "species", "Height" ="H", "D1", "D2")
  
  expect_s3_class(forest_mapWoodyTables(x, y,
                             mapping_x = mapping_x, mapping_y = mapping_y,
                             SpParams = SpParamsMED,
                             plot_size_x = sampled_area, plot_size_y = 4),"forest")
})

test_that("Can produce all vertical profiles with exampleforest",{
  expect_s3_class(vprofile_rootDistribution(exampleforest, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_fuelBulkDensity(exampleforest, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_leafAreaDensity(exampleforest, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_leafAreaDensity(exampleforest, SpParamsMED, byCohorts = TRUE), "ggplot")
  expect_s3_class(vprofile_leafAreaDensity(exampleforest, SpParamsMED, byCohorts = TRUE, includeHerbs = TRUE), "ggplot")
  expect_s3_class(vprofile_PARExtinction(exampleforest, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_SWRExtinction(exampleforest, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_windExtinction(exampleforest, SpParamsMED), "ggplot")
})

test_that("Can produce all vertical profiles with exampleforest2",{
  expect_s3_class(vprofile_rootDistribution(exampleforest2, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_fuelBulkDensity(exampleforest2, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_leafAreaDensity(exampleforest2, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_leafAreaDensity(exampleforest2, SpParamsMED, byCohorts = TRUE), "ggplot")
  expect_s3_class(vprofile_leafAreaDensity(exampleforest2, SpParamsMED, byCohorts = TRUE, includeHerbs = TRUE), "ggplot")
  expect_s3_class(vprofile_PARExtinction(exampleforest2, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_SWRExtinction(exampleforest2, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_windExtinction(exampleforest2, SpParamsMED), "ggplot")
})

test_that("Can produce all vertical profiles with minimal forest",{
  expect_s3_class(vprofile_rootDistribution(exampleforest_minimal, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_fuelBulkDensity(exampleforest_minimal, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_leafAreaDensity(exampleforest_minimal, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_leafAreaDensity(exampleforest_minimal, SpParamsMED, byCohorts = TRUE), "ggplot")
  expect_s3_class(vprofile_leafAreaDensity(exampleforest_minimal, SpParamsMED, byCohorts = TRUE, includeHerbs = TRUE), "ggplot")
  expect_s3_class(vprofile_PARExtinction(exampleforest_minimal, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_SWRExtinction(exampleforest_minimal, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_windExtinction(exampleforest_minimal, SpParamsMED), "ggplot")
})

test_that("Can produce all vertical profiles with herb forest",{
  expect_s3_class(vprofile_rootDistribution(forest_herbs, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_fuelBulkDensity(forest_herbs, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_leafAreaDensity(forest_herbs, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_leafAreaDensity(forest_herbs, SpParamsMED, byCohorts = TRUE), "ggplot")
  expect_s3_class(vprofile_leafAreaDensity(forest_herbs, SpParamsMED, byCohorts = TRUE, includeHerbs = TRUE), "ggplot")
  expect_s3_class(vprofile_PARExtinction(forest_herbs, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_SWRExtinction(forest_herbs, SpParamsMED), "ggplot")
  expect_s3_class(vprofile_windExtinction(forest_herbs, SpParamsMED), "ggplot")
})
test_that("Cannot produce vertical profiles with empty forest",{
  expect_error(vprofile_rootDistribution(emptyforest, SpParamsMED))
  expect_error(vprofile_fuelBulkDensity(emptyforest, SpParamsMED))
  expect_error(vprofile_leafAreaDensity(emptyforest, SpParamsMED))
  expect_error(vprofile_PARExtinction(emptyforest, SpParamsMED))
  expect_error(vprofile_SWRExtinction(emptyforest, SpParamsMED))
  expect_error(vprofile_windExtinction(emptyforest, SpParamsMED))
})

test_that("Test forest summary",{
  expect_s3_class(summary(exampleforest, SpParamsMED), "summary.forest")
  expect_s3_class(summary(exampleforest2, SpParamsMED), "summary.forest")
  expect_s3_class(summary(exampleforest_minimal, SpParamsMED), "summary.forest")
  expect_s3_class(summary(emptyforest, SpParamsMED), "summary.forest")
  expect_s3_class(summary(forest_herbs, SpParamsMED), "summary.forest")
})

test_that("Test forest simplification",{
  f <- exampleforest
  f$treeData$Z100 <- c(1500, 1900)
  f$shrubDataZ100 <- 800
  expect_s3_class(forest_reduceToDominant(exampleforest, SpParamsMED), "forest")
  expect_s3_class(forest_reduceToDominant(exampleforest2, SpParamsMED), "forest")
  expect_s3_class(forest_reduceToDominant(exampleforest_minimal, SpParamsMED), "forest")
  expect_s3_class(forest_reduceToDominant(emptyforest(), SpParamsMED), "forest")
  expect_s3_class(forest_reduceToDominant(f, SpParamsMED), "forest")
  expect_s3_class(forest_mergeTrees(exampleforest), "forest")
  expect_error(forest_mergeTrees(exampleforest2)) # Missing values
  expect_s3_class(forest_mergeTrees(exampleforest_minimal), "forest")
  expect_s3_class(forest_mergeTrees(emptyforest()), "forest")
  expect_s3_class(forest_mergeTrees(emptyforest(addcolumns = "LAI")), "forest")
  expect_s3_class(forest_mergeTrees(f), "forest")
  expect_s3_class(forest_mergeShrubs(exampleforest), "forest")
  expect_error(forest_mergeShrubs(exampleforest2)) # Missing values
  expect_s3_class(forest_mergeShrubs(exampleforest_minimal), "forest")
  expect_s3_class(forest_mergeShrubs(emptyforest()), "forest")
  expect_s3_class(forest_mergeShrubs(emptyforest(addcolumns = "LAI")), "forest")
  expect_s3_class(forest_mergeShrubs(f), "forest")
  f2 <- exampleforest
  f2$shrubData <- rbind(f2$shrubData, f2$shrubData, f2$shrubData)
  f2$shrubData$ObsID <- c(NA,"1", NA)
  f2$treeData$ObsID <- c("1", NA)
  expect_s3_class(forest_mergeTrees(f2), "forest")
  expect_s3_class(forest_mergeShrubs(f2), "forest")
  expect_s3_class(forest_mergeTrees(f2, keepCohortsWithObsID = TRUE), "forest")
  expect_s3_class(forest_mergeShrubs(f2, keepCohortsWithObsID = TRUE), "forest")
})

test_that("Test stand metrics with exampleforest",{
  expect_type(stand_basalArea(exampleforest), "double")
  expect_type(stand_foliarBiomass(exampleforest, SpParamsMED), "double")
  expect_type(stand_fuelLoading(exampleforest, SpParamsMED), "double")
  expect_type(stand_foliarBiomass(exampleforest, SpParamsMED), "double")
  expect_type(stand_LAI(exampleforest, SpParamsMED), "double")
  expect_type(stand_shrubVolume(exampleforest, SpParamsMED), "double")
  expect_type(stand_dominantTreeDiameter(exampleforest), "double")
  expect_type(stand_dominantTreeSpecies(exampleforest, SpParamsMED), "character")
  expect_type(stand_treeDensity(exampleforest), "double")
  expect_type(stand_meanTreeHeight(exampleforest), "double")
  expect_type(stand_dominantTreeHeight(exampleforest), "double")
  expect_type(stand_hartBeckingIndex(exampleforest), "double")
  expect_type(stand_quadraticMeanTreeDiameter(exampleforest), "double")
})

test_that("Test stand metrics with exampleforest2",{
  expect_type(stand_basalArea(exampleforest2), "double")
  expect_type(stand_foliarBiomass(exampleforest2, SpParamsMED), "double")
  expect_type(stand_fuelLoading(exampleforest2, SpParamsMED), "double")
  expect_type(stand_foliarBiomass(exampleforest2, SpParamsMED), "double")
  expect_type(stand_LAI(exampleforest2, SpParamsMED), "double")
  expect_type(stand_shrubVolume(exampleforest2, SpParamsMED), "double")
  expect_error(stand_dominantTreeDiameter(exampleforest2)) # Missing values
  expect_type(stand_dominantTreeSpecies(exampleforest2, SpParamsMED), "character")
  expect_error(stand_treeDensity(exampleforest2)) # Missing values
  expect_error(stand_meanTreeHeight(exampleforest2)) # Missing values
  expect_error(stand_dominantTreeHeight(exampleforest2)) # Missing values
  expect_error(stand_hartBeckingIndex(exampleforest2)) # Missing values
  expect_error(stand_quadraticMeanTreeDiameter(exampleforest2)) # Missing values
})

test_that("Test stand metrics with empty forest",{
  expect_type(stand_basalArea(emptyforest), "double")
  expect_type(stand_foliarBiomass(emptyforest, SpParamsMED), "double")
  expect_type(stand_fuelLoading(emptyforest, SpParamsMED), "double")
  expect_type(stand_foliarBiomass(emptyforest, SpParamsMED), "double")
  expect_type(stand_LAI(emptyforest, SpParamsMED), "double")
  expect_type(stand_shrubVolume(emptyforest, SpParamsMED), "double")
  expect_type(stand_dominantTreeDiameter(emptyforest), "double")
  expect_type(stand_dominantTreeSpecies(emptyforest, SpParamsMED), "character")
  expect_type(stand_treeDensity(emptyforest), "double")
  expect_type(stand_meanTreeHeight(emptyforest), "double")
  expect_type(stand_dominantTreeHeight(emptyforest), "double")
  expect_type(stand_hartBeckingIndex(emptyforest), "double")
  expect_type(stand_quadraticMeanTreeDiameter(emptyforest), "double")
})

test_that("Test stand metrics with minimal data",{
  expect_type(stand_basalArea(exampleforest_minimal), "double")
  expect_type(stand_foliarBiomass(exampleforest_minimal, SpParamsMED), "double")
  expect_type(stand_fuelLoading(exampleforest_minimal, SpParamsMED), "double")
  expect_type(stand_foliarBiomass(exampleforest_minimal, SpParamsMED), "double")
  expect_type(stand_LAI(exampleforest_minimal, SpParamsMED), "double")
  expect_type(stand_shrubVolume(exampleforest_minimal, SpParamsMED), "double")
  expect_type(stand_dominantTreeDiameter(exampleforest_minimal), "double")
  expect_type(stand_dominantTreeSpecies(exampleforest_minimal, SpParamsMED), "character")
  expect_type(stand_treeDensity(exampleforest_minimal), "double")
  expect_type(stand_meanTreeHeight(exampleforest_minimal), "double")
  expect_type(stand_dominantTreeHeight(exampleforest_minimal), "double")
  expect_type(stand_hartBeckingIndex(exampleforest_minimal), "double")
  expect_type(stand_quadraticMeanTreeDiameter(exampleforest_minimal), "double")
})

test_that("Test stand metrics with herb forest",{
  expect_type(stand_basalArea(forest_herbs), "double")
  expect_type(stand_foliarBiomass(forest_herbs, SpParamsMED), "double")
  expect_type(stand_fuelLoading(forest_herbs, SpParamsMED), "double")
  expect_type(stand_foliarBiomass(forest_herbs, SpParamsMED), "double")
  expect_type(stand_LAI(forest_herbs, SpParamsMED), "double")
  expect_type(stand_shrubVolume(forest_herbs, SpParamsMED), "double")
  expect_type(stand_dominantTreeDiameter(forest_herbs), "double")
  expect_type(stand_dominantTreeSpecies(forest_herbs, SpParamsMED), "character")
  expect_type(stand_treeDensity(forest_herbs), "double")
  expect_type(stand_meanTreeHeight(forest_herbs), "double")
  expect_type(stand_dominantTreeHeight(forest_herbs), "double")
  expect_type(stand_hartBeckingIndex(forest_herbs), "double")
  expect_type(stand_quadraticMeanTreeDiameter(forest_herbs), "double")
})
test_that("Test stand metrics with missing tree data",{
  f <-exampleforest
  f$treeData<- f$treeData[numeric(0), ,drop = FALSE]
  expect_type(stand_basalArea(f), "double")
  expect_type(stand_foliarBiomass(f, SpParamsMED), "double")
  expect_type(stand_fuelLoading(f, SpParamsMED), "double")
  expect_type(stand_foliarBiomass(f, SpParamsMED), "double")
  expect_type(stand_shrubVolume(f, SpParamsMED), "double")
  expect_type(stand_LAI(f, SpParamsMED), "double")
  expect_type(stand_dominantTreeDiameter(f), "double")
  expect_type(stand_dominantTreeSpecies(f, SpParamsMED), "character")
  expect_type(stand_treeDensity(f), "double")
  expect_type(stand_meanTreeHeight(f), "double")
  expect_type(stand_dominantTreeHeight(f), "double")
  expect_type(stand_hartBeckingIndex(f), "double")
  expect_type(stand_quadraticMeanTreeDiameter(f), "double")
})

test_that("Test stand metrics with missing shrub data",{
  f <-exampleforest
  f$shrubData<- f$shrubData[numeric(0), ,drop = FALSE]
  expect_type(stand_basalArea(f), "double")
  expect_type(stand_foliarBiomass(f, SpParamsMED), "double")
  expect_type(stand_fuelLoading(f, SpParamsMED), "double")
  expect_type(stand_foliarBiomass(f, SpParamsMED), "double")
  expect_type(stand_shrubVolume(f, SpParamsMED), "double")
  expect_type(stand_LAI(f, SpParamsMED), "double")
  expect_type(stand_dominantTreeDiameter(f), "double")
  expect_type(stand_dominantTreeSpecies(f, SpParamsMED), "character")
  expect_type(stand_treeDensity(f), "double")
  expect_type(stand_meanTreeHeight(f), "double")
  expect_type(stand_dominantTreeHeight(f), "double")
  expect_type(stand_hartBeckingIndex(f), "double")
  expect_type(stand_quadraticMeanTreeDiameter(f), "double")
})


test_that("Test stand metrics with missing tree and shrub data",{
  f <-exampleforest
  f$treeData<- f$treeData[numeric(0), ,drop = FALSE]
  f$shrubData<- f$shrubData[numeric(0), ,drop = FALSE]
  expect_type(stand_basalArea(f), "double")
  expect_type(stand_foliarBiomass(f, SpParamsMED), "double")
  expect_type(stand_fuelLoading(f, SpParamsMED), "double")
  expect_type(stand_foliarBiomass(f, SpParamsMED), "double")
  expect_type(stand_shrubVolume(f, SpParamsMED), "double")
  expect_type(stand_LAI(f, SpParamsMED), "double")
  expect_type(stand_dominantTreeDiameter(f), "double")
  expect_type(stand_dominantTreeSpecies(f, SpParamsMED), "character")
  expect_type(stand_treeDensity(f), "double")
  expect_type(stand_meanTreeHeight(f), "double")
  expect_type(stand_dominantTreeHeight(f), "double")
  expect_type(stand_hartBeckingIndex(f), "double")
  expect_type(stand_quadraticMeanTreeDiameter(f), "double")
})

#' Creation of an empty forest
#' 
#' Creates an empty \code{\link{forest}} object.
#' 
#' @param ntree,nshrub,nherb Number of tree, shrub and herb cohorts, respectively.
#' @param nseedling Number of species in the seedling bank.
#' @param nseed Number of species in the seed bank.
#' @param nsnag Number of snag (dead standing) cohorts.
#' @param nlitter Number of items in the litter compartment.
#' @param addcolumns A character vector with additional columns. Currently allowed are (see \code{\link{forest}}):
#' \itemize{
#'  \item{\code{Z100}: A numeric vector with maximum rooting depth in mm.}
#'  \item{\code{LAI}: Leaf area index (m2/m2).}
#'  \item{\code{FoliarBiomass}: Standing dry biomass of leaves (kg/m2).}
#'  \item{\code{FuelLoading}: Fine fuel loading (kg/m2).}
#'  \item{\code{CrownRatio}: The ratio between crown length and total height (between 0 and 1)}
#'  \item{\code{Age}: A numeric vector indicating age of cohorts in years.}
#'  \item{\code{ObsID} A character vector to label specific cohorts in simulations of forest dynamics.}
#' }
#' @param SOC A boolean flag to initialize SOC data (see \code{\link{forest}}).
#' 
#' @details
#' List elements \code{treeData} and \code{shrubData} are always created, regardless of the number of cohorts. 
#' In contrast, list elements \code{herbData}, \code{seedBank} and \code{seedlingBank} are only created if \code{nherb}, \code{nseed} and \code{nseedling} are non-zero, respectively.
#' 
#' 
#' @return An empty \code{\link{forest}} object.
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso \code{\link{forest}}, \code{\link{tree2forest}}, \code{\link{summary.forest}}, \code{\link{forest_mapWoodyTables}},  \code{\link{forest_mergeTrees}},  
#' \code{\link{plot.forest}}
#' 
#' @examples 
#' # Initializes forest with 2 tree cohorts
#' emptyforest(ntree = 2)
#' 
#' # Initializes forest with 2 tree cohorts and 1 shrub cohort
#' emptyforest(ntree = 2, nshrub = 1)
#' 
#' # Initializes with extra column for leaf area index (LAI)
#' emptyforest(ntree = 2, nshrub = 1, addcolumns = "LAI")
#' 
#' # Initializes forest with 2 tree cohorts, 1 shrub cohort and 1 herbaceous cohort
#' emptyforest(ntree = 2, nshrub = 1, nherb = 1)
#' @name emptyforest
emptyforest <- function(ntree = 0, nshrub = 0, nherb = 0, nseedling = 0, nseed = 0, nsnag = 0, nlitter = 0,
                        addcolumns = NULL, SOC = FALSE) {
  l <- list()
  l$treeData <- data.frame(Species=as.character(rep(NA, ntree)),
                           DBH=as.numeric(rep(NA, ntree)), 
                           Height=as.numeric(rep(NA, ntree)), 
                           N=as.numeric(rep(NA, ntree)),
                           Z50 = as.numeric(rep(NA, ntree)), 
                           Z95=as.numeric(rep(NA, ntree)))
  l$shrubData <- data.frame(Species=as.character(rep(NA, nshrub)), 
                            Height=as.numeric(rep(NA, nshrub)), 
                            Cover = as.numeric(rep(NA, nshrub)), 
                            Z50 = as.numeric(rep(NA, nshrub)), 
                            Z95=as.numeric(rep(NA, nshrub)))

  if(nherb>0) {
    l$herbData <- data.frame(Species=as.character(rep(NA, nshrub)), 
                              Height=as.numeric(rep(NA, nshrub)), 
                              Cover = as.numeric(rep(NA, nshrub)), 
                              Z50 = as.numeric(rep(NA, nshrub)), 
                              Z95=as.numeric(rep(NA, nshrub)))
  }
  if(nseedling > 0) {
    l$seedlingBank <- data.frame(Species = as.character(rep(NA, nseedling)),
                                 Percent = as.numeric(rep(NA, nseedling)),
                                 Age = as.numeric(rep(NA, nseedling)),
                                 Z50 = as.numeric(rep(NA, nseedling)),
                                 Z95 = as.numeric(rep(NA, nseedling)))
  }
  if(nseed > 0 ) {
    l$seedBank <- data.frame(Species = as.character(rep(NA, nseed)),
                             Percent = as.numeric(rep(NA, nseed)))
  }
  if(nsnag > 0) {
    l$snagData<- data.frame(Species = as.character(rep(NA, nsnag)),
                            DBH = as.numeric(rep(NA, nsnag)),
                            Height = as.numeric(rep(NA, nsnag)),
                            DeathAge = as.numeric(rep(NA, nsnag)),
                            SmallBranches = as.numeric(rep(NA, nsnag)),
                            LargeWood = as.numeric(rep(NA, nsnag)))
  }
  if(nlitter > 0) {
    l$litterData <- data.frame(Species = as.character(rep(NA, nlitter)),
                               Leaves = as.numeric(rep(NA, nlitter)),
                               Twigs = as.numeric(rep(NA, nlitter)),
                               SmallBranches = as.numeric(rep(NA, nlitter)),
                               LargeWood = as.numeric(rep(NA, nlitter)),
                               CoarseRoots = as.numeric(rep(NA, nlitter)),
                               FineRoots = as.numeric(rep(NA, nlitter)))
  }
  
  if(!is.null(addcolumns)) {
    if(!is.character(addcolumns)) stop("`addcolumns` should be a character vector")
    addcolumns <- match.arg(addcolumns, c("Z100", "LAI", "FoliarBiomass", "FuelLoading", "CrownRatio", "Age", "ObsID") , several.ok = TRUE)
    if("Z100" %in% addcolumns) {
      l$treeData$Z100 <- as.numeric(rep(NA, ntree))
      l$shrubData$Z100 <- as.numeric(rep(NA, nshrub))
      if(nherb>0) l$herbData$Z100 <- as.numeric(rep(NA, nherb))
      if(nseedling>0) l$seedlingBank$Z100 <- as.numeric(rep(NA, nseedling))
    }
    if("Age" %in% addcolumns) {
      l$treeData$Age <- as.numeric(rep(NA, ntree))
      l$shrubData$Age <- as.numeric(rep(NA, nshrub))
      if(nherb>0) l$herbData$Age <- as.numeric(rep(NA, nherb))
    }
    if("LAI" %in% addcolumns) {
      l$treeData$LAI <- as.numeric(rep(NA, ntree))
      l$shrubData$LAI <- as.numeric(rep(NA, nshrub))
      if(nherb>0) l$herbData$LAI <- as.numeric(rep(NA, nherb))
    }
    if("FoliarBiomass" %in% addcolumns) {
      l$treeData$FoliarBiomass <- as.numeric(rep(NA, ntree))
      l$shrubData$FoliarBiomass <- as.numeric(rep(NA, nshrub))
      if(nherb>0) l$herbData$FoliarBiomass <- as.numeric(rep(NA, nherb))
    }
    if("FuelLoading" %in% addcolumns) {
      l$treeData$FuelLoading <- as.numeric(rep(NA, ntree))
      l$shrubData$FuelLoading <- as.numeric(rep(NA, nshrub))
      if(nherb>0) l$herbData$FuelLoading <- as.numeric(rep(NA, nherb))
    }
    if("CrownRatio" %in% addcolumns) {
      l$treeData$CrownRatio <- as.numeric(rep(NA, ntree))
      l$shrubData$CrownRatio <- as.numeric(rep(NA, nshrub))
      if(nherb>0) l$herbData$CrownRatio <- as.numeric(rep(NA, nherb))
    }
    if("ObsID" %in% addcolumns) {
      l$treeData$ObsID <- as.character(rep(NA, ntree))
      l$shrubData$ObsID <- as.character(rep(NA, nshrub))
      if(nherb>0) l$herbData$ObsID <- as.numeric(rep(NA, nherb))
    }
  }

  if(SOC) {
    l$SOCData = c(SurfaceMetabolic = 0, BelowgroundMetabolic = 0, SurfaceActive = 0, BelowgroundActive = 0,
                  SurfaceSlow = 0, BelowgroundSlow = 0, BelowgroundPassive = 0)
  }  
  class(l)<-c("forest","list")
  return(l)
}

library(medfate)

data(exampleforest)
data(SpParamsMED)

exampleforest_minimal <- exampleforest
exampleforest_minimal$shrubData <- exampleforest_minimal$shrubData[numeric(0),,drop = FALSE]
exampleforest_minimal$herbCover <- NULL
exampleforest_minimal$herbHeight <- NULL
exampleforest_minimal$seedBank <- NULL
exampleforest_minimal$seedlingBank <- NULL

emptyforest <- emptyforest()

forest_herbs <- exampleforest
forest_herbs$herbData <- forest_herbs$shrubData

test_that("Plant ID can be retrieved",{
  expect_type(plant_ID(exampleforest, SpParamsMED), "character")
  expect_type(plant_ID(exampleforest_minimal, SpParamsMED), "character")
  expect_type(plant_ID(emptyforest, SpParamsMED), "character")
  expect_type(plant_ID(forest_herbs, SpParamsMED), "character")
})

test_that("Plant species can be retrieved",{
  expect_type(plant_species(exampleforest, SpParamsMED), "integer")
  expect_type(plant_species(exampleforest_minimal, SpParamsMED), "integer")
  expect_type(plant_species(emptyforest, SpParamsMED), "integer")
  expect_type(plant_species(forest_herbs, SpParamsMED), "integer")
})

test_that("Plant species name can be retrieved",{
  expect_type(plant_speciesName(exampleforest, SpParamsMED), "character")
  expect_type(plant_speciesName(exampleforest_minimal, SpParamsMED), "character")
  expect_type(plant_speciesName(emptyforest, SpParamsMED), "character")
  expect_type(plant_speciesName(forest_herbs, SpParamsMED), "character")
})
test_that("Plant height can be retrieved",{
  expect_type(plant_height(exampleforest, SpParamsMED), "double")
  expect_type(plant_height(exampleforest_minimal, SpParamsMED), "double")
  expect_type(plant_height(emptyforest, SpParamsMED), "double")
  expect_type(plant_height(forest_herbs, SpParamsMED), "double")
})
test_that("Plant density can be retrieved",{
  expect_type(plant_density(exampleforest, SpParamsMED), "double")
  expect_type(plant_density(exampleforest_minimal, SpParamsMED), "double")
  expect_type(plant_density(emptyforest, SpParamsMED), "double")
  expect_type(plant_density(forest_herbs, SpParamsMED), "double")
})
test_that("Plant cover can be retrieved",{
  expect_type(plant_cover(exampleforest, SpParamsMED), "double")
  expect_type(plant_cover(exampleforest_minimal, SpParamsMED), "double")
  expect_type(plant_cover(emptyforest, SpParamsMED), "double")
  expect_type(plant_cover(forest_herbs, SpParamsMED), "double")
})
test_that("Tree basal area can be retrieved",{
  expect_type(plant_basalArea(exampleforest, SpParamsMED), "double")
  expect_type(plant_basalArea(exampleforest_minimal, SpParamsMED), "double")
  expect_type(plant_basalArea(emptyforest, SpParamsMED), "double")
  expect_type(plant_basalArea(forest_herbs, SpParamsMED), "double")
})

test_that("Larger tree basal area can be retrieved",{
  expect_type(plant_largerTreeBasalArea(exampleforest, SpParamsMED), "double")
  expect_type(plant_largerTreeBasalArea(exampleforest_minimal, SpParamsMED), "double")
  expect_type(plant_largerTreeBasalArea(emptyforest, SpParamsMED), "double")
  expect_type(plant_largerTreeBasalArea(forest_herbs, SpParamsMED), "double")
})

test_that("Plant individual area can be retrieved",{
  expect_type(plant_individualArea(exampleforest, SpParamsMED), "double")
  expect_type(plant_individualArea(exampleforest_minimal, SpParamsMED), "double")
  expect_type(plant_individualArea(emptyforest, SpParamsMED), "double")
  expect_type(plant_individualArea(forest_herbs, SpParamsMED), "double")
})

test_that("Plant crown ratio can be retrieved",{
  expect_type(plant_crownRatio(exampleforest, SpParamsMED), "double")
  expect_type(plant_crownRatio(exampleforest_minimal, SpParamsMED), "double")
  expect_type(plant_crownRatio(emptyforest, SpParamsMED), "double")
  expect_type(plant_crownRatio(forest_herbs, SpParamsMED), "double")
})

test_that("Plant crown base height can be retrieved",{
  expect_type(plant_crownBaseHeight(exampleforest, SpParamsMED), "double")
  expect_type(plant_crownBaseHeight(exampleforest_minimal, SpParamsMED), "double")
  expect_type(plant_crownBaseHeight(emptyforest, SpParamsMED), "double")
  expect_type(plant_crownBaseHeight(forest_herbs, SpParamsMED), "double")
})

test_that("Plant crown length can be retrieved",{
  expect_type(plant_crownLength(exampleforest, SpParamsMED), "double")
  expect_type(plant_crownLength(exampleforest_minimal, SpParamsMED), "double")
  expect_type(plant_crownLength(emptyforest, SpParamsMED), "double")
  expect_type(plant_crownLength(forest_herbs, SpParamsMED), "double")
})

test_that("Plant foliar biomass can be retrieved",{
  expect_type(plant_foliarBiomass(exampleforest, SpParamsMED), "double")
  expect_type(plant_foliarBiomass(exampleforest_minimal, SpParamsMED), "double")
  expect_type(plant_foliarBiomass(emptyforest, SpParamsMED), "double")
  expect_type(plant_foliarBiomass(forest_herbs, SpParamsMED), "double")
})

test_that("Plant fuel loading can be retrieved",{
  expect_type(plant_fuelLoading(exampleforest, SpParamsMED), "double")
  expect_type(plant_fuelLoading(exampleforest_minimal, SpParamsMED), "double")
  expect_type(plant_fuelLoading(emptyforest, SpParamsMED), "double")
  expect_type(plant_fuelLoading(forest_herbs, SpParamsMED), "double")
})

test_that("Plant equilibrium leaf litter can be retrieved",{
  expect_type(plant_equilibriumLeafLitter(exampleforest, SpParamsMED), "double")
  expect_type(plant_equilibriumLeafLitter(exampleforest_minimal, SpParamsMED), "double")
  expect_type(plant_equilibriumLeafLitter(emptyforest, SpParamsMED), "double")
  expect_type(plant_equilibriumLeafLitter(forest_herbs, SpParamsMED), "double")
})

test_that("Plant equilibrium small branch litter can be retrieved",{
  expect_type(plant_equilibriumSmallBranchLitter(exampleforest, SpParamsMED), "double")
  expect_type(plant_equilibriumSmallBranchLitter(exampleforest_minimal, SpParamsMED), "double")
  expect_type(plant_equilibriumSmallBranchLitter(emptyforest, SpParamsMED), "double")
  expect_type(plant_equilibriumSmallBranchLitter(forest_herbs, SpParamsMED), "double")
})


test_that("Plant phytovolume can be retrieved",{
  expect_type(plant_phytovolume(exampleforest, SpParamsMED), "double")
  expect_type(plant_phytovolume(exampleforest_minimal, SpParamsMED), "double")
  expect_type(plant_phytovolume(emptyforest, SpParamsMED), "double")
  expect_type(plant_phytovolume(forest_herbs, SpParamsMED), "double")
})


test_that("Plant LAI can be retrieved",{
  expect_type(plant_LAI(exampleforest, SpParamsMED), "double")
  expect_type(plant_LAI(exampleforest_minimal, SpParamsMED), "double")
  expect_type(plant_LAI(emptyforest, SpParamsMED), "double")
  expect_type(plant_LAI(forest_herbs, SpParamsMED), "double")
})

test_that("Aboveground data frame can be build",{
  expect_s3_class(forest2aboveground(exampleforest, SpParamsMED), "data.frame")
  expect_s3_class(forest2aboveground(exampleforest_minimal, SpParamsMED), "data.frame")
  expect_s3_class(forest2aboveground(emptyforest, SpParamsMED), "data.frame")
  expect_s3_class(forest2aboveground(forest_herbs, SpParamsMED), "data.frame")
})

test_that("belowground data frame can be build",{
  s = soil(defaultSoilParams())
  expect_type(forest2belowground(exampleforest, s, SpParamsMED), "double")
  expect_type(forest2belowground(exampleforest_minimal, s, SpParamsMED), "double")
  expect_type(forest2belowground(emptyforest, s, SpParamsMED), "double")
  expect_type(forest2belowground(forest_herbs, s, SpParamsMED), "double")
})

.soil_plot_choices<-function(){
  c("RetentionCurve", "ConductivityCurve")
}

#' Soil water retention and conductivity plots
#' 
#' Internal functions to display water retention curves and conductivity curves.
#' 
#' @param layer Soil layer to be plotted.
#' @param relative Boolean flag to indicate that retention curve should be relative to field capacity or saturation.
#' @param to Either 'SAT' (saturation) or 'FC' (field capacity).
#' @param soil Initialized soil object (returned by function \code{\link{soil}}).
#' @param model model Either 'SX' or 'VG' for Saxton's or Van Genuchten's water retention models; or 'both' to plot both retention models.
#' @param psi A numeric vector specifying a sequence of water potential values.
#' 
#' @details
#' \itemize{
#'    \item{\code{soil_retentionCurvePlot()} allows plotting the water retention curve of a given soil layer.}
#'    \item{\code{soil_conductivityCurvePlot()} allows plotting the conductivity curve of a given soil layer.}
#' }
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @return An object of class ggplot.
#' 
#' @seealso  \code{\link{soil_texture}}
#' @name soil_retentionCurvePlot
#' @keywords internal
soil_retentionCurvePlot<-function(soil, model="SX", layer = 1, 
                                  psi = seq(0, -6.0, by=-0.01),
                                  relative = TRUE, to = "SAT") {
  if(!inherits(soil, "soil")) stop("Parameter 'soil' should be an object of class 'soil'")
  model = match.arg(model, c("SX", "VG", "both"))
  to = match.arg(to, c("SAT", "FC"))
  y_sx = unlist(lapply(as.list(psi), FUN=soil_psi2thetaSX, 
                       clay=soil$clay[layer], 
                       sand=soil$sand[layer], om = soil$om[layer]))
  y_vg = unlist(lapply(as.list(psi), FUN=soil_psi2thetaVG, 
                       alpha=soil$VG_alpha[layer], n = soil$VG_n[layer], 
                       theta_res = soil$VG_theta_res[layer], 
                       theta_sat = soil$VG_theta_sat[layer])) 
  if(relative) {
    if(to=="SAT") {
      toString = "% saturation" 
      tfc_sx = soil_thetaSAT(soil, "SX")
      tfc_vg = soil_thetaSAT(soil, "VG")
    } else if(to=="FC") {
      toString = "% field capacity" 
      tfc_sx = soil_thetaFC(soil, "SX")
      tfc_vg = soil_thetaFC(soil, "VG")
    }
    y_sx = 100*(y_sx/tfc_sx[layer])
    y_vg = 100*(y_vg/tfc_vg[layer])
    ylab=paste0("Moisture content (",toString,")")
  } else {
    ylab="Moisture content (% volume)"
  }
  df = data.frame(SX = y_sx, VG = y_vg, psi = -psi)
  xlab = "Soil water potential (-MPa)"
  g<-ggplot(df, aes(x=.data$psi))  
  if(model=="SX") {
    g<-g+ geom_path(aes(y=.data$SX), col="black")+
       ylab(ylab)+ xlab(xlab)+
       theme_bw()
    return(g)
  }
  else if(model=="VG") {
    g<-g+ geom_path(aes(y=.data$VG), col="black")+
      ylab(ylab)+ xlab(xlab)+
      theme_bw()
    return(g)  
  } 
  else {
    SX = df$SX
    VG = df$VG
    g<-g+ geom_path(aes(y=SX, linetype ="Saxton"), col="black")+
      geom_path(aes(y=VG, linetype ="Van Genuchten"), col="black")+
      scale_linetype_manual(name="", values=c("solid", "dashed"))+
      ylab(ylab)+ xlab(xlab)+
      theme_bw()
    return(g)  
  }
}

#' @rdname soil_retentionCurvePlot
#' @param mmol Boolean flag to indicate that saturated conductivity units should be returned in mmol/m/s/MPa. If \code{mmol = FALSE} then units are cm/day.
#' @param log Boolean to display the y-axis in logarithm units
#' @keywords internal
soil_conductivityCurvePlot<-function(soil, model="SX", layer = 1, 
                                psi = seq(0, -6.0, by=-0.01),
                                relative = TRUE, to = "SAT", log = TRUE, mmol = TRUE) {
  if(!inherits(soil, "soil")) stop("Parameter 'soil' should be an object of class 'soil'")
  model = match.arg(model, c("SX", "VG", "both"))
  to = match.arg(to, c("SAT", "FC"))
  theta_sx = unlist(lapply(as.list(psi), FUN=soil_psi2thetaSX, 
                       clay=soil$clay[layer], 
                       sand=soil$sand[layer], om = soil$om[layer]))
  y_sx = unlist(lapply(as.list(theta_sx), FUN=soil_unsaturatedConductivitySX, 
                       clay=soil$clay[layer], 
                       sand=soil$sand[layer], bd = soil$bd[layer], om = soil$om[layer], mmol = TRUE))
  y_vg = unlist(lapply(as.list(psi), FUN=soil_psi2kVG, 
                       ksat= soil$Ksat[layer],
                       alpha=soil$VG_alpha[layer], n = soil$VG_n[layer], 
                       theta_res = soil$VG_theta_res[layer], 
                       theta_sat = soil$VG_theta_sat[layer])) 
  if(relative) {
    if(to=="SAT") {
      toString = "% saturation" 
      cfc_sx = soil$Ksat[layer]
      cfc_vg = soil$Ksat[layer]
    } else if(to=="FC") {
      toString = "% field capacity" 
      theta_fc_sx = soil_thetaFC(soil, "SX")
      cfc_sx = soil_unsaturatedConductivitySX(theta_fc_sx[layer],clay=soil$clay[layer], 
                                              sand=soil$sand[layer], bd = soil$bd[layer], om = soil$om[layer], mmol = TRUE)
      cfc_vg = soil_psi2kVG(ksat= soil$Ksat[layer],
                                 alpha=soil$VG_alpha[layer], n = soil$VG_n[layer], 
                                 theta_res = soil$VG_theta_res[layer], 
                                 theta_sat = soil$VG_theta_sat[layer],
                                 psi = -0.033)  # Field capacity at -0.033 MPa
    }
    y_sx = 100*(y_sx/cfc_sx)
    y_vg = 100*(y_vg/cfc_vg)
    ylab=paste0("Conductivity (",toString,")")
  } else {
    if(mmol) {
      ylab=expression(paste("Conductivity ",(mmol%.%m^{-1}%.%MPa^{-1}%.%s^{-1})))
    } else {
      cmdTOmmolm2sMPa = 655.2934
      y_sx <- y_sx/cmdTOmmolm2sMPa
      y_vg <- y_vg/cmdTOmmolm2sMPa
      ylab=expression(paste("Conductivity ",(cm%.%d^{-1})))
    }
  }

  df = data.frame(SX = y_sx, VG = y_vg, psi = -psi)
  xlab = "Soil water potential (-MPa)"
  g<-ggplot(df, aes(x=.data$psi))  
  if(model=="SX") {
    g<-g+ geom_path(aes(y=.data$SX), col="black")
  }
  else if(model=="VG") {
    g<-g+ geom_path(aes(y=.data$VG), col="black")
  } 
  else {
    SX = df$SX
    VG = df$VG
    g<-g+ geom_path(aes(y=SX, linetype ="Saxton"), col="black")+
      geom_path(aes(y=VG, linetype ="Van Genuchten"), col="black")+
      scale_linetype_manual(name="", values=c("solid", "dashed"))
  }
  if(log) g <- g+
    scale_y_log10()
  g <- g+
    ylab(ylab)+ xlab(xlab)+
    theme_bw()
  return(g)  
}


#' Soil water curves
#'
#' Function for plotting water retention or conductivity curves for soil layers.
#'
#' @param x Initialized soil object (returned by function \code{\link{soil}}).
#' @param type A string of the plot type: "RetentionCurve" or "ConductivityCurve". 
#' @param model model Either 'SX' or 'VG' for Saxton's or Van Genuchten's water retention models; or 'both' to plot both retention models.
#' @param layer Soil layer to be plotted.
#' @param relative Boolean flag to indicate that retention curve should be relative to field capacity or saturation.
#' @param to Either 'SAT' (saturation) or 'FC' (field capacity).
#' @param \dots Additional parameters to specific functions
#' 
#' @return An object of class ggplot.
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @details
#' The function is a common wrapper to specialized internal functions (see \code{\link{soil_retentionCurvePlot}}).
#' 
#' @seealso \code{\link{soil}}, \code{\link{summary.soil}}, \code{\link{soil_retentionCurvePlot}}
#' 
#' @examples
#' # Initializes soil
#' s = soil(defaultSoilParams())
#' plot(s)
#' 
#' @name plot.soil
plot.soil<-function(x, type = "RetentionCurve", model="SX",  layer = 1, 
                    relative = TRUE, to = "SAT", ...) {
  type = match.arg(type, .soil_plot_choices())
  if(type=="RetentionCurve") return(soil_retentionCurvePlot(soil = x, model = model, layer = layer, relative = relative, to = to, ... ))
  else if(type=="ConductivityCurve") return(soil_conductivityCurvePlot(soil = x, model = model, layer = layer, relative = relative, to = to, ...))
}

#' Redefine soil layer widths
#'
#' Allows redefining soil layer widths of an input data frame of soil parameters.
#'
#' @param x A data frame of soil parameters (see an example in \code{\link{defaultSoilParams}}) or an object of class \code{\link{soil}}.
#' @param widths A numeric vector indicating the desired layer widths, in mm.
#'
#' @author \enc{Víctor}{Victor} Granda, EMF-CREAF
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, EMF-CREAF
#'
#' @details
#' If an initialized \code{\link{soil}} is supplied, its hydraulic parameters will be recalculated and the value of state variables will be lost.
#' 
#' @return A data frame or \code{\link{soil}} object with soil parameters, depending on the class of \code{x}. 
#' 
#' @seealso  \code{\link{soil}}, \code{\link{defaultSoilParams}}
#' @export
#' 
#' @examples
#' # Define initial soil with 5 layers
#' spar <- defaultSoilParams(5)
#' spar
#' 
#' # Redefine to four layers
#' soil_redefineLayers(spar)
#' 
#' # Same but after soil parameter initialization
#' examplesoil <- soil(spar)
#' examplesoil
#' 
#' soil_redefineLayers(examplesoil)
#'
soil_redefineLayers<-function(x, widths = c(300, 700, 1000, 2000)) {
  
  is_soil <- inherits(x, "soil")
  
  restarget  <-  data.frame(matrix(NA, nrow = length(widths), ncol = 8))
  names(restarget)  <-  c("widths", "clay", "sand", "om", "nitrogen", "ph", "bd", "rfc")
  restarget$widths  <-  widths
  
  bottomdepths <- cumsum(widths)
  topdepths <- bottomdepths - widths
  sgbdepths <- cumsum(x$widths)
  sgtdepths <- sgbdepths - x$widths
  for(j in 1:length(widths)) {
    ini <- topdepths[j]
    fin <- bottomdepths[j]
    p1 <- pmin(pmax(fin -sgtdepths,0),x$widths)
    p2 <- pmin(pmax(sgbdepths -ini,0),x$widths)
    p <- pmin(p1,p2)/x$widths
    if(sum(p)==0) p[length(p)]  <-  1
    restarget$clay[j]  <-  sum(x$clay*p)/sum(p)
    restarget$sand[j]  <-  sum(x$sand*p)/sum(p)
    restarget$rfc[j]  <-  sum(x$rfc*p)/sum(p)
    restarget$bd[j]  <-  sum(x$bd*p)/sum(p)
    if("om" %in% names(x)) restarget$om[j]  <-  sum(x$om*p)/sum(p)
    if("nitrogen" %in% names(x)) restarget$nitrogen[j]  <-  sum(x$nitrogen*p)/sum(p)
    if("ph" %in% names(x)) restarget$ph[j]  <-  sum(x$ph*p)/sum(p)
  }
  if(!is_soil) return(restarget)
  return(soil(restarget))
}

library(medfate)



test_that("default soils can be created",{
  expect_s3_class(defaultSoilParams(), "data.frame")
  df <- defaultSoilParams()
  expect_s3_class(soil(df), "soil")
  df_minimal <- df
  df_minimal$om <- NULL
  df_minimal$ph <- NULL
  df_minimal$nitrogen <- NULL
  expect_s3_class(soil(df_minimal), "soil")
  expect_type(medfate:::.testSoilDataFrameToStructure(soil(df)), "double")
})

test_that("soils can be redefined",{
  out_widths <- c(1000,2000)
  df <- defaultSoilParams()
  df_minimal <- df
  df_minimal$om <- NULL
  df_minimal$ph <- NULL
  df_minimal$nitrogen <- NULL
  expect_s3_class(soil_redefineLayers(df, widths = out_widths), "data.frame")
  expect_s3_class(soil_redefineLayers(soil(df), widths = out_widths), "soil")
  expect_s3_class(soil_redefineLayers(df_minimal, widths = out_widths), "data.frame")
  expect_s3_class(soil_redefineLayers(soil(df_minimal), widths = out_widths), "soil")
})

test_that("soils can be summarized",{
  out_widths <- c(1000,2000)
  df <- defaultSoilParams()
  df_minimal <- df
  df_minimal$om <- NULL
  df_minimal$ph <- NULL
  df_minimal$nitrogen <- NULL
  s_minimal <- soil(df_minimal)
  # s_minimal$om <- NULL
  s_minimal$ph <- NULL
  s_minimal$nitrogen <- NULL
  expect_type(capture.output(summary(soil(df), widths = out_widths)), "character")
  expect_type(capture.output(summary(soil(df_minimal), widths = out_widths)), "character")
  expect_type(capture.output(summary(s_minimal, widths = out_widths)), "character")
})

.firehaz_sim<-function(forest, x, SpParams, standardConditions = FALSE, freq = "days", fun = "max") {
  slope = x$topography[["slope"]]
  weather = x$weather
  fmc = x$Plants$LFMC
  if(is.na(slope)) slope = 0.0

  if("dates" %in% names(weather)) {
    dates <- weather$dates
  } else {
    dates <- as.Date(row.names(weather))
  }
  ndays = length(dates)
  
  #Calculate FCCS without FMC
  fccs = fuel_FCCS(forest, SpParams)
  cohLoading = plant_fuelLoading(forest, SpParams)
  cohHeight = plant_height(forest, SpParams)
  cohHeight[is.na(cohHeight)] = 0
  cohCR = plant_crownRatio(forest,SpParams)
  cohCR[is.na(cohCR)] = 0
  
  fb_vec = vector("list", ndays)
  for(i in 1:ndays){
    windSpeed = weather$WindSpeed[i]
    
    # Estimate moisture of dead fine fuels (Resco de Dios et al. 2015)
    vp = meteoland::utils_averageDailyVP(Tmin = weather$MinTemperature[i], Tmax = weather$MaxTemperature[i],
                                         RHmin = weather$MinRelativeHumidity[i], RHmax = weather$MaxRelativeHumidity[i])
    D = max(0, meteoland::utils_saturationVP(weather$MaxTemperature[i]) - vp)
    fm_dead = 5.43 + 52.91*exp(-0.64*D) 

    #Calculate cohort canopy moisture to the average of canopy live and dead fuels, considering that a fraction of LAI is dead
    #proportionally to stem PLC (Ruffault et al. 2023)
    LFMC = x$Plants$LFMC[i,]
    PLC = x$Plants$StemPLC[i,]
    canopyFMC = (LFMC*(1.0 - PLC) + fm_dead*PLC)
    
    #Average canopy moisture in the crown and surface layers
    if(fccs$w[1]>0.0) fccs$ActFMC[1] = .layerFuelAverageParameter(200.0, 10000.0, canopyFMC, cohLoading, cohHeight, cohCR)
    else fccs$ActFMC[1] = NA
    if(fccs$w[2]>0.0) fccs$ActFMC[2] = .layerFuelAverageParameter(0.0, 200.0, canopyFMC, cohLoading, cohHeight, cohCR)
    else fccs$ActFMC[1] = NA

    MdeadSI = rep(fm_dead, 5)
    if(standardConditions) {
      windSpeed = 11.0
      fccs$ActFMC = NA
      MdeadSI = c(6,6,6,6,6)
    }
    fb_vec[[i]] = unlist(fire_FCCS(fccs, slope = slope, windSpeedSI = windSpeed,
                                   MdeadSI = MdeadSI))
  }
  fbm = matrix(NA, nrow = ndays, ncol = length(fb_vec[[1]]))
  rownames(fbm) <- row.names(weather)
  colnames(fbm) <- names(fb_vec[[1]])
  for(i in 1:ndays){
    fbm[i,] <- fb_vec[[i]]
  }
  if(freq!="days") {
    date.factor = cut(dates, breaks=freq)
    fbm = apply(fbm,2,function(x){tapply(x,INDEX=date.factor, FUN = fun, na.rm=TRUE)})
  } 
  return(fbm)
}

#' Fire hazard
#' 
#' Estimates potential fire behaviour at each daily step of a simulation
#' 
#' @param x An object of class \code{\link{spwb}}, \code{\link{spwb_day}}, \code{\link{pwb}}, \code{\link{growth}}, \code{\link{growth_day}} or \code{\link{fordyn}}.
#' @param SpParams A data frame with species parameters (see \code{\link{SpParamsDefinition}} and \code{\link{SpParamsMED}}).
#' @param forest An object of class \code{\link{forest}} (needed if \code{x} is not of class \code{\link{fordyn}}).
#' @param standardConditions A logical flag to indicate that standard fire weather conditions are to be used (instead of deriving fuel moisture and windspeed from \code{x}).
#' @param freq Frequency of summary statistics (see \code{\link{cut.Date}}).
#' @param fun Summary function (by default, maximum values).
#' 
#' @details Live fuel moisture of shrub and canopy layers is estimated from plant water status. 
#' Dead fuel moisture is estimated following Resco-de-Dios et al. (2015).
#' 
#' @return A matrix with fire behaviour variables (columns) for each simulated day (rows) or coarser time steps if summaries are requested.
#' 
#' @references 
#' 
#' Resco de Dios, V., A. W. Fellows, R. H. Nolan, M. M. Boer, R. A. Bradstock, F. Domingo, and M. L. Goulden. 2015. A semi-mechanistic model for predicting the moisture content of fine litter. Agricultural and Forest Meteorology 203:64–73.
#' 
#' Ruffault J, Limousin JM, Pimont F, Dupuy JL, De Cáceres M, Cochard H, Mouillot F, Blackman C, Torres-Ruiz JM, Parsons R, 
#' Moreno M, Delzon S, Jansen S, Olioso A, Choat B, Martin-StPaul N. 2023. Plant hydraulic modelling of leaf and canopy fuel moisture content reveals increasing vulnerability of a Mediterranean forest to wildfires under extreme drought. 
#' New Phytologist. (10.1111/nph.18614).
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso \code{\link{spwb}}, \code{\link{fuel_FCCS}}, \code{\link{fire_FCCS}}
#' 
#' @examples 
#' \donttest{
#' #Load example daily meteorological data
#' data(examplemeteo)
#' 
#' #Load example plot plant data
#' data(exampleforest)
#' 
#' #Default species parameterization
#' data(SpParamsMED)
#' 
#' #Define soil with default soil params (4 layers)
#' examplesoil <- defaultSoilParams(4)
#' 
#' #Initialize control parameters
#' control <- defaultControl("Granier")
#' 
#' #Initialize input
#' x1 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)
#' 
#' #Call simulation function
#' S1 <- spwb(x1, examplemeteo, latitude = 41.82592, elevation = 100)
#' 
#' #Evaluate fire hazard
#' F1 <- fireHazard(S1, SpParamsMED, exampleforest)
#' }
fireHazard<-function(x, SpParams, forest = NULL, standardConditions = FALSE,
                     freq="days", fun = "max") {
  if(!inherits(x, c("spwb","pwb","growth", "fordyn", "spwb_day", "growth_day"))) {
    stop("'x' should be of class 'spwb', 'spwb_day', 'pwb', 'growth', 'growth_day' or 'fordyn'")
  }
  if(inherits(x, c("spwb","pwb", "growth"))) {
    if(is.null(forest)) stop("You must supply a 'forest' object when 'x' is of class 'spwb', 'spwb_day', 'pwb', 'growth' or 'growth_day'")
    res = .firehaz_sim(forest, x, SpParams, standardConditions,
                       freq = freq, fun = fun)
  } else if(inherits(x, c("spwb_day", "growth_day"))) {
    if(is.null(forest)) stop("You must supply a 'forest' object when 'x' is of class 'spwb', 'spwb_day', 'pwb', 'growth' or 'growth_day'")
    slope = x$topography[["slope"]]
    weather = x$weather
    
    # Estimate moisture of dead fine fuels (Resco de Dios et al. 2015)
    vp = meteoland::utils_averageDailyVP(Tmin = weather[["tmin"]], Tmax = weather[["tmax"]],
                                         RHmin = weather[["rhmin"]], RHmax = weather[["rhmax"]])
    D = max(0, meteoland::utils_saturationVP(weather[["tmax"]]) - vp)
    fm_dead = 5.43 + 52.91*exp(-0.64*D) 
    
    
    #Calculate cohort canopy moisture to the average of canopy live and dead fuels, considering that a fraction of LAI is dead
    #proportionally to stem PLC (Ruffault et al. 2023)
    canopyFMC= (x$Plants$LFMC*(1 - x$Plants$StemPLC) + fm_dead*x$Plants$StemPLC)
    
    if(is.na(slope)) slope = 0.0
    windSpeed = weather[["wind"]]
    fccs = fuel_FCCS(forest, SpParams, cohortFMC = canopyFMC)
    MdeadSI = rep(fm_dead, 5)
    if(standardConditions) {
      windSpeed = 11.0
      fccs$ActFMC = NA
      MdeadSI = c(6,6,6,6,6)
    }
    res = unlist(fire_FCCS(fccs, slope = slope, windSpeedSI = windSpeed, MdeadSI = MdeadSI))
  } else {
    vec<-vector("list", length(x$GrowthResults))
    for(i in 1:length(x$GrowthResults)) {
      vec[[i]] <- .firehaz_sim(x$ForestStructures[[i]], x$GrowthResults[[i]], SpParams, standardConditions,
                               freq = freq, fun = fun)
    }
    res = .mergeVectorOfMatrices(vec)
  }
  return(res)
}

.wue_sim<-function(x, type = "Plant Ag/E", leaves = "average", freq="days") {
  if(inherits(x, c("spwb","pwb"))) {
    input = x$spwbInput  
  } else {
    input = x$growthInput
  }
  if(input$control$transpirationMode == "Granier") {
    type = match.arg(type, c("Plant Ag/E", "Stand Ag/E"))
  } else {
    type = match.arg(type, c("Leaf Ci", "Leaf iWUE", "Plant An/E", "Stand An/E", "Plant Ag/E", "Stand Ag/E"))
  }
  
  
  if(type=="Leaf iWUE") {
    if(!input$control$subdailyResults) {
      stop("iWUE can only be calculated with subdailyResults = TRUE")
    }
    Andays = x$Plants$NetPhotosynthesis
    Agdays = x$Plants$GrossPhotosynthesis
    leaves = match.arg(leaves, c("average", "sunlit", "shade"))
    sd = x$subdaily
    ndays = length(sd)
    coh = input$cohorts
    ncoh = nrow(coh)
    dates = as.Date(names(sd))
    iWUEdays = matrix(NA, nrow=ndays, ncol=ncoh)
    rownames(iWUEdays)= as.character(dates)
    colnames(iWUEdays) = rownames(coh)
    for(i in 1:ndays) {
      sl = sd[[i]]$SunlitLeavesInst
      sh = sd[[i]]$ShadeLeavesInst
      sl_lai = sd[[i]]$SunlitLeavesInst$LAI
      sh_lai = sd[[i]]$ShadeLeavesInst$LAI
      an_sl = sl$An
      an_sl[an_sl<0] = 0
      an_sh = sh$An
      an_sh[an_sh<0] = 0
      if(leaves =="sunlit") {
        iwueinst = an_sl/sl$Gsw
        iwueinst[iwueinst<0] = 0
        iWUEdays[i,] = rowSums(iwueinst*an_sl, na.rm=T)/rowSums(an_sl, na.rm=T) #Photosynthesis-weighted iWUE
      }
      else if(leaves =="shade") {
        iwueinst = an_sh/sh$Gsw
        iwueinst[iwueinst<0] = 0
        iWUEdays[i,] = rowSums(iwueinst*an_sh, na.rm=T)/rowSums(an_sh, na.rm=T) #Photosynthesis-weighted iWUE
      }
      else {
        iwueinst_sl = an_sl/sl$Gsw
        iwueinst_sh = an_sh/sh$Gsw
        iwueinst = ((iwueinst_sl*sl_lai) + (iwueinst_sh*sh_lai))/(sl_lai+sh_lai)
        iwueinst[iwueinst<0] = 0
        an_tot = an_sl + an_sh
        iWUEdays[i,] = rowSums(iwueinst*an_tot, na.rm=T)/rowSums(an_tot, na.rm=T) #Photosynthesis-weighted iWUE
      }
    }
    if(freq=="days") {
      res = iWUEdays
    } else {
      
      date.factor = cut(dates, breaks=freq)
      
      Andays[Andays<0] = 0
      #Perform summary at the desired temporal scale (weighted average of iWUE with An as weights)
      sumiWUEAn <- apply(iWUEdays*Andays,2,tapply, INDEX=date.factor, sum, na.rm=T)
      sumAn <- apply(Andays,2,tapply, INDEX=date.factor, sum, na.rm=T)
      M = sumiWUEAn/sumAn
      if(is.vector(M)) {
        M = t(as.matrix(M))
        rownames(M) <- levels(date.factor)
      }
      ncases = table(date.factor)
      M = M[ncases>0, ,drop = FALSE]
      res = M
    }
  }
  else if(type=="Leaf Ci") {
    Andays = x$Plants$NetPhotosynthesis
    Agdays = x$Plants$GrossPhotosynthesis
    if(!input$control$subdailyResults) {
      stop("Ci can only be calculated with subdailyResults = TRUE")
    }
    leaves = match.arg(leaves, c("average", "sunlit", "shade"))
    sd = x$subdaily
    ndays = length(sd)
    coh = input$cohorts
    ncoh = nrow(coh)
    dates = as.Date(names(sd))
    Cidays = matrix(NA, nrow=ndays, ncol=ncoh)
    rownames(Cidays)= as.character(dates)
    colnames(Cidays) = rownames(coh)
    for(i in 1:ndays) {
      sl = sd[[i]]$SunlitLeavesInst
      sh = sd[[i]]$ShadeLeavesInst
      sl_lai = sd[[i]]$SunlitLeavesInst$LAI
      sh_lai = sd[[i]]$ShadeLeavesInst$LAI
      an_sl = sl$An
      an_sl[an_sl<0] = 0
      an_sh = sh$An
      an_sh[an_sh<0] = 0
      if(leaves =="sunlit") {
        ciinst = sl$Ci
        Cidays[i,] = rowSums(ciinst*an_sl, na.rm=T)/rowSums(an_sl, na.rm=T) #Photosynthesis-weighted iWUE
      }
      else if(leaves =="shade") {
        ciinst = sh$Ci
        Cidays[i,] = rowSums(ciinst*an_sh, na.rm=T)/rowSums(an_sh, na.rm=T) #Photosynthesis-weighted iWUE
      }
      else {
        ciinst_sl = sl$Ci
        ciinst_sh = sh$Ci
        ciinst = ((ciinst_sl*sl_lai) + (ciinst_sh*sh_lai))/(sl_lai+sh_lai)
        an_tot = an_sh+an_sl
        Cidays[i,] = rowSums(ciinst*an_tot, na.rm=T)/rowSums(an_tot, na.rm=T) #Photosynthesis-weighted iWUE
      }
    }
    if(freq=="days") {
      res = Cidays
    } else {
      
      date.factor = cut(dates, breaks=freq)
      
      Andays[Andays<0] = 0
      #Perform summary at the desired temporal scale (weighted average of iWUE with An as weights)
      sumCiAn <- apply(Cidays*Andays,2,tapply, INDEX=date.factor, sum, na.rm=T)
      sumAn <- apply(Andays,2,tapply, INDEX=date.factor, sum, na.rm=T)
      M = sumCiAn/sumAn
      if(is.vector(M)) {
        M = t(as.matrix(M))
        rownames(M) <- levels(date.factor)
      }
      ncases = table(date.factor)
      M = M[ncases>0, ,drop = FALSE]
      res = M
    }
  }
  else if(type =="Plant An/E") {
    x$Plants$NetPhotosynthesis[x$Plants$NetPhotosynthesis<0] = 0
    x$Plants$Transpiration[x$Plants$Transpiration<0] = 0
    if(freq=="days") {
      res = x$Plants$NetPhotosynthesis/x$Plants$Transpiration
    } else {
      pt = summary(x, freq=freq, output="Transpiration", FUN=sum, na.rm=T)
      pp = summary(x, freq=freq, output="NetPhotosynthesis", FUN=sum, na.rm=T)
      res = pp/pt
    }
  }
  else if(type =="Plant Ag/E") {
    x$Plants$GrossPhotosynthesis[x$Plants$GrossPhotosynthesis<0] = 0
    x$Plants$Transpiration[x$Plants$Transpiration<0] = 0
    if(freq=="days") {
      res = x$Plants$GrossPhotosynthesis/x$Plants$Transpiration
    } else {
      pt = summary(x, freq=freq, output="Transpiration", FUN=sum, na.rm=T)
      pp = summary(x, freq=freq, output="GrossPhotosynthesis", FUN=sum, na.rm=T)
      res = pp/pt
    }
  }
  else if(type =="Stand An/E") {
    x$Plants$NetPhotosynthesis[x$Plants$NetPhotosynthesis<0] = 0
    x$Plants$Transpiration[x$Plants$Transpiration<0] = 0
    if(freq=="days") {
      res = rowSums(x$Plants$NetPhotosynthesis, na.rm=T)/rowSums(x$Plants$Transpiration, na.rm=T)
    } else {
      pt = summary(x, freq=freq, output="Transpiration", FUN=sum, na.rm=T)
      pp = summary(x, freq=freq, output="NetPhotosynthesis", FUN=sum, na.rm=T)
      res = rowSums(pp, na.rm=T)/rowSums(pt, na.rm=T)
    }
    res = as.matrix(res)
    colnames(res)<-"Stand An/E"
  }
  else if(type =="Stand Ag/E") {
    x$Plants$GrossPhotosynthesis[x$Plants$GrossPhotosynthesis<0] = 0
    x$Plants$Transpiration[x$Plants$Transpiration<0] = 0
    if(freq=="days") {
      res = rowSums(x$Plants$GrossPhotosynthesis, na.rm=T)/rowSums(x$Plants$Transpiration, na.rm=T)
    } else {
      pt = summary(x, freq=freq, output="Transpiration", FUN=sum, na.rm=T)
      pp = summary(x, freq=freq, output="GrossPhotosynthesis", FUN=sum, na.rm=T)
      res = rowSums(pp, na.rm=T)/rowSums(pt, na.rm=T)
    }
    res = as.matrix(res)
    colnames(res)<-"Stand Ag/E"
  }
  return(res)
}


#' Water use efficiency
#'
#' Calculates plant water use efficiency (WUE), at different temporal scales, from simulation results.
#' 
#' @param x An object of class \code{\link{spwb}}, \code{\link{pwb}}, \code{\link{growth}} or \code{\link{fordyn}}.
#' @param type A string to indicate the scale of WUE calculation. Either:
#'     \itemize{
#'       \item{\code{"Leaf iWUE"}: Leaf intrinsic WUE, i.e. instantaneous ratio between photosynthesis and stomatal conductance (only for simulations with \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"} and \code{subdailyResults = TRUE}). }
#'       \item{\code{"Leaf Ci"}: Leaf intercellular CO2 concentration (only for simulations with \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"} and \code{subdailyResults = TRUE}).}
#'       \item{\code{"Plant An/E"}: Plant (cohort) net photosynthesis over plant transpiration (only for simulations with \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"})}
#'       \item{\code{"Stand An/E"}: Stand net photosynthesis over stand transpiration (only for simulations with \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"})}
#'       \item{\code{"Plant Ag/E"}: Plant (cohort) gross photosynthesis over plant transpiration}
#'       \item{\code{"Stand Ag/E"}: Stand gross photosynthesis over stand transpiration}
#'     }
#' @param leaves Either \code{"sunlit"}, \code{"shade"} or \code{"average"}. Refers to the WUE of different leaf types or the average (with weights according to the LAI of sunlit and shade leaves). Only relevant for \code{type = "iWUE"}. 
#' @param freq Frequency of summary statistics (see \code{\link{cut.Date}}).
#' @param draw A boolean flag to indicate that a plot should be returned.
#' @param ylim Range of values for y.
#' 
#' @details Temporal aggregation of WUE values is done differently depending on the value of \code{type}. 
#' For \code{type = "Plant Ag/E"}, \code{type = "Stand Ag/E"}, \code{type = "Plant An/E"} and \code{type = "Stand An/E"} sums 
#' or daily photosynthesis and transpiration are first calculated at the desired temporal scale and the ratio is calculated afterwards. 
#' For \code{type = "Leaf iWUE"} intrinsic WUE values are first calculated at the daily scale (as averages of instantaneous An/gs ratios weighted by An) 
#' and then they are aggregated to the desired scale by calculating weighted averages, where weights are given by daily photosynthesis.
#' 
#' @return If \code{draw=TRUE} a plot is returned. Otherwise, the function returns a matrix with WUE values, 
#' where rows are dates (at the desired temporal scale), and columns are plant cohorts. 
#' In the case of \code{type = "Plant Ag/E"}, \code{type = "Stand Ag/E"}, \code{type = "Plant An/E"} and \code{type = "Stand An/E"} values are in gC/L. 
#' In the case of \code{type = "Leaf iWUE"} values are in micromol of carbon per mmol of water.
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso \code{\link{droughtStress}}
waterUseEfficiency<-function(x, type = "Plant Ag/E", leaves = "average", freq="days", draw = TRUE,
                                  ylim=NULL) {
  if(!inherits(x, c("spwb","pwb","growth", "fordyn"))) {
    stop("'x' should be of class 'spwb', 'pwb', 'growth' or 'fordyn'")
  }
  if(inherits(x, c("spwb","pwb", "growth"))) {
    res = .wue_sim(x = x, type = type, leaves = leaves, freq = freq)
  } else {
    vec<-vector("list", length(x$GrowthResults))
    for(i in 1:length(x$GrowthResults)) {
      vec[[i]] <- .wue_sim(x = x$GrowthResults[[i]], type = type, leaves = leaves, freq = freq)
    }
    res = .mergeVectorOfMatrices(vec)
  }
  if(!draw) {
    return(res)
  } else {
    if(type=="Stand An/E") {
      v = as.vector(res)
      names(v) = rownames(res)
      g<-.single_dynamics(v, ylab = "Stand An/E (gC/L)", ylim = ylim)
    } 
    else if(type=="Stand Ag/E") {
      v = as.vector(res)
      names(v) = rownames(res)
      g<-.single_dynamics(v, ylab = "Stand Ag/E (gC/L)", ylim = ylim)
    }
    else if(type=="Plant An/E") {
      g<-.multiple_dynamics(res, ylab = "Plant An/E (gC/L)", ylim = ylim)
    }
    else if(type=="Plant Ag/E") {
      g<-.multiple_dynamics(res, ylab = "Plant Ag/E (gC/L)", ylim = ylim)
    }
    else if(type %in% c("Leaf iWUE", "Leaf Ci")) {
      if(type=="Leaf iWUE" && leaves == "sunlit") ylab = expression(paste("Sunlit leaf iWUE  (",mu%.%mol%.%mol^{-1},")"))
      if(type=="Leaf iWUE" && leaves == "shade") ylab = expression(paste("Shade leaf iWUE  (",mu%.%mol%.%mol^{-1},")"))
      if(type=="Leaf iWUE" && leaves == "average") ylab = expression(paste("Average leaf iWUE  (",mu%.%mol%.%mol^{-1},")"))
      if(type=="Leaf Ci" && leaves == "sunlit") ylab = expression(paste("Sunlit leaf Ci  ",(ppm)))
      if(type=="Leaf Ci" && leaves == "shade") ylab = expression(paste("Shade leaf Ci  ",(ppm)))
      if(type=="Leaf Ci" && leaves == "average") ylab = expression(paste("Average leaf Ci  ",(ppm)))
      g<-.multiple_dynamics(res, ylab = ylab, ylim = ylim)
    }
    return(g)
  }
}

#' @rdname moisture
#' 
#' @param x An object of class \code{\link{spwbInput}} or \code{\link{growthInput}}.
#' @param segment Segment whose relative water content curve to plot, either \code{"stem"} or \code{"leaf"}
#'                (the latter only available if \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}).
#' @param fraction  Tissue fraction, either \code{"symplastic"}, \code{"apoplastic"} or \code{"all"}.
#' @param psiVec Vector of water potential values to evaluate for the pressure-volume curve.
#' @param speciesNames A flag to indicate the use of species names instead of cohort names in plots.
#' 
#' @keywords internal
moisture_pressureVolumeCurvePlot<-function(x, segment="stem", 
                                           fraction = "all",
                                           psiVec =  seq(-0.1, -8.0, by =-0.01),
                                           speciesNames = FALSE) {
  
  if(!inherits(x, "spwbInput") && !inherits(x, "growthInput")) {
    stop("'x' should be of class 'spwbInput' or 'growthInput'")
  }
  transpirationMode <- x$control$transpirationMode
  if(transpirationMode=="Granier") {
    TYPES = c("stem")
  } else {
    TYPES = c("leaf","stem")
  }
  segment <- match.arg(segment,TYPES)  
  fraction <- match.arg(fraction, c("symplastic", "apoplastic", "all"))  
  
  cohortnames <- row.names(x$cohorts)
  if(speciesNames) cohortnames <- as.character(x$cohorts$Name)
  col <- rainbow(2, start = 0.8, end = 0.1)
  
  ncoh = nrow(x$above)

  minPsi = min(psiVec)
  if(segment=="leaf") {
    PVleaf_pi0 <- x$paramsWaterStorage$LeafPI0
    PVleaf_eps <- x$paramsWaterStorage$LeafEPS
    PVleaf_fapo <- x$paramsWaterStorage$LeafAF
    PVleaf_c <- x$paramsTransp$VCleaf_c
    PVleaf_d <- x$paramsTransp$VCleaf_d
    for(i in 1:ncoh) {
      rwcsymleaf = unlist(lapply(psiVec, moisture_symplasticRWC, PVleaf_pi0[i], PVleaf_eps[i]))*100
      rwcapoleaf = unlist(lapply(psiVec, moisture_apoplasticRWC, PVleaf_c[i], PVleaf_d[i]))*100
      if(fraction=="all") {
        rwcleaf = rwcapoleaf*PVleaf_fapo[i] + rwcsymleaf*(1-PVleaf_fapo[i])
      } else if(fraction=="symplastic") {
        rwcleaf = rwcsymleaf
      } else if(fraction=="apoplastic") {
        rwcleaf = rwcapoleaf
      }
      if(i==1) rwc = matrix(rwcleaf, ncol = 1)
      else rwc = cbind(rwc, rwcleaf)
    }
    colnames(rwc) = cohortnames
    .multiple_y(x = -psiVec, y = rwc, xlab = "Leaf pressure (-MPa)", ylab = "Leaf relative water content [%]", ylim =c(0, 100))
  } 
  else if(segment=="stem") {
    PVstem_pi0 <- x$paramsWaterStorage$StemPI0
    PVstem_eps <- x$paramsWaterStorage$StemEPS
    PVstem_fapo <- x$paramsWaterStorage$StemAF
    PVstem_c <- x$paramsTransp$VCstem_c
    PVstem_d <- x$paramsTransp$VCstem_d
    for(i in 1:ncoh) {
      rwcsymstem = unlist(lapply(psiVec, moisture_symplasticRWC, PVstem_pi0[i], PVstem_eps[i]))*100
      rwcapostem = unlist(lapply(psiVec, moisture_apoplasticRWC, PVstem_c[i], PVstem_d[i]))*100
      if(fraction=="all") {
        rwcstem = rwcapostem*PVstem_fapo[i] + rwcsymstem*(1-PVstem_fapo[i])
      } else if(fraction=="symplastic") {
        rwcstem = rwcsymstem
      } else if(fraction=="apoplastic") {
        rwcstem = rwcapostem
      }
      if(i==1) rwc = matrix(rwcstem, ncol = 1)
      else rwc = cbind(rwc, rwcstem)
    }
    colnames(rwc) = cohortnames
    .multiple_y(x = -psiVec, y = rwc, xlab = "Stem pressure (-MPa)", ylab = "Stem relative water content [%]", ylim =c(0, 100))
  } 
}

#' @rdname hydraulics_conductancefunctions
#' 
#' @param x An object of class \code{\link{spwbInput}}.
#' @param soil A list containing the description of the soil (see \code{\link{soil}}).
#' @param type Plot type for \code{hydraulics_vulnerabilityCurvePlot}, either \code{"leaf"}, 
#'             \code{"stem"}, \code{"root"} or \code{"rhizosphere"}).
#' @param vulnerabilityFunction String indicating the function used to represent vulnerability in plant segments, either "Weibull" or "Sigmoid".
#' @param psiVec Vector of water potential values to evaluate for the vulnerability curve.
#' @param relative A flag to relativize vulnerability curves to the \[0-1\] interval.
#' @param speciesNames A flag to indicate the use of species names instead of cohort names in plots.
#' @param draw A flag to indicate whether the vulnerability curve should be drawn or just returned.
#' @param ylim,xlab,ylab Graphical parameters to override function defaults.
#' 
#' @keywords internal
hydraulics_vulnerabilityCurvePlot<-function(x, soil = NULL, type="leaf",  vulnerabilityFunction = "Weibull",
                                            psiVec =  seq(-0.1, -8.0, by =-0.01), 
                                            relative = FALSE, speciesNames = FALSE, 
                                            draw = TRUE,  ylim = NULL, xlab = NULL, ylab = NULL) {
  
  TYPES <- c("leaf","stem","root","rootlayer","rhizosphere")
  type <- match.arg(type,TYPES)  
  
  TYPES_FUN <- c("Weibull", "Sigmoid")
  vulnerabilityFunction <- match.arg(vulnerabilityFunction,TYPES_FUN)  
  
  if(!(x$control$transpirationMode %in% c("Sperry", "Sureau"))) stop("x has to be initialized using 'Sperry' or 'Sureau' transpiration modes")

  
  cohortnames <- row.names(x$cohorts)
  spnames <- x$cohorts$Name
  VCroot_kmax_layer <- x$belowLayers$VCroot_kmax
  VGrhizo_kmax <- x$belowLayers$VGrhizo_kmax
  nlayer <- ncol(VCroot_kmax_layer)
  col <- rainbow(nlayer, start = 0.8, end = 0.1)
  
  ncoh <- nrow(x$above)

  if(relative) {
    VCroot_kmax_layer[] <- 100
    VGrhizo_kmax[] <- 100
  }
  res <- NULL
  minPsi <- min(psiVec)
  if(type=="leaf") {
    if(is.null(ylab)) {
      if(!relative) ylab <- expression(paste("Leaf conductance  ", (mmol%.%s^{-1}%.%m^{-2}%.%MPa^{-1})))
      else ylab <- "Leaf conductance (% of maximum)"
    }
    if(is.null(xlab)) xlab <- "Leaf pressure (-MPa)"
    res <- matrix(0, ncol=ncoh, nrow = length(psiVec))
    rownames(res) <- psiVec
    colnames(res) <- cohortnames
    if(speciesNames) colnames(res) <- spnames
    if(!relative) VCleaf_kmax <- x$paramsTransp$VCleaf_kmax
    else VCleaf_kmax <- rep(100, ncoh)
    if(vulnerabilityFunction=="Weibull"){
      VCleaf_c <- x$paramsTransp$VCleaf_c
      VCleaf_d <- x$paramsTransp$VCleaf_d
      for(i in 1:ncoh) {
        res[,i] <- unlist(lapply(psiVec, hydraulics_xylemConductance, VCleaf_kmax[i], VCleaf_c[i], VCleaf_d[i]))
      }
    } else {
      VCleaf_P50 <- x$paramsTransp$VCleaf_P50
      VCleaf_slope <- x$paramsTransp$VCleaf_slope
      for(i in 1:ncoh) res[,i] <-VCleaf_kmax[i]*(1.0 - (1.0/(1.0 + exp(VCleaf_slope[i] / 25.0 * (psiVec - VCleaf_P50[i])))))
    }
    if(draw) {
      return(.multiple_y(-psiVec, res, xlab=xlab, ylab=ylab, ylim=ylim))
    }
  } 
  else if(type=="stem") {
    res <- matrix(0, ncol=ncoh, nrow = length(psiVec))
    rownames(res) <- psiVec
    colnames(res) <- cohortnames
    if(speciesNames) colnames(res) <- spnames
    if(is.null(ylab)) {
      if(!relative) ylab <- expression(paste("Stem conductance  ", (mmol%.%s^{-1}%.%m^{-2}%.%MPa^{-1})))
      else  ylab <- "Stem conductance (% of maximum)"
    }
    if(is.null(xlab)) xlab <- "Stem pressure (-MPa)"
    if(!relative) VCstem_kmax <- x$paramsTransp$VCstem_kmax
    else VCstem_kmax <- rep(100, ncoh)
    if(vulnerabilityFunction=="Weibull") {
      VCstem_c <- x$paramsTransp$VCstem_c
      VCstem_d <- x$paramsTransp$VCstem_d
      for(i in 1:ncoh) {
        res[,i] <- unlist(lapply(psiVec, hydraulics_xylemConductance, VCstem_kmax[i], VCstem_c[i], VCstem_d[i]))
      }
    } else {
      VCstem_P50 <- x$paramsTransp$VCstem_P50
      VCstem_slope <- x$paramsTransp$VCstem_slope
      for(i in 1:ncoh) res[,i] <-VCstem_kmax[i]*(1.0 - (1.0/(1.0 + exp(VCstem_slope[i] / 25.0 * (psiVec - VCstem_P50[i])))))
    }
    if(draw) {
      return(.multiple_y(-psiVec, res, xlab=xlab, ylab=ylab, ylim=ylim))
    }
  } 
  else if(type=="root") {
    res <- matrix(0, ncol=ncoh, nrow = length(psiVec))
    rownames(res) <- psiVec
    colnames(res) <- cohortnames
    if(speciesNames) colnames(res) <- spnames
    if(is.null(ylab)) {
      if(!relative) ylab <- expression(paste("Root conductance  ", (mmol%.%s^{-1}%.%m^{-2}%.%MPa^{-1})))
      else ylab <- "Root conductance (% of maximum)"
    }
    if(is.null(xlab)) xlab <- "Root pressure (-MPa)"
    if(!relative) VCroot_kmax <- x$paramsTransp$VCroot_kmax
    else VCroot_kmax <- rep(100, ncoh)
    if(vulnerabilityFunction == "Weibull"){
      VCroot_c <- x$paramsTransp$VCroot_c
      VCroot_d <- x$paramsTransp$VCroot_d
      for(i in 1:ncoh) {
        res[,i] <- unlist(lapply(psiVec, hydraulics_xylemConductance, VCroot_kmax[i], VCroot_c[i], VCroot_d[i]))
      }
    } else {
      VCroot_P50 <- x$paramsTransp$VCroot_P50
      VCroot_slope <- x$paramsTransp$VCroot_slope
      for(i in 1:ncoh) res[,i] <-VCroot_kmax[i]*(1.0 - (1.0/(1.0 + exp(VCroot_slope[i] / 25.0 * (psiVec - VCroot_P50[i])))))
    }
    if(draw) {
      return(.multiple_y(-psiVec, res, xlab=xlab, ylab=ylab, ylim=ylim))
    }
  } 
  else if(type=="rootlayer") {
    if(is.null(ylab)) {
      if(!relative) ylab <- expression(paste("Root layer conductance  ", (mmol%.%s^{-1}%.%m^{-2}%.%MPa^{-1})))
      else ylab <- "Root layer conductance (% of maximum)"
    }
    if(is.null(xlab)) xlab <- "Root layer pressure (-MPa)"
    if(is.null(ylim)) ylim <- c(0, max(VCroot_kmax_layer))
    
    if(vulnerabilityFunction=="Weibull") {
      VCroot_c <- x$paramsTransp$VCroot_c
      VCroot_d <- x$paramsTransp$VCroot_d
      for(i in 1:ncoh) {
        kroot <- matrix(NA, ncol=length(psiVec), nrow = nlayer)
        for(j in 1:nlayer) {
          kroot[j,] <- unlist(lapply(psiVec, hydraulics_xylemConductance, VCroot_kmax_layer[i,j], VCroot_c[i], VCroot_d[i]))
        }
        if(draw) {
          if(i==1) {
            matplot(-psiVec, t(kroot), type="l", xlim=c(0,-minPsi), ylim =ylim,
                    xlab = xlab, ylab = ylab, col=col)
          } else {
            matlines(-psiVec, t(kroot), lty=i, col=col)
          }
        }
      }
    } else {
      VCroot_P50 <- x$paramsTransp$VCroot_P50
      VCroot_slope <- x$paramsTransp$VCroot_slope
      for(i in 1:ncoh) {
        kroot <- matrix(NA, ncol=length(psiVec), nrow = nlayer)
        for(j in 1:nlayer) {
          kroot[j,] <- VCroot_kmax_layer[i,j]*(1.0 - (1.0/(1.0 + exp(VCroot_slope[i] / 25.0 * (psiVec - VCroot_P50[i])))))
        }
        if(draw) {
          if(i==1) {
            matplot(-psiVec, t(kroot), type="l", xlim=c(0,-minPsi), ylim =ylim,
                    xlab = xlab, ylab = ylab, col=col)
          } else {
            matlines(-psiVec, t(kroot), lty=i, col=col)
          }
        }
      }
    }
    if(draw) {
      if(!speciesNames) legend("topright", legend = cohortnames, lty=1:ncoh, col = 1:ncoh, bty="n")
      else legend("topright", legend = spnames, lty=1:ncoh, col = 1:ncoh, bty="n")
      legend("right", legend = paste("Layer", 1:nlayer), lty=1, col=col, bty="n")
    }
  } 
  else if(type=="rhizosphere") {
    if(is.null(soil)) stop("Please supply a non-null soil object!")
    if(!inherits(soil, "soil")) {
      if(inherits(soil, "data.frame")){
        soil <- soil(soil)
      } else {
        stop("soil has to be of class 'data.frame' or 'soil'")
      }
    } 
    if(is.null(ylab)) {
      if(!relative) ylab <- expression(paste("Rhizosphere conductance  ", (mmol%.%s^{-1}%.%m^{-2}%.%MPa^{-1})))
      else ylab <- "Rhizosphere conductance (% of maximum)"
    }
    if(is.null(xlab)) xlab <- "Rhizosphere pressure (-MPa)"
    if(is.null(ylim)) ylim <- c(0,100)
    VG_nc <- soil$VG_n
    VG_alphac <- soil$VG_alpha
    for(i in 1:ncoh) {
      krhizo <- matrix(NA, ncol=length(psiVec), nrow = nlayer)
      for(j in 1:nlayer) {
        krhizo[j,] <- unlist(lapply(psiVec, hydraulics_vanGenuchtenConductance, VGrhizo_kmax[i,j], VG_nc[j], VG_alphac[j]))
      }
      if(i==1) {
        matplot(-psiVec, t(krhizo), type="l", xlim=c(0,-minPsi), ylim =ylim,
                xlab = xlab, ylab = ylab, col=col)
      } else {
        matlines(-psiVec, t(krhizo), lty=i, col=col)
      }
    }
    if(!speciesNames) legend("topright", legend = cohortnames, lty=1:ncoh, col = 1:ncoh, bty="n")
    else legend("topright", legend = spnames, lty=1:ncoh, col = 1:ncoh, bty="n")
    legend("right", legend = paste("Layer", 1:nlayer), lty=1, col=col, bty="n")
  } 
  if(draw) invisible(res)
  else return(res)
}

# Function to calculate Z50 knowing Z95 and the cumulated root proportion V at a given depth Z
.root_ldrZ50 <- function(V,Z,Z95){
  if(sum(V >= 0.9497887)>0) {stop("The function is not defined for V >= 0.9497887")}
  if(sum(Z == Z95)>0) {stop("The function is not defined for Z = Z95")}
  a <- log(V/(1-V))/2.94
  Z50 <- (Z/Z95^a)^(1/(1-a))
  return(Z50)
}

# Convenience function for finding the inverse solution of a given function
.inverse <- function (f, lower, upper) {
  function (y) uniroot((function (x) f(x) - y), lower = lower, upper = upper, extendInt = "yes")[1]
}


#' @rdname utils_ldrOptimization
#'
#' @param x An object of class \code{\link{spwbInput}}.
#' @param meteo A data frame with daily meteorological data series (see \code{\link{spwb}}).
#' @param cohorts A character string with the names of cohorts to be explored. If \code{NULL} then all cohorts are explored.
#' @param RZmin The minimum value of RZ (the rooting depth) to be explored (in mm)
#' @param RZmax The maximum value of RZ (the rooting depth) to be explored (in mm)
#' @param V1min The minimum value of V1 (the root proportion in the first soil layer) to be explored
#' @param V1max The maximum value of V1 (the root proportion in the first soil layer) to be explored
#' @param resolution An integer defining the number of values to obtain by discretization of the root parameters RZ and V1. The number of parameter combinations and therefore the computation cost increases increase with the square of resolution
#' @param transformation Function to modify the size of Z intervals to be explored (by default, bins are equal).
#' @param heat_stop An integer defining the number of days during to discard from the calculation of the optimal root distribution. Usefull if the soil water content initialization is not certain
#' @param ... Additional parameters to function \code{\link[medfate]{spwb}}.
#'
#' @export
utils_ldrExploration<-function(x, meteo, cohorts = NULL,
                              RZmin = 301, RZmax = 4000, V1min = 0.01, V1max = 0.94, resolution = 10,
                              heat_stop = 0, transformation = "identity", verbose = FALSE,
                              ...) {
  # define the days to keep in the analysis
  op_days <- (heat_stop+1):nrow(meteo)
  
  # Define the values of Z50 and Z90 to be explored
  trans <- function(x) do.call(transformation, list(x))
  inverse_trans <- .inverse(trans, lower = 0.01, upper = 100) # inverse of the function used for the transformation
  
  if(RZmax > sum(x$soil$widths)){
    if(verbose) cat("\n RZmax is larger than soil depth\n")
  }
  
  RZ_trans <- seq(trans(RZmin), trans(RZmax), length.out = resolution)
  RZ <- as.numeric(unlist(sapply(RZ_trans, FUN = inverse_trans)))
  
  # the case where RZ = Z1 will create problems when using the LDR model -> remove if it exists
  Z1 <- x$soil$widths[1]
  if(sum(RZ == Z1) > 0){
    if(verbose) cat("\nThe function to derive the root proportion in each soil layer is not defined for RZ = Z1 (depth of the first soil layer)\n",
                    "This value is removed\n",
                    paste("Resolution is now\n", resolution-1))
    RZ <- RZ[-which(RZ == Z1)]
  }
  
  if(V1max >= 0.9497887){
    if(verbose) cat("\nThe function to derive the root proportion in each soil layer is only defined for V1 c ]0,0.949[\nV1max is set to 0.94\n")
    V1max <- 0.94
  }
  if(V1min <= 0){
    if(verbose) cat("\nThe function to derive the root proportion in each soil layer is only defined for V1 c ]0,0.949[\nV1min is set to 0.01\n")
    V1min <- 0.001
  }
  
  V1 <- seq(V1min,V1max,length.out = length(RZ)) # the proportion of root in the first soil layer
  # Create a matrix with V1 as rows and RZ as column, filled with logical values to indicate the parameter combinations to explore
  mExplore <- matrix(T, nrow = length(V1), ncol = length(RZ), dimnames = list(V1 = V1, RZ = RZ))
  # mExplore[lower.tri(mExplore, diag = T)] <- F
  
  # Calculate Z50
  Z50 <- .root_ldrZ50(V = array(V1,dim = dim(mExplore)), Z = array(Z1, dim = dim(mExplore)), Z95 = t(array(RZ, dim = dim(mExplore))))
  dimnames(Z50) <- dimnames(mExplore)
  # Prepare array for V
  V <- array(dim = c(length(x$soil$widths),length(V1), length(RZ)),
             dimnames = list(layer = 1:length(x$soil$widths), V1 = V1, RZ = RZ))
  
  # Sum LAI of all species
  x$above$LAI_live <- sum(x$above$LAI_live)
  x$above$LAI_expanded <- sum(x$above$LAI_expanded)
  x$above$LAI_dead <- sum(x$above$LAI_dead)
  
  # Data outputs
  if(is.null(cohorts)) cohorts = row.names(x$cohorts)
  An<-E <- PsiMin <- array(dim = c(length(cohorts), length(V1), length(RZ)), dimnames = list(cohort = cohorts, V1 = V1, RZ = RZ))
  
  # Start loop
  cc <- which(mExplore == T, arr.ind = T)
  
  # Reset input
  resetInputs(x)
  
  for(ci in 1:length(cohorts)){
    coh = cohorts[ci]
    sp = which(row.names(x$cohorts)==coh)
    
    if(verbose) cat(paste("Exploring root distribution of cohort", coh,"(", x$cohorts$Name[sp],"):\n"))
    
    x_1sp <- x
    x_1sp$cohorts <- x$cohorts[sp,,drop = FALSE]
    x_1sp$above <- x$above[sp,,drop = FALSE]
    x_1sp$below <- x$below
    x_1sp$belowLayers$V <- x$belowLayers$V[sp,,drop = FALSE]
    x_1sp$paramsInterception <- x$paramsInterception[sp,,drop = FALSE]
    x_1sp$paramsTransp <- x$paramsTransp[sp,,drop = FALSE]
    x_1sp$Transpiration <- x$Transpiration[sp,drop = FALSE]
    x_1sp$Photosynthesis <- x$Photosynthesis[sp,drop = FALSE]
    if(x_1sp$control$transpirationMode=="Granier") {
      x_1sp$PLC <- x$PLC[sp,drop = FALSE]
    } else {
      x_1sp$belowLayers$VGrhizo_kmax <- x$belowLayers$V[sp,,drop = FALSE]
      x_1sp$belowLayers$VCroot_kmax <- x$belowLayers$V[sp,,drop = FALSE]
      x_1sp$paramsAnatomy <- x$paramsAnatomy[sp,,drop = FALSE]
      x_1sp$paramsWaterStorage <- x$paramsWaterStorage[sp,,drop = FALSE]
      x_1sp$StemPLC <- x$StemPLC[sp,drop = FALSE]
      x_1sp$Einst <- x$Einst[sp,drop = FALSE]
      x_1sp$RhizoPsi <- x$RhizoPsi[sp,,drop = FALSE]
      x_1sp$RootCrownPsi <- x$RootCrownPsi[sp,drop = FALSE]
      x_1sp$StemSympPsi <- x$StemSympPsi[sp,drop = FALSE]
      x_1sp$StemPsi1 <- x$StemPsi1[sp,drop = FALSE]
      x_1sp$StemPsi2 <- x$StemPsi2[sp,drop = FALSE]
      x_1sp$LeafSympPsi <- x$LeafSympPsi[sp,drop = FALSE]
      x_1sp$LeafPsi <- x$LeafPsi[sp,drop = FALSE]
    }
    x_1sp$control$verbose <- F
    
    
    for(row in 1:nrow(cc)){
      i <- cc[row,1]
      j <- cc[row,2]
      
      # Update the depth of the different soil layer to match RZ
      s. <- x$soil
      s.$SoilDepth <- RZ[j]
      dCum <- cumsum(s.$widths)
      layersWithinRZ <- dCum < RZ[j]
      layersWithinRZ <- c(T,layersWithinRZ[-length(layersWithinRZ)])
      s.$widths <- s.$widths[layersWithinRZ] # remove the layers not included
      nl <- length(s.$widths) #new number of layers
      s.$widths[nl] <- s.$widths[nl]-dCum[nl]+RZ[j] # adjust the width of the last layer
      # s.$Water_FC[nl] = soil$Water_FC[nl]*(s.$widths[nl]/soil$widths[nl]) #Adjust volume of the last layer
      # Adjust the other soil parameters to the new number of layers
      s.[["sand"]] <- s.[["sand"]][1:nl]
      s.[["clay"]] <- s.[["clay"]][1:nl]
      s.[["om"]] <- s.[["om"]][1:nl]
      s.[["rfc"]] <- s.[["rfc"]][1:nl]
      s.[["macro"]] <- s.[["macro"]][1:nl]
      s.[["W"]] <- s.[["W"]][1:nl]
      s.[["Temp"]] <- s.[["Temp"]][1:nl]
      s.[["VG_alpha"]] <- s.[["VG_alpha"]][1:nl]
      s.[["VG_theta_res"]] <- s.[["VG_theta_res"]][1:nl]
      s.[["VG_theta_sat"]] <- s.[["VG_theta_sat"]][1:nl]
      s.[["Ksat"]] <- s.[["Ksat"]][1:nl]
      
      V[,i,j] <- 0
      x_1sp$belowLayers$V = x$belowLayers$V[sp,1:nl,drop = FALSE]
      x_1sp$belowLayers$V[1,] <- root_ldrDistribution(Z50 = Z50[i,j], Z95 = RZ[j], Z100 = sum(s.$widths), d=s.$widths)
      V[1:length(x_1sp$belowLayers$V),i,j] <- x_1sp$belowLayers$V
      
      x_1sp[["soil"]] <- s.
      s_res <- spwb(x = x_1sp, meteo = meteo, ...)
      
      # Outputs
      years <- substr(as.Date(meteo$dates), start = 1, stop = 4)
      ma <- function(x,n=10){
        f = stats::filter(x,rep(1/n,n), method = "convolution", sides = 2)
        f = f[!is.na(f)]
        # print(sum(is.na(f)))
        f
      }
      if(x_1sp$control$transpirationMode=="Granier") {
        psi <- s_res$Plants$PlantPsi[op_days]
      } else {
        psi <- s_res$Plants$StemPsi[op_days]
      }
      PsiMin[ci,i,j] <- mean(aggregate(psi,
                                       by = list(years[op_days]),
                                       FUN = function(x) {
                                         m <- ma(x)
                                         if(sum(!is.na(m)>0)) return(min(m, na.rm=TRUE))
                                         return(NA)
                                       })$x)
      # if(verbose) print(s_res$spwbInput)
      E[ci,i,j] <- mean(s_res$Plants$Transpiration[op_days], na.rm=TRUE)
      if(x_1sp$control$transpirationMode=="Granier") {
        An[ci,i,j] <- mean(s_res$Plants$GrossPhotosynthesis[op_days], na.rm=TRUE)
      } else {
        An[ci,i,j] <- mean(s_res$Plants$NetPhotosynthesis[op_days], na.rm=TRUE)
      }
    }
    cat("\n")
  }
  res <-list(cohorts = cohorts, RZ = RZ, V1 = V1, Z50 = Z50, E = E, An = An, PsiMin = PsiMin)
  class(res)<-list("utils_ldrExploration","list")
  return(res)
}

#' Optimization of root distribution
#'
#' Functions \code{utils_ldrExploration} and \code{utils_ldrOptimization} are used to
#' find optimum the species root distribution within \code{spwb}, given the arguments
#' \code{x}, \code{meteo} and \code{psi_crit}.
#'
#' @param y The result of calling \code{utils_ldrExploration}.
#' @param psi_crit A numerical vector of length iqual to the number of species in the plot containing the species values of water potential inducing hydraulic failure (in MPa). Use \code{NA} values to skip optimization for particular plant cohorts.
#' @param opt_mode Optimization mode:
#'     \itemize{
#'       \item{\code{opt_mode = 1} maximizes transpiration along the line of stress equal to \code{psi_crit} (Cabon et al. 2018). The optimization is based on the eco-hydrological equilibrium hypothesis (Eagleson, 1982), which is formulated here as the root distribution for which plant transpiration is maximized while the plant water potential is close to the species-defined critical value \code{psi_crit} (Cabon et al.,2018).}
#'       \item{\code{opt_mode = 2} maximizes transpiration among combinations with stress according to \code{psi_crit}).}
#'       \item{\code{opt_mode = 3} maximizes photosynthesis among combinations with stress according to \code{psi_crit}).}
#'       \item{\code{opt_mode = 4} maximizes transpiration, subject to root construction constrains, among combinations with stress according to \code{psi_crit}).}
#'       \item{\code{opt_mode = 5} maximizes photosynthesis, subject to root construction constrains, among combinations with stress according to \code{psi_crit}).}
#'     }
#' @param verbose A logical value. Print the internal messages of the function?
#'
#' @details
#' For each combination of the parameters RZ and V1 the function \code{utils_ldrExploration} runs \code{spwb},
#' setting the total soil depth equal to RZ. The root proportion in each soil layer is derived from V1,
#' the depth of the first soil layer and RZ using the LDR root distribution model (Schenk and Jackson, 2002)
#' and assuming that the depth containing 95 percent of the roots is equal to RZ.
#' Function \code{utils_ldrOptimization} takes the result of the exploration and tries
#' to find optimum root distribution parameters. \code{psi_crit}, the species specific
#' water potential inducing hydraulic failure, can be approached by the water potential
#' inducing 50 percent of loss of conductance for the and gymnosperms and 88 percent for
#' the angiosperms (Urli et al., 2013, Brodribb et al., 2010). Details of the hypothesis
#' and limitations of the optimization method are given in Cabon et al. (2019).
#'
#' @return
#' Function \code{utils_ldrExploration} returns a list containing a list containing
#' the explored RZ and V1 combinations as well as arrays with the values of average daily plant transpiration,
#' average daily net photosynthesis and the minimum plant water potential for each cohort and parameter combination.
#'
#' Function \code{utils_ldrOptimization}  returns a data frame with containing
#' the species index used in medfate, \code{psi_crit} and the optimized values of V1
#' and the LDR parameters Z50 and Z95 (see \code{\link{root_ldrDistribution}})
#' and as many rows as the number of species.
#'
#' @references
#' Brodribb, T.J., Bowman, D.J.M.S., Nichols, S., Delzon, S., Burlett, R., 2010. Xylem function and growth rate interact to determine recovery rates after exposure to extreme water deficit. New Phytol. 188, 533–542. doi:10.1111/j.1469-8137.2010.03393.x
#'
#' Cabon, A., \enc{Martínez-Vilalta}{Martinez-Vilalta}, J., Poyatos, R., \enc{Martínez de Aragón}{Martinez de Aragon}, J., De \enc{Cáceres}{Caceres}, M. (2018) Applying the eco-hydrological equilibrium hypothesis to estimate root ditribution in water-limited forests. Ecohydrology 11: e2015.
#'
#' Eagleson, P.S., 1982. Ecological optimality in water-limited natural soil-vegetation systems: 1. Theory and hypothesis. Water Resour. Res. 18, 325–340. doi:10.1029/WR018i002p00325
#'
#' Schenk, H.J., Jackson, R.B., 2002. The Global Biogeography of Roots. Ecol. Monogr. 72, 311. doi:10.2307/3100092
#'
#' Urli, M., Porte, A.J., Cochard, H., Guengant, Y., Burlett, R., Delzon, S., 2013. Xylem embolism threshold for catastrophic hydraulic failure in angiosperm trees. Tree Physiol. 33, 672–683. doi:10.1093/treephys/tpt030
#'
#' @author
#' Antoine Cabon, WSL
#'
#' Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#'
#' @seealso  \code{\link{utils_rockOptimization}},  \code{\link{spwb}}, \code{\link{soil}}, \code{\link{root_ldrDistribution}}
#'
#' @name utils_ldrOptimization
#' @export
utils_ldrOptimization<-function(y, psi_crit, opt_mode = 1) {
  
  
  E = y$E
  An = y$An
  PsiMin = y$PsiMin
  V1 = y$V1
  RZ = y$RZ
  Z50 = y$Z50
  cohorts = y$cohorts
  
  if(length(psi_crit)!= length(cohorts)) stop("The length of 'psi_crit' must be equal to the number of cohorts in 'y'.")
  
  optim <- data.frame(psi_crit = psi_crit, Z50 = NA, Z95 = NA, V1 = NA)
  row.names(optim) = cohorts
  for (i in 1:length(cohorts)){
    psimin <- PsiMin[i,,]
    e <- E[i,,]
    an <- An[i,,]
    if(opt_mode==1) {
      # emax <- max(e)
      # e[e >= emax-0.05*emax] <- emax - 0.05*emax
      # cost <- (matrix(z, ncol = 1)%*%(1-v) + matrix(300, ncol = 1, nrow = length(z))%*%v)^(3/2)
      supinf <- matrix(0, ncol = ncol(psimin), nrow = nrow(psimin))
      supinf[psimin >= psi_crit[i]] <- 1
      subselb <- rbind(supinf[-nrow(supinf),]-supinf[-1,], rep(0, ncol(supinf)))
      subselt <- rbind(rep(0, ncol(supinf)), supinf[-1,]-supinf[-nrow(supinf),])
      subsell <- cbind(rep(0, nrow(supinf)), supinf[,-1]-supinf[,-ncol(supinf)])
      subselr <- cbind(supinf[,-ncol(supinf)]-supinf[,-1], rep(0, nrow(supinf)))
      sel <- matrix(F, ncol = ncol(psimin), nrow = nrow(psimin))
      sel[subselb == 1 | subselt == 1 | subsell == 1 | subselr == 1] <- T
      if(length(e[sel])==0) {
        warning(paste("Psi value", psi_crit[i],"for cohort ",row.names(cohorts)[i],"not reached for any combination."))
        optim[i,] <- NA
      } else {
        point <- which(sel & e == max(e[sel]), arr.ind = T)
        optim$Z50[i] <- Z50[point[1], point[2]]
        optim$V1[i] <- V1[point[1]]
        optim$Z95[i] <- RZ[point[2]]
      }
    }
    else if(opt_mode==2) {
      selPsi = (psimin > psi_crit[i]) # Select combinations with less stress than psi_crit
      if(sum(selPsi)==0) selPsi = (psimin == max(psimin)) # If none, select combination of minimum stress
      maxE = max(e[selPsi]) # Find maximum transpiration (among combinations selected)
      sel2 = selPsi & (e == maxE) # Select combination with maximum transpiration
      point = which(sel2, arr.ind = TRUE)
      optim$Z50[i] <- Z50[point[1], point[2]]
      optim$V1[i] <- V1[point[1]]
      optim$Z95[i] <- RZ[point[2]]
    }
    else if(opt_mode==3) {
      selPsi = (psimin > psi_crit[i]) # Select combinations with less stress than psi_crit
      if(sum(selPsi)==0) selPsi = (psimin == max(psimin)) # If none, select combination of minimum stress
      maxAn = max(an[selPsi]) # Find maximum transpiration (among combinations selected)
      sel2 = selPsi & (an == maxAn) # Select combinations with maximum photosynthesis
      point = which(sel2, arr.ind = TRUE)
      optim$Z50[i] <- Z50[point[1], point[2]]
      optim$V1[i] <- V1[point[1]]
      optim$Z95[i] <- RZ[point[2]]
    }
    else if(opt_mode==4) {
      selPsi = (psimin > psi_crit[i]) # Select combinations with less stress than psi_crit
      if(sum(selPsi)==0) selPsi = (psimin == max(psimin)) # If none, select combination of minimum stress
      maxE = max(e[selPsi]) # Find maximum transpiration (among combinations selected)
      sel2 = selPsi & (e >= maxE*0.95) # Select combinations with > 95% of maximum transpiration
      points = as.data.frame(which(sel2, arr.ind = TRUE))
      minZ = min(points$RZ, na.rm=T) # Minimum rooting depth
      maxV1 = max(points$V1[points$RZ==minZ], na.rm=T) # Maximum V1
      point = c(maxV1, minZ)
      optim$Z50[i] <- Z50[point[1], point[2]]
      optim$V1[i] <- V1[point[1]]
      optim$Z95[i] <- RZ[point[2]]
    }
    else if(opt_mode==5) {
      selPsi = (psimin > psi_crit[i]) # Select combinations with less stress than psi_crit
      if(sum(selPsi)==0) selPsi = (psimin == max(psimin)) # If none, select combination of minimum stress
      maxAn = max(an[selPsi]) # Find maximum transpiration (among combinations selected)
      sel2 = selPsi & (an >= maxAn*0.95) # Select combinations with > 95% of maximum photosynthesis
      points = as.data.frame(which(sel2, arr.ind = TRUE))
      minZ = min(points$RZ, na.rm=T) # Minimum rooting depth
      maxV1 = max(points$V1[points$RZ==minZ], na.rm=T) # Maximum V1
      point = c(maxV1, minZ)
      optim$Z50[i] <- Z50[point[1], point[2]]
      optim$V1[i] <- V1[point[1]]
      optim$Z95[i] <- RZ[point[2]]
    }
  }
  return(optim)
}

.resistances_sim<-function(x, cohort, relative = FALSE) {
  if(inherits(x, c("spwb","pwb"))) {
    input <- x$spwbInput  
  } else {
    input <- x$growthInput
  }
  if(!(input$control$transpirationMode %in% c("Sperry", "Sureau"))) {
    stop("Resistances can only be calculated when transpirationMode = 'Sperry' or 'Sureau'.")
  }
  cn <- row.names(input$cohorts)
  if(!(cohort %in% cn)) stop("'cohort' must be a string identifying a cohort name")
  i_coh <- which(cn==cohort)
  
  VCroot_kmax <- input$belowLayers$VCroot_kmax
  VGrhizo_kmax <- input$belowLayers$VGrhizo_kmax
  VG_nc <- input$soil$VG_n
  VG_alphac <- input$soil$VG_alpha
  
  paramsTranspiration <- input$paramsTranspiration
  VCstem_kmax <- paramsTranspiration$VCstem_kmax
  VCleaf_kmax <- paramsTranspiration$VCleaf_kmax
  if(input$control$transpirationMode=="Sperry") {
    VCroot_c <- paramsTranspiration$VCroot_c
    VCroot_d <- paramsTranspiration$VCroot_d
    VCstem_c <- paramsTranspiration$VCstem_c
    VCstem_d <- paramsTranspiration$VCstem_d
    VCleaf_c <- paramsTranspiration$VCleaf_c
    VCleaf_d <- paramsTranspiration$VCleaf_d
  } else {
    VCroot_P50 <- paramsTranspiration$VCroot_P50
    VCroot_slope <- paramsTranspiration$VCroot_slope
    VCstem_P50 <- paramsTranspiration$VCstem_P50
    VCstem_slope <- paramsTranspiration$VCstem_slope
    VCleaf_P50 <- paramsTranspiration$VCleaf_P50
    VCleaf_slope <- paramsTranspiration$VCleaf_slope
  }
  
  LeafPsi <- x$Plants$LeafPsiMin
  StemPsi <- x$Plants$StemPsi
  RootPsi <- x$Plants$RootPsi
  LeafPLC <- x$Plants$LeafPLC
  StemPLC <- x$Plants$StemPLC
  RhizoPsi <- x$Plants$RhizoPsi
  
  nlayers <- length(VG_nc)
  psiSoil <- x$Soil$Psi[,1:nlayers]

  nsteps <- nrow(psiSoil)
  pathmat <- matrix(0, nrow=nsteps, ncol = 4)
  rownames(pathmat) <- rownames(StemPsi)
  colnames(pathmat) <- c("Rhizosphere", "Root", "Stem", "Leaf")
  rhizomat <- matrix(0, nrow=nsteps, ncol = nlayers)
  rownames(rhizomat) <- rownames(StemPsi)
  colnames(rhizomat) <- 1:nlayers
  rootmat <- rhizomat
  for(j in 1:nsteps) {
    if(input$control$transpirationMode=="Sperry") {
      rrow <- hydraulics_soilPlantResistancesWeibull(psiSoil = psiSoil[j,],
                                                     psiRhizo = RhizoPsi[[i_coh]][j,],
                                                     psiStem = StemPsi[j,i_coh],
                                                     PLCstem = StemPLC[j,i_coh],
                                                     psiLeaf = LeafPsi[j,i_coh],
                                                     PLCleaf = LeafPLC[j,i_coh],
                                                     VGrhizo_kmax[i_coh,],VG_nc,VG_alphac,
                                                     VCroot_kmax[i_coh,], VCroot_c[i_coh],VCroot_d[i_coh],
                                                     VCstem_kmax[i_coh], VCstem_c[i_coh],VCstem_d[i_coh], 
                                                     VCleaf_kmax[i_coh], VCleaf_c[i_coh],VCleaf_d[i_coh])
    } else {
      rrow <- hydraulics_soilPlantResistancesSigmoid(psiSoil = psiSoil[j,],
                                                     psiRhizo = RhizoPsi[[i_coh]][j,],
                                                     psiStem = StemPsi[j,i_coh],
                                                     PLCstem = StemPLC[j,i_coh],
                                                     psiLeaf = LeafPsi[j,i_coh],
                                                     PLCleaf = LeafPLC[j,i_coh],
                                                     VGrhizo_kmax[i_coh,],VG_nc,VG_alphac,
                                                     VCroot_kmax[i_coh,], VCroot_P50[i_coh],VCroot_slope[i_coh],
                                                     VCstem_kmax[i_coh], VCstem_P50[i_coh],VCstem_slope[i_coh], 
                                                     VCleaf_kmax[i_coh], VCleaf_P50[i_coh],VCleaf_slope[i_coh])
    }
    rhizo_row <- rrow[["rhizosphere"]]
    root_row <- rrow[["root"]]
    stem_row <- rrow[["stem"]]
    leaf_row <- rrow[["leaf"]]
    pathmat[j,] <- c(1/sum(1/rhizo_row), 1/sum(1/root_row), stem_row, leaf_row)
    rootmat[j, ] <- root_row
    rhizomat[j, ] <- rhizo_row
    if(relative) {
      pathmat[j,] <- 100*pathmat[j,]/sum(pathmat[j,])
      rootmat[j,] <- 100*rootmat[j,]/sum(rootmat[j,])
      rhizomat[j,] <- 100*rhizomat[j,]/sum(rhizomat[j,])
    }
  }
  return(list("pathway" = pathmat,
              "root" = rootmat,
              "rhizosphere" = rhizomat))
}

#' Soil-plant resistances
#'
#' Calculates and draws rhizosphere, root, stem and leaf resistances for simulation time steps
#' 
#' @param x An object of class \code{\link{spwb}}, \code{\link{pwb}}, \code{\link{growth}} or \code{\link{fordyn}}. 
#' The function only works with the result of simulations with \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}.
#' @param cohort An string indicating the cohort for which resistances are desired.
#' @param relative A boolean flag to indicate that relative percentages are desired as output.
#' @param draw A boolean flag to indicate that a plot should be drawn (only pathway resistances, without discriminating between soil layers).
#' @param cumulative A flag to indicate that drawn series should be cumulative.
#' @param xlab x-axis label.
#' @param ylab y-axis label.
#' 
#' @details
#' The function makes internal calls to \code{\link{hydraulics_soilPlantResistancesWeibull}} or
#' \code{\link{hydraulics_soilPlantResistancesSigmoid}} depending on the value of \code{transpirationMode} in \code{x}.
#' 
#' @return 
#' If \code{draw = FALSE}, the function returns list with three items:
#' \itemize{
#'  \item{\code{pathway}: A data frame with dates in rows and resistance segments in columns (Rhizosphere, Root, Stem and Leaf). }
#'  \item{\code{root}: A data frame with dates in rows and root resistances for soil layers in columns.}
#'  \item{\code{rhizosphere}: A data frame with dates in rows and rhizosphere resistances for soil layers in columns. }
#'}
#' Values depend on whether \code{relative = TRUE} (percentages) or \code{relative = FALSE} (absolute resistance values). 
#' 
#' If \code{draw = TRUE}, a plot object is returned showing the time series of pathway resistances.
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' @author \enc{Léa}{Lea} Veuillen, INRAE-URFM
#' 
#' @seealso \code{\link{waterUseEfficiency}}, \code{\link{droughtStress}}
resistances<-function(x, cohort, relative = FALSE, draw = FALSE, 
                      cumulative = FALSE, xlab = NULL, ylab=NULL) {
  
  if(!inherits(x, c("spwb","pwb","growth", "fordyn"))) {
    stop("'x' should be of class 'spwb', 'pwb', 'growth' or 'fordyn'")
  }
  if(inherits(x, c("spwb","pwb", "growth"))) {
    res <- .resistances_sim(x = x, cohort = cohort, relative = relative)
    pathmat <- res[["pathway"]]
    rootmat <- res[["root"]]
    rhizomat <- res[["rhizosphere"]]
  } else {
    vec_pathway<-vector("list", length(x$GrowthResults))
    vec_root<-vector("list", length(x$GrowthResults))
    vec_rhizo<-vector("list", length(x$GrowthResults))
    for(i in 1:length(x$GrowthResults)) {
      res <- .resistances_sim(x = x$GrowthResults[[i]], cohort = cohort, relative = relative)
      vec_pathway[[i]] <- res[["pathway"]]
      vec_root[[i]] <- res[["root"]]
      vec_rhizo[[i]] <- res[["rhizosphere"]]
    }
    pathmat <- .mergeVectorOfMatrices(vec_pathway)
    rootmat <- .mergeVectorOfMatrices(vec_root)
    rhizomat <- .mergeVectorOfMatrices(vec_rhizo)
  }
  if(draw) {
    if(is.null(ylab)) ylab = ifelse(relative, "Relative resistances (%)", "Resistances")
    if(is.null(xlab)) xlab = ""
    if(!cumulative) {
      g<-.multiple_dynamics(pathmat, ylab=ylab, xlab = xlab)
    } else {
      rescum = pathmat
      rescum[,2] = rescum[,1] + rescum[,2]
      rescum[,3] = rescum[,2] + rescum[,3]
      rescum[,4] = rescum[,3] + rescum[,4]
      
      df = as.data.frame(rescum)
      df$Date =  as.Date(rownames(x$WaterBalance))
      g<-ggplot(df, aes(x = df$Date))+
        geom_area(aes(y=df$Leaf, fill = "4"))+
        geom_area(aes(y=df$Stem, fill = "3"))+
        geom_area(aes(y=df$Root, fill = "2"))+
        geom_area(aes(y=df$Rhizosphere, fill="1"))+
        scale_fill_manual(name="", values=c("1" = "black", "2"="red",
                                            "3" = "green", "4" = "blue"),
                          labels = c("Rhizosphere", "Root", "Stem", "Leaf"))+
        xlab(xlab)+ylab(ylab)+
        theme_bw()
    }
    return(g)
  } else {
    return(list("pathway" = pathmat, "root" = rootmat, "rhizosphere" = rhizomat))
  }
}

#' Plots simulation results for one day
#' 
#' Functions to plot the sub-daily simulation results of \code{\link{spwb_day}}, \code{\link{growth_day}} 
#' or the transpiration calculations of \code{\link{transp_transpirationSperry}} or \code{\link{transp_transpirationSureau}}.
#'
#' @param x An object of class \code{spwb_day}, \code{growth_day} or \code{pwb_day}.
#' @param type The information to be plotted (see details).
#' @param bySpecies Allows aggregating output by species, before drawing plots. Aggregation can involve a sum (as for plant LAI or transpiration) 
#'                  or a LAI-weighted mean (as for plant stress or plant water potential).
#' @param xlim Range of values for x.
#' @param ylim Range of values for y.
#' @param xlab x-axis label.
#' @param ylab y-axis label.
#' @param ... Additional parameters for function \code{plot}.
#' 
#' @details The following plots are available for \code{spwb_day} and \code{pwb_day}:
#' \itemize{
#'   \item{\code{"LeafPsi"}: Leaf water potential (for shade and sunlit leaves).}
#'   \item{\code{"LeafPsiAverage"}: Average leaf water potential.}
#'   \item{\code{"RootPsi"}: Root crown water potential.}
#'   \item{\code{"StemPsi"}: Stem water potential.}
#'   \item{\code{"StemPLC"}: (Average) percentage of loss conductance in the stem conduits.}
#'   \item{\code{"StemRWC"}: (Average) relative water content in the stem.}
#'   \item{\code{"LeafRWC"}: Relative water content in the leaf.}
#'   \item{\code{"StemSympRWC"}: (Average) relative water content in the stem symplasm.}
#'   \item{\code{"LeafSympRWC"}: Relative water content in the leaf symplasm.}
#'   \item{\code{"SoilPlantConductance"}: Overall soil plant conductance (calculated as the derivative of the supply function).}
#'   \item{\code{"PlantExtraction"}:  Water extracted from each soil layer.}
#'   \item{\code{"PlantTranspiration"}: Plant cohort transpiration per ground area.}
#'   \item{\code{"TranspirationPerLeaf"}: Plant cohort transpiration per leaf area.}
#'   \item{\code{"PlantGrossPhotosynthesis"}: Plant cohort gross photosynthesis per ground area.}
#'   \item{\code{"GrossPhotosynthesisPerLeaf"}: Plant cohort gross photosynthesis per leaf area.}
#'   \item{\code{"PlantNetPhotosynthesis"}: Plant cohort net photosynthesis per ground area.}
#'   \item{\code{"NetPhotosynthesisPerLeaf"}: Plant cohort net photosynthesis per leaf area.}
#'   \item{\code{"LeafTranspiration"}: Instantaneous transpiration per leaf area (differentiates sunlit and shade leaves).}
#'   \item{\code{"LeafGrossPhotosynthesis"}: Instantaneous gross photosynthesis per leaf area (differentiates sunlit and shade leaves).}
#'   \item{\code{"LeafNetPhotosynthesis"}: Instantaneous net photosynthesis per leaf area (differentiates sunlit and shade leaves).}
#'   \item{\code{"LeafAbsorbedSWR"}: Absorbed short wave radiation per leaf area (differentiates sunlit and shade leaves).}
#'   \item{\code{"LeafAbsorbedPAR"}: Absorbed photosynthetically-active radiation per leaf area (differentiates sunlit and shade leaves).}
#'   \item{\code{"LeafNetLWR"}: Net long wave radiation per leaf area (differentiates sunlit and shade leaves).}
#'   \item{\code{"LeafCi"}: Leaf intercellular CO2 concentration (differentiates sunlit and shade leaves).}
#'   \item{\code{"LeafIntrinsicWUE"}: Leaf intrinsic water use efficiency, i.e. the ratio between instantaneous photosynthesis and stomatal conductance (differentiates sunlit and shade leaves).}
#'   \item{\code{"LeafVPD"}: Leaf vapour pressure deficit (differentiates sunlit and shade leaves).}
#'   \item{\code{"LeafStomatalConductance"}: Leaf stomatal conductance to water vapour (differentiates sunlit and shade leaves).}
#'   \item{\code{"LeafTemperature"}: Leaf temperature (differentiates sunlit and shade leaves).}
#'   \item{\code{"Temperature"}: Above-canopy, inside-canopy and soil temperature.}
#'   \item{\code{"CanopyEnergyBalance"}: Canopy energy balance components.}
#'   \item{\code{"SoilEnergyBalance"}: Soil energy balance components.}
#'   \item{\code{"PlantWaterBalance"}: Difference between water extraction from the soil and transpired water per ground area.}
#'   \item{\code{"WaterBalancePerLeaf"}: Difference between water extraction from the soil and transpired water per leaf area.}
#' }
#' And the following plots are additionally available for \code{growth_day}:
#'   \itemize{
#'     \item{\code{"GrossPhotosynthesis"}: Gross photosynthesis rate per dry weight.}
#'     \item{\code{"MaintenanceRespiration"}: Maintenance respiration cost per dry weight.}
#'     \item{\code{"RootExudation"}: Root exudation rate per dry weight.}
#'     \item{\code{"LabileCarbonBalance"}: Labile carbon balance per dry weight.}
#'     \item{\code{"SugarLeaf"}: Sugar concentration in leaves.}
#'     \item{\code{"StarchLeaf"}: Starch concentration in leaves.}
#'     \item{\code{"SugarSapwood"}: Sugar concentration in sapwood.}
#'     \item{\code{"StarchSapwood"}: Starch concentration in sapwood.}
#'     \item{\code{"SugarTransport"}: Phloem sugar transport rate.}
#'   }
#'   
#' @note Only for soil plant water balance simulations using \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}. This function can be used to display subdaily dynamics of corresponding to single days on \code{\link{spwb}} runs, if control option \code{subdailyResults} is set to \code{TRUE}. See also option \code{subdaily} in \code{\link{plot.spwb}}.
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso  \code{\link{spwb_day}}, \code{\link{growth_day}}, \code{\link{plot.spwb}}
#' @return An ggplot object
#' 
#' @examples 
#' #Load example daily meteorological data
#' data(examplemeteo)
#' 
#' #Load example plot plant data
#' data(exampleforest)
#' 
#' #Default species parameterization
#' data(SpParamsMED)
#' 
#' #Define soil with default soil params (2 layers)
#' examplesoil <- defaultSoilParams(4)
#' 
#' #Switch to 'Sperry' transpiration mode
#' control <- defaultControl("Sperry")
#' 
#' #Enable subdaily results for plotting
#' control["subdailyResults"] <- TRUE
#' 
#' #Initialize model inputs
#' x2 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)
#' 
#' #Simulate one day only
#' d <- 100
#' date <- examplemeteo$dates[d]
#' meteovec <- unlist(examplemeteo[d,])
#' sd2 <- spwb_day(x2, date, meteovec,
#'               latitude = 41.82592, elevation = 100, slope= 0, aspect = 0)
#' 
#' #Display transpiration for subdaily steps
#' plot(sd2, "PlantTranspiration")
#' 
#' @name plot.spwb_day
plot.spwb_day<-function(x, type="PlantTranspiration", bySpecies = FALSE, 
                        xlim = NULL, ylim=NULL, xlab = NULL, ylab = NULL, ...) {
  plot.pwb_day(x, type, bySpecies, xlim, ylim, xlab, ylab,...)
}

#' @rdname plot.spwb_day
plot.growth_day<-function(x, type="PlantTranspiration", bySpecies = FALSE, 
                          xlim = NULL, ylim=NULL, xlab = NULL, ylab = NULL, ...) {
  GROWTH_TYPES = .getSubdailyGROWTHPlotTypes()
  PWB_TYPES = .getSubdailySPWBPlotTypes()
  type = match.arg(type,GROWTH_TYPES)
  if(type %in% PWB_TYPES) {
    return(plot.pwb_day(x, type, bySpecies, xlim, ylim, xlab, ylab,...))
  } else {
    LCBInst = x$LabileCarbonBalanceInst
    OM = LCBInst[[type]]
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
}

#' @rdname plot.spwb_day
plot.pwb_day<-function(x, type="PlantTranspiration", bySpecies = FALSE, 
                       xlim = NULL, ylim=NULL, xlab = NULL, ylab = NULL, ...) {
  if(!("EnergyBalance" %in% names(x))) stop("Plotting function available for transpirationMode = 'Sperry' only.")
  EB = x$EnergyBalance
  Plants = x$Plants
  PlantsInst = x$PlantsInst
  SunlitLeavesInst = x$SunlitLeavesInst
  ShadeLeavesInst = x$ShadeLeavesInst
  type = match.arg(type,.getSubdailySPWBPlotTypes())  
  cohortnames = row.names(x$cohorts)
  timesteps = as.numeric(colnames(x$PlantsInst$LeafPsi))
  if(is.null(xlab)) xlab = "Time step"
  if(type=="LeafPsiAverage") {
    OM = PlantsInst$LeafPsi
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="StemPsi") {
    OM = PlantsInst$StemPsi
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="LeafSympPsi") {
    OM = PlantsInst$LeafSympPsi
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="StemSympPsi") {
    OM = PlantsInst$StemSympPsi
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="RootPsi") {
    OM = PlantsInst$RootPsi
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="LeafPLC") {
    OM = PlantsInst$LeafPLC*100
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="StemPLC") {
    OM = PlantsInst$StemPLC*100
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="StemRWC") {
    OM = PlantsInst$StemRWC*100
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="StemSympRWC") {
    OM = PlantsInst$StemSympRWC*100
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="LeafRWC") {
    OM = PlantsInst$LeafRWC*100
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="LeafSympRWC") {
    OM = PlantsInst$LeafSympRWC*100
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="SoilPlantConductance") {
    OM = PlantsInst$dEdP
    if(bySpecies) {
      OM = apply(OM,2, tapply, x$cohorts$Name, sum, na.rm=T)
    } 
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="PlantWaterBalance") {
    OM = PlantsInst$PWB
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab =  .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="WaterBalancePerLeaf") {
    OM = PlantsInst$PWB
    if(bySpecies) {
      m1 = apply(OM,2, tapply, x$cohorts$Name, sum, na.rm=T)
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OM = sweep(m1,1,lai1,"/")
    } else {
      OM = sweep(OM,1,Plants$LAI,"/")
    }
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="PlantExtraction") {
    OM = x$ExtractionInst
    nlayers = nrow(OM)
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="PlantTranspiration") {
    OM = PlantsInst$E
    if(bySpecies) {
      OM = apply(OM,2, tapply, x$cohorts$Name, sum, na.rm=T)
    } 
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="TranspirationPerLeaf") {
    OM = PlantsInst$E
    if(bySpecies) {
      m1 = apply(OM,2, tapply, x$cohorts$Name, sum, na.rm=T)
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OM = sweep(m1,1,lai1,"/")
    } else {
      OM = sweep(OM,1,Plants$LAI,"/")
    }
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="PlantGrossPhotosynthesis") {
    OM = PlantsInst$Ag
    if(bySpecies) {
      OM = apply(OM,2, tapply, x$cohorts$Name, sum, na.rm=T)
    } 
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="PlantNetPhotosynthesis") {
    OM = PlantsInst$An
    if(bySpecies) {
      OM = apply(OM,2, tapply, x$cohorts$Name, sum, na.rm=T)
    } 
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="GrossPhotosynthesisPerLeaf") {
    OM = PlantsInst$Ag
    if(bySpecies) {
      m1 = apply(OM,2, tapply, x$cohorts$Name, sum, na.rm=T)
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OM = sweep(m1,1,lai1,"/")
    } else {
      OM = sweep(OM,1,Plants$LAI,"/")
    }
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="NetPhotosynthesisPerLeaf") {
    OM = PlantsInst$An
    if(bySpecies) {
      m1 = apply(OM,2, tapply, x$cohorts$Name, sum, na.rm=T)
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OM = sweep(m1,1,lai1,"/")
    } else {
      OM = sweep(OM,1,Plants$LAI,"/")
    }
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_subday_dynamics(t(OM), ylab = ylab, ylim = ylim))
  }
  else if(type=="LeafLAI") {
    OM_SL = SunlitLeavesInst$LAI
    OM_SH = ShadeLeavesInst$LAI
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM_SL, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SL = sweep(m1,1,lai1,"/")
      OMlai = sweep(OM_SH, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SH = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_subday_dynamics_sunlit_shade(t(OM_SL), t(OM_SH), ylab = ylab, ylim = ylim))
  }
  else if(type=="LeafTranspiration") {
    OM_SL = SunlitLeavesInst$E
    OM_SH = ShadeLeavesInst$E
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM_SL, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SL = sweep(m1,1,lai1,"/")
      OMlai = sweep(OM_SH, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SH = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_subday_dynamics_sunlit_shade(t(OM_SL), t(OM_SH), ylab = ylab, ylim = ylim))
  }
  else if(type=="LeafNetPhotosynthesis") {
    OM_SL = SunlitLeavesInst$An
    OM_SH = ShadeLeavesInst$An
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM_SL, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SL = sweep(m1,1,lai1,"/")
      OMlai = sweep(OM_SH, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SH = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_subday_dynamics_sunlit_shade(t(OM_SL), t(OM_SH), ylab = ylab, ylim = ylim))
  }
  else if(type=="LeafGrossPhotosynthesis") {
    OM_SL = SunlitLeavesInst$Ag
    OM_SH = ShadeLeavesInst$Ag
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM_SL, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SL = sweep(m1,1,lai1,"/")
      OMlai = sweep(OM_SH, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SH = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_subday_dynamics_sunlit_shade(t(OM_SL), t(OM_SH), ylab = ylab, ylim = ylim))
  }
  else if(type=="LeafAbsorbedSWR") {
    OM_SL <- SunlitLeavesInst$Abs_SWR
    OM_SH <- ShadeLeavesInst$Abs_SWR
    if(bySpecies) {
      m1 <- apply(OM_SL,2, tapply, x$cohorts$Name, sum, na.rm=T)
      lai1 <- apply(x$SunlitLeavesInst$LAI,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SL <- m1/lai1
      m1 <- apply(OM_SH,2, tapply, x$cohorts$Name, sum, na.rm=T)
      lai1 <- apply(x$ShadeLeavesInst$LAI,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SH <- m1/lai1
    } else {
      OM_SL <- OM_SL/x$SunlitLeavesInst$LAI
      OM_SH <- OM_SH/x$ShadeLeavesInst$LAI
    }
    OM_SL[is.na(OM_SL)] <- 0.0
    OM_SH[is.na(OM_SH)] <- 0.0
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_subday_dynamics_sunlit_shade(t(OM_SL), t(OM_SH), ylab = ylab, ylim = ylim))
  }
  else if(type=="LeafAbsorbedPAR") {
    OM_SL <- SunlitLeavesInst$Abs_PAR
    OM_SH <- ShadeLeavesInst$Abs_PAR
    if(bySpecies) {
      m1 <- apply(OM_SL,2, tapply, x$cohorts$Name, sum, na.rm=T)
      lai1 <- apply(x$ShadeLeavesInst$LAI,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SL <- m1/lai1
      m1 <- apply(OM_SH,2, tapply, x$cohorts$Name, sum, na.rm=T)
      lai1 <- apply(x$ShadeLeavesInst$LAI,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SH <- m1/lai1
    } else {
      OM_SL <- OM_SL/x$ShadeLeavesInst$LAI
      OM_SH <- OM_SH/x$ShadeLeavesInst$LAI
    }
    OM_SL[is.na(OM_SL)] <- 0.0
    OM_SH[is.na(OM_SH)] <- 0.0
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_subday_dynamics_sunlit_shade(t(OM_SL), t(OM_SH), ylab = ylab, ylim = ylim))
  }
  else if(type=="LeafNetLWR") {
    OM_SL <- SunlitLeavesInst$Net_LWR
    OM_SH <- ShadeLeavesInst$Net_LWR
    if(bySpecies) {
      m1 <- apply(OM_SL,2, tapply, x$cohorts$Name, sum, na.rm=T)
      lai1 <- apply(x$ShadeLeavesInst$LAI,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SL <- m1/lai1
      m1 <- apply(OM_SH,2, tapply, x$cohorts$Name, sum, na.rm=T)
      lai1 <- apply(x$ShadeLeavesInst$LAI,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SH <- m1/lai1
    } else {
      OM_SL <- OM_SL/x$ShadeLeavesInst$LAI
      OM_SH <- OM_SH/x$ShadeLeavesInst$LAI
    }
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_subday_dynamics_sunlit_shade(t(OM_SL), t(OM_SH), ylab = ylab, ylim = ylim))
  }
  else if(type=="LeafPsi") {
    OM_SL = SunlitLeavesInst$Psi
    OM_SH = ShadeLeavesInst$Psi
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM_SL, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SL = sweep(m1,1,lai1,"/")
      OMlai = sweep(OM_SH, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SH = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_subday_dynamics_sunlit_shade(t(OM_SL), t(OM_SH), ylab = ylab, ylim = ylim))
  }
  else if(type=="LeafTemperature") {
    OM_SL = SunlitLeavesInst$Temp
    OM_SH = ShadeLeavesInst$Temp
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM_SL, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SL = sweep(m1,1,lai1,"/")
      OMlai = sweep(OM_SH, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SH = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_subday_dynamics_sunlit_shade(t(OM_SL), t(OM_SH), ylab = ylab, ylim = ylim))
  }
  else if(type=="LeafVPD") {
    OM_SL = SunlitLeavesInst$VPD
    OM_SH = ShadeLeavesInst$VPD
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM_SL, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SL = sweep(m1,1,lai1,"/")
      OMlai = sweep(OM_SH, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SH = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_subday_dynamics_sunlit_shade(t(OM_SL), t(OM_SH), ylab = ylab, ylim = ylim))
  }
  else if(type=="LeafStomatalConductance") {
    OM_SL = SunlitLeavesInst$Gsw
    OM_SH = ShadeLeavesInst$Gsw
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM_SL, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SL = sweep(m1,1,lai1,"/")
      OMlai = sweep(OM_SH, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SH = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_subday_dynamics_sunlit_shade(t(OM_SL), t(OM_SH), ylab = ylab, ylim = ylim))
  }
  else if(type=="LeafIntrinsicWUE") {
    OM_SL = SunlitLeavesInst$An/SunlitLeavesInst$Gsw
    OM_SH = ShadeLeavesInst$An/ShadeLeavesInst$Gsw
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM_SL, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SL = sweep(m1,1,lai1,"/")
      OMlai = sweep(OM_SH, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SH = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_subday_dynamics_sunlit_shade(t(OM_SL), t(OM_SH), ylab = ylab, ylim = ylim))
  }
  else if(type=="LeafCi") {
    OM_SL = SunlitLeavesInst$Ci
    OM_SH = ShadeLeavesInst$Ci
    if(bySpecies) {
      lai1 = tapply(Plants$LAI, x$cohorts$Name, sum, na.rm=T)
      OMlai = sweep(OM_SL, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SL = sweep(m1,1,lai1,"/")
      OMlai = sweep(OM_SH, 1, Plants$LAI, "*")
      m1 = apply(OMlai,2, tapply, x$cohorts$Name, sum, na.rm=T)
      OM_SH = sweep(m1,1,lai1,"/")
    } 
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_subday_dynamics_sunlit_shade(t(OM_SL), t(OM_SH), ylab = ylab, ylim = ylim))
  }
  else if(type=="Temperature") {
    
    if(is.null(ylab)) ylab = "Temperature (degrees C)"
    df = data.frame(row.names=timesteps)
    df[["Above-canopy"]] = EB$Temperature$Tatm
    df[["Inside-canopy"]] = EB$Temperature$Tcan
    if("Tsoil.1" %in% names(EB$Temperature)) {
      df[["Soil"]] = EB$Temperature$Tsoil.1
    } else {
      df[["Soil"]] = EB$SoilTemperature[,1]
    }
    g<-.multiple_subday_dynamics(as.matrix(df), ylab=ylab, ylim = ylim)
    return(g)
  } 
  else if(type=="CanopyEnergyBalance") {
    if(is.null(ylab)) ylab = expression(W%.%m^{-2})
    df = data.frame(row.names=timesteps)
    df[["Balance"]] = EB$CanopyEnergyBalance$Ebalcan
    df[["SWR abs."]] = EB$CanopyEnergyBalance$SWRcan 
    df[["LWR net"]] = EB$CanopyEnergyBalance$LWRcan
    df[["Latent heat vaporisation"]] = -EB$CanopyEnergyBalance$LEVcan
    df[["Latent heat snow fusion"]] = -EB$CanopyEnergyBalance$LEFsnow
    df[["Convection can./atm."]] = -EB$CanopyEnergyBalance$Hcan
    df[["Convection soil/can."]] = -EB$SoilEnergyBalance$Hcansoil
    g<-.multiple_subday_dynamics(as.matrix(df), ylab=ylab, ylim = ylim)
    # cols = c("red","brown","orange", "blue","green", "gray", "dark gray", "black")
    # names(cols) = c("SWR abs. from atm.","LWR abs. from atm.","LWR abs. from soil","LWR emmited", "Latent heat (L)",
    #                 "Convection can./atm.","Convection soil/can.", "Balance")
    return(g)
  }
  else if(type=="SoilEnergyBalance") {
    if(is.null(ylab)) ylab = expression(W%.%m^{-2})    
    df = data.frame(row.names=timesteps)
    df[["Balance"]] = EB$SoilEnergyBalance$Ebalsoil
    df[["SWR abs."]] = EB$SoilEnergyBalance$SWRsoil
    df[["LWR net"]] = EB$SoilEnergyBalance$LWRsoil
    df[["Convection soil/can."]] = EB$SoilEnergyBalance$Hcansoil
    df[["Latent heat vaporisation"]] = -EB$SoilEnergyBalance$LEVsoil
    g<-.multiple_subday_dynamics(as.matrix(df), ylab=ylab, ylim = ylim)
    
    # legend("topright", bty="n", col=c("red","brown","orange", "blue", "gray", "black"), lty=1,
    #        legend=c("SWR abs. from atm.","LWR abs. from atm.", "LWR abs. from canopy","LWR emmited", 
    #                   "Convection soil/can.", "Balance"),...)        
    return(g)
  }
}

#' Forest complexity reduction
#' 
#' Functions \code{forest_mergeTrees}, \code{forest_mergeShrubs} and \code{forest_mergeHerbs} merge cohorts of a \code{\link{forest}} object. 
#' Function \code{forest_reduceToDominant} performs a strongest simplification of plant cohorts (see details).
#' 
#' @param x An object of class \code{\link{forest}}.
#' @param byDBHclass Logical flag to indicate that 5-cm tree DBH classes should be kept separated.
#' @param keepCohortsWithObsID Logical flag to indicate that cohorts with non-missin ObsID should be spared from merging.
#' 
#' @details Tree DBH classes are defined in 5-cm intervals, whereas shrub/herb height classes are defined in 10-cm intervals.
#' Tree DBH and shrub/herb height classes are defined up to a specific size (i.e. larger plants are not merged) 
#' corresponding to 52.5 cm and 90 cm, respectively.
#' 
#' Function \code{forest_reduceToDominant} simplifies the input forest to the tree cohort of highest LAI, among those of the tree species with highest LAI.
#' The leaf area index of the whole tree layer will be attributed to the chosen cohort. The same is performed for the shrub and herb layers.
#' 
#' @return Another \code{\link{forest}} object with simplified structure/composition, depending on the function.
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso \code{\link{spwb}}, \code{\link{forest}},  \code{\link{forest_mapWoodyTables}}, \code{\link{fordyn}}, \code{\link{summary.forest}}
#' 
#' @name forest_simplification
#' 
#' @examples
#' # Example forest data
#' data("exampleforest")
#'
#' # Reduce to dominant tree and dominant shrub
#' reduced <- forest_reduceToDominant(exampleforest, SpParamsMED)
#' 
#' # Check that overall LAI does not change
#' stand_LAI(exampleforest, SpParamsMED)
#' stand_LAI(reduced, SpParamsMED)
forest_mergeTrees<-function(x, byDBHclass = TRUE, keepCohortsWithObsID = FALSE) {
  if(!inherits(x, "forest")) stop("`x` should be of class `forest`")
  mergeTreesSize<-function(x) {
    ntree <- nrow(x)
    if(ntree>0) {
      BA <- x$N*pi*(x$DBH/200)^2
      BAsp <- tapply(BA, x$Species, FUN = sum)
      Nsp <- as.numeric(tapply(x$N, x$Species, FUN = sum))
      DBHsp <-  2*sqrt(10000*as.numeric(BAsp)/(pi*Nsp))
      y <- data.frame(Species = names(BAsp),
                     row.names = 1:length(BAsp),
                     stringsAsFactors = FALSE)
      y$DBH <- DBHsp 
      y$Height <- as.numeric(tapply(x$Height*BA, x$Species, FUN = sum)/BAsp)
      y$N <- Nsp 
      y$Z50 <- as.numeric(tapply(x$Z50*BA, x$Species, FUN = sum)/BAsp)
      y$Z95 <- as.numeric(tapply(x$Z95*BA, x$Species, FUN = sum)/BAsp)
      if("Z100" %in% names(x)) {
        y$Z100 <- as.numeric(tapply(x$Z100*BA, x$Species, FUN = sum)/BAsp)
      }
      if("LAI" %in% names(x)) {
        y$LAI <- as.numeric(tapply(x$LAI, x$Species, FUN = sum))
      }
      if("FoliarBiomass" %in% names(x)) {
        y$FoliarBiomass <- as.numeric(tapply(x$FoliarBiomass, x$Species, FUN = sum))
      }
      if("FuelLoading" %in% names(x)) {
        y$FuelLoading <- as.numeric(tapply(x$FuelLoading, x$Species, FUN = sum))
      }
      if("Age" %in% names(x)) {
        y$Age <- as.numeric(tapply(x$Age*BA, x$Species, FUN = sum)/BAsp)
      }
      if("ObsID" %in% names(x)) {
        y$ObsID <- rep(as.character(NA), nrow(y)) 
      }
      return(y)
    }
    return(x)
  }
  mergeTreesBySizeClass<-function(x) {
    sel0a <- (x$DBH >= 97.5) & (x$DBH < 102.5)
    sel0b <- (x$DBH >= 92.5) & (x$DBH < 97.5)
    sel1a <- (x$DBH >= 87.5) & (x$DBH < 92.5)
    sel1b <- (x$DBH >= 82.5) & (x$DBH < 87.5)
    sel2a <- (x$DBH >= 77.5) & (x$DBH < 82.5)
    sel2b <- (x$DBH >= 72.5) & (x$DBH < 77.5)
    sel3a <- (x$DBH >= 67.5) & (x$DBH < 72.5)
    sel3b <- (x$DBH >= 62.5) & (x$DBH < 67.5)
    sel4a <- (x$DBH >= 57.5) & (x$DBH < 62.5)
    sel4b <- (x$DBH >= 52.5) & (x$DBH < 57.5)
    sel5a <- (x$DBH >= 47.5) & (x$DBH < 52.5)
    sel5b <- (x$DBH >= 42.5) & (x$DBH < 47.5)
    sel6a <- (x$DBH >= 37.5) & (x$DBH < 42.5)
    sel6b <- (x$DBH >= 32.5) & (x$DBH < 37.5)
    sel7a <- (x$DBH >= 27.5) & (x$DBH < 32.5)
    sel7b <- (x$DBH >= 22.5) & (x$DBH < 27.5)
    sel8a <- (x$DBH >= 17.5) & (x$DBH < 22.5)
    sel8b <- (x$DBH >= 12.5) & (x$DBH < 17.5)
    sel9a <- (x$DBH >= 7.5) & (x$DBH < 12.5)
    sel9b <- (x$DBH >= 2.5) & (x$DBH < 7.5)
    sel10 <- (x$DBH < 2.5)
    nosel <- !(sel0a | sel0b | sel1a | sel1b | sel2a| sel2b | sel3a | sel3b | 
               sel4a | sel4b | sel5a | sel5b | sel6a | sel6b | sel7a | sel7b | 
               sel8a | sel8b | sel9a | sel9b | sel10)
    y <- x[nosel, c("Species", "DBH", "Height","N","Z50", "Z95"), drop = FALSE]
    if("Z100" %in% names(x)) y$Z100 <- x$Z100[nosel]
    if("LAI" %in% names(x)) y$LAI <- x$LAI[nosel]
    if("FoliarBiomass" %in% names(x)) y$FoliarBiomass <- x$FoliarBiomass[nosel]
    if("FuelLoading" %in% names(x)) y$FuelLoading <- x$FuelLoading[nosel]
    if("Age" %in% names(x)) y$Age <- x$Age[nosel]
    if("ObsID" %in% names(x)) y$ObsID <- x$ObsID[nosel]
    if(sum(sel0a)>0) y <- rbind(y, mergeTreesSize(x[sel0a,, drop = FALSE]))
    if(sum(sel0b)>0) y <- rbind(y, mergeTreesSize(x[sel0b,, drop = FALSE]))
    if(sum(sel1a)>0) y <- rbind(y, mergeTreesSize(x[sel1a,, drop = FALSE]))
    if(sum(sel1b)>0) y <- rbind(y, mergeTreesSize(x[sel1b,, drop = FALSE]))
    if(sum(sel2a)>0) y <- rbind(y, mergeTreesSize(x[sel2a,, drop = FALSE]))
    if(sum(sel2b)>0) y <- rbind(y, mergeTreesSize(x[sel2b,, drop = FALSE]))
    if(sum(sel3a)>0) y <- rbind(y, mergeTreesSize(x[sel3a,, drop = FALSE]))
    if(sum(sel3b)>0) y <- rbind(y, mergeTreesSize(x[sel3b,, drop = FALSE]))
    if(sum(sel4a)>0) y <- rbind(y, mergeTreesSize(x[sel4a,, drop = FALSE]))
    if(sum(sel4b)>0) y <- rbind(y, mergeTreesSize(x[sel4b,, drop = FALSE]))
    if(sum(sel5a)>0) y <- rbind(y, mergeTreesSize(x[sel5a,, drop = FALSE]))
    if(sum(sel5b)>0) y <- rbind(y, mergeTreesSize(x[sel5b,, drop = FALSE]))
    if(sum(sel6a)>0) y <- rbind(y, mergeTreesSize(x[sel6a,, drop = FALSE]))
    if(sum(sel6b)>0) y <- rbind(y, mergeTreesSize(x[sel6b,, drop = FALSE]))
    if(sum(sel7a)>0) y <- rbind(y, mergeTreesSize(x[sel7a,, drop = FALSE]))
    if(sum(sel7b)>0) y <- rbind(y, mergeTreesSize(x[sel7b,, drop = FALSE]))
    if(sum(sel8a)>0) y <- rbind(y, mergeTreesSize(x[sel8a,, drop = FALSE]))
    if(sum(sel8b)>0) y <- rbind(y, mergeTreesSize(x[sel8b,, drop = FALSE]))
    if(sum(sel9a)>0) y <- rbind(y, mergeTreesSize(x[sel9a,, drop = FALSE]))
    if(sum(sel9b)>0) y <- rbind(y, mergeTreesSize(x[sel9b,, drop = FALSE]))
    if(sum(sel10)>0) y <- rbind(y, mergeTreesSize(x[sel10,, drop = FALSE]))
    return(y)
  }
  td <- x$treeData
  td_spared <- NULL
  if(keepCohortsWithObsID) {
    if("ObsID" %in% names(td)) {
      td_spared <- td[!is.na(td$ObsID), , drop = FALSE]
      td <- td[is.na(td$ObsID), , drop = FALSE]
    }
  }
  ntree <- nrow(td)
  x2 <- x
  if(ntree>0) {
    if(any(is.na(td$DBH))) stop("Missing values in DBH")
    if(any(is.na(td$N))) stop("Missing values in N")
    if(byDBHclass) {
      td_merged <- mergeTreesBySizeClass(td)
    } else {
      BA <- td$N*pi*(td$DBH/200)^2
      BAsp <- tapply(BA, td$Species, FUN = sum)
      Nsp <- as.numeric(tapply(td$N, td$Species, FUN = sum))
      Hsp <- as.numeric(tapply(td$Height*BA, td$Species, FUN = sum)/BAsp)
      DBHsp <-  2*sqrt(10000*as.numeric(BAsp)/(pi*Nsp))
      Z50sp <- as.numeric(tapply(td$Z50*BA, td$Species, FUN = sum)/BAsp)
      Z95sp <- as.numeric(tapply(td$Z95*BA, td$Species, FUN = sum)/BAsp)
      td_merged <- data.frame(Species = names(BAsp), 
                              DBH = DBHsp,
                              Height = Hsp, 
                              N = Nsp, 
                              Z50 = Z50sp, 
                              Z95 = Z95sp, 
                              row.names = 1:length(BAsp), stringsAsFactors = FALSE)
      if("Z100" %in% names(td)) {
        td_merged$Z100 <- as.numeric(tapply(td$Z100*BA, td$Species, FUN = sum)/BAsp)
      }
      if("ObsID" %in% names(td)) {
        td_merged$ObsID <- rep(as.character(NA), nrow(td_merged)) 
      }
    }
    if(!is.null(td_spared)) {
      x2$treeData <- rbind(td_spared, td_merged)
    } else {
      x2$treeData <- td_merged
    }
  }
  return(x2)
}

.mergeShrubsHerbsSize<-function(x) {
  nshrub = nrow(x)
  if(nshrub>0) {
    Coversp <- tapply(x$Cover, x$Species, FUN = sum)
    Heightsp <- tapply(x$Height*x$Cover, x$Species, FUN = sum)/Coversp
    Z50sp <- tapply(x$Z50*x$Cover, x$Species, FUN = sum)/Coversp
    Z95sp <- tapply(x$Z95*x$Cover, x$Species, FUN = sum)/Coversp
    y = data.frame(Species = names(Coversp),
                   Cover = as.numeric(Coversp),
                   Height = as.numeric(Heightsp),
                   Z50 = as.numeric(Z50sp),
                   Z95 = as.numeric(Z95sp),
                   row.names = 1:length(Coversp),
                   stringsAsFactors = FALSE)
    if("Z100" %in% names(x)) {
      y$Z100 <- as.numeric(tapply(x$Z100*x$Cover, x$Species, FUN = sum)/Coversp)
    }
    if("ObsID" %in% names(x)) {
      y$ObsID <- rep(as.character(NA), nrow(y)) 
    }
    if("LAI" %in% names(x)) {
      y$LAI <- as.numeric(tapply(x$LAI, x$Species, FUN = sum))
    }
    if("FoliarBiomass" %in% names(x)) {
      y$FoliarBiomass <- as.numeric(tapply(x$FoliarBiomass, x$Species, FUN = sum))
    }
    if("FuelLoading" %in% names(x)) {
      y$FuelLoading <- as.numeric(tapply(x$FuelLoading, x$Species, FUN = sum))
    }
    if("Age" %in% names(x)) {
      y$Age <- as.numeric(tapply(x$Age*x$Cover, x$Species, FUN = sum)/Coversp)
    }
    return(y)
  }
  return(x)
}
.mergeShrubsHerbsBySizeClass<-function(x) {
  sel0a = (x$Height >= 210) & (x$Height < 220)
  sel0b = (x$Height >= 200) & (x$Height < 210)
  sel1a = (x$Height >= 180) & (x$Height < 190)
  sel1b = (x$Height >= 170) & (x$Height < 180)
  sel2a = (x$Height >= 160) & (x$Height < 170)
  sel2b = (x$Height >= 150) & (x$Height < 160)
  sel3a = (x$Height >= 140) & (x$Height < 150)
  sel3b = (x$Height >= 130) & (x$Height < 140)
  sel4b = (x$Height >= 120) & (x$Height < 130)
  sel4a = (x$Height >= 110) & (x$Height < 120)
  sel5a = (x$Height >= 100) & (x$Height < 110)
  sel5b = (x$Height >= 90) & (x$Height < 100)
  sel6a = (x$Height >= 80) & (x$Height < 90)
  sel6b = (x$Height >= 70) & (x$Height < 80)
  sel7a = (x$Height >= 60) & (x$Height < 70)
  sel7b = (x$Height >= 50) & (x$Height < 60)
  sel8a = (x$Height >= 40) & (x$Height < 50)
  sel8b = (x$Height >= 30) & (x$Height < 40)
  sel9a = (x$Height >= 20) & (x$Height < 30)
  sel9b = (x$Height >= 10) & (x$Height < 20)
  sel10 = (x$Height < 10)
  nosel <- !(sel0a | sel0b | sel1a | sel1b | sel2a| sel2b | sel3a | sel3b | 
               sel4a | sel4b | sel5a | sel5b | sel6a | sel6b | sel7a | sel7b | 
               sel8a | sel8b | sel9a | sel9b | sel10)
  y = x[nosel,c("Species", "Height", "Cover", "Z50", "Z95"), drop = FALSE]
  if("Z100" %in% names(x)) y$Z100 <- x$Z100[nosel]
  if("LAI" %in% names(x)) y$LAI <- x$LAI[nosel]
  if("FoliarBiomass" %in% names(x)) y$FoliarBiomass <- x$FoliarBiomass[nosel]
  if("FuelLoading" %in% names(x)) y$FuelLoading <- x$FuelLoading[nosel]
  if("Age" %in% names(x)) y$Age <- x$Age[nosel]
  if("ObsID" %in% names(x)) y$ObsID <- x$ObsID[nosel]
  if(sum(sel0a)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel0a,, drop = FALSE]))
  if(sum(sel0b)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel0b,, drop = FALSE]))
  if(sum(sel1a)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel1a,, drop = FALSE]))
  if(sum(sel1b)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel1b,, drop = FALSE]))
  if(sum(sel2a)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel2a,, drop = FALSE]))
  if(sum(sel2b)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel2b,, drop = FALSE]))
  if(sum(sel3a)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel3a,, drop = FALSE]))
  if(sum(sel3b)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel3b,, drop = FALSE]))
  if(sum(sel4a)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel4a,, drop = FALSE]))
  if(sum(sel4b)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel4b,, drop = FALSE]))
  if(sum(sel5a)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel5a,, drop = FALSE]))
  if(sum(sel5b)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel5b,, drop = FALSE]))
  if(sum(sel6a)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel6a,, drop = FALSE]))
  if(sum(sel6b)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel6b,, drop = FALSE]))
  if(sum(sel7a)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel7a,, drop = FALSE]))
  if(sum(sel7b)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel7b,, drop = FALSE]))
  if(sum(sel8a)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel8a,, drop = FALSE]))
  if(sum(sel8b)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel8b,, drop = FALSE]))
  if(sum(sel9a)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel9a,, drop = FALSE]))
  if(sum(sel9b)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel9b,, drop = FALSE]))
  if(sum(sel10)>0) y <- rbind(y, .mergeShrubsHerbsSize(x[sel10,, drop = FALSE]))
  return(y)
}

#' @rdname forest_simplification
#' 
#' @param byHeightclass Boolean flag to indicate that 10-cm shrub height classes should be kept separated.
#' 
forest_mergeShrubs<-function(x, byHeightclass = TRUE, keepCohortsWithObsID = FALSE) {
  if(!inherits(x, "forest")) stop("`x` should be of class `forest`")

  sd <- x$shrubData
  sd_spared <- NULL
  if(keepCohortsWithObsID) {
    if("ObsID" %in% names(sd)) {
      sd_spared <- sd[!is.na(sd$ObsID), , drop = FALSE]
      sd <- sd[is.na(sd$ObsID), , drop = FALSE]
    }
  }
  nshrub <- nrow(sd)
  x2 <- x
  if(nshrub>0) {
    if(any(is.na(sd$Cover))) stop("Missing values in Cover")
    if(any(is.na(sd$Height))) stop("Missing values in Height")
    if(byHeightclass) {
      sd_merged <- .mergeShrubsHerbsBySizeClass(sd)
    } else {
      sd_merged <- .mergeShrubsHerbsSize(sd)
    }
    if(!is.null(sd_spared)) {
      x2$shrubData <- rbind(sd_spared, sd_merged)
    } else {
      x2$shrubData <- sd_merged
    }
  }
  return(x2)
}

#' @rdname forest_simplification
#' 
#' @param byHeightclass Boolean flag to indicate that 10-cm shrub height classes should be kept separated.
#' 
forest_mergeHerbs<-function(x, byHeightclass = TRUE, keepCohortsWithObsID = FALSE) {
  if(!inherits(x, "forest")) stop("`x` should be of class `forest`")
  if(!("herbData" %in% names(x))) stop("`x` should contain an element `herbData`")
  sd <- x$herbData
  sd_spared <- NULL
  if(keepCohortsWithObsID) {
    if("ObsID" %in% names(sd)) {
      sd_spared <- sd[!is.na(sd$ObsID), , drop = FALSE]
      sd <- sd[is.na(sd$ObsID), , drop = FALSE]
    }
  }
  nshrub <- nrow(sd)
  x2 <- x
  if(nshrub>0) {
    if(any(is.na(sd$Cover))) stop("Missing values in Cover")
    if(any(is.na(sd$Height))) stop("Missing values in Height")
    if(byHeightclass) {
      sd_merged <- .mergeShrubsHerbsBySizeClass(sd)
    } else {
      sd_merged <- .mergeShrubsHerbsSize(sd)
    }
    if(!is.null(sd_spared)) {
      x2$herbData <- rbind(sd_spared, sd_merged)
    } else {
      x2$herbData <- sd_merged
    }
  }
  return(x2)
}

#' @rdname forest_simplification
#' 
#' @param SpParams A data frame with species parameters (see \code{\link{SpParamsDefinition}} and \code{\link{SpParamsMED}}).
#' 
forest_reduceToDominant <- function(x, SpParams) {
  if(!inherits(x, "forest")) stop("`x` should be of class `forest`")
  if(!inherits(SpParams, "data.frame")) stop("Object `SpParams` should be of class `data.frame`")
  ntree <- nrow(x$treeData)
  nshrub <- nrow(x$shrubData)
  nherb <- 0
  if("herbData" %in% names(x)) {
    nherb <- nrow(x$herbData)
  }
  if(sum(ntree+nshrub+nherb)>0) {
    stand_lai <- medfate::stand_LAI(x, SpParams)
    plant_lai <- medfate::plant_LAI(x, SpParams)
    plant_species <- medfate::plant_speciesName(x, SpParams)
    is_tree <- rep(FALSE, sum(ntree+nshrub+nherb))
    is_shrub <- rep(FALSE, sum(ntree+nshrub+nherb))
    is_herb <- rep(FALSE, sum(ntree+nshrub+nherb))
    if(ntree>0) is_tree[1:ntree] <- TRUE
    if(nshrub>0) is_shrub[ntree + (1:nshrub)] <- TRUE
    if(nherb>0) is_herb[ntree+nshrub + (1:nherb)] <- TRUE
    tree_lai <- sum(plant_lai[is_tree])
    shrub_lai <- sum(plant_lai[is_shrub])
    herb_lai <- sum(plant_lai[is_herb])
    if(ntree>0) {
      tree_species_lai <- tapply(plant_lai[is_tree], plant_species[is_tree], FUN = sum)
      max_tree_species_lai <- names(tree_species_lai)[which.max(tree_species_lai)]
      sel_tree_cohort <- (plant_species[is_tree] == max_tree_species_lai)
      sel_tree_cohort[sel_tree_cohort] <- plant_lai[is_tree][sel_tree_cohort]==max(plant_lai[is_tree][sel_tree_cohort])
      tree_cohort <- which(sel_tree_cohort)[1]
      x$treeData <- x$treeData[tree_cohort, , drop=FALSE]
      x$treeData$LAI <- tree_lai
    }
    if(nshrub>0) {
      shrub_species_lai <- tapply(plant_lai[is_shrub], plant_species[is_shrub], FUN = sum)
      max_shrub_species_lai <- names(shrub_species_lai)[which.max(shrub_species_lai)]
      sel_shrub_cohort <- (plant_species[is_shrub] == max_shrub_species_lai)
      sel_shrub_cohort[sel_shrub_cohort] <- plant_lai[is_shrub][sel_shrub_cohort]==max(plant_lai[is_shrub][sel_shrub_cohort])
      shrub_cohort <- which(sel_shrub_cohort)[1]
      x$shrubData <- x$shrubData[shrub_cohort, , drop=FALSE]
      x$shrubData$LAI <- shrub_lai
    }
    if(nherb>0) {
      herb_species_lai <- tapply(plant_lai[is_herb], plant_species[is_herb], FUN = sum)
      max_herb_species_lai <- names(herb_species_lai)[which.max(herb_species_lai)]
      sel_herb_cohort <- (plant_species[is_herb] == max_herb_species_lai)
      sel_herb_cohort[sel_herb_cohort] <- plant_lai[is_herb][sel_herb_cohort]==max(plant_lai[is_herb][sel_herb_cohort])
      herb_cohort <- which(sel_herb_cohort)[1]
      x$herbData <- x$herbData[herb_cohort, , drop=FALSE]
      x$herbData$LAI <- herb_lai
    }
  }
  return(x)
}

#' Forest dynamics
#' 
#' Function \code{fordyn} implements a forest dynamics model that simulates 
#' growth, mortality, recruitment and (optionally) management actions in a given forest stand 
#' during a period specified in the input climatic data.
#' 
#' @param forest An object of class \code{\link{forest}}. Alternatively, the output of a previous run (an object of class \code{fordyn}), if continuing a previous simulation.
#' @param soil An object of class \code{\link{data.frame}} or \code{\link{soil}}.
#' @param SpParams A data frame with species parameters (see \code{\link{SpParamsMED}} and \code{\link{SpParamsDefinition}}).
#' @param meteo A data frame with daily weather data series (see \code{\link{spwb}}).
#' @param control A list with default control parameters (see \code{\link{defaultControl}}).
#' @param latitude Latitude (in degrees).
#' @param elevation,slope,aspect Elevation above sea level (in m), slope (in degrees) and aspect (in degrees from North). 
#' @param CO2ByYear A named numeric vector with years as names and atmospheric CO2 concentration (in ppm) as values. Used to specify annual changes in CO2 concentration along the simulation (as an alternative to specifying daily values in \code{meteo}).
#' @param management_function A function that implements forest management actions (see details).
#' @param management_args A list of additional arguments to be passed to the \code{management_function}.
#' 
#' @details Function \code{fordyn} simulates forest dynamics for annual time steps, building on other simulation functions. For each simulated year, the function performs the following steps:
#' \enumerate{
#'   \item{Calls function \code{\link{growth}} to simulate daily water/carbon balance, growth and mortality processes and update the forest object.}
#'   \item{If required, calls function \code{management_function}, using as parameters the forest object and \code{management_args}, which may result in a density reduction for existing plant cohorts and/or a set of new planted cohorts.}
#'   \item{Simulate natural recruitment (for species present in the stand or given in a seed rain input).}
#'   \item{Prepares the input of function \code{\link{growth}} for the next annual time step.}
#'   \item{Store forest status, management arguments, and summaries.}
#' }
#' 
#' To enable forest management, the user needs to provide a function that implements it, which is passed to \code{fordyn} via its argument \code{management_function}. Such function should have  the following arguments:
#'   \itemize{
#'     \item{\code{"x"}: the \code{\link{forest}} object representing the stand to be managed.}
#'     \item{\code{"args"}: a list of parameters regulating the behavior of the management function.} 
#'     \item{\code{"verbose"}: a logical flag to enable console output during the execution of the management function.}
#'   }
#' and return a list with the following elements:
#'   \itemize{
#'     \item{\code{"action"}: A string identifying the action performed (e.g. "thinning").}
#'     \item{\code{"N_tree_cut"}: A vector with the density of trees removed.}
#'     \item{\code{"Cover_shrub_cut"}: A vector with the cover of shrubs removed.} 
#'     \item{\code{"planted_forest"}: An object of class \code{\link{forest}} with the new plant cohorts resulting from tree/shrub planting.}
#'     \item{\code{"management_args"}: A list of management arguments to be used in the next call to the management function.}
#'   }
#' 
#' An example of management function is provided in \code{\link{defaultManagementFunction}}.
#' 
#' @return A list of class \code{fordyn} with the following elements:
#' \itemize{
#'   \item{\code{"StandSummary"}: A data frame with stand-level summaries (tree basal area, tree density, shrub cover, etc.) at the beginning of the simulation and after each simulated year.}
#'   \item{\code{"SpeciesSummary"}: A data frame with species-level summaries (tree basal area, tree density, shrub cover, etc.) at the beginning of the simulation and after each simulated year.}
#'   \item{\code{"CohortSummary"}: A data frame with cohort-level summaries (tree basal area, tree density, shrub cover, etc.) at the beginning of the simulation and after each simulated year.}
#'   \item{\code{"TreeTable"}: A data frame with tree-cohort data (species, density, diameter, height, etc.) at the beginning of the simulation (if any) and after each simulated year.}
#'   \item{\code{"DeadTreeTable"}: A data frame with dead tree-cohort data (species, density, diameter, height, etc.) at the beginning of the simulation and after each simulated year.}
#'   \item{\code{"CutTreeTable"}: A data frame with cut tree data (species, density, diameter, height, etc.) after each simulated year.}
#'   \item{\code{"ShrubTable"}: A data frame with shrub-cohort data (species, density, cover, height, etc.) at the beginning of the simulation and after each simulated year.}
#'   \item{\code{"DeadShrubTable"}: A data frame with dead shrub-cohort data (species, density, cover, height, etc.) at the beginning of the simulation (if any) and after each simulated year.}
#'   \item{\code{"CutShrubTable"}: A data frame with cut shrub data (species, density, cover, height, etc.) after each simulated year.}
#'   \item{\code{"ForestStructures"}: A list with the \code{\link{forest}} object of the stand at the beginning of the simulation and after each simulated year.}
#'   \item{\code{"GrowthResults"}: A list with the results of calling function \code{\link{growth}} for each simulated year.}
#'   \item{\code{"ManagementArgs"}: A list of management arguments to be used in another call to \code{fordyn}.}
#'   \item{\code{"NextInputObject"}: An object of class \code{growthInput} to be used in a subsequent simulation.}
#'   \item{\code{"NextForestObject"}: An object of class \code{forest} to be used in a subsequent simulation.}
#' }
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso \code{\link{growth}}, \code{\link{regeneration}}, \code{\link{plot.growth}}, \code{\link{defaultManagementFunction}}
#' 
#' @references 
#' De Cáceres M, Molowny-Horas R, Cabon A, Martínez-Vilalta J, Mencuccini M, García-Valdés R, Nadal-Sala D, Sabaté S, 
#' Martin-StPaul N, Morin X, D'Adamo F, Batllori E, Améztegui A (2023) MEDFATE 2.9.3: A trait-enabled model to simulate 
#' Mediterranean forest function and dynamics at regional scales. 
#' Geoscientific Model Development 16: 3165-3201 (https://doi.org/10.5194/gmd-16-3165-2023).
#' 
#' @examples 
#' \donttest{
#' #Load example daily meteorological data
#' data(examplemeteo)
#' #Prepare a two-year meteorological data with half precipitation during 
#' #the second year
#' meteo2001 <- examplemeteo
#' meteo2002 <- examplemeteo
#' meteo2002$Precipitation <- meteo2002$Precipitation/2
#' meteo2002$dates <- seq(as.Date("2002-01-01"), 
#'                            as.Date("2002-12-31"), by="day")
#' meteo_01_02 <- rbind(meteo2001, meteo2002)
#' 
#' #Load example plot plant data
#' data(exampleforest)
#' 
#' #Default species parameterization
#' data(SpParamsMED)
#' 
#' #Initialize control parameters
#' control <- defaultControl("Granier")
#' 
#' #Define soil with default soil params (4 layers)
#' examplesoil <- defaultSoilParams(4)
#' 
#' #Call simulation function
#' fd<-fordyn(exampleforest, examplesoil, 
#'            SpParamsMED, meteo_01_02, control,
#'            latitude = 41.82592, elevation = 100)
#' 
#' #Stand-level summaries
#' fd$StandSummary
#' 
#' #Tree table by annual steps
#' fd$TreeTable
#' 
#' #Dead tree table by annual steps
#' fd$DeadTreeTable
#' }
#' 
fordyn<-function(forest, soil, SpParams,
                 meteo, control,
                 latitude , elevation = NA, slope = NA, aspect = NA,
                 CO2ByYear = numeric(0),
                 management_function = NULL, management_args = NULL) {
  
  # Check input
  if(!inherits(forest, "forest") && !inherits(forest, "fordyn")) stop("Object `forest` should be of class `forest` or `fordyn`")
  if(!inherits(meteo, "data.frame")) stop("Object `meteo` should be of class `data.frame`")
  if(!inherits(SpParams, "data.frame")) stop("Object `SpParams` should be of class `data.frame`")
  if(!inherits(control, "list")) stop("Object `control` should be of class `list`")
  
  # Modify control parameters
  verboseDyn <- control$verbose
  control$verbose <- FALSE
  control$subdailyResults <- FALSE
  
  control$recruitmentMode <- match.arg(control$recruitmentMode, c("stochastic", "deterministic","annual/stochastic", "annual/deterministic", "daily/stochastic", "daily/deterministic"))
  
  # Back-compatibility of control parameters
  if(!("keepCohortsWithObsID" %in% names(control))) control$keepCohortsWithObsID = FALSE
  if(!("removeEmptyCohorts" %in% names(control))) control$removeEmptyCohorts = TRUE
  if(!("dynamicallyMergeCohorts" %in% names(control))) control$dynamicallyMergeCohorts = TRUE
  
  if("dates" %in% names(meteo)) {
    dates <- as.Date(meteo$dates)
  } else {
    dates <- as.Date(row.names(meteo))
  }
  years <- as.numeric(format(dates, "%Y"))
  months <- as.numeric(format(dates, "%m"))
  yearsUnique <- unique(years)
  nYears <- length(yearsUnique)
  growthResults <- vector("list", nYears)
  names(growthResults) <- paste0("Step_", 1:nYears)
  forestStructures <- vector("list", nYears+1)
  names(forestStructures) <- c("Initial", paste0("Step_", 1:nYears))
  
  
  #Initialization
  if(inherits(forest, "fordyn")) {
    if(verboseDyn) cat(paste0("Initialisation from previous run\n"))
    xi <- forest$NextInputObject
    forest <- forest$NextForestObject
    #Check number of cohorts of both objects
    if(nrow(xi$above) != (nrow(forest$treeData) + nrow(forest$shrubData))) stop("growthInput and forest objects do not match!") 
  } else {
    if(is.numeric(forest$treeData$Species)) {
      forest$treeData$Species <- .speciesCharacterParameterFromSpIndex(forest$treeData$Species, SpParams, "Name")
    }
    if(is.numeric(forest$shrubData$Species)) {
      forest$shrubData$Species <- .speciesCharacterParameterFromSpIndex(forest$shrubData$Species, SpParams, "Name")
    }
    
    #Ensure columns relevant for fordyn (in case there are other)
    forest <- .checkForestColumns(forest)

    #Fill missing root params
    if(control$fillMissingRootParams) {
      treeSPZ95 <- species_parameter(forest$treeData$Species, SpParams, "Z95")
      treeSPZ50 <- species_parameter(forest$treeData$Species, SpParams, "Z50")
      treeSPZ50[is.na(treeSPZ50)] <- exp(log(treeSPZ95[is.na(treeSPZ50)])/1.4)
      shrubSPZ50 <- species_parameter(forest$shrubData$Species, SpParams, "Z50")
      shrubSPZ95 <- species_parameter(forest$shrubData$Species, SpParams, "Z95")
      shrubSPZ50[is.na(shrubSPZ50)] <- exp(log(shrubSPZ95[is.na(shrubSPZ50)])/1.4)
      forest$treeData$Z50[is.na(forest$treeData$Z50)] <- treeSPZ50[is.na(forest$treeData$Z50)]
      forest$treeData$Z95[is.na(forest$treeData$Z95)] <- treeSPZ95[is.na(forest$treeData$Z95)]
      forest$shrubData$Z50[is.na(forest$shrubData$Z50)] <- shrubSPZ50[is.na(forest$shrubData$Z50)]
      forest$shrubData$Z95[is.na(forest$shrubData$Z95)] <- shrubSPZ95[is.na(forest$shrubData$Z95)]
    }
    xi <- growthInput(forest, soil, SpParams, control)
  }
  forestStructures[[1]] <- forest

  #initial tree/shrub tables
  treeTable <- .createTreeTable(0, NA, xi)
  shrubTable <- .createShrubTable(0, NA, xi)
  deadTreeTable <- .createDeadTreeTable(0, NA, xi)
  deadShrubTable <- .createDeadShrubTable(0, NA, xi)
  cutTreeTable <- treeTable[numeric(),,drop = FALSE]
  cutShrubTable <- shrubTable[numeric(),,drop = FALSE]
  
  #initial summaries
  cohortSummary <-.summarizeCohorts(0, 
                                    treeTable, shrubTable,
                                    deadTreeTable, deadShrubTable,
                                    cutTreeTable, cutShrubTable)
  speciesSummary<-.summarizeSpecies(0,cohortSummary, xi, SpParams)
  standSummary<-.summarizeStand(0,cohortSummary, xi)

  
  #Simulations
  for(iYear in 1:nYears) {
    year <- yearsUnique[iYear]
    if(verboseDyn) cat(paste0("Simulating year ", year, " (", iYear,"/", nYears,"): "))
    meteoYear <- meteo[years==year,]
    monthsYear <- months[years==year]
    # 1.1 Calls growth model
    if(verboseDyn) cat(paste0(" (a) Growth/mortality"))
    Gi <- growth(xi, meteoYear, latitude = latitude, 
                elevation = elevation, slope = slope, aspect = aspect,
                CO2ByYear = CO2ByYear)

    # 1.2 Store growth results
    growthResults[[iYear]] <- Gi
    
    # 1.3 Retrieve modified growth output
    xo <- Gi$growthOutput

    # 2.2 Update dead tree/shrub tables
    deadTreeTableYear <- .createDeadTreeTable(iYear, year, xo)
    deadShrubTableYear <- .createDeadShrubTable(iYear, year, xo)
    
    # 2.2 Update forest structural variables
    ctype <- .cohortType(row.names(xo$cohorts))
    isTree <- (ctype=="tree")
    isShrub <- (ctype=="shrub")
    forest$treeData$N  <- xo$above$N[isTree]
    forest$treeData$DBH  <- xo$above$DBH[isTree]
    forest$treeData$Height  <- xo$above$H[isTree]
    forest$treeData$Z50  <- xo$below$Z50[isTree]
    forest$treeData$Z95  <- xo$below$Z95[isTree]
    forest$treeData$Z100  <- xo$below$Z100[isTree]
    if(control$shrubDynamics) {
      forest$shrubData$Cover  <- xo$above$Cover[isShrub]
      forest$shrubData$Height  <- xo$above$H[isShrub]
      forest$shrubData$Z50  <- xo$below$Z50[isShrub]
      forest$shrubData$Z95  <- xo$below$Z95[isShrub]
      forest$shrubData$Z100  <- xo$below$Z100[isShrub]
    }
    
    # 2.3 Call management function if required
    cutTreeTableYear <- NULL
    cutShrubTableYear <- NULL
    management_result <- NULL
    planted_forest <- emptyforest(addcolumns = c("Z100", "Age", "ObsID"))
    if(!is.null(management_function)) {
      management_result <- do.call(management_function, list(x = forest, args= management_args, verbose = FALSE))
      if(verboseDyn) cat(paste0(" & management [", management_result$action,"]"))
      # Update forest and xo objects
      forest$treeData$N <- pmax(0,forest$treeData$N - management_result$N_tree_cut)
      xo$above$N[isTree] <- forest$treeData$N
      forest$shrubData$Cover <- pmax(0,forest$shrubData$Cover - management_result$Cover_shrub_cut)
      xo$above$Cover[isShrub] <- forest$shrubData$Cover
      # Update cut tables
      cutTreeTableYear <- .createCutTreeTable(iYear, year, xo, management_result$N_tree_cut)
      cutShrubTableYear <- .createCutShrubTable(iYear, year, xo, management_result$Cover_shrub_cut)
      # Retrieve plantation information
      planted_forest <- management_result$planted_forest
      ntree_planted <- nrow(planted_forest$treeData)
      if(!("Z100" %in% names(planted_forest$treeData))) planted_forest$treeData$Z100 <- as.numeric(rep(NA, ntree_planted))
      if(!("Age" %in% names(planted_forest$treeData))) planted_forest$treeData$Age <- as.numeric(rep(NA, ntree_planted))
      if(!("ObsID" %in% names(planted_forest$treeData))) planted_forest$treeData$ObsID <- as.character(rep(NA, ntree_planted))
      if(ntree_planted>0) {
        for(i in 1:ntree_planted) {
          if(length(grep("[a-z]", planted_forest$treeData$Species[i]))==0) planted_forest$treeData$Species[i] <- SpParams$Name[SpParams$SpIndex == planted_forest$treeData$Species[i]]
          planted_forest$treeData$Z95[i] <- species_parameter(planted_forest$treeData$Species[i], SpParams,"Z95")
          planted_forest$treeData$Z50[i] <- exp(log(planted_forest$treeData$Z95[i])/1.4)
        }
      }
      nshrub_planted <- nrow(planted_forest$shrubData)
      if(!("Z100" %in% names(planted_forest$shrubData))) planted_forest$shrubData$Z100 <- as.numeric(rep(NA, nshrub_planted))
      if(!("Age" %in% names(planted_forest$shrubData))) planted_forest$shrubData$Age <- as.numeric(rep(NA, nshrub_planted))
      if(!("ObsID" %in% names(planted_forest$shrubData))) planted_forest$shrubData$ObsID <- as.character(rep(NA, nshrub_planted))
      if(nshrub_planted>0) {
        for(i in 1:nrow(planted_forest$shrubData)) {
          if(length(grep("[a-z]", planted_forest$shrubData$Species[i]))==0) planted_forest$shrubData$Species[i] <- SpParams$Name[SpParams$SpIndex == planted_forest$shrubData$Species[i]]
          planted_forest$shrubData$Z50[i] <- species_parameter(planted_forest$shrubData$Species[i], SpParams,"Z95")
          planted_forest$shrubData$Z95[i] <- exp(log(planted_forest$shrubData$Z95[i])/1.4)
          if(is.na(planted_forest$shrubData$Z50[i])) planted_forest$shrubData$Z50[i] <- 100
          if(is.na(planted_forest$shrubData$Z95[i])) planted_forest$shrubData$Z95[i] <- 300
        }
      }
      
      # Store new management arguments (may have changed)
      management_args <- management_result$management_args
    } 
    
    # 3. Simulate species seed recruitment and resprouting
    if(verboseDyn && (control$allowSeedBankDynamics || control$allowRecruitment || control$allowResprouting)) 
      cat(paste0(", (b) Regeneration"))
    if(control$allowSeedBankDynamics) {
      # Reduce seed bank according to longevity
      forest$seedBank <- regeneration_seedmortality(forest$seedBank, SpParams)
      # Seed local production
      seed_local <- regeneration_seedproduction(forest, SpParams, control)
      # Seed rain from control
      seed_rain <- control$seedRain
      if(!is.null(seed_rain)) seed <- unique(c(seed_local, seed_rain)) 
      else seed <- seed_local
      # Refill seed bank with new seeds
      forest$seedBank <- regeneration_seedrefill(forest$seedBank, seed)
    }
    if(control$allowRecruitment) {
      if(control$recruitmentMode %in% c("daily/deterministic", "daily/stochastic")) {
        recr_forest <- regeneration_recruitment_daily(forest, SpParams, control, 
                                                      Gi, verbose = FALSE)
      } else {
        monthlyMinTemp <- tapply(Gi$weather$MinTemperature, monthsYear, FUN="mean", na.rm=TRUE)
        monthlyMaxTemp <- tapply(Gi$weather$MaxTemperature, monthsYear, FUN="mean", na.rm=TRUE)
        monthlyTemp <- 0.606*monthlyMaxTemp + 0.394*monthlyMinTemp
        minMonthTemp <- min(monthlyTemp, na.rm=TRUE)
        moistureIndex <- sum(Gi$WaterBalance$Precipitation, na.rm=TRUE)/sum(Gi$WaterBalance$PET, na.rm=TRUE)
        recr_forest <- regeneration_recruitment(forest, SpParams, control, 
                                                minMonthTemp, moistureIndex, verbose = FALSE)
      }
    } else {
      recr_forest <- emptyforest(addcolumns = c("Z100", "Age", "ObsID"))
    }
    # 3.2. Simulate species resprouting
    if(control$allowResprouting) {
      resp_forest <- regeneration_resprouting(forest, xo$internalMortality, SpParams, control,
                                              management_result)
    } else {
      resp_forest <- emptyforest(addcolumns = c("Z100", "Age", "ObsID"))
    }
    
    # 4. Update inputs for next year 
    nyf <- .nextYearForest(forest, xo, SpParams, control, 
                           planted_forest, recr_forest, resp_forest)

    forest <- nyf$forest
    if(verboseDyn) {
      cat(paste0(" nT = ", nrow(forest$treeData), " nS = ", nrow(forest$shrubData)))
    }
    xi <- nyf$xi

    # 6.1 Store current forest state (after recruitment/resprouting)
    forestStructures[[iYear+1]] <- forest
    
    # 6.2 Process summaries (after recruitment/resprouting)
    treeTableYear <- .createTreeTable(iYear, year, xi)
    shrubTableYear <- .createShrubTable(iYear, year, xi)
    cohSumYear <- .summarizeCohorts(iYear,
                                   treeTableYear, shrubTableYear,
                                   deadTreeTableYear, deadShrubTableYear,
                                   cutTreeTableYear, cutShrubTableYear)
    speciesSummary <- rbind(speciesSummary,  .summarizeSpecies(iYear,cohSumYear, xi, SpParams))
    standSummary <- rbind(standSummary,  .summarizeStand(iYear,cohSumYear, xi))
    cohortSummary <- rbind(cohortSummary, cohSumYear)
    
    # 6.3 Update tree/shrub tables (after recruitment)
    treeTable <- rbind(treeTable, treeTableYear)
    shrubTable <- rbind(shrubTable, shrubTableYear)
    deadTreeTable <- rbind(deadTreeTable, deadTreeTableYear)
    deadShrubTable <- rbind(deadShrubTable, deadShrubTableYear)
    if(!is.null(cutTreeTableYear)) cutTreeTable <- rbind(cutTreeTable, cutTreeTableYear)
    if(!is.null(cutShrubTableYear)) cutShrubTable <- rbind(cutShrubTable, cutShrubTableYear)
    
    if(verboseDyn) cat(paste0("\n"))
  }
  res <- list(
    "StandSummary" = standSummary,
    "SpeciesSummary" = speciesSummary,
    "CohortSummary" = cohortSummary,
    "TreeTable" = treeTable,
    "DeadTreeTable" = deadTreeTable,
    "CutTreeTable" = cutTreeTable,
    "ShrubTable" = shrubTable,
    "DeadShrubTable" = deadShrubTable,
    "CutShrubTable" = cutShrubTable,
    "ForestStructures" = forestStructures,
    "GrowthResults" = growthResults,
    "ManagementArgs" = management_args,
    "NextInputObject" = xi,
    "NextForestObject" = forest)
  class(res)<-c("fordyn", "list")
  return(res)
}

.checkForestColumns <-function(forest) {
  ntree <- nrow(forest$treeData)
  if(!("Z100" %in% names(forest$treeData))) forest$treeData$Z100 <- as.numeric(rep(NA, ntree))
  if(!("Age" %in% names(forest$treeData))) forest$treeData$Age <- as.numeric(rep(NA, ntree))
  if(!("ObsID" %in% names(forest$treeData))) forest$treeData$ObsID <- as.character(rep(NA, ntree))
  forest$treeData <- forest$treeData[,c("Species", "N", "DBH", "Height", "Z50", "Z95","Z100", "Age", "ObsID")]
  nshrub <- nrow(forest$shrubData)
  if(!("Z100" %in% names(forest$shrubData))) forest$shrubData$Z100 <- as.numeric(rep(NA, nshrub))
  if(!("Age" %in% names(forest$shrubData))) forest$shrubData$Age <- as.numeric(rep(NA, nshrub))
  if(!("ObsID" %in% names(forest$shrubData))) forest$shrubData$ObsID <- as.character(rep(NA, nshrub))
  forest$shrubData <- forest$shrubData[,c("Species", "Cover", "Height", "Z50", "Z95","Z100", "Age", "ObsID")]
  return(forest)
}

.ageSnagCohorts<-function(xo) {
  oldSnagData <- xo$internalSnags
  if(nrow(oldSnagData)>0) {
    oldSnagData$DeathAge <- oldSnagData$DeathAge + 1
  }
  newSnagData <- data.frame(Species = xo$cohorts$Name,
                            DBH = xo$above$DBH,
                            Height = xo$above$H,
                            DeathAge = rep(1, nrow(xo$above)),
                            SmallBranches = xo$internalMortality$Snag_smallbranches,
                            LargeWood = xo$internalMortality$Snag_largewood)
  mergedSnagData <- rbind(oldSnagData, newSnagData)
  row.names(mergedSnagData) <- NULL
  return(mergedSnagData)
}

# TO BE IMPROVED!
.snagFall<-function(snagData, litterData) {
  if(nrow(snagData)>0) {
    for(s in 1:nrow(snagData)) {
      # Determine branch fall and large wood fall
      speciesSnag <- snagData$Species[s]
      dbhSnag <- snagData$DBH[s]
      ageSnag <- snagData$DeathAge[s]
      smallBranchFallAmount <- 0.0
      largeWoodFallAmount <- 0.0
      decayClass <- 1 # Class 1: Standing dead tree with most of its branches intact
      if(ageSnag >= 4  && ageSnag < 10) { # Class 2: Dead tree with  < 50% branch left and loose bark
        decayClass <- 2
        if(ageSnag == 4) smallBranchFallAmount <- snagData$SmallBranches[s]/2 # 50% of branches fall at age 5
      } else if(ageSnag >= 10 && ageSnag < 20) { # Class 3 : dead tree without branches or bark
        decayClass <- 3
        if(ageSnag == 10) smallBranchFallAmount <- snagData$SmallBranches[s] # All branches fall at age 10  
      } else if(ageSnag >= 20) { # Class 4/5: Broken stem
        decayClass <- 4
        if(ageSnag == 20) largeWoodFallAmount <- snagData$LargeWood[s]/2 # 50% of large wood falls
      } else if(ageSnag >= 30) {
        decayClass <- 5
      }
      if(!is.na(dbhSnag)) {
        p_fall<- decomposition_snagFallProbability(DBH = dbhSnag, decayClass = decayClass)
      } else {
        p_fall <- 0.5
      }
      # To prevent infinite accumulation of snag cohorts
      if(ageSnag > 50) p_fall <- 1.0
      if(runif(1) < p_fall) { # If falls, all remaining wood goes to the ground
        largeWoodFallAmount <- snagData$LargeWood[s]
        smallBranchFallAmount <- snagData$SmallBranches[s]
      }
      # Remove branch fall and large wood fall from snag data
      snagData$SmallBranches[s] = snagData$SmallBranches[s] - smallBranchFallAmount
      snagData$LargeWood[s] = snagData$LargeWood[s] - largeWoodFallAmount
      # Add branch fall and large wood fall to litter data
      if(speciesSnag %in% litterData$Species) {
        row <- which(litterData$Species==speciesSnag)
        litterData$SmallBranches[row] = litterData$SmallBranches[row] + smallBranchFallAmount
        litterData$LargeWood[row] = litterData$LargeWood[row] + largeWoodFallAmount 
      } else { ## Create new row
        litterData <- rbind(litterData,
                            data.frame(Species = speciesSnag, Leaves = 0, Twigs = 0, 
                                       SmallBranches = smallBranchFallAmount,
                                       LargeWood = largeWoodFallAmount, 
                                       CoarseRoots = 0))
      }
    }
    # Remove snags that do not have remaining mass
    snagData <- snagData[snagData$SmallBranches>0 | snagData$LargeWood>0, , drop = FALSE]
  }
  return(list(snagData = snagData, litterData = litterData))
}
.nextYearForest<-function(forest, xo, SpParams, control,
                          planted_forest = emptyforest(addcolumns = c("Z100", "Age", "ObsID")),
                          recr_forest = emptyforest(addcolumns = c("Z100", "Age", "ObsID")),
                          resp_forest = emptyforest(addcolumns = c("Z100", "Age", "ObsID"))) {
  
  #Check completeness of columns in forest objects
  forest <- .checkForestColumns(forest)
  planted_forest <- .checkForestColumns(planted_forest)
  recr_forest <- .checkForestColumns(recr_forest)
  resp_forest <- .checkForestColumns(resp_forest)
  
  #Determine offsets
  treeOffset <- 0
  shrubOffset <- 0
  coh_names <- row.names(xo$cohorts)
  ctype <- .cohortType(coh_names)
  isTree <- ctype=="tree"
  isShrub <- ctype=="shrub"
  if(length(coh_names)>0) {
    coh_numbers <- sapply(strsplit(coh_names, "_"), function(x) {
      as.numeric(substr(x[[1]], 2, nchar(x[[1]])))
    })
    if(sum(isTree)>0) treeOffset <- max(coh_numbers[isTree])
    if(sum(isShrub)>0) shrubOffset <- max(coh_numbers[isShrub])
  } 
  
  # 1. Remove empty cohorts if required
  emptyTrees <- rep(FALSE, nrow(forest$treeData))
  emptyShrubs <- rep(FALSE, nrow(forest$shrubData))
  # print(forest)
  if(control$removeEmptyCohorts) {
    emptyTrees <- (forest$treeData$N < control$minimumTreeCohortDensity)
    if(control$keepCohortsWithObsID) { # Exclude from removal if cohort has non-missing ObsID
      if("ObsID" %in% names(forest$treeData)) {
        emptyTrees[!is.na(forest$treeData)] <- FALSE
      }
    }
    if(control$shrubDynamics) {
      emptyShrubs <- (forest$shrubData$Cover < control$minimumShrubCohortCover)
      if(control$keepCohortsWithObsID) { # Exclude from removal if cohort has non-missing ObsID
        if("ObsID" %in% names(forest$shrubData)) {
          emptyShrubs[!is.na(forest$shrubData)] <- FALSE
        }
      }
    }
  }
  emptyCohorts <- c(emptyTrees, emptyShrubs)
  
  # print(emptyTrees)
  # print(emptyShrubs)
  if(sum(emptyCohorts)>0) {
    forest$treeData <- forest$treeData[!emptyTrees,, drop=FALSE] 
    forest$shrubData <- forest$shrubData[!emptyShrubs,, drop=FALSE] 
    # Remove from growth input object
    xo$cohorts <- xo$cohorts[!emptyCohorts, , drop=FALSE] 
    xo$above <- xo$above[!emptyCohorts, , drop=FALSE] 
    xo$below <- xo$below[!emptyCohorts, , drop=FALSE] 
    xo$belowLayers$V <- xo$belowLayers$V[!emptyCohorts, , drop=FALSE] 
    xo$belowLayers$L <- xo$belowLayers$L[!emptyCohorts, , drop=FALSE] 
    if(control$transpirationMode!="Granier") {
      xo$belowLayers$VGrhizo_kmax <- xo$belowLayers$VGrhizo_kmax[!emptyCohorts, , drop=FALSE]
      xo$belowLayers$VCroot_kmax <- xo$belowLayers$VCroot_kmax[!emptyCohorts, , drop=FALSE]
      xo$belowLayers$RhizoPsi <- xo$belowLayers$RhizoPsi[!emptyCohorts, , drop=FALSE]
    }
    xo$belowLayers$Wpool <- xo$belowLayers$Wpool[!emptyCohorts, , drop=FALSE]
    xo$paramsPhenology <- xo$paramsPhenology[!emptyCohorts,, drop=FALSE]
    xo$paramsAnatomy <- xo$paramsAnatomy[!emptyCohorts,, drop=FALSE]
    xo$paramsInterception <- xo$paramsInterception[!emptyCohorts,, drop=FALSE]
    xo$paramsTranspiration <- xo$paramsTranspiration[!emptyCohorts,, drop=FALSE]
    xo$paramsWaterStorage <- xo$paramsWaterStorage[!emptyCohorts,, drop=FALSE]
    xo$paramsGrowth <- xo$paramsGrowth[!emptyCohorts,, drop=FALSE]
    xo$paramsAllometries <- xo$paramsAllometries[!emptyCohorts,, drop=FALSE]
    xo$internalPhenology <- xo$internalPhenology[!emptyCohorts,, drop=FALSE]
    xo$internalWater <- xo$internalWater[!emptyCohorts,, drop=FALSE]
    xo$internalCarbon <- xo$internalCarbon[!emptyCohorts,, drop=FALSE]
    xo$internalAllocation <- xo$internalAllocation[!emptyCohorts,, drop=FALSE]
    xo$internalMortality <- xo$internalMortality[!emptyCohorts,, drop=FALSE]
  }
  
  
  # 2.1 Generate above-ground data
  #planted
  planted_above <- forest2aboveground(planted_forest, SpParams, NA, TRUE)
  row.names(planted_above) <- plant_ID(planted_forest, SpParams, treeOffset, shrubOffset)
  treeOffset <- treeOffset + nrow(planted_forest$treeData)
  shrubOffset <- shrubOffset + nrow(planted_forest$shrubData)
  #recruitment
  recr_above <- forest2aboveground(recr_forest, SpParams, NA, TRUE)
  row.names(recr_above) <- plant_ID(recr_forest, SpParams, treeOffset, shrubOffset)
  treeOffset <- treeOffset + nrow(recr_forest$treeData)
  shrubOffset <- shrubOffset + nrow(recr_forest$shrubData)
  #resprouting
  resp_above <- forest2aboveground(resp_forest, SpParams, NA, TRUE)
  row.names(resp_above) <- plant_ID(resp_forest, SpParams, treeOffset, shrubOffset)
  treeOffset <- treeOffset + nrow(resp_forest$treeData)
  shrubOffset <- shrubOffset + nrow(resp_forest$shrubData)
  #surviving
  forest_above <- forest2aboveground(forest, SpParams, NA, TRUE)
  row.names(forest_above) <- row.names(xo$cohorts)
  forest_above$LAI_live[!is.na(forest_above$DBH)] <- xo$above$LAI_live[!is.na(forest_above$DBH)]
  forest_above$LAI_expanded[!is.na(forest_above$DBH)] <- xo$above$LAI_expanded[!is.na(forest_above$DBH)]
  forest_above$LAI_nocomp[!is.na(forest_above$DBH)] <- xo$above$LAI_nocomp[!is.na(forest_above$DBH)]
  if(control$shrubDynamics) {
    forest_above$LAI_live[is.na(forest_above$DBH)] <- xo$above$LAI_live[is.na(forest_above$DBH)]
    forest_above$LAI_expanded[is.na(forest_above$DBH)] <- xo$above$LAI_expanded[is.na(forest_above$DBH)]
    forest_above$LAI_nocomp[is.na(forest_above$DBH)] <- xo$above$LAI_nocomp[is.na(forest_above$DBH)]
  }

  # 2.2 Merge aboveground data (first trees)
  above_all <- rbind(forest_above[!is.na(forest_above$DBH),, drop = FALSE], 
                     planted_above[!is.na(planted_above$DBH),, drop = FALSE],
                     recr_above[!is.na(recr_above$DBH),, drop = FALSE],
                     resp_above[!is.na(resp_above$DBH),, drop = FALSE],
                     forest_above[is.na(forest_above$DBH),, drop = FALSE],
                     planted_above[is.na(planted_above$DBH),, drop = FALSE],
                     recr_above[is.na(recr_above$DBH),, drop = FALSE],
                     resp_above[is.na(resp_above$DBH),, drop = FALSE])
  
  # 3. Logical vector for replacement
  repl_vec <- c(rep(TRUE, nrow(forest$treeData)),
                rep(FALSE, nrow(planted_forest$treeData)),
                rep(FALSE, nrow(recr_forest$treeData)),
                rep(FALSE, nrow(resp_forest$treeData)),
                rep(control$shrubDynamics, nrow(forest$shrubData)),
                rep(FALSE, nrow(planted_forest$shrubData)),
                rep(FALSE, nrow(recr_forest$shrubData)),
                rep(FALSE, nrow(resp_forest$shrubData)))
  sel_vec <- c(rep(TRUE, nrow(forest$treeData)),
               rep(control$shrubDynamics, nrow(forest$shrubData)))
  
  
  # 4.1 Increase forest age for existing cohorts
  forest$treeData$Age <- forest$treeData$Age + 1
  forest$shrubData$Age <- forest$shrubData$Age + 1
  
  # 4.2 Merge cohorts in forest object
  forest$treeData <- rbind(forest$treeData, planted_forest$treeData, recr_forest$treeData, resp_forest$treeData)
  row.names(forest$treeData) <- NULL
  forest$shrubData <- rbind(forest$shrubData, planted_forest$shrubData, recr_forest$shrubData, resp_forest$shrubData)
  row.names(forest$shrubData) <- NULL

  # 4.3 Copy seedling bank from recr_forest
  if(!is.null(recr_forest$seedlingBank)) {
    forest$seedlingBank <- recr_forest$seedlingBank
  }
  
  # 5.1 Prepare growth input for next year
  FCCSprops = fuel_FCCS(forest, SpParams);
  treeZ50 <- forest$treeData$Z50
  treeZ95 <- forest$treeData$Z95
  treeZ100 <- rep(NA, nrow(forest$treeData))
  if("Z100" %in% names(forest$treeData)) treeZ100 <- forest$treeData$Z100
  shrubZ50 <- forest$shrubData$Z50
  shrubZ95 <- forest$shrubData$Z95
  shrubZ100 <- rep(NA, nrow(forest$shrubData))
  if("Z100" %in% names(forest$shrubData)) shrubZ100 <- forest$shrubData$Z100
  herbZ50 <- numeric(0)
  herbZ95 <- numeric(0)
  herbZ100 <- numeric(0)
  if("herbData" %in% names(forest)) {
    herbZ50 <- forest$herbData$Z50
    herbZ95 <- forest$herbData$Z95
    herbZ100 <- rep(NA, nrow(forest$herbData))
    if("Z100" %in% names(forest$herbData)) herbZ100 <- forest$herbData$Z100
  }
  
  # Add new snag cohorts from mortality and increment snag age
  pooled_snags <- .ageSnagCohorts(xo)
  # Process snag fall and add new litter
  snag_fall <- .snagFall(pooled_snags, xo$internalLitter)
  forest$snagData <- snag_fall$snagData
  forest$litterData <- snag_fall$litterData
  # Add SOC pools to forest
  forest$SOCData <- xo$internalSOC
  
  
  xi <- .growthInput(above = above_all, 
                     Z50 = c(treeZ50, shrubZ50, herbZ50),
                     Z95 = c(treeZ95, shrubZ95, herbZ95),
                     Z100 = c(treeZ100, shrubZ100, herbZ100),
                     xo$soil, forest$snagData, forest$litterData, forest$SOCData, FCCSprops, 
                     SpParams, control)
  if("herbLAI" %in% names(xo)) xi$herbLAI <- xo$herbLAI
  if("herbLAImax" %in% names(xo)) xi$herbLAImax <- xo$herbLAImax
  

  
  # 5.2 Replace previous state for surviving cohorts (except age)
  xi$cohorts[repl_vec,] <- xo$cohorts[sel_vec,, drop=FALSE]
  xi$above[repl_vec, (names(xi$above)!="Age")] <- xo$above[sel_vec,(names(xo$above)!="Age"), drop=FALSE]
  xi$below[repl_vec,] <- xo$below[sel_vec,, drop=FALSE]
  xi$belowLayers$V[repl_vec,] <- xo$belowLayers$V[sel_vec,, drop=FALSE]
  xi$belowLayers$L[repl_vec,] <- xo$belowLayers$L[sel_vec,, drop=FALSE]
  if(control$transpirationMode!="Granier") {
    xi$belowLayers$VGrhizo_kmax[repl_vec,] <- xo$belowLayers$VGrhizo_kmax[sel_vec,, drop=FALSE]
    xi$belowLayers$VCroot_kmax[repl_vec,] <- xo$belowLayers$VCroot_kmax[sel_vec,, drop=FALSE]
    xi$belowLayers$RhizoPsi[repl_vec,] <- xo$belowLayers$RhizoPsi[sel_vec,, drop=FALSE]
  }
  xi$belowLayers$Wpool[repl_vec,] <- xo$belowLayers$Wpool[sel_vec,, drop=FALSE]
  xi$paramsPhenology[repl_vec,] <- xo$paramsPhenology[sel_vec,, drop=FALSE]
  xi$paramsAnatomy[repl_vec,] <- xo$paramsAnatomy[sel_vec,, drop=FALSE]
  xi$paramsInterception[repl_vec,] <- xo$paramsInterception[sel_vec,, drop=FALSE]
  xi$paramsTranspiration[repl_vec,] <- xo$paramsTranspiration[sel_vec,, drop=FALSE]
  xi$paramsWaterStorage[repl_vec,] <- xo$paramsWaterStorage[sel_vec,, drop=FALSE]
  xi$paramsGrowth[repl_vec,] <- xo$paramsGrowth[sel_vec,, drop=FALSE]
  xi$paramsAllometries[repl_vec,] <- xo$paramsAllometries[sel_vec,, drop=FALSE]
  xi$internalPhenology[repl_vec,] <- xo$internalPhenology[sel_vec,, drop=FALSE]
  xi$internalWater[repl_vec,] <- xo$internalWater[sel_vec,, drop=FALSE]
  xi$internalCarbon[repl_vec,] <- xo$internalCarbon[sel_vec,, drop=FALSE]
  xi$internalAllocation[repl_vec,] <- xo$internalAllocation[sel_vec,, drop=FALSE]
  
  # This causes loss of cohort identity and reinitizalization of vegetation state variables
  # except for cohorts with ObsID when control variable 'keepCohortsWithObsID = TRUE'
  if(control$dynamicallyMergeCohorts) {
    merged_forest <- forest_mergeTrees(forest, byDBHclass = TRUE, keepCohortsWithObsID = control$keepCohortsWithObsID)
    merged_forest <- forest_mergeShrubs(merged_forest, byHeightclass = TRUE, keepCohortsWithObsID = control$keepCohortsWithObsID)
    # Only replace growth input if merging caused a reduction in woody cohorts
    if((nrow(merged_forest$treeData) < nrow(forest$treeData)) || (nrow(merged_forest$shrubData) < nrow(forest$shrubData))) {
      xi_merged <- growthInput(merged_forest, xo$soil, SpParams, control)
      if(control$keepCohortsWithObsID && ("ObsID" %in% names(xi$above))) { # Try to copy values from spared cohorts into new growth input
        # Determine sel_vec for spared cohorts
        sel_vec <- rep(FALSE, nrow(xi$above))
        sel_vec[!is.na(xi$above$ObsID)] <- TRUE
        repl_vec <- rep(FALSE, nrow(xi_merged$above))
        repl_vec[!is.na(xi_merged$above$ObsID)] <- TRUE
        
        # Replace previous state for spared cohorts
        xi_merged$cohorts[repl_vec,] <- xi$cohorts[sel_vec,, drop=FALSE]
        xi_merged$above[repl_vec,] <- xi$above[sel_vec,, drop=FALSE]
        xi_merged$below[repl_vec,] <- xi$below[sel_vec,, drop=FALSE]
        xi_merged$belowLayers$V[repl_vec,] <- xi$belowLayers$V[sel_vec,, drop=FALSE]
        xi_merged$belowLayers$L[repl_vec,] <- xi$belowLayers$L[sel_vec,, drop=FALSE]
        if(control$transpirationMode!="Granier") {
          xi_merged$belowLayers$VGrhizo_kmax[repl_vec,] <- xi$belowLayers$VGrhizo_kmax[sel_vec,, drop=FALSE]
          xi_merged$belowLayers$VCroot_kmax[repl_vec,] <- xi$belowLayers$VCroot_kmax[sel_vec,, drop=FALSE]
          xi_merged$belowLayers$RhizoPsi[repl_vec,] <- xi$belowLayers$RhizoPsi[sel_vec,, drop=FALSE]
        }
        xi_merged$belowLayers$Wpool[repl_vec,] <- xi$belowLayers$Wpool[sel_vec,, drop=FALSE]
        xi_merged$paramsPhenology[repl_vec,] <- xi$paramsPhenology[sel_vec,, drop=FALSE]
        xi_merged$paramsAnatomy[repl_vec,] <- xi$paramsAnatomy[sel_vec,, drop=FALSE]
        xi_merged$paramsInterception[repl_vec,] <- xi$paramsInterception[sel_vec,, drop=FALSE]
        xi_merged$paramsTranspiration[repl_vec,] <- xi$paramsTranspiration[sel_vec,, drop=FALSE]
        xi_merged$paramsWaterStorage[repl_vec,] <- xi$paramsWaterStorage[sel_vec,, drop=FALSE]
        xi_merged$paramsGrowth[repl_vec,] <- xi$paramsGrowth[sel_vec,, drop=FALSE]
        xi_merged$paramsAllometries[repl_vec,] <- xi$paramsAllometries[sel_vec,, drop=FALSE]
        xi_merged$internalPhenology[repl_vec,] <- xi$internalPhenology[sel_vec,, drop=FALSE]
        xi_merged$internalWater[repl_vec,] <- xi$internalWater[sel_vec,, drop=FALSE]
        xi_merged$internalCarbon[repl_vec,] <- xi$internalCarbon[sel_vec,, drop=FALSE]
        xi_merged$internalAllocation[repl_vec,] <- xi$internalAllocation[sel_vec,, drop=FALSE]
      }
      # Replace growthInput and forest by the one after merging
      forest <- merged_forest
      xi <- xi_merged
    }
  }
  return(list(forest = forest, xi = xi))
}

.summarizeCohorts<-function(step, 
                            treeTableYear, shrubTableYear,
                            deadTreeTableYear, deadShrubTableYear,
                            cutTreeTableYear, cutShrubTableYear) {
  treecohnames = unique(c(treeTableYear$Cohort,deadTreeTableYear$Cohort))
  if(!is.null(cutTreeTableYear)) treecohnames = unique(c(treecohnames, cutTreeTableYear$Cohort))
  shrubcohnames = unique(c(shrubTableYear$Cohort,deadShrubTableYear$Cohort))
  if(!is.null(cutShrubTableYear)) shrubcohnames = unique(c(shrubcohnames, cutShrubTableYear$Cohort))
  cohnames = c(treecohnames, shrubcohnames)
  isTree = c(rep(TRUE, length(treecohnames)), rep(FALSE, length(shrubcohnames)))
  cohortSummary = data.frame("Step" = rep(step, length(cohnames)),
                             "Species" = rep(NA, length(cohnames)),
                             "Cohort" = cohnames,
                             "TreeDensityLive" = rep(0, length(cohnames)),
                             "TreeBasalAreaLive"= rep(0, length(cohnames)),
                             "ShrubCoverLive"= rep(0, length(cohnames)),
                             "BasalAreaDead" = rep(0, length(cohnames)),
                             "ShrubCoverDead" = rep(0, length(cohnames)),
                             "BasalAreaCut" = rep(0, length(cohnames)),
                             "ShrubCoverCut" = rep(0, length(cohnames)))
  cohortSummary$ShrubCoverLive[isTree] = NA
  cohortSummary$ShrubCoverDead[isTree] = NA
  cohortSummary$ShrubCoverCut[isTree] = NA
  cohortSummary$TreeDensityLive[!isTree] = NA
  cohortSummary$TreeBasalAreaLive[!isTree] = NA
  cohortSummary$BasalAreaDead[!isTree] = NA
  cohortSummary$BasalAreaCut[!isTree] = NA
  
  ba_live = .treeBasalArea(treeTableYear$N, treeTableYear$DBH)
  for(i in 1:nrow(treeTableYear)) {
    icoh = which(cohortSummary$Cohort==treeTableYear$Cohort[i])
    cohortSummary$Cohort[icoh] = treeTableYear$Cohort[i]
    cohortSummary$Species[icoh] = treeTableYear$Species[i]
    cohortSummary$TreeDensityLive[icoh] = treeTableYear$N[i]
    cohortSummary$TreeBasalAreaLive[icoh] = ba_live[i]
  }
  for(i in 1:nrow(shrubTableYear)) {
    icoh = which(cohortSummary$Cohort==shrubTableYear$Cohort[i])
    cohortSummary$Cohort[icoh] = shrubTableYear$Cohort[i]
    cohortSummary$Species[icoh] = shrubTableYear$Species[i]
    cohortSummary$ShrubCoverLive[icoh] = shrubTableYear$Cover[i]
  }
  ba_dead = .treeBasalArea(deadTreeTableYear$N, deadTreeTableYear$DBH)
  for(i in 1:nrow(deadTreeTableYear)) {
    icoh = which(cohortSummary$Cohort==deadTreeTableYear$Cohort[i])
    cohortSummary$Cohort[icoh] = deadTreeTableYear$Cohort[i]
    cohortSummary$Species[icoh] = deadTreeTableYear$Species[i]
    cohortSummary$BasalAreaDead[icoh] = ba_dead[i]
  }
  for(i in 1:nrow(deadShrubTableYear)) {
    icoh = which(cohortSummary$Cohort==deadShrubTableYear$Cohort[i])
    cohortSummary$Cohort[icoh] = deadShrubTableYear$Cohort[i]
    cohortSummary$Species[icoh] = deadShrubTableYear$Species[i]
    cohortSummary$ShrubCoverDead[icoh] = deadShrubTableYear$Cover[i]
  }
  if(!is.null(cutTreeTableYear)) {
    ba_cut = .treeBasalArea(cutTreeTableYear$N, cutTreeTableYear$DBH)
    for(i in 1:nrow(cutTreeTableYear)) {
      icoh = which(cohortSummary$Cohort==cutTreeTableYear$Cohort[i])
      cohortSummary$Cohort[icoh] = cutTreeTableYear$Cohort[i]
      cohortSummary$Species[icoh] = cutTreeTableYear$Species[i]
      cohortSummary$BasalAreaCut[icoh] = ba_cut[i]
    }
  }
  if(!is.null(cutShrubTableYear)) {
    for(i in 1:nrow(cutShrubTableYear)) {
      icoh = which(cohortSummary$Cohort==cutShrubTableYear$Cohort[i])
      cohortSummary$Cohort[icoh] = cutShrubTableYear$Cohort[i]
      cohortSummary$Species[icoh] = cutShrubTableYear$Species[i]
      cohortSummary$ShrubCoverCut[icoh] = cutShrubTableYear$Cover[i]
    }
  }
  return(cohortSummary)
}
.summarizeSpecies<-function(step, cohSum, x, SpParams) {
  nl_sp = tapply(cohSum$TreeDensityLive, cohSum$Species, sum, na.rm=FALSE)
  bal_sp = tapply(cohSum$TreeBasalAreaLive, cohSum$Species, sum, na.rm=FALSE)
  bad_sp = tapply(cohSum$BasalAreaDead, cohSum$Species, sum, na.rm=FALSE)
  bac_sp = tapply(cohSum$BasalAreaCut, cohSum$Species, sum, na.rm=FALSE)
  shl_sp = tapply(cohSum$ShrubCoverLive, cohSum$Species, sum, na.rm=FALSE)
  shd_sp = tapply(cohSum$ShrubCoverDead, cohSum$Species, sum, na.rm=FALSE)
  shc_sp = tapply(cohSum$ShrubCoverCut, cohSum$Species, sum, na.rm=FALSE)
  spSumYear <-data.frame("Step" = rep(step, length(bal_sp)),
                         "Species" = names(bal_sp),
                         "NumCohorts" = as.numeric(table(cohSum$Species)),
                         "TreeDensityLive"= as.numeric(nl_sp),
                         "TreeBasalAreaLive"= as.numeric(bal_sp),
                         "ShrubCoverLive"= as.numeric(shl_sp),
                         "BasalAreaDead" = as.numeric(bad_sp),
                         "ShrubCoverDead" = as.numeric(shd_sp),
                         "BasalAreaCut" = as.numeric(bac_sp),
                         "ShrubCoverCut" = as.numeric(shc_sp))
}
.summarizeStand<-function(step, cohSum, x) {
  isTree = !is.na(x$above$DBH)
  HB = .hartBeckingIndex(x$above$N[isTree], x$above$H[isTree], x$above$DBH[isTree])
  domH = .dominantTreeHeight(x$above$N[isTree], x$above$H[isTree], x$above$DBH[isTree])
  domDBH = .dominantTreeDiameter(x$above$N[isTree], x$above$DBH[isTree])
  qmDBH = .quadraticMeanTreeDiameter(x$above$N[isTree], x$above$DBH[isTree])
  standSumYear = data.frame("Step" = step,
                            "NumTreeSpecies" = length(unique(x$above$SP[isTree])),
                            "NumTreeCohorts" = sum(isTree),
                            "NumShrubSpecies" = length(unique(x$above$SP[!isTree])),
                            "NumShrubCohorts" = sum(!isTree),
                            "TreeDensityLive"= sum(cohSum$TreeDensityLive, na.rm = TRUE),
                            "TreeBasalAreaLive"= sum(cohSum$TreeBasalAreaLive, na.rm = TRUE),
                            "DominantTreeHeight"= domH,
                            "DominantTreeDiameter"= domDBH,
                            "QuadraticMeanTreeDiameter"= qmDBH,
                            "HartBeckingIndex"= HB,
                            "ShrubCoverLive"= sum(cohSum$ShrubCoverLive, na.rm=TRUE),
                            "BasalAreaDead" = sum(cohSum$BasalAreaDead, na.rm=TRUE),
                            "ShrubCoverDead" = sum(cohSum$ShrubCoverDead, na.rm=TRUE),
                            "BasalAreaCut" = sum(cohSum$BasalAreaCut, na.rm=TRUE),
                            "ShrubCoverCut" = sum(cohSum$ShrubCoverCut, na.rm=TRUE))
}

.createTreeTable<-function(step, year, x) {
  range <- numeric(0)
  ctype  <- .cohortType(row.names(x$cohorts))
  isTree <- ctype=="tree"
  if(sum(isTree)>0) range <- 1:sum(isTree)

  tt<-data.frame(Step = rep(step, length(range)), 
                 Year = rep(year, length(range)),
                 Cohort = row.names(x$cohorts)[range],
                 Species = x$cohorts$Name[range],
                 DBH = x$above$DBH[range],
                 Height = x$above$H[range],
                 N = x$above$N[range],
                 Z50 = x$below$Z50[range],
                 Z95 = x$below$Z95[range],
                 Z100 = x$below$Z100[range])
  if("Age" %in% names(x$above)) {
    tt$Age <- x$above$Age[range]
  } else {
    tt$Age <- as.numeric(rep(NA, sum(isTree)))
  }
  if("ObsID" %in% names(x$above)) {
    tt$ObsID <- x$above$ObsID[range]
  } else {
    tt$ObsID <- as.character(rep(NA, sum(isTree)))
  }
  tt = tt[tt$N>0,, drop=FALSE]
  return(tt)
}
.createDeadTreeTable<-function(step, year, x) {
  range <- numeric(0)
  ctype  <- .cohortType(row.names(x$cohorts))
  isTree <- ctype=="tree"
  if(sum(isTree)>0) range <- 1:sum(isTree)
  
  dtt<-data.frame(Step = rep(step, length(range)), 
                  Year = rep(year, length(range)),
                  Cohort = row.names(x$cohorts)[range],
                  Species = x$cohorts$Name[range],
                  DBH = x$above$DBH[range],
                  Height = x$above$H[range],
                  N = x$internalMortality$N_dead[range],
                  N_starvation = x$internalMortality$N_starvation[range],
                  N_dessication = x$internalMortality$N_dessication[range],
                  N_burnt = x$internalMortality$N_burnt[range],
                  N_resprouting_stumps = x$internalMortality$N_resprouting_stumps[range],
                  Z50 = x$below$Z50[range],
                  Z95 = x$below$Z95[range],
                  Z100 = x$below$Z100[range])
  if("Age" %in% names(x$above)) {
    dtt$Age <- x$above$Age[range]
  } else {
    dtt$Age <- as.numeric(rep(NA, sum(isTree)))
  }
  if("ObsID" %in% names(x$above)) {
    dtt$ObsID <- x$above$ObsID[range]
  } else {
    dtt$ObsID <- as.character(rep(NA, sum(isTree)))
  }
  dtt = dtt[dtt$N>0,, drop = FALSE]
  return(dtt)
}
.createCutTreeTable<-function(step, year, x, N_cut) {
  ctype  <- .cohortType(row.names(x$cohorts))
  isTree <- ctype=="tree"
  range <- numeric(0)
  if(length(N_cut)>0) range = 1:length(N_cut)
  ctt<-data.frame(Step = rep(step, length(N_cut)), 
                 Year = rep(year, length(N_cut)),
                 Cohort = row.names(x$cohorts)[range],
                 Species = x$cohorts$Name[range],
                 DBH = x$above$DBH[range],
                 Height = x$above$H[range],
                 N = N_cut,
                 Z50 = x$below$Z50[range],
                 Z95 = x$below$Z95[range],
                 Z100 = x$below$Z100[range])
  if("Age" %in% names(x$above)) {
    ctt$Age <- x$above$Age[range]
  } else {
    ctt$Age <- as.numeric(rep(NA, sum(isTree)))
  }
  if("ObsID" %in% names(x$above)) {
    ctt$ObsID <- x$above$ObsID[range]
  } else {
    ctt$ObsID <- as.character(rep(NA, sum(isTree)))
  }
  ctt = ctt[ctt$N>0,, drop=FALSE]
  return(ctt)
}
.createShrubTable<-function(step, year, x) {
  ctype  <- .cohortType(row.names(x$cohorts))
  nt <- sum(ctype=="tree")
  ns <- sum(ctype=="shrub")
  range <- numeric(0)
  if(ns>0) range = (nt+1):(nt+ns)
  st<-data.frame(Step = rep(step, ns), 
                 Year = rep(year, ns),
                 Cohort = row.names(x$cohorts)[range],
                 Species = x$cohorts$Name[range],
                 Cover = x$above$Cover[range],
                 Height = x$above$H[range],
                 Z50 = x$below$Z50[range],
                 Z95 = x$below$Z95[range],
                 Z100 = x$below$Z100[range])
  if("Age" %in% names(x$above)) {
    st$Age <- x$above$Age[range]
  } else {
    st$Age <- as.numeric(rep(NA, ns))
  }
  if("ObsID" %in% names(x$above)) {
    st$ObsID <- x$above$ObsID[range]
  } else {
    st$ObsID <- as.character(rep(NA, ns))
  }
  st = st[st$Cover>0,, drop = FALSE]
  return(st)
}
.createDeadShrubTable<-function(step, year, x) {
  ctype  <- .cohortType(row.names(x$cohorts))
  nt = sum(ctype=="tree")
  ns <- sum( ctype=="shrub")
  range <- numeric(0)
  if(ns>0) range = (nt+1):(nt+ns)
  dst<-data.frame(Step = rep(step, ns), 
                  Year = rep(year, ns),
                  Cohort = row.names(x$cohorts)[range],
                  Species = x$cohorts$Name[range],
                  Cover = x$internalMortality$Cover_dead[range],
                  Cover_starvation = x$internalMortality$Cover_starvation[range],
                  Cover_dessication = x$internalMortality$Cover_dessication[range],
                  Cover_burnt = x$internalMortality$Cover_burnt[range],
                  Cover_resprouting_stumps = x$internalMortality$Cover_resprouting_stumps[range],
                  Height = x$above$H[range],
                  Z50 = x$below$Z50[range],
                  Z95 = x$below$Z95[range],
                  Z100 = x$below$Z100[range])
  if("Age" %in% names(x$above)) {
    dst$Age <- x$above$Age[range]
  } else {
    dst$Age <- as.numeric(rep(NA, ns))
  }
  if("ObsID" %in% names(x$above)) {
    dst$ObsID <- x$above$ObsID[range]
  } else {
    dst$ObsID <- as.character(rep(NA, ns))
  }
  dst = dst[dst$Cover>0,,drop=FALSE]
  return(dst)
}
.createCutShrubTable<-function(step, year, x, Cover_cut) {
  ctype  <- .cohortType(row.names(x$cohorts))
  nt = sum(ctype=="tree")
  ns <- sum( ctype=="shrub")
  range <- numeric(0)
  if(ns>0) range = (nt+1):(nt+ns)
  cst<-data.frame(Step = rep(step, length(range)), 
                 Year = rep(year, length(range)),
                 Cohort = row.names(x$cohorts)[range],
                 Species = x$cohorts$Name[range],
                 Cover = Cover_cut,
                 Height = x$above$H[range],
                 Z50 = x$below$Z50[range],
                 Z95 = x$below$Z95[range],
                 Z100 = x$below$Z100[range])
  if("Age" %in% names(x$above)) {
    cst$Age <- x$above$Age[range]
  } else {
    cst$Age <- as.numeric(rep(NA, ns))
  }
  if("ObsID" %in% names(x$above)) {
    cst$ObsID <- x$above$ObsID[range]
  } else {
    cst$ObsID <- as.character(rep(NA, ns))
  }
  cst = cst[cst$Cover>0,, drop = FALSE]
  return(cst)
}

#' Single-cohort forests
#'
#' Creates a \code{\link{forest}} object with a single plant cohort
#'
#'
#' @param Species String with species (taxon) name or a non-negative integer for species identity (i.e., 0,1,2,...) matching SpParams.
#' @param Height Plant height (cm).
#' @param LAI Leaf area index (m2/m2)
#' @param N Tree density (ind/ha)
#' @param DBH Tree DBH (cm).
#' @param CrownRatio Crown ratio (fraction of total height)
#' @param FoliarBiomass Standing dry biomass of leaves (kg/m2)
#' @param FuelLoading Fine fuel loading (kg/m2)
#' @param Z50 Depth (in mm) corresponding to 50% of fine roots.
#' @param Z95 Depth (in mm) corresponding to 95% of fine roots.
#' @param Z100 Depth (in mm) corresponding to 100% of fine roots.
#'
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso \code{\link{forest}}, \code{\link{emptyforest}}
#' @return An object of class \code{\link{forest}}
#' @export
#'
#' @name tree2forest
#' @examples
#' 
#' oak_forest <-tree2forest("Quercus ilex", Height= 200, LAI = 2)
#' oak_forest
#' 
tree2forest<-function(Species, Height, LAI = NA, N = NA, DBH = NA, Z50 = NA, Z95 = NA, Z100 = NA,
                      CrownRatio = NA, FoliarBiomass = NA, FuelLoading = NA) {
  f<- emptyforest(ntree = 1) 
  f$treeData[["Species"]] <- Species
  f$treeData[["Height"]] <- Height
  f$treeData[["N"]] <- N
  f$treeData[["DBH"]] <- DBH
  f$treeData[["Z50"]] <- Z50
  f$treeData[["Z95"]] <- Z95
  if(!is.na(Z100)) {
    f$treeData[["Z100"]] <- Z100
  }
  if(!is.na(LAI)) {
    f$treeData[["LAI"]] <- LAI
  }
  if(!is.na(CrownRatio)) {
    f$treeData[["CrownRatio"]] <- CrownRatio
  }
  if(!is.na(FoliarBiomass)) {
    f$treeData[["FoliarBiomass"]] <- FoliarBiomass
  }
  if(!is.na(FuelLoading)) {
    f$treeData[["FuelLoading"]] <- FuelLoading
  }
  return(f)
}

#' @rdname tree2forest
#' @param Cover Percent cover
#' @export
shrub2forest<-function(Species, Height, LAI = NA, Cover = NA, Z50 = NA, Z95 = NA, Z100 = NA,
                       CrownRatio = NA, FoliarBiomass = NA, FuelLoading = NA) {
  f <- emptyforest(nshrub = 1) 
  f$shrubData[["Species"]] <- Species
  f$shrubData[["Height"]] <- Height
  f$shrubData[["Cover"]] <- Cover
  f$shrubData[["Z50"]] <- Z50
  f$shrubData[["Z95"]] <- Z95
  if(!is.na(Z100)) {
    f$shrubData[["Z100"]] <- Z100
  }
  if(!is.na(LAI)) {
    f$shrubData[["LAI"]] <- LAI
  }
  if(!is.na(CrownRatio)) {
    f$shrubData[["CrownRatio"]] <- CrownRatio
  }
  if(!is.na(FoliarBiomass)) {
    f$treeData[["FoliarBiomass"]] <- FoliarBiomass
  }
  if(!is.na(FuelLoading)) {
    f$treeData[["FuelLoading"]] <- FuelLoading
  }
  return(f)
}

#' Default soil parameters
#'
#' Creates a data frame with default soil physical and chemical description for model functions
#' 
#' @param n An integer with the number of soil layers (between two and five).
#' 
#' @details The function returns a data frame with default physical and chemical soil description, with soil layers in rows. 
#' Users can change those that need to be set to other values and use the list as input for function \code{\link{soil}}.
#' 
#' @note While this function is limited to five soil layers, user defined data frames can discretize soils using an unlimited number of soil layers.
#' 
#' @return A data frame with layers in rows and the following columns (and default values):
#' \itemize{
#'   \item{\code{widths (= c(300,700,1000,2000)}: Width of soil layers (in mm).}
#'   \item{\code{clay (= 25)}: Clay percentage for each layer (in %).}
#'   \item{\code{sand (= 25)}: Sand percentage for each layer (in %).}
#'   \item{\code{om (= NA)}: Organic matter percentage for each layer (in %) (optional).}0
#'   \item{\code{nitrogen (= NA)}: Sum of total nitrogen (ammonia, organic and reduced nitrogen) for each layer (in g/kg) (optional).}
#'   \item{\code{ph (=NA)}: pH in water (0-14) (optional).}
#'   \item{\code{bd (= 1.5)}: Bulk density for each layer (in g/cm3).}
#'   \item{\code{rfc (= c(20,40,60,85))}: Percentage of rock fragment content (volume basis) for each layer.}
#' }
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso  \code{\link{soil}}, \code{\link{soil_redefineLayers}},  \code{\link{defaultControl}}, \code{\link{SpParamsMED}}
#' 
#' @examples 
#' defaultSoilParams(4)
#' 
defaultSoilParams<-function(n=4) {
  n = min(max(n,2),5)
  return(data.frame(
    widths = c(300,700,1000,2000,4000)[1:n],
    clay = rep(25,n),
    sand = rep(25,n),
    om = rep(NA,n),
    nitrogen = rep(NA,n),
    ph = rep(NA,n),
    bd = rep(1.5,n),
    rfc = c(25,45,75,95,98)[1:n]));
}

.multiple_x<-function(x, y, xlab = "", ylab=NULL, xlim = NULL, ylim = NULL, labels = NULL) {
  if(is.null(labels)) labels = colnames(x)
  df = data.frame("X" = as.vector(x), 
                  "Y" = y,
                  "Cohort" = gl(length(colnames(x)), nrow(x), labels=labels))
  g<-ggplot(df, aes(x=.data$X, y=.data$Y))+
    geom_path(aes(col=.data$Cohort, linetype = .data$Cohort))+
    scale_color_discrete(name="")+
    scale_linetype_discrete(name="")+
    theme_bw()+
    xlab(xlab)
  if(!is.null(ylim)) g <- g+ylim(ylim)
  if(!is.null(xlim)) g <- g+xlim(xlim)
  if(!is.null(ylab)) g <- g+ylab(ylab)
  return(g)
}
.multiple_y<-function(x, y, xlab = "", ylab=NULL, ylim = NULL, labels = NULL) {
  if(is.null(labels)) labels = colnames(y)
  df = data.frame("Y" = as.vector(y), "X" = x,
                  "Cohort" = gl(length(colnames(y)), nrow(y), labels=labels))
  g<-ggplot(df, aes(x=.data$X, y=.data$Y))+
    geom_path(aes(col=.data$Cohort, linetype = .data$Cohort))+
    scale_color_discrete(name="")+
    scale_linetype_discrete(name="")+
    theme_bw()+
    xlab(xlab)
  if(!is.null(ylim)) g <- g+ylim(ylim)
  if(!is.null(ylab)) g <- g+ylab(ylab)
  return(g)
}

.multiple_dynamics<-function(x, xlab = "", ylab=NULL, ylim = NULL, labels = NULL) {
  if(is.null(labels)) labels = colnames(x)
  df = data.frame("Y" = as.vector(x), 
                  "Date" = as.Date(rownames(x)),
                  "Cohort" = gl(length(colnames(x)), nrow(x), labels=labels))
  g<-ggplot(df, aes(x=.data$Date, y=.data$Y))
  if(length(labels)<=10) {
    g<- g + geom_line(aes(col=.data$Cohort, linetype = .data$Cohort))+
      scale_color_discrete(name="")+
      scale_linetype_discrete(name="")
  } else {
    g<- g + geom_line(aes(group=.data$Cohort))
  }
  g<-g+theme_bw()+xlab(xlab)
  if(!is.null(ylim)) g <- g+ylim(ylim)
  if(!is.null(ylab)) g <- g+ylab(ylab)
  return(g)
}
.multiple_dynamics_range<-function(x1,x2, xlab = "", ylab=NULL, ylim = NULL, labels = NULL) {
  if(is.null(labels)) labels = colnames(x1)
  df = data.frame("Y1" = as.vector(x1),
                  "Y2" = as.vector(x2),
                  "Date" = as.Date(rownames(x1)),
                  "Cohort" = gl(length(colnames(x1)), nrow(x1), labels=labels))
  g<-ggplot(df, aes(x=.data$Date))+
    geom_ribbon(aes(ymin = .data$Y2, ymax=.data$Y1, color = .data$Cohort, fill=.data$Cohort), alpha = 0.5)+
    scale_fill_discrete(name="")+
    guides(color = "none")+
    theme_bw()+
    xlab(xlab)
  if(!is.null(ylim)) g <- g+ylim(ylim)
  if(!is.null(ylab)) g <- g+ylab(ylab)
  return(g)
}


.multiple_dynamics_subdaily<-function(x, xlab = "", ylab=NULL, ylim = NULL, labels = NULL) {
  if(is.null(labels)) labels = colnames(x)[-1]
  df = data.frame("Y" = as.vector(as.matrix(x[,-1])), 
                  "DateTime" = as.POSIXct(x$datetime),
                  "Cohort" = gl(length(names(x)[-1]), nrow(x), labels=labels))
  g<-ggplot(df, aes(x=.data$DateTime, y=.data$Y))+
    geom_line(aes(col=.data$Cohort, linetype = .data$Cohort))+
    scale_color_discrete(name="")+
    scale_linetype_discrete(name="")+
    theme_bw()+
    xlab(xlab)
  if(!is.null(ylim)) g <- g+ylim(ylim)
  if(!is.null(ylab)) g <- g+ylab(ylab)
  return(g)
}
.multiple_dynamics_subdaily_sunlit_shade<-function(x_sl, x_sh, xlab = "", ylab=NULL, ylim = NULL, labels = NULL) {
  if(is.null(labels)) labels = colnames(x_sl)[-1]
  df_sl = data.frame("Y" = as.vector(as.matrix(x_sl[,-1])), 
                     "DateTime" = as.POSIXct(x_sl$datetime),
                     "Cohort" = gl(length(colnames(x_sl)[-1]), nrow(x_sl), labels=labels),
                     "LeafType" = "Sunlit", stringsAsFactors = F)
  df_sh = data.frame("Y" = as.vector(as.matrix(x_sh[,-1])), 
                     "DateTime" = as.POSIXct(x_sh$datetime),
                     "Cohort" = gl(length(colnames(x_sh)[-1]), nrow(x_sh), labels=labels),
                     "LeafType" = "Shade", stringsAsFactors = F)
  df = as.data.frame(rbind(df_sl, df_sh), stringsAsFactors = F)
  df$LeafType = factor(df$LeafType, levels =c("Sunlit","Shade"))
  g<-ggplot(df, aes(x=.data$DateTime, y=.data$Y))+
    geom_line(aes(col=.data$Cohort, linetype = .data$Cohort))+
    facet_wrap(~LeafType, ncol=1)+
    scale_color_discrete(name="")+
    scale_linetype_discrete(name="")+
    theme_bw()+
    xlab(xlab)
  if(!is.null(ylim)) g <- g+ylim(ylim)
  if(!is.null(ylab)) g <- g+ylab(ylab)
  return(g)
}
.single_dynamics<-function(x, xlab="", ylab=NULL, ylim = NULL) {
  df = data.frame("Y" = x, 
                  "Date" = as.Date(names(x)))
  g<-ggplot(df, aes(x = .data$Date, y= .data$Y))+
    geom_line()+
    scale_color_discrete(name="")+
    scale_linetype_discrete(name="")+
    theme_bw()+
    xlab(xlab)
  if(!is.null(ylim)) g <- g+ylim(ylim)
  if(!is.null(ylab)) g <- g+ylab(ylab)
  return(g)
}

.single_subday_dynamics <-function(x, xlab="Time step", ylab=NULL, ylim = NULL) {
  df = data.frame("Y" = x, 
                  "TimeStep" = 1:length(x))
  g<-ggplot(df, aes(x = .data$TimeStep, y= .data$Y))+
    geom_line()+
    scale_color_discrete(name="")+
    scale_linetype_discrete(name="")+
    theme_bw()+
    xlab(xlab)
  if(!is.null(ylim)) g <- g+ylim(ylim)
  if(!is.null(ylab)) g <- g+ylab(ylab)
  return(g)
}

.multiple_subday_dynamics<-function(x, xlab = "Time step", ylab=NULL, ylim = NULL, labels = NULL) {
  if(is.null(labels)) labels = colnames(x)
  df = data.frame("Y" = as.vector(x), 
                  "TimeStep" = as.numeric(rownames(x)),
                  "Cohort" = gl(length(colnames(x)), nrow(x), labels=labels))
  g<-ggplot(df, aes(x=.data$TimeStep, y=.data$Y))+
    geom_line(aes(col=.data$Cohort, linetype = .data$Cohort))+
    scale_color_discrete(name="")+
    scale_linetype_discrete(name="")+
    theme_bw()+
    xlab(xlab)
  if(!is.null(ylim)) g <- g+ylim(ylim)
  if(!is.null(ylab)) g <- g+ylab(ylab)
  return(g)
}

.multiple_subday_dynamics_sunlit_shade<-function(x_sl, x_sh, xlab = "Time step", ylab=NULL, ylim = NULL, labels = NULL) {
  if(is.null(labels)) labels = colnames(x_sl)
  df_sl = data.frame("Y" = as.vector(x_sl), 
                     "TimeStep" = as.numeric(rownames(x_sl)),
                     "Cohort" = gl(length(colnames(x_sl)), nrow(x_sl), labels=labels),
                     "LeafType" = "Sunlit", stringsAsFactors = F)
  df_sh = data.frame("Y" = as.vector(x_sh), 
                     "TimeStep" = as.numeric(rownames(x_sh)),
                     "Cohort" = gl(length(colnames(x_sh)), nrow(x_sh), labels=labels),
                     "LeafType" = "Shade", stringsAsFactors = F)
  df = as.data.frame(rbind(df_sl, df_sh), stringsAsFactors = F)
  df$LeafType = factor(df$LeafType, levels =c("Sunlit","Shade"))
  g<-ggplot(df, aes(x=.data$TimeStep, y=.data$Y))+
    geom_line(aes(col=.data$Cohort, linetype = .data$Cohort))+
    facet_wrap(~LeafType, ncol=2)+
    scale_color_discrete(name="")+
    scale_linetype_discrete(name="")+
    theme_bw()+
    xlab(xlab)
  if(!is.null(ylim)) g <- g+ylim(ylim)
  if(!is.null(ylab)) g <- g+ylab(ylab)
  return(g)
}

#' Summary of forest structure
#' 
#' Displays a summary of forest structure
#' 
#' @param object An object of class \code{\link{forest}}
#' @param SpParams A data frame with species parameters (see \code{\link{SpParamsMED}}).
#' @param x The object returned by \code{summary.forest}.
#' @param digits Minimal number of significant digits.
#' @param ... Additional parameters for functions \code{\link{summary}} and \code{\link{print}}.
#' 
#' @details Function \code{summary.forest} can be used to summarize a \code{forest} object in the console. 
#' 
#' @return Function \code{summary.forest} returns a list with several structural attributes, such as the basal area and LAI of the forest. 
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso \code{\link{forest}}, \code{\link{forest_mapWoodyTables}},  \code{\link{forest_mergeTrees}},  
#' \code{\link{plot.forest}}, \code{\link{tree2forest}}
#' 
#' @examples 
#' # Summary of example forests
#' summary(exampleforest, SpParamsMED)
#' summary(exampleforest2, SpParamsMED)
#' 
#' @name summary.forest
summary.forest<-function(object, SpParams, ...) {

  # Checks
  if(length(object$herbCover)!=1) object$herbCover = NA
  if(length(object$herbHeight)!=1) object$herbHeight = NA
  
  ntree <- nrow(object$treeData)
  nshrub <- nrow(object$shrubData)
  nherb <- 0
  if(!is.null(object$herbData)) nherb <- nrow(object$herbData)
  
  selTree <- c(rep(TRUE, ntree), rep(FALSE, nshrub), rep(FALSE, nherb))
  selAdult <- c(object$treeData$DBH > 5.0, rep(FALSE, nshrub), rep(FALSE, nherb))
  selSapling <- c(object$treeData$DBH <= 5.0, rep(FALSE, nshrub), rep(FALSE, nherb))
  selShrub <- c(rep(FALSE, ntree), rep(TRUE, nshrub), rep(FALSE, nherb))
  selHerb <- c(rep(FALSE, ntree), rep(FALSE, nshrub), rep(TRUE, nherb))
  
  coh_N <- plant_density(object, SpParams)
  coh_cov <- plant_cover(object, SpParams)
  coh_lai <- plant_LAI(object, SpParams)
  coh_fuel <- plant_fuelLoading(object, SpParams)
  
  coh_ba <- plant_basalArea(object, SpParams)
  
  s <- list()
  s[["Tree_BA"]] <- sum(coh_ba[selTree], na.rm=TRUE)
  s[["Adult_BA"]] <- sum(coh_ba[selAdult], na.rm=TRUE)
  s[["Sapling_BA"]] <- sum(coh_ba[selSapling], na.rm=TRUE)
  
  s[["Tree_density"]] <- sum(coh_N[selTree], na.rm=TRUE)
  s[["Adult_density"]] <- sum(coh_N[selAdult], na.rm=TRUE)
  s[["Sapling_density"]] <- sum(coh_N[selSapling], na.rm=TRUE)
  s[["Shrub_density"]] <- sum(coh_N[selShrub], na.rm=TRUE)
  s[["Herb_density"]] <- sum(coh_N[selHerb], na.rm=TRUE)
  

  s[["Tree_cover"]] <- pmin(100,sum(coh_cov[selTree], na.rm=TRUE))
  s[["Adult_cover"]] <- pmin(100,sum(coh_cov[selAdult], na.rm=TRUE))
  s[["Sapling_cover"]] <- pmin(100,sum(coh_cov[selSapling], na.rm=TRUE))
  s[["Shrub_cover"]] <- pmin(100,sum(coh_cov[selShrub], na.rm=TRUE))
  s[["Herb_cover"]] <- pmin(100,sum(coh_cov[selHerb], na.rm=TRUE))
  if(!is.null(object$herbCover)) {
    hc <- object$herbCover
    if(is.na(hc)) hc <- 0
    s[["Herb_cover"]] <- s[["Herb_cover"]] + hc
  }

  s[["Tree_lai"]] <- sum(coh_lai[selTree], na.rm=TRUE)
  s[["Adult_lai"]] <- sum(coh_lai[selAdult], na.rm=TRUE)
  s[["Sapling_lai"]] <- sum(coh_lai[selSapling], na.rm=TRUE)
  s[["Shrub_lai"]] <- sum(coh_lai[selShrub], na.rm=TRUE)
  s[["Herb_lai"]] <- sum(coh_lai[selHerb], na.rm=TRUE)
  s[["Herb_lai"]] <- s[["Herb_lai"]] + herb_LAI(object, SpParams)
  s["Total_lai"] <- s[["Tree_lai"]] + s[["Shrub_lai"]] + s[["Herb_lai"]]
  
  s[["Tree_fuel"]] <- sum(coh_fuel[selTree], na.rm=TRUE)
  s[["Adult_fuel"]] <- sum(coh_fuel[selAdult], na.rm=TRUE)
  s[["Sapling_fuel"]] <- sum(coh_fuel[selSapling], na.rm=TRUE)
  s[["Shrub_fuel"]] <- sum(coh_fuel[selShrub], na.rm=TRUE)
  s[["Herb_fuel"]] <- sum(coh_fuel[selHerb], na.rm=TRUE)
  s[["Herb_fuel"]] <- s[["Herb_fuel"]] + herb_fuelLoading(object, SpParams)
  s[["Total_fuel"]] <- s[["Tree_fuel"]] + s[["Shrub_fuel"]] + s[["Herb_fuel"]]
  
  s[["PARground"]] <- NA
  s[["SWRground"]] <- NA
  
  if(all(!is.na(object$treeData$Height)) && all(!is.na(object$shrubData$Height))) {
    s[["PARground"]] <- light_PARground(object, SpParams)
    s[["SWRground"]] <- light_SWRground(object, SpParams)
  }
  class(s)<-c("summary.forest","list")
  return(s)
}

#' @rdname summary.forest
print.summary.forest<-function(x, digits=getOption("digits"),...) {
  cat(paste("Tree BA (m2/ha):", round(x[["Tree_BA"]],digits)," adult trees:", round(x[["Adult_BA"]], digits), 
            " saplings:", round(x[["Sapling_BA"]], digits),"\n"))
  cat(paste("Density (ind/ha) adult trees:", round(x[["Adult_density"]], digits), 
            " saplings:", round(x[["Sapling_density"]], digits), 
            " shrubs (estimated):", round(x[["Shrub_density"]],digits),"\n"))
  cat(paste("Cover (%) adult trees:", round(x[["Adult_cover"]],digits), 
            " saplings:", round(x[["Sapling_cover"]], digits), 
            " shrubs:", round(x[["Shrub_cover"]],digits),
            " herbs:", round(x[["Herb_cover"]],digits),
            "\n"))
  cat(paste("LAI (m2/m2) total:", round(x[["Total_lai"]], digits),
            " adult trees:", round(x[["Adult_lai"]], digits),
            " saplings:", round(x[["Sapling_lai"]], digits), 
            " shrubs:", round(x[["Shrub_lai"]], digits),
            " herbs:", round(x[["Herb_lai"]], digits),
            "\n"))
  cat(paste("Fuel loading (kg/m2) total:", round(x[["Total_fuel"]], digits),
            " adult trees:", round(x[["Adult_fuel"]], digits),
            " saplings:", round(x[["Sapling_fuel"]], digits), 
            " shrubs:", round(x[["Shrub_fuel"]], digits),
            " herbs:", round(x[["Herb_fuel"]],digits),
            "\n"))
  cat(paste("PAR ground (%):", round(x[["PARground"]],digits)," SWR ground (%):", round(x[["SWRground"]],digits),"\n"))
}

.extractSubdaily<-function(x, output = "E", dates = NULL, long_format = FALSE)  {
  leafTypes= c("LAI", "Abs_PAR", "Abs_SWR","Net_LWR","E","Ag","An","Ci","Gsw","VPD","Temp","Psi","iWUE")  
  sunlitTypes = paste("SunlitLeaves",leafTypes, sep="$")
  shadeTypes = paste("ShadeLeaves",leafTypes, sep="$")
  plantTypes = c("E","Ag","An","dEdP","RootPsi",
                "StemPsi","LeafPsi","StemPLC", "LeafPLC","StemRWC","LeafRWC","StemSympRWC","LeafSympRWC",
                "LeafSympPsi", "StemSympPsi","PWB")
  PWBTYPES = c("PlantLAI","Temperature", "SoilTemperature","CanopyEnergyBalance", "SoilEnergyBalance",
               "ExtractionInst", plantTypes, sunlitTypes, shadeTypes)
  CBTYPES = c("GrossPhotosynthesis", "MaintenanceRespiration", "GrowthCosts", "RootExudation", "LabileCarbonBalance",
              "SugarLeaf", "SugarSapwood", "StarchLeaf", "StarchSapwood","SugarTransport")
  GROWTHTYPES = c(CBTYPES, PWBTYPES)
  if(is.null(dates)) dates = as.Date(names(x$subdaily))
  
  if(("spwb" %in% class(x)) || ("pwb" %in% class(x))) {
    input = x$spwbInput
    output = match.arg(output, PWBTYPES)
  } else {
    input = x$growthInput
    output = match.arg(output, GROWTHTYPES)
  }
  
  numCohorts = nrow(input$above)
  numDates = length(dates)
  numSteps = input$control$ndailysteps
  h = 0 + (0:(numSteps-1))*(24/numSteps)
  minutes = 60*h%%1
  seconds = round(60*minutes%%1)
  minutes = floor(minutes)
  hours = floor(h)
  times = paste(hours,minutes,seconds, sep=":")
  
  if(output %in% plantTypes) {
    m<-data.frame(matrix(nrow = numDates*numSteps, ncol = numCohorts+1))
    for(i in 1:numDates) {
      ori = x$subdaily[[as.character(dates[i])]]$PlantsInst[[output]]
      m[((i-1)*numSteps+1):(i*numSteps), 2:(numCohorts+1)] = t(ori) 
    }
    colnames(m) = c("datetime", row.names(input$above))
  } else if(output=="PlantLAI") {
    ori1 = x$subdaily[[as.character(dates[1])]]$Plants$LAI
    nc = length(ori1)
    m<-data.frame(matrix(nrow = numDates*numSteps, ncol = nc+1))
    for(i in 1:numDates) {
      ori = x$subdaily[[as.character(dates[i])]]$Plants$LAI
      m[((i-1)*numSteps+1):(i*numSteps), 2:(nc+1)] = matrix(ori, nrow = numSteps, ncol = nc, byrow = TRUE) 
    }
    colnames(m) = c("datetime", row.names(input$above))
  } else if(output %in% c("Temperature", "SoilTemperature","CanopyEnergyBalance", "SoilEnergyBalance")) {
    ori1 = x$subdaily[[as.character(dates[1])]]$EnergyBalance[[output]]
    ncols = ncol(ori1)
    m<-data.frame(matrix(nrow = numDates*numSteps, ncol = ncols+1))
    for(i in 1:numDates) {
      ori = x$subdaily[[as.character(dates[i])]]$EnergyBalance[[output]]
      m[((i-1)*numSteps+1):(i*numSteps), 2:(ncols+1)] = ori 
    }
    colnames(m) = c("datetime", colnames(ori1))
  } else if(output=="ExtractionInst") {
    ori1 = x$subdaily[[as.character(dates[1])]]$ExtractionInst
    ncols = nrow(ori1)
    m<-data.frame(matrix(nrow = numDates*numSteps, ncol = ncols+1))
    for(i in 1:numDates) {
      ori = x$subdaily[[as.character(dates[i])]]$ExtractionInst
      m[((i-1)*numSteps+1):(i*numSteps), 2:(ncols+1)] = t(ori) 
    }
    colnames(m) = c("datetime", rownames(ori1))
  } else if(output %in% sunlitTypes) {
    leafType = strsplit(output,"[$]")[[1]][2]
    m<-data.frame(matrix(nrow = numDates*numSteps, ncol = numCohorts+1))
    for(i in 1:numDates) {
      if(leafType=="iWUE") {
          ori1 = x$subdaily[[as.character(dates[i])]]$SunlitLeavesInst$An
          ori2 = x$subdaily[[as.character(dates[i])]]$SunlitLeavesInst$Gsw
          m[((i-1)*numSteps+1):(i*numSteps), 2:(numCohorts+1)] = t(ori1/ori2) 
      } else{
        ori = x$subdaily[[as.character(dates[i])]]$SunlitLeavesInst[[leafType]]
        m[((i-1)*numSteps+1):(i*numSteps), 2:(numCohorts+1)] = t(ori) 
      }
    }
    colnames(m) = c("datetime", row.names(input$above))
  } else if(output %in% shadeTypes) {
    leafType = strsplit(output,"[$]")[[1]][2]
    m<-data.frame(matrix(nrow = numDates*numSteps, ncol = numCohorts+1))
    for(i in 1:numDates) {
      if(leafType=="iWUE") {
        ori1 = x$subdaily[[as.character(dates[i])]]$ShadeLeavesInst$An
        ori2 = x$subdaily[[as.character(dates[i])]]$ShadeLeavesInst$Gsw
        m[((i-1)*numSteps+1):(i*numSteps), 2:(numCohorts+1)] = t(ori1/ori2) 
      } else{
        ori = x$subdaily[[as.character(dates[i])]]$ShadeLeavesInst[[leafType]]
        m[((i-1)*numSteps+1):(i*numSteps), 2:(numCohorts+1)] = t(ori) 
      }
    }
    colnames(m) = c("datetime", row.names(input$above))
  } else if(output %in% CBTYPES) {
    ori1 = x$subdaily[[as.character(dates[1])]]$LabileCarbonBalanceInst[[output]]
    ncols = nrow(ori1)
    m<-data.frame(matrix(nrow = numDates*numSteps, ncol = ncols+1))
    for(i in 1:numDates) {
      ori = x$subdaily[[as.character(dates[i])]]$LabileCarbonBalanceInst[[output]]
      m[((i-1)*numSteps+1):(i*numSteps), 2:(ncols+1)] = t(ori) 
    }
    colnames(m) = c("datetime", row.names(ori1))
  }
  m$datetime = as.POSIXct(paste(dates[gl(n=numDates, k=numSteps)], times))
  ## To long format
  if(long_format) {
    cohorts <- names(m)[-1]
    df = data.frame("datetime" = rep(as.POSIXct(m$datetime),length(cohorts)),
                    "cohort" = gl(n = length(cohorts), k=nrow(m), labels = cohorts),
                    "Y" = as.vector(as.matrix(m[,-1])))
    names(df)[3] <- output
    m <- df
  }
  return(m)
}

.getSubdailyOutputUnit<-function(level, variable) {
  u <- NULL
  if(level=="cohort") {
    if(variable %in% c("E", "PWB")) u <- "l/m2"
    else if(variable %in% c("Ag", "An")) u <- "g/m2"
    else if(variable %in% c("dEdP")) u <- "mmol/m2/s/MPa"
    else if(variable %in% c("RootPsi", "StemPsi", "LeafPsi", "LeafSympPsi", "StemSympPsi")) u <- "MPa"
    
  } else if(level %in% c("sunlitleaf", "shadeleaf")){
    if(variable %in% c("LAI")) u <- "m2/m2"
    else if(variable %in% c("Abs_PAR", "Abs_SWR","Net_LWR")) u <- "W/m2"
    else if(variable %in% c("Ag", "An")) u <- "micromol/m2/s"
    else if(variable %in% c("E")) u <- "mmol/m2/s"
    else if(variable %in% c("Ci")) u <- "ppm"
    else if(variable %in% c("Gsw")) u <- "mol/m2/s"
    else if(variable %in% c("VPD")) u <- "kPa"
    else if(variable %in% c("Temp")) u <- "celsius"
    else if(variable %in% c("Psi")) u <- "MPa"
    else if(variable %in% c("iWUE")) u <- "micromol/mol"
  }
  return(u)
}
.addSubdailyOutputUnits<-function(x, level) {
  cnames <- colnames(x)
  cnames <- cnames[!(cnames %in% c("datetime", "cohort", "species", "sunlitleaf", "shadeleaf"))]
  for(i in 1:ncol(x)) {
    u <- .getSubdailyOutputUnit(level, cnames[i])
    if(!is.null(u)) {
      x[[cnames[i]]] <- units::set_units(x[[cnames[i]]], u, mode = "standard")
    }
  }
  return(x)
}

.getDailyOutputUnit<-function(level, output, variable) {
  u <- NULL 
  if(level=="forest") {
    if(output=="WaterBalance") {
      u <- "l/m2"
    } else if(output=="Snow") {
      u <- "l/m2"
    } else if(output=="Stand") {
      if(variable %in% c("LAI", "LAIherb", "LAIlive", "LAIexpanded", "LAIdead")) u <- "m2/m2"
      else if(variable %in% c("Cm")) u <- "l/m2"
      else if(variable %in% c("LgroundPAR", "LgroundSWR")) u <- "%"
    } else if(output=="EnergyBalance") {
      if(variable %in% c("SWRcan", "LWRcan", "LEVcan", "LEFsnow", "Hcan", "Ebalcan", "Hcansoil", "SWRsoil", "LWRsoil", "LEVsoil", "Ebalsoil")) u <- "W/m2"
    } else if(output=="Temperature") {
      if(variable %in% c("Tatm_mean", "Tatm_min", "Tatm_max", "Tcan_mean", "Tcan_min", "Tcan_max", "Tsoil_mean", "Tsoil_min", "Tsoil_max")) u <- "celsius"
    } else if(output=="CarbonBalance") {
      u <- "g C/m2"
    } else if(output=="BiomassBalance") {
      u <- "g/m2"
    } else if(output=="DecompositionPools") {
      u <- "g C/m2"
    } else if(output=="FireHazard") {
      if(variable %in% c("Loading_overstory", "Loading_understory")) u <- "kg/m2"
      else if(variable %in% c("CFMC_understory", "CFMC_overstory", "DFMC")) u <- "%"
      else if(variable %in% c("ROS_surface", "ROS_crown")) u <- "m/min"
      else if(variable %in% c("I_b_surface", "I_b_crown")) u <- "kW/m"
      else if(variable %in% c("FL_surface", "FL_crown")) u <- "m"
      else if(variable %in% c("t_r_surface","t_r_crown")) u <- "s"
    }
  } else if(level=="soillayer") {
    if(variable %in% c("ML")) u <- "l/m2"
    else if(variable %in% c("PlantExt", "HydraulicInput")) u <- "l/m2"
    else if(variable %in% c("Psi")) u <- "MPa"
  } else if(level=="cohort") {
    if(variable %in% c("LAI", "LAIlive")) u <- "m2/m2"
    else if(variable %in% c("FPAR", "AbsorbedSWR")) u <- "%"
    else if(variable %in% c("NetLWR")) u <- "W/m2"
    else if(variable %in% c("Transpiration", "PlantWaterBalance")) u <- "l/m2"
    else if(variable %in% c("GrossPhotosynthesis", "NetPhotosynthesis")) u <- "l/m2"
    else if(variable %in% c("PlantPsi", "LeafPsiMin", "LeafPsiMax", "StemPsi", "RootPsi")) u <- "MPa"
    else if(variable %in% c("LFMC", "LeafRWC", "StemRWC")) u <- "%"
    else if(variable %in% c("dEdP")) u <- "mmol / s /m2 /MPa"
    else if(variable %in% c("GrowthCosts", "RootExudation", "LabileCarbonBalance")) u <- "g/g"
    else if(variable %in% c("SugarLeaf", "StarchLeaf", "SugarSapwood", "StarchSapwood")) u <- "mol/l"
    else if(variable %in% c("SugarTransport")) u <- "mol/s"
    else if(variable %in% c("StructuralBiomassBalance", "LabileBiomassBalance", "PlantBiomassBalance", "MortalityBiomassLoss", "CohortBiomassBalance")) u <- "g/m2"
    else if(variable %in% c("LeafBiomass", "SapwoodBiomass", "FineRootBiomass")) u <- "g"
    else if(variable %in% c("LeafArea", "FineRootArea")) u <- "m2"
    else if(variable %in% c("SapwoodArea")) u <- "cm2"
    else if(variable %in% c("HuberValue")) u <- "cm2/m2"
    else if(variable %in% c("RootAreaLeafArea")) u <- "m2/m2"
    else if(variable %in% c("DBH", "Height")) u <- "cm"
    else if(variable %in% c("LAgrowth", "FRAgrowth")) u <- "m2/day"
    else if(variable %in% c("SAgrowth")) u <- "cm2/day"
    else if(variable %in% c("StarvationRate", "DessicationRate", "MortalityRate")) u <- "day-1"
  } else if(level=="sunlitleaf" || level=="shadeleaf") {
    if(variable %in% c("LeafPsiMin", "LeafPsiMax")) u <- "MPa" 
    else if(variable %in% c("TempMin", "TempMax")) u <- "celsius" 
    else if(variable %in% c("GSWMin", "GSWMax")) u <- "mol m-2 s-1" 
  }
  return(u)
}
.addDailyOutputUnits<-function(x, level, output) {
  cnames <- colnames(x)
  cnames <- cnames[!(cnames %in% c("date", "soillayer", "cohort", "species", "sunlitleaf", "shadeleaf"))]
  for(i in 1:ncol(x)) {
    u <- .getDailyOutputUnit(level, output, cnames[i])
    if(!is.null(u)) {
      x[[cnames[i]]] <- units::set_units(x[[cnames[i]]], u, mode = "standard")
    }
  }
  return(x)
}
.extractInner<-function(x, level = "forest", output = NULL, vars = NULL, dates = NULL, subdaily = FALSE, addunits = FALSE)  {
  if(inherits(x, "aspwb")) {
    level <- match.arg(level, "soillayer")
    subdaily <- FALSE
  } else {
    level <- match.arg(level, c("forest", "soillayer","cohort", "sunlitleaf", "shadeleaf"))
  }
  if(inherits(x, "aspwb")) {
    input <- x$aspwbInput
    cohorts <- character(0)
    cohnames <- character(0)
    spnames <- character(0)
  } else {
    if(inherits(x, "spwb") || inherits(x, "pwb")) {
      input <- x$spwbInput
      cohorts <- x$spwbInput$cohorts
    } else if(inherits(x, "growth")) {
      input <- x$growthInput
      cohorts <- x$growthInput$cohorts
    }
    cohnames <- row.names(cohorts)
    spnames <- cohorts$Name
  }  
  
  if(subdaily) {
    if(level %in% c("forest", "soillayer")) stop("Subdaily results are for levels 'cohort', 'sunlitleaf' and 'shadeleaf' only.")
    if(level=="cohort") {
      cohort_types = c("E","Ag","An","dEdP","RootPsi",
                       "StemPsi","LeafPsi","StemPLC", "LeafPLC","StemRWC","LeafRWC","StemSympRWC","LeafSympRWC",
                       "LeafSympPsi", "StemSympPsi","PWB")
      if(is.null(vars)) {
        vars <- cohort_types
      } else {
        for(i in 1:length(vars)) vars[i] <-match.arg(vars[i], cohort_types)
      }
    }
    if(level %in% c("sunlitleaf", "shadeleaf")) {
      leaf_types= c("LAI", "Abs_PAR", "Abs_SWR","Net_LWR","E","Ag","An","Ci","Gsw","VPD","Temp","Psi","iWUE")  
      if(is.null(vars)) {
        vars <- leaf_types
      } else {
        for(i in 1:length(vars)) vars[i] <-match.arg(vars[i], leaf_types)
      }
    }
    df <- NULL
    for(ivar in 1:length(vars)) {
      var_name <- vars[ivar]
      outputSubdaily <- var_name
      if(level=="sunlitleaf") outputSubdaily <- paste0("SunlitLeaves$", outputSubdaily)
      if(level=="shadeleaf") outputSubdaily <- paste0("ShadeLeaves$", outputSubdaily)
      if(is.null(df)) {
        df <- .extractSubdaily(x, output = outputSubdaily, dates = dates, long_format = TRUE)
        df[["species"]] <-as.character(gl(length(spnames), nrow(df)/length(spnames), labels = spnames))
        df <- df[,c(1,2,4,3)]
        names(df)[4] <- var_name
      } else {
        df_var <- .extractSubdaily(x, output = outputSubdaily, dates = dates, long_format = TRUE)
        df[[var_name]] <- df_var[,3]
      }
    }
    if(addunits) {
      df <- .addSubdailyOutputUnits(df, level)
    }
    return(df)
  }
  if(is.null(dates)) dates <- row.names(x$WaterBalance)
  else {
    if(!all(dates %in% row.names(x$WaterBalance))) stop("Some dates are outside the range in 'x'")
  }
  
  
  if(level=="forest") {
    stand_level_names <-c("WaterBalance", "Stand", "Snow",
                          "EnergyBalance", "Temperature", "CarbonBalance", "BiomassBalance", "DecompositionPools","FireHazard")
    if(is.null(output)) {
      output <- stand_level_names
    } else {
      for(i in 1:length(output)) output[i] <-match.arg(output[i], stand_level_names)
    }
    out <- data.frame(date = dates)
    if(addunits) out$date <- as.Date(out$date)
    for(n in output) {
      if(n %in% names(x)) {
        M <- x[[n]]
        varnames <- colnames(M)
        M <- M[rownames(M) %in% dates, varnames, drop = FALSE]
        if(!is.null(vars)) M <- M[,colnames(M) %in% vars, drop = FALSE]
        if(ncol(M)>0) {
          row.names(M) <- NULL
          M <- as.data.frame(M)
          if(addunits) M <- .addDailyOutputUnits(M, level, n)
          out <- cbind(out, M)
        }
      }
    }
  } else if (level =="soillayer") {
    layers <- c(1:length(input$soil$widths), "Overall")
    output <- "Soil"
    out <- data.frame(date = rep(dates, length(layers)),
                      soillayer = layers[gl(length(layers), length(dates))])
    if(addunits) out$date <- as.Date(out$date)
    for(n in output) {
      if(n %in% names(x)) {
        P = x[[n]]
        vars_n <- vars
        if(is.null(vars_n)) vars_n <- names(P)
        for(v in vars_n) {
          M <- P[[v]]
          M <- M[rownames(M) %in% dates, , drop = FALSE]
          out[[v]] <- as.vector(M)
        }
      }
    }
    if(addunits) out <- .addDailyOutputUnits(out, level, "")
  } else if (level =="cohort") {
    plant_level_names <-c("Plants", "LabileCarbonBalance","PlantBiomassBalance", 
                          "PlantStructure", "GrowthMortality")
    if(is.null(output)) {
      output <- plant_level_names
    } else {
      for(i in 1:length(output)) output[i] <-match.arg(output[i], plant_level_names)
    }
    out <- data.frame(date = rep(dates, length(cohnames)),
                      cohort = cohnames[gl(length(cohnames), length(dates))],
                      species = spnames[gl(length(cohnames), length(dates))])
    if(addunits) out$date <- as.Date(out$date)
    for(n in output) {
      if(n %in% names(x)) {
        P <- x[[n]]
        vars_n <- vars
        if(is.null(vars_n)) vars_n <- names(P)
        vars_n <- vars_n[vars_n!="RhizoPsi"]
        for(v in vars_n) {
          M <- P[[v]]
          M <- M[rownames(M) %in% dates, , drop = FALSE]
          out[[v]] <- as.vector(M)
        }
      }
    }
    if(addunits) out <- .addDailyOutputUnits(out, level, "")
  } else if (level =="sunlitleaf") {
    leaf_level_names <-c("SunlitLeaves")
    if(is.null(output)) {
      output <- leaf_level_names
    } else {
      for(i in 1:length(output)) output[i] <-match.arg(output[i], leaf_level_names)
    }
    out <- data.frame(date = rep(dates, length(cohnames)),
                      cohort = cohnames[gl(length(cohnames), length(dates))],
                      species = spnames[gl(length(cohnames), length(dates))],
                      leaftype = "sunlit")
    if(addunits) out$date <- as.Date(out$date)
    for(n in output) {
      if(n %in% names(x)) {
        P = x[[n]]
        if(is.null(vars)) vars <- names(P)
        for(v in vars) {
          M <- P[[v]]
          M <- M[rownames(M) %in% dates, , drop = FALSE]
          out[[v]] <- as.vector(M)
        }
      }
    }
    if(addunits) out <- .addDailyOutputUnits(out, level, "")
  } else if (level =="shadeleaf") {
    leaf_level_names <-c("ShadeLeaves")
    if(is.null(output)) {
      output <- leaf_level_names
    } else {
      for(i in 1:length(output)) output[i] <-match.arg(output[i], leaf_level_names)
    }
    out <- data.frame(date = rep(dates, length(cohnames)),
                      cohort = cohnames[gl(length(cohnames), length(dates))],
                      species = spnames[gl(length(cohnames), length(dates))],
                      leaftype = "shade")
    if(addunits) out$date <- as.Date(out$date)
    for(n in output) {
      if(n %in% names(x)) {
        P = x[[n]]
        if(is.null(vars)) vars <- names(P)
        for(v in vars) {
          M <- P[[v]]
          M <- M[rownames(M) %in% dates, , drop = FALSE]
          out[[v]] <- as.vector(M)
        }
      }
    }
    if(addunits) out <- .addDailyOutputUnits(out, level, "")
  }
  return(out)
}

#' Extracts model outputs
#' 
#' Function \code{extract()} extracts daily or subdaily output and returns it as a tidy data frame.
#' 
#' @param x An object returned by simulation functions \code{\link{spwb}}, \code{\link{aspwb}}, \code{\link{pwb}}, \code{\link{growth}} or \code{\link{fordyn}}.
#' @param level Level of simulation output, either "forest" (stand-level results), "soillayer" (soil layer-level results), "cohort" (cohort-level results), 
#' "sunlitleaf" or "shadeleaf" (leaf-level results)
#' @param output Section of the model output to be explored. See details.
#' @param vars Variables to be extracted (by default, all of them).
#' @param dates A date vector indicating the subset of simulated days for which output is desired.
#' @param subdaily A flag to indicate that subdaily values are desired (see details).
#' @param addunits A flag to indicate that variable units should be added whenever possible.
#' 
#' @details 
#' When \code{subdaily = FALSE}, parameter \code{output} is used to restrict the section in \code{x} where variables are located. For
#' example \code{output = "Plants"} will correspond to variables "LAI", "LAIlive", "Transpiration", "StemPLC",... as returned by a call
#' \code{names(x$Plants)}. 
#' 
#' Option \code{subdaily = TRUE} only works when simulations have been carried using control option 'subdailyResults = TRUE' (see \code{\link{defaultControl}}). 
#' When using \code{subdaily = TRUE}, parameter \code{output} is not taken into account, and options for parameter \code{vars} are the following:
#' \itemize{
#'   \item{Variables for \code{level = "forest"} or \code{level = "soillayer"}: Not allowed. An error is raised.}
#'   \item{Variables for \code{level = "cohort"}: "E","Ag","An","dEdP","RootPsi","StemPsi","LeafPsi","StemPLC","StemRWC","LeafRWC","StemSympRWC","LeafSympRWC","PWB".}
#'   \item{Variables for \code{level = "shadeleaf"} and \code{level="sunlitleaf"}: "Abs_SWR","Abs_PAR","Net_LWR","E","Ag","An","Ci","Gsw","VPD","Temp","Psi","iWUE".}
#' }
#' 
#' @return 
#' Function \code{extract()} returns a data frame:
#' \itemize{
#'   \item{If \code{level = "forest"}, columns are "date" and variable names.}
#'   \item{If \code{level = "soillayer"}, columns are "date", "soillayer" and variable names.} 
#'   \item{If \code{level = "cohort"}, \code{level = "sunlitleaf"} or \code{level = "shadeleaf"}, columns are "date", "cohorts", "species" and variable names.} 
#'   \item{If \code{subdaily = TRUE}, columns are "datetime", "cohorts", "species" and variable names.} 
#' }
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @name extract
#' @examples
#' #Load example daily meteorological data
#' data(examplemeteo)
#' 
#' #Load example plot plant data
#' data(exampleforest)
#' 
#' #Default species parameterization
#' data(SpParamsMED)
#' 
#' #Define soil with default soil params (4 layers)
#' examplesoil <- defaultSoilParams(4)
#' 
#' #Initialize control parameters
#' control <- defaultControl("Granier")
#' 
#' #Initialize input
#' x <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)
#' 
#' #Call simulation function (ten days)
#' S1<-spwb(x, examplemeteo[1:10, ], latitude = 41.82592, elevation = 100)
#' 
#' #Extracts daily forest-level output as a data frame
#' extract(S1, level = "forest", addunits = TRUE)
#'
#' #Extracts daily soil layer-level output as a data frame
#' extract(S1, level = "soillayer", addunits = TRUE)
#' 
#' #Extracts daily cohort-level output as a data frame
#' extract(S1, level = "cohort", addunits = TRUE)
#' 
#' #Select the output tables/variables to be extracted
#' extract(S1, level ="cohort", output="Plants", vars = c("PlantStress", "StemPLC"))
#' 
#' @seealso \code{\link{summary.spwb}}
#' @export
extract<-function(x, level = "forest", output = NULL, vars = NULL, dates = NULL, subdaily = FALSE, addunits = FALSE)  {
  if(inherits(x, "aspwb") || inherits(x, "pwb") || inherits(x, "spwb")|| inherits(x, "growth"))  {
    return(.extractInner(x, level, output, vars, dates, subdaily, addunits))
  } else if (inherits(x, "fordyn")) {
    n <- length(x$GrowthResults)
    out <- data.frame()
    for(i in 1:n) {
      out <- rbind(out, .extractInner(x$GrowthResults[[i]], level, output, vars, dates, subdaily, addunits))
    }
    return(out)
  }
  stop("Wrong class for 'x'. Should be one of 'aswpb', 'pwb', 'spwb', 'growth' or 'fordyn'")
}

library(medfate)

data(examplemeteo)
data(exampleforest)
data(SpParamsMED)
d = 100:105
examplesoil = defaultSoilParams(4)


test_that("Can produce all basic spwb plots and summaries",{
  control = defaultControl("Granier")
  control$verbose = FALSE
  x1 = spwbInput(exampleforest,examplesoil, SpParamsMED, control)
  expect_s3_class(x1, "spwbInput")
  S1<-spwb(x1, examplemeteo[d,], latitude = 41.82592, elevation = 100)
  expect_s3_class(S1, "spwb")
  expect_type(fireHazard(S1, SpParamsMED, exampleforest), "double")
  plot_types <- c("PET_Precipitation", "PET_NetRain", "Snow", "Export", 
                  "Evapotranspiration", "SoilPsi", "SoilRWC", "SoilREW", "SoilTheta", "SoilVol", "PlantExtraction", "HydraulicRedistribution", "LAI", "GroundIrradiance", "PlantLAI", "PlantLAIlive", "PlantTranspiration", "TranspirationPerLeaf", "PlantWaterBalance", "PlantGrossPhotosynthesis", "GrossPhotosynthesisPerLeaf", "FPAR", "AbsorbedSWRFraction", "PlantPsi", "StemRWC", "LeafRWC", "LFMC", "PlantStress", "LeafPLC", "StemPLC")
  for(type in plot_types) {
    expect_s3_class(plot(S1, type), "ggplot")
    expect_s3_class(plot(S1, type, summary.freq = "weeks"), "ggplot")
  }
  expect_type(summary(S1, output = "WaterBalance"), "double")
  expect_type(summary(S1, output = "RWC"), "double")
  expect_type(summary(S1, output = "Stand"), "double")
  expect_type(summary(S1, output = "Plants$LAI"), "double")
  expect_type(summary(S1, output = "AbsorbedSWRFraction"), "double")
  expect_type(summary(S1, output = "Transpiration"), "double")
  expect_type(summary(S1, output = "GrossPhotosynthesis"), "double")
  expect_type(summary(S1, output = "PlantPsi"), "double")
  expect_type(summary(S1, output = "LeafPLC"), "double")
  expect_type(summary(S1, output = "StemPLC"), "double")
  expect_type(summary(S1, output = "PlantStress"), "double")
  expect_type(droughtStress(S1, index = "ADS", draw=FALSE), "double")
  expect_type(waterUseEfficiency(S1, type = "Plant Ag/E", draw=FALSE), "double")
  expect_type(waterUseEfficiency(S1, type = "Stand Ag/E", draw=FALSE), "double")
  expect_s3_class(extract(S1, level = "forest"), "data.frame")
  expect_s3_class(extract(S1, level = "soillayer"), "data.frame")
  expect_s3_class(extract(S1, level = "cohort"), "data.frame")
})

test_that("Can produce all aspwb plots and summaries",{
  control <- defaultControl("Granier")
  control$verbose <- FALSE
  x1 <- aspwbInput(0.75, control, examplesoil)
  expect_s3_class(x1, "aspwbInput")
  S1 <- aspwb(x1, examplemeteo, latitude = 41.82592, elevation = 100)
  expect_s3_class(S1, "aspwb")
  expect_s3_class(plot(S1, "PET_Precipitation"), "ggplot")
  expect_s3_class(plot(S1, "Snow"), "ggplot")
  expect_s3_class(plot(S1, "Export"), "ggplot")
  expect_s3_class(plot(S1, "Evapotranspiration"), "ggplot")
  expect_s3_class(plot(S1, "SoilPsi"), "ggplot")
  expect_s3_class(plot(S1, "SoilREW"), "ggplot")
  expect_s3_class(plot(S1, "SoilRWC"), "ggplot")
  expect_s3_class(plot(S1, "SoilTheta"), "ggplot")
  expect_s3_class(plot(S1, "SoilVol"), "ggplot")
  expect_type(summary(S1, output = "WaterBalance"), "double")
  expect_type(summary(S1, output = "RWC", FUN = "mean"), "double")
  expect_s3_class(extract(S1, level = "soillayer"), "data.frame")
})

test_that("Can produce all advanced spwb plots and summaries",{
  for(transpirationMode in c("Sperry", "Sureau")) {
    control = defaultControl(transpirationMode)
    control$verbose = FALSE
    x2 = spwbInput(exampleforest,examplesoil, SpParamsMED, control)
    coh_1 = row.names(x2$cohorts)[1]
    expect_s3_class(x2, "spwbInput")
    S2<-spwb(x2, examplemeteo[d,], latitude = 41.82592, elevation = 100)
    expect_s3_class(S2, "spwb")
    expect_type(fireHazard(S2, SpParamsMED, exampleforest), "double")
    expect_s3_class(plot(S2, "SoilPlantConductance"), "ggplot")
    expect_s3_class(plot(S2, "LeafPsiMin"), "ggplot")
    expect_s3_class(plot(S2, "LeafPsiMax"), "ggplot")
    expect_s3_class(plot(S2, "LeafPsiRange"), "ggplot")
    expect_s3_class(plot(S2, "StemPsi"), "ggplot")
    expect_s3_class(plot(S2, "RootPsi"), "ggplot")
    expect_s3_class(plot(S2, "TempMin_SL"), "ggplot")
    expect_s3_class(plot(S2, "TempMin_SH"), "ggplot")
    expect_s3_class(plot(S2, "TempMax_SL"), "ggplot")
    expect_s3_class(plot(S2, "TempMax_SH"), "ggplot")
    expect_s3_class(plot(S2, "GSWMin_SL"), "ggplot")
    expect_s3_class(plot(S2, "GSWMin_SH"), "ggplot")
    expect_s3_class(plot(S2, "GSWMax_SL"), "ggplot")
    expect_s3_class(plot(S2, "GSWMax_SH"), "ggplot")
    expect_s3_class(plot(S2, "LeafPsiMin_SL"), "ggplot")
    expect_s3_class(plot(S2, "LeafPsiMin_SH"), "ggplot")
    expect_s3_class(plot(S2, "LeafPsiMax_SL"), "ggplot")
    expect_s3_class(plot(S2, "LeafPsiMax_SH"), "ggplot")
    expect_s3_class(plot(S2, "StemRWC"), "ggplot")
    expect_s3_class(plot(S2, "LeafRWC"), "ggplot")
    expect_s3_class(plot(S2, "LFMC"), "ggplot")
    expect_s3_class(plot(S2, "PlantWaterBalance"), "ggplot")
    expect_s3_class(plot(S2, "PlantNetPhotosynthesis"), "ggplot")
    expect_s3_class(plot(S2, "NetPhotosynthesisPerLeaf"), "ggplot")
    expect_s3_class(plot(S2, "PlantWUE"), "ggplot")
    expect_s3_class(plot(S2, "PlantAbsorbedSWR"), "ggplot")
    expect_s3_class(plot(S2, "AbsorbedSWRPerLeaf"), "ggplot")
    expect_s3_class(plot(S2, "PlantNetLWR"), "ggplot")
    expect_s3_class(plot(S2, "NetLWRPerLeaf"), "ggplot")
    expect_s3_class(plot(S2, "Temperature"), "ggplot")
    expect_s3_class(plot(S2, "AirTemperature"), "ggplot")
    expect_s3_class(plot(S2, "CanopyTemperature"), "ggplot")
    expect_s3_class(plot(S2, "SoilTemperature"), "ggplot")
    expect_s3_class(plot(S2, "CanopyEnergyBalance"), "ggplot")
    expect_s3_class(plot(S2, "SoilEnergyBalance"), "ggplot")
    expect_type(summary(S2, output = "AbsorbedSWR"), "double")
    expect_type(summary(S2, output = "NetLWR"), "double")
    expect_type(summary(S2, output = "NetPhotosynthesis"), "double")
    expect_type(summary(S2, output = "dEdP"), "double")
    expect_type(summary(S2, output = "PlantWaterBalance"), "double")
    expect_type(summary(S2, output = "LeafPsiMin"), "double")
    expect_type(summary(S2, output = "LeafPsiMax"), "double")
    expect_type(summary(S2, output = "LeafRWC"), "double")
    expect_type(summary(S2, output = "StemRWC"), "double")
    expect_type(summary(S2, output = "LFMC"), "double")
    expect_type(summary(S2, output = "StemPsi"), "double")
    expect_type(summary(S2, output = "RootPsi"), "double")
    expect_type(summary(S2, output = "SunlitLeaves$LeafPsiMin"), "double")
    expect_type(summary(S2, output = "ShadeLeaves$LeafPsiMin"), "double")
    expect_type(summary(S2, output = "SunlitLeaves$LeafPsiMax"), "double")
    expect_type(summary(S2, output = "ShadeLeaves$LeafPsiMax"), "double")
    expect_type(summary(S2, output = "SunlitLeaves$TempMin"), "double")
    expect_type(summary(S2, output = "ShadeLeaves$TempMin"), "double")
    expect_type(summary(S2, output = "SunlitLeaves$TempMax"), "double")
    expect_type(summary(S2, output = "ShadeLeaves$TempMax"), "double")
    expect_type(summary(S2, output = "SunlitLeaves$GSWMin"), "double")
    expect_type(summary(S2, output = "ShadeLeaves$GSWMin"), "double")
    expect_type(summary(S2, output = "SunlitLeaves$GSWMax"), "double")
    expect_type(summary(S2, output = "ShadeLeaves$GSWMax"), "double")
    expect_type(droughtStress(S2, index = "ADS", draw=FALSE), "double")
    expect_type(waterUseEfficiency(S2, "Plant An/E", draw=FALSE), "double")
    expect_type(waterUseEfficiency(S2, "Stand An/E", draw=FALSE), "double")
    expect_type(resistances(S2, cohort = coh_1, draw=FALSE), "list")
    expect_s3_class(extract(S2, level = "shadeleaf"), "data.frame")
    expect_s3_class(extract(S2, level = "sunlitleaf"), "data.frame")
  }
})

test_that("Can produce all advanced subdaily spwb plots",{
  for(transpirationMode in c("Sperry", "Sureau")) {
    control = defaultControl(transpirationMode)
    control$verbose <- FALSE
    control$subdailyResults <- TRUE
    x2 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)
    expect_s3_class(x2, "spwbInput")
    S2<-spwb(x2, examplemeteo[d,], latitude = 41.82592, elevation = 100)
    expect_s3_class(S2, "spwb")
    
    expect_s3_class(plot(S2, "LeafPsi", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "LeafPsiAverage", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "RootPsi", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "StemPsi", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "StemRWC", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "LeafRWC", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "StemPLC", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "StemSympRWC", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "LeafSympRWC", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "StemSympPsi", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "LeafSympPsi", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "PlantExtraction", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "PlantTranspiration", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "LeafTranspiration", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "TranspirationPerLeaf", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "PlantGrossPhotosynthesis", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "LeafGrossPhotosynthesis", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "PlantNetPhotosynthesis", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "LeafNetPhotosynthesis", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "LeafAbsorbedPAR", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "LeafAbsorbedSWR", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "LeafNetLWR", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "LeafCi", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "LeafIntrinsicWUE", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "LeafVPD", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "LeafStomatalConductance", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "LeafTemperature", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "Temperature", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(S2, "PlantWaterBalance", subdaily = TRUE), "ggplot")
    expect_type(waterUseEfficiency(S2, type = "Leaf Ci", draw=FALSE), "double")
    expect_type(waterUseEfficiency(S2, type = "Leaf iWUE", draw=FALSE), "double")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="E"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="Ag"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="An"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="dEdP"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="RootPsi"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="StemPsi"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="StemPLC"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="StemRWC"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="LeafRWC"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="StemSympRWC"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="LeafSympRWC"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="PWB"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="Temperature"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="ExtractionInst"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="SunlitLeaves$Abs_PAR"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="SunlitLeaves$Abs_SWR"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="SunlitLeaves$Net_LWR"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="SunlitLeaves$E"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="SunlitLeaves$Ag"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="SunlitLeaves$An"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="SunlitLeaves$Ci"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="SunlitLeaves$Gsw"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="SunlitLeaves$VPD"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="SunlitLeaves$Temp"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="SunlitLeaves$Psi"), "data.frame")
    expect_s3_class(medfate:::.extractSubdaily(S2, output="SunlitLeaves$iWUE"), "data.frame")    
  }    
})

test_that("Can produce all advanced spwb_day plots",{
  for(transpirationMode in c("Sperry", "Sureau")) {
    control = defaultControl(transpirationMode)
    control$verbose <- TRUE
    control$subdailyResults <- TRUE
    x2 = spwbInput(exampleforest,examplesoil, SpParamsMED, control)
    expect_s3_class(x2, "spwbInput")
    d1 = d[1]
    sd2<-spwb_day(x2, examplemeteo$dates[d1],
                  unlist(examplemeteo[d1,]), 
                  latitude = 41.82592, elevation = 100, slope=0, aspect=0)
    expect_s3_class(sd2, "spwb_day")
    expect_type(fireHazard(sd2, SpParamsMED, exampleforest), "double")
    expect_s3_class(plot(sd2, "LeafPsi"), "ggplot")
    expect_s3_class(plot(sd2, "LeafPsiAverage"), "ggplot")
    expect_s3_class(plot(sd2, "RootPsi"), "ggplot")
    expect_s3_class(plot(sd2, "StemPsi"), "ggplot")
    expect_s3_class(plot(sd2, "StemPLC"), "ggplot")
    expect_s3_class(plot(sd2, "StemRWC"), "ggplot")
    expect_s3_class(plot(sd2, "LeafRWC"), "ggplot")
    expect_s3_class(plot(sd2, "StemSympRWC"), "ggplot")
    expect_s3_class(plot(sd2, "LeafSympRWC"), "ggplot")
    expect_s3_class(plot(sd2, "SoilPlantConductance"), "ggplot")
    expect_s3_class(plot(sd2, "PlantExtraction"), "ggplot")
    expect_s3_class(plot(sd2, "PlantTranspiration"), "ggplot")
    expect_s3_class(plot(sd2, "TranspirationPerLeaf"), "ggplot")
    expect_s3_class(plot(sd2, "PlantGrossPhotosynthesis"), "ggplot")
    expect_s3_class(plot(sd2, "GrossPhotosynthesisPerLeaf"), "ggplot")
    expect_s3_class(plot(sd2, "PlantNetPhotosynthesis"), "ggplot")
    expect_s3_class(plot(sd2, "NetPhotosynthesisPerLeaf"), "ggplot")
    expect_s3_class(plot(sd2, "LeafTranspiration"), "ggplot")
    expect_s3_class(plot(sd2, "LeafGrossPhotosynthesis"), "ggplot")
    expect_s3_class(plot(sd2, "LeafNetPhotosynthesis"), "ggplot")
    expect_s3_class(plot(sd2, "LeafAbsorbedSWR"), "ggplot")
    expect_s3_class(plot(sd2, "LeafAbsorbedPAR"), "ggplot")
    expect_s3_class(plot(sd2, "LeafNetLWR"), "ggplot")
    expect_s3_class(plot(sd2, "LeafCi"), "ggplot")
    expect_s3_class(plot(sd2, "LeafIntrinsicWUE"), "ggplot")
    expect_s3_class(plot(sd2, "LeafStomatalConductance"), "ggplot")
    expect_s3_class(plot(sd2, "LeafTemperature"), "ggplot")
    expect_s3_class(plot(sd2, "Temperature"), "ggplot")
    expect_s3_class(plot(sd2, "CanopyEnergyBalance"), "ggplot")
    expect_s3_class(plot(sd2, "SoilEnergyBalance"), "ggplot")
    expect_s3_class(plot(sd2, "PlantWaterBalance"), "ggplot")
    expect_s3_class(plot(sd2, "WaterBalancePerLeaf"), "ggplot")    
  }
})

test_that("Can produce all basic growth plots and summaries",{
  examplesoil = defaultSoilParams(4)
  control = defaultControl("Granier")
  control$verbose = FALSE
  x1 = growthInput(exampleforest,examplesoil, SpParamsMED, control)
  expect_s3_class(x1, "growthInput")
  G1<-growth(x1, examplemeteo[d,], latitude = 41.82592, elevation = 100)
  expect_s3_class(G1, "growth")
  
  expect_type(fireHazard(G1, SpParamsMED, exampleforest), "double")
  expect_s3_class(plot(G1, "CarbonBalance"), "ggplot")
  expect_s3_class(plot(G1, "DecompositionPools"), "ggplot")
  expect_s3_class(plot(G1, "BiomassBalance"), "ggplot")
  expect_s3_class(plot(G1, "GrossPhotosynthesis"), "ggplot")
  expect_s3_class(plot(G1, "MaintenanceRespiration"), "ggplot")
  expect_s3_class(plot(G1, "LabileCarbonBalance"), "ggplot")
  expect_s3_class(plot(G1, "SugarLeaf"), "ggplot")
  expect_s3_class(plot(G1, "StarchLeaf"), "ggplot")
  expect_s3_class(plot(G1, "SugarSapwood"), "ggplot")
  expect_s3_class(plot(G1, "StarchSapwood"), "ggplot")
  expect_s3_class(plot(G1, "SugarTransport"), "ggplot")
  expect_s3_class(plot(G1, "RootExudation"), "ggplot")
  expect_s3_class(plot(G1, "StructuralBiomassBalance"), "ggplot")
  expect_s3_class(plot(G1, "LabileBiomassBalance"), "ggplot")
  expect_s3_class(plot(G1, "PlantBiomassBalance"), "ggplot")
  expect_s3_class(plot(G1, "MortalityBiomassLoss"), "ggplot")
  expect_s3_class(plot(G1, "CohortBiomassBalance"), "ggplot")
  expect_s3_class(plot(G1, "SapwoodArea"), "ggplot")
  expect_s3_class(plot(G1, "LeafArea"), "ggplot")
  expect_s3_class(plot(G1, "FineRootBiomass"), "ggplot")
  expect_s3_class(plot(G1, "DBH"), "ggplot")
  expect_s3_class(plot(G1, "Height"), "ggplot")
  expect_s3_class(plot(G1, "SAgrowth"), "ggplot")
  expect_s3_class(plot(G1, "LAgrowth"), "ggplot")
  expect_s3_class(plot(G1, "HuberValue"), "ggplot")
  expect_type(summary(G1, output = "CarbonBalance"), "double")
  expect_type(summary(G1, output = "LabileCarbonBalance$GrossPhotosynthesis"), "double")
  expect_type(summary(G1, output = "MaintenanceRespiration"), "double")
  expect_type(summary(G1, output = "GrowthCosts"), "double")
  expect_type(summary(G1, output = "RootExudation"), "double")
  expect_type(summary(G1, output = "LabileCarbonBalance"), "double")
  expect_type(summary(G1, output = "SugarLeaf"), "double")
  expect_type(summary(G1, output = "StarchLeaf"), "double")
  expect_type(summary(G1, output = "SugarSapwood"), "double")
  expect_type(summary(G1, output = "StarchSapwood"), "double")
  expect_type(summary(G1, output = "SugarTransport"), "double")
  expect_type(summary(G1, output = "LeafArea"), "double")
  expect_type(summary(G1, output = "SapwoodArea"), "double")
  expect_type(summary(G1, output = "FineRootBiomass"), "double")
  expect_type(summary(G1, output = "LAgrowth"), "double")
  expect_type(summary(G1, output = "SAgrowth"), "double")
  expect_type(droughtStress(G1, index = "ADS", draw=FALSE), "double")
  expect_type(waterUseEfficiency(G1, type = "Plant Ag/E", draw=FALSE), "double")
  expect_type(waterUseEfficiency(G1, type = "Stand Ag/E", draw=FALSE), "double")
  
})

test_that("Can produce all advanced growth plots and summaries",{
  for(transpirationMode in c("Sperry", "Sureau")) {
    control = defaultControl(transpirationMode)
    control$verbose = FALSE
    x2 = growthInput(exampleforest,examplesoil, SpParamsMED, control)
    coh_1 = row.names(x2$cohorts)[1]
    expect_s3_class(x2, "growthInput")
    G2<-growth(x2, examplemeteo[d,], latitude = 41.82592, elevation = 100)
    expect_s3_class(G2, "growth")
    expect_type(fireHazard(G2, SpParamsMED, exampleforest), "double")
    expect_s3_class(plot(G2, "FineRootArea"), "ggplot")
    expect_s3_class(plot(G2, "FRAgrowth"), "ggplot")
    expect_s3_class(plot(G2, "RootAreaLeafArea"), "ggplot")
    expect_type(summary(G2, output = "FineRootArea"), "double")
    expect_type(summary(G2, output = "FRAgrowth"), "double")
    expect_type(droughtStress(G2, index = "ADS", draw=FALSE), "double")
    expect_type(waterUseEfficiency(G2, "Plant An/E", draw=FALSE), "double")
    expect_type(waterUseEfficiency(G2, "Stand An/E", draw=FALSE), "double")  
    expect_type(resistances(G2, cohort = coh_1, draw=FALSE), "list")
  }  
})

test_that("Can produce all advanced subdaily growth plots",{
  for(transpirationMode in c("Sperry", "Sureau")) {
    control = defaultControl(transpirationMode)
    control$verbose <- FALSE
    control$subdailyResults <- TRUE
    control$subdailyCarbonBalance <- TRUE
    x2 = growthInput(exampleforest,examplesoil, SpParamsMED, control)
    expect_s3_class(x2, "growthInput")
    G2<-growth(x2, examplemeteo[d,], latitude = 41.82592, elevation = 100)
    expect_s3_class(G2, "growth")
    
    expect_s3_class(plot(G2, "GrossPhotosynthesis", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(G2, "MaintenanceRespiration", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(G2, "GrowthCosts", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(G2, "RootExudation", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(G2, "LabileCarbonBalance", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(G2, "SugarTransport", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(G2, "SugarLeaf", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(G2, "SugarSapwood", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(G2, "StarchLeaf", subdaily = TRUE), "ggplot")
    expect_s3_class(plot(G2, "StarchSapwood", subdaily = TRUE), "ggplot")
    expect_type(waterUseEfficiency(G2, type = "Leaf Ci", draw=FALSE), "double")
    expect_type(waterUseEfficiency(G2, type = "Leaf iWUE", draw=FALSE), "double")
    expect_s3_class(.extractSubdaily(G2, output="GrossPhotosynthesis"), "data.frame")
    expect_s3_class(.extractSubdaily(G2, output="MaintenanceRespiration"), "data.frame")
    expect_s3_class(.extractSubdaily(G2, output="GrowthCosts"), "data.frame")
    expect_s3_class(.extractSubdaily(G2, output="RootExudation"), "data.frame")
    expect_s3_class(.extractSubdaily(G2, output="LabileCarbonBalance"), "data.frame")
    expect_s3_class(.extractSubdaily(G2, output="SugarLeaf"), "data.frame")
    expect_s3_class(.extractSubdaily(G2, output="SugarSapwood"), "data.frame")
    expect_s3_class(.extractSubdaily(G2, output="StarchLeaf"), "data.frame")
    expect_s3_class(.extractSubdaily(G2, output="StarchSapwood"), "data.frame")
    expect_s3_class(.extractSubdaily(G2, output="SugarTransport"), "data.frame")
  }
})

test_that("Can produce all advanced growth_day plots",{
  for(transpirationMode in c("Sperry", "Sureau")) {
    control = defaultControl(transpirationMode)
    control$verbose <- FALSE
    control$subdailyResults <- TRUE
    control$subdailyCarbonBalance <- TRUE
    x2 <- growthInput(exampleforest,examplesoil, SpParamsMED, control)
    expect_s3_class(x2, "growthInput")
    d1 <- d[1]
    sd2<-growth_day(x2, examplemeteo$dates[d1],
                    unlist(examplemeteo[d1,]), 
                    latitude = 41.82592, elevation = 100, slope=0, aspect=0)
    expect_s3_class(sd2, "growth_day")
    expect_type(fireHazard(sd2, SpParamsMED, exampleforest), "double")
    expect_s3_class(plot(sd2, "GrossPhotosynthesis"), "ggplot")
    expect_s3_class(plot(sd2, "MaintenanceRespiration"), "ggplot")
    expect_s3_class(plot(sd2, "RootExudation"), "ggplot")
    expect_s3_class(plot(sd2, "LabileCarbonBalance"), "ggplot")
    expect_s3_class(plot(sd2, "SugarLeaf"), "ggplot")
    expect_s3_class(plot(sd2, "StarchLeaf"), "ggplot")
    expect_s3_class(plot(sd2, "SugarSapwood"), "ggplot")
    expect_s3_class(plot(sd2, "StarchSapwood"), "ggplot")
    expect_s3_class(plot(sd2, "SugarTransport"), "ggplot")
  }  
})

test_that("Can produce all fordyn plots",{
  control <- defaultControl("Granier")
  control$verbose <- FALSE
  fd<-fordyn(exampleforest, examplesoil, 
             SpParamsMED, examplemeteo, control,
             latitude = 41.82592, elevation = 100)
  expect_s3_class(plot(fd, "PET_Precipitation"), "ggplot")
  expect_s3_class(plot(fd, "PET_NetRain"), "ggplot")
  expect_s3_class(plot(fd, "Snow"), "ggplot")
  expect_s3_class(plot(fd, "Export"), "ggplot")
  expect_s3_class(plot(fd, "Evapotranspiration"), "ggplot")
  expect_s3_class(plot(fd, "SoilPsi"), "ggplot")
  expect_s3_class(plot(fd, "SoilREW"), "ggplot")
  expect_s3_class(plot(fd, "SoilRWC"), "ggplot")
  expect_s3_class(plot(fd, "SoilTheta"), "ggplot")
  expect_s3_class(plot(fd, "SoilVol"), "ggplot")
  expect_s3_class(plot(fd, "PlantExtraction"), "ggplot")
  expect_s3_class(plot(fd, "HydraulicRedistribution"), "ggplot")
  expect_s3_class(plot(fd, "LAI"), "ggplot")
  expect_s3_class(plot(fd, "PlantLAI"), "ggplot")
  expect_s3_class(plot(fd, "PlantLAIlive"), "ggplot")
  expect_s3_class(plot(fd, "PlantStress"), "ggplot")
  expect_s3_class(plot(fd, "LeafPLC"), "ggplot")
  expect_s3_class(plot(fd, "StemPLC"), "ggplot")
  expect_s3_class(plot(fd, "PlantPsi"), "ggplot")
  expect_s3_class(plot(fd, "PlantTranspiration"), "ggplot")
  expect_s3_class(plot(fd, "TranspirationPerLeaf"), "ggplot")
  expect_s3_class(plot(fd, "PlantGrossPhotosynthesis"), "ggplot")
  expect_s3_class(plot(fd, "GrossPhotosynthesisPerLeaf"), "ggplot")
  expect_s3_class(plot(fd, "CarbonBalance"), "ggplot")
  expect_s3_class(plot(fd, "DecompositionPools"), "ggplot")
  expect_s3_class(plot(fd, "BiomassBalance"), "ggplot")
  expect_s3_class(plot(fd, "GrossPhotosynthesis"), "ggplot")
  expect_s3_class(plot(fd, "MaintenanceRespiration"), "ggplot")
  expect_s3_class(plot(fd, "LabileCarbonBalance"), "ggplot")
  expect_s3_class(plot(fd, "SugarLeaf"), "ggplot")
  expect_s3_class(plot(fd, "StarchLeaf"), "ggplot")
  expect_s3_class(plot(fd, "SugarSapwood"), "ggplot")
  expect_s3_class(plot(fd, "StarchSapwood"), "ggplot")
  expect_s3_class(plot(fd, "SugarTransport"), "ggplot")
  expect_s3_class(plot(fd, "RootExudation"), "ggplot")
  expect_s3_class(plot(fd, "StructuralBiomassBalance"), "ggplot")
  expect_s3_class(plot(fd, "LabileBiomassBalance"), "ggplot")
  expect_s3_class(plot(fd, "PlantBiomassBalance"), "ggplot")
  expect_s3_class(plot(fd, "MortalityBiomassLoss"), "ggplot")
  expect_s3_class(plot(fd, "CohortBiomassBalance"), "ggplot")
  expect_s3_class(plot(fd, "SapwoodArea"), "ggplot")
  expect_s3_class(plot(fd, "LeafArea"), "ggplot")
  expect_s3_class(plot(fd, "FineRootBiomass"), "ggplot")
  expect_s3_class(plot(fd, "DBH"), "ggplot")
  expect_s3_class(plot(fd, "Height"), "ggplot")
  expect_s3_class(plot(fd, "SAgrowth"), "ggplot")
  expect_s3_class(plot(fd, "LAgrowth"), "ggplot")
  expect_s3_class(plot(fd, "HuberValue"), "ggplot")
  expect_s3_class(plot(fd, "NumTreeSpecies"), "ggplot")
  expect_s3_class(plot(fd, "NumTreeCohorts"), "ggplot")
  expect_s3_class(plot(fd, "NumShrubSpecies"), "ggplot")
  expect_s3_class(plot(fd, "NumShrubCohorts"), "ggplot")
  expect_s3_class(plot(fd, "StandBasalArea"), "ggplot")
  expect_s3_class(plot(fd, "StandDensity"), "ggplot")
  expect_s3_class(plot(fd, "StandShrubCover"), "ggplot")
  expect_s3_class(plot(fd, "SpeciesBasalArea"), "ggplot")
  expect_s3_class(plot(fd, "SpeciesDensity"), "ggplot")
  expect_s3_class(plot(fd, "SpeciesShrubCover"), "ggplot")
  expect_s3_class(plot(fd, "CohortBasalArea"), "ggplot")
  expect_s3_class(plot(fd, "CohortDensity"), "ggplot")
  expect_s3_class(plot(fd, "CohortShrubCover"), "ggplot")
  expect_s3_class(plot(fd, "DominantTreeHeight"), "ggplot")
  expect_s3_class(plot(fd, "DominantTreeDiameter"), "ggplot")
  expect_s3_class(plot(fd, "QuadraticMeanTreeDiameter"), "ggplot")
  expect_s3_class(plot(fd, "HartBeckingIndex"), "ggplot")
  expect_s3_class(extract(fd, level = "forest"), "data.frame")
  expect_s3_class(extract(fd, level = "soillayer"), "data.frame")
  expect_s3_class(extract(fd, level = "cohort"), "data.frame")
})

#' Plots simulation results
#'
#' Function \code{plot} plots time series of the results of the soil plant water balance model (see \code{\link{spwb}}), 
#' plant water balance model (see \code{\link{pwb}}), the forest growth model (see \code{\link{growth}}) 
#' or the forest dynamics model (see \code{\link{fordyn}}).
#' 
#' @param x An object of class \code{spwb}, \code{pwb}, \code{growth} or \code{fordyn}.
#' @param type The information to be plotted (see details)
#' @param cohorts An integer, boolean or character vector to select the plant cohorts to be plotted. If \code{cohorts = "T"} (resp. \code{cohorts = "S"}) then all tree (resp. shrub) cohorts will be displayed.
#' @param bySpecies Allows aggregating output by species, before drawing plots (only has an effect with some values of \code{type}). Aggregation can involve a sum (as for plant lai or transpiration) or a LAI-weighted mean (as for plant stress or plant water potential), where LAI values are those of \code{LAIlive}.
#' @param dates A Date vector with a subset of dates to be plotted.
#' @param subdaily Whether subdaily results should be shown, only for simulations using \code{transpirationMode = "Sperry"} and having set \code{subdailyResults = TRUE} in the simulation control object. If \code{subdaily = TRUE}, then the valid strings for \code{type} are listed in \code{\link{plot.spwb_day}}.
#' @param xlim Range of values for x.
#' @param ylim Range of values for y.
#' @param xlab x-axis label.
#' @param ylab y-axis label.
#' @param summary.freq Frequency of summary statistics (see \code{\link{cut.Date}}).
#' @param ... Additional parameters for function \code{plot} (not used).
#' 
#' 
#' @details 
#' The following plots are currently available for \code{\link{spwb}} (most of them also for \code{\link{pwb}}):
#' \itemize{
#'   \item{\code{"PET_Precipitation"}: Potential evapotranspiration and Precipitation.}
#'   \item{\code{"PET_NetRain"}: Potential evapotranspiration and Net rainfall.}
#'   \item{\code{"Snow"}: Snow precipitation and snowpack dynamics.}
#'   \item{\code{"Export"}: Water exported through deep drainage and surface runoff.}
#'   \item{\code{"Evapotranspiration"}: Plant transpiration and soil evaporation.}
#'   \item{\code{"SoilPsi"}: Soil water potential.}
#'   \item{\code{"SoilRWC"}: Soil relative water content (in percent of field capacity).}
#'   \item{\code{"SoilTheta"}: Soil moisture water content (in percent volume).}
#'   \item{\code{"SoilVol"}: Soil water volumetric content (in mm).}
#'   \item{\code{"PlantExtraction"}: Water extracted by plants from each soil layer.}
#'   \item{\code{"HydraulicRedistribution"}: Water added to each soil layer coming from other soil layers, transported through the plant hydraulic network.}
#'   \item{\code{"LAI"}: Expanded and dead leaf area index of the whole stand.}
#'   \item{\code{"PlantLAI"}: Plant cohort leaf area index (expanded leaves).}
#'   \item{\code{"PlantLAIlive"}: Plant cohort leaf area index ("live" leaves).}
#'   \item{\code{"PlantStress"}: Plant cohort average daily drought stress.}
#'   \item{\code{"PlantTranspiration"}: Plant cohort transpiration.}
#'   \item{\code{"TranspirationPerLeaf"}: Plant cohort transpiration per leaf area.}
#'   \item{\code{"PlantGrossPhotosynthesis"}: Plant cohort photosynthesis.}
#'   \item{\code{"GrossPhotosynthesisPerLeaf"}: Plant cohort photosynthesis per leaf area.}
#'   \item{\code{"StemRWC"}: Average daily stem relative water content.}
#'   \item{\code{"LeafRWC"}: Average daily leaf relative water content.}
#'   \item{\code{"LFMC"}: Live fuel moisture content.}
#' }
#' The following plots are available for \code{\link{spwb}} and \code{\link{pwb}} \emph{only if} \code{transpirationMode = "Granier"}:
#'   \itemize{
#'     \item{\code{"PlantPsi"}: Plant cohort water potential.}
#'     \item{\code{"FPAR"}: Fraction of PAR at the canopy level of each plant cohort.}
#'     \item{\code{"AbsorbedSWRFraction"}: Fraction of SWR absorbed by each plant cohort.}
#'   }
#' The following plots are available for \code{\link{spwb}} and \code{\link{pwb}} \emph{only if} \code{transpirationMode = "Sperry"}:
#'   \itemize{
#'     \item{\code{"SoilPlantConductance"}: Average instantaneous overall soil plant conductance (calculated as the derivative of the supply function).}
#'     \item{\code{"LeafPsiMin"}:  Midday leaf water potential.}
#'     \item{\code{"LeafPsiMax"}:  Pre-dawn leaf water potential.}
#'     \item{\code{"LeafPsiRange"}:  Range of leaf water potential.}
#'     \item{\code{"LeafPsiMin_SL"}: Minimum water potential of sunlit leaves.}
#'     \item{\code{"LeafPsiMax_SL"}: Maximum water potential of sunlit leaves.}
#'     \item{\code{"LeafPsiMin_SH"}: Minimum water potential of shade leaves.}
#'     \item{\code{"LeafPsiMax_SH"}: Maximum water potential of shade leaves.}
#'     \item{\code{"TempMin_SL"}: Minimum temperature of sunlit leaves.}
#'     \item{\code{"TempMax_SL"}: Maximum temperature of sunlit leaves.}
#'     \item{\code{"TempMin_SH"}: Minimum temperature of shade leaves.}
#'     \item{\code{"TempMax_SH"}: Maximum temperature of shade leaves.}
#'     \item{\code{"GSWMin_SL"}: Minimum stomatal conductance of sunlit leaves.}
#'     \item{\code{"GSWMax_SL"}: Maximum stomatal conductance of sunlit leaves.}
#'     \item{\code{"GSWMin_SH"}: Minimum stomatal conductance of shade leaves.}
#'     \item{\code{"GSWMax_SH"}: Maximum stomatal conductance of shade leaves.}
#'     \item{\code{"StemPsi"}:  Midday (upper) stem water potential.}
#'     \item{\code{"RootPsi"}:  Midday root crown water potential.}
#'     \item{\code{"PlantNetPhotosynthesis"}:  Plant cohort net photosynthesis.}
#'     \item{\code{"NetPhotosynthesisPerLeaf"}:  Plant cohort net photosynthesis per leaf area.}
#'     \item{\code{"PlantWUE"}:  Plant cohort daily water use efficiency.}
#'     \item{\code{"PlantAbsorbedSWR"}:  Plant cohort absorbed short wave radiation.}
#'     \item{\code{"AbsorbedSWRPerLeaf"}:  Plant cohort absorbed short wave radiation per leaf area.}
#'     \item{\code{"PlantNetLWR"}:  Plant cohort net long wave radiation.}
#'     \item{\code{"NetLWRPerLeaf"}:  Plant cohort net long wave radiation per leaf area.}
#'     \item{\code{"AirTemperature"}:  Minimum/maximum/mean daily temperatures above canopy.}
#'     \item{\code{"CanopyTemperature"}:  Minimum/maximum/mean daily temperatures inside canopy.}
#'     \item{\code{"SoilTemperature"}:  Minimum/maximum/mean daily temperatures inside the first soil layer.}
#'     \item{\code{"CanopyEnergyBalance"}:  Canopy energy balance components.}
#'     \item{\code{"SoilEnergyBalance"}:  Soil energy balance components.}
#'   }
#' In addition to the former, the following plots are available for objects \code{\link{growth}} or \code{\link{fordyn}}:
#'   \itemize{
#'     \item{\code{"CarbonBalance"}:  Stand-level carbon balance components.}
#'     \item{\code{"BiomassBalance"}:  Stand-level biomass balance components.}
#'     \item{\code{"GrossPhotosynthesis"}:  Gross photosynthesis rate per dry weight.}
#'     \item{\code{"MaintenanceRespiration"}:  Maintenance respiration cost per dry weight.}
#'     \item{\code{"PhotosynthesisMaintenanceRatio"}:  The ratio of gross photosynthesis over maintenance respiration.}
#'     \item{\code{"RootExudation"}:  Root exudation rate per dry weight.}
#'     \item{\code{"LabileCarbonBalance"}:  Labile carbon balance per dry weight.}
#'     \item{\code{"SugarLeaf"}:  Sugar concentration in leaves.}
#'     \item{\code{"StarchLeaf"}:  Starch concentration in leaves.}
#'     \item{\code{"SugarSapwood"}:  Sugar concentration in sapwood.}
#'     \item{\code{"StarchSapwood"}:  Starch concentration in sapwood.}
#'     \item{\code{"SugarTransport"}:  Phloem sugar transport rate.}
#'     \item{\code{"StructuralBiomassBalance"}:  Daily structural biomass balance (g dry · ind-2).}
#'     \item{\code{"LabileBiomassBalance"}:  Daily labile biomass balance (g dry · ind-2).}
#'     \item{\code{"PlantBiomassBalance"}:  Daily plant biomass balance, i.e. labile change + structural change (g dry · ind-2).}
#'     \item{\code{"MortalityBiomassLoss"}:  Biomass loss due to mortality (g dry · m-2).}    
#'     \item{\code{"PlantBiomassBalance"}:  Daily cohort biomass balance (including mortality) (g dry · m-2).}
#'     \item{\code{"LeafBiomass"}: Leaf structural dry biomass per individual.}
#'     \item{\code{"SapwoodBiomass"}: Sapwood dry biomass per individual.}
#'     \item{\code{"FineRootBiomass"}: Fine root dry biomass per individual.}
#'     \item{\code{"SapwoodArea"}:  Sapwood area per individual.}
#'     \item{\code{"LeafArea"}:  Leaf area per individual.}
#'     \item{\code{"FineRootArea"}: Fine root area per individual (only for \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}).}
#'     \item{\code{"DBH"}: Diameter at breast height (in cm) for an average individual of each plant cohort.}
#'     \item{\code{"Height"}: Height (in cm) for an average individual of each plant cohort.}
#'     \item{\code{"SAgrowth"}:  Sapwood area growth rate.}
#'     \item{\code{"LAgrowth"}:  Leaf area growth rate.}
#'     \item{\code{"FRAgrowth"}:  Fine root area growth rate (only for \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}).}
#'     \item{\code{"HuberValue"}:  Ratio of leaf area to sapwood area.}
#'     \item{\code{"RootAreaLeafArea"}:  Ratio of fine root area to leaf area (only for \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}).}
#'   }
#' Finally, the following plots are only available for \code{\link{fordyn}} simulation results:
#'   \itemize{
#'     \item{\code{"StandBasalArea"}: Stand basal area of living trees.}
#'     \item{\code{"StandDensity"}: Stand density of living trees.}
#'     \item{\code{"SpeciesBasalArea"}: Basal area of living trees by species.}
#'     \item{\code{"SpeciesDensity"}: Density of living trees by species.}
#'     \item{\code{"CohortBasalArea"}: Basal area of living trees by plant cohort.}
#'     \item{\code{"CohortDensity"}: Density of living trees by plant cohort.}
#'   }
#'
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' @return An ggplot object
#' 
#' @seealso  \code{\link{spwb}}, \code{\link{pwb}}, \code{\link{growth}}, \code{\link{fordyn}}, \code{\link{summary.spwb}}
#' 
#' @examples 
#' \donttest{
#' #Load example daily meteorological data
#' data(examplemeteo)
#' 
#' #Load example plot plant data
#' data(exampleforest)
#' 
#' #Default species parameterization
#' data(SpParamsMED)
#' 
#' #Define soil with default soil params (4 layers)
#' examplesoil <- defaultSoilParams(4)
#' 
#' #Initialize control parameters
#' control <- defaultControl("Granier")
#' 
#' #Initialize input
#' x <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)
#' 
#' #Call simulation function
#' S1 <- spwb(x, examplemeteo, latitude = 41.82592, elevation = 100)
#' 
#' #Plot results
#' plot(S1)
#' }
plot.spwb<-function(x, type="PET_Precipitation", cohorts = NULL, bySpecies = FALSE,
                    dates = NULL, subdaily = FALSE, 
                    xlim = NULL, ylim=NULL, xlab=NULL, ylab=NULL, 
                    summary.freq = NULL, ...) {
  
  if(subdaily) return(.plotsubdaily(x,type, cohorts, bySpecies, dates, 
                                    xlim, ylim, xlab, ylab))
  
  if(("spwb" %in% class(x)) || ("pwb" %in% class(x))) {
    input = x$spwbInput
  } else {
    input = x$growthInput
  }
  TYPES = .getDailySPWBPlotTypes(input$control$transpirationMode)  
  
  type = match.arg(type,TYPES)  
  if(is.null(xlab)) xlab = ""
  if(type %in% c("PET_Precipitation", "PET_NetRain", "Evapotranspiration", "Snow", "Export")) {
    return(.plot_wb(WaterBalance = x$WaterBalance, Soil = x$Soil, Snow = x$Snow, input_soil = input$soil, 
                    type = type, dates = dates, 
                    xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                    summary.freq = summary.freq, ...))
  } 
  return(plot.pwb(x, type=type, cohorts = cohorts, bySpecies = bySpecies,
                  dates = dates, xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                  summary.freq = summary.freq, ...))
}

#' @rdname plot.spwb
plot.aspwb<-function(x, type="PET_Precipitation", 
                     dates = NULL,  
                     xlim = NULL, ylim=NULL, xlab=NULL, ylab=NULL, 
                     summary.freq = NULL, ...) {
  
  input = x$aspwbInput
  TYPES = .getDailyASPWBPlotTypes()  
  
  type = match.arg(type,TYPES)  
  if(is.null(xlab)) xlab = ""
  if(type %in% c("PET_Precipitation", "Evapotranspiration", "Snow", "Export")) {
    return(.plot_wb(WaterBalance = x$WaterBalance, Soil = x$Soil, Snow = x$Snow, input_soil = input$soil, 
                    type = type, dates = dates, 
                    xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                    summary.freq = summary.freq, ...))
  } else {
    return(.plot_soil(Soil = x$Soil, input_soil = input$soil, input_control = input$control,
                      type = type, dates = dates, 
                      xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                      summary.freq = summary.freq, ...))
  }
}

#' @rdname plot.spwb
plot.pwb<-function(x, type="PlantTranspiration", cohorts = NULL, bySpecies = FALSE,
                   dates = NULL, subdaily = FALSE,
                   xlim = NULL, ylim=NULL, xlab=NULL, ylab=NULL, 
                   summary.freq = NULL,...) {
  
  if(subdaily) return(.plotsubdaily(x,type, cohorts, bySpecies, dates, 
                                    xlim, ylim, xlab, ylab))
  
  if(("spwb" %in% class(x)) || ("pwb" %in% class(x))) {
    input = x$spwbInput
  } else {
    input = x$growthInput
  }
  nlayers = length(input$soil$W)
  transpMode = input$control$transpirationMode
  
  if(is.null(cohorts))  cohorts = row.names(input$cohorts)
  else if(length(cohorts)==1) {
    if(cohorts=="T") {
      cohorts = row.names(input$cohorts)
      cohorts = cohorts[substr(cohorts,1,1)=="T"]
    } else if(cohorts=="S") {
      cohorts = row.names(input$cohorts)
      cohorts = cohorts[substr(cohorts,1,1)=="S"]
    }
  }
  
  spnames = as.character(input$cohorts[cohorts,"Name"])
  
  PlantsLAIlive = x$Plants$LAIlive[,cohorts, drop=FALSE]
  PlantsLAI = x$Plants$LAI[,cohorts, drop=FALSE]
  
  TYPES = .getDailyPWBPlotTypes(transpMode)
  type = match.arg(type,TYPES)  
  if(is.null(xlab)) xlab = ""  
  
  if(type %in% c("SoilPsi", "SoilTheta", "SoilRWC", "SoilREW", "SoilVol","PlantExtraction", "HydraulicRedistribution")) {
    return(.plot_soil(Soil = x$Soil, input_soil = input$soil, input_control = input$control,
                      type = type, dates = dates, 
                      xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                      summary.freq = summary.freq, ...))
  }
  else if(type %in% c("LAI", "GroundIrradiance")) {
    return(.plot_stand(Stand = x$Stand,
                       type = type, dates = dates, 
                       xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                       summary.freq = summary.freq, ...))
  }
  else if(type %in% c("FPAR", "AbsorbedSWRFraction")) {
    OM = x$Plants[[type]][,cohorts,drop=FALSE]
    return(.plot_plant_om(OM, PlantsLAIlive, spnames,
                          type, bySpecies = bySpecies, dates = dates, 
                          xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                          summary.freq = summary.freq, ...))
  } 
  else if(type %in% c("PlantStress","LeafPLC","StemPLC", "StemRWC", "LeafRWC")) {
    OM = x$Plants[[type]][,cohorts,drop=FALSE]*100
    return(.plot_plant_om(OM, PlantsLAIlive, spnames,
                          type, bySpecies = bySpecies, dates = dates, 
                          xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                          summary.freq = summary.freq, ...))
  } 
  else if(type %in% c("PlantLAI","PlantLAIlive","PlantTranspiration","PlantNetPhotosynthesis", "PlantGrossPhotosynthesis",
                      "PlantAbsorbedSWR","PlantNetLWR")) {
    subtype = substr(type,6,nchar(type))
    OM = x$Plants[[subtype]][,cohorts,drop=FALSE]
    return(.plot_plant_om_sum(OM, spnames,
                              type, bySpecies = bySpecies, dates = dates, 
                              xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                              summary.freq = summary.freq, ...))
  } 
  else if(type %in% c("SoilPlantConductance","PlantPsi", "LeafPsiMin",
                      "LeafPsiMax", "StemPsi", "RootPsi", 
                      "PlantWaterBalance", "LFMC")) {
    if(type=="SoilPlantConductance") OM = x$Plants[["dEdP"]][,cohorts,drop=FALSE]
    else OM = x$Plants[[type]][,cohorts,drop=FALSE]
    return(.plot_plant_om(OM, PlantsLAIlive, spnames,
                          type, bySpecies = bySpecies, dates = dates, 
                          xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                          summary.freq = summary.freq, ...))
  } 
  else if(type %in% c("LeafPsiMin_SL", "LeafPsiMax_SL", "GSWMin_SL", "GSWMax_SL", "TempMin_SL", "TempMax_SL")) {
    subType = strsplit(type,"_")[[1]][1]
    OM = x$SunlitLeaves[[subType]][,cohorts,drop=FALSE]
    return(.plot_plant_om(OM, PlantsLAIlive, spnames,
                          type, bySpecies = bySpecies, dates = dates, 
                          xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                          summary.freq = summary.freq, ...))
  } 
  else if(type %in% c("LeafPsiMin_SH", "LeafPsiMax_SH", "GSWMin_SH", "GSWMax_SH", "TempMin_SH", "TempMax_SH")) {
    subType = strsplit(type,"_")[[1]][1]
    OM = x$ShadeLeaves[[subType]][,cohorts,drop=FALSE]
    return(.plot_plant_om(OM, PlantsLAIlive, spnames,
                          type, bySpecies = bySpecies, dates = dates, 
                          xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                          summary.freq = summary.freq, ...))
  } 
  else if(type %in% c("TranspirationPerLeaf","GrossPhotosynthesisPerLeaf", "NetPhotosynthesisPerLeaf",
                      "AbsorbedSWRPerLeaf", "NetLWRPerLeaf")) {
    subtype = substr(type, 1, nchar(type)-7)
    df = x$Plants[[subtype]][,cohorts,drop=FALSE]
    df = df/PlantsLAI
    df[PlantsLAI==0] = NA
    return(.plot_plant_om(df, PlantsLAIlive, spnames,
                          type, bySpecies = bySpecies, dates = dates, 
                          xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                          summary.freq = summary.freq, ...))
  } 
  else if(type == "LeafPsiRange") {
    OM1 = x$Plants$LeafPsiMax[,cohorts,drop=FALSE]
    OM2 = x$Plants$LeafPsiMin[,cohorts,drop=FALSE]
    if(bySpecies) {
      OM1 = .averageByLAISpecies(OM1, PlantsLAIlive, spnames)
      OM2 = .averageByLAISpecies(OM2, PlantsLAIlive, spnames)
    } 
    if(!is.null(dates)) {
      OM1 = OM1[row.names(OM1) %in% as.character(dates),,drop = FALSE]
      OM2 = OM2[row.names(OM2) %in% as.character(dates),,drop = FALSE]
    }
    if(!is.null(summary.freq)) {
      OM1 = .temporalSummary(OM1, summary.freq, mean, na.rm=TRUE)
      OM2 = .temporalSummary(OM2, summary.freq, mean, na.rm=TRUE)
    }
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_dynamics_range(as.matrix(OM1), as.matrix(OM2),  xlab = xlab, ylab = ylab, ylim = ylim))
  }
  else if(type=="PlantWUE") {
    OM = x$Plants$GrossPhotosynthesis/x$Plants$Transpiration
    OM[x$Plants$Transpiration==0] = 0
    OM = OM[,cohorts,drop=FALSE]
    return(.plot_plant_om(OM, PlantsLAIlive, spnames,
                          type, bySpecies = bySpecies, dates = dates, 
                          xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                          summary.freq = summary.freq, ...))
  } 
  else if(type %in% c("Temperature","TemperatureRange", "AirTemperature",
                      "CanopyTemperature", "SoilTemperature")) {
    return(.plot_temperature(x$Temperature, type,  
                             dates = dates, 
                             xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                             summary.freq = summary.freq, ...))
  }
  else if(type %in% c("CanopyEnergyBalance", "SoilEnergyBalance")) {
    return(.plot_energybalance(x$EnergyBalance, type,  
                               dates = dates, 
                               xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                               summary.freq = summary.freq, ...))
  } 
}

#' @rdname plot.spwb
plot.growth<-function(x, type="PET_Precipitation", cohorts = NULL, bySpecies = FALSE, 
                      dates = NULL, subdaily = FALSE, 
                      xlim = NULL, ylim=NULL, xlab=NULL, ylab=NULL, 
                      summary.freq = NULL, ...) {
  
  if(subdaily) return(.plotsubdaily(x,type, cohorts, bySpecies, dates, 
                                    xlim, ylim, xlab, ylab))
  
  # Get common elements
  input = x$growthInput
  nlayers = length(input$soil$W)
  transpMode = input$control$transpirationMode
  
  TYPES_GROWTH = .getDailyGROWTHPlotTypes(transpMode)
  TYPES_SWB = .getDailySPWBPlotTypes(transpMode)  
  
  type = match.arg(type,TYPES_GROWTH)  
  
  if(is.null(cohorts))  cohorts = row.names(input$cohorts)
  else if(length(cohorts)==1) {
    if(cohorts=="T") {
      cohorts = row.names(input$cohorts)
      cohorts = cohorts[substr(cohorts,1,1)=="T"]
    } else if(cohorts=="S") {
      cohorts = row.names(input$cohorts)
      cohorts = cohorts[substr(cohorts,1,1)=="S"]
    }
  }
  
  spnames = as.character(input$cohorts[cohorts,"Name"])
  PlantsLAIlive = x$Plants$LAIlive[,cohorts, drop=FALSE]
  PlantsLAI = x$Plants$LAI[,cohorts, drop=FALSE]
  
  if(type %in% TYPES_SWB) {
    return(plot.spwb(x,type, cohorts, bySpecies, dates, subdaily, xlim, ylim, xlab, ylab, 
                     summary.freq, ...))
  } 
  else if(type == "BiomassBalance") {
    return(.plot_biomass(BiomassBalance= x$BiomassBalance,
                         type = type, dates = dates, 
                         xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                         summary.freq = summary.freq, ...))
  }
  else if(type == "CarbonBalance") {
    return(.plot_carbon(CarbonBalance= x$CarbonBalance,
                        type = type, dates = dates, 
                        xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                        summary.freq = summary.freq, ...))
  }
  else if(type == "DecompositionPools") {
    return(.plot_decompositionpools(DecompositionPools= x$DecompositionPools,
                        type = type, dates = dates, 
                        xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                        summary.freq = summary.freq, ...))
  }
  else if(type %in% c("GrossPhotosynthesis", "MaintenanceRespiration",  "GrowthCosts", 
                      "LabileCarbonBalance", 
                      "SugarLeaf","StarchLeaf","SugarSapwood","StarchSapwood", "SugarTransport", "RootExudation")) {
    OM = x$LabileCarbonBalance[[type]][,cohorts,drop=FALSE]
  } 
  else if(type == "PhotosynthesisMaintenanceRatio") {
    OM1 = x$LabileCarbonBalance[["GrossPhotosynthesis"]][,cohorts,drop=FALSE]
    OM2 = x$LabileCarbonBalance[["MaintenanceRespiration"]][,cohorts,drop=FALSE]
    OM = OM1/OM2
  } 
  else if(type %in% c("StructuralBiomassBalance","LabileBiomassBalance", "PlantBiomassBalance",
                      "MortalityBiomassLoss","CohortBiomassBalance")) {
    OM = x$PlantBiomassBalance[[type]][,cohorts,drop=FALSE]
  }
  else if(type %in% c("SapwoodBiomass", "LeafBiomass", "FineRootBiomass", 
                      "SapwoodArea", "LeafArea", "FineRootArea", 
                      "DBH", "Height", "HuberValue", "RootAreaLeafArea")) {
    OM = x$PlantStructure[[type]][,cohorts,drop=FALSE]
  } 
  else if(type %in% c("SAgrowth", "LAgrowth", "FRAgrowth", "StarvationRate", "DessicationRate", "MortalityRate")) {
    OM = x$GrowthMortality[[type]][,cohorts,drop=FALSE]
  } 
  return(.plot_plant_om(OM, PlantsLAIlive, spnames,
                        type, bySpecies = bySpecies, dates = dates, 
                        xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                        summary.freq = summary.freq, ...))
}

#' @rdname plot.spwb
plot.fordyn<-function(x, type="StandBasalArea",  
                      cohorts = NULL, bySpecies = FALSE, dates = NULL, 
                      xlim = NULL, ylim=NULL, xlab = NULL, ylab=NULL, 
                      summary.freq = NULL,...) {
  
  input_control = x$GrowthResults[[1]]$growthInput$control
  TYPES_GROWTH = .getDailyGROWTHPlotTypes(input_control$transpirationMode)
  TYPES_GROWTH_UNIQUE = .getUniqueDailyGROWTHPlotTypes(input_control$transpirationMode)
  TYPES_FORDYN_UNIQUE = .getUniqueFORDYNPlotTypes(input_control$transpirationMode)  
  
  type = match.arg(type,c(TYPES_GROWTH, TYPES_FORDYN_UNIQUE))  
  
  if(type %in% TYPES_GROWTH) {
    
    if(is.null(cohorts))  cohorts = row.names(x$GrowthResults[[1]]$growthInput$cohorts)
    PlantsLAI = summary(x, freq = "days", output = "Plants$LAI")[,cohorts,drop=FALSE]
    PlantsLAIlive = summary(x, freq = "days", output = "Plants$LAIlive")[,cohorts,drop=FALSE]
    spnames = as.character(x$GrowthResults[[1]]$growthInput$cohorts[cohorts,"Name"])
    input_soil = x$GrowthResults[[1]]$growthInput$soil
    
    if(type %in% c("PET_Precipitation", "PET_NetRain", "Evapotranspiration" ,"Snow", "Export")) {
      input_soil = x$GrowthResults[[1]]$growthInput$soil
      WaterBalance = summary(x, freq = "days", output = "WaterBalance")
      Snow = summary(x, freq = "days", output = "Snow")
      return(.plot_wb(WaterBalance = WaterBalance, Snow = Snow, 
                      type=type, dates = dates, ylim = ylim, xlab = xlab, ylab = ylab,
                      summary.freq = summary.freq,...))
    }
    else if(type %in% c("SoilPsi", "SoilTheta", "SoilRWC", "SoilREW", "SoilVol", "PlantExtraction", "HydraulicRedistribution")) {
      if(type=="SoilTheta") {
        output = "Soil$SWC"
        var = "SWC"
      } else if(type=="SoilPsi") {
        output = "Soil$Psi"
        var = "Psi"
      } else if(type=="SoilRWC") {
        output = "Soil$RWC"
        var = "RWC"
      } else if(type=="SoilREW") {
        output = "Soil$REW"
        var = "REW"
      } else if(type=="SoilVol") {
        output = "Soil$ML"
        var = "ML"
      } else if(type=="PlantExtraction") {
        output = "Soil$PlantExt"
        var = "PlantExt"
      } else if(type=="HydraulicRedistribution") {
        output = "Soil$HydraulicInput"
        var = "HydraulicInput"
      }
      Soil <- list(var = summary(x, freq = "days", output = output))
      names(Soil)<- var
      return(.plot_soil(Soil = Soil, input_soil = input_soil, input_control = input_control,
                        type=type, dates = dates, 
                        xlim = xlim, ylim = ylim, xlab = xlab, ylab = ylab,
                        summary.freq = summary.freq, ...))
    }
    else if(type %in% c("LAI", "GroundIrradiance")) {
      Stand = summary(x, freq = "days", output = "Stand")
      return(.plot_stand(Stand = Stand,
                         type = type, dates = dates, 
                         xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab,
                         summary.freq = summary.freq,...))
    }
    else if(type %in% c("LeafPLC","StemPLC", "StemRWC", "LeafRWC", "StemSympRWC", "LeafSympRWC")) {
      OM = summary(x, freq = "days", output = paste0("Plants$",type))[,cohorts,drop=FALSE]*100
      return(.plot_plant_om(OM, PlantsLAIlive, spnames,
                            type, bySpecies = bySpecies, dates = dates, 
                            xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                            summary.freq = summary.freq, ...))
    } 
    else if(type %in% c("PlantLAI","PlantLAIlive","PlantTranspiration","PlantNetPhotosynthesis", "PlantGrossPhotosynthesis",
                        "PlantAbsorbedSWR","PlantNetLWR")) {
      subtype = substr(type,6,nchar(type))
      OM = summary(x, freq = "days", output = paste0("Plants$",subtype))[,cohorts,drop=FALSE]
      return(.plot_plant_om_sum(OM, spnames,
                                type, bySpecies = bySpecies, dates = dates, 
                                xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                                summary.freq = summary.freq, ...))
    } 
    else if(type=="PlantWUE") {
      GP = summary(x, freq = "days", output = "Plants$GrossPhotosynthesis")[,cohorts,drop=FALSE]
      E = summary(x, freq = "days", output = "Plants$Transpiration")[,cohorts,drop=FALSE]
      OM = GP/E
      OM[E==0] = 0
      return(.plot_plant_om(OM, PlantsLAIlive, spnames,
                            type, bySpecies = bySpecies, dates = dates, 
                            xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                            summary.freq = summary.freq, ...))
    } 
    else if(type %in% c("SoilPlantConductance","PlantPsi", "LeafPsiMin",
                        "LeafPsiMax", "StemPsi", "RootPsi", "PlantStress",
                        "PlantWaterBalance", "FPAR", "AbsorbedSWRFraction")) {
      if(type=="SoilPlantConductance") OM = summary(x, freq = "days", output = "Plants$dEdP")[,cohorts,drop=FALSE]
      else OM = summary(x, freq = "days", output = paste0("Plants$",type))[,cohorts,drop=FALSE]
      return(.plot_plant_om(OM, PlantsLAIlive, spnames,
                            type, bySpecies = bySpecies, dates = dates, 
                            xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                            summary.freq = summary.freq, ...))
    } 
    else if(type == "LeafPsiRange") {
      OM1 = summary(x, freq = "days", output = "Plants$LeafPsiMax")[,cohorts,drop=FALSE]
      OM2 = summary(x, freq = "days", output = "Plants$LeafPsiMin")[,cohorts,drop=FALSE]
      if(bySpecies) {
        OM1 = .averageByLAISpecies(OM1, PlantsLAIlive, spnames)
        OM2 = .averageByLAISpecies(OM2, PlantsLAIlive, spnames)
      } 
      if(!is.null(dates)) {
        OM1 = OM1[row.names(OM1) %in% as.character(dates),,drop = FALSE]
        OM2 = OM2[row.names(OM2) %in% as.character(dates),,drop = FALSE]
      }
      if(!is.null(summary.freq)) {
        OM1 = .temporalSummary(OM1, summary.freq, mean, na.rm=TRUE)
        OM2 = .temporalSummary(OM2, summary.freq, mean, na.rm=TRUE)
      }
      if(is.null(ylab)) ylab = .getYLab(type)
      return(.multiple_dynamics_range(as.matrix(OM1), as.matrix(OM2),  xlab = xlab, ylab = ylab, ylim = ylim))
    }
    else if(type %in% c("TranspirationPerLeaf","GrossPhotosynthesisPerLeaf", "NetPhotosynthesisPerLeaf",
                        "AbsorbedSWRPerLeaf", "NetLWRPerLeaf")) {
      subtype = substr(type, 1, nchar(type)-7)
      OM = summary(x, freq = "days", output = paste0("Plants$",subtype))[,cohorts,drop=FALSE]
      OM = OM/PlantsLAI
      OM[PlantsLAI==0] = NA
      return(.plot_plant_om(OM, PlantsLAIlive, spnames,
                            type, bySpecies = bySpecies, dates = dates, 
                            xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                            summary.freq = summary.freq, ...))
    } 
    else if(type %in% c("Temperature","TemperatureRange", "AirTemperature",
                        "CanopyTemperature", "SoilTemperature")) {
      OM = summary(x, freq = "days", output = "Temperature")
      return(.plot_temperature(OM, type,  
                               dates = dates, 
                               xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                               summary.freq = summary.freq, ...))
    }
    else if(type %in% c("CanopyEnergyBalance", "SoilEnergyBalance")) {
      OM = summary(x, freq = "days", output = "EnergyBalance")
      return(.plot_energybalance(OM, type,  
                                 dates = dates, 
                                 xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                                 summary.freq = summary.freq, ...))
    } 
    else if(type %in% TYPES_GROWTH_UNIQUE) {
      if(type=="BiomassBalance") {
        OM = summary(x, freq = "days", output = "BiomassBalance")
        return(.plot_biomass(OM, type,  
                             dates = dates, 
                             xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                             summary.freq = summary.freq, ...))
      }
      if(type=="CarbonBalance") {
        OM = summary(x, freq = "days", output = "CarbonBalance")
        return(.plot_carbon(OM, type,  
                            dates = dates, 
                            xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                            summary.freq = summary.freq, ...))
      }
      if(type=="DecompositionPools") {
        OM = summary(x, freq = "days", output = "DecompositionPools", FUN = "mean")
        return(.plot_decompositionpools(OM, type,  
                            dates = dates, 
                            xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                            summary.freq = summary.freq, ...))
      }
      if(type %in% c("GrossPhotosynthesis", "MaintenanceRespiration",  "GrowthCosts", 
                     "LabileCarbonBalance", 
                     "SugarLeaf","StarchLeaf","SugarSapwood","StarchSapwood", "SugarTransport", "RootExudation")) {
        OM = summary(x, freq = "days", output = paste0("LabileCarbonBalance$",type))[,cohorts,drop=FALSE]
      } 
      if(type =="PhotosynthesisMaintenanceRatio") {
        OM1 = summary(x, freq = "days", output = "LabileCarbonBalance$GrossPhotosynthesis")[,cohorts,drop=FALSE]
        OM2 = summary(x, freq = "days", output = "LabileCarbonBalance$MaintenanceRespiration")[,cohorts,drop=FALSE]
        OM = OM1/OM2
      }
      else if(type %in% c("StructuralBiomassBalance", "LabileBiomassBalance", "PlantBiomassBalance", 
                          "MortalityBiomassLoss", "CohortBiomassBalance")) {
        OM = summary(x, freq = "days", output = paste0("PlantBiomassBalance$",type))[,cohorts,drop=FALSE]
      } 
      else if(type %in% c("LeafBiomass", "SapwoodBiomass", "FineRootBiomass", "SapwoodArea", "LeafArea", "FineRootArea","DBH", "Height",
                          "HuberValue", "RootAreaLeafArea")) {
        OM = summary(x, freq = "days", output = paste0("PlantStructure$",type))[,cohorts,drop=FALSE]
      } 
      else if(type %in% c("SAgrowth", "LAgrowth", "FRAgrowth", "StarvationRate", "MortalityRate", "DessicationRate")) {
        OM = summary(x, freq = "days", output = paste0("GrowthMortality$",type))[,cohorts,drop=FALSE]
      } 
      return(.plot_plant_om(OM, PlantsLAIlive, spnames,
                            type, bySpecies = bySpecies, dates = dates, 
                            xlim = xlim, ylim=ylim, xlab=xlab, ylab=ylab, 
                            summary.freq = summary.freq, ...))
    }
  }
  
  
  ## FORDYN PLOT
  
  if(is.null(ylab)) ylab = .getYLab(type)
  if(is.null(xlab)) xlab = "Step"
  
  if(type %in% c("NumTreeSpecies", "NumTreeCohorts", "NumShrubSpecies", "NumShrubCohorts"))  {
    out = x$StandSummary
    var = type
  }
  else if(type == "StandDensity")  {
    out = x$StandSummary
    var = "TreeDensityLive"
  }
  else if(type == "StandBasalArea")  {
    out = x$StandSummary
    var = "TreeBasalAreaLive"
  }
  else if(type == "StandShrubCover")  {
    out = x$StandSummary
    var = "ShrubCoverLive"
  }
  else if(type %in% c("DominantTreeHeight", "DominantTreeDiameter", "QuadraticMeanTreeDiameter", "HartBeckingIndex")) {
    out = x$StandSummary
    var = type
  }
  else if(type == "SpeciesDensity")  {
    out = x$SpeciesSummary
    var = "TreeDensityLive"
  }
  else if(type == "SpeciesBasalArea")  {
    out = x$SpeciesSummary
    var = "TreeBasalAreaLive"
  } 
  else if(type == "SpeciesShrubCover")  {
    out = x$SpeciesSummary
    var = "ShrubCoverLive"
  } 
  else if(type == "NumCohortsSpecies")  {
    out = x$SpeciesSummary
    var = "NumCohorts"
  } 
  else if(type == "CohortDensity")  {
    out = x$CohortSummary
    var = "TreeDensityLive"
  }
  else if(type == "CohortBasalArea")  {
    out = x$CohortSummary
    var = "TreeBasalAreaLive"
  }
  else if(type == "CohortShrubCover")  {
    out = x$CohortSummary
    var = "ShrubCoverLive"
  }
  
  df = data.frame(Step = out[["Step"]], y = out[[var]])
  if(type %in% c("SpeciesDensity", "SpeciesBasalArea", "SpeciesShrubCover", "NumCohortsSpecies")) df$group = as.character(out[["Species"]])
  else if(type %in% c("CohortBasalArea", "CohortDensity", "CohortShrubCover")) {
    df$group = paste0(as.character(out[["Cohort"]]), " (", as.character(out[["Species"]]),")")
  }
  df = df[!is.na(df$y),]
  g<-ggplot(df, aes(x=.data$Step, y=.data$y))
  if("group" %in% names(df)) {
    g <- g+ geom_line(aes(col=.data$group))+
      scale_color_discrete(name="")
  } else {
    g <- g+ geom_line()
  }
  if(!is.null(ylim)) g <- g+ylim(ylim)
  g<-g+theme_bw()+ylab(ylab)+xlab(xlab)
  return(g)
}

#' Multiple model runs and function factories for optimization routines
#'
#' Function factories to generate functions to be used in model calibration, uncertainty or sensitivity analysis.
#'
#' @param parMatrix A matrix of parameter values with runs in rows and parameters in columns. Column names should follow parameter modification naming rules (see examples and naming rules in \code{\link{modifyInputParams}}).
#' @param parNames A string vector of parameter names (see examples and naming rules in \code{\link{modifyInputParams}}).
#' @param x An object of class \code{\link{spwbInput}} or \code{\link{growthInput}}.
#' @param meteo,latitude,elevation,slope,aspect Additional parameters to simulation functions \code{\link{spwb}} or \code{\link{growth}}.
#' @param verbose A flag to indicate extra console output.
#' @param measuredData A data frame with observed/measured values. Dates should be in row names, whereas columns should be named according to the type of output to be evaluated (see details).
#' @param type A string with the kind of model output to be evaluated. Accepted values are \code{"SWC"} (soil moisture content), \code{"REW"} relative extractable water, \code{"ETR"} (total evapotranspiration), \code{"E"} (transpiration per leaf area), \code{"LFMC"} (live fuel moisture content) and \code{"WP"} (plant water potentials).
#' @param cohorts A string or a vector of strings with the cohorts to be compared (e.g. "T1_68"). If several cohort names are provided, the function \code{optimization_cohorts_function} evaluates the performance for each one and provides the mean value. If \code{NULL} results for the first cohort will be evaluated.
#' @param temporalResolution A string to indicate the temporal resolution of the model evaluation, which can be "day", "week", "month" or "year". Observed and modelled values are aggregated temporally (using either means or sums) before comparison.
#' @param metric An evaluation metric (see \code{\link{evaluation_metric}}).
#' @param summary_function A function whose input is the result of \code{\link{spwb}} or \code{\link{growth}}. The function must return a numeric scalar in the case of \code{optimization_function}, but is not restricted in the case of \code{multiple_runs}.
#' @param args A list of additional arguments of \code{optimization_function}.
#' @param cohortParNames A string vector of vegetation parameter names for cohorts (e.g. 'Z95' or 'psiExtract').
#' @param cohortNames A string vector of cohort names. All cohorts will be given the same parameter values for each parameter in 'cohortParNames'.
#' @param otherParNames A string vector of parameter names (see examples and naming rules in \code{\link{modifyInputParams}}) for non-vegetation parameters (i.e. control parameters and soil parameters).
#' 
#' @details 
#' See \code{\link{evaluation}} for details regarding how to specify measured data.
#' 
#' Functions produced by these function factories should be useful for sensitivity analyses using package 'sensitivity'.
#' 
#' Parameter naming (i.e. \code{parNames}) should follow the rules specified in section details of \code{\link{modifyInputParams}}. 
#' The exception to the naming rules applies when multiple cohorts are to be modified to the same values with functions 
#' \code{optimization_multicohort_function} and \code{optimization_evaluation_multicohort_function}. 
#' Then, only a vector of parameter names is supplied for \code{cohortParNames}.
#' 
#' @return 
#' Function \code{multiple_runs} returns a list, whose elements are either the result of calling simulation models 
#' or the result of calling \code{summary_function} afterwards. 
#' 
#' Function \code{optimization_function} returns a function whose parameters are parameter values 
#' and whose return is a prediction scalar (e.g. total transpiration).
#' 
#' Function \code{optimization_evaluation_function} returns a function whose parameters are parameter values 
#' and whose return is an evaluation metric (e.g. loglikelihood of the data observations given model predictions). 
#' If evaluation data contains information for different cohorts (e.g. plant water potentials or transpiration rates) 
#' then the evaluation is performed for each cohort and the metrics are averaged. 
#' 
#' Function \code{optimization_multicohorts_function} returns a function whose parameters are parameter values 
#' and whose return is a prediction scalar (e.g. total transpiration). The difference with \code{optimization_function} 
#' is that multiple cohorts are set to the same parameter values.
#' 
#' Function \code{optimization_evaluation_multicohort_function} returns a function whose parameters are parameter values 
#' and whose return is an evaluation metric (e.g. loglikelihood of the data observations given model predictions). 
#' If evaluation data contains information for different cohorts (e.g. plant water potentials or transpiration rates) 
#' then the evaluation is performed for each cohort and the metrics are averaged. The difference with \code{optimization_evaluation_function} 
#' is that multiple cohorts are set to the same parameter values.
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso \code{\link{evaluation_metric}}, \code{\link{modifyInputParams}}, \code{\link{spwb}}, \code{\link{growth}}
#' 
#' @examples 
#' \donttest{
#' #Load example daily meteorological data
#' data(examplemeteo)
#' 
#' #Load example plot plant data
#' data(exampleforest)
#' 
#' #Default species parameterization
#' data(SpParamsMED)
#' 
#' #Define soil with default soil params (4 layers)
#' examplesoil <- defaultSoilParams(4)
#' 
#' #Initialize control parameters
#' control <- defaultControl("Granier")
#' 
#' #Initialize input
#' x1 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)
#' 
#' # Cohort name for Pinus halepensis
#' PH_coh <- paste0("T1_", SpParamsMED$SpIndex[SpParamsMED$Name=="Pinus halepensis"])
#' PH_coh 
#' 
#' #Parameter names of interest
#' parNames <- c(paste0(PH_coh,"/Z50"), paste0(PH_coh,"/Z95"))
#' 
#' #Specify parameter matrix
#' parMatrix <- cbind(c(200,300), c(500,1000))
#' colnames(parMatrix) <- parNames
#' 
#' #Define a summary function as the total transpiration over the simulated period
#' sf<-function(x) {sum(x$WaterBalance$Transpiration, na.rm=TRUE)}
#' 
#' #Perform two runs and evaluate the summary function
#' multiple_runs(parMatrix, 
#'               x1, examplemeteo, latitude = 42, elevation = 100,
#'               summary_function = sf)
#' 
#' #Load observed data (in this case the same simulation results with some added error)  
#' # Generate a prediction function for total transpiration over the simulated period
#' # as a function of parameters "Z50" and "Z95" for Pinus halepensis cohort 
#' of<-optimization_function(parNames = parNames,
#'                           x = x1,
#'                           meteo = examplemeteo, 
#'                           latitude = 41.82592, elevation = 100,
#'                           summary_function = sf)
#' 
#' # Evaluate for the values of the parameter matrix
#' of(parMatrix[1, ])
#' of(parMatrix)
#' 
#' 
#' # Generate a loglikelihood function for soil water content
#' # as a function of parameters "Z50" and "Z95" for Pinus halepensis cohort 
#' data(exampleobs)
#' oef<-optimization_evaluation_function(parNames = parNames,
#'                                       x = x1,
#'                                       meteo = examplemeteo, latitude = 41.82592, elevation = 100,
#'                                       measuredData = exampleobs, type = "SWC", 
#'                                       metric = "loglikelihood")
#' 
#' # Loglikelihood for the values of the parameter matrix
#' oef(parMatrix[1, ])
#' oef(parMatrix)
#' }
#' 
#' @name optimization
multiple_runs<-function(parMatrix, x,
                        meteo, latitude,
                        elevation = NA, slope = NA, aspect = NA, 
                        summary_function = NULL, args = NULL, 
                        verbose = TRUE) {
  if(inherits(x, "spwbInput")) model = "spwb"
  else model = "growth"
  
  n = nrow(parMatrix)
  res = vector("list", n)
  parNames = colnames(parMatrix)
  for(r in 1:n) {
    x_r = .cloneInput(x)
    customParams = parMatrix[r,]
    names(customParams) <- parNames
    x_r = modifyInputParams(x_r, customParams, FALSE)
    x_r$control$verbose = FALSE
    S = do.call(model, list(x = x_r,
                            meteo = meteo, 
                            latitude = latitude, elevation = elevation,
                            slope  = slope,aspect = aspect))
    if(!is.null(summary_function)) {
      res[[r]] = do.call(summary_function, c(list(S), args))
      if(verbose) cat(paste0(r, ". Parameter values = [", paste0(customParams, collapse=", "), "] f = ", res[[r]], "\n"))
    } else {
      res[[r]] = S
      if(verbose) cat(paste0(r, ". Parameter values = [", paste0(customParams, collapse=", "), "]\n"))
    }
  }
  return(res)
}

#' @rdname optimization
optimization_function<-function(parNames, x, 
                                meteo, latitude,
                                elevation = NA, slope = NA, aspect = NA, 
                                summary_function, args= NULL) {
  
  if(inherits(x, "spwbInput")) model = "spwb"
  else model = "growth"
  
  x$control$verbose = FALSE
  yf<-function(v, verbose = FALSE) {
    x_i <- .cloneInput(x)
    if(is.vector(v)) {
      customParams = v
      names(customParams) <- parNames
      x_i = modifyInputParams(x_i, customParams, FALSE)
      S = do.call(model, list(x = x_i, 
                              meteo = meteo, 
                              latitude = latitude, elevation = elevation,
                              slope  = slope,aspect = aspect))
      y = do.call(summary_function, c(list(S), args))
      if(verbose) cat(paste0("Parameter values = [", paste0(customParams, collapse=", "), "] f = ", y, "\n"))
      return(y)
    } else if(is.matrix(v)) {
      colnames(v)<-parNames
      y<-multiple_runs(parMatrix = v, x = x_i, 
                       meteo = meteo,
                       latitude = latitude, elevation = elevation,
                       slope  = slope,aspect = aspect,
                       summary_function = summary_function, args = args,
                       verbose = verbose)
      return(as.numeric(y))
    } else {
      stop("Wrong 'v' class")
    }
  }
  return(yf)
}

#' @rdname optimization
optimization_evaluation_function<-function(parNames, x, 
                                           meteo, latitude,
                                           elevation = NA, slope = NA, aspect = NA, 
                                           measuredData, type = "SWC", cohorts = NULL, 
                                           temporalResolution = "day", 
                                           metric = "loglikelihood") {
  sf<-function(S) {
    if(!is.null(cohorts)) { # If cohorts != NULL evaluate output for each cohort and average the result
      y = rep(NA, length(cohorts))
      for(i in 1:length(cohorts)) {
        if(paste0(type,"_", cohorts[i]) %in% names(measuredData)) {
          y[i] = evaluation_metric(S, measuredData = measuredData, type=type, 
                                   cohort=cohorts[i], 
                                   temporalResolution = temporalResolution, metric = metric)
        }
      }
      return(mean(y, na.rm=TRUE))
    } else { # If cohorts == NULL evaluate output for first cohort (or no referred to any)
      y = evaluation_metric(S, measuredData = measuredData, type=type, 
                            cohort=NULL, 
                            temporalResolution = temporalResolution, metric = metric)
    }
    return(y)
  }
  return(optimization_function(parNames = parNames, x = x,
                               meteo = meteo, latitude = latitude,
                               elevation = elevation, slope = slope, aspect = aspect,
                               summary_function = sf))
}

#' @rdname optimization
optimization_multicohort_function<-function(cohortParNames, cohortNames, x, 
                                            meteo, latitude, 
                                            otherParNames = NULL,
                                            elevation = NA, slope = NA, aspect = NA, 
                                            summary_function, args= NULL) {
  
  if(inherits(x, "spwbInput")) model = "spwb"
  else model = "growth"
  
  x$control$verbose = FALSE
  yf<-function(v, verbose = FALSE) {
    x_i <- .cloneInput(x)
    if(is.vector(v)) {
      for(j in 1:length(cohortNames)) {
        customParams = v
        names(customParams) <- c(paste0(cohortNames[j],"/",cohortParNames), otherParNames)
        x_i = modifyInputParams(x_i, customParams, FALSE)
      }
      S = do.call(model, list(x = x_i, 
                              meteo = meteo, 
                              latitude = latitude, elevation = elevation,
                              slope  = slope,aspect = aspect))
      y = do.call(summary_function, c(list(S), args))
      if(verbose) cat(paste0("Parameter values = [", paste0(customParams, collapse=", "), "] f = ", y, "\n"))
      return(y)
    } else if(is.matrix(v)) {
      colnames(v) <- c(paste0(cohortNames[j],"/",cohortParNames), otherParNames)
      y<-multiple_runs(parMatrix = v, x = x_i, 
                       meteo = meteo,
                       latitude = latitude, elevation = elevation,
                       slope  = slope,aspect = aspect,
                       summary_function = summary_function, args = args,
                       verbose = verbose)
      return(as.numeric(y))
    } else {
      stop("Wrong 'v' class")
    }
  }
  return(yf)
}

#' @rdname optimization
optimization_evaluation_multicohort_function<-function(cohortParNames, cohortNames, x, 
                                                       meteo, latitude,
                                                       otherParNames = NULL,
                                                       elevation = NA, slope = NA, aspect = NA, 
                                                       measuredData, type = "SWC", cohorts = cohortNames,
                                                       temporalResolution = "day", 
                                                       metric = "loglikelihood") {
  sf<-function(S) {
    if(!is.null(cohorts)) { # If cohorts != NULL evaluate output for each cohort and average the result
      y = rep(NA, length(cohorts))
      for(i in 1:length(cohorts)) {
        if(paste0(type,"_", cohorts[i]) %in% names(measuredData)) {
          y[i] = evaluation_metric(S, measuredData = measuredData, type=type, 
                                   cohort=cohorts[i], 
                                   temporalResolution = temporalResolution, metric = metric)
        }
      }
      return(mean(y, na.rm=TRUE))
    } else { # If cohorts == NULL evaluate output for first cohort (or no referred to any)
      y = evaluation_metric(S, measuredData = measuredData, type=type, 
                            cohort=NULL, 
                            temporalResolution = temporalResolution, metric = metric)
    }
    return(y)
  }
  return(optimization_multicohort_function(cohortParNames = cohortParNames, 
                                           cohortNames = cohortNames, 
                                           x = x,
                                           meteo = meteo, latitude = latitude,
                                           otherParNames = otherParNames,
                                           elevation = elevation, slope = slope, aspect = aspect,
                                           summary_function = sf))
}

#' Map forest plot data
#'
#' Mapping functions to facilitate building forest objects from forest plot data
#'
#' @param x A data frame with tree records in rows and attributes in columns. Tree records can correspond to individual trees or groups of trees with an associated density.
#' @param y A data frame with shrub records in rows and attributes in columns. Records can correspond to individual shrubs (with crown dimensions and height) or groups of shrubs with an associated cover estimate.
#' @param mapping_x A named character vector to specify mappings of columns in \code{x} into attributes of \code{treeData} data frames. Accepted names (and the corresponding specifications for the columns in \code{x}) are:
#' @param mapping_y A named character vector to specify mappings of columns in \code{y} into attributes of \code{shrubData} data frames. 
#' Accepted names (and the corresponding specifications for the columns in \code{y}) are:
#' \itemize{
#'   \item{\code{Species}: Species code (should follow codes in \code{SpParams}).}
#'   \item{\code{Species.name}: Species name. In this case, the species code will be drawn by matching names with species names in \code{SpParams}.}
#'   \item{\code{N}: Tree density (in individuals per ha).}
#'   \item{\code{Cover}: Shrub cover (in percent).}
#'   \item{\code{D1}: Shrub largest crown diameter (in cm).}
#'   \item{\code{D2}: Shrub crown diameter orthogonal to the largest one (in cm).}
#'   \item{\code{plot.size}: Plot size (in m2) to which each record refers to. This is used to calculate tree density (stems per hectare) when not supplied or shrub cover when shrub data is given at the individual level.}
#'   \item{\code{DBH}: Diameter at breast height (in cm).}
#'   \item{\code{Height}: Tree or shrub height (in cm).}
#'   \item{\code{Z50}: Depth (in mm) corresponding to 50 percent of fine roots.}
#'   \item{\code{Z95}: Depth (in mm) corresponding to 95 percent of fine roots.}
#'   \item{\code{Z100}: Depth (in mm) corresponding to 100 percent of fine roots.}
#'   }
#' @param SpParams A data frame with species parameters (see \code{\link{SpParamsMED}}) from which valid species names are drawn.
#' @param plot_size_x The size of tree plot sampled area (in m2). Alternatively, 'plot_size_x'
#' can be a column in \code{x} and specified in \code{mapping_x} to indicate that trees
#' have been measured in different subplots and, therefore, they represent different
#' densities per hectare.
#' @param plot_size_y The size of shrub plot sampled area (in m2). Alternatively, 'plot_size_y'
#' can be a column in \code{y} and specified in \code{mapping_y} to indicate that shrubs
#' have been measured in different subplots and, therefore, they represent different
#' cover values.
#'
#' @return Functions \code{forest_mapTreeTable} and \code{forest_mapShrubTable} return a data frame with the structure of \code{treeData} and \code{shrubData} from \code{\link{forest}} objects. Function \code{forest_mapWoodyTable} returns directly a \code{\link{forest}} object.
#'
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, EMF-CREAF
#'
#' @seealso \code{\link{forest}}, \code{\link{poblet_trees}}, \code{\link{forest_mergeTrees}}, \code{\link{tree2forest}}
#'
#' @name forest_mapWoodyTables
#'
#' @examples
#'
#' # Load species parameters
#' data(SpParamsMED)
#'
#' # Create an empty forest object
#' f <- emptyforest()
#'
#' # (1) Mapping tree data
#' # Load Poblet tree data
#' data(poblet_trees)
#'
#' # Subset control plot
#' x <- subset(poblet_trees, Plot.Code=="POBL_CTL")
#'
#' # Estimate sampled area (15-m radius plot)
#' sampled_area <- pi*15^2
#'
#' # Define mapping
#' mapping_x <- c("Species.name" = "Species", "DBH" = "Diameter.cm")
#'
#' # Map tree data for plot 'POBL_CTL'
#' f$treeData <- forest_mapTreeTable(x,
#'                     mapping_x = mapping_x, SpParams = SpParamsMED,
#'                     plot_size_x = sampled_area)
#'
#' # (2) Mapping shrub individual data
#' #
#' # Create the individual shrub data frame
#' species <- c("Erica arborea","Cistus albidus", "Erica arborea", "Cistus albidus", "Cistus albidus")
#' H <- c(200,50,100,40,30)
#' D1 <- c(140,40,100, 35,30)
#' D2 <- D1
#' y <- data.frame(species, H, D1, D2)
#'
#' # Define mapping (D1 and D2 map to variables with the same name)
#' mapping_y <- c("Species.name"= "species", "Height" ="H", "D1", "D2")
#'
#' # Map individual shrub data to cover data (here each individual becomes a cohort)
#' # assuming that the sampled area was 4 m2
#' f$shrubData <- forest_mapShrubTable(y,
#'                      mapping_y = mapping_y, SpParams = SpParamsMED,
#'                      plot_size_y = 4)
#'
#' # (3) Print forest attributes
#' summary(f, SpParamsMED)
#'
#' # (4) Forest initialization in a single step
#' f <- forest_mapWoodyTables(x, y,
#'                            mapping_x = mapping_x, mapping_y = mapping_y,
#'                            SpParams = SpParamsMED,
#'                            plot_size_x = sampled_area, plot_size_y = 4)
#' summary(f, SpParamsMED)
forest_mapTreeTable<-function(x, mapping_x, SpParams, plot_size_x = NULL) {
  if(!inherits(x, "data.frame")) stop("Object `x` should be of class `data.frame`")
  if(!inherits(SpParams, "data.frame")) stop("Object `SpParams` should be of class `data.frame`")
  
  n = nrow(x)
  treeData = data.frame(
    Species = rep(NA, n),
    N = rep(NA, n),
    Height = rep(NA, n),
    DBH = rep(NA, n),
    Z50 = rep(NA, n),
    Z95 = rep(NA, n))
  
  # Fill any empty mapping names with correspoinding mapping values
  names(mapping_x)[names(mapping_x)==""] = mapping_x[names(mapping_x)==""]
  
  if("Height" %in% names(mapping_x)) {
    treeData$Height = x[[mapping_x[["Height"]]]]
  }
  if("DBH" %in% names(mapping_x)) {
    treeData$DBH = x[[mapping_x[["DBH"]]]]
  }
  if("N" %in% names(mapping_x)) {
    treeData$N = x[[mapping_x[["N"]]]]
  } else {
    treeData$N = 1
  }
  if("Z50" %in% names(mapping_x)) {
    treeData$Z50 = x[[mapping_x[["Z50"]]]]
  }
  if("Z95" %in% names(mapping_x)) {
    treeData$Z95 = x[[mapping_x[["Z95"]]]]
  }
  if("Z100" %in% names(mapping_x)) {
    treeData$Z100 = x[[mapping_x[["Z100"]]]]
  }
  if("Species" %in% names(mapping_x)) {
    treeData$Species = x[[mapping_x[["Species"]]]]
  }
  if("plot_size_x" %in% names(mapping_x)) {
    plot_size_x = x[[mapping_x[["plot_size_x"]]]]
  }
  if(!is.null(plot_size_x)) {
    treeData$N = treeData$N*(10000/plot_size_x)
  }
  if("Species.name" %in% names(mapping_x)) {
    non_recognized = character(0)
    Species.name = x[[mapping_x[["Species.name"]]]]
    for(i in 1:n) {
      indices = which(SpParams$Name==Species.name[i])
      if(length(indices)>0) {
        treeData$Species[i] = SpParams$Name[indices]
      } else {
        non_recognized = unique(c(non_recognized, Species.name[i]))
      }
    }
    if(length(non_recognized)>0) {
      warning(paste0("Taxon names that were not matched: ", paste0(non_recognized, collapse=","),"."))
    }
  }
  return(treeData)
}

#' @rdname forest_mapWoodyTables
#' @export
forest_mapShrubTable<-function(y, mapping_y, SpParams, plot_size_y = NULL) {
  if(!inherits(y, "data.frame")) stop("Object `y` should be of class `data.frame`")
  if(!inherits(SpParams, "data.frame")) stop("Object `SpParams` should be of class `data.frame`")
  
  n = nrow(y)
  shrubData = data.frame(
    Species = rep(NA, n),
    Height = rep(NA, n),
    Cover = rep(NA, n),
    Z50 = rep(NA, n),
    Z95 = rep(NA, n))
  
  # Fill any empty mapping names with correspoinding mapping values
  names(mapping_y)[names(mapping_y)==""] = mapping_y[names(mapping_y)==""]
  
  if("Height" %in% names(mapping_y)) {
    shrubData$Height = y[[mapping_y[["Height"]]]]
  }
  if("plot_size_y" %in% names(mapping_y)) {
    plot_size_y = y[[mapping_y[["plot_size_y"]]]]
  }
  if("Cover" %in% names(mapping_y)) {
    shrubData$Cover = y[[mapping_y[["Cover"]]]]
  } else if("D1" %in% names(mapping_y)) {
    if(is.null(plot_size_y)) stop("You must supply plot size when mapping crown diameter data.")
    D1 = y[[mapping_y[["D1"]]]] # D1 in cm
    D2 = D1
    if("D2" %in% names(mapping_y)) {
      D2 = y[[mapping_y[["D2"]]]] # D2 in cm
    }
    area = pi*((D1/200)*(D2/200)) #area in m2
    shrubData$Cover = pmin(100,100*area/plot_size_y)
  }
  if("Z50" %in% names(mapping_y)) {
    shrubData$Z50 = y[[mapping_y[["Z50"]]]]
  }
  if("Z95" %in% names(mapping_y)) {
    shrubData$Z95 = y[[mapping_y[["Z95"]]]]
  }
  if("Z100" %in% names(mapping_y)) {
    shrubData$Z100 = y[[mapping_y[["Z100"]]]]
  }
  if("Species" %in% names(mapping_y)) {
    shrubData$Species = y[[mapping_y[["Species"]]]]
  }
  if("Species.name" %in% names(mapping_y)) {
    non_recognized = character(0)
    Species.name = y[[mapping_y[["Species.name"]]]]
    for(i in 1:n) {
      indices = which(SpParams$Name==Species.name[i])
      if(length(indices)>0) {
        shrubData$Species[i] = SpParams$Name[indices]
      } else {
        non_recognized = unique(c(non_recognized, Species.name[i]))
      }
    }
    if(length(non_recognized)>0) {
      warning(paste0("Taxon names that were not matched: ", paste0(non_recognized, collapse=",")))
    }
  }
  return(shrubData)
}

#' @rdname forest_mapWoodyTables
#' @export
forest_mapWoodyTables<-function(x = NULL, y = NULL, mapping_x = NULL, mapping_y = NULL, SpParams, plot_size_x=NULL, plot_size_y = NULL) {
  if(!inherits(x, "data.frame")) stop("Object `x` should be of class `data.frame`")
  if(!inherits(y, "data.frame")) stop("Object `y` should be of class `data.frame`")
  if(!inherits(SpParams, "data.frame")) stop("Object `SpParams` should be of class `data.frame`")
  f = emptyforest()
  if(!is.null(x)) {
    if(is.null(mapping_x)) stop("You need to specify a mapping for 'x'")
    f$treeData = forest_mapTreeTable(x, mapping_x = mapping_x,  SpParams=SpParams, plot_size_x = plot_size_x)
  }
  if(!is.null(y)) {
    if(is.null(mapping_y)) stop("You need to specify a mapping for 'y'")
    f$shrubData = forest_mapShrubTable(y, mapping_y = mapping_y,  SpParams=SpParams, plot_size_y = plot_size_y)
  }
  return(f)
}

#' Description of a forest stand.
#' 
#' \code{exampleforest} is an example of forest stand description, whereas \code{exampleforest2} is an alternative forest description where leaf area index and crown ratio are supplied instead of structural (density, DBH and cover) parameters. 
#' 
#' @name forest
#' @aliases exampleforest exampleforest2
#' @docType data
#' 
#' @source DGCN (2005). Tercer Inventario Forestal Nacional (1997-2007): Catalunya. \enc{Dirección}{Direccion} General de \enc{Conservación}{Conservacion} de la Naturaleza, Ministerio de Medio Ambiente, Madrid.
#' @format  An object of class \code{forest} contains the description of the woody (tree or shrub) cohorts of a forest patch.
#' It has the following structure (see additional columns in details):
#' \itemize{
#'   \item{\code{treeData}: A data frame of tree cohorts (in rows) and the following columns:
#'       \itemize{
#'         \item{\code{Species}: String with species (taxon) name or a non-negative integer for tree species identity (i.e., 0,1,2,...) matching SpParams.}
#'         \item{\code{Height}: Total tree height (in cm).}
#'         \item{\code{DBH}: Tree diameter at breast height (in cm).}
#'         \item{\code{N}: Density (number of individuals/hectare) that the measured tree represents.}
#'         \item{\code{Z50}: Depth (in mm) corresponding to 50% of fine roots.}
#'         \item{\code{Z95}: Depth (in mm) corresponding to 95% of fine roots.}
#'      }
#'   }
#'   \item{\code{shrubData}: A data frame of shrub cohorts (in rows) and the following columns:
#'       \itemize{
#'         \item{\code{Species}: String with species (taxon) name or a non-negative integer for shrub species identity (i.e., 0,1,2,...) matching SpParams.}
#'         \item{\code{Height}: Average total height of plants (in cm).}
#'         \item{\code{Cover}: Percent cover.}
#'         \item{\code{Z50}: Depth (in mm) corresponding to 50% of fine roots.}
#'         \item{\code{Z95}: Depth (in mm) corresponding to 95% of fine roots.}
#'       }
#'   }
#' }
#' Additionally, it can contain information about other elements: the herbaceous layer, seedling/sapling bank, seed bank, snags, litter or soil carbon:
#' \itemize{
#'    \item{\code{herbData}: A data frame of herbaceous cohorts (in rows) and the following columns (see an alternative way of defining the herbaceous layer in details):
#'       \itemize{
#'         \item{\code{Species}: String with species (taxon) name or a non-negative integer for herbaceous species identity (i.e., 0,1,2,...) matching SpParams.}
#'         \item{\code{Height}: Average total height of plants (in cm).}
#'         \item{\code{Cover}: Percent cover.}
#'         \item{\code{Z50}: Depth (in mm) corresponding to 50% of fine roots.}
#'         \item{\code{Z95}: Depth (in mm) corresponding to 95% of fine roots.}
#'       }
#'   }
#'   \item{\code{seedlingBank}: An optional data frame containing seedling/sapling information with the following columns:
#'       \itemize{
#'         \item{\code{Species}: String with species (taxon) name or a non-negative integer for seedling/sapling species identity (i.e., 0,1,2,...) matching SpParams.}
#'         \item{\code{Percent}: Amount of seedling in relation to full seedling bank (in %).}
#'         \item{\code{Age}: A numeric vector indicating age of seedlings/saplings in years.}
#'         \item{\code{Z50}: Depth (in mm) corresponding to 50% of fine roots.}
#'         \item{\code{Z95}: Depth (in mm) corresponding to 95% of fine roots.}
#'      }
#'   }
#'   \item{\code{seedBank}: An optional data frame containing seed bank information with the following columns:
#'       \itemize{
#'         \item{\code{Species}: String with species (taxon) name or a non-negative integer for seed species identity (i.e., 0,1,2,...) matching SpParams.}
#'         \item{\code{Percent}: Amount of seeds in relation to full seed bank (in %).}
#'      }
#'   }
#'   \item{\code{snagData}: An optional data frame containing information for snag cohorts, with the following columns:
#'       \itemize{
#'         \item{\code{Species}: String with species (taxon) name.}
#'         \item{\code{DBH}: Diameter at breast height (in cm), for tree snags only.}
#'         \item{\code{Height}: Height of the snag cohort (tree or shrub) (in cm).}
#'         \item{\code{DeathAge}: Years passed since plant death (in yrs).}
#'         \item{\code{SmallBranches}: Mass of (standing) small dead branches (diameters between 0.635 cm and 7.5 cm; 10h and 100h fuels; in g C/m2).}
#'         \item{\code{LargeWood}: Mass of (standing) large dead wood (diameters larger than 7.5 cm; 1000h and 10000h fuels; in g C/m2).}
#'      }
#'   }
#'   \item{\code{litterData}: An optional data frame containing litter information with the following columns:
#'       \itemize{
#'         \item{\code{Species}: String with species (taxon) name.}
#'         \item{\code{Leaves}: Mass of leaf litter (in g C/m2)}
#'         \item{\code{Twigs}: Mass of twig litter (diameters < 0.635 cm; 1h fuels; in g C/m2)}
#'         \item{\code{SmallBranches}: Mass of (downed) small dead branches (diameters between 0.635 cm and 7.5 cm; 10h and 100h fuels; in g C/m2)}
#'         \item{\code{LargeWood}: Mass of (downed) large dead wood (diameters larger than 7.5 cm; 1000h and 10000h fuels; in g C/m2)}
#'         \item{\code{CoarseRoots}: Mass of dead coarse roots (in g C/m2)}
#'         \item{\code{FineRoots}: Mass of fine root litter (in g C/m2)}
#'      }
#'   }
#'   \item{\code{SOCData}: An optional named numeric vector containing CENTURY soil organic carbon pools (normally from previous simulations):
#'       \itemize{
#'         \item{\code{SurfaceMetabolic}: Metabolic carbon in the surface (in g C/m2).}
#'         \item{\code{BelowgroundMetabolic}: Belowground metabolic carbon pool (in g C/m2)}
#'         \item{\code{SurfaceActive}: Active decomposition carbon pool in the surface (in g C/m2)}
#'         \item{\code{BelowgroundActive}: Belowground active decomposition carbon pool (in g C/m2)}
#'         \item{\code{SurfaceSlow}: Slow decomposition carbon pool in the surface (in g C/m2)}
#'         \item{\code{BelowgroundSlow}: Belowground slow decomposition carbon pool (in g C/m2)}
#'         \item{\code{BelowgroundPassive}: Belowground passive decomposition carbon pool (in g C/m2)}
#'      }
#'   }
#' }
#' @details
#' The structure presented above for \code{forest} objects corresponds to the main (required and optional) data elements and their required columns. 
#' A \code{forest} object can contain additional information when this is available. Data frames \code{treeData}, 
#' \code{shrubData} and \code{herbData} can contain additional columns (\code{Z100} is also commonly used for data frame \code{seedlingBank}):
#' \itemize{
#'   \item{\code{Z100}: Depth (in mm) corresponding to 100% of fine roots (to specify a truncated root distribution).}
#'   \item{\code{Age}: A numeric vector indicating age of cohorts in years. Used to track cohort age in simulations with \code{\link{fordyn}}.}
#'   \item{\code{LAI}: Leaf area index (m2/m2).}
#'   \item{\code{FoliarBiomass}: Standing dry biomass of leaves (kg/m2).}
#'   \item{\code{FuelLoading}: Fine fuel loading (kg/m2).}
#'   \item{\code{CrownRatio}: The ratio between crown length and total height (between 0 and 1)}
#'   \item{\code{ObsID}: A string identifying plant cohorts at the stage of forest sampling. Used to track the fate of particular plant cohorts through simulations.
#'   In \code{\link{fordyn}}, the use of these identifiers can be combined with the control option \code{keepCohortsWithObsID} so that these cohorts are not merged 
#'   or removed during simulations.}
#' }
#' 
#' Leaf area index (\code{LAI}), foliar biomass (\code{FoliarBiomass}), fuel loading (\code{FuelLoading}) and \code{CrownRatio} are used to override allometry-based estimates of those variables 
#' when initializing inputs for functions \code{\link{spwb}} or \code{\link{spwb_day}}, but they will have no effect in simulations of \code{\link{growth}}, \code{\link{growth_day}} or \code{\link{fordyn}}. 
#' Note that leaf area index, foliar biomass and fuel loading are related entities, and they are treated as such in medfate. Therefore, users are expected to supply 
#' one or the other, and not all of them at the same time.
#' 
#' Instead of defining \code{herbData}, the herbaceous layer can be defined collectively (avoiding the need to specify species parameters for herbaceous species), 
#' using the following list items:
#' \itemize{
#'   \item{\code{herbCover}: Percent cover of the herb layer.}
#'   \item{\code{herbHeight}: Mean height (in cm) of the herb layer.}
#'   \item{\code{herbLAI}: Leaf area index (m2/m2) of the herb layer.}
#'   \item{\code{herbFoliarBiomass}: Dry biomass (kg/m2) of the herb layer.}
#'   \item{\code{herbFuelLoading}: Fine fuel loading (kg/m2) of the herb layer.}
#' }
#' 
#' 
#' @seealso \code{\link{summary.forest}}, \code{\link{emptyforest}}, \code{\link{plot.forest}}, \code{\link{spwbInput}}
#' @examples
#' data(exampleforest)
#' exampleforest
#' 
#' data(exampleforest2)
#' exampleforest2
#' @keywords data
NULL

#' Example daily meteorology data
#' 
#' Example data set of meteorological input.
#' 
#' @name examplemeteo
#' @docType data
#' 
#' @format
#' A data frame containing daily meteorology of a location in Catalonia (Spain) for year 2001:
#' \describe{
#'   \item{\code{dates}}{Vector of \code{\link{Date}} objects.}
#'    \item{\code{MinTemperature}}{Minimum daily temperature (in degrees Celsius).}
#'    \item{\code{MaxTemperature}}{Maximum daily temperature (in degrees Celsius).}
#'    \item{\code{Precipitation}}{Daily precipitation (in mm of water).}
#'    \item{\code{MinRelativeHumidity}}{Minimum daily relative humidity (in percent).}
#'    \item{\code{MaxRelativeHumidity}}{Maximum daily relative humidity (in percent).}
#'    \item{\code{Radiation}}{Incoming radiation (in MJ/m2).}
#'    \item{\code{WindSpeed}}{Wind speed (in m/s).}
#' }
#' 
#' @source Interpolated from weather station data (Spanish and Catalan meteorology agencies) using package 'meteoland'.
#' 
#' @seealso \code{\link{spwb}}
#' @examples
#'  data(examplemeteo)
#' @keywords data
NULL

#' Data tables with species parameter definitions and values
#' 
#' A data sets of species parameter definition and values, the latter resulting from existing databases, fit to empirical data or expert-based guesses.
#' 
#' @name SpParams
#' @aliases SpParamsDefinition SpParamsMED
#' 
#' @docType data 
#' 
#' @format
#' \itemize{
#'   \item{Data frame \code{SpParamsDefinition} has parameters in rows and columns 'ParameterName', 'ParameterGroup', 'Definition', 'Type' and 'Units'.}
#'   \item{Data frames \code{SpParamsMED} has species or genus as rows and column names equal to parameter names in \code{SpParamsDefinition}.}
#' }
#' @details
#' \code{SpParamsMED} was the official species parameter for package versions up to v.4.0.0, but will not be maintained in the future. Additional 
#' species parameter tables for different countries are distributed via package [traits4models](https://emf-creaf.github.io/traits4models/).
#' 
#' @examples
#' data(SpParamsDefinition)
#' data(SpParamsMED)
#' @keywords data
NULL

#' Example observed data
#'
#' Example (fake) data set of variables measured in a plot. 
#'
#' @name exampleobs
#' @docType data
#' 
#' @format
#' A data frame containing daily 'observed' values for year 2001:
#' \describe{
#'   \item{\code{dates}}{Measurement dates.}
#'   \item{\code{SWC}}{Soil moisture content (in m3/m3).}
#'   \item{\code{ETR}}{Total evapotranspiration (mm).}
#'   \item{\code{E_T1_148}}{Transpiration of Pinus halepensis cohort 'T1_148' (L/m2 of leaf area).}
#'   \item{\code{E_T2_168}}{Transpiration of Quercus ilex cohort 'T2_168' (L/m2 of leaf area).}
#'   \item{\code{FMC_T1_148}}{Fuel moisture content of Pinus halepensis cohort 'T1_148'  (in percent).}
#'   \item{\code{FMC_T2_168}}{Fuel moisture content of Quercus ilex cohort 'T2_168' (in percent).}
#'   \item{\code{BAI_T1_148}}{Basal area increment for Pinus halepensis cohort 'T1_148'  (in cm2).}
#'   \item{\code{BAI_T2_168}}{Basal area increment for Quercus ilex cohort 'T2_168' (in cm2).}
#'   \item{\code{DI_T1_148}}{Diameter increment for Pinus halepensis cohort 'T1_148'  (in cm).}
#'   \item{\code{DI_T2_168}}{Diameter increment for Quercus ilex cohort 'T2_168' (in cm).}
#'  }
#'  
#' @source
#' This data set was actually created by running a simulation and adding some gaussian error to the outputs.
#' 
#' @seealso \code{\link{evaluation}}
#' @examples
#' data(exampleobs)
#' @keywords datasets
NULL

#' Standard fuel models (Albini 1976, Scott & Burgan 2005)
#' 
#' Standard fuel models converted to metric system. Copied from package 'Rothermel' (Giorgio Vacchiano, Davide Ascoli).
#' 
#' @name SFM_metric
#' @docType data
#' @format
#'   A data frame including standard fuel models as in Albini (1976) and Scott and Burgan (2005), to be used as input of \code{\link{fire_Rothermel}} function. All values converted to metric format.
#'  \describe{
#'     \item{\code{Fuel_Model_Type}}{A factor with levels \code{D} (for dynamic) or \code{S} (for static).}
#'     \item{\code{Load_1h}}{Loading of 1h fuel class \[t/ha\].}
#'     \item{\code{Load_10h}}{Loading of 10h fuel class \[t/ha\].}
#'     \item{\code{Load_100h}}{Loading of 100h fuel class \[t/ha\]}
#'     \item{\code{Load_Live_Herb}}{Loading of herbaceous fuels \[t/ha\]}
#'     \item{\code{Load_Live_Woody}}{Loading of woody fuels \[t/ha\]}
#'     \item{\samp{SA/V_1h}}{Surface area to volume ratio of 1h fuel class \[m2/m3\]}
#'     \item{\samp{SA/V_10h}}{Surface area to volume ratio of 10h fuel class \[m2/m3\]}
#'     \item{\samp{SA/V_100h}}{Surface area to volume ratio of 100h fuel class \[m2/m3\]}
#'     \item{\samp{SA/V_Live_Herb}}{Surface area to volume ratio of herbaceous fuels \[m2/m3\]}
#'     \item{\samp{SA/V_Live_Woody}}{Surface area to volume ratio of woody fuels \[m2/m3\]}
#'     \item{\code{Fuel_Bed_Depth}}{Fuel bed depth \[cm\]}
#'     \item{\code{Mx_dead}}{Dead fuel moisture of extinction \[percent\]}
#'     \item{\code{Heat_1h}}{Heat content of 1h fuel class \[kJ/kg\]}
#'     \item{\code{Heat_10h}}{Heat content of 10h fuel class \[kJ/kg\]}
#'     \item{\code{Heat_100h}}{Heat content of 100h fuel class \[kJ/kg\]}
#'     \item{\code{Heat_Live_Herb}}{Heat content of herbaceous fuels \[kJ/kg\]}
#'     \item{\code{Heat_Live_Woody}}{Heat content of woody fuels \[kJ/kg\]}
#'  }
#' @source
#' Albini, F. A. (1976). Computer-based models of wildland fire behavior: A users' manual. Ogden, UT: US Department of Agriculture, Forest Service, Intermountain Forest and Range Experiment Station.
#'
#' Scott, J., and Burgan, R. E. (2005). A new set of standard fire behavior fuel models for use with Rothermel's surface fire spread model. Gen. Tech. Rep. RMRSGTR-153. Fort Collins, CO: US Department of Agriculture, Forest Service, Rocky Mountain Research Station.
#' 
#' @seealso \code{\link{fire_Rothermel}}
#' @examples
#' data(SFM_metric)
#' @keywords data
NULL


#' Example forest inventory data
#'
#' Example data to illustrate the creation of forest objects from inventory data,
#' coming from a forest inventory survey, used to illustrate the general function \code{\link{forest_mapTreeTable}}:
#' \itemize{
#'  \item \code{poblet_trees} - Data frame with example tree plot data from Poblet, Catalonia (717 observations and 4 variables).
#'    \itemize{
#'      \item Plot.Code - Plot ID (character)
#'      \item Indv.Ref - Tree individual (integer)
#'      \item Species - Species name (character)
#'      \item Diameter.cm - Tree diameter at breast height (cm)
#'    }
#' }
#' @name poblet_trees
#' @docType data
#' @source
#' \itemize{
#'   \item{Data table \code{poblet_trees} corresponds to field data sampled by the Catalan Forest Ownership Center (Centre de la Propietat Forestal; CPF).}
#'  }
#' @seealso \code{\link{forest_mapTreeTable}}
#' @keywords data
NULL

.mergeVectorOfMatrices<-function(vec){
  out<- NULL
  for(i in 1:length(vec)) {
    out_i <- vec[[i]]
    if(is.null(out)) out = out_i
    else {
      cno <- colnames(out)
      cno_i <- colnames(out_i)
      if(length(cno)==length(cno_i) && sum(cno==cno_i)==length(cno)) {
        out<-rbind(out, out_i)
      } else {
        cn_all = unique(c(cno, cno_i))
        cn_old = cno[which(!(cno %in% cno_i))]
        cn_new = cno_i[which(!(cno_i %in% cno))]
        if(length(cn_new)>0) {
          out <- as.data.frame(out)
          for(n in cn_new) out[[n]] = NA
        }
        if(length(cn_old)>0) {
          out_i <- as.data.frame(out_i)
          for(n in cn_old) out_i[[n]] = NA
        }
        out <- as.matrix(out[,cn_all, drop= FALSE])
        out_i <- as.matrix(out_i[,cn_all, drop= FALSE])
        out<-rbind(out, out_i)
      }
    }
  }
  return(out)
}
.summarysim<-function(object, freq="years", output="WaterBalance", FUN=sum, bySpecies = FALSE,
                      months = NULL, ...){  
  dates <- as.Date(rownames(object$WaterBalance))
  month_dates <- as.character(as.numeric(format(dates, "%m")))
  ndaysTotal <- length(dates)
  date.factor <- cut(dates, breaks=freq)
  
  if("spwbInput" %in% names(object)) input = object$spwbInput
  else if("aspwbInput" %in% names(object)) input = object$aspwbInput
  else input = object$growthInput
  
  object_names = names(object)
  output_vec = strsplit(output, "\\$")[[1]]
  if(!(output_vec[1] %in% object_names)) {
    # Try to complete
    found = FALSE
    object_names_search = object_names
    object_names_search = object_names_search[!(object_names_search %in% c("Snow", "Stand", "Temperature",
                                                                           "CarbonBalance", "WaterBalance", "EnergyBalance", "BiomassBalance",
                                                                           "FireHazard"))]
    for(nm in object_names_search) {
      if(!found) {
        if(output_vec[1] %in% names(object[[nm]])) {
          output_vec = c(nm, output_vec[1])
          found = TRUE
        }
      }
    }
    if(!found) {
      stop(paste0("Output table '", output_vec[1], "' was not generated in simulation results"))
    }
  } else if(length(output_vec)==2) {
    if(!(output_vec[2] %in% names(object[[output_vec[1]]]))) stop(paste0("Unrecognized output string: '", output ,"'\n"))
  } else if(length(output_vec)==1 && output_vec[1]=="LabileCarbonBalance") {
    output_vec = rep(output_vec, 2)
  }
  
  if(output_vec[1] %in% c("Snow", "Stand", "Temperature", 
                          "CarbonBalance", "WaterBalance", "EnergyBalance", "BiomassBalance",
                          "FireHazard", "DecompositionPools")) {
    OM = object[[output_vec[1]]]
  } else if(output_vec[1]=="Plants" && output_vec[2]=="LAI") {
    OM = object$Plants$LAI
    if(bySpecies) {
      OM = t(apply(OM,1, tapply, as.factor(input$cohorts$Name), sum, na.rm=T))
      if(nrow(OM)==1) rownames(OM) = levels(as.factor(input$cohorts$Name))
    } 
  } else {
    OM = object[[output_vec[1]]][[output_vec[2]]]
    if(bySpecies && ncol(OM)>0) {
      lai1 = t(apply(object$Plants$LAI,1, tapply, as.factor(input$cohorts$Name), sum, na.rm=T))
      if(nrow(lai1)==1) rownames(lai1) = levels(as.factor(input$cohorts$Name))
      m1 = t(apply(object$Plants$LAI * OM,1, tapply, as.factor(input$cohorts$Name), sum, na.rm=T))
      if(nrow(m1)==1) rownames(m1) = levels(as.factor(input$cohorts$Name))
      OM = m1/lai1
      OM[lai1==0] = NA
    } else if(bySpecies) {
      colnames(OM) = levels(as.factor(input$cohorts$Name))
    }
  }
  if(ncol(OM)==length(date.factor) && nrow(OM)==1) OM = t(OM)
  
  # Subset dates if 'months' is specified
  if(!is.null(months)) {
    months <- match.arg(as.character(months), as.character(1:12), several.ok = TRUE)
    sel_months <- month_dates %in% months
    date.factor <- date.factor[sel_months]
    OM <- OM[sel_months,,drop = FALSE]
  }
  #Perform summary at the desired temporal scale
  M <- apply(OM,2,tapply, INDEX=date.factor, FUN, na.rm=T)
  if(length(M)==0) {
    l <- levels(date.factor)
    M <- matrix(nrow = length(l), ncol=0)
    rownames(M) <- l
  } else if(is.vector(M)) {
    M = t(as.matrix(M))
    rownames(M) <- levels(date.factor)
  }
  # if(sum(is.na(M[nrow(M), drop=FALSE]))==ncol(M)) M = M[-nrow(M), drop=FALSE] #Remove empty row
  ncases = table(date.factor)
  if(length(M)>0) {
    M = M[ncases>0, ,drop = FALSE]
  }
  return(M)
}

#' Summarize simulation results
#' 
#' Function \code{summary} summarizes the model's output in different temporal steps (i.e. weekly, annual, ...).
#' 
#' @param object An object of class \code{spwb}, \code{aspwb}, \code{pwb}, \code{growth} or \code{fordyn}.
#' @param freq Frequency of summary statistics (see \code{\link{cut.Date}}).
#' @param output The data table to be summarized. Accepted values are the path to data tables in \code{object}, such as 'WaterBalance', 'Soil', 'Stand' or 'Plants$LAI'. It is also possible to use strings like 'Transpiration' and the function will interpret it as 'Plants$Transpiration'.
#' @param FUN The function to summarize results (e.g., \code{sum}, \code{mean}, ...)
#' @param bySpecies Allows aggregating output by species before calculating summaries (only has an effect with some values of \code{output}). Aggregation can involve a sum (as for plant lai or transpiration) or a LAI-weighted mean (as for plant stress or plant water potential).
#' @param months A vector of month numbers (1 to 12) to subset the season where summaries apply.
#' @param ... Additional parameters for function \code{summary}.
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @return A matrix with dates as row names and the desired summaries in columns
#' 
#' @note When applied to \code{\link{fordyn}} objects, the summary function can be used to gather the results of different yearly steps into a single table while keeping a daily resolution (i.e. using \code{freq = "days"}.
#' 
#' @seealso \code{\link{spwb}}, \code{\link{pwb}}, \code{\link{growth}}, \code{\link{fordyn}}, 
#' \code{\link{plot.spwb}}, \code{\link{extract}}
#' 
#' @examples
#' \donttest{
#' #Load example daily meteorological data
#' data(examplemeteo)
#' 
#' #Load example plot plant data
#' data(exampleforest)
#' 
#' #Default species parameterization
#' data(SpParamsMED)
#' 
#' #Define soil with default soil params (4 layers)
#' examplesoil <- defaultSoilParams(4)
#' 
#' #Initialize control parameters
#' control <- defaultControl("Granier")
#' 
#' #Initialize input
#' x <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)
#' 
#' #Call simulation function
#' S1<-spwb(x, examplemeteo, latitude = 41.82592, elevation = 100)
#' 
#' #Queries the tables in 'Soil'
#' names(S1$Soil)
#' 
#' #Monthly summary (averages) of soil relative water content
#' summary(S1, freq="months",FUN=mean, output="RWC")
#' 
#' #Queries the tables in 'Plants'
#' names(S1$Plants)
#' 
#' #Monthly summary (averages) of plant stress
#' summary(S1, freq="months",FUN=mean, output="PlantStress", 
#'         bySpecies = TRUE)
#' }
#' 
#' @name summary.spwb
summary.spwb<-function(object, freq="years", output="WaterBalance", FUN=sum, bySpecies = FALSE, months = NULL, ...){  
  .summarysim(object = object, freq = freq, output = output, FUN = FUN, bySpecies = bySpecies, months = months, ...)
}

#' @name summary.spwb
summary.aspwb<-function(object, freq="years", output="WaterBalance", FUN=sum, bySpecies = FALSE, months = NULL, ...){  
  .summarysim(object = object, freq = freq, output = output, FUN = FUN, bySpecies = bySpecies, months = months, ...)
}

#' @rdname summary.spwb
summary.pwb<-function(object, freq="years", output="WaterBalance", FUN=sum, bySpecies = FALSE,  months = NULL,...){  
  .summarysim(object = object, freq = freq, output = output, FUN = FUN, bySpecies = bySpecies,  months = months,...)
}

#' @rdname summary.spwb
summary.growth<-function(object, freq="years", output="WaterBalance", FUN=sum, bySpecies = FALSE,  months = NULL,...){  
  .summarysim(object = object, freq = freq, output = output, FUN = FUN, bySpecies = bySpecies, months = months, ...)
}

#' @rdname summary.spwb
summary.fordyn<-function(object, freq="years", output="WaterBalance", FUN=sum, bySpecies = FALSE,  months = NULL, ...){
  vec<-vector("list", length(object$GrowthResults))
  for(i in 1:length(object$GrowthResults)) {
    vec[[i]] <- .summarysim(object = object$GrowthResults[[i]], 
                           freq = freq, output = output, FUN = FUN, bySpecies = bySpecies, months = months, ...)
  }
  return(.mergeVectorOfMatrices(vec))
}

runners <- Rcpp::Module("runners")

.onAttach <- function(lib, pkg)  {
  packageStartupMessage("Package 'medfate' [ver. ",
                        utils::packageDescription("medfate",
                                                  fields="Version"),"]",
                        appendLF = TRUE)
}

.droughtstress_sim<-function(x, index = "NDD", freq = "years", bySpecies = FALSE) {
  dates = as.Date(rownames(x$Plants$PlantStress))
  ndaysTotal = length(dates)
  date.factor = cut(dates, breaks=freq)
  if(inherits(x, c("spwb","pwb"))) {
    transpMode = x$spwbInput$control$transpirationMode
  } else {
    transpMode = x$growthInput$control$transpirationMode
  }
  if("spwbInput" %in% names(x)) input = x$spwbInput
  else input = x$growthInput
  
  ndd<-function(dds) { # De Caceres et al (2015)
    return(sum(dds>0.5))
  }
  di<-function(dds) { # De Caceres et al (2015)
    return(sum(pmax(0,(dds-0.5)/0.5))/length(dds))
  }
  wsi<-function(lwp) { # Myers (1988)
    c = max(lwp, na.rm=T)
    return(abs(sum(lwp-c, na.rm=T)))
  }
  if(index=="NDD") {
    M <- apply(x$Plants$PlantStress,2,tapply, INDEX=date.factor, ndd)
  } else if(index=="DI") {
    M <- apply(x$Plants$PlantStress,2,tapply, INDEX=date.factor, di)
  } else if(index=="ADS") {
    M <- apply(x$Plants$PlantStress,2,tapply, INDEX=date.factor, function(x) {return(mean(x, na.rm=T))})
  } else if(index=="MDS") {
    M <- apply(x$Plants$PlantStress,2,tapply, INDEX=date.factor, function(x) {return(max(x, na.rm=T))})
  } else if(index=="WSI") {
    if(transpMode=="Granier") {
      M <- apply(x$Plants$PlantPsi,2,tapply, INDEX=date.factor, wsi)
    } else {
      M <- apply(x$Plants$LeafPsi,2,tapply, INDEX=date.factor, wsi)
    }
  }
  if(is.vector(M)) {
    M = t(as.matrix(M))
    rownames(M) <- levels(date.factor)
  }
  if(bySpecies) {
    cohlai = apply(x$Plants$LAI,2,max, na.rm=T)
    cohsp = as.character(input$cohorts$Name)
    lai1 = tapply(cohlai, cohsp, sum, na.rm=T)
    m1 = t(apply(sweep(M,2,cohlai,"*"),1,tapply, cohsp, sum, na.rm=T))
    if(length(lai1)==1) {
      m1 = t(m1)
    } 
    M = sweep(m1,2,lai1,"/")
    colnames(M) = names(lai1)
  }
  ncases = table(date.factor)
  M = M[ncases>0, ,drop = FALSE]
  return(M)
}

#' Drought stress indicators
#' 
#' Calculates plant drought stress indices, at different temporal scales, from simulation results.
#' 
#' @param x An object of class \code{\link{spwb}}, \code{\link{pwb}}, \code{\link{growth}} or \code{\link{fordyn}}.
#' @param index A string with the index to be calculated, either \code{"DI"}, \code{"NDD"}, \code{"ADS"}, \code{"MDS"} or \code{"WSI"} (see details).
#' @param freq Frequency of stress statistics (see \code{\link{cut.Date}}). Normally, either \code{"years"} or \code{"months"} for yearly-based or monthly-based indices.
#' @param bySpecies Allows aggregating output by species.
#' @param draw A boolean flag to indicate that a plot should be returned.
#' 
#' @details The currently available drought stress indices are:
#' \itemize{
#'   \item{\code{"ADS"}: Average of daily drought stress values for the period considered.}
#'   \item{\code{"MDS"}: Maximum daily drought stress during the period considered.}
#'   \item{\code{"DI"}: Drought intensity, as defined in De \enc{Cáceres}{Caceres} et al. (2015).}
#'   \item{\code{"NDD"}: Number of drought days, as defined in De \enc{Cáceres}{Caceres} et al. (2015).}
#'   \item{\code{"WSI"}: Water stress integral, as defined in Myers (1988).}
#' }
#' 
#' @return A data frame with periods (e.g., years or months) in rows and plant cohorts (or species) in columns. 
#' Values are the calculated stress index. If \code{draw=TRUE} a ggplot is returned instead.
#' 
#' @references 
#' 
#' De \enc{Cáceres}{Caceres} M, \enc{Martínez}{Martinez}-Vilalta J, Coll L, Llorens P, Casals P, Poyatos R, Pausas JG, Brotons L. (2015) Coupling a water balance model with forest inventory data to predict drought stress: the role of forest structural changes vs. climate changes. Agricultural and Forest Meteorology 213: 77-90 (doi:10.1016/j.agrformet.2015.06.012).
#' 
#' Myers BJ (1988) Water stress integral - a link between short-term stress and long-term growth. Tree Physiology 4: 315–323 (doi: 10.1093/treephys/4.4.315)
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso \code{\link{summary.spwb}}, \code{\link{waterUseEfficiency}}
#' 
droughtStress<-function(x, index = "NDD", freq = "years", bySpecies = FALSE, draw = TRUE) {
  if(!inherits(x,c("spwb","pwb","growth", "fordyn"))) {
    stop("'x' should be of class 'spwb', 'pwb', 'growth' or 'fordyn'")
  }
  index = match.arg(index,c("NDD","DI", "ADS", "MDS","WSI"))  
  
  if(inherits(x, c("spwb","pwb", "growth"))) {
     M = .droughtstress_sim(x = x, index = index, freq = freq, bySpecies = bySpecies)
  } else {
    vec<-vector("list", length(x$GrowthResults))
    for(i in 1:length(x$GrowthResults)) {
      vec[[i]] <- .droughtstress_sim(x = x$GrowthResults[[i]], index = index, freq = freq, bySpecies = bySpecies)
    }
    M = .mergeVectorOfMatrices(vec)
  }
  if(draw) {
    if(index=="NDD") {
      g<-.multiple_dynamics(M, ylab = "Number of days with DS > 0.5")
    }
    else if(index=="DI") {
      g<-.multiple_dynamics(M, ylab = "Average drought stress over 0.5")
    }
    else if(index=="ADS") {
      g<-.multiple_dynamics(M, ylab = "Average drought stress")
    }
    else if(index=="MDS") {
      g<-.multiple_dynamics(M, ylab = "Maximum drought stress")
    }
    else if(index=="WSI") {
      g<-.multiple_dynamics(M, ylab = "Water stress integral")
    }
    return(g)
  } else {
    return(M)
  }
}

.shinyplot_day<-function(out){
  if(inherits(out, c("spwb_day", "pwb_day"))) {
    transpirationMode = out$spwbInput$control$transpirationMode
    cohorts_out = row.names(out$spwbInput$cohorts)
    cohorts_sp_out = paste0(row.names(out$spwbInput$cohorts), 
                            " (",out$spwbInput$cohorts$Name, ")")
  } else {
    transpirationMode = out$growthInput$control$transpirationMode
    cohorts_out = row.names(out$growthInput$cohorts)
    cohorts_sp_out = paste0(row.names(out$growthInput$cohorts), 
                            " (",out$growthInput$cohorts$Name, ")")
  }
  plot_main_choices = c("Soil", "Plants", "Sunlit/Shade", "Energy balance")
  if(inherits(out, c("growth_day"))) {
    plot_main_choices = c(plot_main_choices, 
                          "Labile carbon balance")
  }
  subdaily_soil_plot_choices = .getSubdailySoilPlotTypes()
  subdaily_plant_plot_choices = .getSubdailyPlantPlotTypes()
  subdaily_sunlitshade_plot_choices = .getSubdailySunlitShadePlotTypes()
  subdaily_energy_plot_choices = .getSubdailyEnergyBalancePlotTypes()
  subdaily_labile_plot_choices = .getSubdailyLabilePlotTypes()
  
  ui <- fluidPage(
    sidebarLayout(
      sidebarPanel(
        selectInput(
          inputId = "plot_main_type",
          label = "Category",
          choices = plot_main_choices,
          selected = plot_main_choices[1]
        ),
        selectInput(
          inputId = "plot_var",
          label = "Variable", 
          choices = subdaily_soil_plot_choices,
          selected = subdaily_soil_plot_choices[1]
        ),
        checkboxInput(
          inputId = "byspecies_check",
          label = "Aggregation by species",
          value = FALSE
        )
      ),
      mainPanel(
        plotOutput("spatial_plot")
      )
    )
  )
  server <- function(input, output, session) {
    observe({
      main_plot <- input$plot_main_type
      if(main_plot=="Soil") sub_choices = subdaily_soil_plot_choices
      else if(main_plot=="Plants") sub_choices = subdaily_plant_plot_choices
      else if(main_plot=="Sunlit/Shade") sub_choices = subdaily_sunlitshade_plot_choices
      else if(main_plot=="Energy balance") sub_choices = subdaily_energy_plot_choices
      else if(main_plot=="Labile carbon balance") sub_choices = subdaily_labile_plot_choices
      updateSelectInput(session, "plot_var",
                        choices = sub_choices)
    })
    output$spatial_plot <- renderPlot({
      plot(out, type = input$plot_var, bySpecies = input$byspecies_check)
    })
  }
  
  shinyApp(ui = ui, server = server)
}

.shinyplot_sim<-function(out, measuredData = NULL) {
  if(inherits(out, c("spwb_day", "pwb_day", "growth_day"))) return(.shinyplot_day(out))
  if(!inherits(out, c("aspwb","growth", "pwb" , "spwb", "fordyn"))) stop("Wrong class for 'out'. Should either be 'spwb', 'growth' or 'fordyn'.")
  type_out = class(out)[1] #growth, spwb, fordyn
  if(type_out=="aspwb") {
    transpirationMode = NA
    subdaily_out = FALSE
    cohorts_out = character(0)
    cohorts_sp_out = character(0)
    dates_out = as.Date(row.names(out$WaterBalance))
  } else if(type_out=="spwb") {
    transpirationMode = out$spwbInput$control$transpirationMode
    subdaily_out = out$spwbInput$control$subdailyResults
    cohorts_out = row.names(out$spwbInput$cohorts)
    cohorts_sp_out = paste0(row.names(out$spwbInput$cohorts), 
                            " (",out$spwbInput$cohorts$Name, ")")
    dates_out = as.Date(row.names(out$WaterBalance))
  } else if(type_out=="growth") {
    transpirationMode = out$growthInput$control$transpirationMode
    cohorts_out = row.names(out$growthInput$cohorts)
    cohorts_sp_out = paste0(row.names(out$growthInput$cohorts), 
                            " (",out$growthInput$cohorts$Name, ")")
    subdaily_out = out$growthInput$control$subdailyResults
    dates_out = as.Date(row.names(out$WaterBalance))
  } else { # fordyn
    out_1 = out$GrowthResults[[1]]
    transpirationMode = out_1$growthInput$control$transpirationMode
    cohorts_out = row.names(out_1$growthInput$cohorts)
    sp_out = out_1$growthInput$cohorts$Name
    if(length(out$GrowthResults)>1) {
      for(i in 2:length(out$GrowthResults)) {
        out_i = out$GrowthResults[[i]]
        cn = row.names(out_i$growthInput$cohorts)
        for(j in 1:length(cn)) {
          if(!(cn[j] %in% cohorts_out)) {
            cohorts_out = c(cohorts_out, cn[j])
            sp_out = c(sp_out, out_i$growthInput$cohorts$Name[j])
          }
        }
      }
    }
    cohorts_sp_out = paste0(cohorts_out, 
                            " (",sp_out, ")")
    subdaily_out = FALSE
    dates_out = NULL
    for(i in 1:length(out$GrowthResults)) {
      if(is.null(dates_out)) dates_out = as.Date(row.names(out$GrowthResults[[i]]$WaterBalance))
      else dates_out = c(dates_out, as.Date(row.names(out$GrowthResults[[i]]$WaterBalance)))
    }
  }
  cohort_choices = cohorts_out
  names(cohort_choices) = cohorts_sp_out
  
  wb_plot_choices = .getWaterBalancePlotTypes(type_out)
  stand_plot_choices = .getStandPlotTypes(type_out)
  soil_plot_choices = .getSoilPlotTypes(type_out) 
  
  if(type_out!="aswpb") {
    plant_plot_choices = .getPlantPlotTypes(transpirationMode)
    sunlitshade_plot_choices = .getSunlitShadePlotTypes(transpirationMode)
    energy_plot_choices = .getEnergyPlotTypes(transpirationMode)
    labile_plot_choices = .getLabileGROWTHPlotTypes(transpirationMode)
    plant_balance_plot_choices = .getCohortBiomassBalanceGROWTHPlotTypes(transpirationMode)
    plant_structure_plot_choices = .getStructuralGROWTHPlotTypes(transpirationMode)
    plant_growthmortality_plot_choices = .getGrowthMortalityGROWTHPlotTypes(transpirationMode)
    forest_dynamics_plot_choices = .getUniqueFORDYNPlotTypes(transpirationMode)
  }
  
  plot_main_choices <- c("Water balance", "Soil")
  if(type_out!= "aspwb") {
    plot_main_choices <- c(plot_main_choices, "Stand", "Plants")
    if(transpirationMode %in% c("Sperry","Sureau")) {
      plot_main_choices = c(plot_main_choices,"Sunlit/Shade", "Energy balance")
    }
    if(type_out %in% c("growth", "fordyn")) {
      plot_main_choices = c(plot_main_choices, 
                            "Labile carbon balance",
                            "Biomass balance",
                            "Plant structure",
                            "Growth & mortality")
    }
    if(type_out=="fordyn") {
      plot_main_choices = c(plot_main_choices, "Forest structure & composition")
    }
  }
  
  subdaily_soil_plot_choices = .getSubdailySoilPlotTypes()
  subdaily_plant_plot_choices = .getSubdailyPlantPlotTypes()
  subdaily_sunlitshade_plot_choices = .getSubdailySunlitShadePlotTypes()
  subdaily_labile_plot_choices = .getSubdailyLabilePlotTypes()
  subdaily_energy_plot_choices = .getSubdailyEnergyBalancePlotTypes()
  
  
  # Define UI for application that draws a histogram
  results <- tabPanel("Results",
                      # Sidebar with a slider input for number of bins 
                      sidebarLayout(
                        sidebarPanel(
                          tabsetPanel(
                            tabPanel("Plot selection",
                                     checkboxInput(
                                       inputId = "subdaily_check",
                                       label = "Subdaily plots",
                                       value = FALSE
                                     ),                          
                                     selectInput(
                                       inputId = "plot_main_type",
                                       label = "Plot category", 
                                       choices = plot_main_choices,
                                       selected = "Water balance"
                                     ),
                                     selectInput(
                                       inputId = "plot_type",
                                       label = "Plot type", 
                                       choices = wb_plot_choices,
                                       selected = wb_plot_choices[1]
                                     ),
                                     sliderInput(
                                       inputId = "date_range",
                                       label = "Date range",
                                       value = c(dates_out[1],dates_out[length(dates_out)]),
                                       min = dates_out[1],
                                       max = dates_out[length(dates_out)]
                                     ),
                                     selectInput(
                                       inputId = "summary_type",
                                       label = "Temporal aggregation", 
                                       choices = c("None" = "day", 
                                                   "By weeks" = "week", 
                                                   "By months" = "month", 
                                                   "By seasons" = "quarter", 
                                                   "By years" = "year"),
                                       selected = ifelse(type_out=="fordyn","year","None")
                                     )
                            ),
                            tabPanel("Plants",
                                     radioButtons(inputId = "plant_group_selection",
                                                  label = "Plant group",
                                                  choices = c("all", "trees", "shrubs"),
                                                  selected = "all",
                                                  inline = TRUE),
                                     selectInput(
                                       inputId = "cohort_selection",
                                       label = "Plant cohorts",
                                       choices = cohort_choices,
                                       selected = cohort_choices,
                                       multiple = TRUE,
                                       selectize = FALSE
                                     ),
                                     checkboxInput(
                                       inputId = "byspecies_check",
                                       label = "Aggregation by species",
                                       value = FALSE
                                     )
                            )
                          )
                        ),
                        
                        # Show a plot of the generated distribution
                        mainPanel(
                          plotOutput("results_plot")
                        )
                      )
  )
  eval_choices = c()
  if(!is.null(measuredData)) {
    if("SWC" %in% names(measuredData)) {
      eval_choices[["Soil water content"]] = "SWC"
      eval_choices[["Relative soil water content"]] = "REW"
    } 
    if("ETR" %in% names(measuredData)) {
      eval_choices[["Total evapotranspiration"]] = "ETR"
      eval_choices[["Total ET against modelled SE+TR"]] = "SE+TR"
    }
    if(any(paste0("E_", cohorts_out) %in% names(measuredData))) {
      eval_choices[["Transpiration per leaf area"]] = "E"
    }
    if(any(paste0("FMC_", cohorts_out) %in% names(measuredData))) {
      eval_choices[["Live fuel moisture content"]] = "LFMC"
    }
    if(any(c(paste0("PD_", cohorts_out) %in% names(measuredData),
             paste0("MD_", cohorts_out) %in% names(measuredData)))) {
      eval_choices[["Leaf water potential"]] = "WP"
    }
    if(type_out=="growth" && any(paste0("BAI_", cohorts_out) %in% names(measuredData))) {
      eval_choices[["Basal area increment"]] = "BAI"
    }
    if(type_out=="growth" && any(paste0("DI_", cohorts_out) %in% names(measuredData))) {
      eval_choices[["Diameter increment"]] = "DI"
    }
    if(type_out=="growth" && any(paste0("DBH_", cohorts_out) %in% names(measuredData))) {
      eval_choices[["Diameter at breast height"]] = "DBH"
    }
    if(type_out=="growth" && any(paste0("Height_", cohorts_out) %in% names(measuredData))) {
      eval_choices[["Plant height"]] = "Height"
    }
  }
  evaluation <- tabPanel("Evaluation",
                         sidebarLayout(
                           sidebarPanel(
                             selectInput(
                               inputId = "eval_type",
                               label = "Evaluation type", 
                               choices = eval_choices,
                               selected = eval_choices[1]
                             ),
                             selectInput(
                               inputId = "eval_cohort",
                               label = "Plant cohort",
                               choices = c()
                             ),
                             selectInput(
                               inputId = "eval_summary_type",
                               label = "Temporal aggregation", 
                               choices = c("By days" = "day", 
                                           "By weeks" = "week", 
                                           "By months" = "month", 
                                           "By years" = "year"),
                               selected = c("None")
                             )
                           ),
                           mainPanel(
                             tabsetPanel(
                               tabPanel("Dynamic",
                                        plotOutput("dynamic_eval_plot")
                               ),
                               tabPanel("Scatter",
                                        plotOutput("scatter_eval_plot")
                               ), 
                               tabPanel("Stats",
                                        verbatimTextOutput("eval_stats")
                               )
                             )
                           )
                         ),
  )
  if(is.null(measuredData)) {
    ui <- navbarPage("Interactive plots", results)
  } else {
    ui <- navbarPage("Interactive plots", results, evaluation)
  }
  
  # Define server logic required to draw a histogram
  server <- function(input, output, session) {
    observe({
      if(input$subdaily_check && subdaily_out)  {
        sel <- plot_main_choices %in% c("Plants", "Sunlit/Shade","Labile carbon balance", "Soil", "Energy balance")
        updateSelectInput(session, "plot_main_type",
                          choices = plot_main_choices[sel])
      } else {
        updateSelectInput(session, "plot_main_type",
                          choices = plot_main_choices)
      }
    })
    observe({
      main_plot <- input$plot_main_type
      if(main_plot=="Water balance") sub_choices = wb_plot_choices
      else if(main_plot=="Stand") sub_choices = stand_plot_choices
      else if(main_plot=="Plants") sub_choices = plant_plot_choices
      else if(main_plot=="Sunlit/Shade") sub_choices = sunlitshade_plot_choices
      else if(main_plot=="Labile carbon balance") sub_choices = labile_plot_choices
      else if(main_plot=="Biomass balance") sub_choices = plant_balance_plot_choices
      else if(main_plot=="Energy balance") sub_choices = energy_plot_choices
      else if(main_plot=="Plant structure") sub_choices = plant_structure_plot_choices
      else if(main_plot=="Growth & mortality") sub_choices = plant_growthmortality_plot_choices
      else if(main_plot=="Forest structure & composition") sub_choices = forest_dynamics_plot_choices
      else sub_choices = soil_plot_choices
      
      if(input$subdaily_check && subdaily_out) {
        if(main_plot=="Plants") sub_choices = subdaily_plant_plot_choices
        else if(main_plot=="Sunlit/Shade") sub_choices = subdaily_sunlitshade_plot_choices
        else if(main_plot=="Labile carbon balance")  sub_choices = subdaily_labile_plot_choices
        else if(main_plot=="Energy balance") sub_choices = subdaily_energy_plot_choices
        else sub_choices = subdaily_soil_plot_choices
      }
      updateSelectInput(session, "plot_type",
                        choices = sub_choices)
    })
    observe({
      plant_group = input$plant_group_selection
      if(plant_group=="trees") {
        sel = (substr(cohorts_out,1,1)=="T")
      } else if(plant_group=="shrubs") {
        sel = (substr(cohorts_out,1,1)=="S")
      } else {
        sel = rep(TRUE, length(cohorts_out))
      }
      cohort_choices = cohorts_out[sel]
      names(cohort_choices) = cohorts_sp_out[sel]
      updateSelectInput(session, "cohort_selection",
                        choices = cohort_choices,
                        selected = cohort_choices)
    })
    output$results_plot <- renderPlot({
      date_lim = input$date_range
      date_range = dates_out[dates_out >= date_lim[1] & dates_out <= date_lim[2]]
      plot(out, type = input$plot_type, dates = date_range,
           summary.freq = input$summary_type, 
           subdaily = input$subdaily_check,
           cohorts = cohort_choices[cohort_choices %in% input$cohort_selection],
           bySpecies = input$byspecies_check)
    })
    if(!is.null(measuredData)) {
      observe({
        eval_plot <- input$eval_type
        sub_choices <- NULL
        if(eval_plot %in% c("E", "BAI", "DI", "DBH", "Height", "FMC")) {
          sel = paste0(eval_plot,"_", cohorts_out) %in% names(measuredData)
          sub_choices = cohorts_out[sel]
          names(sub_choices) = cohorts_sp_out[sel]
        }
        else if(eval_plot == "WP") {
          sel = paste0("MD_", cohorts_out) %in% names(measuredData) | paste0("PD_", cohorts_out) %in% names(measuredData)
          sub_choices = cohorts_out[sel]
          names(sub_choices) = cohorts_sp_out[sel]
        }
        updateSelectInput(session, "eval_cohort",
                          choices = sub_choices)
      })
      output$dynamic_eval_plot <- renderPlot(
        evaluation_plot(out, measuredData, 
                        type = input$eval_type,
                        temporalResolution = input$eval_summary_type,
                        cohort = input$eval_cohort,
                        plotType = "dynamic")
      )
      output$scatter_eval_plot <- renderPlot(
        evaluation_plot(out, measuredData, 
                        type = input$eval_type,
                        temporalResolution = input$eval_summary_type,
                        cohort = input$eval_cohort,
                        plotType = "scatter")
      )
      output$eval_stats <- renderPrint({
        evaluation_stats(out, measuredData, 
                         type = input$eval_type,
                         temporalResolution = input$eval_summary_type,
                         cohort = input$eval_cohort)
      })
    }
  }
  
  # Run the application 
  shinyApp(ui = ui, server = server)
}


#' Shiny app with interactive plots
#' 
#' Creates a shiny app with interactive plots for simulation results and evaluation
#' 
#' @param x An object of the right class.
#' @param measuredData A data frame with observed/measured values (see \code{\link{evaluation_plot}}).
#' @param ... Additional parameters.
#' 
#' @details Only run this function in interactive mode. When \code{measuredData} is not \code{NULL}, an additional panel is shown for evaluation plots.
#' 
#' @return An object that represents the shiny app
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso \code{\link{plot.spwb}}, \code{\link{evaluation_plot}}
#' 
#' @name shinyplot
shinyplot<-function(x, ...) {
  UseMethod("shinyplot", x)
}

#' @rdname shinyplot 
shinyplot.growth<-function(x, measuredData = NULL, ...) {
  .shinyplot_sim(x, measuredData = measuredData)
}

#' @rdname shinyplot
shinyplot.aspwb<-function(x, measuredData = NULL, ...) {
  .shinyplot_sim(x, measuredData = measuredData)
}


#' @rdname shinyplot
shinyplot.spwb<-function(x, measuredData = NULL, ...) {
  .shinyplot_sim(x, measuredData = measuredData)
}

#' @rdname shinyplot
shinyplot.pwb<-function(x, measuredData = NULL, ...) {
  .shinyplot_sim(x, measuredData = measuredData)
}

#' @rdname shinyplot
shinyplot.fordyn<-function(x, measuredData = NULL, ...) {
  .shinyplot_sim(x, measuredData = measuredData)
}

#' @rdname shinyplot
shinyplot.growth_day<-function(x, ...) {
  .shinyplot_day(x)
}

#' @rdname shinyplot
shinyplot.spwb_day<-function(x, ...) {
  .shinyplot_day(x)
}

#' @rdname shinyplot
shinyplot.pwb_day<-function(x, ...) {
  .shinyplot_day(x)
}

.getWaterBalancePlotTypes<-function(model = "pwb") {
  TYPES <- character(0)
  if(model == "aspwb") {
    TYPES = c("PET & Precipitation" = "PET_Precipitation",
              "Snow" = "Snow",
              "Water exported" = "Export",
              "Evapotranspiration" = "Evapotranspiration")
  } else {
    TYPES = c("PET & Precipitation" = "PET_Precipitation",
              "PET and Net rain" = "PET_NetRain",
              "Snow" = "Snow",
              "Water exported" = "Export",
              "Evapotranspiration" = "Evapotranspiration")
  }
  return(TYPES)
}
.getSoilPlotTypes<-function(model = "pwb") {
  TYPES = c(
    "Soil water potential" = "SoilPsi",
    "Soil relative water content" = "SoilRWC",
    "Soil relative extractable water" = "SoilREW",
    "Soil moisture (m3/m3) content" = "SoilTheta",
    "Soil volume (mm) content" = "SoilVol")
  if(model != "aspwb") {
    TYPES = c(TYPES, 
              "Plant extraction from soil"= "PlantExtraction",
              "Hydraulic redistribution" = "HydraulicRedistribution")
  }
  return(TYPES)
}
.getStandPlotTypes<-function(model = "pwb") {
  TYPES = character(0)
  if(model !="aspwb") {
    TYPES = c("Stand LAI"="LAI",
              "Ground-level irradiance" = "GroundIrradiance")
  }
  if(model %in% c("growth", "fordyn")) {
    TYPES = c(TYPES, 
              "Carbon balance" = "CarbonBalance",
              "Biomass balance" = "BiomassBalance",
              "Decomposition pools" = "DecompositionPools")
  }
  return(TYPES)
}
.getPlantPlotTypes<-function(transpirationMode = "Granier") {
  TYPES = c("Plant LAI" = "PlantLAI",
            "Plant LAI (live)" = "PlantLAIlive",
            "Transpiration" = "PlantTranspiration",
            "Transpiration per leaf" = "TranspirationPerLeaf",
            "Plant water balance" = "PlantWaterBalance",
            "Gross photosynthesis" = "PlantGrossPhotosynthesis",
            "Gross photosynthesis per leaf" = "GrossPhotosynthesisPerLeaf")
  if(transpirationMode %in% c("Sperry","Sureau")) {
    TYPES <-c(TYPES,
              "Net photosynthesis" = "PlantNetPhotosynthesis",
              "Net photosynthesis per leaf" = "NetPhotosynthesisPerLeaf",
              "Water use efficiency" = "PlantWUE",
              "Absorbed short-wave radiation" = "PlantAbsorbedSWR",
              "Absorbed short-wave radiation per leaf" = "AbsorbedSWRPerLeaf",
              "Net long-wave radiation" = "PlantNetLWR",
              "Net long-wave radiation per leaf" = "NetLWRPerLeaf")
  } else {
    TYPES <-c(TYPES,
              "Fraction of PAR" = "FPAR",
              "Absorbed SWR fraction" = "AbsorbedSWRFraction")
  }           
  
  if(transpirationMode %in% c("Sperry","Sureau")) {
    TYPES <-c(TYPES,
              "Minimum leaf water potential" = "LeafPsiMin",
              "Maximum leaf water potential" = "LeafPsiMax",
              "Leaf water potential range" = "LeafPsiRange",
              "Midday upper stem water potential" = "StemPsi",
              "Midday root crown water potential" = "RootPsi",
              "Stem relative water content" = "StemRWC",
              "Leaf relative water content" = "LeafRWC",
              "Live fuel moisture content" = "LFMC")
  } else {
    TYPES <-c(TYPES,
              "Plant water potential" = "PlantPsi",
              "Stem relative water content" = "StemRWC",
              "Leaf relative water content" = "LeafRWC",
              "Live fuel moisture content" = "LFMC")
  }
  if(transpirationMode %in% c("Sperry","Sureau")) {
    TYPES <-c(TYPES,
              "Soil-plant conductance" = "SoilPlantConductance")
  }
  TYPES <-c(TYPES,
            "Plant stress" = "PlantStress",
            "Leaf percent conductance loss" = "LeafPLC",
            "Stem percent conductance loss" = "StemPLC")
  return(TYPES)
}
.getSunlitShadePlotTypes<-function(transpirationMode = "Granier"){
  TYPES = character(0)
  if(transpirationMode %in% c("Sperry","Sureau")) {
    TYPES = c(TYPES,
              "Minimum leaf temperature (sunlit)" ="TempMin_SL", 
              "Minimum leaf temperature (shade)" = "TempMin_SH", 
              "Maximum leaf temperature (sunlit)" ="TempMax_SL",
              "Maximum leaf temperature (shade)" ="TempMax_SH",
              "Minimum stomatal conductance (sunlit)" ="GSWMin_SL", 
              "Minimum stomatal conductance (shade)" ="GSWMin_SH", 
              "Maximum stomatal conductance (sunlit)" ="GSWMax_SL", 
              "Maximum stomatal conductance (shade)" ="GSWMax_SH",
              "Minimum leaf water potential (sunlit)" ="LeafPsiMin_SL", 
              "Minimum leaf water potential (shade)" ="LeafPsiMin_SH", 
              "Maximum leaf water potential (sunlit)" ="LeafPsiMax_SL", 
              "Maximum leaf water potential (shade)" ="LeafPsiMax_SH")
  }
  return(TYPES)
}
.getEnergyPlotTypes<-function(transpirationMode = "Granier") {
  TYPES = character(0)
  if(transpirationMode %in% c("Sperry","Sureau")) {
    TYPES = c(TYPES,
              "Temperature" = "Temperature",
              "Temperature range" = "TemperatureRange",
              "Above-canopy air temperature" = "AirTemperature",
              "Within-canopy air temperature" = "CanopyTemperature",
              "Soil surface temperature" = "SoilTemperature",
              "Canopy energy balance components" = "CanopyEnergyBalance",
              "Soil energy balance components" = "SoilEnergyBalance")
  }
  return(TYPES)
}
.getStructuralGROWTHPlotTypes<-function(transpirationMode = "Granier"){
  TYPES = c("Leaf biomass per individual" = "LeafBiomass",
            "Sapwood biomass per individual" = "SapwoodBiomass",
            "Fine root biomass per individual" = "FineRootBiomass",
            "Sapwood area" ="SapwoodArea",
            "Leaf area" = "LeafArea", 
            "Fine root area" ="FineRootArea")
  TYPES = c(TYPES,             
            "Diameter at breast height" = "DBH",
            "Plant height" =  "Height", 
            "Sapwood area / Leaf area" ="HuberValue",
            "Fine root area / Leaf area" ="RootAreaLeafArea")
  return(TYPES)
}
.getGrowthMortalityGROWTHPlotTypes<-function(transpirationMode = "Granier"){
  TYPES = c("Sapwood area growth rate" ="SAgrowth",
            "Leaf area growth rate" = "LAgrowth",
            "Leaf area growth rate" = "LAgrowth", 
            "Fine root area growth rate" ="FRAgrowth")
  TYPES = c(TYPES,
            "Starvation mortality rate" = "StarvationRate", 
            "Dessication mortality rate" = "DessicationRate", 
            "Mortality rate" = "MortalityRate")
  return(TYPES)
}
.getCohortBiomassBalanceGROWTHPlotTypes<-function(transpirationMode = "Granier"){
  return(c("Structural biomass balance (g/m2)" = "StructuralBiomassBalance",
           "Labile biomass balance (g/m2)" = "LabileBiomassBalance",
           "Plant biomass balance (g/m2)" = "PlantBiomassBalance",
           "Mortality biomass loss (g/m2)" = "MortalityBiomassLoss",
           "Cohort biomass balance (g/m2)" = "CohortBiomassBalance"))
}
.getLabileGROWTHPlotTypes<-function(transpirationMode = "Granier") {
  TYPES= c("Gross photosynthesis per dry" = "GrossPhotosynthesis",
           "Maintenance respiration per dry" = "MaintenanceRespiration",
           "Photosynthesis-maintenance ratio" = "PhotosynthesisMaintenanceRatio",
           "Growth costs per dry" = "GrowthCosts",
           "Labile carbon balance per dry" = "LabileCarbonBalance",
           "Leaf sugar concentration" = "SugarLeaf",
           "Leaf starch concentration" = "StarchLeaf",
           "Sapwood sugar concentration" = "SugarSapwood",
           "Sapwood starch concentration" = "StarchSapwood",
           "Sugar transport" = "SugarTransport",
           "Root exudation" = "RootExudation")
  return(TYPES)
}

.getDailyPWBPlotTypes<-function(transpirationMode = "Granier") {
  TYPES = c(.getSoilPlotTypes("pwb"),
            .getStandPlotTypes("pwb"),
            .getPlantPlotTypes(transpirationMode),
            .getSunlitShadePlotTypes(transpirationMode),
            .getEnergyPlotTypes(transpirationMode))
  return(TYPES)
}

.getDailyASPWBPlotTypes<-function(transpirationMode = "Granier") {
  TYPES = c(.getWaterBalancePlotTypes("aspwb"),
            .getSoilPlotTypes("aspwb"))
  return(TYPES)
}

.getDailySPWBPlotTypes<-function(transpirationMode = "Granier") {
  TYPES = c(.getWaterBalancePlotTypes("spwb"),
            .getSoilPlotTypes("spwb"),
            .getStandPlotTypes("spwb"),
            .getPlantPlotTypes(transpirationMode),
            .getSunlitShadePlotTypes(transpirationMode),
            .getEnergyPlotTypes(transpirationMode))
  return(TYPES)
}

.getUniqueDailyGROWTHPlotTypes<-function(transpirationMode = "Granier"){
  TYPES = c("Carbon balance" = "CarbonBalance",
            "Biomass balance" = "BiomassBalance",
            "Decomposition pools" = "DecompositionPools",
            .getLabileGROWTHPlotTypes(transpirationMode),
            .getCohortBiomassBalanceGROWTHPlotTypes(transpirationMode),
            .getStructuralGROWTHPlotTypes(transpirationMode),
            .getGrowthMortalityGROWTHPlotTypes(transpirationMode))
  return(TYPES)
}
.getDailyGROWTHPlotTypes<-function(transpirationMode = "Granier"){
  TYPES = c(.getWaterBalancePlotTypes("growth"),
            .getSoilPlotTypes("growth"),
            .getStandPlotTypes("growth"),
            .getPlantPlotTypes(transpirationMode),
            .getSunlitShadePlotTypes(transpirationMode),
            .getEnergyPlotTypes(transpirationMode),
            .getUniqueDailyGROWTHPlotTypes(transpirationMode))
  return(TYPES)
}

.getUniqueFORDYNPlotTypes<-function(transpirationMode = "Granier"){
  return(c("Stand basal area" = "StandBasalArea", 
           "Dominant tree height" = "DominantTreeHeight",
           "Dominant tree diameter" = "DominantTreeDiameter",
           "Quadratic mean tree diameter" = "QuadraticMeanTreeDiameter",
           "Hart-Becking index" = "HartBeckingIndex",
           "Basal area of trees by species" = "SpeciesBasalArea", 
           "Basal area of trees by cohort" = "CohortBasalArea", 
           "Stand density of trees" = "StandDensity",
           "Density of trees by species" = "SpeciesDensity",
           "Density of trees by cohort" = "CohortDensity",
           "Stand shrub cover" = "StandShrubCover",
           "Shrub cover by species" = "SpeciesShrubCover",
           "Shrub cover by cohort" = "CohortShrubCover",
           "Number of tree species" = "NumTreeSpecies",
           "Number of shrub species" = "NumShrubSpecies",
           "Number of tree cohorts" = "NumTreeCohorts",
           "Number of shrub cohorts" = "NumShrubCohorts",
           "Number of cohorts by species" = "NumCohortsSpecies"))
}

.getSubdailySoilPlotTypes<-function(){
  return(c("Plant extraction from soil" = "PlantExtraction"))
}
.getSubdailyPlantPlotTypes<-function(){
  TYPES = c("Average leaf water potential" = "LeafPsiAverage",
            "Root crown water potential" = "RootPsi", 
            "Stem water potential" = "StemPsi", 
            "Leaf symplastic water potential" = "LeafSympPsi", 
            "Stem symplastic water potential" = "StemSympPsi",
            "Leaf percent conductance loss" = "LeafPLC",
            "Stem percent conductance loss" = "StemPLC",
            "Stem relative water content" = "StemRWC", 
            "Leaf relative water content" = "LeafRWC",
            "Stem symplastic relative water content" = "StemSympRWC", 
            "Leaf symplastic relative water content" = "LeafSympRWC",
            "Soil-plant conductance" = "SoilPlantConductance",
            "Plant transpiration" = "PlantTranspiration", 
            "Transpiration per leaf area" = "TranspirationPerLeaf",
            "Plant gross photosynthesis" = "PlantGrossPhotosynthesis",
            "Gross photosynthesis per leaf area" = "GrossPhotosynthesisPerLeaf",
            "Plant net photosynthesis" = "PlantNetPhotosynthesis",
            "Net photosynthesis per leaf area" = "NetPhotosynthesisPerLeaf", 
            "Plant water balance" = "PlantWaterBalance", 
            "Water balance per leaf area"= "WaterBalancePerLeaf")
  return(TYPES)
}
.getSubdailySunlitShadePlotTypes<-function(){
  TYPES = c("Leaf area" = "LeafLAI",
            "Leaf water potential" = "LeafPsi",
            "Leaf transpiration" = "LeafTranspiration",
            "Leaf gross photosynthesis" = "LeafGrossPhotosynthesis", 
            "Leaf net photosynthesis" = "LeafNetPhotosynthesis",
            "Absorbed SWR per leaf area" = "LeafAbsorbedSWR",
            "Absorbed PAR per leaf area" = "LeafAbsorbedPAR",
            "Net LWR per leaf area" = "LeafNetLWR",
            "Leaf internal CO2" = "LeafCi", 
            "Leaf intrinsic WUE" = "LeafIntrinsicWUE",
            "Leaf vapour pressure deficit" = "LeafVPD",
            "Leaf stomatal conductance" = "LeafStomatalConductance", 
            "Leaf temperature" = "LeafTemperature")
  return(TYPES)
}
.getSubdailyEnergyBalancePlotTypes<-function(){
  TYPES = c("Air/canopy/soil temperature" ="Temperature",
            "CanopyEnergyBalance",
            "SoilEnergyBalance")
  return(TYPES)
}
.getSubdailyLabilePlotTypes<-function(){
  TYPES = c("Gross photosynthesis per dry" = "GrossPhotosynthesis",
            "Maintenance respiration per dry" = "MaintenanceRespiration",
            "Growth costs per dry" = "GrowthCosts",
            "Root exudation per dry" = "RootExudation",
            "Labile carbon balance per dry" = "LabileCarbonBalance",
            "Leaf sugar concentration" = "SugarLeaf",
            "Leaf starch concentration" = "StarchLeaf",
            "Sapwood sugar concentration" = "SugarSapwood",
            "Sapwood starch concentration" = "StarchSapwood",
            "Sugar transport" = "SugarTransport")
  return(TYPES)
}

.getSubdailySPWBPlotTypes<-function(){
  TYPES = c(.getSubdailySoilPlotTypes(),
            .getSubdailyPlantPlotTypes(),
            .getSubdailySunlitShadePlotTypes(),
            .getSubdailyEnergyBalancePlotTypes())
  return(TYPES)
}
.getSubdailyGROWTHPlotTypes<-function(){
  TYPES = c(.getSubdailySoilPlotTypes(),
            .getSubdailyPlantPlotTypes(),
            .getSubdailySunlitShadePlotTypes(),
            .getSubdailyEnergyBalancePlotTypes(),
            .getSubdailyLabilePlotTypes())
  return(TYPES)
}


.getYLab<-function(type) {
  ylab="Unknown"
  if(type=="PlantTranspiration") ylab = expression(paste("Plant transpiration ",(L%.%m^{-2}%.%d^{-1})))
  else if(type=="TranspirationPerLeaf") ylab = expression(paste("Transpiration per leaf area ",(L%.%m^{-2}%.%d^{-1})))
  else if(type=="LeafTranspiration") ylab = expression(paste("Leaf transpiration ",(mmol%.%m^{-2}%.%s^{-1})))
  else if(type=="PlantPhotosynthesis") ylab = expression(paste("Plant photosynthesis ",(g*C%.%m^{-2}%.%d^{-1})))
  else if(type=="PlantGrossPhotosynthesis") ylab = expression(paste("Plant gross photosynthesis ",(g*C%.%m^{-2}%.%d^{-1})))
  else if(type=="LeafGrossPhotosynthesis") ylab = expression(paste("Leaf gross photosynthesis ",(mu%.%mol%.%m^{-2}%.%s^{-1})))
  else if(type=="PlantNetPhotosynthesis") ylab = expression(paste("Plant net photosynthesis ",(g*C%.%m^{-2}%.%d^{-1})))
  else if(type=="LeafNetPhotosynthesis") ylab = expression(paste("Leaf net photosynthesis ",(mu%.%mol%.%m^{-2}%.%s^{-1})))
  else if(type=="PhotosynthesisPerLeaf") ylab = expression(paste("Photosynthesis per leaf area ",(g*C%.%m^{-2}%.%d^{-1})))
  else if(type=="GrossPhotosynthesisPerLeaf") ylab = expression(paste("Gross photosynthesis per leaf area ",(g*C%.%m^{-2}%.%d^{-1})))
  else if(type=="NetPhotosynthesisPerLeaf") ylab = expression(paste("Net photosynthesis per leaf area ",(g*C%.%m^{-2}%.%d^{-1})))
  else if(type=="PlantWUE") ylab = expression(paste("Plant water use efficiency ",(g*C%.%L^{-1})))
  else if(type=="FPAR") ylab = "Average fraction of PAR (%)"
  else if(type=="AbsorbedSWRFraction") ylab = "Fraction of absorbed SWR (%)"
  else if(type=="PlantAbsorbedSWR") ylab = expression(paste("Plant absorbed SWR ",(MJ%.%m^{-2}%.%d^{-1})))
  else if(type=="PlantNetLWR") ylab = expression(paste("Plant net LWR ",(MJ%.%m^{-2}%.%d^{-1})))
  else if(type=="PlantExtraction") ylab = expression(paste("Extraction from soil layers   ",(L%.%m^{-2})))
  else if(type=="PlantWaterBalance") ylab = expression(paste("Plant water balance   ",(L%.%m^{-2})))
  else if(type=="WaterBalancePerLeaf") ylab = expression(paste("Water balance per leaf area ",(L%.%m^{-2})))
  else if(type=="PlantLAI") ylab = expression(paste("Leaf area index ",(m^{-2}%.%m^{-2})))
  else if(type=="PlantLAIlive") ylab = expression(paste("(Live) leaf area index ",(m^{-2}%.%m^{-2})))
  else if(type=="AbsorbedSWRPerLeaf") ylab = expression(paste("Absorbed SWR per leaf area ",(MJ%.%m^{-2}%.%d^{-1})))
  else if(type=="AbsorbedPARPerLeaf") ylab = expression(paste("Absorbed PAR per leaf area ",(MJ%.%m^{-2}%.%d^{-1})))
  else if(type=="LeafLAI") ylab = expression(paste("Leaf area index ",(m^{-2}%.%m^{-2})))
  else if(type=="LeafAbsorbedSWR") ylab = expression(paste("Absorbed SWR per leaf area ",(W%.%m^{-2})))
  else if(type=="LeafAbsorbedPAR") ylab = expression(paste("Absorbed PAR per leaf area ",(W%.%m^{-2})))
  else if(type=="NetLWRPerLeaf") ylab = expression(paste("Net LWR per leaf area ",(MJ%.%m^{-2}%.%d^{-1})))
  else if(type=="LeafNetLWR") ylab = expression(paste("Net LWR per leaf area ",(W%.%m^{-2})))
  else if(type=="GrossPhotosynthesis") ylab=expression(paste("Gross photosynthesis ", (gGluc%.%gdry^{-1}%.%d^{-1})))
  else if(type=="MaintenanceRespiration") ylab=expression(paste("Maintenance respiration ", (gGluc%.%gdry^{-1}%.%d^{-1})))
  else if(type=="PhotosynthesisMaintenanceRatio") ylab="Photosynthesis-maintenance ratio "
  else if(type=="GrowthCosts") ylab=expression(paste("Growth costs ", (gGluc%.%gdry^{-1}%.%d^{-1})))
  else if(type=="LabileCarbonBalance") ylab=expression(paste("Labile carbon balance ", (gGluc%.%gdry^{-1}%.%d^{-1})))
  else if(type=="SugarLeaf") ylab=expression(paste("Leaf sugar concentration  ", (mol%.%L^{-1})))
  else if(type=="StarchLeaf") ylab=expression(paste("Leaf starch concentration  ", (mol%.%L^{-1})))
  else if(type=="SugarSapwood") ylab=expression(paste("Sapwood sugar concentration  ", (mol%.%L^{-1})))
  else if(type=="StarchSapwood") ylab=expression(paste("Sapwood starch concentration  ", (mol%.%L^{-1})))
  else if(type=="SugarTransport") ylab=expression(paste("Floem sugar transport rate ", (mmol%.%s^{-1})))
  else if(type=="RootExudation") ylab=expression(paste("Root exudation ", (gGluc%.%gdry^{-1})))
  else if(type=="StructuralBiomassBalance") ylab=expression(paste("Structural biomass change ", (g%.%m^{-2})))
  else if(type=="LabileBiomassBalance") ylab=expression(paste("Labile biomass change ", (g%.%m^{-2})))
  else if(type=="PlantBiomassBalance") ylab=expression(paste("Plant biomass balance ", (g%.%m^{-2})))
  else if(type=="MortalityBiomassLoss") ylab=expression(paste("Mortality biomass loss ", (g%.%m^{-2})))
  else if(type=="CohortBiomassBalance") ylab=expression(paste("Cohort biomass balance ", (g%.%m^{-2})))
  else if(type=="SapwoodArea")  ylab = expression(paste("Sapwood area  ",(cm^2)))
  else if(type=="LeafArea")  ylab = expression(paste("Leaf area  ",(m^2)))
  else if(type=="FineRootArea")  ylab = expression(paste("Fine root area  ",(m^2)))
  else if(type=="LeafBiomass")  ylab = expression(paste("Leaf structural biomass  ", (gdry%.%ind^{-1})))
  else if(type=="SapwoodBiomass")  ylab = expression(paste("Sapwood structural biomass  ", (gdry%.%ind^{-1})))
  else if(type=="FineRootBiomass")  ylab = expression(paste("Fine root biomass  ", (gdry%.%ind^{-1})))
  else if(type=="DBH")  ylab = expression(paste("Diameter at breast height  ", (cm)))
  else if(type=="Height")  ylab = expression(paste("Plant height  ", (cm)))
  else if(type=="HuberValue")  ylab = expression(paste("Huber value  ",(cm^2 %.% m^{-2})))
  else if(type=="RootAreaLeafArea")  ylab = expression(paste("Root area / Leaf area  ",(m^2 %.% m^{-2})))
  else if(type=="SAgrowth") ylab = expression(paste("Sapwood area growth rate ",(cm^2  %.% d^{-1})))
  else if(type=="LAgrowth") ylab = expression(paste("Leaf area growth rate ",(m^2 %.% d^{-1})))
  else if(type=="FRAgrowth") ylab = expression(paste("Fine root area growth rate ",(m^2 %.% d^{-1})))
  else if(type=="DessicationRate") ylab = expression(paste("Dessication mortality rate ",(ind %.% d^{-1})))
  else if(type=="StarvationRate") ylab = expression(paste("Starvation mortality rate ",(ind %.% d^{-1})))
  else if(type=="MortalityRate") ylab = expression(paste("Mortality rate ",(ind %.% d^{-1})))
  else if(type=="LeafPI0")  ylab = expression(paste("Leaf osmotic potential at full turgor  ",(MPa)))
  else if(type=="StemPI0")  ylab = expression(paste("Stem osmotic potential at full turgor  ",(MPa)))
  else if(type=="LeafPLC") ylab = "Percent loss conductance in leaves [%]"
  else if(type=="StemPLC") ylab = "Percent loss conductance in stem [%]"
  else if(type=="StemRWC") ylab = "Relative water content in stem [%]"
  else if(type=="StemSympRWC") ylab = "Relative water content in stem symplasm [%]"
  else if(type=="StemSympPsi") ylab = "Stem symplastic water potential (MPa)"
  else if(type=="LeafRWC") ylab = "Relative water content in leaf [%]"
  else if(type=="LFMC") ylab = "Live fuel moisture content [%]"
  else if(type=="LeafSympRWC") ylab = "Relative water content in leaf symplasm [%]"
  else if(type=="LeafSympPsi") ylab = "Leaf symplastic water potential (MPa)"
  else if(type=="PlantPsi") ylab = "Plant water potential (MPa)"
  else if(type=="PlantStress") ylab = "Drought stress [%]"
  else if(type=="StemPsi") ylab = "Stem water potential (MPa)"
  else if(type=="RootPsi") ylab = "Root crown water potential (MPa)"
  else if(type=="LeafPsiAverage") ylab = "Average leaf water potential (MPa)"
  else if(type=="LeafPsi") ylab = "Leaf water potential (MPa)"
  else if(type=="LeafPsiRange") ylab = "Leaf water potential range (MPa)"
  else if(type=="SoilPlantConductance") ylab = expression(paste("Soil-plant conductance ",(mmol%.%m^{-2}%.%s^{-1})))
  else if(type=="LeafPsiMin") ylab = "Minimum (midday) leaf water potential (MPa)"
  else if(type=="LeafPsiMax") ylab = "Maximum (predawn) leaf water potential (MPa)"
  else if(type=="LeafPsiMin_SL") ylab = "Minimum (midday) sunlit leaf water potential (MPa)"
  else if(type=="LeafPsiMax_SL") ylab = "Maximum (predawn) sunlit leaf water potential (MPa)"
  else if(type=="LeafPsiMin_SH") ylab = "Minimum (midday) shade leaf water potential (MPa)"
  else if(type=="LeafPsiMax_SH") ylab = "Maximum (predawn) shade leaf water potential (MPa)"
  else if(type=="LeafStomatalConductance") ylab = expression(paste("Stomatal conductance ", (mol%.%m^{-2}%.%s^{-1})))
  else if(type=="LeafCi") ylab = expression(paste("Intercellular CO2 concentration  ", (ppm)))
  else if(type=="LeafVPD") ylab = "Leaf vapour pressure deficit (kPa)"
  else if(type=="LeafTemperature") ylab ="Leaf temperature (degrees C)"
  else if(type=="LeafIntrinsicWUE") ylab = expression(paste("iWUE  ", (mu%.%mol%.%mol^{-1})))
  else if(type=="GSWMin_SH") ylab = expression(paste("Minimum shade leaf stomatal conductance ",(mol%.%m^{-2}%.%s^{-1})))
  else if(type=="GSWMax_SH") ylab = expression(paste("Maximum shade leaf stomatal conductance ",(mol%.%m^{-2}%.%s^{-1})))
  else if(type=="GSWMin_SL") ylab = expression(paste("Minimum sunlit leaf stomatal conductance ",(mol%.%m^{-2}%.%s^{-1})))
  else if(type=="GSWMax_SL") ylab = expression(paste("Maximum sunlit leaf stomatal conductance ",(mol%.%m^{-2}%.%s^{-1})))
  else if(type=="TempMin_SH") ylab = expression(paste("Minimum shade leaf temperature (Celsius)"))
  else if(type=="TempMax_SH") ylab = expression(paste("Maximum shade leaf temperature (Celsius)"))
  else if(type=="TempMin_SL") ylab = expression(paste("Minimum sunlit leaf temperature (Celsius)"))
  else if(type=="TempMax_SL") ylab = expression(paste("Maximum sunlit leaf temperature (Celsius)"))
  else if(type=="NumTreeSpecies") ylab = expression(paste("Number of tree species"))
  else if(type=="NumShrubSpecies") ylab = expression(paste("Number of shrub species"))
  else if(type=="NumTreeCohorts") ylab = expression(paste("Number of tree cohorts"))
  else if(type=="NumShrubCohorts") ylab = expression(paste("Number of shrub cohorts"))
  else if(type=="NumCohortsSpecies") ylab = expression(paste("Number of cohorts by species"))
  else if(type=="StandBasalArea") ylab = expression(paste("Stand basal area ",(m^{-2}%.%ha^{-1})))
  else if(type=="DominantTreeHeight") ylab = expression(paste("Dominant tree height ",(cm)))
  else if(type=="DominantTreeDiameter") ylab = expression(paste("Dominant tree diameter ",(cm)))
  else if(type=="QuadraticMeanTreeDiameter") ylab = expression(paste("Quadratic mean tree diameter ",(cm)))
  else if(type=="HartBeckingIndex") ylab = expression(paste("Hart-becking index "))
  else if(type=="StandLAI") ylab = expression(paste("Stand leaf area index ",(m^{-2}%.%m^{-2})))
  else if(type=="StandDensity") ylab = expression(paste("Stand tree density ",(ind%.%ha^{-1})))
  else if(type=="StandShrubCover") ylab = expression(paste("Stand shrub cover (%)"))
  else if(type=="SpeciesBasalArea") ylab = expression(paste("Species basal area ",(m^{-2}%.%ha^{-1})))
  else if(type=="SpeciesLAI") ylab = expression(paste("Species leaf area index ",(m^{-2}%.%m^{-2})))
  else if(type=="SpeciesDensity") ylab = expression(paste("Species tree density ",(ind%.%ha^{-1})))
  else if(type=="SpeciesShrubCover") ylab = expression(paste("Shrub cover by species (%)"))
  else if(type=="CohortBasalArea") ylab = expression(paste("Cohort basal area ",(m^{-2}%.%ha^{-1})))
  else if(type=="CohortLAI") ylab = expression(paste("Cohort leaf area index ",(m^{-2}%.%m^{-2})))
  else if(type=="CohortDensity") ylab = expression(paste("Cohort tree density ",(ind%.%ha^{-1})))
  else if(type=="CohortShrubCover") ylab = expression(paste("Shrub cover by cohort (%)"))
  return(ylab)
}

.averageBySpecies<-function(OM, spnames) {
  if(ncol(OM)>1) OM = t(apply(OM,1, tapply, spnames, mean, na.rm=T))
  else colnames(OM) = spnames[1]
  return(OM)
}
.sumBySpecies<-function(OM, spnames) {
  if(ncol(OM)>1) OM = t(apply(OM,1, tapply, spnames, sum, na.rm=T))
  else colnames(OM) = spnames[1]
  return(OM)
}
.averageByLAISpecies<-function(OM, PlantsLAIlive, spnames) {
  if(ncol(OM)>1) {
    lai1 = t(apply(PlantsLAIlive,1, tapply, spnames, sum))
    m1 = t(apply(PlantsLAIlive * OM,1, tapply, spnames, sum))
    OM = m1/lai1
    OM[lai1==0] = NA
  }
  else colnames(OM) = spnames[1]
  return(OM)
}
.temporalSummary<-function(OM, summary.freq, FUN = mean, ...) {
  varnames = colnames(OM)
  date.factor = cut(as.Date(rownames(OM)), breaks=summary.freq)
  df = data.frame(row.names = as.Date(as.character(levels(date.factor))))
  for(i in 1:length(varnames)) {
    df[[varnames[i]]] = tapply(OM[,i],INDEX=date.factor, FUN=FUN, ...)
  }
  return(as.matrix(df))
}


.plot_wb<-function(WaterBalance, Snow, type,  
                   dates = NULL, 
                   xlim = NULL, ylim=NULL, xlab=NULL, ylab=NULL, 
                   summary.freq = NULL, ...) {
  WaterBalance = as.data.frame(WaterBalance)
  Snow = as.data.frame(Snow)
  if(type=="PET_Precipitation") {
    if(is.null(ylab)) ylab = expression(L%.%m^{-2}) 
    df = data.frame(row.names=row.names(WaterBalance))
    df[["PET"]] = WaterBalance$PET
    df[["Precipitation"]] = WaterBalance$Precipitation
    df[["Snow"]] = WaterBalance$Snow
    df[["Date"]] = as.Date(row.names(WaterBalance))
    if(!is.null(dates)) df = df[df$Date %in% dates,]
    if(!is.null(summary.freq)) {
      date.factor = cut(as.Date(df$Date), breaks=summary.freq)
      df = data.frame(Date = as.Date(as.character(levels(date.factor))),
                      Precipitation = tapply(df$Precipitation,INDEX=date.factor, FUN=sum, na.rm=TRUE),
                      Snow = tapply(df$Snow,INDEX=date.factor, FUN=sum, na.rm=TRUE),
                      PET = tapply(df$PET,INDEX=date.factor, FUN=sum, na.rm=TRUE))
    }
    g<-ggplot(df)+
      geom_bar(aes(x=.data$Date, y=.data$Precipitation, fill="Precipitation"), stat = "identity")+
      geom_bar(aes(x=.data$Date, y=.data$Snow, fill="Snow"), stat = "identity")+
      geom_path(aes(x=.data$Date, y=.data$PET, col="PET"))+
      scale_fill_manual(name="", values=c("Precipitation"="black", "Snow"="red"))+
      scale_color_manual(name="", values=c("PET"="gray"))+
      ylab(ylab)+ xlab(xlab)+
      theme_bw()
    return(g)
  } 
  else if(type=="PET_NetRain") {
    if(is.null(ylab)) ylab = expression(L%.%m^{-2}) 
    df = data.frame(row.names=row.names(WaterBalance))
    df[["PET"]] = WaterBalance$PET
    df[["NetRain"]] = WaterBalance$NetRain
    df[["Date"]] = as.Date(row.names(WaterBalance))
    if(!is.null(dates)) df = df[df$Date %in% dates,]
    if(!is.null(summary.freq)) {
      date.factor = cut(as.Date(df$Date), breaks=summary.freq)
      df = data.frame(Date = as.Date(as.character(levels(date.factor))),
                      NetRain = tapply(df$NetRain,INDEX=date.factor, FUN=sum, na.rm=TRUE),
                      PET = tapply(df$PET,INDEX=date.factor, FUN=sum, na.rm=TRUE))
    }
    g<-ggplot(df)+
      geom_area(aes(x=.data$Date, y=.data$NetRain, fill="NetRain"))+
      geom_path(aes(x=.data$Date, y=.data$PET, col="PET"))+
      scale_fill_manual(name="", values=c("NetRain"="black"))+
      scale_color_manual(name="", values=c("PET"="gray"))+
      ylab(ylab)+xlab(xlab)+
      theme_bw()
    return(g)
  } 
  else if(type=="Evapotranspiration") {
    if(is.null(ylab)) ylab = expression(L%.%m^{-2})
    df <- data.frame(row.names=row.names(WaterBalance))
    df[["Total evapotranspiration"]] <- WaterBalance$Evapotranspiration
    df[["Interception evaporation"]] <- NA
    df[["Woody transpiration"]] <- WaterBalance$Transpiration
    df[["Bare soil evaporation"]] <- WaterBalance$SoilEvaporation
    df["Herbaceous transpiration"] <- NA
    if("Interception" %in% names(WaterBalance)) {
      df[["Interception evaporation"]] <- WaterBalance$Interception
    }
    if("HerbTranspiration" %in% names(WaterBalance)) {
      df[["Herbaceous transpiration"]] <- WaterBalance$HerbTranspiration
    }
    if(!is.null(dates)) df = df[row.names(df) %in% as.character(dates), , drop = FALSE]
    if(!is.null(summary.freq)) {
      date.factor = cut(as.Date(row.names(df)), breaks=summary.freq)
      df_summary = data.frame(row.names = as.Date(as.character(levels(date.factor))),
                      "Total evapotranspiration" = tapply(df[["Total evapotranspiration"]],INDEX=date.factor, FUN=sum, na.rm=TRUE),
                      "Interception evaporation" = NA,
                      "Woody transpiration" = tapply(df[["Woody transpiration"]],INDEX=date.factor, FUN=sum, na.rm=TRUE),
                      "Bare soil evaporation" = tapply(df[["Bare soil evaporation"]],INDEX=date.factor, FUN=sum, na.rm=TRUE),
                      "Herbaceous transpiration" = NA, check.names = FALSE)
      if("Interception" %in% names(WaterBalance))  {
        df_summary[["Interception evaporation"]] = tapply(df[["Interception evaporation"]],INDEX=date.factor, FUN=sum, na.rm=TRUE)
      }
      if("HerbTranspiration" %in% names(WaterBalance))  {
        df_summary[["Herbaceous transpiration"]] = tapply(df[["Herbaceous transpiration"]],INDEX=date.factor, FUN=sum, na.rm=TRUE)
      }
      df <- df_summary
    }
    return(.multiple_dynamics(as.matrix(df), ylab=ylab, xlab=xlab, ylim = ylim))
  } 
  else if(type=="Snow") {
    if(is.null(ylab)) ylab = expression(L%.%m^{-2})  
    df = data.frame(row.names=row.names(WaterBalance))
    df[["Snow"]] = WaterBalance$Snow
    df[["Snowpack"]] = Snow$SWE
    df[["Date"]] = as.Date(row.names(WaterBalance))
    if(!is.null(dates)) df = df[df$Date %in% dates,]
    if(!is.null(summary.freq)) {
      date.factor = cut(as.Date(df$Date), breaks=summary.freq)
      df = data.frame(Date = as.Date(as.character(levels(date.factor))),
                      Snow = tapply(df$Snow,INDEX=date.factor, FUN=sum, na.rm=TRUE),
                      Snowpack = tapply(df$Snowpack,INDEX=date.factor, FUN=mean, na.rm=TRUE))
    }
    g<-ggplot(df)+
      geom_area(aes(x=.data$Date, y=.data$Snow, fill="Snow"))+
      geom_path(aes(x=.data$Date, y=.data$Snowpack, col="Snowpack"))+
      scale_fill_manual(name="", values=c("Snow"="black"))+
      scale_color_manual(name="", values=c("Snowpack"="gray"))+
      ylab(ylab)+xlab(xlab)+
      theme_bw()
    return(g)
  } 
  else if(type=="Export") {
    if(is.null(ylab)) ylab =  expression(L%.%m^{-2})    
    df = data.frame(row.names=row.names(WaterBalance))
    df[["InfiltrationExcess"]] = WaterBalance$InfiltrationExcess
    df[["CapillarityRise"]] = -WaterBalance$CapillarityRise
    df[["SaturationExcess"]] = WaterBalance$SaturationExcess
    df[["Export"]] = WaterBalance$DeepDrainage + WaterBalance$Runoff
    df[["DeepDrainage"]] = WaterBalance$DeepDrainage
    df[["Runoff"]] = WaterBalance$Runoff 
    df[["Date"]]= as.Date(row.names(WaterBalance))
    if(!is.null(dates)) df = df[df$Date %in% dates,]
    if(!is.null(summary.freq)) {
      date.factor = cut(as.Date(df$Date), breaks=summary.freq)
      df = data.frame(Date = as.Date(as.character(levels(date.factor))),
                      InfiltrationExcess = tapply(df$InfiltrationExcess,INDEX=date.factor, FUN=sum, na.rm=TRUE),
                      SaturationExcess = tapply(df$SaturationExcess,INDEX=date.factor, FUN=sum, na.rm=TRUE),
                      CapillarityRise = tapply(df$CapillarityRise,INDEX=date.factor, FUN=sum, na.rm=TRUE),
                      Export = tapply(df$Export,INDEX=date.factor, FUN=sum, na.rm=TRUE),
                      DeepDrainage = tapply(df$DeepDrainage,INDEX=date.factor, FUN=sum, na.rm=TRUE),
                      Runoff = tapply(df$Runoff,INDEX=date.factor, FUN=sum, na.rm=TRUE))
    }
    g<-ggplot(df)+
      geom_line(aes(x=.data$Date, y=.data$Export, col="Export"))+
      geom_line(aes(x=.data$Date, y=.data$DeepDrainage, col="Deep drainage"))+
      geom_line(aes(x=.data$Date, y=.data$InfiltrationExcess, col="Infiltration excess"))+
      geom_line(aes(x=.data$Date, y=.data$SaturationExcess, col="Saturation excess"))+
      geom_line(aes(x=.data$Date, y=.data$CapillarityRise, col="Capillarity rise"))+
      geom_line(aes(x=.data$Date, y=.data$Runoff, col="Runoff"))+
      scale_color_manual(name="", values=c("Export"="black", "Deep drainage" = "blue", 
                                           "Infiltration excess" = "yellow", "Saturation excess" = "lightblue",
                                           "Runoff" = "red", 
                                           "Capillarity rise" = "darkgreen"))+
      ylab(ylab)+ xlab(xlab)+
      theme_bw()
    return(g)
  } 
}
.plot_soil<-function(Soil, input_soil, input_control, type,  
                     dates = NULL, 
                     xlim = NULL, ylim=NULL, xlab=NULL, ylab=NULL, 
                     summary.freq = NULL, ...) {
  nlayers = length(input_soil$W)
  if(type=="SoilPsi") {
    PsiM = as.data.frame(Soil$Psi)
    if(is.null(ylab)) ylab = "Soil water potential (MPa)"    
    if(!is.null(dates)) PsiM = PsiM[row.names(PsiM) %in% as.character(dates),,drop = FALSE]
    if(!is.null(summary.freq)) PsiM = .temporalSummary(PsiM, summary.freq, mean, na.rm=TRUE)
    return(.multiple_dynamics(as.matrix(PsiM),  xlab = xlab, ylab = ylab, ylim = ylim,
                              labels = c(paste("Layer", 1:nlayers), "Overall")))
  } 
  else if(type=="SoilTheta") {
    SWCM = as.data.frame(Soil$SWC)
    if(!is.null(dates)) SWCM = SWCM[row.names(SWCM) %in% as.character(dates),,drop = FALSE]
    if(!is.null(summary.freq)) SWCM = .temporalSummary(SWCM, summary.freq, mean, na.rm=TRUE)
    if(is.null(ylab)) ylab = "Soil water content (% volume)"
    return(.multiple_dynamics(as.matrix(SWCM),  xlab = xlab, ylab = ylab, ylim = ylim,
                              labels = c(paste("Layer", 1:nlayers), "Overall")))
  } 
  else if(type=="SoilREW") {
    REWM = as.data.frame(100*Soil$REW)
    if(!is.null(dates)) REWM = REWM[row.names(REWM) %in% as.character(dates),,drop = FALSE]
    if(!is.null(summary.freq)) REWM = .temporalSummary(REWM, summary.freq, mean, na.rm=TRUE)
    if(is.null(ylab)) ylab = "Relative extractable water (%)"
    return(.multiple_dynamics(as.matrix(REWM),  xlab = xlab, ylab = ylab, ylim = ylim,
                              labels = c(paste("Layer", 1:nlayers), "Overall")))
  } 
  else if(type=="SoilRWC") {
    RWCM = as.data.frame(100*Soil$RWC)
    if(!is.null(dates)) RWCM = RWCM[row.names(RWCM) %in% as.character(dates),,drop = FALSE]
    if(!is.null(summary.freq)) RWCM = .temporalSummary(RWCM, summary.freq, mean, na.rm=TRUE)
    if(is.null(ylab)) ylab = "Relative water content (% field capacity)"
    return(.multiple_dynamics(as.matrix(RWCM),  xlab = xlab, ylab = ylab, ylim = ylim,
                              labels = c(paste("Layer", 1:nlayers), "Overall")))
  } 
  else if(type=="SoilVol") {
    if(is.null(ylab)) ylab = "Soil water content (mm)"
    MLM = as.data.frame(Soil$ML)
    if(!is.null(dates)) MLM = MLM[row.names(MLM) %in% as.character(dates),]
    if(!is.null(summary.freq)) MLM = .temporalSummary(MLM, summary.freq, mean, na.rm=TRUE)
    return(.multiple_dynamics(as.matrix(MLM), ylab = ylab, ylim = ylim,
                              xlab=xlab, labels = c(paste("Layer", 1:nlayers), "Overall")))
  } 
  else if(type=="PlantExtraction") {
    extrBal = as.data.frame(Soil$PlantExt)
    if(!is.null(dates)) extrBal = extrBal[row.names(extrBal) %in% as.character(dates),,drop = FALSE]
    if(is.null(ylab)) ylab = .getYLab(type)
    if(!is.null(summary.freq)) extrBal = .temporalSummary(extrBal, summary.freq, sum, na.rm=TRUE)
    g<-.multiple_dynamics(as.matrix(extrBal),  xlab = xlab, ylab = ylab, ylim = ylim,
                          labels = c(paste("Layer", 1:nlayers), "Overall"))
    g<-g+geom_abline(slope=0, intercept=0, col="gray")
    return(g)
  } 
  else if(type=="HydraulicRedistribution") {
    hydrIn = as.data.frame(Soil$HydraulicInput)
    if(!is.null(dates)) hydrIn = hydrIn[row.names(hydrIn) %in% as.character(dates),,drop = FALSE]
    if(is.null(ylab)) ylab = "Hydraulic input (mm)"    
    if(!is.null(summary.freq)) hydrIn = .temporalSummary(hydrIn, summary.freq, sum, na.rm=TRUE)
    return(.multiple_dynamics(as.matrix(hydrIn),  xlab = xlab, ylab = ylab, ylim = ylim,
                              labels = c(paste("Layer", 1:nlayers), "Overall")))
  } 
}
.plot_stand<-function(Stand, type,  
                      dates = NULL, 
                      xlim = NULL, ylim=NULL, xlab=NULL, ylab=NULL, 
                      summary.freq = NULL, ...) {
  Stand = as.data.frame(Stand)
  if(type=="LAI") {
    if(is.null(ylab)) ylab = expression(paste("Leaf Area Index   ",(m^{2}%.%m^{-2})))
    df = Stand[,c("LAI", "LAIherb", "LAIexpanded", "LAIdead")]
    names(df)<-c("Total (herb+unfolded+dead)", "Herbaceous", "Woody plants unfolded","Woody plants dead")
    if(!is.null(dates)) df = df[row.names(df) %in% as.character(dates),,drop = FALSE]
    if(!is.null(summary.freq)) df = .temporalSummary(df, summary.freq, mean, na.rm=TRUE)
    return(.multiple_dynamics(as.matrix(df), ylab = ylab, ylim = ylim))
  } 
  else if(type=="GroundIrradiance") {
    if(is.null(ylab)) ylab = expression(paste("Ground-level irradiance (%) "))
    df = Stand[,c("LgroundPAR", "LgroundSWR")]
    names(df)<-c("Photosynthetically-active radiation","Short-wave radiation")
    if(!is.null(dates)) df = df[row.names(df) %in% as.character(dates),,drop = FALSE]
    if(!is.null(summary.freq)) df = .temporalSummary(df, summary.freq, mean, na.rm=TRUE)
    return(.multiple_dynamics(as.matrix(df), ylab = ylab, ylim = ylim))
  } 
}
.plot_plant_om<-function(OM, PlantsLAIlive, spnames,
                         type,  bySpecies = FALSE,
                         dates = NULL, 
                         xlim = NULL, ylim=NULL, xlab=NULL, ylab=NULL, 
                         summary.freq = NULL, ...) {
  OM = as.data.frame(OM)
  if(bySpecies) OM = .averageByLAISpecies(OM, PlantsLAIlive, spnames)
  if(!is.null(dates)) OM = OM[row.names(OM) %in% as.character(dates),,drop =FALSE]
  if(!is.null(summary.freq)) OM = .temporalSummary(OM, summary.freq, mean, na.rm=TRUE)
  if(is.null(ylab)) ylab = .getYLab(type)
  return(.multiple_dynamics(as.matrix(OM),  xlab = xlab, ylab = ylab, ylim = ylim))
}
.plot_plant_om_sum<-function(OM, spnames,
                             type,  bySpecies = FALSE,
                             dates = NULL, 
                             xlim = NULL, ylim=NULL, xlab=NULL, ylab=NULL, 
                             summary.freq = NULL, ...) {
  OM = as.data.frame(OM)
  if(bySpecies) OM = .sumBySpecies(OM, spnames)
  if(!is.null(dates)) OM = OM[row.names(OM) %in% as.character(dates),, drop = FALSE]
  if(!is.null(summary.freq)) OM = .temporalSummary(OM, summary.freq, mean, na.rm=TRUE)
  if(is.null(ylab)) ylab = .getYLab(type)
  return(.multiple_dynamics(as.matrix(OM),  xlab = xlab, ylab = ylab, ylim = ylim))
}
.plot_temperature<-function(Temperature, type,  
                      dates = NULL, 
                      xlim = NULL, ylim=NULL, xlab=NULL, ylab=NULL, 
                      summary.freq = NULL, ...) {
  Temperature = as.data.frame(Temperature)
  if(type=="Temperature") {
    if(is.null(ylab)) ylab = "Temperature (Celsius)"
    df = data.frame(row.names=row.names(Temperature))
    df[["Above-canopy"]] = Temperature$Tatm_mean
    df[["Inside-canopy"]] = Temperature$Tcan_mean
    df[["Soil"]] = Temperature$Tsoil_mean
    if(!is.null(dates)) df = df[row.names(df) %in% as.character(dates),,drop = FALSE]
    if(!is.null(summary.freq)) df = .temporalSummary(df, summary.freq, mean, na.rm=TRUE)
    return(.multiple_dynamics(as.matrix(df),  xlab = xlab, ylab=ylab, ylim = ylim))
  }
  else if(type=="TemperatureRange") {
    if(is.null(ylab)) ylab = "Temperature (Celsius)"
    df1 = data.frame(row.names=row.names(Temperature))
    df1[["Above-canopy"]] = Temperature$Tatm_min
    df1[["Inside-canopy"]] = Temperature$Tcan_min
    df1[["Soil"]] = Temperature$Tsoil_min
    df2 = data.frame(row.names=row.names(Temperature))
    df2[["Above-canopy"]] = Temperature$Tatm_max
    df2[["Inside-canopy"]] = Temperature$Tcan_max
    df2[["Soil"]] = Temperature$Tsoil_max
    if(!is.null(dates)) {
      df1 = df1[row.names(df1) %in% as.character(dates),,drop = FALSE]
      df2 = df2[row.names(df2) %in% as.character(dates),,drop = FALSE]
    }
    if(!is.null(summary.freq)) {
      df1 = .temporalSummary(df1, summary.freq, mean, na.rm=TRUE)
      df2 = .temporalSummary(df2, summary.freq, mean, na.rm=TRUE)
    }
    return(.multiple_dynamics_range(as.matrix(df1),  as.matrix(df2), xlab = xlab, ylab=ylab, ylim = ylim))
  }
  else if(type=="AirTemperature") {
    if(is.null(ylab)) ylab = "Above-canopy temperature (Celsius)"
    df = data.frame(row.names=row.names(Temperature))
    df[["Mean"]] = Temperature$Tatm_mean
    df[["Minimum"]] = Temperature$Tatm_min
    df[["Maximum"]] = Temperature$Tatm_max
    if(!is.null(dates)) df = df[row.names(df) %in% as.character(dates),,drop = FALSE]
    if(!is.null(summary.freq)) df = .temporalSummary(df, summary.freq, mean, na.rm=TRUE)
    return(.multiple_dynamics(as.matrix(df),  xlab = xlab, ylab=ylab, ylim = ylim))
  } 
  else if(type=="CanopyTemperature") {
    if(is.null(ylab)) ylab = "Canopy temperature (Celsius)"
    df = data.frame(row.names=row.names(Temperature))
    df[["Mean"]] = Temperature$Tcan_mean
    df[["Minimum"]] = Temperature$Tcan_min
    df[["Maximum"]] = Temperature$Tcan_max
    if(!is.null(dates)) df = df[row.names(df) %in% as.character(dates),,drop = FALSE]
    if(!is.null(summary.freq)) df = .temporalSummary(df, summary.freq, mean, na.rm=TRUE)
    return(.multiple_dynamics(as.matrix(df),  xlab = xlab, ylab=ylab, ylim = ylim))
  } 
  else if(type=="SoilTemperature") {
    if(is.null(ylab)) ylab = "Soil temperature (Celsius)"
    df = data.frame(row.names=row.names(Temperature))
    df[["Mean"]] = Temperature$Tsoil_mean
    df[["Minimum"]] = Temperature$Tsoil_min
    df[["Maximum"]] = Temperature$Tsoil_max
    if(!is.null(dates)) df = df[row.names(df) %in% as.character(dates),,drop = FALSE]
    if(!is.null(summary.freq)) df = .temporalSummary(df, summary.freq, mean, na.rm=TRUE)
    return(.multiple_dynamics(as.matrix(df),  xlab = xlab, ylab=ylab, ylim = ylim))
  } 
}
.plot_energybalance<-function(EnergyBalance, type,  
                            dates = NULL, 
                            xlim = NULL, ylim=NULL, xlab=NULL, ylab=NULL, 
                            summary.freq = NULL, ...) {
  EnergyBalance = as.data.frame(EnergyBalance)
  if(type=="CanopyEnergyBalance") {
    if(is.null(ylab)) ylab = expression(MJ%.%m^{-2})    
    df = data.frame(row.names=row.names(EnergyBalance))
    df[["Balance"]] = EnergyBalance$Ebalcan
    df[["SWR abs."]] = EnergyBalance$SWRcan 
    df[["Net LWR"]] = EnergyBalance$LWRcan
    df[["Latent heat vaporisation"]] = -EnergyBalance$LEVcan
    df[["Latent heat fusion"]] = -EnergyBalance$LEFsnow
    df[["Convection can./atm."]] = -EnergyBalance$Hcan
    df[["Convection soil/can."]] = -EnergyBalance$Hcansoil
    if(!is.null(dates)) df = df[row.names(df) %in% as.character(dates),,drop = FALSE]
    if(!is.null(summary.freq)) df = .temporalSummary(df, summary.freq, mean, na.rm=TRUE)
    g<-.multiple_dynamics(as.matrix(df),  xlab = xlab, ylab=ylab, ylim = ylim)
    return(g)
  } 
  else if(type=="SoilEnergyBalance") {
    if(is.null(ylab)) ylab = expression(MJ%.%m^{-2})    
    df = data.frame(row.names=row.names(EnergyBalance))
    df[["Balance"]] = EnergyBalance$Ebalsoil
    df[["SWR abs."]] = EnergyBalance$SWRsoil
    df[["Net LWR"]] = EnergyBalance$LWRsoil
    df[["Convection soil/can."]] = EnergyBalance$Hcansoil
    df[["Latent heat vaporisation"]] = -EnergyBalance$LEVsoil
    if(!is.null(dates)) df = df[row.names(df) %in% as.character(dates),,drop = FALSE]
    if(!is.null(summary.freq)) df = .temporalSummary(df, summary.freq, mean, na.rm=TRUE)
    g<-.multiple_dynamics(as.matrix(df),  xlab = xlab, ylab=ylab, ylim = ylim)
    return(g)
  }
}
.plot_biomass<-function(BiomassBalance, type,  
                      dates = NULL, 
                      xlim = NULL, ylim=NULL, xlab=NULL, ylab=NULL, 
                      summary.freq = NULL, ...) {
  df<-as.data.frame(BiomassBalance)
  names(df)<-c("Structural balance", "Labile balance","Plant individual balance", "Mortality loss",
               "Cohort balance")
  if(is.null(ylab))  ylab = expression(g%.%m^{-2})    
  if(!is.null(dates)) df = df[row.names(df) %in% as.character(dates),,drop = FALSE]
  if(!is.null(summary.freq)) df = .temporalSummary(df, summary.freq, mean, na.rm=TRUE)
  return(.multiple_dynamics(as.matrix(df), ylab = ylab, ylim = ylim))
}
.plot_carbon<-function(CarbonBalance, type,  
                        dates = NULL, 
                        xlim = NULL, ylim=NULL, xlab=NULL, ylab=NULL, 
                        summary.freq = NULL, ...) {
  df<-as.data.frame(CarbonBalance)
  df[,2] = - df[,2]
  df[,3] = - df[,3]
  df[,5] = - df[,5]
  df[,6] = - df[,6]
  names(df)<-c("Gross primary production", "Maintenance respiration","Synthesis respiration", "Net primary production",
               "Heterotrophic respiration", "Fire combustion", "Net ecosystem production")
  if(is.null(ylab))  ylab = expression(gC%.%m^{-2})    
  if(!is.null(dates)) df = df[row.names(df) %in% as.character(dates),,drop = FALSE]
  if(!is.null(summary.freq)) df = .temporalSummary(df, summary.freq, sum, na.rm=TRUE)
  return(.multiple_dynamics(as.matrix(df), ylab = ylab, ylim = ylim))
}
.plot_decompositionpools<-function(DecompositionPools, type,  
                       dates = NULL, 
                       xlim = NULL, ylim=NULL, xlab=NULL, ylab=NULL, 
                       summary.freq = NULL, ...) {
  df<-as.data.frame(DecompositionPools)
  names(df)<-c("Surface snags", "Surface litter","Belowground litter", "Surface metabolic",
               "Belowground metabolic", "Surface active", "Belowground active", "Surface slow",
               "Belowground slow", "Belowground passive")
  if(is.null(ylab))  ylab = expression(gC%.%m^{-2})    
  if(!is.null(dates)) df = df[row.names(df) %in% as.character(dates),,drop = FALSE]
  if(!is.null(summary.freq)) df = .temporalSummary(df, summary.freq, mean, na.rm=TRUE)
  return(.multiple_dynamics(as.matrix(df), ylab = ylab, ylim = ylim))
}
.sumSubdailyBySpecies<-function(OM, spnames) {
  if(ncol(OM)>2) OM = cbind(OM[,1],t(apply(OM[,-1],1, tapply, spnames, sum, na.rm=T)))
  else colnames(OM)[2] = spnames[1]
  return(OM)
}
.averageSubdailyBySpecies<-function(OM, spnames) {
  if(ncol(OM)>2) OM = cbind(OM[,1],t(apply(OM[,-1],1, tapply, spnames, mean, na.rm=T)))
  else colnames(OM)[2] = spnames[1]
  return(OM)
}
.plotsubdaily<-function(x, type="PlantTranspiration", cohorts = NULL, bySpecies = FALSE,
                        dates = NULL, xlim = NULL, ylim=NULL, xlab=NULL, ylab=NULL) {
  if(("spwb" %in% class(x)) || ("pwb" %in% class(x))) {
    input = x$spwbInput
    type = match.arg(type, .getSubdailySPWBPlotTypes())  
  } else {
    input = x$growthInput
    type = match.arg(type, .getSubdailyGROWTHPlotTypes())  
  }
  
  if(is.null(cohorts)) {
    cohorts = row.names(input$cohorts)
  } else if(is.numeric(cohorts)){
    cohorts = row.names(input$cohorts)[cohorts]
  }
  spnames = as.character(input$cohorts[cohorts,"Name"])
  
  if(type=="PlantTranspiration") {
    m = .extractSubdaily(x, "E", dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_dynamics_subdaily(m,  xlab = xlab, ylab = ylab, ylim = ylim))
  } 
  else if(type=="TranspirationPerLeaf") {
    m = .extractSubdaily(x, "E", dates)[,c("datetime", cohorts), drop=FALSE]
    lai = .extractSubdaily(x, "PlantLAI", dates)[,c("datetime", cohorts), drop=FALSE]
    m[,-1] = m[,-1, drop = FALSE]/lai[,-1,drop=FALSE]
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_dynamics_subdaily(m,  xlab = xlab, ylab = ylab, ylim = ylim))
  } 
  else if(type=="PlantGrossPhotosynthesis") {
    m = .extractSubdaily(x, "Ag", dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_dynamics_subdaily(m,  xlab = xlab, ylab = ylab, ylim = ylim))
  } 
  else if(type=="GrossPhotosynthesisPerLeaf") {
    m = .extractSubdaily(x, "Ag", dates)[,c("datetime", cohorts), drop=FALSE]
    lai = .extractSubdaily(x, "PlantLAI", dates)[,c("datetime", cohorts), drop=FALSE]
    m[,-1] = m[,-1, drop = FALSE]/lai[,-1,drop=FALSE]
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_dynamics_subdaily(m,  xlab = xlab, ylab = ylab, ylim = ylim))
  } 
  else if(type=="PlantNetPhotosynthesis") {
    m = .extractSubdaily(x, "An", dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_dynamics_subdaily(m,  xlab = xlab, ylab = ylab, ylim = ylim))
  } 
  else if(type=="NetPhotosynthesisPerLeaf") {
    m = .extractSubdaily(x, "An", dates)[,c("datetime", cohorts), drop=FALSE]
    lai = .extractSubdaily(x, "PlantLAI", dates)[,c("datetime", cohorts), drop=FALSE]
    m[,-1] = m[,-1, drop = FALSE]/lai[,-1,drop=FALSE]
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_dynamics_subdaily(m,  xlab = xlab, ylab = ylab, ylim = ylim))
  } 
  else if(type=="LeafPsiAverage") {
    m = .extractSubdaily(x, "LeafPsi", dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_dynamics_subdaily(m,  xlab = xlab, ylab = ylab, ylim = ylim))
  } 
  else if(type %in% c("LeafRWC", "StemRWC", "LeafPLC", "StemPLC",
                      "LeafSympRWC", "StemSympRWC")) {
    m = .extractSubdaily(x, type, dates)[,c("datetime", cohorts), drop=FALSE]
    m[, -1] <- 100*m[, -1]
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_dynamics_subdaily(m,  xlab = xlab, ylab = ylab, ylim = ylim))
  } 
  else if(type %in% c("StemPsi", "RootPsi", "LeafSympPsi", "StemSympPsi")) {
    m = .extractSubdaily(x, type, dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_dynamics_subdaily(m,  xlab = xlab, ylab = ylab, ylim = ylim))
  } 
  else if(type=="PlantWaterBalance") {
    m = .extractSubdaily(x, "PWB", dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_dynamics_subdaily(m,  xlab = xlab, ylab = ylab, ylim = ylim))
  } 
  else if(type=="WaterBalancePerLeaf") {
    m = .extractSubdaily(x, "PWB", dates)[,c("datetime", cohorts), drop=FALSE]
    m[,-1] = m[,-1, drop = FALSE]/x$Plants$LAI
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_dynamics_subdaily(m,  xlab = xlab, ylab = ylab, ylim = ylim))
  } 
  else if(type=="SoilPlantConductance") {
    m = .extractSubdaily(x, "dEdP", dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab = .getYLab(type)
    return(.multiple_dynamics_subdaily(m,  xlab = xlab, ylab = ylab, ylim = ylim))
  } 
  else if(type=="Temperature") {
    m = .extractSubdaily(x, "Temperature", dates)
    if("Tsoil.1" %in% colnames(m)) {
      m = m[,c("datetime","Tatm", "Tcan", "Tsoil.1")]
    } else {
      sm = .extractSubdaily(x, "SoilTemperature", dates)
      m = cbind(m, sm[,"1"])
    }
    names(m) = c("datetime", "Above-canopy","Inside-canopy", "Soil")
    if(is.null(ylab)) ylab = "Temperature (Celsius)"
    return(.multiple_dynamics_subdaily(m,  xlab = xlab, ylab = ylab, ylim = ylim))
  } 
  else if(type=="CanopyEnergyBalance") {
    if(is.null(ylab)) ylab = expression(W%.%m^{-2})
    ceb = .extractSubdaily(x, "CanopyEnergyBalance", dates)
    seb = .extractSubdaily(x, "SoilEnergyBalance", dates)
    df = data.frame(datetime=ceb$datetime)
    df[["Balance"]] = ceb$Ebalcan
    df[["SWR abs."]] = ceb$SWRcan 
    df[["LWR net"]] = ceb$LWRcan
    df[["Latent heat vaporisation"]] = -ceb$LEVcan
    df[["Latent heat fusion"]] = -seb$LEFsnow
    df[["Convection can./atm."]] = -ceb$Hcan
    df[["Convection soil/can."]] = -seb$Hcansoil
    return(.multiple_dynamics_subdaily(df,  xlab = xlab, ylab = ylab, ylim = ylim))
  } 
  else if(type=="SoilEnergyBalance") {
    if(is.null(ylab)) ylab = expression(W%.%m^{-2})    
    seb = .extractSubdaily(x, "SoilEnergyBalance", dates)
    df = data.frame(datetime=seb$datetime)
    df[["Balance"]] = seb$Ebalsoil
    df[["SWR abs."]] = seb$SWRsoil
    df[["LWR net"]] = seb$LWRsoil
    df[["Convection soil/can."]] = seb$Hcansoil
    df[["Latent heat vaporisation"]] = -seb$LEVsoil
    return(.multiple_dynamics_subdaily(df,  xlab = xlab, ylab = ylab, ylim = ylim))
  }
  else if(type=="PlantExtraction") {
    m = .extractSubdaily(x, "ExtractionInst", dates)
    if(is.null(ylab)) ylab =.getYLab(type)
    return(.multiple_dynamics_subdaily(m,  xlab = xlab, ylab = ylab, ylim = ylim))
  } 
  else if(type=="LeafLAI") {
    mSu = .extractSubdaily(x, "SunlitLeaves$LAI", dates)[,c("datetime", cohorts), drop=FALSE]
    mSh = .extractSubdaily(x, "ShadeLeaves$LAI", dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_dynamics_subdaily_sunlit_shade(mSu, mSh, ylab = ylab, ylim = ylim))
  } 
  else if(type=="LeafPsi") {
    mSu = .extractSubdaily(x, "SunlitLeaves$Psi", dates)[,c("datetime", cohorts), drop=FALSE]
    mSh = .extractSubdaily(x, "ShadeLeaves$Psi", dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_dynamics_subdaily_sunlit_shade(mSu, mSh, ylab = ylab, ylim = ylim))
  } 
  else if(type=="LeafAbsorbedSWR") {
    mSu = .extractSubdaily(x, "SunlitLeaves$Abs_SWR", dates)
    mSh = .extractSubdaily(x, "ShadeLeaves$Abs_SWR", dates)
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_dynamics_subdaily_sunlit_shade(mSu, mSh, ylab = ylab, ylim = ylim))
  } 
  else if(type=="LeafAbsorbedPAR") {
    mSu = .extractSubdaily(x, "SunlitLeaves$Abs_PAR", dates)
    mSh = .extractSubdaily(x, "ShadeLeaves$Abs_PAR", dates)
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_dynamics_subdaily_sunlit_shade(mSu, mSh, ylab = ylab, ylim = ylim))
  } 
  else if(type=="LeafNetLWR") {
    mSu = .extractSubdaily(x, "SunlitLeaves$Net_LWR", dates)[,c("datetime", cohorts), drop=FALSE]
    mSh = .extractSubdaily(x, "ShadeLeaves$Net_LWR", dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_dynamics_subdaily_sunlit_shade(mSu, mSh, ylab = ylab, ylim = ylim))
  } 
  else if(type=="LeafTranspiration") {
    mSu = .extractSubdaily(x, "SunlitLeaves$E", dates)[,c("datetime", cohorts), drop=FALSE]
    mSh = .extractSubdaily(x, "ShadeLeaves$E", dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_dynamics_subdaily_sunlit_shade(mSu, mSh, ylab = ylab, ylim = ylim))
  } 
  else if(type=="LeafGrossPhotosynthesis") {
    mSu = .extractSubdaily(x, "SunlitLeaves$Ag", dates)[,c("datetime", cohorts), drop=FALSE]
    mSh = .extractSubdaily(x, "ShadeLeaves$Ag", dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_dynamics_subdaily_sunlit_shade(mSu, mSh, ylab = ylab, ylim = ylim))
  } 
  else if(type=="LeafNetPhotosynthesis") {
    mSu = .extractSubdaily(x, "SunlitLeaves$An", dates)[,c("datetime", cohorts), drop=FALSE]
    mSh = .extractSubdaily(x, "ShadeLeaves$An", dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_dynamics_subdaily_sunlit_shade(mSu, mSh, ylab = ylab, ylim = ylim))
  } 
  else if(type=="LeafStomatalConductance") {
    mSu = .extractSubdaily(x, "SunlitLeaves$Gsw", dates)[,c("datetime", cohorts), drop=FALSE]
    mSh = .extractSubdaily(x, "ShadeLeaves$Gsw", dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_dynamics_subdaily_sunlit_shade(mSu, mSh, ylab = ylab, ylim = ylim))
  } 
  else if(type=="LeafTemperature") {
    mSu = .extractSubdaily(x, "SunlitLeaves$Temp", dates)[,c("datetime", cohorts), drop=FALSE]
    mSh = .extractSubdaily(x, "ShadeLeaves$Temp", dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_dynamics_subdaily_sunlit_shade(mSu, mSh, ylab = ylab, ylim = ylim))
  } 
  else if(type=="LeafVPD") {
    mSu = .extractSubdaily(x, "SunlitLeaves$VPD", dates)[,c("datetime", cohorts), drop=FALSE]
    mSh = .extractSubdaily(x, "ShadeLeaves$VPD", dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_dynamics_subdaily_sunlit_shade(mSu, mSh, ylab = ylab, ylim = ylim))
  } 
  else if(type=="LeafCi") {
    mSu = .extractSubdaily(x, "SunlitLeaves$Ci", dates)[,c("datetime", cohorts), drop=FALSE]
    mSh = .extractSubdaily(x, "ShadeLeaves$Ci", dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_dynamics_subdaily_sunlit_shade(mSu, mSh, ylab = ylab, ylim = ylim))
  } 
  else if(type=="LeafIntrinsicWUE") {
    mSu = .extractSubdaily(x, "SunlitLeaves$iWUE", dates)[,c("datetime", cohorts), drop=FALSE]
    mSh = .extractSubdaily(x, "ShadeLeaves$iWUE", dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_dynamics_subdaily_sunlit_shade(mSu, mSh, ylab = ylab, ylim = ylim))
  } 
  else if(type %in% c("GrossPhotosynthesis", "MaintenanceRespiration", "GrowthCosts", "RootExudation" , "LabileCarbonBalance",
                      "SugarLeaf","StarchLeaf","SugarSapwood","StarchSapwood", "SugarTransport")) {
    m = .extractSubdaily(x, type, dates)[,c("datetime", cohorts), drop=FALSE]
    if(is.null(ylab)) ylab=.getYLab(type)
    return(.multiple_dynamics_subdaily(m,  xlab = xlab, ylab = ylab, ylim = ylim))
  } 
}

#Draws the supply function (E vs PlantPsi) for the current soil state and plant hydraulic parameters
#' @rdname hydraulics_supplyfunctions
#' 
#' @param x An object of class \code{\link{spwbInput}}.
#' @param type Plot type for \code{hydraulics_supplyFunctionPlot}, either \code{"E"}, 
#' \code{"ERhizo"}, \code{"StemPsi"}, \code{"RootPsi"} or \code{"dEdP"}).
#' @param draw A flag to indicate whether the supply function should be drawn or just returned.
#' @param speciesNames A flag to indicate the use of species names instead of cohort names in plots.
#' @param ylim Graphical parameter to override function defaults.
#' 
#' @keywords internal
hydraulics_supplyFunctionPlot<-function(x, draw = TRUE, type="E", speciesNames = FALSE, ylim=NULL) {
  
  TYPES = c("E","dEdP","StemPsi","RootPsi","ERhizo")
  type = match.arg(type,TYPES)  
  
  psiSoil = soil_psi(x$soil, model="VG")
  VG_nc = x$soil$VG_n
  VG_alphac = x$soil$VG_alpha
  VCroot_kmax = x$belowLayers$VCroot_kmax
  VGrhizo_kmax = x$belowLayers$VGrhizo_kmax
  StemPLC = x$internalWater$StemPLC
  LeafPLC = x$internalWater$LeafPLC
  nlayer = length(psiSoil)
  col = rainbow(nlayer, start = 0.8, end = 0.1)
  
  numericParams = x$control$numericParams
  
  VCroot_c = x$paramsTransp$VCroot_c
  VCroot_d = x$paramsTransp$VCroot_d
  VCstem_kmax = x$paramsTransp$VCstem_kmax
  VCstem_c = x$paramsTransp$VCstem_c
  VCstem_d = x$paramsTransp$VCstem_d
  VCleaf_kmax = x$paramsTransp$VCleaf_kmax
  VCleaf_c = x$paramsTransp$VCleaf_c
  VCleaf_d = x$paramsTransp$VCleaf_d
  cohortnames = row.names(x$cohorts)
  if(speciesNames) cohortnames = as.character(x$cohorts$Name)
  
  ncoh = length(cohortnames)
  l = vector("list", ncoh)
  names(l) = cohortnames
  for(i in 1:ncoh) {
    VGrhizo_kmaxc = VGrhizo_kmax[i,]
    VCroot_kmaxc = VCroot_kmax[i,]
    psic = psiSoil[VGrhizo_kmaxc>0]
    VGrhizo_kmaxc = VGrhizo_kmaxc[VGrhizo_kmaxc>0]
    VCroot_kmaxc = VCroot_kmaxc[VCroot_kmaxc>0]
    hn = list("numericParams" = x$control$numericParams,
              "stemCavitationEffects" = x$control$stemCavitationEffects,
              "leafCavitationEffects" = x$control$leafCavitationEffects,
              "psisoil" = psiSoil,
               "krhizomax" = VGrhizo_kmaxc, "nsoil" = VG_nc, "alphasoil" = VG_alphac,
               "krootmax" = VCroot_kmaxc, "rootc" = VCroot_c[i], "rootd" = VCroot_d[i],
               "kstemmax" = VCstem_kmax[i], "stemc" = VCstem_c[i], "stemd" = VCstem_d[i], 
               "kleafmax" = VCleaf_kmax[i], "leafc" = VCleaf_c[i], "leafd" = VCleaf_d[i],
               "PLCstem" = StemPLC[i],
               "PLCleaf" = LeafPLC[i])
    l[[i]] = hydraulics_supplyFunctionNetwork(hn)
  }
  if(draw) {
    minPsi = 0
    psi = numeric(0)
    E = numeric(0)
    dEdP = numeric(0)
    psiStem = numeric(0)
    psiRoot = numeric(0)
    cohort = character(0)
    xlab = "Leaf pressure (-MPa)"
    for(i in 1:ncoh) {
      minPsi = min(minPsi, min(l[[i]]$psiLeaf, na.rm = T))
      psi = c(psi, -l[[i]]$psiLeaf)
      psiStem = c(psiStem, -l[[i]]$psiStem[,1])
      psiRoot = c(psiRoot, -l[[i]]$psiRoot)
      dEdP = c(dEdP, l[[i]]$dEdP)
      E = c(E, l[[i]]$E)
      ci = rep(cohortnames[i], length(l[[i]]$E))
      cohort = c(cohort, ci)
      Eri = as.vector(l[[i]]$ERhizo)
      Psiri = as.vector(-l[[i]]$psiRhizo)
      Li = gl(n=ncol(l[[i]]$ERhizo), k=nrow(l[[i]]$ERhizo), labels = paste0("Layer ", 1:ncol(l[[i]]$ERhizo)))
      dfi = data.frame("Psi" = rep(-l[[i]]$psiLeaf, ncol(l[[i]]$ERhizo)), 
                       "PsiRhizo" = Psiri, 
                       "ERhizo" = Eri, 
                       "layer" = Li, "cohort" = ci)         
      if(!exists("dfRhizo")) {
        dfRhizo  = dfi
      } else {
        dfRhizo = rbind(dfRhizo, dfi)
      }
    }
    dfRhizo$cohort = factor(dfRhizo$cohort, levels = cohortnames)
    
    df = data.frame("psi" = psi, 
                    "StemPsi" = psiStem, 
                    "RootPsi" = psiRoot, 
                    "E" = E, "dEdP" = dEdP, 
                    "cohort" = cohort)
    df$cohort = factor(df$cohort, levels = cohortnames)
    if(type=="E") {
      ylab = expression(paste("Flow rate    ",(mmol%.%s^{-1}%.%m^{-2})))
      g<-ggplot(df, aes(x = .data$psi, y=.data$E))+
        geom_path(aes(col=.data$cohort, 
                      linetype=.data$cohort))+
        scale_color_discrete(name="")+
        scale_linetype_discrete(name="")
      g<-g+xlab(xlab)+ylab(ylab)+theme_bw()
      if(!is.null(ylim)) g<-g+ylim(ylim)
      return(g)
    } 
    else if(type=="dEdP") {
      ylab = expression(paste("dE/dP  ",(mmol%.%s^{-1}%.%m^{-2}%.%MPa^{-1})))
      g<-ggplot(df, aes(x = .data$psi, y=.data$dEdP))+
        geom_path(aes(col=.data$cohort, linetype=.data$cohort))+
        scale_color_discrete(name="")+
        scale_linetype_discrete(name="")
      g<-g+xlab(xlab)+ylab(ylab)+theme_bw()
      if(!is.null(ylim)) g<-g+ylim(ylim)
      return(g)
    }
    else if(type=="StemPsi") {
      ylab = "Stem pressure (-MPa)"
      g<-ggplot(df, aes(x = .data$psi, y=.data$StemPsi))+
        geom_path(aes(col=.data$cohort, linetype=.data$cohort))+
        scale_color_discrete(name="")+
        scale_linetype_discrete(name="")
      g<-g+xlab(xlab)+ylab(ylab)+theme_bw()
      if(!is.null(ylim)) g<-g+ylim(ylim)
      return(g)
    }
    else if(type=="RootPsi") {
      ylab = "Root crown pressure (-MPa)"
      g<-ggplot(df, aes(x = .data$psi, y=.data$RootPsi))+
        geom_path(aes(col=.data$cohort, linetype=.data$cohort))+
        scale_color_discrete(name="")+
        scale_linetype_discrete(name="")
      g<-g+xlab(xlab)+ylab(ylab)+theme_bw()
      if(!is.null(ylim)) g<-g+ylim(ylim)
      return(g)
    }
    else if(type=="ERhizo") {
      ylab = expression(paste("Flow rate from/to layers "(mmol%.%s^{-1}%.%m^{-2})))
      g<-ggplot(dfRhizo, aes(x = .data$Psi, y=.data$ERhizo))+
        geom_path(aes(col=.data$cohort, linetype=.data$layer))+
        scale_color_discrete(name="")+
        scale_linetype_discrete(name="")+
        geom_hline(yintercept=0, col="gray")
      g<-g+xlab(xlab)+ylab(ylab)+theme_bw()
      if(!is.null(ylim)) g<-g+ylim(ylim)
      return(g)
    }
    else if(type=="PsiRhizo") {
      ylab = "Rhizosphere pressure (-MPa)"
      g<-ggplot(dfRhizo, aes(x = .data$Psi, y=.data$PsiRhizo))+
        geom_path(aes(col=.data$cohort, linetype=.data$layer))+
        scale_color_discrete(name="")+
        scale_linetype_discrete(name="")
      g<-g+xlab(xlab)+ylab(ylab)+theme_bw()
      if(!is.null(ylim)) g<-g+ylim(ylim)
      return(g)
    }
    # else if(type=="resistances") {
    #   for(i in 1:ncoh) {
    #     nsteps = length(l[[i]]$E)
    #     resmat = matrix(0, nrow=nsteps, ncol = 4)
    #     for(j in 1:nsteps) {
    #       rrow  = hydraulics_soilPlantResistances(psiSoil = psic,
    #                                               psiRhizo = l[[i]]$psiRhizo[j,],
    #                                               psiStem = l[[i]]$psiStem[j,],
    #                                               PLCstem = PLCstem,
    #                                               psiLeaf = l[[i]]$psiLeaf[j],
    #                                               VGrhizo_kmax[i,],VG_nc,VG_alphac,
    #                                               VCroot_kmax[i,], VCroot_c[i],VCroot_d[i],
    #                                               VCstem_kmax[i], VCstem_c[i],VCstem_d[i], 
    #                                               VCleaf_kmax[i], VCleaf_c[i],VCleaf_d[i])
    #       resmat[j,] = 100*rrow/sum(rrow)
    #     }
    #     if(i==1) {
    #       plot(-l[[i]]$psiLeaf, resmat[,1], type="l", ylim=c(0,100), xlim=c(0,-minPsi),
    #            xlab = "Leaf pressure (-MPa)", 
    #            ylab = expression(paste("Percent resistances")), 
    #            col=i, lty=1)
    #       lines(-l[[i]]$psiLeaf, resmat[,2], lty=2, col=i)
    #       lines(-l[[i]]$psiLeaf, resmat[,3], lty=3, col=i)
    #       lines(-l[[i]]$psiLeaf, resmat[,4], lty=4, col=i)
    #     } else {
    #       lines(-l[[i]]$psiLeaf, resmat[,1], lty=1, col=i)
    #       lines(-l[[i]]$psiLeaf, resmat[,2], lty=2, col=i)
    #       lines(-l[[i]]$psiLeaf, resmat[,3], lty=3, col=i)
    #       lines(-l[[i]]$psiLeaf, resmat[,4], lty=4, col=i)
    #     }
    #   }
    # }
  }
  return(l)
}

#' Optimization of rock fragment content
#'
#' Function \code{utils_rockOptimization} finds optimum rock fragment content in the soil
#' corresponding to given vegetation, weather and target percent loss
#' of conductance (PLC), following a modification of the method proposed by Druel et al. (2023).
#'
#' @param x An object of class \code{\link[medfate]{forest}}.
#' @param SpParams A data frame with species parameters (see \code{\link[medfate]{SpParamsDefinition}} and \code{\link[medfate]{SpParamsMED}}).
#' @param soil An object of class \code{\link{data.frame}} or \code{\link[medfate]{soil}}, containing soil parameters per soil layer.
#' @param control A list with default control parameters (see \code{\link[medfate]{defaultControl}}).
#' @param meteo A data frame with daily meteorological data series (see \code{\link[medfate]{spwb}}).
#' @param PLCquantile Maximum PLC quantile to be calculated across years.
#' @param qPLC_target Target PLC to be achieved (by default 12%).
#' @param qPLC_tol Tolerance of PLC difference to target accepted when finding solution.
#' @param sew_min Minimum soil extractable water (mm) for rock exploration.
#' @param max_rocks Maximum content in coarse fragments allowed for any soil layer.
#' @param verbose A logical value. Print the internal messages of the function?
#' @param ... Additional parameters to function \code{\link[medfate]{spwb}}.
#'
#' @details
#' The function performs a model inversion based on an ecohydrological assumption,
#' consisting in that forest leaf area index is in equilibrium with a low embolism
#' rate under normal conditions. This is translated in that the (by default 90%) interannual quantile of
#' the maximum annual percent loss of conductance (PLC), averaged over plant cohorts,
#' should be close to a target PLC value (by default 12%).
#' 
#' The algorithm first determines the PLC corresponding to the minimum and maximum soil extractable water (SEW). 
#' The minimum SEW (SEW_min) is an input parameter, whereas the maximum SEW (SEW_max) corresponds to no rock fragments in the soil. 
#' 
#' Then three situations are distinguished:
#' \enumerate{
#'   \item{If \code{PLC(SEW_min) < qPLC_target}  and \code{PLC(SEW_max) < qPLC_target}, the function will use \code{\link{uniroot}} to find the root
#' of the function \code{f(x) = PLC(x) - qPLC_target}, where \code{x} is SEW, which corresponds to a factor that multiplies the original rock fragment content.}
#'   \item{If both \code{PLC(SEW_min) < qPLC_target} and \code{PLC(SEW_max) < qPLC_target}, the function cannot find an optimum, because PLC is always too low, and will return the original rock fragment content}
#'   \item{Analogously, if both \code{PLC(SEW_min) > qPLC_target} and \code{PLC(SEW_max) > qPLC_target}, the function cannot find an optimum, because PLC is always too large, and will return the original rock fragment content}
#' } 
#'
#' @return
#' Function \code{utils_rockOptimization} returns a list containing:
#'  \itemize{
#'    \item{\code{RFC}: A vector with the estimated rock fragment content for each soil layer.}
#'    \item{\code{SEW}: Soil extractable water (mm).}
#'    \item{\code{runs}: Number of simulations performed.}
#'    \item{\code{message}: Text message indicating whether optimization could be done (OK) or not.}
#'  }
#'
#'
#' @references
#' Druel, A., Martins, N., Cochard, H., De Caceres, M., Delzon, S., Mencuccini, M., Torres-Ruiz, J., and Ruffault, J.: European forest vulnerability to hydraulic failure: an ecohydrological approach, EGU General Assembly 2023, Vienna, Austria, 24–28 Apr 2023, EGU23-17068, https://doi.org/10.5194/egusphere-egu23-17068, 2023.
#'
#' @author
#' \enc{Arsène}{Arsene} Druel, URFM-INRAE
#'
#' Nicolas Martin-StPaul, URFM-INRAE
#'
#' Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#'
#' @seealso \code{\link{spwb}}, \code{\link{soil}}, \code{\link{utils_ldrOptimization}}
#'
#' @examples
#' \donttest{
#' #Load example daily meteorological data
#' data(examplemeteo)
#'
#' #Load example plot plant data
#' data(exampleforest)
#'
#' #Default species parameterization
#' data(SpParamsMED)
#'
#' #Initialize soil with two layers
#' examplesoil <- defaultSoilParams(4)
#'
#' #Rock fragment content optimization (Granier)
#' utils_rockOptimization(exampleforest, soil = examplesoil,
#'                        SpParams = SpParamsMED, meteo = examplemeteo,
#'                        control = defaultControl("Granier"),
#'                        elevation = 100, latitude = 41.82592)
#' }
#' @export
utils_rockOptimization<- function(x, soil, SpParams, control, meteo,
                                 PLCquantile = 0.9, qPLC_target = 12, qPLC_tol = 0.5,
                                 sew_min = 30, max_rocks = 99, verbose = FALSE, ...){
  
  control$verbose = FALSE
  control$leafCavitationRecovery = "annual"
  control$stemCavitationRecovery = "annual"
  if(!inherits(soil, "soil")) {
    soil <- medfate::soil(soil)
  }
  nlayers <- nrow(soil)
  
  LAI_max_coh <- medfate::plant_LAI(x, SpParams)
  LAI_max <- sum(LAI_max_coh, na.rm = TRUE)
  
  sew_ori <- sum(medfate::soil_waterExtractable(soil, model = control$soilFunctions))
  
  soil_max <- soil
  soil_max$rfc <- rep(0, nlayers)
  sew_max <- sum(medfate::soil_waterExtractable(soil_max, model = control$soilFunctions))
  if(verbose) cat(paste0("SEW original = ", round(sew_ori), " minimum = ", round(sew_min), " maximum = ", round(sew_max),"\n"))

  # Function to be optimized for factor corresponding to sew_target
  f_sew_diff <- function(factor, sew_target) {
    soil_tmp <- soil
    soil_tmp$rfc <- pmax(pmin(soil_tmp$rfc*factor,max_rocks),0)
    sew <- sum(medfate::soil_waterExtractable(soil_tmp, model = control$soilFunctions))
    return(sew_target - sew)
  }
  
  f_PLC_diff<-function(sew_target, ...) {
    soil_new <- soil
    r <- uniroot(f_sew_diff, c(0,10), sew_target)
    soil_new$rfc <- pmax(pmin(soil_new$rfc*r$root,max_rocks),0)
    input_new <- medfate::spwbInput(x, soil = soil_new, SpParams = SpParams, control = control)
    
    # Launch simulation
    S_new <- spwb(x = input_new, meteo = meteo, ...)
    # 90% quantile by species of annual maximum PLC
    PLC_new <- 100*apply(summary(S_new, output="StemPLC", FUN = max),2,quantile, prob = PLCquantile)
    if(length(PLC_new)>0) {
      PLC_av_new <- sum(PLC_new*LAI_max_coh, na.rm = TRUE)/LAI_max
    } else {
      PLC_av_new <- 0
    }
    return(PLC_av_new - qPLC_target)
  }
  
  # Evaluate function at extremes
  plc_sew_min <- f_PLC_diff(sew_min, ...)
  plc_sew_max <- f_PLC_diff(sew_max, ...)
  if(verbose) cat(paste0("PLC(SEW minimum) = ", round(plc_sew_min + qPLC_target, 2), " PLC(SEW maximum) = ", round(plc_sew_max + qPLC_target),"\n"))
  
  runs <- 2
  
  # Normal situation (negative and positive extremes), find root
  message = "OK"
  if((plc_sew_max < 0.0) && (plc_sew_min > 0.0)) {
    a <-uniroot(f_PLC_diff, c(sew_min, sew_max), tol = qPLC_tol, ...)
    sew_target <- a$root
    runs <- runs + a$iter
  } else if(plc_sew_max==0.0) { #Unlikely but possible
    sew_target <- sew_max
  } else if(plc_sew_min==0.0) { #Unlikely but possible
    sew_target <- sew_min
  } else if((plc_sew_max > 0.0) && (plc_sew_min > 0.0)) {
    message = paste0("PLC larger than target for the whole range of SEW. Returning original SEW.")
    sew_target <- sew_ori
  } else if((plc_sew_max < 0.0) && (plc_sew_min < 0.0)) {
    message = paste0("PLC lower than target for the whole range of SEW. Returning original SEW.")
    sew_target <- sew_ori
  }
  
  f_target <- uniroot(f_sew_diff, c(0,10), sew_target)
  rfc_target <- pmax(pmin(soil$rfc*f_target$root,max_rocks),0)
  res <- list(RFC = rfc_target, 
              SEW = sew_target, 
              runs = runs,
              message = message)
  return(res)
}

#' #' @rdname transp_stomatalregulation
#' #' 
#' #' @param x An object of class \code{\link{spwbInput}} built using the 'Sperry' transpiration mode.
#' #' @param meteo A data frame with daily meteorological data series (see \code{\link{spwb}}).
#' #' @param day An integer to identify a day (a row) within \code{meteo}.
#' #' @param timestep An integer between 1 and \code{ndailysteps} specified in \code{x} (see \code{\link{defaultControl}}).
#' #' @param latitude Latitude (in degrees).
#' #' @param elevation,slope,aspect Elevation above sea level (in m), slope (in degrees) and aspect (in degrees from North).
#' #' @param type A string with plot type, either \code{"E"} (transpiration flow), \code{"Ag"} (gross photosynthesis), \code{"An"} (net photosynthesis), \code{"Gsw"} (stomatal conductance to water vapour), \code{"T"} (temperature) or \code{"VPD"} (leaf vapour pressure deficit).
#' #' 
#' #' @keywords internal
#' transp_stomatalRegulationPlot<-function(x, meteo, day, timestep, latitude, elevation, slope = NA, aspect = NA,
#'                                         type = "E") {
#'   type = match.arg(type, c("E", "Ag","An" , "Gsw", "T", "VPD"))
#'   dctr = transp_transpirationSperry(x, meteo, day, latitude, elevation, slope, aspect,
#'                                     stepFunctions = timestep, 
#'                                     modifyInput = FALSE)
#'   ncoh = length(dctr$SupplyFunctions)
#' 
#'   l = dctr$SupplyFunctions
#'   cohnames = names(l)
#'   phsunlit = dctr$PhotoSunlitFunctions
#'   phshade = dctr$PhotoShadeFunctions
#'   pmsunlit = dctr$PMSunlitFunctions
#'   pmshade = dctr$PMShadeFunctions
#'   
#'   psi = numeric(0)
#'   E = numeric(0)
#'   Ag_sunlit = numeric(0)
#'   Ag_shade = numeric(0)
#'   An_sunlit = numeric(0)
#'   An_shade = numeric(0)
#'   Gsw_sunlit = numeric(0)
#'   Gsw_shade = numeric(0)
#'   Temp_sunlit = numeric(0)
#'   Temp_shade = numeric(0)
#'   VPD_sunlit = numeric(0)
#'   VPD_shade = numeric(0)
#'   cohorts = character(0)
#'   PM_sunlit = logical(0)
#'   PM_shade = logical(0)
#'   for(i in 1:ncoh) {
#'     psi = c(psi, -l[[i]]$psiLeaf)
#'     E = c(E, l[[i]]$E)
#'     Ag_sunlit = c(Ag_sunlit, phsunlit[[i]]$GrossPhotosynthesis)
#'     Ag_shade = c(Ag_shade, phshade[[i]]$GrossPhotosynthesis)
#'     An_sunlit = c(An_sunlit, phsunlit[[i]]$NetPhotosynthesis)
#'     An_shade = c(An_shade, phshade[[i]]$NetPhotosynthesis)
#'     Gsw_sunlit = c(Gsw_sunlit, phsunlit[[i]]$Gsw)
#'     Gsw_shade = c(Gsw_shade, phshade[[i]]$Gsw)
#'     Temp_sunlit = c(Temp_sunlit, phsunlit[[i]]$LeafTemperature)
#'     Temp_shade = c(Temp_shade, phshade[[i]]$LeafTemperature)
#'     VPD_sunlit = c(VPD_sunlit, phsunlit[[i]]$LeafVPD)
#'     VPD_shade = c(VPD_shade, phshade[[i]]$LeafVPD)
#'     PMsli = rep(F, length(l[[i]]$psiLeaf))
#'     PMshi = rep(F, length(l[[i]]$psiLeaf))
#'     PMsli[pmsunlit[[i]]$iMaxProfit+1] = T
#'     PMshi[pmshade[[i]]$iMaxProfit+1] = T
#'     PM_sunlit = c(PM_sunlit, PMsli)
#'     PM_shade = c(PM_shade, PMshi)
#'     cohorts = c(cohorts, rep(cohnames[i], length(l[[i]]$psiLeaf)))
#'   }
#'   df_sunlit = data.frame(psi = psi, E = E, 
#'                          Ag = Ag_sunlit, An = An_sunlit, Gsw = Gsw_sunlit,
#'                          Temp = Temp_sunlit, VPD = VPD_sunlit, 
#'                          PM = PM_sunlit,
#'                          cohort = cohorts, leaf = "sunlit", 
#'                          stringsAsFactors = F)
#'   df_shade = data.frame(psi = psi, E = E, 
#'                         Ag = Ag_shade, An = An_shade, Gsw = Gsw_shade,
#'                         Temp = Temp_shade, VPD = VPD_shade, 
#'                         PM = PM_shade,
#'                         cohort = cohorts, leaf = "shade",
#'                         stringsAsFactors = F)
#'   df = rbind(df_sunlit, df_shade)
#'   df$leaf = factor(df$leaf, levels = c("sunlit", "shade"))
#'   df_PM = df[df$PM,]
#'   g<-ggplot(df, aes(x=.data$psi))+
#'     xlab("Leaf pressure (-MPa)")+
#'     facet_wrap(~leaf)+
#'     theme_bw()
#'   if(type=="E") {
#'     g<- g + geom_path(aes(y = .data$E, col = .data$cohort))+
#'       geom_point(data = df_PM, aes(y=.data$E, col = .data$cohort))+
#'       ylab(expression(paste("Flow rate "(mmol%.%s^{-1}%.%m^{-2}))))
#'   } 
#'   else if(type=="Ag") {
#'     g<- g + geom_path(aes(y = .data$Ag, col = .data$cohort))+
#'       geom_point(data = df_PM, aes(y=.data$Ag, col = .data$cohort))+
#'       ylab(expression(paste("Gross photosynthesis "(mu*mol*C%.%s^{-1}%.%m^{-2}))))
#'   } 
#'   else if(type=="An") {
#'     g<- g + geom_path(aes(y = .data$An, col = .data$cohort))+
#'       geom_point(data = df_PM, aes(y=.data$An, col = .data$cohort))+
#'       ylab(expression(paste("Net photosynthesis "(mu*mol*C%.%s^{-1}%.%m^{-2}))))
#'   } 
#'   else if(type=="Gsw") {
#'     g<- g + geom_path(aes(y = .data$Gsw, col = .data$cohort))+
#'       geom_point(data = df_PM, aes(y=.data$Gsw, col = .data$cohort))+
#'       ylab(expression(paste("Stomatal conductance "(mol%.%s^{-1}%.%m^{-2}))))
#'   } 
#'   else if(type=="T") {
#'     g<- g + geom_path(aes(y = .data$Temp, col = .data$cohort))+
#'       geom_point(data = df_PM, aes(y=.data$Temp, col = .data$cohort))+
#'       ylab("Temperature (degrees C)")
#'   } 
#'   else if(type=="VPD") {
#'     g<- g + geom_path(aes(y = .data$VPD, col = .data$cohort))+
#'       geom_point(data = df_PM, aes(y=.data$VPD, col = .data$cohort))+
#'       ylab("Vapour pressure deficit (kPa)")
#'   } 
#'   g <- g + scale_color_discrete(name="")
#'   return(g)
#' }

#' Rainfall interception
#' 
#' Function \code{hydrology_rainInterception} calculates the amount of rainfall intercepted daily by the canopy, given a rainfall and canopy characteristics. 
#' Two canopy interception models are currently available: the sparse Gash (1995) model and the Liu (2001) model. 
#' In both cases the current implementation assumes no trunk interception.
#' 
#' @param Rainfall A numeric vector of (daily) rainfall.
#' @param Cm Canopy water storage capacity.
#' @param p Proportion of throughfall (normally 1 - c, where c is the canopy cover).
#' @param ER The ratio of evaporation rate to rainfall rate.
#' @param model Rainfall interception model (either \code{"Gash1995"} or \code{"Liu2001"}).
#' 
#' @details 
#' Function \code{hydrology_rainInterception} can accept either vectors or scalars as parameters \code{Cm}, \code{p} and \code{ER}. If they are supplied as vectors they should be of the same length as \code{Rainfall}.
#' 
#' Function \code{hydrology_rainfallIntensity} estimates the rainfall intensity (mm/h) for input values of rainfall and seasonal variation in rainfall intensity (mm/h).
#' 
#' @return 
#' Function \code{hydrology_rainInterception} returns a vector of the same length as \code{Rainfall} containing intercepted rain values. 
#' 
#' Function \code{hydrology_rainfallIntensity} returns a scalar with the rainfall intensity.
#' 
#' @references 
#' Liu (2001). Evaluation of the Liu model for predicting rainfall interception in forests world-wide. - Hydrol. Process. 15: 2341-2360.
#' 
#' Gash (1979). An analytical model of rainfall interception by forests. - Quarterly Journal of the Royal Meteorological Society.                                       
#' 
#' Gash et al. (1995). Estimating sparse forest rainfall interception with an analytical model. - Journal of Hydrology.
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso \code{\link{spwb}}
#' 
#' @examples 
#' #Load example plot plant data
#' data(exampleforest)
#' 
#' #Default species parameterization
#' data(SpParamsMED)
#' 
#' #Draw rainfall interception for two values of the E/R ratio
#' hydrology_interceptionPlot(exampleforest, SpParamsMED, ER = c(0.05, 0.2))
#' 
#' @name hydrology_interception
hydrology_rainInterception<-function(Rainfall, Cm, p, ER=0.05, model="Gash1995"){
  model <- match.arg(model, c("Liu2001","Gash1995"))
  if(length(ER)==1) ER =rep(ER, length(Rainfall))
  if(length(Cm)==1) Cm =rep(Cm, length(Rainfall))
  if(length(p)==1) p =rep(p, length(Rainfall))  
  
  if(model=="Gash1995") {
    PG = (-Cm/(ER*(1-p)))*log(1-ER) #Rainfall need to saturate the canopy
    PG[Cm==0 | p==1]=0 #Avoid NAs
    sel = Rainfall > PG #Days where the canopy becomes saturated
    I = rep(NA,length(Rainfall))
    I[sel] = (1-p[sel])*PG[sel] + (1-p[sel])*ER[sel]*(Rainfall[sel]-PG[sel]) 
    I[!sel] = (1-p[!sel])*Rainfall[!sel]  
  } else if(model=="Liu2001") {
    I = Cm*(1-exp(-1*(Rainfall)*((1-p)/Cm)))*(1-(ER/(1-p)))+(ER*Rainfall)
  }
  return(I)
}

#' @param x An object of class \code{\link{spwbInput}}.
#' @param SpParams A data frame with species parameters (see \code{\link{SpParamsMED}} and \code{\link{SpParamsMED}}).
#' @param gdd Growth degree days (in Celsius).
#' @param throughfall Boolean flag to plot relative throughfall instead of percentage of intercepted rainfall.
#' 
#' @rdname hydrology_interception
hydrology_interceptionPlot<-function(x, SpParams, ER = 0.05, gdd = NA, throughfall = FALSE, model = "Gash1995"){
  
  LAI_coh = plant_LAI(x, SpParams, gdd)
  g_coh = plant_parameter(x, SpParams, "g", TRUE)
  
  Cm = sum(LAI_coh*g_coh)
  
  p = .parExtinctionProfile(0,x, SpParams, gdd)/100

  precipitation = seq(0.5,50, by=0.5)
  
  m2<-precipitation-hydrology_rainInterception(precipitation, Cm,p,ER=ER[1], model = model)
  rt = 100*m2/precipitation
  er = rep(ER[1], length(rt))
  if(length(ER)>1) {
    for(i in 2:length(ER)) {
      m2<-precipitation-hydrology_rainInterception(precipitation, Cm,p,ER=ER[i], model = model)
      rt2 = 100*m2/precipitation
      rt = c(rt, rt2)
      er = c(er, rep(ER[i], length(rt2)))
    }
  }
  if(!throughfall) {
    rt = 100 - rt
    ylab="Percentage of intercepted rainfall (%)"
  } else {
    ylab="Relative throughfall (%)"
  }
  xlab="Gross rainfall (mm)"
  ylim=c(0,100)
  df = data.frame(P = precipitation, RT = rt, ER = paste0("ER = ",er))
  g<-ggplot(df, aes(x=.data$P, y=.data$RT))+
    xlab(xlab)+ylab(ylab)+ylim(ylim)+
    theme_bw()
  if(length(ER)==1) {
    g<-g + geom_path()
  } else {
    g<-g + geom_path(aes(col=.data$ER, linetype=.data$ER))+
      scale_color_discrete(name="")+
      scale_linetype_discrete(name="")
  }
  return(g)
}

#' medfate: Mediterranean Forest Simulation
#'
#' Simulate Mediterranean forest functioning and dynamics using cohort-based description of vegetation
#'
#' @name medfate-package
#' @aliases medfate medfate-package
#' @docType package
#' @author \strong{Maintainer}: Miquel De Cáceres
#' \email{miquelcaceres@@gmail.com}
#' [ORCID](https://orcid.org/0000-0001-7132-2080)
#'
#' Authors: \itemize{
#' \item{ Nicolas Martin-StPaul
#' [ORCID](https://orcid.org/0000-0001-7574-0108)}
#' \item{ Víctor Granda
#' [ORCID](https://orcid.org/0000-0002-0469-1991)}
#' \item{ Antoine Cabon
#' [ORCID](https://orcid.org/0000-0001-6426-1726)}
#' \item{ Arsène Druel
#' [ORCID](https://orcid.org/0000-0002-3938-0085)}
#' \item{ Julien Ruffault
#' [ORCID](https://orcid.org/0000-0003-3647-8172)}
#' }
#' Contributors: \itemize{
#' \item{ Jordi Martínez-Vilalta
#' [ORCID](https://orcid.org/0000-0002-2332-7298)}
#' \item{ Maurizio Mencuccini
#' [ORCID](https://orcid.org/0000-0003-0840-1477)}
#' \item{ François Pimont
#' [ORCID](https://orcid.org/0000-0002-9842-6207)}
#' \item{ Hervé Cochard
#' [ORCID](https://orcid.org/0000-0002-2727-7072)}
#' \item{ Aitor Améztegui
#' [ORCID](https://orcid.org/0000-0001-6426-1726)}
#' \item{ Léa Veuillen
#' [ORCID](https://orcid.org/0000-0002-2790-3627)}
#' \item{ Shengli Huang
#' [ORCID](https://orcid.org/0003-3927-7042)}
#' }
#' 
#' @seealso Useful links: 
#' \itemize{ 
#'  \item{\url{https://emf-creaf.github.io/medfate/}} 
#'  \item{\url{https://emf-creaf.github.io/medfatebook/}} 
#' }
#'
#' @references 
#' \itemize{
#'    \item{De Cáceres et al. (2015) (\doi{10.1016/j.agrformet.2015.06.012})}
#'    \item{De Cáceres et al. (2021) (\doi{10.1016/j.agrformet.2020.108233})}
#'    \item{Ruffault et al. (2022) (\doi{10.5194/gmd-15-5593-2022})}
#' }
#' 
#' @keywords internal
"_PACKAGE"

#' @rdname woodformation
#' @param dbh1,dbh2 Initial and final diameter at breast height.
#' @param yeardiff Interval between dbh measurements, in years.
#' @param lower,upper Lower and upper bounds for root finding.
woodformation_relativeGrowthRate<-function(dbh1, dbh2, yeardiff, lower = -2, upper = 8){
  grow<-function(dbh1, x, ny = 10) {
    dbh = dbh1
    for(i in 1:ny) {
      b <- (dbh/2)^2+dbh*x
      if(b<0) return(0)
      dbh = 2*sqrt(b)
    }
    return(dbh)
  }
  r<-uniroot(function(x) dbh2 - grow(dbh1,x,yeardiff), lower=lower, upper = upper)
  return(r$root)
}

#' Vertical profiles
#' 
#' Functions to generate vertical profiles generated by an input \code{\link{forest}} object.
#' 
#' @param x An object of class \code{\link{forest}}
#' @param SpParams A data frame with species parameters (see \code{\link{SpParamsMED}}).
#' @param z A numeric vector with height values.
#' @param d A numeric vector with soil layer widths.
#' @param gdd Growth degree days.
#' @param byCohorts Separate profiles for each cohort.
#' @param bySpecies Aggregate cohort profiles by species.
#' @param includeHerbs Include herbaceous layer in the profile.
#' @param u The value of measured wind speed (in m/s).
#' @param windMeasurementHeight Height corresponding to wind measurement (in cm over the canopy).
#' @param boundaryLayerSize Size of the boundary layer (in cm) over the canopy.
#' @param target Wind property to draw, either "windspeed", "kineticenergy" (turbulent kinetic energy) or "stress" (Reynold's stress).
#' @param draw Logical flag to indicate that a plot is desired.
#' @param xlim Limits of the x-axis.
#' 
#' @return If \code{draw = FALSE}, the functions return a numeric vector with values measured at each height. Units depend on the profile function:
#' \itemize{
#'   \item{\code{vprofile_leafAreaDensity}: Cumulative LAI (m2/m2) per height bin.}
#'   \item{\code{vprofile_fuelBulkDensity}: Fuel bulk density (kg/m3) per height bin.}
#'   \item{\code{vprofile_PARExtinction}: Percent of photosynthetically active radiation (%) corresponding to each height.}
#'   \item{\code{vprofile_SWRExtinction}: Percent of shortwave radiation (%) corresponding to each height.}
#'   \item{\code{vprofile_windExtinction}: Wind speed (m/s) corresponding to each height.}
#' }
#' 
#' If \code{draw = TRUE} the functions return a ggplot object, instead.
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso \code{\link{forest}}, \code{\link{plot.forest}}, \code{\link{wind_canopyTurbulence}}
#' 
#' @examples 
#' #Default species parameterization
#' data(SpParamsMED)
#' 
#' #Load example plot plant data
#' data(exampleforest)
#' 
#' vprofile_leafAreaDensity(exampleforest, SpParamsMED)
#' vprofile_fuelBulkDensity(exampleforest, SpParamsMED)
#' 
#' vprofile_PARExtinction(exampleforest, SpParamsMED)
#' vprofile_SWRExtinction(exampleforest, SpParamsMED)
#' 
#' vprofile_windExtinction(exampleforest, SpParamsMED)
#' 
#' @keywords internal
#' @name vprofile_leafAreaDensity
vprofile_leafAreaDensity<-function(x, SpParams = NULL, z = NULL, gdd = NA, 
                                   byCohorts = FALSE, bySpecies = FALSE, includeHerbs = FALSE,
                                   draw = TRUE, xlim = NULL) {
  if(!(inherits(x,"data.frame") || inherits(x, "forest"))) stop("'x' should be of class 'forest' or 'data.frame'")
  if(inherits(x, "forest")) {
    if(is.null(SpParams)) stop("Please, provide 'SpParams' to calculate leaf area.")
    spnames <- plant_speciesName(x, SpParams)
    herbHeight <- NA
    if("herbHeight" %in% names(x)) herbHeight <- x$herbHeight
    herbLAI <- herb_LAI(x, SpParams)
    x <- forest2aboveground(x, SpParams, gdd)
  } else {
    if(any(!(c("LAI_expanded", "H", "CR", "SP") %in% names(x)))) {
      stop("Data frame should contain columns 'SP', 'LAI_expanded', 'H' and 'CR'")
    }
    spnames <- x$SP
  }
  cohortnames <- row.names(x)
  if(nrow(x)==0) stop("The forest object does not contain plant cohorts")
  if(is.null(z)) z <- seq(0, ceiling(max(x$H)/100)*100 +10, by=1)
  w <- z[2:length(z)]- z[1:(length(z)-1)]
  
  lai_vect <- x$LAI_expanded
  h_vect <- x$H
  cr_vect <- x$CR
  if(includeHerbs && !is.na(herbHeight) && !is.na(herbLAI)) {
    lai_vect <- c(lai_vect, herbLAI)
    h_vect <- c(h_vect, herbHeight)
    cr_vect <- c(x$CR, 1.0)
    spnames <- c(spnames, "Herbaceous")
    cohortnames <- c(cohortnames, "Herbaceous")
  }
  if(!byCohorts) {
    lai <- .LAIprofileVectors(z, lai_vect, h_vect, cr_vect)
    lai <- 100*lai/w
    if(draw) {
      df <- data.frame("lai" = c(0,lai), "z" = z)
      g<-ggplot(df, aes(x=.data$lai, y=.data$z))+
        geom_path()+
        xlab("Leaf Area Density (m2/m3)")+
        ylab("Height (cm)")+
        theme_bw()
      if(!is.null(xlim)) g <- g + xlim(xlim)
    }
  } else {
    lai <- .LAIdistributionVectors(z, lai_vect, h_vect, cr_vect)
    lai <- 100*sweep(lai,1,w, "/")
    if(bySpecies) {
      lai <- t(apply(lai,1, tapply, spnames, sum, na.rm=T))
      cohortnames <- colnames(lai)
    } 
    if(draw) {
      lai <- rbind(rep(0, ncol(lai)),lai)
      df <- data.frame("lai" = as.vector(lai), "z" = z,
                      "Cohort" = gl(length(cohortnames), nrow(lai), labels=cohortnames))
      g<-ggplot(df, aes(x=.data$lai, y=.data$z))+
        geom_path(aes(col=.data$Cohort, linetype = .data$Cohort))+
        xlab("Leaf Area Density (m2/m3)")+
        ylab("Height (cm)")+
        scale_color_discrete(name="")+
        scale_linetype_discrete(name="")+
        theme_bw()
      if(!is.null(xlim)) g <- g + xlim(xlim)
    }
  }
  if(draw) return(g)
  else return(lai)
}

#' @rdname vprofile_leafAreaDensity
#' @keywords internal
vprofile_rootDistribution<-function(x, SpParams, d = NULL, bySpecies = FALSE, 
                                    draw = TRUE, xlim = NULL) {
  if(is.null(d)){
    zmax <- 100
    if(nrow(x$treeData)>0) zmax <- max(zmax, ceiling(max(x$treeData$Z95)/100)*100)
    if(nrow(x$shrubData)>0) zmax <- max(zmax, ceiling(max(x$shrubData$Z95)/100)*100)
    if(!is.null(x$herbData)) {
      if(nrow(x$herbData)>0) zmax <- max(zmax, ceiling(max(x$herbData$Z95)/100)*100)
    }
    d <- rep(10,1+(zmax/10))
    z <- seq(0,zmax, by=10)
  } else {
    zmax <- sum(d)
    z <- numeric(length(d))
    z[1] <- 0
    for(i in 2:length(z)) z[i] <- z[i-1] + d[i-1]
  }
  cohortnames <- plant_ID(x, SpParams)
  rd <- .rootDistribution(d,x)
  rownames(rd) <- cohortnames
  if(nrow(rd)==0) stop("The forest object does not contain plant cohorts")
  if(bySpecies) {
    spnames <- plant_speciesName(x, SpParams)
    rd <- apply(rd,2, tapply, spnames, mean, na.rm=T)
  } 
  if(draw) {
    return(.multiple_x(x=t(rd)*100, y=z/10, xlab="% of fine roots/cm",
                       ylab="Depth (cm)", ylim=c(zmax/10,0), xlim = xlim))
  } else return(rd)
}

#' @rdname vprofile_leafAreaDensity
#' @keywords internal
vprofile_fuelBulkDensity<-function(x, SpParams, z = NULL, gdd = NA,
                                   draw = TRUE, xlim = NULL) {
  h <- plant_height(x, SpParams)
  if(length(h)==0) stop("The forest object does not contain plant cohorts")
  if(is.null(z)) z <- seq(0, ceiling(max(h)/100)*100 +10, by=1)
  wfp <- .woodyFuelProfile(z,x, SpParams, gdd)
  df <- data.frame("BD" = c(0,wfp), "Z" = z)
  if(draw) {
    g<-ggplot(df, aes(x=.data$BD, y=.data$Z))+
      geom_path()+
      xlab("Bulk density (kg/m3)")+
      ylab("Height (cm)")+
      theme_bw()
    if(!is.null(xlim)) g <- g + xlim(xlim)
  }
  if(draw) return(g)
  else return(wfp)
}

#' @rdname vprofile_leafAreaDensity
#' @keywords internal
vprofile_PARExtinction<-function(x, SpParams, z = NULL, gdd = NA, includeHerbs = FALSE, 
                                 draw = TRUE, xlim = c(0,100)) {
  h <- plant_height(x, SpParams)
  if(length(h)==0) stop("The forest object does not contain plant cohorts")
  if(is.null(z)) z <- seq(0, ceiling(max(h, na.rm = TRUE)/100)*100 +10, by=1)
  pep <- .parExtinctionProfile(z,x, SpParams, gdd, includeHerbs)
  df <- data.frame("PEP" = pep, "Z" = z)
  if(draw) {
    g<-ggplot(df, aes(x=.data$PEP, y=.data$Z))+
      geom_path()+
      xlab("Available PAR (%)")+
      ylab("Height (cm)")+
      theme_bw()
    if(!is.null(xlim)) g <- g + xlim(xlim)
  }
  if(draw) return(g)
  else return(pep)
}

#' @rdname vprofile_leafAreaDensity
#' @keywords internal
vprofile_SWRExtinction<-function(x, SpParams, z = NULL, gdd = NA, includeHerbs = FALSE, 
                                 draw = TRUE, xlim = c(0,100)) {
  h <- plant_height(x, SpParams)
  if(length(h)==0) stop("The forest object does not contain plant cohorts")
  if(is.null(z)) z <- seq(0, ceiling(max(h)/100)*100 +10, by=1)
  swr <- .swrExtinctionProfile(z,x, SpParams, gdd, includeHerbs)
  df <- data.frame("SWR" = swr, "Z" = z)
  if(draw) {
    g<-ggplot(df, aes(x=.data$SWR, y=.data$Z))+
      geom_path()+
      xlab("Available SWR (%)")+
      ylab("Height (cm)")+
      theme_bw()
    if(!is.null(xlim)) g <- g + xlim(xlim)
  }
  if(draw) return(g)
  else return(swr)
}

#' @rdname vprofile_leafAreaDensity
#' @keywords internal
vprofile_windExtinction<-function(x, SpParams, u = 1, windMeasurementHeight = 200,
                                  boundaryLayerSize = 2000, target = "windspeed",
                                  z = NULL, gdd = NA, includeHerbs = FALSE,
                                  draw = TRUE, xlim = NULL) {
  h <- plant_height(x, SpParams)
  if(length(h)==0) stop("The forest object does not contain plant cohorts")
  if(is.null(z)) z <- seq(0, ceiling(max(h)/100)*100 +boundaryLayerSize, by=1)
  lad <- vprofile_leafAreaDensity(x=x, SpParams = SpParams, z = z, gdd = gdd,
                                  byCohorts = FALSE, bySpecies = FALSE, includeHerbs = includeHerbs,
                                  draw = FALSE, xlim = xlim)
  canopyHeight <- max(plant_height(x, SpParams), na.rm=T)
  zmid <- 0.5*(z[1:(length(z)-1)] + z[2:(length(z))])
  df <- wind_canopyTurbulence(zmid, lad, canopyHeight, u, windMeasurementHeight)
  target <- match.arg(target, c("windspeed", "kineticenergy", "stress"))
  if(draw) {
    if(target=="windspeed") {
      g<-ggplot(df, aes(x=.data$u, y=.data$zmid))+
        geom_path()+
        xlab("Wind speed (m/s)")
    } else if(target == "kineticenergy") {
      g<-ggplot(df, aes(x=.data$k, y=.data$zmid))+
        geom_path()+
        xlab("Turbulent kinetic energy (m2/s2)")
    } else if(target == "stress") {
      g<-ggplot(df, aes(x=.data$uw, y=.data$zmid))+
        geom_path()+
        xlab("Reynolds stress (m2/s2)")
    }
    g <- g + geom_hline(yintercept=canopyHeight, col="gray", linetype="dashed")+
      ylab("Height (cm)")+
      theme_bw()
    if(!is.null(xlim)) g <- g + xlim(xlim)
  }
  if(draw) return(g)
  else return(df)
}

#Default species parameterization
data(SpParamsMED)

#Load example plot plant data
data(exampleforest)

#Canopy height (in m)
h= max(exampleforest$treeData$Height/100) 
d0 = 0.67*h
z0 = 0.08*h

#Height values (cm)
z = seq(50,1000, by=50)
zm = z/100 # (in m)

# Leaf area density
lad = vprofile_leafAreaDensity(exampleforest, SpParamsMED, draw = FALSE,
                               z = c(0,z))

# Effective drag
Cd = 0.2
Cx = Cd*lad

# canopy turbulence model
test_that("wind canopy turbulence can be run ",{
  expect_s3_class(wind_canopyTurbulenceModel(zm, Cx,h,d0,z0), "data.frame")
})

#' Evaluation of simulations results
#' 
#' Functions to compare model predictions against observed values.
#' 
#' @param out An object of class \code{\link{spwb}}, \code{\link{growth}} or \code{\link{pwb}}.
#' @param measuredData A data frame with observed/measured values. Dates should be in row names, whereas columns should be named according to the type of output to be evaluated (see details).
#' @param type A string with the kind of model output to be evaluated. Accepted values are:
#'     \itemize{
#'       \item{\code{"SWC"}: Soil water content (percent volume). See details for specific soil layers.}
#'       \item{\code{"RWC"}: Relative water content (relative to field capacity). See details for specific soil layers.}
#'       \item{\code{"REW"}: Relative extractable water. See details for specific soil layers.}
#'       \item{\code{"ETR"}: Total evapotranspiration.}
#'       \item{\code{"SE+TR"}: Modelled soil evaporation + plant transpiration against observed total evapotranspiration}
#'       \item{\code{"E"}: Transpiration per leaf area}
#'       \item{\code{"LE"}: Latent heat (vaporisation) turbulent flux}
#'       \item{\code{"H"}: Canopy sensible heat turbulent flux}
#'       \item{\code{"GPP"}: Stand-level gross primary productivity}
#'       \item{\code{"LFMC"}: Live fuel moisture content}
#'       \item{\code{"WP"}: Plant water potentials}
#'       \item{\code{"BAI"}: Basal area increment}
#'       \item{\code{"DI"}: Diameter increment}
#'       \item{\code{"DBH"}: Diameter at breast height}
#'       \item{\code{"Height"}: Plant height}
#'     }
#' @param cohort A string of the cohort to be compared (e.g. "T1_68"). If \code{NULL} results for the first cohort will be evaluated.
#' @param temporalResolution A string to indicate the temporal resolution of the model evaluation, which can be "day", "week", "month" or "year". Observed and modelled values are aggregated temporally (using either means or sums) before comparison.
#' @param plotType Plot type to draw, either \code{"dynamics"}, \code{"pointdynamics"}  or \code{"scatter"}.
#' @param metric An evaluation metric:
#'     \itemize{
#'       \item{\code{"MAE"}: Mean absolute error.}
#'       \item{\code{"MAE.rel"}: Mean absolute error in relative terms.}
#'       \item{\code{"r"}: Pearson's linear correlation coefficient.}
#'       \item{\code{"NSE"}: Nash-Sutcliffe model efficiency coefficient.}
#'       \item{\code{"NSE.abs"}: Modified Nash-Sutcliffe model efficiency coefficient (L1 norm) (Legates & McCabe 1999).}
#'       \item{\code{"loglikelihood"}: Logarithm of the likelihood of observing the data given the model predictions, assuming independent Gaussian errors.}
#'     }
#'
#' @details Users should provide the appropriate columns in \code{measuredData}, depending on the type of output to be evaluated:
#' \itemize{
#'   \item{\code{"SWC", "RWC", "REW"}: A column with the same name should be present. By default, the first soil layer is compared. Evaluation can be done for specific soil layers, for example using "RWC.2" for the relative water content of the second layer.}
#'   \item{\code{"ETR"} or \code{"SE+TR"}: A column named \code{"ETR"} should be present, containing stand's evapotranspiration in mm/day (or mm/week, mm/month, etc, depending on the temporal resolution). If \code{type="ETR"} observed values will be compared against modelled evapotranspiration (i.e. sum of transpiration, soil evaporation and interception loss), whereas if \code{type= "SE+TR"} observed values will be compared against the sum of transpiration and soil evaporation only.}
#'   \item{\code{"LE"}: A column named \code{"LE"} should be present containing daily latent heat turbulent flux in MJ/m2.}
#'   \item{\code{"H"}: A column named \code{"H"} should be present containing daily sensible heat turbulent flux in MJ/m2.}
#'   \item{\code{"E"}: For each plant cohort whose transpiration is to be evaluated, a column starting with \code{"E_"} and continuing with a cohort name (e.g. \code{"E_T1_68"}) with transpiration in L/m2/day on a leaf area basis (or L/m2/week, L/m2/month, etc, depending on the temporal resolution).}
#'   \item{\code{"GPP"}: A column named \code{"GPP"} should be present containing daily gross primary productivity in gC/m2.}
#'   \item{\code{"LFMC"}: For each plant cohort whose transpiration is to be evaluated, a column starting with \code{"LFMC_"} and continuing with a cohort name (e.g. \code{"LFMC_T1_68"}) with fuel moisture content as percent of dry weight.}
#'   \item{\code{"WP"}: For each plant cohort whose transpiration is to be evaluated, two columns, one starting with \code{"PD_"} (for pre-dawn) and the other with \code{"MD_"} (for midday), and continuing with a cohort name (e.g. \code{"PD_T1_68"}). They should contain leaf water potential values in MPa. These are compared against sunlit water potentials.}
#'   \item{\code{"BAI"}: For each plant cohort whose growth is to be evaluated, a column starting with \code{"BAI_"} and continuing with a cohort name (e.g. \code{"BAI_T1_68"}) with basal area increment in cm2/day, cm2/week, cm2/month or cm2/year, depending on the temporal resolution.}
#'   \item{\code{"DI"}: For each plant cohort whose growth is to be evaluated, a column starting with \code{"DI_"} and continuing with a cohort name (e.g. \code{"DI_T1_68"}) with basal area increment in cm/day, cm/week, cm/month or cm/year, depending on the temporal resolution.}
#'   \item{\code{"DBH"}: For each plant cohort whose growth is to be evaluated, a column starting with \code{"DBH_"} and continuing with a cohort name (e.g. \code{"DBH_T1_68"}) with DBH values in cm.}
#'   \item{\code{"Height"}: For each plant cohort whose growth is to be evaluated, a column starting with \code{"Height_"} and continuing with a cohort name (e.g. \code{"Height_T1_68"}) with Height values in cm.}
#' }
#' Additional columns may exist with the standard error of measured quantities. These should be named as the referred quantity, followed by \code{"_err"} (e.g. \code{"PD_T1_68_err"}), and are used to draw confidence intervals around observations.
#'  
#' Row names in \code{measuredData} indicate the date of measurement (in the case of days). Alternatively, a column called \code{"dates"} can contain the measurement dates.
#' If measurements refer to months or years, row names should also be in a "year-month-day" format, although with "01" for days and/or months (e.g. "2001-02-01" for february 2001, or "2001-01-01" for year 2001).
#'
#' @return 
#' \itemize{
#'   \item{Function \code{evaluation_table} returns a data frame with dates, observed and predicted values.}
#'   \item{Function \code{evaluation_stats} returns evaluation statistics (a vector or a data frame depending on \code{type}):
#'     \itemize{
#'       \item{\code{Bias}: Mean deviation (positive values correspond to model overestimations).}
#'       \item{\code{Bias.rel}: Bias in relative terms (%).}
#'       \item{\code{MAE}: Mean absolute error.}
#'       \item{\code{MAE.rel}: Mean absolute error in relative terms (%).}
#'       \item{\code{r}: Pearson's linear correlation coefficient.}
#'       \item{\code{NSE}: Nash-Sutcliffe model efficiency coefficient.}
#'       \item{\code{NSE.abs}: Modified Nash-Sutcliffe model efficiency coefficient (L1 norm) (Legates & McCabe 1999).}
#'     }
#'   }
#'   \item{Function \code{evaluation_plot} returns a ggplot object.}
#'   \item{Function \code{evaluation_metric} returns a scalar with the desired metric.}
#' }
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @references Legates, D.R., McCabe, G.J., 1999. Evaluating the use of “goodness-of-fit” measures in hydrologic and hydroclimatic model validation. Water Resour. Res. 35, 233–241.  
#' 
#' @seealso \code{\link{spwb}}, \code{\link{growth}}, \code{\link{optimization}}, \code{\link{exampleobs}}
#' 
#' @examples 
#' \donttest{
#' #Load example daily meteorological data
#' data(examplemeteo)
#' 
#' #Load example plot plant data
#' data(exampleforest)
#' 
#' #Default species parameterization
#' data(SpParamsMED)
#' 
#' #Define soil with default soil params (4 layers)
#' examplesoil <- defaultSoilParams(4)
#' 
#' #Initialize control parameters
#' control <- defaultControl("Granier")
#' 
#' #Initialize input
#' x1 <- spwbInput(exampleforest, examplesoil, SpParamsMED, control)
#' 
#' #Call simulation function
#' S1 <- spwb(x1, examplemeteo, latitude = 41.82592, elevation = 100)
#' 
#' #Load observed data (in this case the same simulation results with some added error)  
#' data(exampleobs)
#' 
#' #Evaluation statistics for soil water content
#' evaluation_stats(S1, exampleobs)
#' 
#' #NSE only
#' evaluation_metric(S1, exampleobs, metric="NSE")
#' 
#' #Comparison of temporal dynamics
#' evaluation_plot(S1, exampleobs)
#' 
#' #Loglikelihood value
#' evaluation_metric(S1, exampleobs)
#' }
#' 
#' @name evaluation
evaluation_table<-function(out, measuredData, type = "SWC", cohort = NULL, 
                           temporalResolution = "day") {
  
  # allow dates in column 'dates'
  if("dates" %in% names(measuredData)) {
    row.names(measuredData) <- as.character(measuredData$dates)
  }
  # Check arguments
  temporalResolution = match.arg(temporalResolution, c("day", "week", "month", "year"))
  soil_layers_opts <- c("", ".1", ".2", ".3", ".4", ".5", ".6", ".7", ".8", ".9", ".10")
  soil_opts <- c(paste0("SWC", soil_layers_opts),
                 paste0("RWC", soil_layers_opts),
                 paste0("REW", soil_layers_opts))
  if("spwbInput" %in% names(out)) {
    modelInput<-out[["spwbInput"]]
    type = match.arg(type, c(soil_opts,"E", "ETR", "SE+TR", "LE", "H", "WP", "LFMC", "GPP"))
  } else {
    modelInput<- out[["growthInput"]]
    type = match.arg(type, c(soil_opts,"E", "ETR", "SE+TR", "LE", "H", "WP", "LFMC", "GPP", 
                             "BAI", "DI","DBH", "Height"))
  }
  if(substr(type,1,3) %in% c("REW", "SWC", "RWC")) {
    sm = as.data.frame(out$Soil[[substr(type,1,3)]])
    d = rownames(sm)
    if(type=="SWC")  var_mod <- "1"
    else if(type=="REW")  var_mod <- "1"
    else if(type=="RWC")  var_mod <- "1"
    else {
      var_mod  <- substr(type,5, nchar(type))
    }
    df <- data.frame(Dates = as.Date(d), Observed = NA, Modelled = sm[[var_mod]])
    
    if(!(type %in% names(measuredData))) stop(paste0("Column '", type, "' not found in measured data frame."))
    seld = rownames(measuredData) %in% d
    df$Observed[d %in% rownames(measuredData)] = measuredData[seld, type]
    errcolumn = paste0(type, "_err")
    if(errcolumn %in% names(measuredData))  {
      df$obs_lower[d %in% rownames(measuredData)] = df$Observed[d %in% rownames(measuredData)] - 1.96*measuredData[[errcolumn]][seld]
      df$obs_upper[d %in% rownames(measuredData)] = df$Observed[d %in% rownames(measuredData)] + 1.96*measuredData[[errcolumn]][seld]
    }
  } 
  else if(type=="E") {
    pt = out$Plants$Transpiration
    d = rownames(pt)
    LAI = modelInput$above$LAI_live
    spnames = modelInput$cohorts$Name
    allcohnames = row.names(modelInput$cohorts)
    
    if(is.null(cohort)) {
      icoh = 1
      cohort = allcohnames[1] 
      message("Choosing first cohort")
    } else {
      icoh = which(allcohnames==cohort)
    }
    df <- data.frame(Dates = as.Date(d), Observed = NA, Modelled = pt[,icoh]/LAI[icoh])
    ## Fill observed values
    obscolumn = paste0("E_", cohort)
    if(!(obscolumn %in% names(measuredData))) stop(paste0("Column '", obscolumn, "' not found in measured data frame."))
    df$Observed[d %in% rownames(measuredData)] = measuredData[[obscolumn]][rownames(measuredData) %in% d] 
  }
  else if(type=="ETR") {
    ET2 = out$WaterBalance$Evapotranspiration
    d = rownames(out$WaterBalance)
    df = data.frame(Dates = as.Date(d), Observed = NA, Modelled = ET2)
    
    if(!("ETR" %in% names(measuredData))) stop(paste0("Column 'ETR' not found in measured data frame."))
    df$Observed[d %in% rownames(measuredData)] = measuredData$ETR[rownames(measuredData) %in% d]
  }
  else if(type=="LE") {
    LEmod = out$EnergyBalance$LEVcan + out$EnergyBalance$LEVsoil
    d = rownames(out$EnergyBalance)
    df = data.frame(Dates = as.Date(d), Observed = NA, Modelled = LEmod)
    if(!("LE" %in% names(measuredData))) stop(paste0("Column 'LE' not found in measured data frame."))
    df$Observed[d %in% rownames(measuredData)] = measuredData$LE[rownames(measuredData) %in% d]
  }
  else if(type=="H") {
    Hmod = out$EnergyBalance$Hcan
    d = rownames(out$EnergyBalance)
    df = data.frame(Dates = as.Date(d), Observed = NA, Modelled = Hmod)
    if(!("H" %in% names(measuredData))) stop(paste0("Column 'H' not found in measured data frame."))
    df$Observed[d %in% rownames(measuredData)] = measuredData$H[rownames(measuredData) %in% d]
  }
  else if(type=="SE+TR") {
    ET1 = out$WaterBalance$SoilEvaporation+out$WaterBalance$Transpiration
    d = rownames(out$WaterBalance)
    df = data.frame(Dates = as.Date(d), Observed = NA, Modelled = ET1)
    
    if(!("ETR" %in% names(measuredData))) stop(paste0("Column 'ETR' not found in measured data frame."))
    df$Observed[d %in% rownames(measuredData)] = measuredData$ETR[rownames(measuredData) %in% d]
  }
  else if(type=="WP"){
    wtMD = out$Plants$LeafPsiMin
    wtPD = out$Plants$LeafPsiMax
    d = rownames(wtMD)
    spnames = modelInput$cohorts$Name
    allcohnames = row.names(modelInput$cohorts)
    
    if(is.null(cohort)) {
      icoh = 1
      cohort = allcohnames[1] 
      message("Choosing first cohort")
    } else {
      icoh = which(allcohnames==cohort)
    }
    pdcolumn = paste0("PD_", cohort)
    mdcolumn = paste0("MD_", cohort)
    pderrcolumn = paste0("PD_", cohort, "_err")
    mderrcolumn = paste0("MD_", cohort, "_err")
    icoh = which(allcohnames==cohort)
    
    df = data.frame(Dates = as.Date(d), 
                    PD_obs = NA, MD_obs = NA, PD_obs_lower = NA, PD_obs_upper = NA, MD_obs_lower = NA, MD_obs_upper = NA,
                    PD_mod = wtPD[,icoh], MD_mod = wtMD[,icoh])
    
    seld = rownames(measuredData) %in% d
    if(pdcolumn %in% names(measuredData))  df$PD_obs[d %in% rownames(measuredData)] = measuredData[[pdcolumn]][seld]
    if(mdcolumn %in% names(measuredData))  df$MD_obs[d %in% rownames(measuredData)] = measuredData[[mdcolumn]][seld]
    if(pderrcolumn %in% names(measuredData))  {
      df$PD_obs_lower[d %in% rownames(measuredData)] = df$PD_obs[d %in% rownames(measuredData)] - 1.96*measuredData[[pderrcolumn]][seld]
      df$PD_obs_upper[d %in% rownames(measuredData)] = df$PD_obs[d %in% rownames(measuredData)] + 1.96*measuredData[[pderrcolumn]][seld]
    } else {
      df$PD_obs_lower[d %in% rownames(measuredData)] = df$PD_obs[d %in% rownames(measuredData)]
      df$PD_obs_upper[d %in% rownames(measuredData)] = df$PD_obs[d %in% rownames(measuredData)]
    }
    if(mderrcolumn %in% names(measuredData))  {
      df$MD_obs_lower[d %in% rownames(measuredData)] = df$MD_obs[d %in% rownames(measuredData)] - 1.96*measuredData[[mderrcolumn]][seld]
      df$MD_obs_upper[d %in% rownames(measuredData)] = df$MD_obs[d %in% rownames(measuredData)] + 1.96*measuredData[[mderrcolumn]][seld]
    } else {
      df$MD_obs_lower[d %in% rownames(measuredData)] = df$MD_obs[d %in% rownames(measuredData)]
      df$MD_obs_upper[d %in% rownames(measuredData)] = df$MD_obs[d %in% rownames(measuredData)]
    }
  }
  else if(type=="LFMC") {
    fmc = out$Plants$LFMC
    d = rownames(fmc)
    spnames = modelInput$cohorts$Name
    allcohnames = row.names(modelInput$cohorts)
    
    if(is.null(cohort)) {
      icoh = 1
      cohort = allcohnames[1] 
      message("Choosing first cohort")
    } else {
      icoh = which(allcohnames==cohort)
    }
    df <- data.frame(Dates = as.Date(d), Observed = NA, Modelled = fmc[,icoh])
    ## Fill observed values
    obscolumn = paste0("LFMC_", cohort)
    if(!(obscolumn %in% names(measuredData))) stop(paste0("Column '", obscolumn, "' not found in measured data frame."))
    df$Observed[d %in% rownames(measuredData)] = measuredData[[obscolumn]][rownames(measuredData) %in% d] 
  }
  else if(type=="GPP") {
    GPP = rowSums(out$Plants$GrossPhotosynthesis)
    d = rownames(out$Plants$GrossPhotosynthesis)
    df = data.frame(Dates = as.Date(d), Observed = NA, Modelled = GPP)
    
    if(!("GPP" %in% names(measuredData))) stop(paste0("Column 'GPP' not found in measured data frame."))
    df$Observed[d %in% rownames(measuredData)] = measuredData$GPP[rownames(measuredData) %in% d]
  }
  else if(type=="BAI") {
    SAg = out$GrowthMortality$SAgrowth
    d = rownames(SAg)
    spnames = modelInput$cohorts$Name
    allcohnames = row.names(modelInput$cohorts)
    
    if(is.null(cohort)) {
      icoh = 1
      cohort = allcohnames[1] 
      message("Choosing first cohort")
    } else {
      icoh = which(allcohnames==cohort)
    }
    df <- data.frame(Dates = as.Date(d), Observed = NA, Modelled = SAg[,icoh])
    ## Fill observed values
    obscolumn = paste0("BAI_", cohort)
    if(!(obscolumn %in% names(measuredData))) stop(paste0("Column '", obscolumn, "' not found in measured data frame."))
    df$Observed[d %in% rownames(measuredData)] = measuredData[[obscolumn]][rownames(measuredData) %in% d] 
  }  
  else if(type=="DI") {
    DBH = out$PlantStructure$DBH
    DI = DBH - rbind(modelInput$above$DBH, DBH[-nrow(DBH),])
    d = rownames(DI)
    spnames = modelInput$cohorts$Name
    allcohnames = row.names(modelInput$cohorts)
    
    if(is.null(cohort)) {
      icoh = 1
      cohort = allcohnames[1] 
      message("Choosing first cohort")
    } else {
      icoh = which(allcohnames==cohort)
    }
    df <- data.frame(Dates = as.Date(d), Observed = NA, Modelled = DI[,icoh])
    ## Fill observed values
    obscolumn = paste0("DI_", cohort)
    if(!(obscolumn %in% names(measuredData))) stop(paste0("Column '", obscolumn, "' not found in measured data frame."))
    df$Observed[d %in% rownames(measuredData)] = measuredData[[obscolumn]][rownames(measuredData) %in% d] 
  }  
  else if(type=="DBH") {
    DBH = out$PlantStructure$DBH
    d = rownames(DBH)
    spnames = modelInput$cohorts$Name
    allcohnames = row.names(modelInput$cohorts)
    
    if(is.null(cohort)) {
      icoh = 1
      cohort = allcohnames[1] 
      message("Choosing first cohort")
    } else {
      icoh = which(allcohnames==cohort)
    }
    df <- data.frame(Dates = as.Date(d), Observed = NA, Modelled = DBH[,icoh])
    ## Fill observed values
    obscolumn = paste0("DBH_", cohort)
    if(!(obscolumn %in% names(measuredData))) stop(paste0("Column '", obscolumn, "' not found in measured data frame."))
    df$Observed[d %in% rownames(measuredData)] = measuredData[[obscolumn]][rownames(measuredData) %in% d] 
  }  
  else if(type=="Height") {
    Height = out$PlantStructure$Height
    d = rownames(Height)
    spnames = modelInput$cohorts$Name
    allcohnames = row.names(modelInput$cohorts)
    
    if(is.null(cohort)) {
      icoh = 1
      cohort = allcohnames[1] 
      message("Choosing first cohort")
    } else {
      icoh = which(allcohnames==cohort)
    }
    df <- data.frame(Dates = as.Date(d), Observed = NA, Modelled = Height[,icoh])
    ## Fill observed values
    obscolumn = paste0("Height_", cohort)
    if(!(obscolumn %in% names(measuredData))) stop(paste0("Column '", obscolumn, "' not found in measured data frame."))
    df$Observed[d %in% rownames(measuredData)] = measuredData[[obscolumn]][rownames(measuredData) %in% d] 
  }  
  if(temporalResolution != "day") {
    d.cut = cut(as.Date(d), breaks=temporalResolution)
    if(type %in% c("SWC", "REW", "LFMC", "DBH", "Height")) {
      df = data.frame(Dates = as.Date(levels(d.cut)),
                      Observed = tapply(df$Observed, d.cut, FUN = mean, na.rm = TRUE),
                      Modelled = tapply(df$Modelled, d.cut, FUN = mean, na.rm = TRUE))
    } else if(type == "WP") {
      df = data.frame(Dates = as.Date(levels(d.cut)),
                      PD_obs = tapply(df$PD_obs, d.cut, FUN = mean, na.rm = TRUE),
                      PD_obs_lower = tapply(df$PD_obs_lower, d.cut, FUN = mean, na.rm = TRUE),
                      PD_obs_upper = tapply(df$PD_obs_upper, d.cut, FUN = mean, na.rm = TRUE),
                      MD_obs = tapply(df$MD_obs, d.cut, FUN = mean, na.rm = TRUE),
                      MD_obs_lower = tapply(df$MD_obs_lower, d.cut, FUN = mean, na.rm = TRUE),
                      MD_obs_upper = tapply(df$MD_obs_upper, d.cut, FUN = mean, na.rm = TRUE),
                      PD_mod = tapply(df$PD_mod, d.cut, FUN = mean, na.rm = TRUE),
                      MD_mod = tapply(df$MD_mod, d.cut, FUN = mean, na.rm = TRUE))
    } else { # E, ETR, BAI
      df = data.frame(Dates = as.Date(levels(d.cut)),
                      Observed = tapply(df$Observed, d.cut, FUN = sum, na.rm = TRUE),
                      Modelled = tapply(df$Modelled, d.cut, FUN = sum, na.rm = TRUE))
    }
  }
  
  return(df)
}

#' @rdname evaluation
evaluation_stats<-function(out, measuredData, type="SWC", cohort = NULL, 
                           temporalResolution = "day") {
  evalstats<-function(obs, pred) {
    sel_complete = !(is.na(obs) | is.na(pred))
    obs = obs[sel_complete]
    pred = pred[sel_complete]
    E <- pred-obs
    Bias <- mean(E)
    Bias.rel <- 100*Bias/abs(mean(obs))
    MAE <- mean(abs(E))
    MAE.rel <- 100*MAE/abs(mean(obs))
    r<- cor(obs, pred)
    NSE <- 1 - (sum((obs-pred)^2)/sum((obs-mean(obs))^2))
    NSE.abs <- 1 - (sum(abs(obs-pred))/sum(abs(obs-mean(obs))))
    return(c(n = sum(sel_complete), Bias= Bias, Bias.rel= Bias.rel,MAE = MAE, MAE.rel = MAE.rel, r = r, NSE = NSE, NSE.abs = NSE.abs))
  }
  
  df = evaluation_table(out = out, measuredData = measuredData, 
                        type = type, cohort = cohort, 
                        temporalResolution = temporalResolution)
  if(type=="WP") {
    eval_res = as.data.frame(rbind(evalstats(df$PD_obs, df$PD_mod),
                                   evalstats(df$MD_obs, df$MD_mod)))
    row.names(eval_res)<-c("Predawn potentials", "Midday potentials")
  } else {
    eval_res = evalstats(df$Observed, df$Modelled)
  }
  return(eval_res)
}

#' @rdname evaluation
evaluation_plot<-function(out, measuredData, type="SWC", cohort = NULL, 
                          temporalResolution = "day",
                          plotType = "dynamics") {
  scatterplot<-function(df, xlab="", ylab="", title=NULL, err = FALSE) {
    g<-ggplot(df, aes(x=.data$Modelled))
    if(err) {
      data_err <- df[!is.na(df$obs_lower) & !is.na(df$obs_upper), , drop = FALSE]
      if(nrow(data_err)>0) {
        g<-g+
          geom_pointrange(aes(y = .data$Observed, ymin = .data$obs_lower, ymax = .data$obs_upper),cex=0.5,
                          data = data_err)
      }
    }
    g<-g + 
      geom_point(aes(y = .data$Observed), cex=0.5)+
      geom_abline(intercept=0, slope=1, col="black")+
      geom_smooth(aes(y = .data$Observed), method="lm", se = FALSE, col="gray", linetype="dashed")+
      xlab(xlab)+
      ylab(ylab)+
      theme_bw()
    if(!is.null(title)) g<-g+labs(title=title)
    return(g)
  }
  dynamicsplot<-function(df, xlab="", ylab="", title=NULL, err = FALSE,
                         str_obs = "Observed", str_mod = "Modelled") {
    g<-ggplot(df, aes(x=.data$Dates))
    if(err) {
      g <- g +          
        geom_ribbon(aes(ymin=.data$obs_lower, ymax=.data$obs_upper), 
                    col="gray", alpha= 0.5)
    }
    g<-g+       
      geom_path(aes(y=.data$Observed, col="Observed"))+
      geom_path(aes(y=.data$Modelled, col="Modelled"))+
      xlab(xlab)+
      ylab(ylab)+
      scale_color_manual(name="", 
                         values=c("Observed"="black", "Modelled"= "red"),
                         labels =c("Observed"=str_obs, "Modelled"=str_mod))+
      theme_bw()
    if(!is.null(title)) g<-g+labs(title=title)
    return(g)
  }
  pointdynamicsplot<-function(df, xlab="", ylab="", title=NULL, err = FALSE,
                              str_obs = "Observed", str_mod = "Modelled") {
    g<-ggplot(df, aes(x=.data$Dates))
    g<- g + geom_path(aes(y=.data$Modelled, col="Modelled"))
    if(err) {
      g <- g + geom_pointrange(aes(x = .data$Dates, y = .data$Observed, ymin = .data$obs_lower, ymax = .data$obs_upper))
    } else {
      g<- g + geom_point(aes(y=.data$Observed, col="Observed"))      
    }
    g<-g+       
      xlab(xlab)+
      ylab(ylab)+
      scale_color_manual(name="", 
                         values=c("Observed"="black", "Modelled"= "red"),
                         labels =c("Observed"=str_obs, "Modelled"=str_mod))+
      theme_bw()
    if(!is.null(title)) g<-g+labs(title=title)
    return(g)
  }
  # Check arguments
  plotType = match.arg(plotType, c("pointdynamics", "dynamics", "scatter"))
  if("spwbInput" %in% names(out)) {
    modelInput<-out[["spwbInput"]]
  } else {
    modelInput<- out[["growthInput"]]
  }
  df = evaluation_table(out = out, measuredData = measuredData, 
                        type = type, cohort = cohort, 
                        temporalResolution = temporalResolution)
  
  if(type %in% paste0("SWC", c("", paste0(".", 1:10)))) {
    if(plotType=="dynamics") {
      g<-dynamicsplot(df, ylab = expression(paste("Soil moisture ",(m^{3}%.%m^{-3}))),
                      err = (paste0(type,"_err") %in% names(measuredData)))
    } else if(plotType=="pointdynamics") {
      g<-pointdynamicsplot(df, ylab = expression(paste("Soil moisture ",(m^{3}%.%m^{-3}))),
                           err = (paste0(type,"_err") %in% names(measuredData)))
    } else {
      g<-scatterplot(df, xlab  = expression(paste("Measured soil moisture ",(m^{3}%.%m^{-3}))),
                     ylab = expression(paste("Measured soil moisture ",(m^{3}%.%m^{-3}))), 
                     err = (paste0(type,"_err") %in% names(measuredData)))
    }
  } 
  else if(type %in% paste0("RWC", c("", paste0(".", 1:10)))) {
    if(plotType=="dynamics") {
      g<-dynamicsplot(df, ylab = "Relative water content (RWC)",
                      err = (paste0(type,"_err") %in% names(measuredData)))
    } else if(plotType=="pointdynamics") {
      g<-pointdynamicsplot(df, ylab = "Relative water content (RWC)",
                           err = (paste0(type,"_err") %in% names(measuredData)))
    } else {
      g<-scatterplot(df, xlab  = "Modelled relative water content (RWC)",
                     ylab = "Measured relative water content (RWC)", 
                     err = (paste0(type,"_err") %in% names(measuredData)))
      
    }
  }
  else if(type %in% paste0("REW", c("", paste0(".", 1:10)))) {
    if(plotType=="dynamics") {
      g<-dynamicsplot(df, ylab = "Relative extractable soil water (REW)",
                      err = (paste0(type,"_err") %in% names(measuredData)))
    } else if(plotType=="pointdynamics") {
      g<-pointdynamicsplot(df, ylab = "Relative extractable soil water (REW)",
                           err = (paste0(type,"_err") %in% names(measuredData)))
    } else {
      g<-scatterplot(df, xlab  = "Modelled relative extractable soil water (REW)",
                     ylab = "Measured relative extractable soil water (REW)", 
                     err = (paste0(type,"_err") %in% names(measuredData)))
      
    }
  }
  else if(type=="E") {
    allcohnames = row.names(modelInput$cohorts)
    spnames = modelInput$cohorts$Name
    
    if(is.null(cohort)) {
      icoh = 1
      cohort = allcohnames[1] 
      message("Choosing first cohort")
    } else {
      icoh = which(allcohnames==cohort)
    }
    
    if(plotType=="dynamics") {
      g<-dynamicsplot(df, ylab = "Transpiration per leaf area (l/m2/day)", 
                      title=paste0(cohort , " (",spnames[icoh],")"))
    } else if(plotType=="pointdynamics") {
      g<-pointdynamicsplot(df, ylab = "Transpiration per leaf area (l/m2/day)", 
                      title=paste0(cohort , " (",spnames[icoh],")"))
    } else {
      g<-scatterplot(df, 
                     xlab = "Modelled transpiration per leaf area (l/m2/day)",
                     ylab = "Measured transpiration per leaf area (l/m2/day)", 
                     title=paste0(cohort , " (",spnames[icoh],")"))
    }
  }
  else if(type=="LFMC") {
    allcohnames <- row.names(modelInput$cohorts)
    spnames <- modelInput$cohorts$Name
    
    if(is.null(cohort)) {
      icoh <- 1
      cohort <- allcohnames[1] 
      message("Choosing first cohort")
    } else {
      icoh <- which(allcohnames==cohort)
    }
    
    if(plotType=="dynamics") {
      g<-dynamicsplot(df, ylab = "Fuel moisture content (% of dry weight)", 
                      title=paste0(cohort , " (",spnames[icoh],")"))
    } else if(plotType=="pointdynamics") {
      g<-pointdynamicsplot(df, ylab = "Fuel moisture content (% of dry weight)", 
                           title=paste0(cohort , " (",spnames[icoh],")"))
    } else {
      g<-scatterplot(df, 
                     xlab = "Modelled fuel moisture content (% of dry weight)",
                     ylab = "Measured fuel moisture content (% of dry weight)", 
                     title=paste0(cohort , " (",spnames[icoh],")"))
    }
  }
  else if(type=="BAI") {
    allcohnames = row.names(modelInput$cohorts)
    spnames = modelInput$cohorts$Name
    
    if(is.null(cohort)) {
      icoh = 1
      cohort = allcohnames[1] 
      message("Choosing first cohort")
    } else {
      icoh = which(allcohnames==cohort)
    }
    
    if(plotType=="dynamics") {
      g<-dynamicsplot(df, ylab = paste0("Basal area increment (cm2/", temporalResolution,")"), 
                      title=paste0(cohort , " (",spnames[icoh],")"))
    } else if(plotType=="pointdynamics") {
      g<-pointdynamicsplot(df, ylab = paste0("Basal area increment (cm2/", temporalResolution,")"), 
                      title=paste0(cohort , " (",spnames[icoh],")"))
    } else {
      g<-scatterplot(df, 
                     xlab = paste0("Modelled basal area increment (cm2/", temporalResolution,")"),
                     ylab = paste0("Measured basal area increment (cm2/", temporalResolution,")"), 
                     title=paste0(cohort , " (",spnames[icoh],")"))
    }
  }
  else if(type=="DI") {
    allcohnames = row.names(modelInput$cohorts)
    spnames = modelInput$cohorts$Name
    
    if(is.null(cohort)) {
      icoh = 1
      cohort = allcohnames[1] 
      message("Choosing first cohort")
    } else {
      icoh = which(allcohnames==cohort)
    }
    
    if(plotType=="dynamics") {
      g<-dynamicsplot(df, ylab = paste0("Diameter increment (cm/", temporalResolution,")"), 
                      title=paste0(cohort , " (",spnames[icoh],")"))
    } else if(plotType=="pointdynamics") {
      g<-pointdynamicsplot(df, ylab = paste0("Diameter increment (cm/", temporalResolution,")"), 
                      title=paste0(cohort , " (",spnames[icoh],")"))
    } else {
      g<-scatterplot(df, 
                     xlab = paste0("Modelled diameter increment (cm/", temporalResolution,")"),
                     ylab = paste0("Measured diameter increment (cm/", temporalResolution,")"), 
                     title=paste0(cohort , " (",spnames[icoh],")"))
    }
  }
  else if(type=="DBH") {
    allcohnames = row.names(modelInput$cohorts)
    spnames = modelInput$cohorts$Name
    
    if(is.null(cohort)) {
      icoh = 1
      cohort = allcohnames[1] 
      message("Choosing first cohort")
    } else {
      icoh = which(allcohnames==cohort)
    }
    
    if(plotType=="dynamics") {
      g<-dynamicsplot(df, ylab = paste0("DBH (cm)"), 
                      title=paste0(cohort , " (",spnames[icoh],")"))
    } else if(plotType=="pointdynamics") {
      g<-pointdynamicsplot(df, ylab = paste0("DBH (cm)"), 
                      title=paste0(cohort , " (",spnames[icoh],")"))
    } else {
      g<-scatterplot(df, 
                     xlab = paste0("Modelled DBH (cm)"),
                     ylab = paste0("Measured DBH (cm)"), 
                     title=paste0(cohort , " (",spnames[icoh],")"))
    }
  }
  else if(type=="Height") {
    allcohnames = row.names(modelInput$cohorts)
    spnames = modelInput$cohorts$Name
    
    if(is.null(cohort)) {
      icoh = 1
      cohort = allcohnames[1] 
      message("Choosing first cohort")
    } else {
      icoh = which(allcohnames==cohort)
    }
    
    if(plotType=="dynamics") {
      g<-dynamicsplot(df, ylab = paste0("Height (cm)"), 
                      title=paste0(cohort , " (",spnames[icoh],")"))
    } else if(plotType=="pointdynamics") {
      g<-pointdynamicsplot(df, ylab = paste0("Height (cm)"), 
                      title=paste0(cohort , " (",spnames[icoh],")"))
    } else {
      g<-scatterplot(df, 
                     xlab = paste0("Modelled height (cm)"),
                     ylab = paste0("Measured height (cm)"), 
                     title=paste0(cohort , " (",spnames[icoh],")"))
    }
  }
  else if(type=="ETR") {
    if(plotType=="dynamics") {
      g<-dynamicsplot(df, ylab = "ETR (mm)",
                      err = (paste0(type,"_err") %in% names(measuredData)))
    } else if(plotType=="pointdynamics") {
      g<-pointdynamicsplot(df, ylab = "ETR (mm)",
                           err = (paste0(type,"_err") %in% names(measuredData)))
    } else {
      g<-scatterplot(df, xlab  = "Modelled ETR (mm)",
                     ylab ="Measured ETR (mm)",
                     err = (paste0(type,"_err") %in% names(measuredData)))
    }
  }
  else if(type=="LE") {
    if(plotType=="dynamics") {
      g<-dynamicsplot(df, ylab = "Latent heat (MJ/m2)",
                      err = (paste0(type,"_err") %in% names(measuredData)))
    } else if(plotType=="pointdynamics") {
      g<-pointdynamicsplot(df, ylab = "Latent heat (MJ/m2)",
                      err = (paste0(type,"_err") %in% names(measuredData)))
    } else {
      g<-scatterplot(df, xlab  = "Modelled latent heat (MJ/m2)",
                     ylab ="Measured latent heat (MJ/m2)",
                     err = (paste0(type,"_err") %in% names(measuredData)))
    }
  }
  else if(type=="H") {
    if(plotType=="dynamics") {
      g<-dynamicsplot(df, ylab = "Canpy sensible heat (MJ/m2)",
                      err = (paste0(type,"_err") %in% names(measuredData)))
    } else if(plotType=="pointdynamics") {
      g<-pointdynamicsplot(df, ylab = "Canpy sensible heat (MJ/m2)",
                      err = (paste0(type,"_err") %in% names(measuredData)))
    } else{
      g<-scatterplot(df, xlab  = "Modelled sensible heat (MJ/m2)",
                     ylab ="Measured sensible heat (MJ/m2)",
                     err = (paste0(type,"_err") %in% names(measuredData)))
    }
  }
  else if(type=="SE+TR") {
    if(plotType=="dynamics") {
      g<-dynamicsplot(df, ylab = "ETR or SE+TR (mm)", str_obs = "Observed (ETR)", str_mod = "Modelled (SE+TR)",
                      err = (paste0(type,"_err") %in% names(measuredData)))
    } else if(plotType=="pointdynamics") {
      g<-pointdynamicsplot(df, ylab = "ETR or SE+TR (mm)", str_obs = "Observed (ETR)", str_mod = "Modelled (SE+TR)",
                      err = (paste0(type,"_err") %in% names(measuredData)))
    } else{
      g<-scatterplot(df, xlab  = "Modelled SE+TR (mm)",
                     ylab ="Measured ETR (mm)",
                     err = (paste0(type,"_err") %in% names(measuredData)))
    }
  }
  else if(type=="GPP") {
    if(plotType=="dynamics") {
      g<-dynamicsplot(df, ylab = "GPP (gC/m2)",
                      err = (paste0(type,"_err") %in% names(measuredData)))
    } else if(plotType=="pointdynamics") {
      g<-pointdynamicsplot(df, ylab = "GPP (gC/m2)",
                      err = (paste0(type,"_err") %in% names(measuredData)))
    } else {
      g<-scatterplot(df, xlab  = "Modelled GPP (gC/m2)",
                     ylab ="Measured GPP (gC/m2)",
                     err = (paste0(type,"_err") %in% names(measuredData)))
    }
  }
  else if(type=="WP"){
    wtMD = out$Plants$LeafPsiMin
    wtPD = out$Plants$LeafPsiMax
    d = rownames(wtMD)
    spnames = modelInput$cohorts$Name
    allcohnames = row.names(modelInput$cohorts)
    
    if(is.null(cohort)) {
      icoh = 1
      cohort = allcohnames[1] 
      message("Choosing first cohort")
    } else {
      icoh = which(allcohnames==cohort)
    }
    
    if(plotType=="dynamics"  || plotType == "pointdynamics"){
      g<-ggplot(df)+
        geom_path(aes(x=.data$Dates, y=.data$PD_mod, col="Predawn", linetype="Predawn"))+
        geom_path(aes(x=.data$Dates, y=.data$MD_mod, col="Midday", linetype="Midday"))+
        geom_pointrange(aes(x = .data$Dates, y = .data$PD_obs, ymin = .data$PD_obs_lower, ymax = .data$PD_obs_upper, col="Predawn", linetype="Predawn"))+
        geom_pointrange(aes(x = .data$Dates, y = .data$MD_obs, ymin = .data$MD_obs_lower, ymax = .data$MD_obs_upper, col="Midday",linetype="Midday"))+
        scale_color_manual(name="", values=c("Predawn"="blue", "Midday"= "red"))+
        scale_linetype_manual(name="", values=c("Predawn"="dashed", "Midday"= "solid"))+
        labs(title=paste0(cohort , " (",spnames[icoh],")"))+
        xlab("")+
        ylab("Leaf water potential (MPa)")+
        theme_bw()
    } else {
      g<-ggplot(df)+
        geom_abline(intercept=0, slope=1, col="black")+
        geom_pointrange(aes(x = .data$PD_mod, y = .data$PD_obs, ymin = .data$PD_obs_lower, ymax = .data$PD_obs_upper, col="Predawn"))+
        geom_pointrange(aes(x = .data$MD_mod, y = .data$MD_obs, ymin = .data$MD_obs_lower, ymax = .data$MD_obs_upper,col="Midday"))+
        geom_smooth(aes(x = .data$PD_mod, y = .data$PD_obs, col="Predawn"), method="lm", se = FALSE, linetype="dashed")+
        geom_smooth(aes(x = .data$MD_mod, y = .data$MD_obs, col="Midday"), method="lm", se = FALSE, linetype="dashed")+
        scale_color_manual(name="", values=c("Predawn"="blue", "Midday"= "red"))+
        labs(title=paste0(cohort , " (",spnames[icoh],")"))+
        xlab("Modelled leaf water potential (MPa)")+
        ylab("Measured leaf water potential (MPa)")+
        theme_bw()
    }
  }
  return(g)
}

#' @rdname evaluation
evaluation_metric<-function(out, measuredData, type="SWC", cohort=NULL, 
                            temporalResolution = "day",
                            metric = "loglikelihood") {
  df = evaluation_table(out = out, measuredData = measuredData, 
                        type = type, cohort = cohort, 
                        temporalResolution = temporalResolution)
  obs = df$Observed
  pred = df$Modelled
  sel_complete = !(is.na(obs) | is.na(pred))
  obs = obs[sel_complete]
  pred = pred[sel_complete]
  sd <- sd(obs, na.rm=TRUE)
  metric<-match.arg(metric, c("loglikelihood", "NSE", "NSE.abs", "MAE", "MAE.rel", "r"))
  m <- switch(metric,
         "loglikelihood" = sum(dnorm(obs, pred, sd, log=TRUE), na.rm=TRUE),
         "NSE" = 1 - (sum((obs-pred)^2, na.rm=TRUE)/sum((obs-mean(obs, na.rm=TRUE))^2, na.rm=TRUE)),
         "MAE" = mean(abs(pred-obs), na.rm=TRUE),
         "MAE.rel" = 100*mean(abs(pred-obs), na.rm=TRUE)/abs(mean(obs, na.rm=TRUE)),
         "r" = cor(obs, pred),
         "NSE.abs" = 1 - (sum(abs(obs-pred))/sum(abs(obs-mean(obs))))
  )
  return(m)
}

library(medfate)

data(examplemeteo)
data(exampleforest)
data(SpParamsMED)
examplesoil = defaultSoilParams(4)
control = defaultControl("Granier")
control$verbose = FALSE
data(exampleobs)
x1 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)
S1 <- spwb(x1, examplemeteo, latitude = 41.82592, elevation = 100)

test_that("evaluation can be performed",{
  expect_type(evaluation_stats(S1, exampleobs), "double")
  expect_type(evaluation_metric(S1, exampleobs, metric="NSE"), "double")
  expect_s3_class(evaluation_plot(S1, exampleobs), "ggplot")
})

test_that("evaluation for first soil layer can be performed",{
  names(exampleobs)[2] <- "SWC.1"
  expect_type(evaluation_stats(S1, exampleobs, type="SWC.1"), "double")
  expect_type(evaluation_metric(S1, exampleobs, type="SWC.1", metric="NSE"), "double")
  expect_s3_class(evaluation_plot(S1, exampleobs, type="SWC.1"), "ggplot")
})

#' @rdname soil
#' 
#' @param object An object of class \code{soil}.
#' @param model Either 'SX' or 'VG' for Saxton or Van Genuchten pedotransfer models.
#' @param ... Additional parameters to \code{summary}.
#' 
summary.soil<-function(object, model="SX",...) {
  #Depth
  cat(paste("Soil depth (mm):", round(sum(object$widths), digits=0),"\n"))
  #Soil parameters related to texture
  nlayers = length(object$widths)
  dini = 0;
  dfin = 0;
  ##Water content at field capacity
  Water_WP = soil_waterWP(object, model)
  Theta_WP = soil_thetaWP(object, model)
  Water_FC = soil_waterFC(object, model)
  Theta_FC = soil_thetaFC(object, model)
  Water_SAT = soil_waterSAT(object, model)
  Theta_SAT = soil_thetaSAT(object, model)
  Water_EXTR = soil_waterExtractable(object,model)
  
  for(l in 1:nlayers) {
    dfin = dfin+object$widths[l]
    silt = 100-object$sand[l]-object$clay[l]
    if(!is.na(object$om[l])) silt = silt - object$om[l]
    usda_Type = soil_USDAType(object$clay[l],object$sand[l]);
    
    s <- paste("\nLayer ",l," [",dini," to ",dfin,"mm ]",
               "\n    clay (%):", round(object$clay[l]),"silt (%):", round(silt), "sand (%):", round(object$sand[l]), " usda:",   usda_Type)
    if(any(c("om", "nitrogen", "ph") %in% names(object))) s <- paste(s, "\n   ")
    if("om" %in% names(object)) s <- paste(s,  "organic matter (%):", round(object$om[l]))
    if("nitrogen" %in% names(object)) s <- paste(s,  "nitrogen (g/kg):", round(object$nitrogen[l]))
    if("ph" %in% names(object)) s <- paste(s,  "ph (0-14):", round(object$ph[l]))
    cat(paste(s,
              "\n    rock fragment content (%):", round(object$rfc[l]),"macroporosity (%):", round(object$macro[l]*100),  
              "\n    Theta WP (%):", round(100*Theta_WP[l]),"Theta FC (%):", round(100*Theta_FC[l]), "Theta SAT (%):", round(100*Theta_SAT[l]), "Theta current (%)", round(100*object$W[l]*Theta_FC[l]),
              "\n    Vol. WP (mm):", round(Water_WP[l]),"Vol. FC (mm):", round(Water_FC[l]),"Vol. SAT (mm):", round(Water_SAT[l]), "Vol. current (mm):", round(object$W[l]*Water_FC[l]), 
              "\n    Temperature (Celsius):", round(object$Temp[l],1),
              "\n"))
    dini = dini+object$widths[l]
  }
  cat(paste("\nTotal soil saturated capacity (mm):", round(sum(Water_SAT), digits=0),"\n"))  
  cat(paste("Total soil water holding capacity (mm):", round(sum(Water_FC), digits=0),"\n"))  
  cat(paste("Total soil extractable water (mm):", round(sum(Water_EXTR), digits=0),"\n"))  
  cat(paste("Total soil current Volume (mm):",round(sum(object$W*Water_FC), digits=0),"\n"))
  cat(paste("Saturated water depth (mm):",round(soil_saturatedWaterDepth(object, model), digits=0),"\n\n"))
}

#' Plant regeneration
#'
#' Functions to simulate annual plant regeneration from seed recruitment or from resprouting
#' 
#' @param forest An object of class \code{\link{forest}}.
#' @param seedBank A data frame with columns 'Species' and 'Percent', describing a seed bank.
#' @param SpParams A data frame with species parameters (see \code{\link{SpParamsMED}} and \code{\link{SpParamsDefinition}}).
#' @param refillSpecies A string vector of species names corresponding to seed rain to refill seed bank.
#' @param refillPercent A numeric vector of indicating the percentage of seed bank refilling (if missing then seed bank is set to 100%).
#' @param minPercent A minimum percent of seed bank to retain entry in \code{seedBank} element of \code{forest}.
#' @param control A list with default control parameters (see \code{\link{defaultControl}}).
#' @param minMonthTemp Minimum month temperature.
#' @param moistureIndex Moisture index (annual precipitation over annual potential evapotranspiration).
#' @param verbose Boolean flag to indicate console output during calculations.
#' 
#' @details 
#' \itemize{
#'   \item{\code{regeneration_seedproduction} evaluates if reproductive individuals (i.e. sufficiently tall individuals) are present.} 
#'   \item{\code{regeneration_seedrefill} fills seed bank of input \code{forest} object with seed rain.}
#'   \item{\code{regeneration_seedmortality} updates seed bank of input \code{forest} object according to annual seed mortality.}
#'   \item{\code{regeneration_recruitment} evaluates recruitment from the seed bank (or local seed production if seed bank is missing). Minimum month temperature and moisture index values are used to determine if recruitment was successful. 
#' Species also require a minimum amount of light at the ground level.}
#'   \item{\code{regeneration_resprouting} evaluates resprouting occurs after “mortality” from die-back (including drought- or pathogen-induced dessication), 
#' cutting or burning of the aerial part in a species with resprouting ability, 
#' but not after carbon starvation or baseline mortality (unspecific mortality causes).}
#' }
#' 
#' @return 
#' \itemize{
#'   \item{\code{regeneration_seedproduction} returns a list of species names}
#'   \item{\code{regeneration_seedrefill} and \code{regeneration_seedmortality} return a copy of the input \code{data.frame} object with an update seed bank. }
#'   \item{\code{regeneration_resprouting} and \code{regeneration_recruitment} return a new object of class \code{\link{forest}} with the new plant cohorts.}
#' }
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso \code{\link{fordyn}}
#' 
#' @examples 
#' #Load example plot plant data
#' data(exampleforest)
#' 
#' #Default species parameterization
#' data(SpParamsMED)
#' 
#' #Initialize control parameters
#' control <- defaultControl("Granier")
#' control$recruitmentMode = "annual/deterministic" 
#' 
#' #Recruitment limits
#' plant_parameter(exampleforest, SpParamsMED, "MinTempRecr")
#' plant_parameter(exampleforest, SpParamsMED, "MinMoistureRecr")
#' 
#' #Compare seed recruitment outcomes
#' regeneration_recruitment(exampleforest, SpParamsMED, control, 0, 0.25)
#' regeneration_recruitment(exampleforest, SpParamsMED, control, 3, 0.25)
#' 
#' @name regeneration
#' @keywords internal
regeneration_seedproduction<-function(forest, SpParams, control) {
  treeSpp <- forest$treeData$Species
  if(length(treeSpp)>0) { 
    # Whether the tree reaches seed production diameter or height
    # We could use the Dmat ~ Dmax relationship in https://onlinelibrary.wiley.com/doi/10.1111/ele.14500
    spd <- species_parameter(treeSpp, SpParams, "SeedProductionDiameter", fillMissing = FALSE)
    selDiam  <- (forest$treeData$DBH > spd)
    sph <- species_parameter(treeSpp, SpParams, "SeedProductionHeight", fillMissing = FALSE)
    sph[is.na(sph)] <- control$seedProductionTreeHeight
    selHeight <- (forest$treeData$Height > sph)
    selDiam[is.na(selDiam)] <- selHeight[is.na(selDiam)] # Replace missing selection values with height criterion
    treeSpp <- unique(treeSpp[selDiam])
  }
  if(control$shrubDynamics) {
    shrubSpp <- forest$shrubData$Species
    if(length(shrubSpp)>0) {
      sph <- species_parameter(shrubSpp, SpParams, "SeedProductionHeight", fillMissing = FALSE)
      sph[is.na(sph)] <- control$seedProductionShrubHeight
      selHeight <- forest$shrubData$Height > sph
      shrubSpp <- unique(shrubSpp[selHeight])
    }
  } else {
    shrubSpp <- character(0)
  } 
  return(unique(c(treeSpp, shrubSpp)))
}

#' @rdname regeneration
#' @keywords internal
regeneration_seedrefill <-function(seedBank, refillSpecies, refillPercent = NULL) {
  # Initialize seed bank if not present
  if(is.null(seedBank)) {
    seedBank <- data.frame(Species = character(0), Percent = numeric(0))
  }
  
  #If not supplied, all species refill to 100%
  if(is.null(refillPercent)) refillPercent <- rep(100, length(refillSpecies))
  
  #If refillPercent is missing for some species, it will be refilled to 100%
  refillPercent[is.na(refillPercent)] <- 100
  
  if(length(refillSpecies) > 0) {
    for(isp in 1:length(refillSpecies)) {
      sp <- refillSpecies[isp]
      if(sp %in% seedBank$Species) {
        seedBank$Percent[seedBank$Species==sp] <- min(100.0, seedBank$Percent[seedBank$Species==sp] + refillPercent[isp])
      } else {
        seedBank <- rbind(seedBank, data.frame("Species" = sp, "Percent" = refillPercent[isp]))
      }
    }
  }
  return(seedBank)
}

#' @rdname regeneration
#' @keywords internal
regeneration_seedmortality <- function(seedBank, SpParams, minPercent = 1) {
  if(is.null(seedBank)) {
    seedBank <- data.frame(Species = character(0), Percent = numeric(0))
    return(seedBank)
  }
  seed_longevity <- species_parameter(seedBank$Species, SpParams, "SeedLongevity")
  seed_longevity[is.na(seed_longevity)] <- 2.0 # Default 2 years
  seedBank$Percent <- seedBank$Percent*exp(-1.0/seed_longevity)
  seedBank <- seedBank[seedBank$Percent >= minPercent, , drop = FALSE]
  return(seedBank)
}

#' @rdname regeneration
#' @keywords internal
regeneration_germination <- function(forest, SpParams, control) {
  # If seed bank is defined take seeds from it. Otherwise, use local seed production
  if("seedBank" %in% names(forest)) {
    seedSpp <- forest$seedBank$Species 
    seedPercent <- forest$seedBank$Percent
  } else {
    seedSpp <- regeneration_seedproduction(forest, SpParams, control)
    seedPercent <- rep(100.0, length(seedSpp))
  }
  isTree <- !(species_characterParameter(seedSpp, SpParams, "GrowthForm")=="Shrub")
  treeSpp <- seedSpp[isTree]
  treePercent <- seedPercent[isTree]
  if(control$shrubDynamics) {
    shrubSpp <- seedSpp[!isTree]
    shrubPercent <- seedPercent[!isTree]
  } else {
    shrubSpp <- character(0)
    shrubPercent <- numeric(0)
  }
  tree_recr_prob <- species_parameter(treeSpp, SpParams, "ProbRecr")
  tree_recr_prob[is.na(tree_recr_prob)] <- control$probRecr
  shrub_recr_prob <- species_parameter(shrubSpp, SpParams, "ProbRecr")
  shrub_recr_prob[is.na(shrub_recr_prob)] <- control$probRecr
  if(control$recruitmentMode %in% c("annual/stochastic", "daily/stochastic", "stochastic")) {
    treePercent <- rbinom(length(treeSpp), size = 1, prob = tree_recr_prob)*treePercent
    shrubPercent <- rbinom(length(shrubSpp), size = 1, prob = shrub_recr_prob)*shrubPercent
  } else {
    treePercent <- treePercent*tree_recr_prob
    shrubPercent <- shrubPercent*shrub_recr_prob
  }
  nseedling <- length(seedSpp)
  # Create new seedling data
  seedlingBank <- data.frame(Species = c(treeSpp, shrubSpp),
                             Percent = c(treePercent, shrubPercent),
                             Age = as.numeric(rep(0, nseedling)),
                             Z50 = as.numeric(rep(0, nseedling)),
                             Z95 = as.numeric(rep(0, nseedling)),
                             Z100 = as.numeric(rep(NA, nseedling)))
  return(seedlingBank)
}

#' @rdname regeneration
#' @keywords internal
regeneration_seedlings_daily <- function(forest, SpParams, control,
                                         growthResult, verbose = FALSE) {

  
  newSeedlingBank <- regeneration_germination(forest, SpParams, control)
  
  # If exists, merge with existing forest seedling bank 
  if(!is.null(forest$seedlingBank)) {
    seedlingBank <- rbind(newSeedlingBank, forest$seedlingBank)
  } else {
    seedlingBank <- newSeedlingBank
  }
  
  if(nrow(seedlingBank)>0) {
    # Determine thresholds
    minFPAR <- species_parameter(seedlingBank$Species, SpParams, "MinFPARRecr")
    minTemp <- species_parameter(seedlingBank$Species, SpParams, "MinTempRecr")
    minFPAR[is.na(minFPAR)] <- control$minFPARRecr
    minTemp[is.na(minTemp)] <- control$minTempRecr
    
    VCstem_P12 <- species_parameter(seedlingBank$Species, SpParams, "VCstem_P12", TRUE, TRUE)
    VCstem_P50 <- species_parameter(seedlingBank$Species, SpParams, "VCstem_P50", TRUE, TRUE)
    VCstem_P88 <- species_parameter(seedlingBank$Species, SpParams, "VCstem_P88", TRUE, TRUE)
    VCstem_slope = (88.0 - 12.0)/(abs(VCstem_P88) - abs(VCstem_P12))
    Psi_Extract <- species_parameter(seedlingBank$Species, SpParams, "Psi_Extract", TRUE, TRUE)
    Exp_Extract <- species_parameter(seedlingBank$Species, SpParams, "Exp_Extract", TRUE, TRUE)
    Z95adult <- species_parameter(seedlingBank$Species, SpParams, "Z95")
    if("RecrAge" %in% names(SpParams)) RecrAge <- species_parameter(seedlingBank$Species, SpParams, "RecrTreeDensity")
    if("recrAge" %in% names(control)) {
      RecrAge[is.na(RecrAge)] <- control$recrAge
    } else {
      RecrAge[is.na(RecrAge)] <- 5
    }
    
    # Daily increment in root depth
    incrZ95 <- Z95adult/(RecrAge*365.26)

    # Retrieve environmental_cues
    soil_widths <- growthResult$growthInput$soil$widths
    soilPsi <- growthResult$Soil$Psi[, 1:length(soil_widths)]
    LgroundPAR <- growthResult$Stand$LgroundPAR
    months <- as.numeric(format(as.Date(growthResult$weather$dates), "%m"))
    monthlyMinTemp <- tapply(growthResult$weather$MinTemperature, months, FUN="mean", na.rm=TRUE)
    monthlyMaxTemp <- tapply(growthResult$weather$MaxTemperature, months, FUN="mean", na.rm=TRUE)
    monthlyTemp <- 0.606*monthlyMaxTemp + 0.394*monthlyMinTemp
    minMonthTemp <- min(monthlyTemp, na.rm=TRUE)
    
    # Daily root growth and seedling mortality
    for(i in 1:length(LgroundPAR)) {
      #root growth
      seedlingBank$Z95 <- seedlingBank$Z95 + incrZ95
      seedlingBank$Z50 <- exp(log(seedlingBank$Z95)/1.4)
      if(control$truncateRootDistribution) {
        seedlingBank$Z100 <- exp(log(seedlingBank$Z95)/0.95);
      }
      seedling_v <- root_ldrDistribution(seedlingBank$Z50, seedlingBank$Z95, seedlingBank$Z100, 
                                         soil_widths)
      #mortality
      for(j in 1:nrow(seedlingBank)) {
        seedling_psi <- hydraulics_averagePsi(soilPsi[i, ], seedling_v[j, ], exp_extract = Exp_Extract[j], psi_extract = Psi_Extract[j])
        stem_plc <- 1.0 - hydraulics_xylemConductanceSigmoid(seedling_psi, 1.0, VCstem_P50[j], VCstem_slope[j]);
        m_light <- mortality_dailyProbability(LgroundPAR[i]/100, minFPAR[j]/100)
        m_dry <- mortality_dailyProbability(1.0 - stem_plc, 0.4) 
        seedlingBank$Percent[j] <- seedlingBank$Percent[j]*(1 - max(m_light, m_dry)) 
      }
    }
    # Minimum temperature filter 
    recr_selection <- (minMonthTemp > minTemp)
    
    # Remove rows
    recr_selection[seedlingBank$Percent == 0] <- FALSE
    seedlingBank <- seedlingBank[recr_selection, , drop = FALSE]
    row.names(seedlingBank) <- NULL
    
    # Increment seedling age
    seedlingBank$Age <- seedlingBank$Age + 1 
  }
  
  return(seedlingBank)
}


#' @rdname regeneration
#' @keywords internal
regeneration_seedlings <- function(forest, SpParams, control,
                                   minMonthTemp, moistureIndex, verbose = FALSE) {
  
  newSeedlingBank <- regeneration_germination(forest, SpParams, control)
  
  # If exists, merge with existing forest seedling bank 
  if(!is.null(forest$seedlingBank)) {
    seedlingBank <- rbind(newSeedlingBank, forest$seedlingBank)
  } else {
    seedlingBank <- newSeedlingBank
  }
  
  # Calculate light in the ground
  if((nrow(forest$treeData)>0) || (nrow(forest$shrubData)>0)) {
    PARperc <- light_PARground(forest, SpParams)
  } else {
    PARperc <- 100
  } 
  if(verbose) cat(paste0(" [Cold (C): ", round(minMonthTemp,2), " / Moist: ", round(moistureIndex,2), " / FPAR (%): ", round(PARperc,1), "]"))
  
  
  # Determine thresholds
  minFPAR <- species_parameter(seedlingBank$Species, SpParams, "MinFPARRecr")
  minTemp <- species_parameter(seedlingBank$Species, SpParams, "MinTempRecr")
  minMoisture <- species_parameter(seedlingBank$Species, SpParams, "MinMoistureRecr")
  minFPAR[is.na(minFPAR)] <- control$minFPARRecr
  minTemp[is.na(minTemp)] <- control$minTempRecr
  minMoisture[is.na(minMoisture)] <- control$minMoistureRecr
  # Seedling mortality
  recr_selection <- (minMonthTemp > minTemp) & (moistureIndex > minMoisture) & (PARperc > minFPAR)
  recr_selection[seedlingBank$Percent == 0] <- FALSE
  seedlingBank <- seedlingBank[recr_selection, , drop = FALSE]
  row.names(seedlingBank) <- NULL
  # Increment seedling age and update root distribution
  seedlingBank$Age <- seedlingBank$Age + 1 
  Z95adult <- species_parameter(seedlingBank$Species, SpParams, "Z95")
  if("RecrAge" %in% names(SpParams)) RecrAge <- species_parameter(seedlingBank$Species, SpParams, "RecrTreeDensity")
  if("recrAge" %in% names(control)) {
    RecrAge[is.na(RecrAge)] <- control$recrAge
  } else {
    RecrAge[is.na(RecrAge)] <- 5
  }
  seedlingBank$Z95 <- Z95adult*(seedlingBank$Age/RecrAge)
  seedlingBank$Z50 <- exp(log(seedlingBank$Z95)/1.4)
  if(control$truncateRootDistribution) {
    seedlingBank$Z100 <- exp(log(seedlingBank$Z95)/0.95);
  }
  return(seedlingBank)
}

.seedlings2recruits <- function(seedlingBank, SpParams, control) {
  
  # Get recruitment age (with back-compatibility)
  if("RecrAge" %in% names(SpParams)) RecrAge <- species_parameter(seedlingBank$Species, SpParams, "RecrTreeDensity")
  if("recrAge" %in% names(control)) {
    RecrAge[is.na(RecrAge)] <- control$recrAge
  } else {
    RecrAge[is.na(RecrAge)] <- 5
  }
  
  ## Determine if species can recruit 
  recruitment <- seedlingBank$Age >= RecrAge
  recrBank <- seedlingBank[recruitment, , drop = FALSE]
  if(length(recrBank$Species)>0) {
    isTree <- !(species_characterParameter(recrBank$Species, SpParams, "GrowthForm")=="Shrub")
  } else {
    isTree <- logical(0)
  }
  recrBankTree <- recrBank[isTree, , drop = FALSE]  
  recrBankShrub <- recrBank[!isTree, , drop = FALSE]  
  if(!control$shrubDynamics) {
    recrBankShrub <- recrBank[numeric(0), , drop = FALSE]
  }
  
  recr_forest <- emptyforest(ntree = nrow(recrBankTree), nshrub=nrow(recrBankShrub),
                             addcolumns = c("Z100", "Age", "ObsID"))
  
  if(nrow(recrBankTree)>0) {
    recr_forest$treeData$Species <- recrBankTree$Species
    recr_forest$treeData$N <- species_parameter(recrBankTree$Species, SpParams, "RecrTreeDensity")
    recr_forest$treeData$N[is.na(recr_forest$treeData$N)] <- control$recrTreeDensity
    recr_forest$treeData$N <- recr_forest$treeData$N*(recrBankTree$Percent/100.0) #Apply reduction due to seed bank size
    recr_forest$treeData$DBH <- species_parameter(recrBankTree$Species, SpParams, "RecrTreeDBH")
    recr_forest$treeData$DBH[is.na(recr_forest$treeData$DBH)] <- control$recrTreeDBH
    recr_forest$treeData$Height <- species_parameter(recrBankTree$Species, SpParams, "RecrTreeHeight")
    recr_forest$treeData$Height[is.na(recr_forest$treeData$Height)] <- control$recrTreeHeight
    recr_forest$treeData$Z50 <- recrBankTree$Z50
    recr_forest$treeData$Z95 <- recrBankTree$Z95
    recr_forest$treeData$Z100 <- recrBankTree$Z100
    recr_forest$treeData$Age <- recrBankTree$Age 
  }
  if(nrow(recrBankShrub)>0) {
    recr_forest$shrubData$Species <- recrBankTree$Species
    recr_forest$shrubData$Cover <- species_parameter(recrBankShrub$Species, SpParams, "RecrShrubCover")
    recr_forest$shrubData$Cover[is.na(recr_forest$shrubData$Cover)] <- control$recrShrubCover
    recr_forest$shrubData$Cover <- recr_forest$shrubData$Cover*(recrBankShrub$Percent/100.0) #Apply reduction due to seed bank size
    recr_forest$shrubData$Height <- species_parameter(recrBankShrub$Species, SpParams, "RecrShrubHeight")
    recr_forest$shrubData$Height[is.na(recr_forest$shrubData$Height)] <- control$recrShrubHeight
    recr_forest$shrubData$Z50 <- recrBankShrub$Z50
    recr_forest$shrubData$Z95 <- recrBankShrub$Z95
    recr_forest$shrubData$Z100 <- recrBankShrub$Z100
    recr_forest$shrubData$Age <- recrBankShrub$Age 
  }
  
  recr_forest$treeData <- recr_forest$treeData[recr_forest$treeData$N>0, ,drop=FALSE]
  recr_forest$shrubData <- recr_forest$shrubData[recr_forest$shrubData$Cover>0, ,drop=FALSE]
  
  
  if("herbData" %in% names(recr_forest)) recr_forest$herbData <- NULL
  if("herbCover" %in% names(recr_forest)) recr_forest$herbCover <- NULL
  if("herbHeight" %in% names(recr_forest)) recr_forest$herbHeight <- NULL
  if("seedBank" %in% names(recr_forest)) recr_forest$seedBank <- NULL
  if("litterData" %in% names(recr_forest)) recr_forest$litterData <- NULL
  
  #Remaining seedling bank
  recr_forest$seedlingBank <- seedlingBank[!recruitment, ,drop  = FALSE]
  
  return(recr_forest)
}

#' @rdname regeneration
#' @keywords internal
regeneration_recruitment<-function(forest, SpParams, control,
                      minMonthTemp, moistureIndex, verbose = FALSE) {
  
  seedlingBank <- regeneration_seedlings(forest, SpParams, control,
                                         minMonthTemp, moistureIndex, verbose)

  return(.seedlings2recruits(seedlingBank, SpParams, control))
}

#' @rdname regeneration
#' @param growthResult An object of class 'growth'.
#' @keywords internal
regeneration_recruitment_daily<-function(forest, SpParams, control,
                                         growthResult, verbose = FALSE) {
  
  seedlingBank <- regeneration_seedlings_daily(forest, SpParams, control,
                                               growthResult, verbose)
  
  return(.seedlings2recruits(seedlingBank, SpParams, control))
}


#' @rdname regeneration
#' 
#' @param internalMortality A data frame with mortality occurred in the last year of simulation. 
#' @param management_results The result of calling a management function (see \code{\link{defaultManagementFunction}}).
#' @keywords internal
regeneration_resprouting <- function(forest, internalMortality, SpParams, control, 
                                     management_results = NULL) {
  n_trees <- nrow(forest$treeData)
  n_shrubs <- nrow(forest$shrubData)
  
  ## Resprouting survivorship
  resp_clip_trees <- species_parameter(forest$treeData$Species, SpParams, "RespClip")
  resp_clip_trees[is.na(resp_clip_trees)] <- 0
  resp_clip_shrubs <- species_parameter(forest$shrubData$Species, SpParams, "RespClip")
  resp_clip_shrubs[is.na(resp_clip_shrubs)] <- 0
  
  # Resprouting survivorship (fire + dessication)
  N_resprouting_stumps <- internalMortality$N_resprouting_stumps
  if(n_trees>0) {
    # Resprouting vigor depends on cm2 of stump area
    N_resprouting <- N_resprouting_stumps[1:n_trees]*pi*(forest$treeData$DBH/2)^2*1.82*10^(-0.053*5) 
  } else { 
    N_resprouting <- numeric(0)
  }
  Cover_resprouting_stumps <- internalMortality$Cover_resprouting_stumps
  if(n_shrubs>0) {
    Cover_resprouting <- Cover_resprouting_stumps[(n_trees+1):(n_trees+n_shrubs)]
  } else {
    Cover_resprouting <- numeric(0)
  }
  if(!is.null(management_results)) { ## Add tree/shrub cuts
    N_surv_cut <- management_results$N_tree_cut*resp_clip_trees
    N_resprouting_cut <- N_surv_cut*pi*(forest$treeData$DBH/2)^2*1.82*10^(-0.053*5) 
    N_resprouting <- N_resprouting + N_resprouting_cut
    Cover_resprouting <- Cover_resprouting + management_results$Cover_shrub_cut*resp_clip_shrubs
  }
  
  # Copy forest to inherit species and belowground information
  resp_forest <- forest 
  resp_forest$treeData$N <- pmin(control$recrTreeDensity, N_resprouting) #Truncates maximum density to control variable
  
  resp_forest$treeData$DBH <- species_parameter(resp_forest$treeData$Species, SpParams, "RecrTreeDBH")
  resp_forest$treeData$DBH[is.na(resp_forest$treeData$DBH)] <- control$recrTreeDBH
  resp_forest$treeData$Height <- species_parameter(resp_forest$treeData$Species, SpParams, "RecrTreeHeight")
  resp_forest$treeData$Height[is.na(resp_forest$treeData$Height)] <- control$recrTreeHeight
  
  resp_forest$shrubData$Cover <- Cover_resprouting
  resp_forest$shrubData$Height <- species_parameter(resp_forest$shrubData$Species, SpParams, "RecrShrubHeight")
  resp_forest$shrubData$Height[is.na(resp_forest$shrubData$Height)] <- control$recrShrubHeight
  
  # Trim species with no resprouting
  resp_forest$treeData <- resp_forest$treeData[resp_forest$treeData$N > 0, , drop = FALSE]
  resp_forest$shrubData <- resp_forest$shrubData[resp_forest$shrubData$Cover > 0, , drop = FALSE]
  
  if("herbData" %in% names(resp_forest)) resp_forest$herbData <- NULL
  if("herbCover" %in% names(resp_forest)) resp_forest$herbCover <- NULL
  if("herbHeight" %in% names(resp_forest)) resp_forest$herbHeight <- NULL
  if("seedBank" %in% names(resp_forest)) resp_forest$seedBank <- NULL
  if("litterData" %in% names(resp_forest)) resp_forest$litterData <- NULL
  
  return(resp_forest)
}

#' Modify parameters
#' 
#' Routines to modify species parameter table or model input objects
#' 
#' @param x A model input object of class \code{\link{spwbInput}} or \code{\link{growthInput}}.
#' @param SpParams A species parameter data frame, typically \code{\link{SpParamsMED}}.
#' @param customParams A data frame or a named vector with new parameter values (see details).
#' @param subsetSpecies A logical flag to indicate that the output data frame should include only those species mentioned in \code{customParams}.
#' @param verbose A logical flag to indicate that messages should be printed on the console.
#' 
#' @details When calling function \code{modifySpParams}, \code{customParams} should be a data frame with as many rows as species 
#' and as many columns as parameters to modify, plus a column called 'Name' or 'Species' to match species names between the two tables. In both
#' cases, the function will match input strings with column 'Name' of \code{x}. Alternatively, \code{customParams} can contain a column 'SpIndex' for
#' matching of species indices, but this is deprecated. 
#' 
#' When calling \code{modifyCohortParams}, \code{customParams} can be a data frame with as many rows as cohorts 
#' and as many columns as parameters to modify, plus a column called 'Cohort' which will be matched with the cohort names 
#' given by \code{\link{spwbInput}} or \code{\link{growthInput}}. 
#' Alternatively, \code{customParams} can be a named list or named numeric vector as for \code{modifyInputParams}.
#' 
#' When calling \code{modifyInputParams}, \code{customParams} must be either a named list or a named numeric vector. 
#' Cohort parameters are specified using the syntax "\[cohortName\]/\[paramName\]" for names (e.g. "T2_176/Z50" to modify parameter 'Z50' of cohort 'T2_176'). 
#' Soil layer parameters are specified using the syntax "\[paramName\]@#layer" for names, where #layer is the layer index (e.g. "rfc@1" will modify the rock fragment content of soil layer 1). 
#' Control parameters are specified using either "\[paramName\]" (e.g "phloemConductanceFactor") or "\[paramName\]$\[subParamName\]" (e.g "maximumRelativeGrowthRates$leaf"). 
#' It may seem unnecessary to modify soil or control parameters via a function, but \code{modifyInputParams} is called from optimization functions (see \code{\link{optimization}}).
#'  
#' @return Function \code{modifySpParams} returns a modified species parameter data frame. 
#' 
#' Functions \code{modifyCohortParams} and \code{modifyInputParams} return a modified \code{\link{spwbInput}} or \code{\link{growthInput}} object. Note that modifications may affect other parameters beyond those indicated in \code{customParams}, as a result of parameter dependencies (see examples).
#' 
#' @author Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' @seealso \code{\link{spwbInput}}, \code{\link{SpParamsMED}}, \code{\link{optimization}}
#' 
#' @examples 
#' #Load example daily meteorological data
#' data(examplemeteo)
#' 
#' #Load example plot plant data
#' data(exampleforest)
#' 
#' #Default species parameterization
#' data(SpParamsMED)
#' 
#' #Define soil with default soil params (4 layers)
#' examplesoil <- defaultSoilParams(4)
#' 
#' #Initialize control parameters
#' control <- defaultControl("Granier")
#' 
#' #Initialize input
#' x1 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)
#' 
#' # Cohort name for Pinus halepensis
#' PH_coh <- paste0("T1_", SpParamsMED$SpIndex[SpParamsMED$Name=="Pinus halepensis"])
#' PH_coh 
#' 
#' # Modify Z50 and Z95 of Pinus halepensis cohort 
#' customParams <- c(200,2000)
#' names(customParams) <- paste0(PH_coh,c("/Z50", "/Z95"))
#' x1m <- modifyInputParams(x1, customParams)
#' 
#' # Inspect original and modified objects 
#' x1$below
#' x1m$below
#' 
#' # Inspect dependencies: fine root distribution across soil layers
#' x1$belowLayers$V
#' x1m$belowLayers$V
#' 
#' # Modify rock fragment content and sand proportion of soil layer 1
#' x1s <- modifyInputParams(x1, c("rfc@1" = 5, "sand@1" = 10))
#' 
#' # Inspect original and modified soils 
#' x1$soil
#' x1s$soil
#' 
#' # When modifying growth input objects dependencies increase
#' x1 <- growthInput(exampleforest,examplesoil, SpParamsMED, control)
#' customParams <- c(2000,2)
#' names(customParams) <- paste0(PH_coh,c("/Al2As", "/LAI_live"))
#' x1m <- modifyInputParams(x1, customParams)
#' 
#' @name modifyParams

#' @rdname modifyParams
modifySpParams<-function(SpParams, customParams, subsetSpecies = TRUE) {
  
  # check if customParams exists, if not return SpParams without modification
  if (is.null(customParams)) {
    return(SpParams)
  }
  
  # get the names of the custom params and the SpParams
  target_par <- names(customParams)
  fixed_cols <- c("Name", "SpIndex", "AcceptedName", "Species", "Genus", "Family", "Order","Group")
  target_par <- target_par[!(target_par %in% fixed_cols)]

  sp_par <- names(SpParams)
  
  # iterate between the custom params existing in SpParams
  for (param in target_par) {
    # check if the param exists in SpParams
    if (param %in% sp_par) {
      # iterate by species, in case same variable has different values by sp
      if("Name" %in% names(customParams)) {
        for (sp in customParams[['Name']]) {
          val <- customParams[which(customParams[['Name']] == sp), param][1]
          if(!is.na(val)) {
            SpParams[which(SpParams[['Name']] == sp), param] <- val
          }
        }
      } else if("Species" %in% names(customParams)) {
        for (sp in customParams[['Species']]) {
          val <- customParams[which(customParams[['Species']] == sp), param][1]
          if(!is.na(val)) {
            SpParams[which(SpParams[['Name']] == sp), param] <- val
          }
        }
      } else if ("SpIndex" %in% names(customParams)) {
        for (sp in customParams[['SpIndex']]) {
          val <- customParams[which(customParams[['SpIndex']] == sp), param][1]
          if(!is.na(val)) {
            SpParams[which(SpParams[['SpIndex']] == sp), param] <- val
          }
        }
      }
    }
  }
  # subset species
  if(subsetSpecies) {
    if("SpIndex" %in% names(customParams)) SpParams = SpParams[SpParams$SpIndex %in% customParams[['SpIndex']],]
    if("Species" %in% names(customParams)) SpParams = SpParams[SpParams$Name %in% customParams[['Species']],]
  }
  # return the new SpParams
  return(SpParams)
}

#' @rdname modifyParams
modifyCohortParams<-function(x, customParams, verbose = TRUE) {
  
  # check if customParams exists, if not return x without modification
  if (is.null(customParams)) {
    return(x)
  }
  # check class of customParams
  if((!inherits(customParams, "data.frame")) && (!inherits(customParams, "numeric")) && (!inherits(customParams, "list"))) {
    stop("'customParams' must be a named numeric vector, a list or a data frame")
  }
  
  # get the names of the custom params and the input tables
  custom <- names(customParams)
  above_par <- names(x[['above']])
  below_par <- c("Z50","Z95")
  pheno_par <- names(x[['paramsPhenology']])
  base_par <- names(x[['paramsInterception']])
  transp_par <- c(names(x[['paramsTranspiration']]), "VC_P50", "VC_c", "VC_d", "Vmax298_Jmax298")
  anatomy_par <- names(x[['paramsAnatomy']])
  waterstorage_par <- names(x[['paramsWaterStorage']])
  growth_par <- names(x[['paramsGrowth']])
  allom_par <- names(x[['paramsAllometries']])
  
  # clone object to modify
  x = .cloneInput(x)
  
  x_coh = row.names(x$cohorts)
  
  modifyParameterValue<-function(param, icoh, val) {
    if(!is.na(val)) {
      if(param %in% above_par) .modifyInputParam(x, "above", param, icoh - 1, val, verbose)
      if(param %in% below_par) .modifyInputParam(x, "below", param, icoh - 1, val, verbose) 
      if(param %in% base_par) .modifyInputParam(x, "paramsInterception", param, icoh - 1, val, verbose)
      if(param %in% transp_par) .modifyInputParam(x, "paramsTranspiration", param, icoh - 1, val, verbose) 
      if(param %in% anatomy_par)  .modifyInputParam(x, "paramsAnatomy", param, icoh - 1, val, verbose)
      if(!is.null(growth_par)) if (param %in% growth_par) .modifyInputParam(x, "paramsGrowth", param, icoh - 1, val, verbose)
      if(!is.null(allom_par)) if (param %in% allom_par) .modifyInputParam(x, "paramsAllometries", param, icoh - 1, val, verbose)
      if(!is.null(waterstorage_par)) if (param %in% waterstorage_par) .modifyInputParam(x, "paramsWaterStorage", param, icoh - 1, val, verbose)
    }
    return(x)
  }
  # iterate between the custom params
  if(inherits(customParams, "data.frame")) {
    if(sum(!(customParams[['Cohort']] %in% x_coh))>0) stop("Cohort names do not match between 'x' and 'customParams'")
    for (param in custom) {
      for (coh in customParams[['Cohort']]) {
        val <- customParams[customParams[['Cohort']] == coh, param]
        icoh <- which(x_coh==coh)
        modifyParameterValue(param, icoh, val)
      }
    }
  } 
  else { # assume a vector
    s <- strsplit(custom, "/")
    for(i in 1:length(s)) {
      paramCoh <- s[[i]]
      val <- customParams[[i]]
      coh <- paramCoh[[1]]
      if(!(coh %in% x_coh)) stop(paste0("Cohort '", coh,"' not found in 'x'"))
      icoh <- which(x_coh==coh)
      param <- paramCoh[[2]]
      # cat(paste0(coh, " ", param, " ", val,"\n"))
      modifyParameterValue(param, icoh, val)
    }
  }
  # return the modified input
  return(x)
}

#' @rdname modifyParams
modifyInputParams<-function(x, customParams, verbose = TRUE) {
  # check class of customParams
  if((!inherits(customParams, "numeric")) && (!inherits(customParams, "list"))) {
    stop("'customParams' must be a named numeric vector or a named list")
  }
  cn = names(customParams)
  isSoilParam = unlist(lapply(strsplit(cn, "@"), length))==2 #detect soil params
  isCohParam = unlist(lapply(strsplit(cn, "/"), length))==2 #detect cohort params
  customCohortParams = customParams[isCohParam]
  customSoilParams = customParams[isSoilParam]
  customControlParams = customParams[(!isCohParam) & (!isSoilParam)]
  # Modify control params
  if(length(customControlParams)>0) {
    for(i in 1:length(customControlParams)) {
      parName = names(customControlParams)[i]
      s = strsplit(parName, "\\$")[[1]]
      if(length(s)==1) {
        if(s %in% names(x[["control"]])) {
          x[["control"]][[s]] = customControlParams[[i]]
        } else {
          stop(paste0("Wrong control parameter name ", parName))
        }
      } else if(length(s)==2) {
        if((s[1] %in% names(x[["control"]])) && (s[2] %in% names(x[["control"]][[s[1]]]))) {
          x[["control"]][[s[1]]][[s[2]]] = customControlParams[[i]]
        } else {
          stop(paste0("Wrong control parameter name ", parName))
        }
      } else {
        stop(paste0("Wrong control parameter name ", parName))
      }
    }
  }
  # Modify cohort params
  if(length(customCohortParams)>0) {
    x = modifyCohortParams(x, customCohortParams, verbose)
  } else {
    x = .cloneInput(x)
  }
  # Modify soil layer params
  if(length(customSoilParams)>0) {
    s <- strsplit(names(customSoilParams), "@")
    for(i in 1:length(s)) {
      paramLayer <- s[[i]]
      val <- customSoilParams[[i]]
      param <- paramLayer[[1]]
      layer <- as.numeric(paramLayer[[2]])
      if(!(layer %in% 1:length(x$soil$widths))) stop(paste0("Soil layer '", layer,"' not found in 'x'"))
      .modifySoilLayerParam(x$soil, param, layer-1, val)
    }
    .updateBelow(x)
  }
  return(x)
}

#' Default forest management actions
#'
#' Function \code{defaultManagementFunction} implements actions for 'regular' and 'irregular' management models of monospecific or mixed stands, 
#' whereas function \code{defaultManagementArguments} returns a list with default values for the parameters regulating management. 
#' Both functions are meant to be used in simulations with \code{\link{fordyn}}.
#' 
#' @param x An object of class \code{\link{forest}}
#' @param args A list of arguments regulating management actions, e.g. the list returned by \code{defaultManagementArguments}
#' @param verbose A logical flag enabling console printing
#' 
#' @details This function implements silvicultural actions following either 'regular' or 'irregular' management models. 
#' Irregular models are implemented by executing thinning operations only, whereas regular models include both thinning and a set of final cuts. 
#' Thinning occurs anytime a stand-level metric (e.g. basal area) crosses a given threshold, and different kinds of thinning operations are allowed. 
#' Unrealistic high frequency thinning can be avoided by setting a minimum number of years to happen between thinning operations. 
#' Final cuts start whenever mean DBH exceeds a given threshold, and may include different cuts separated a number of years. 
#' The function can be applied to target management of specific taxa (instead of assuming a monospecific stand), but the thresholds that determine
#' thinning operations apply to stand-level metrics. Mean DBH will be calculated for the target species only.
#' Planting is only allowed under regular management models, and is applied after the last final cut. 
#' Understory clearings are assumed to occur anytime there is an intervention on trees, an only a residual shrub cover is left.
#' 
#' \emph{Thinning types}:
#'   \itemize{
#'     \item{\code{above}: Extract largest trees (according to DBH) until thinning objective is met.}
#'     \item{\code{below}: Extract smallest trees (according to DBH) until thinning objective is met.}
#'     \item{\code{systematic}: Extract equally from all size classes until thinning objective is met.}
#'     \item{\code{above-systematic}: Extract half the objective as systematic thinning and the other hald as above thinning.}
#'     \item{\code{below-systematic}: Extract half the objective as systematic thinning and the other hald as below thinning.}
#'     \item{\code{free string}: A string specifying the proportion of tree cuts from size classes, with size classes separated by "/" and each one composed of a number specifying the upper limit and a number indicating its proportion, separated by "-" (e.g. "10-50/40-30/60-20").}
#'   }
#' 
#' @return 
#' Function \code{defaultManagementFunction} returns a list with the following items:
#'   \itemize{
#'     \item{\code{"action"}: A string identifying the action performed (e.g. "thinning").}
#'     \item{\code{"N_tree_cut"}: A vector with the density of trees removed.}
#'     \item{\code{"Cover_shrub_cut"}: A vector with the cover of shrubs removed.} 
#'     \item{\code{"planted_forest"}: An object of class \code{\link{forest}} with the new plant cohorts resulting from tree/shrub planting.}
#'     \item{\code{"management_args"}: A list of management arguments to be used in the next call to the management function.}
#'   }
#' 
#' Function \code{defaultManagementArguments} returns a list with default arguments:
#'  \itemize{
#'    \item{\code{"type"}: Management model, either 'regular' or 'irregular'.}
#'    \item{\code{"targetTreeSpecies"}: Either \code{"all"} for unspecific cuttings or a numeric vector of target tree species to be selected for cutting operations.}
#'    \item{\code{"thinning"}: Kind of thinning to be applied in irregular models or in regular models before the final cuts. Options are 'below', 'above', 'systematic', 'below-systematic', 'above-systematic' or a string with the proportion of cuts to be applied to different diameter sizes (see details).}
#'    \item{\code{"thinningMetric"}: The stand-level metric used to decide whether thinning is applied, either 'BA' (basal area), 'N' (density) or 'HB' (Hart-Becking index).} 
#'    \item{\code{"thinningThreshold"}: The threshold value of the stand-level metric causing the thinning decision.}
#'    \item{\code{"thinningPerc"}: Percentage of stand's basal area to be removed in thinning operations.}
#'    \item{\code{"minThinningInterval"}: Minimum number of years between thinning operations.}
#'    \item{\code{"yearsSinceThinning"}: State variable to count the years since the last thinning ocurred.}
#'    \item{\code{"finalMeanDBH"}: Mean DBH threshold to start final cuts.}
#'    \item{\code{"finalPerc"}: String with percentages of basal area to be removed in final cuts, separated by '-' (e.g. "40-60-100").}
#'    \item{\code{"finalPreviousStage"}: Integer state variable to store the stage of final cuts ('0' before starting final cuts).}
#'    \item{\code{"finalYearsBetweenCuts"}: Number of years separating final cuts.}
#'    \item{\code{"finalYearsToCut"}: State variable to count the years to be passed before new final cut is applied.}
#'    \item{\code{"plantingSpecies"}: Species code to be planted. If missing, planting does not occur and only natural regeneration is allowed.}
#'    \item{\code{"plantingDBH"}: Initial DBH (cm) of planted species.}
#'    \item{\code{"plantingHeight"}: Initial height (cm) of planted species.}
#'    \item{\code{"plantingDensity"}: Initial density (ind./ha) of the planted species.}
#'    \item{\code{"understoryMaximumCover"}: Percentage of overall shrub cover to be left after any silvicultural intervention. 
#'    If missing, shrub cover will not be left unmodified.}
#'  }
#' 
#' @author 
#' Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
#' 
#' Aitor \enc{Améztegui}{Caceres}, UdL
#' 
#' Jose-Ramon Gonzalez Olabarria, CTFC
#' 
#' @seealso \code{\link{fordyn}}
#' 
#' @examples
#' # Load example forest object
#' data(exampleforest)
#'   
#' # Define arguments
#' args = defaultManagementArguments()
#'   
#' # Call management function
#' f = defaultManagementFunction(exampleforest, args)
#'   
#' #list names
#' names(f)
#'   
#' # Action performed
#' f$action
#'   
#' # Number of trees cut for each cohort
#' f$N_tree_cut
#'   
#' # Percent cover of shrubs removed
#' f$Cover_shrub_cut
#'   
#' @name defaultManagementFunction
defaultManagementFunction<-function(x, args, verbose = FALSE) {
  
  if(is.null(args)) stop("Please supply a list of management arguments")
  
  # Set missing final previous stage to 0
  if(is.na(args$finalPreviousStage)) args$finalPreviousStage = 0
  # If missing years since thinning, allow thinning by setting it equal to the minimum years for thinning
  if(is.na(args$yearsSinceThinning)) args$yearsSinceThinning = args$minThinningInterval
  
  ntree = nrow(x$treeData)
  nshrub = nrow(x$shrubData)
  # Initialize output data
  N_tree_cut = rep(0, ntree)
  Cover_shrub_cut = rep(0, nshrub)
  planted_forest = emptyforest()
  
  Ntotal = sum(x$treeData$N, na.rm=TRUE)
  BAtotal = stand_basalArea(x)
  
  if(length(args$targetTreeSpecies)==0) args$targetTreeSpecies = "all"
    
  if(args$targetTreeSpecies[1] == "all") {
    isTarget = rep(TRUE, ntree)
  } else {
    isTarget = (x$treeData$Species %in% args$targetTreeSpecies)
  }
  
  # Calculate mean DBH (of target species if specified)
  meanDBH = sum(x$treeData$N[isTarget] * x$treeData$DBH[isTarget], na.rm=TRUE)/sum(x$treeData$N[isTarget], na.rm=TRUE)
  
  action <- "none"

  if(args$type == "irregular") {
    action <- "thinning"
  } else if(args$type == "regular") {
    if(!is.na(meanDBH)) {
      if(is.na(args$finalMeanDBH)) stop("Argument 'finalMeanDBH' is missing in a regular management model.")
      if(verbose) cat(paste0("  mean DBH: ", round(meanDBH,1), " threshold ", args$finalMeanDBH))
      if(meanDBH > args$finalMeanDBH && args$finalPreviousStage==0) { # If meanDBH exceeds threshold start final cuts
        action <- "finalcut"
      } else if(args$finalPreviousStage>0) {
        if(args$finalYearsToCut==0) { # If we are in final cuts and this year needs cutting...
          action <- "finalcut"
        } else { # If we are in final cuts but we have to wait, decrease year by one
          args$finalYearsToCut <- args$finalYearsToCut - 1
        }
      } else {
        action <- "thinning"
      }
    } else {
      warning("Mean DBH for the target species is missing. Cannot apply management.")
    }
  }
  planting = FALSE
  
  if(verbose) cat(paste0("  action: ", action))
  
  if(action=="thinning") {
    thin = FALSE
    
    enoughYearsForThinning = (args$yearsSinceThinning >= args$minThinningInterval)

    if(args$thinningMetric=="BA") {
      if(verbose) cat(paste0("  Basal area: ", round(BAtotal,1), " threshold ", round(args$thinningThreshold)))
      if((BAtotal > args$thinningThreshold) && enoughYearsForThinning) thin = TRUE
    }
    else if(args$thinningMetric=="N") {
      if(verbose) cat(paste0("  Density: ", round(Ntotal,1), " threshold ", round(args$thinningThreshold)))
      if((Ntotal > args$thinningThreshold) && enoughYearsForThinning) thin = TRUE
    }
    else if(args$thinningMetric=="HB") {
      HB = stand_hartBeckingIndex(x)
      if(!is.na(HB)) { # HB can be missing if not enough trees > minDBH
        if(verbose) cat(paste0("  Hart-Becking: ", round(HB,1), " threshold ", round(args$thinningThreshold)))
        if((HB < args$thinningThreshold) && enoughYearsForThinning) thin = TRUE
      }
    }
    else {
      stop(paste0("Non-recognized thinning metric '", args$thinningMetric,"'.\n"))
    }
    if(thin && (sum(isTarget)>0)) {
      
      #DBH, N and N_cut of target trees
      dbhTarget = x$treeData$DBH[isTarget]
      nTarget = x$treeData$N[isTarget]
      nCutTarget = N_tree_cut[isTarget]
      
      BAtarget = sum(pi*(dbhTarget/200)^2*nTarget)
      
      # Cannot remove more than BA of target species
      BA2remove = min(BAtarget, BAtotal*(args$thinningPerc/100))
      BAremoved = 0
      args$yearsSinceThinning = 1
      
      if(verbose) cat(paste0(", type: ",args$thinning,", BA to extract: ", round(BA2remove,1), ", target cohorts: ", sum(isTarget)))
      
      if(args$thinning %in% c("below", "above")) {
        o = order(dbhTarget, decreasing = (args$thinning=="above"))
        cohort = 1
        while(BA2remove > 0) {
          r = (dbhTarget[o[cohort]]/200)
          n = nTarget[o[cohort]]
          BAcohort = pi*(r^2)*n
          if(BAcohort > BA2remove) {
            nCutTarget[o[cohort]] = BA2remove/(pi*(r^2))
            BA2remove = 0
          } else {
            nCutTarget[o[cohort]] = n
            BA2remove = BA2remove - BAcohort
          }
          cohort = cohort + 1
        }
      }
      else if (args$thinning%in% c("below-systematic", "above-systematic")) { #Cut half of target BA from below/above and the other half using trees from all diameters (keep current distribution)
        # Remove half as systematic
        sec = pi*(dbhTarget/200)^2
        propN  = nTarget/sum(nTarget)
        HalfBA2remove = BA2remove/2
        while(HalfBA2remove > 0) {
          if(sum(sec*propN)> HalfBA2remove) { # Correct to avoid cutting above existences
            propN = propN*(HalfBA2remove/sum(sec*propN))
          }
          nCutTarget = nCutTarget + propN
          HalfBA2remove = HalfBA2remove - sum(sec*propN)
        }
        BA2remove = BA2remove/2
        #Remove remaining as below/above
        o = order(dbhTarget, decreasing = (args$thinning=="above-systematic"))
        cohort = 1
        while(BA2remove > 0) {
          r = (dbhTarget[o[cohort]]/200)
          n = nTarget[o[cohort]] - nCutTarget[o[cohort]]
          BAcohort = pi*(r^2)*n
          if(BAcohort > BA2remove) {
            nCutTarget[o[cohort]] =  nCutTarget[o[cohort]] + BA2remove/(pi*(r^2))
            BA2remove = 0
          } else {
            nCutTarget[o[cohort]] = nCutTarget[o[cohort]]+n
            BA2remove = BA2remove - BAcohort
          }
          cohort = cohort + 1
        }
        #Copy cut vector of target trees to overall cut vector
        N_tree_cut[isTarget] = nCutTarget
      }
      else if (args$thinning=="systematic") { #Cut trees from all diameters (keep current distribution)
        sec = pi*(dbhTarget/200)^2
        propN  = nTarget/sum(nTarget)
        while(BA2remove > 0) {
          if(sum(sec*propN)> BA2remove) { # Correct to avoid cutting above existences
            propN = propN*(BA2remove/sum(sec*propN))
          }
          nCutTarget = nCutTarget + propN
          BA2remove = BA2remove - sum(sec*propN)
        }
        #Copy cut vector of target trees to overall cut vector
        N_tree_cut[isTarget] = nCutTarget
      }
      else {
        s = strsplit(args$thinning,"/")[[1]]
        # print(s)
        ncl = length(s)
        breaks = rep(0, ncl)
        props = rep(0, ncl)
        for(i in 1:ncl) {
          s2  = strsplit(s[i],"-")[[1]]
          breaks[i] = as.numeric(s2[1])
          props[i] = as.numeric(s2[2])
        }
        breaks[ncl] = max(breaks[ncl], max(dbhTarget)+1) # To include largest trees
        breaks = c(0, breaks)
        # print(breaks)
        props = props/sum(props)
        cl = as.numeric(cut(dbhTarget, breaks))
        propNmat = matrix(0, sum(isTarget), ncol = ncl)
        sec = pi*(dbhTarget/200)^2
        BAcl = rep(0, ncl)
        for(i in 1:ncl) {
          # print(sum(cl==i))
          propNmat[cl==i,i] = nTarget[cl==i]/sum(nTarget[cl==i])
          BAcl[i] = sum(sec[cl==i]*nTarget[cl==i])
        }
        # print(propNmat)
        BA2removecl = BA2remove*props
        # print(cbind(BA2removecl, BAcl))
        BA2removecl = pmin(BA2removecl, BAcl) # Do not allow to cut more than is available for a given class
        for(i in 1:ncl) {
          propN = propNmat[,i]
          while(BA2removecl[i] > 0) {
            if(sum(sec*propN)> BA2removecl[i]) { # Correct to avoid cutting above existences
              propN = propN*(BA2removecl[i]/sum(sec*propN))
            }
            nCutTarget = nCutTarget + propN
            BA2removecl[i] = BA2removecl[i] - sum(sec*propN)
          }
        }
      }
      
      #Copy cut vector of target trees to overall cut vector
      N_tree_cut[isTarget] = nCutTarget
    }
    else {
      action = "none"
      args$yearsSinceThinning = args$yearsSinceThinning + 1
      
    }
  }
  else if(action=="finalcut") {
    
    #DBH, N and N_cut of target trees
    dbhTarget = x$treeData$DBH[isTarget]
    nTarget = x$treeData$N[isTarget]
    nCutTarget = N_tree_cut[isTarget]
    
    BAtarget = sum(pi*(dbhTarget/200)^2*nTarget)
    
    #Proportions in different stages
    if(verbose) cat(paste0(", previous stage: ",args$finalPreviousStage))
    args$finalPreviousStage = args$finalPreviousStage + 1
    args$finalYearsToCut = args$finalYearsBetweenCuts
    props = as.numeric(strsplit(args$finalPerc,"-")[[1]])/100
    
    #BA to extract
    BA2remove = BAtarget*props[args$finalPreviousStage]
    
    if(verbose) cat(paste0(", % to extract: ", round(props[args$finalPreviousStage]*100),", BA to extract: ", round(BA2remove,1)))
    BAremoved = 0
    #Cut from above in final cuts
    o = order(dbhTarget, decreasing = TRUE)
    cohort = 1
    while((BA2remove > 0) && (cohort<=length(o))) {
      # print(BA2remove)
      d = dbhTarget[o[cohort]]
      r = (d/200)
      n = nTarget[o[cohort]]
      if((d > 12.5) || (!is.na(args$plantingSpecies))) { # Do not cut regeneration if there is no planting
        BAcohort = pi*(r^2)*n
        if(BAcohort > BA2remove) {
          nCutTarget[o[cohort]] = BA2remove/(pi*(r^2))
          BA2remove = 0
        } else {
          nCutTarget[o[cohort]] = n
          BA2remove = BA2remove - BAcohort
        }
      }
      cohort = cohort + 1
    }
    
    #Copy cut vector of target trees to overall cut vector
    N_tree_cut[isTarget] = nCutTarget
    
    if(args$finalPreviousStage==length(props)) {
      args$finalPreviousStage = 0
      if(!is.na(args$plantingSpecies)) planting = TRUE
    }
    if(verbose) cat(paste0(", final stage: ",args$finalPreviousStage))
  }
  
  # If tree felling occurred, apply understory clearing
  if(sum(N_tree_cut)>0) {
    understory_max_cover <- args$understoryMaximumCover
    if(!is.na(understory_max_cover)) {
      stand_shrub_cover = sum(x$shrubData$Cover, na.rm=TRUE)
      stand_to_rem = pmax(0,stand_shrub_cover - understory_max_cover)
      Cover_shrub_cut = x$shrubData$Cover*(stand_to_rem/stand_shrub_cover)
    }
  }
  # Apply planting if needed (regular management)
  if(planting) {
    action = paste0(action, " + planting")
    if(verbose) cat(paste0(", planting"))
    planted_forest = emptyforest(ntree=1)
    planted_forest$treeData$Species[1] = args$plantingSpecies
    planted_forest$treeData$DBH[1] = args$plantingDBH
    planted_forest$treeData$Height[1] = args$plantingHeight
    planted_forest$treeData$N[1] = args$plantingDensity
  }
  # Return
  return(list(action = action,
              N_tree_cut = N_tree_cut,
              Cover_shrub_cut = Cover_shrub_cut,
              planted_forest = planted_forest, 
              management_args = args))
}

#' @rdname defaultManagementFunction
defaultManagementArguments<-function(){
  return(list(
    type = "irregular",
    targetTreeSpecies = "all",
    thinning = "below", 
    thinningMetric = "BA", 
    thinningThreshold = 20,
    thinningPerc = 30,
    minThinningInterval = 10,
    yearsSinceThinning = NA,
    finalMeanDBH = 20, 
    finalPerc = "40-60-100",
    finalPreviousStage = 0,
    finalYearsBetweenCuts = 10,
    finalYearsToCut = NA,
    plantingSpecies = NA,  
    plantingDBH = 5, 
    plantingHeight = 5, 
    plantingDensity = 200,
    understoryMaximumCover = 3
  ))
}

#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

test_that("FCCS properties can be calculated", {
  expect_s3_class(fuel_FCCS(exampleforest, SpParamsMED), "data.frame")
})
  
test_that("FCCS behaviour can be calculated", {
  fccs_props <- fuel_FCCS(exampleforest, SpParamsMED)
  expect_type(fire_FCCS(fccs_props), "list")
})

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{light_basic}
\alias{light_basic}
\alias{light_PARcohort}
\alias{light_PARground}
\alias{light_SWRground}
\alias{light_cohortAbsorbedSWRFraction}
\title{Radiation extinction functions used in basic transpiration sub-model}
\usage{
light_PARcohort(x, SpParams, gdd = NA_real_)

light_PARground(x, SpParams, gdd = NA_real_)

light_SWRground(x, SpParams, gdd = NA_real_)

light_cohortAbsorbedSWRFraction(z, x, SpParams, gdd = NA_real_)
}
\arguments{
\item{x}{An object of class \code{\link{forest}}}

\item{SpParams}{A data frame with species parameters (see \code{\link{SpParamsMED}}).}

\item{gdd}{Growth degree days.}

\item{z}{A numeric vector with height values.}
}
\description{
Radiation extinction functions used in basic transpiration sub-model
}
\seealso{
\code{\link{spwb}}, \code{\link{light_advanced}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extract.R
\name{extract}
\alias{extract}
\title{Extracts model outputs}
\usage{
extract(
  x,
  level = "forest",
  output = NULL,
  vars = NULL,
  dates = NULL,
  subdaily = FALSE,
  addunits = FALSE
)
}
\arguments{
\item{x}{An object returned by simulation functions \code{\link{spwb}}, \code{\link{aspwb}}, \code{\link{pwb}}, \code{\link{growth}} or \code{\link{fordyn}}.}

\item{level}{Level of simulation output, either "forest" (stand-level results), "soillayer" (soil layer-level results), "cohort" (cohort-level results),
"sunlitleaf" or "shadeleaf" (leaf-level results)}

\item{output}{Section of the model output to be explored. See details.}

\item{vars}{Variables to be extracted (by default, all of them).}

\item{dates}{A date vector indicating the subset of simulated days for which output is desired.}

\item{subdaily}{A flag to indicate that subdaily values are desired (see details).}

\item{addunits}{A flag to indicate that variable units should be added whenever possible.}
}
\value{
Function \code{extract()} returns a data frame:
\itemize{
\item{If \code{level = "forest"}, columns are "date" and variable names.}
\item{If \code{level = "soillayer"}, columns are "date", "soillayer" and variable names.}
\item{If \code{level = "cohort"}, \code{level = "sunlitleaf"} or \code{level = "shadeleaf"}, columns are "date", "cohorts", "species" and variable names.}
\item{If \code{subdaily = TRUE}, columns are "datetime", "cohorts", "species" and variable names.}
}
}
\description{
Function \code{extract()} extracts daily or subdaily output and returns it as a tidy data frame.
}
\details{
When \code{subdaily = FALSE}, parameter \code{output} is used to restrict the section in \code{x} where variables are located. For
example \code{output = "Plants"} will correspond to variables "LAI", "LAIlive", "Transpiration", "StemPLC",... as returned by a call
\code{names(x$Plants)}.

Option \code{subdaily = TRUE} only works when simulations have been carried using control option 'subdailyResults = TRUE' (see \code{\link{defaultControl}}).
When using \code{subdaily = TRUE}, parameter \code{output} is not taken into account, and options for parameter \code{vars} are the following:
\itemize{
\item{Variables for \code{level = "forest"} or \code{level = "soillayer"}: Not allowed. An error is raised.}
\item{Variables for \code{level = "cohort"}: "E","Ag","An","dEdP","RootPsi","StemPsi","LeafPsi","StemPLC","StemRWC","LeafRWC","StemSympRWC","LeafSympRWC","PWB".}
\item{Variables for \code{level = "shadeleaf"} and \code{level="sunlitleaf"}: "Abs_SWR","Abs_PAR","Net_LWR","E","Ag","An","Ci","Gsw","VPD","Temp","Psi","iWUE".}
}
}
\examples{
#Load example daily meteorological data
data(examplemeteo)

#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Define soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

#Initialize control parameters
control <- defaultControl("Granier")

#Initialize input
x <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)

#Call simulation function (ten days)
S1<-spwb(x, examplemeteo[1:10, ], latitude = 41.82592, elevation = 100)

#Extracts daily forest-level output as a data frame
extract(S1, level = "forest", addunits = TRUE)

#Extracts daily soil layer-level output as a data frame
extract(S1, level = "soillayer", addunits = TRUE)

#Extracts daily cohort-level output as a data frame
extract(S1, level = "cohort", addunits = TRUE)

#Select the output tables/variables to be extracted
extract(S1, level ="cohort", output="Plants", vars = c("PlantStress", "StemPLC"))

}
\seealso{
\code{\link{summary.spwb}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{photo_photosynthesis}
\alias{photo_photosynthesis}
\alias{photo_photosynthesisBaldocchi}
\alias{photo_leafPhotosynthesisFunction}
\alias{photo_leafPhotosynthesisFunction2}
\alias{photo_sunshadePhotosynthesisFunction}
\alias{photo_multilayerPhotosynthesisFunction}
\alias{photo}
\alias{photo_GammaTemp}
\alias{photo_KmTemp}
\alias{photo_VmaxTemp}
\alias{photo_JmaxTemp}
\alias{photo_electronLimitedPhotosynthesis}
\alias{photo_rubiscoLimitedPhotosynthesis}
\title{Photosynthesis submodel functions}
\usage{
photo_photosynthesis(Q, Catm, Gc, Tleaf, Vmax298, Jmax298, verbose = FALSE)

photo_photosynthesisBaldocchi(
  Q,
  Catm,
  Tleaf,
  u,
  Vmax298,
  Jmax298,
  leafWidth,
  Gsw_AC_slope,
  Gsw_AC_intercept
)

photo_leafPhotosynthesisFunction(
  E,
  psiLeaf,
  Catm,
  Patm,
  Tair,
  vpa,
  u,
  absRad,
  Q,
  Vmax298,
  Jmax298,
  leafWidth = 1,
  refLeafArea = 1,
  verbose = FALSE
)

photo_leafPhotosynthesisFunction2(
  E,
  psiLeaf,
  Catm,
  Patm,
  Tair,
  vpa,
  u,
  SWRabs,
  LWRnet,
  Q,
  Vmax298,
  Jmax298,
  leafWidth = 1,
  refLeafArea = 1,
  verbose = FALSE
)

photo_sunshadePhotosynthesisFunction(
  E,
  psiLeaf,
  Catm,
  Patm,
  Tair,
  vpa,
  SLarea,
  SHarea,
  u,
  absRadSL,
  absRadSH,
  QSL,
  QSH,
  Vmax298SL,
  Vmax298SH,
  Jmax298SL,
  Jmax298SH,
  leafWidth = 1,
  verbose = FALSE
)

photo_multilayerPhotosynthesisFunction(
  E,
  psiLeaf,
  Catm,
  Patm,
  Tair,
  vpa,
  SLarea,
  SHarea,
  u,
  absRadSL,
  absRadSH,
  QSL,
  QSH,
  Vmax298,
  Jmax298,
  leafWidth = 1,
  verbose = FALSE
)

photo_GammaTemp(Tleaf)

photo_KmTemp(Tleaf, Oi)

photo_VmaxTemp(Vmax298, Tleaf)

photo_JmaxTemp(Jmax298, Tleaf)

photo_electronLimitedPhotosynthesis(Q, Ci, GT, Jmax)

photo_rubiscoLimitedPhotosynthesis(Ci, GT, Km, Vmax)
}
\arguments{
\item{Q}{Active photon flux density (micromol * s-1 * m-2).}

\item{Catm}{CO2 air concentration (micromol * mol-1).}

\item{Gc}{CO2 leaf (stomatal) conductance (mol * s-1 * m-2).}

\item{Tleaf}{Leaf temperature (in ºC).}

\item{Vmax298, Vmax298SL, Vmax298SH}{Maximum Rubisco carboxylation rate per leaf area at 298ºK (i.e. 25 ºC) (micromol\emph{s-1}m-2) (for each canopy layer in the case of \code{photo_multilayerPhotosynthesisFunction}). 'SH' stands for shade leaves, whereas 'SL' stands for sunlit leaves.}

\item{Jmax298, Jmax298SL, Jmax298SH}{Maximum electron transport rate per leaf area at 298ºK (i.e. 25 ºC) (micromol\emph{s-1}m-2) (for each canopy layer in the case of \code{photo_multilayerPhotosynthesisFunction}). 'SH' stands for shade leaves, whereas 'SL' stands for sunlit leaves.}

\item{verbose}{Boolean flag to indicate console output.}

\item{u}{Wind speed above the leaf boundary (in m/s) (for each canopy layer in the case of \code{photo_multilayerPhotosynthesisFunction}).}

\item{leafWidth}{Leaf width (in cm).}

\item{Gsw_AC_slope}{Slope of the An/C vs Gsw relationship}

\item{Gsw_AC_intercept}{Intercept of the An/C vs Gsw relationship}

\item{E}{Transpiration flow rate per leaf area (mmol\emph{s-1}m-2).}

\item{psiLeaf}{Leaf water potential (MPa).}

\item{Patm}{Atmospheric air pressure (in kPa).}

\item{Tair}{Air temperature (in ºC).}

\item{vpa}{Vapour pressure deficit (in kPa).}

\item{absRad}{Absorbed long- and short-wave radiation (in W*m^-2).}

\item{refLeafArea}{Leaf reference area.}

\item{SWRabs}{Absorbed short-wave radiation (in W·m-2).}

\item{LWRnet}{Net long-wave radiation balance (in W·m-2).}

\item{SLarea, SHarea}{Leaf area index of sunlit/shade leaves (for each canopy layer in the case of \code{photo_multilayerPhotosynthesisFunction}).}

\item{absRadSL, absRadSH}{Instantaneous absorbed radiation (W·m-2) per unit of sunlit/shade leaf area (for each canopy layer in the case of \code{photo_multilayerPhotosynthesisFunction}).}

\item{QSL, QSH}{Active photon flux density (micromol * s-1 * m-2) per unit of sunlit/shade leaf area (for each canopy layer in the case of \code{photo_multilayerPhotosynthesisFunction}).}

\item{Oi}{Oxigen concentration (mmol*mol-1).}

\item{Ci}{CO2 internal concentration (micromol * mol-1).}

\item{GT}{CO2 saturation point corrected by temperature (micromol * mol-1).}

\item{Jmax}{Maximum electron transport rate per leaf area (micromol\emph{s-1}m-2).}

\item{Km}{Km = Kc*(1.0+(Oi/Ko)) - Michaelis-Menten term corrected by temperature (in micromol * mol-1).}

\item{Vmax}{Maximum Rubisco carboxylation rate per leaf area (micromol\emph{s-1}m-2).}
}
\value{
Values returned for each function are:
\itemize{
\item{\code{photo_GammaTemp}: CO2 compensation concentration (micromol * mol-1).}
\item{\code{photo_KmTemp}: Michaelis-Menten coefficients of Rubisco for Carbon (micromol * mol-1) and Oxigen (mmol * mol-1).}
\item{\code{photo_VmaxTemp}: Temperature correction of Vmax298.}
\item{\code{photo_JmaxTemp}: Temperature correction of Jmax298.}
\item{\code{photo_electronLimitedPhotosynthesis}: Electron-limited photosynthesis (micromol\emph{s-1}m-2) following Farquhar et al. (1980).}
\item{\code{photo_rubiscoLimitedPhotosynthesis}: Rubisco-limited photosynthesis (micromol\emph{s-1}m-2) following Farquhar et al. (1980).}
\item{\code{photo_photosynthesis}: Calculates gross photosynthesis (micromol\emph{s-1}m-2) following (Farquhar et al. (1980) and Collatz et al (1991).}
\item{\code{photo_leafPhotosynthesisFunction}: Returns a data frame with the following columns:
\itemize{
\item{\code{LeafTemperature}: Leaf temperature (ºC).}
\item{\code{LeafVPD}: Leaf vapor pressure deficit (kPa).}
\item{\code{LeafCi}: Internal CO2 concentration (micromol * mol-1).}
\item{\code{Gsw}: Leaf stomatal conductance to water vapor (mol * s-1 * m-2).}
\item{\code{GrossPhotosynthesis}: Gross photosynthesis (micromol\emph{s-1}m-2).}
\item{\code{NetPhotosynthesis}: Net photosynthesis, after discounting autotrophic respiration (micromol\emph{s-1}m-2).}
}
}
\item{\code{photo_sunshadePhotosynthesisFunction}: Returns a data frame with the following columns:
\itemize{
\item{\code{GrossPhotosynthesis}: Gross photosynthesis (micromol\emph{s-1}m-2).}
\item{\code{NetPhotosynthesis}: Net photosynthesis, after discounting autotrophic respiration (micromol\emph{s-1}m-2).}
\item{\code{LeafCiSL}: Sunlit leaf internal CO2 concentration (micromol * mol-1).}
\item{\code{LeafCiSH}: Shade leaf internal CO2 concentration (micromol * mol-1).}
\item{\code{LeafTempSL}: Sunlit leaf temperature (ºC).}
\item{\code{LeafTempSH}: Shade leaf temperature (ºC).}
\item{\code{LeafVPDSL}: Sunlit leaf vapor pressure deficit (kPa).}
\item{\code{LeafVPDSH}: Shade leaf vapor pressure deficit (kPa).}
}
}
\item{\code{photo_multilayerPhotosynthesisFunction}: Return a data frame with the following columns:
\itemize{
\item{\code{GrossPhotosynthesis}: Gross photosynthesis (micromol\emph{s-1}m-2).}
\item{\code{NetPhotosynthesis}: Net photosynthesis, after discounting autotrophic respiration (micromol\emph{s-1}m-2).}
}
}
}
}
\description{
Set of functions used in the calculation of photosynthesis
}
\details{
Details of the photosynthesis submodel are given in the medfate book
}
\references{
Bernacchi, C. J., E. L. Singsaas, C. Pimentel, A. R. Portis, and S. P. Long. 2001. Improved temperature response functions for models of Rubisco-limited photosynthesis. Plant, Cell and Environment 24:253–259.

Collatz, G. J., J. T. Ball, C. Grivet, and J. A. Berry. 1991. Physiological and environmental regulation of stomatal conductance, photosynthesis and transpiration: a model that includes a laminar boundary layer. Agricultural and Forest Meteorology 54:107–136.

Farquhar, G. D., S. von Caemmerer, and J. A. Berry. 1980. A biochemical model of photosynthetic CO2 assimilation in leaves of C3 species. Planta 149:78–90.

Leuning, R. 2002. Temperature dependence of two parameters in a photosynthesis model. Plant, Cell and Environment 25:1205–1210.

Sperry, J. S., M. D. Venturas, W. R. L. Anderegg, M. Mencuccini, D. S. Mackay, Y. Wang, and D. M. Love. 2016. Predicting stomatal responses to the environment from the optimization of photosynthetic gain and hydraulic cost. Plant Cell and Environment.
}
\seealso{
\code{\link{hydraulics_supplyFunctionNetwork}}, \code{\link{biophysics_leafTemperature}}, \code{\link{spwb}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{plant_values}
\alias{plant_values}
\alias{plant_ID}
\alias{plant_basalArea}
\alias{plant_largerTreeBasalArea}
\alias{plant_cover}
\alias{plant_species}
\alias{plant_speciesName}
\alias{plant_density}
\alias{plant_height}
\alias{plant_individualArea}
\alias{plant_crownRatio}
\alias{plant_crownBaseHeight}
\alias{plant_crownLength}
\alias{plant_foliarBiomass}
\alias{plant_fuelLoading}
\alias{plant_equilibriumLeafLitter}
\alias{plant_equilibriumSmallBranchLitter}
\alias{plant_phytovolume}
\alias{plant_LAI}
\alias{plant_characterParameter}
\alias{plant_parameter}
\title{Woody plant cohort description functions}
\usage{
plant_ID(x, SpParams, treeOffset = 0L, shrubOffset = 0L, herbOffset = 0L)

plant_basalArea(x, SpParams)

plant_largerTreeBasalArea(x, SpParams, self_proportion = 0.5)

plant_cover(x, SpParams)

plant_species(x, SpParams)

plant_speciesName(x, SpParams)

plant_density(x, SpParams)

plant_height(x, SpParams)

plant_individualArea(x, SpParams)

plant_crownRatio(x, SpParams)

plant_crownBaseHeight(x, SpParams)

plant_crownLength(x, SpParams)

plant_foliarBiomass(x, SpParams, gdd = NA_real_, competitionEffect = TRUE)

plant_fuelLoading(x, SpParams, gdd = NA_real_, includeDead = TRUE)

plant_equilibriumLeafLitter(x, SpParams, AET = 800)

plant_equilibriumSmallBranchLitter(
  x,
  SpParams,
  smallBranchDecompositionRate = 0.81
)

plant_phytovolume(x, SpParams)

plant_LAI(
  x,
  SpParams,
  gdd = NA_real_,
  bounded = TRUE,
  competitionEffect = TRUE
)

plant_characterParameter(x, SpParams, parName)

plant_parameter(x, SpParams, parName, fillMissing = TRUE, fillWithGenus = TRUE)
}
\arguments{
\item{x}{An object of class \code{\link{forest}}.}

\item{SpParams}{A data frame with species parameters (see \code{\link{SpParamsMED}}).}

\item{treeOffset, shrubOffset, herbOffset}{Integers to offset cohort IDs.}

\item{self_proportion}{Proportion of the target cohort included in the assessment}

\item{gdd}{Growth degree days (to account for leaf phenology effects).}

\item{competitionEffect}{Logical flag to indicate the inclusion of competition effect on LAI estimates.}

\item{includeDead}{A flag to indicate that standing dead fuels (dead branches) are included.}

\item{AET}{Actual annual evapotranspiration (in mm).}

\item{smallBranchDecompositionRate}{Decomposition rate of small branches.}

\item{bounded}{A boolean flag to indicate that extreme values should be prevented (maximum tree LAI = 7 and maximum shrub LAI = 3)}

\item{parName}{A string with a parameter name.}

\item{fillMissing}{A boolean flag to try imputation on missing values.}

\item{fillWithGenus}{A boolean flag to try imputation of missing values using genus values.}
}
\value{
A vector with values for each woody plant cohort of the input \code{\link{forest}} object:
\itemize{
\item{\code{plant_basalArea}: Tree basal area (m2/ha).}
\item{\code{plant_largerTreeBasalArea}: Basal area (m2/ha) of trees larger (in diameter) than the tree. Half of the trees of the same record are included.}
\item{\code{plant_characterParameter}: The parameter values of each plant, as strings.}
\item{\code{plant_cover}: Shrub cover (in percent).}
\item{\code{plant_crownBaseHeight}: The height corresponding to the start of the crown (in cm).}
\item{\code{plant_crownLength}: The difference between crown base height and total height (in cm).}
\item{\code{plant_crownRatio}: The ratio between crown length and total height (between 0 and 1).}
\item{\code{plant_density}: Plant density (ind/ha). Tree density is directly taken from the forest object, while the shrub density is estimated from cover and height by calculating the area of a single individual.}
\item{\code{plant_equilibriumLeafLitter}: Litter biomass of leaves at equilibrium (in kg/m2).}
\item{\code{plant_equilibriumSmallBranchLitter}: Litter biomass of small branches (< 6.35 mm diameter) at equilibrium (in kg/m2).}
\item{\code{plant_foliarBiomass}: Standing biomass of leaves (in kg/m2).}
\item{\code{plant_fuelLoading}: Fine fuel load (in kg/m2).}
\item{\code{plant_height}: Total height (in cm).}
\item{\code{plant_ID}: Cohort coding for simulation functions (concatenation of 'T' (Trees) or 'S' (Shrub), cohort index and species index).}
\item{\code{plant_LAI}: Leaf area index (m2/m2).}
\item{\code{plant_individualArea}: Area (m2) occupied by a shrub individual.}
\item{\code{plant_parameter}: The parameter values of each plant, as numeric.}
\item{\code{plant_phytovolume}: Shrub phytovolume (m3/m2).}
\item{\code{plant_species}: Species identity integer (indices start with 0).}
\item{\code{plant_speciesName}: String with species taxonomic name (or a functional group).}
}
}
\description{
Functions to calculate attributes of woody plants in a \code{\link{forest}} object.
}
\examples{
#Default species parameterization
data(SpParamsMED)

#Load example plot
data(exampleforest)

#A plant-level way to obtain stand basal area
sum(plant_basalArea(exampleforest, SpParamsMED), na.rm=TRUE)

#The analogous plant-level function for LAI
sum(plant_LAI(exampleforest, SpParamsMED))
  
#The analogous plant-level function for fuel loading
sum(plant_fuelLoading(exampleforest, SpParamsMED))
      
#Summary function for 'forest' objects can be also used
summary(exampleforest, SpParamsMED)

#Cohort IDs in the models
plant_ID(exampleforest, SpParamsMED)
      
}
\seealso{
\code{\link{spwb}}, \code{\link{forest}}, \code{\link{summary.forest}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/emptyforest.R
\name{emptyforest}
\alias{emptyforest}
\title{Creation of an empty forest}
\usage{
emptyforest(
  ntree = 0,
  nshrub = 0,
  nherb = 0,
  nseedling = 0,
  nseed = 0,
  nsnag = 0,
  nlitter = 0,
  addcolumns = NULL,
  SOC = FALSE
)
}
\arguments{
\item{ntree, nshrub, nherb}{Number of tree, shrub and herb cohorts, respectively.}

\item{nseedling}{Number of species in the seedling bank.}

\item{nseed}{Number of species in the seed bank.}

\item{nsnag}{Number of snag (dead standing) cohorts.}

\item{nlitter}{Number of items in the litter compartment.}

\item{addcolumns}{A character vector with additional columns. Currently allowed are (see \code{\link{forest}}):
\itemize{
\item{\code{Z100}: A numeric vector with maximum rooting depth in mm.}
\item{\code{LAI}: Leaf area index (m2/m2).}
\item{\code{FoliarBiomass}: Standing dry biomass of leaves (kg/m2).}
\item{\code{FuelLoading}: Fine fuel loading (kg/m2).}
\item{\code{CrownRatio}: The ratio between crown length and total height (between 0 and 1)}
\item{\code{Age}: A numeric vector indicating age of cohorts in years.}
\item{\code{ObsID} A character vector to label specific cohorts in simulations of forest dynamics.}
}}

\item{SOC}{A boolean flag to initialize SOC data (see \code{\link{forest}}).}
}
\value{
An empty \code{\link{forest}} object.
}
\description{
Creates an empty \code{\link{forest}} object.
}
\details{
List elements \code{treeData} and \code{shrubData} are always created, regardless of the number of cohorts.
In contrast, list elements \code{herbData}, \code{seedBank} and \code{seedlingBank} are only created if \code{nherb}, \code{nseed} and \code{nseedling} are non-zero, respectively.
}
\examples{
# Initializes forest with 2 tree cohorts
emptyforest(ntree = 2)

# Initializes forest with 2 tree cohorts and 1 shrub cohort
emptyforest(ntree = 2, nshrub = 1)

# Initializes with extra column for leaf area index (LAI)
emptyforest(ntree = 2, nshrub = 1, addcolumns = "LAI")

# Initializes forest with 2 tree cohorts, 1 shrub cohort and 1 herbaceous cohort
emptyforest(ntree = 2, nshrub = 1, nherb = 1)
}
\seealso{
\code{\link{forest}}, \code{\link{tree2forest}}, \code{\link{summary.forest}}, \code{\link{forest_mapWoodyTables}},  \code{\link{forest_mergeTrees}},
\code{\link{plot.forest}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.soil.R
\name{soil_retentionCurvePlot}
\alias{soil_retentionCurvePlot}
\alias{soil_conductivityCurvePlot}
\title{Soil water retention and conductivity plots}
\usage{
soil_retentionCurvePlot(
  soil,
  model = "SX",
  layer = 1,
  psi = seq(0, -6, by = -0.01),
  relative = TRUE,
  to = "SAT"
)

soil_conductivityCurvePlot(
  soil,
  model = "SX",
  layer = 1,
  psi = seq(0, -6, by = -0.01),
  relative = TRUE,
  to = "SAT",
  log = TRUE,
  mmol = TRUE
)
}
\arguments{
\item{soil}{Initialized soil object (returned by function \code{\link{soil}}).}

\item{model}{model Either 'SX' or 'VG' for Saxton's or Van Genuchten's water retention models; or 'both' to plot both retention models.}

\item{layer}{Soil layer to be plotted.}

\item{psi}{A numeric vector specifying a sequence of water potential values.}

\item{relative}{Boolean flag to indicate that retention curve should be relative to field capacity or saturation.}

\item{to}{Either 'SAT' (saturation) or 'FC' (field capacity).}

\item{log}{Boolean to display the y-axis in logarithm units}

\item{mmol}{Boolean flag to indicate that saturated conductivity units should be returned in mmol/m/s/MPa. If \code{mmol = FALSE} then units are cm/day.}
}
\value{
An object of class ggplot.
}
\description{
Internal functions to display water retention curves and conductivity curves.
}
\details{
\itemize{
\item{\code{soil_retentionCurvePlot()} allows plotting the water retention curve of a given soil layer.}
\item{\code{soil_conductivityCurvePlot()} allows plotting the conductivity curve of a given soil layer.}
}
}
\seealso{
\code{\link{soil_texture}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.forest.R
\name{plot.forest}
\alias{plot.forest}
\alias{shinyplot.forest}
\title{Plot forest attributes}
\usage{
\method{plot}{forest}(
  x,
  SpParams,
  type = "LeafAreaDensity",
  byCohorts = FALSE,
  bySpecies = FALSE,
  includeHerbs = FALSE,
  ...
)

\method{shinyplot}{forest}(x, SpParams, ...)
}
\arguments{
\item{x}{An object of class \code{\link{forest}}.}

\item{SpParams}{A data frame with species parameters (see \code{\link{SpParamsMED}}).}

\item{type}{A string of the plot type: "LeafAreaDensity", "RootDistribution", "FuelBulkDensity", "PARExtinction", "SWRExtinction" or "WindExtinction".}

\item{byCohorts}{A logical flag to separate profiles for each cohort.}

\item{bySpecies}{A logical flag to aggregate results by species.}

\item{includeHerbs}{A logical flag to include herbaceous layer in the profile.}

\item{\dots}{Additional parameters to vertical profiles}
}
\value{
A ggplot or a shiny application, depending on the function.
}
\description{
Function for plotting vertical forest profiles.
}
\details{
The function is a common wrapper to specialized internal functions (see \code{\link{vprofile_leafAreaDensity}}).
}
\examples{
data(exampleforest)
data(SpParamsMED)
plot(exampleforest, SpParamsMED)

}
\seealso{
\code{\link{forest}}, \code{\link{summary.forest}}, \code{\link{vprofile_leafAreaDensity}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summary.forest.R
\name{summary.forest}
\alias{summary.forest}
\alias{print.summary.forest}
\title{Summary of forest structure}
\usage{
\method{summary}{forest}(object, SpParams, ...)

\method{print}{summary.forest}(x, digits = getOption("digits"), ...)
}
\arguments{
\item{object}{An object of class \code{\link{forest}}}

\item{SpParams}{A data frame with species parameters (see \code{\link{SpParamsMED}}).}

\item{...}{Additional parameters for functions \code{\link{summary}} and \code{\link{print}}.}

\item{x}{The object returned by \code{summary.forest}.}

\item{digits}{Minimal number of significant digits.}
}
\value{
Function \code{summary.forest} returns a list with several structural attributes, such as the basal area and LAI of the forest.
}
\description{
Displays a summary of forest structure
}
\details{
Function \code{summary.forest} can be used to summarize a \code{forest} object in the console.
}
\examples{
# Summary of example forests
summary(exampleforest, SpParamsMED)
summary(exampleforest2, SpParamsMED)

}
\seealso{
\code{\link{forest}}, \code{\link{forest_mapWoodyTables}},  \code{\link{forest_mergeTrees}},
\code{\link{plot.forest}}, \code{\link{tree2forest}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dataset_documentation.R
\docType{data}
\name{examplemeteo}
\alias{examplemeteo}
\title{Example daily meteorology data}
\format{
A data frame containing daily meteorology of a location in Catalonia (Spain) for year 2001:
\describe{
\item{\code{dates}}{Vector of \code{\link{Date}} objects.}
\item{\code{MinTemperature}}{Minimum daily temperature (in degrees Celsius).}
\item{\code{MaxTemperature}}{Maximum daily temperature (in degrees Celsius).}
\item{\code{Precipitation}}{Daily precipitation (in mm of water).}
\item{\code{MinRelativeHumidity}}{Minimum daily relative humidity (in percent).}
\item{\code{MaxRelativeHumidity}}{Maximum daily relative humidity (in percent).}
\item{\code{Radiation}}{Incoming radiation (in MJ/m2).}
\item{\code{WindSpeed}}{Wind speed (in m/s).}
}
}
\source{
Interpolated from weather station data (Spanish and Catalan meteorology agencies) using package 'meteoland'.
}
\description{
Example data set of meteorological input.
}
\examples{
 data(examplemeteo)
}
\seealso{
\code{\link{spwb}}
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree2forest.R
\name{tree2forest}
\alias{tree2forest}
\alias{shrub2forest}
\title{Single-cohort forests}
\usage{
tree2forest(
  Species,
  Height,
  LAI = NA,
  N = NA,
  DBH = NA,
  Z50 = NA,
  Z95 = NA,
  Z100 = NA,
  CrownRatio = NA,
  FoliarBiomass = NA,
  FuelLoading = NA
)

shrub2forest(
  Species,
  Height,
  LAI = NA,
  Cover = NA,
  Z50 = NA,
  Z95 = NA,
  Z100 = NA,
  CrownRatio = NA,
  FoliarBiomass = NA,
  FuelLoading = NA
)
}
\arguments{
\item{Species}{String with species (taxon) name or a non-negative integer for species identity (i.e., 0,1,2,...) matching SpParams.}

\item{Height}{Plant height (cm).}

\item{LAI}{Leaf area index (m2/m2)}

\item{N}{Tree density (ind/ha)}

\item{DBH}{Tree DBH (cm).}

\item{Z50}{Depth (in mm) corresponding to 50\% of fine roots.}

\item{Z95}{Depth (in mm) corresponding to 95\% of fine roots.}

\item{Z100}{Depth (in mm) corresponding to 100\% of fine roots.}

\item{CrownRatio}{Crown ratio (fraction of total height)}

\item{FoliarBiomass}{Standing dry biomass of leaves (kg/m2)}

\item{FuelLoading}{Fine fuel loading (kg/m2)}

\item{Cover}{Percent cover}
}
\value{
An object of class \code{\link{forest}}
}
\description{
Creates a \code{\link{forest}} object with a single plant cohort
}
\examples{

oak_forest <-tree2forest("Quercus ilex", Height= 200, LAI = 2)
oak_forest

}
\seealso{
\code{\link{forest}}, \code{\link{emptyforest}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils_rockOptimization.R
\name{utils_rockOptimization}
\alias{utils_rockOptimization}
\title{Optimization of rock fragment content}
\usage{
utils_rockOptimization(
  x,
  soil,
  SpParams,
  control,
  meteo,
  PLCquantile = 0.9,
  qPLC_target = 12,
  qPLC_tol = 0.5,
  sew_min = 30,
  max_rocks = 99,
  verbose = FALSE,
  ...
)
}
\arguments{
\item{x}{An object of class \code{\link[medfate]{forest}}.}

\item{soil}{An object of class \code{\link{data.frame}} or \code{\link[medfate]{soil}}, containing soil parameters per soil layer.}

\item{SpParams}{A data frame with species parameters (see \code{\link[medfate]{SpParamsDefinition}} and \code{\link[medfate]{SpParamsMED}}).}

\item{control}{A list with default control parameters (see \code{\link[medfate]{defaultControl}}).}

\item{meteo}{A data frame with daily meteorological data series (see \code{\link[medfate]{spwb}}).}

\item{PLCquantile}{Maximum PLC quantile to be calculated across years.}

\item{qPLC_target}{Target PLC to be achieved (by default 12\%).}

\item{qPLC_tol}{Tolerance of PLC difference to target accepted when finding solution.}

\item{sew_min}{Minimum soil extractable water (mm) for rock exploration.}

\item{max_rocks}{Maximum content in coarse fragments allowed for any soil layer.}

\item{verbose}{A logical value. Print the internal messages of the function?}

\item{...}{Additional parameters to function \code{\link[medfate]{spwb}}.}
}
\value{
Function \code{utils_rockOptimization} returns a list containing:
\itemize{
\item{\code{RFC}: A vector with the estimated rock fragment content for each soil layer.}
\item{\code{SEW}: Soil extractable water (mm).}
\item{\code{runs}: Number of simulations performed.}
\item{\code{message}: Text message indicating whether optimization could be done (OK) or not.}
}
}
\description{
Function \code{utils_rockOptimization} finds optimum rock fragment content in the soil
corresponding to given vegetation, weather and target percent loss
of conductance (PLC), following a modification of the method proposed by Druel et al. (2023).
}
\details{
The function performs a model inversion based on an ecohydrological assumption,
consisting in that forest leaf area index is in equilibrium with a low embolism
rate under normal conditions. This is translated in that the (by default 90\%) interannual quantile of
the maximum annual percent loss of conductance (PLC), averaged over plant cohorts,
should be close to a target PLC value (by default 12\%).

The algorithm first determines the PLC corresponding to the minimum and maximum soil extractable water (SEW).
The minimum SEW (SEW_min) is an input parameter, whereas the maximum SEW (SEW_max) corresponds to no rock fragments in the soil.

Then three situations are distinguished:
\enumerate{
\item{If \code{PLC(SEW_min) < qPLC_target}  and \code{PLC(SEW_max) < qPLC_target}, the function will use \code{\link{uniroot}} to find the root
of the function \code{f(x) = PLC(x) - qPLC_target}, where \code{x} is SEW, which corresponds to a factor that multiplies the original rock fragment content.}
\item{If both \code{PLC(SEW_min) < qPLC_target} and \code{PLC(SEW_max) < qPLC_target}, the function cannot find an optimum, because PLC is always too low, and will return the original rock fragment content}
\item{Analogously, if both \code{PLC(SEW_min) > qPLC_target} and \code{PLC(SEW_max) > qPLC_target}, the function cannot find an optimum, because PLC is always too large, and will return the original rock fragment content}
}
}
\examples{
\donttest{
#Load example daily meteorological data
data(examplemeteo)

#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Initialize soil with two layers
examplesoil <- defaultSoilParams(4)

#Rock fragment content optimization (Granier)
utils_rockOptimization(exampleforest, soil = examplesoil,
                       SpParams = SpParamsMED, meteo = examplemeteo,
                       control = defaultControl("Granier"),
                       elevation = 100, latitude = 41.82592)
}
}
\references{
Druel, A., Martins, N., Cochard, H., De Caceres, M., Delzon, S., Mencuccini, M., Torres-Ruiz, J., and Ruffault, J.: European forest vulnerability to hydraulic failure: an ecohydrological approach, EGU General Assembly 2023, Vienna, Austria, 24–28 Apr 2023, EGU23-17068, https://doi.org/10.5194/egusphere-egu23-17068, 2023.
}
\seealso{
\code{\link{spwb}}, \code{\link{soil}}, \code{\link{utils_ldrOptimization}}
}
\author{
\enc{Arsène}{Arsene} Druel, URFM-INRAE

Nicolas Martin-StPaul, URFM-INRAE

Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R, R/stand_metrics.R
\name{stand_basalArea}
\alias{stand_basalArea}
\alias{stand_foliarBiomass}
\alias{stand_fuelLoading}
\alias{stand_shrubVolume}
\alias{stand_LAI}
\alias{stand_values}
\alias{stand_dominantTreeDiameter}
\alias{stand_treeDensity}
\alias{stand_meanTreeHeight}
\alias{stand_dominantTreeHeight}
\alias{stand_hartBeckingIndex}
\alias{stand_quadraticMeanTreeDiameter}
\alias{stand_dominantTreeSpecies}
\title{Stand values}
\usage{
stand_basalArea(x, minDBH = 7.5)

stand_foliarBiomass(x, SpParams, gdd = NA_real_)

stand_fuelLoading(x, SpParams, gdd = NA_real_, includeDead = TRUE)

stand_shrubVolume(x, SpParams)

stand_LAI(x, SpParams, gdd = NA_real_, bounded = TRUE)

stand_dominantTreeDiameter(x, minDBH = 7.5)

stand_treeDensity(x, minDBH = 7.5)

stand_meanTreeHeight(x, minDBH = 7.5)

stand_dominantTreeHeight(x, minDBH = 7.5)

stand_hartBeckingIndex(x, minDBH = 7.5)

stand_quadraticMeanTreeDiameter(x, minDBH = 7.5)

stand_dominantTreeSpecies(x, SpParams)
}
\arguments{
\item{x}{An object of class \code{\link{forest}}.}

\item{minDBH}{Minimum diameter at breast height (in cm) to include in estimation.}

\item{SpParams}{A data frame with species parameters (see \code{\link{SpParamsMED}}).}

\item{gdd}{Growth degree days (to account for leaf phenology effects).}

\item{includeDead}{A flag to indicate that standing dead fuels (dead branches) are included.}

\item{bounded}{A boolean flag to indicate that extreme values should be prevented (maximum tree LAI = 7 and maximum shrub LAI = 3)}
}
\value{
\itemize{
\item{\code{stand_basalArea}: Stand basal area (m2/ha).}
\item{\code{stand_treeDensity}: Stand tree density (in ind/ha).}
\item{\code{stand_dominantTreeDiameter}: Dominant tree diameter, i.e the average diameter of the 100 widest trees (in cm).}
\item{\code{stand_quadraticMeanTreeDiameter}: Quadratic mean tree diameter, i.e. the diameter value corresponding to the current basal area and density.}
\item{\code{stand_meanTreeHeight}: Mean tree height (in cm).}
\item{\code{stand_dominantTreeHeight}: Dominant tree height, i.e the average height of the 100 tallest trees (in cm).}
\item{\code{stand_dominantTreeSpecies}: Dominant tree species name, determined in terms of basal area (and considering all tree sizes).}
\item{\code{stand_hartBeckingIndex}: Hart-Becking index.}
\item{\code{stand_foliarBiomass}: Standing biomass of leaves (in kg/m2).}
\item{\code{stand_fuel}: Stand fine fuel load (in kg/m2).}
\item{\code{stand_LAI}: Stand leaf area index (m2/m2).}
\item{\code{stand_shrubVolume}: Stand shrub phytovolume (m3/m2).}
}
}
\description{
Functions to calculate stand attributes of a \code{\link{forest}} object.
}
\examples{
#Default species parameterization
data(SpParamsMED)
  
#Load example plot
data(exampleforest)
    
#A short way to obtain total basal area
stand_basalArea(exampleforest)
    
}
\seealso{
\code{\link{forest}}, \code{\link{plant_basalArea}}, \code{\link{summary.forest}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/forest_mapWoodyTables.R
\name{forest_mapWoodyTables}
\alias{forest_mapWoodyTables}
\alias{forest_mapTreeTable}
\alias{forest_mapShrubTable}
\title{Map forest plot data}
\usage{
forest_mapTreeTable(x, mapping_x, SpParams, plot_size_x = NULL)

forest_mapShrubTable(y, mapping_y, SpParams, plot_size_y = NULL)

forest_mapWoodyTables(
  x = NULL,
  y = NULL,
  mapping_x = NULL,
  mapping_y = NULL,
  SpParams,
  plot_size_x = NULL,
  plot_size_y = NULL
)
}
\arguments{
\item{x}{A data frame with tree records in rows and attributes in columns. Tree records can correspond to individual trees or groups of trees with an associated density.}

\item{mapping_x}{A named character vector to specify mappings of columns in \code{x} into attributes of \code{treeData} data frames. Accepted names (and the corresponding specifications for the columns in \code{x}) are:}

\item{SpParams}{A data frame with species parameters (see \code{\link{SpParamsMED}}) from which valid species names are drawn.}

\item{plot_size_x}{The size of tree plot sampled area (in m2). Alternatively, 'plot_size_x'
can be a column in \code{x} and specified in \code{mapping_x} to indicate that trees
have been measured in different subplots and, therefore, they represent different
densities per hectare.}

\item{y}{A data frame with shrub records in rows and attributes in columns. Records can correspond to individual shrubs (with crown dimensions and height) or groups of shrubs with an associated cover estimate.}

\item{mapping_y}{A named character vector to specify mappings of columns in \code{y} into attributes of \code{shrubData} data frames.
Accepted names (and the corresponding specifications for the columns in \code{y}) are:
\itemize{
\item{\code{Species}: Species code (should follow codes in \code{SpParams}).}
\item{\code{Species.name}: Species name. In this case, the species code will be drawn by matching names with species names in \code{SpParams}.}
\item{\code{N}: Tree density (in individuals per ha).}
\item{\code{Cover}: Shrub cover (in percent).}
\item{\code{D1}: Shrub largest crown diameter (in cm).}
\item{\code{D2}: Shrub crown diameter orthogonal to the largest one (in cm).}
\item{\code{plot.size}: Plot size (in m2) to which each record refers to. This is used to calculate tree density (stems per hectare) when not supplied or shrub cover when shrub data is given at the individual level.}
\item{\code{DBH}: Diameter at breast height (in cm).}
\item{\code{Height}: Tree or shrub height (in cm).}
\item{\code{Z50}: Depth (in mm) corresponding to 50 percent of fine roots.}
\item{\code{Z95}: Depth (in mm) corresponding to 95 percent of fine roots.}
\item{\code{Z100}: Depth (in mm) corresponding to 100 percent of fine roots.}
}}

\item{plot_size_y}{The size of shrub plot sampled area (in m2). Alternatively, 'plot_size_y'
can be a column in \code{y} and specified in \code{mapping_y} to indicate that shrubs
have been measured in different subplots and, therefore, they represent different
cover values.}
}
\value{
Functions \code{forest_mapTreeTable} and \code{forest_mapShrubTable} return a data frame with the structure of \code{treeData} and \code{shrubData} from \code{\link{forest}} objects. Function \code{forest_mapWoodyTable} returns directly a \code{\link{forest}} object.
}
\description{
Mapping functions to facilitate building forest objects from forest plot data
}
\examples{

# Load species parameters
data(SpParamsMED)

# Create an empty forest object
f <- emptyforest()

# (1) Mapping tree data
# Load Poblet tree data
data(poblet_trees)

# Subset control plot
x <- subset(poblet_trees, Plot.Code=="POBL_CTL")

# Estimate sampled area (15-m radius plot)
sampled_area <- pi*15^2

# Define mapping
mapping_x <- c("Species.name" = "Species", "DBH" = "Diameter.cm")

# Map tree data for plot 'POBL_CTL'
f$treeData <- forest_mapTreeTable(x,
                    mapping_x = mapping_x, SpParams = SpParamsMED,
                    plot_size_x = sampled_area)

# (2) Mapping shrub individual data
#
# Create the individual shrub data frame
species <- c("Erica arborea","Cistus albidus", "Erica arborea", "Cistus albidus", "Cistus albidus")
H <- c(200,50,100,40,30)
D1 <- c(140,40,100, 35,30)
D2 <- D1
y <- data.frame(species, H, D1, D2)

# Define mapping (D1 and D2 map to variables with the same name)
mapping_y <- c("Species.name"= "species", "Height" ="H", "D1", "D2")

# Map individual shrub data to cover data (here each individual becomes a cohort)
# assuming that the sampled area was 4 m2
f$shrubData <- forest_mapShrubTable(y,
                     mapping_y = mapping_y, SpParams = SpParamsMED,
                     plot_size_y = 4)

# (3) Print forest attributes
summary(f, SpParamsMED)

# (4) Forest initialization in a single step
f <- forest_mapWoodyTables(x, y,
                           mapping_x = mapping_x, mapping_y = mapping_y,
                           SpParams = SpParamsMED,
                           plot_size_x = sampled_area, plot_size_y = 4)
summary(f, SpParamsMED)
}
\seealso{
\code{\link{forest}}, \code{\link{poblet_trees}}, \code{\link{forest_mergeTrees}}, \code{\link{tree2forest}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, EMF-CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dataset_documentation.R
\docType{data}
\name{forest}
\alias{forest}
\alias{exampleforest}
\alias{exampleforest2}
\title{Description of a forest stand.}
\format{
An object of class \code{forest} contains the description of the woody (tree or shrub) cohorts of a forest patch.
It has the following structure (see additional columns in details):
\itemize{
\item{\code{treeData}: A data frame of tree cohorts (in rows) and the following columns:
\itemize{
\item{\code{Species}: String with species (taxon) name or a non-negative integer for tree species identity (i.e., 0,1,2,...) matching SpParams.}
\item{\code{Height}: Total tree height (in cm).}
\item{\code{DBH}: Tree diameter at breast height (in cm).}
\item{\code{N}: Density (number of individuals/hectare) that the measured tree represents.}
\item{\code{Z50}: Depth (in mm) corresponding to 50\% of fine roots.}
\item{\code{Z95}: Depth (in mm) corresponding to 95\% of fine roots.}
}
}
\item{\code{shrubData}: A data frame of shrub cohorts (in rows) and the following columns:
\itemize{
\item{\code{Species}: String with species (taxon) name or a non-negative integer for shrub species identity (i.e., 0,1,2,...) matching SpParams.}
\item{\code{Height}: Average total height of plants (in cm).}
\item{\code{Cover}: Percent cover.}
\item{\code{Z50}: Depth (in mm) corresponding to 50\% of fine roots.}
\item{\code{Z95}: Depth (in mm) corresponding to 95\% of fine roots.}
}
}
}
Additionally, it can contain information about other elements: the herbaceous layer, seedling/sapling bank, seed bank, snags, litter or soil carbon:
\itemize{
\item{\code{herbData}: A data frame of herbaceous cohorts (in rows) and the following columns (see an alternative way of defining the herbaceous layer in details):
\itemize{
\item{\code{Species}: String with species (taxon) name or a non-negative integer for herbaceous species identity (i.e., 0,1,2,...) matching SpParams.}
\item{\code{Height}: Average total height of plants (in cm).}
\item{\code{Cover}: Percent cover.}
\item{\code{Z50}: Depth (in mm) corresponding to 50\% of fine roots.}
\item{\code{Z95}: Depth (in mm) corresponding to 95\% of fine roots.}
}
}
\item{\code{seedlingBank}: An optional data frame containing seedling/sapling information with the following columns:
\itemize{
\item{\code{Species}: String with species (taxon) name or a non-negative integer for seedling/sapling species identity (i.e., 0,1,2,...) matching SpParams.}
\item{\code{Percent}: Amount of seedling in relation to full seedling bank (in \%).}
\item{\code{Age}: A numeric vector indicating age of seedlings/saplings in years.}
\item{\code{Z50}: Depth (in mm) corresponding to 50\% of fine roots.}
\item{\code{Z95}: Depth (in mm) corresponding to 95\% of fine roots.}
}
}
\item{\code{seedBank}: An optional data frame containing seed bank information with the following columns:
\itemize{
\item{\code{Species}: String with species (taxon) name or a non-negative integer for seed species identity (i.e., 0,1,2,...) matching SpParams.}
\item{\code{Percent}: Amount of seeds in relation to full seed bank (in \%).}
}
}
\item{\code{snagData}: An optional data frame containing information for snag cohorts, with the following columns:
\itemize{
\item{\code{Species}: String with species (taxon) name.}
\item{\code{DBH}: Diameter at breast height (in cm), for tree snags only.}
\item{\code{Height}: Height of the snag cohort (tree or shrub) (in cm).}
\item{\code{DeathAge}: Years passed since plant death (in yrs).}
\item{\code{SmallBranches}: Mass of (standing) small dead branches (diameters between 0.635 cm and 7.5 cm; 10h and 100h fuels; in g C/m2).}
\item{\code{LargeWood}: Mass of (standing) large dead wood (diameters larger than 7.5 cm; 1000h and 10000h fuels; in g C/m2).}
}
}
\item{\code{litterData}: An optional data frame containing litter information with the following columns:
\itemize{
\item{\code{Species}: String with species (taxon) name.}
\item{\code{Leaves}: Mass of leaf litter (in g C/m2)}
\item{\code{Twigs}: Mass of twig litter (diameters < 0.635 cm; 1h fuels; in g C/m2)}
\item{\code{SmallBranches}: Mass of (downed) small dead branches (diameters between 0.635 cm and 7.5 cm; 10h and 100h fuels; in g C/m2)}
\item{\code{LargeWood}: Mass of (downed) large dead wood (diameters larger than 7.5 cm; 1000h and 10000h fuels; in g C/m2)}
\item{\code{CoarseRoots}: Mass of dead coarse roots (in g C/m2)}
\item{\code{FineRoots}: Mass of fine root litter (in g C/m2)}
}
}
\item{\code{SOCData}: An optional named numeric vector containing CENTURY soil organic carbon pools (normally from previous simulations):
\itemize{
\item{\code{SurfaceMetabolic}: Metabolic carbon in the surface (in g C/m2).}
\item{\code{BelowgroundMetabolic}: Belowground metabolic carbon pool (in g C/m2)}
\item{\code{SurfaceActive}: Active decomposition carbon pool in the surface (in g C/m2)}
\item{\code{BelowgroundActive}: Belowground active decomposition carbon pool (in g C/m2)}
\item{\code{SurfaceSlow}: Slow decomposition carbon pool in the surface (in g C/m2)}
\item{\code{BelowgroundSlow}: Belowground slow decomposition carbon pool (in g C/m2)}
\item{\code{BelowgroundPassive}: Belowground passive decomposition carbon pool (in g C/m2)}
}
}
}
}
\source{
DGCN (2005). Tercer Inventario Forestal Nacional (1997-2007): Catalunya. \enc{Dirección}{Direccion} General de \enc{Conservación}{Conservacion} de la Naturaleza, Ministerio de Medio Ambiente, Madrid.
}
\description{
\code{exampleforest} is an example of forest stand description, whereas \code{exampleforest2} is an alternative forest description where leaf area index and crown ratio are supplied instead of structural (density, DBH and cover) parameters.
}
\details{
The structure presented above for \code{forest} objects corresponds to the main (required and optional) data elements and their required columns.
A \code{forest} object can contain additional information when this is available. Data frames \code{treeData},
\code{shrubData} and \code{herbData} can contain additional columns (\code{Z100} is also commonly used for data frame \code{seedlingBank}):
\itemize{
\item{\code{Z100}: Depth (in mm) corresponding to 100\% of fine roots (to specify a truncated root distribution).}
\item{\code{Age}: A numeric vector indicating age of cohorts in years. Used to track cohort age in simulations with \code{\link{fordyn}}.}
\item{\code{LAI}: Leaf area index (m2/m2).}
\item{\code{FoliarBiomass}: Standing dry biomass of leaves (kg/m2).}
\item{\code{FuelLoading}: Fine fuel loading (kg/m2).}
\item{\code{CrownRatio}: The ratio between crown length and total height (between 0 and 1)}
\item{\code{ObsID}: A string identifying plant cohorts at the stage of forest sampling. Used to track the fate of particular plant cohorts through simulations.
In \code{\link{fordyn}}, the use of these identifiers can be combined with the control option \code{keepCohortsWithObsID} so that these cohorts are not merged
or removed during simulations.}
}

Leaf area index (\code{LAI}), foliar biomass (\code{FoliarBiomass}), fuel loading (\code{FuelLoading}) and \code{CrownRatio} are used to override allometry-based estimates of those variables
when initializing inputs for functions \code{\link{spwb}} or \code{\link{spwb_day}}, but they will have no effect in simulations of \code{\link{growth}}, \code{\link{growth_day}} or \code{\link{fordyn}}.
Note that leaf area index, foliar biomass and fuel loading are related entities, and they are treated as such in medfate. Therefore, users are expected to supply
one or the other, and not all of them at the same time.

Instead of defining \code{herbData}, the herbaceous layer can be defined collectively (avoiding the need to specify species parameters for herbaceous species),
using the following list items:
\itemize{
\item{\code{herbCover}: Percent cover of the herb layer.}
\item{\code{herbHeight}: Mean height (in cm) of the herb layer.}
\item{\code{herbLAI}: Leaf area index (m2/m2) of the herb layer.}
\item{\code{herbFoliarBiomass}: Dry biomass (kg/m2) of the herb layer.}
\item{\code{herbFuelLoading}: Fine fuel loading (kg/m2) of the herb layer.}
}
}
\examples{
data(exampleforest)
exampleforest

data(exampleforest2)
exampleforest2
}
\seealso{
\code{\link{summary.forest}}, \code{\link{emptyforest}}, \code{\link{plot.forest}}, \code{\link{spwbInput}}
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/VerticalProfiles.R
\name{vprofile_leafAreaDensity}
\alias{vprofile_leafAreaDensity}
\alias{vprofile_rootDistribution}
\alias{vprofile_fuelBulkDensity}
\alias{vprofile_PARExtinction}
\alias{vprofile_SWRExtinction}
\alias{vprofile_windExtinction}
\title{Vertical profiles}
\usage{
vprofile_leafAreaDensity(
  x,
  SpParams = NULL,
  z = NULL,
  gdd = NA,
  byCohorts = FALSE,
  bySpecies = FALSE,
  includeHerbs = FALSE,
  draw = TRUE,
  xlim = NULL
)

vprofile_rootDistribution(
  x,
  SpParams,
  d = NULL,
  bySpecies = FALSE,
  draw = TRUE,
  xlim = NULL
)

vprofile_fuelBulkDensity(
  x,
  SpParams,
  z = NULL,
  gdd = NA,
  draw = TRUE,
  xlim = NULL
)

vprofile_PARExtinction(
  x,
  SpParams,
  z = NULL,
  gdd = NA,
  includeHerbs = FALSE,
  draw = TRUE,
  xlim = c(0, 100)
)

vprofile_SWRExtinction(
  x,
  SpParams,
  z = NULL,
  gdd = NA,
  includeHerbs = FALSE,
  draw = TRUE,
  xlim = c(0, 100)
)

vprofile_windExtinction(
  x,
  SpParams,
  u = 1,
  windMeasurementHeight = 200,
  boundaryLayerSize = 2000,
  target = "windspeed",
  z = NULL,
  gdd = NA,
  includeHerbs = FALSE,
  draw = TRUE,
  xlim = NULL
)
}
\arguments{
\item{x}{An object of class \code{\link{forest}}}

\item{SpParams}{A data frame with species parameters (see \code{\link{SpParamsMED}}).}

\item{z}{A numeric vector with height values.}

\item{gdd}{Growth degree days.}

\item{byCohorts}{Separate profiles for each cohort.}

\item{bySpecies}{Aggregate cohort profiles by species.}

\item{includeHerbs}{Include herbaceous layer in the profile.}

\item{draw}{Logical flag to indicate that a plot is desired.}

\item{xlim}{Limits of the x-axis.}

\item{d}{A numeric vector with soil layer widths.}

\item{u}{The value of measured wind speed (in m/s).}

\item{windMeasurementHeight}{Height corresponding to wind measurement (in cm over the canopy).}

\item{boundaryLayerSize}{Size of the boundary layer (in cm) over the canopy.}

\item{target}{Wind property to draw, either "windspeed", "kineticenergy" (turbulent kinetic energy) or "stress" (Reynold's stress).}
}
\value{
If \code{draw = FALSE}, the functions return a numeric vector with values measured at each height. Units depend on the profile function:
\itemize{
\item{\code{vprofile_leafAreaDensity}: Cumulative LAI (m2/m2) per height bin.}
\item{\code{vprofile_fuelBulkDensity}: Fuel bulk density (kg/m3) per height bin.}
\item{\code{vprofile_PARExtinction}: Percent of photosynthetically active radiation (\%) corresponding to each height.}
\item{\code{vprofile_SWRExtinction}: Percent of shortwave radiation (\%) corresponding to each height.}
\item{\code{vprofile_windExtinction}: Wind speed (m/s) corresponding to each height.}
}

If \code{draw = TRUE} the functions return a ggplot object, instead.
}
\description{
Functions to generate vertical profiles generated by an input \code{\link{forest}} object.
}
\examples{
#Default species parameterization
data(SpParamsMED)

#Load example plot plant data
data(exampleforest)

vprofile_leafAreaDensity(exampleforest, SpParamsMED)
vprofile_fuelBulkDensity(exampleforest, SpParamsMED)

vprofile_PARExtinction(exampleforest, SpParamsMED)
vprofile_SWRExtinction(exampleforest, SpParamsMED)

vprofile_windExtinction(exampleforest, SpParamsMED)

}
\seealso{
\code{\link{forest}}, \code{\link{plot.forest}}, \code{\link{wind_canopyTurbulence}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{pwb}
\alias{pwb}
\title{Plant water balance}
\usage{
pwb(
  x,
  meteo,
  W,
  latitude,
  elevation,
  slope = NA_real_,
  aspect = NA_real_,
  canopyEvaporation = numeric(0),
  snowMelt = numeric(0),
  soilEvaporation = numeric(0),
  herbTranspiration = numeric(0),
  CO2ByYear = numeric(0)
)
}
\arguments{
\item{x}{An object of class \code{\link{spwbInput}}.}

\item{meteo}{A data frame with daily meteorological data series (see \code{\link{spwb}}).}

\item{W}{A matrix with the same number of rows as \code{meteo} and as many columns as soil layers, containing the soil moisture of each layer as proportion of field capacity.}

\item{latitude}{Latitude (in degrees).}

\item{elevation, slope, aspect}{Elevation above sea level (in m), slope (in degrees) and aspect (in degrees from North).}

\item{canopyEvaporation}{A vector of daily canopy evaporation (from interception) values (mm). The length should match the number of rows in \code{meteo}.}

\item{snowMelt}{A vector of daily snow melt values (mm). The length should match the number of rows in \code{meteo}.}

\item{soilEvaporation}{A vector of daily bare soil evaporation values (mm). The length should match the number of rows in \code{meteo}.}

\item{herbTranspiration}{A vector of daily herbaceous transpiration values (mm). The length should match the number of rows in \code{meteo}.}

\item{CO2ByYear}{A named numeric vector with years as names and atmospheric CO2 concentration (in ppm) as values. Used to specify annual changes in CO2 concentration along the simulation (as an alternative to specifying daily values in \code{meteo}).}
}
\value{
A list of class 'pwb' with the same elements as explained in \code{\link{spwb}}.
}
\description{
Function \code{pwb()} performs plant water balance
only (i.e. soil moisture dynamics is an input) at daily steps for a given forest stand
during a period specified in the input climatic data. It works much as \code{\link{spwb}} but imposing soil moisture dynamics. Plant transpiration
and photosynthesis processes are conducted with different level of detail depending on the transpiration mode.
}
\details{
See details in \code{\link{spwb}}.
}
\references{
De \enc{Cáceres}{Caceres} M, \enc{Martínez}{Martinez}-Vilalta J, Coll L, Llorens P, Casals P, Poyatos R, Pausas JG, Brotons L. (2015) Coupling a water balance model with forest inventory data to predict drought stress: the role of forest structural changes vs. climate changes. Agricultural and Forest Meteorology 213: 77-90 (doi:10.1016/j.agrformet.2015.06.012).

De \enc{Cáceres}{Caceres} M, Mencuccini M, Martin-StPaul N, Limousin JM, Coll L, Poyatos R, Cabon A, Granda V, Forner A, Valladares F, \enc{Martínez}{Martinez}-Vilalta J (2021) Unravelling the effect of species mixing on water use and drought stress in holm oak forests: a modelling approach. Agricultural and Forest Meteorology 296 (doi:10.1016/j.agrformet.2020.108233).

Granier A, \enc{Bréda}{Breda} N, Biron P, Villette S (1999) A lumped water balance model to evaluate duration and intensity of drought constraints in forest stands. Ecol Modell 116:269–283. https://doi.org/10.1016/S0304-3800(98)00205-1.

Ruffault J, Pimont F, Cochard H, Dupuy JL, Martin-StPaul N (2022)
SurEau-Ecos v2.0: a trait-based plant hydraulics model for simulations of plant water status and drought-induced mortality at the ecosystem level.
Geoscientific Model Development 15, 5593-5626 (doi:10.5194/gmd-15-5593-2022).

Sperry, J. S., M. D. Venturas, W. R. L. Anderegg, M. Mencuccini, D. S. Mackay, Y. Wang, and D. M. Love. 2017. Predicting stomatal responses to the environment from the optimization of photosynthetic gain and hydraulic cost. Plant Cell and Environment 40, 816-830 (doi: 10.1111/pce.12852).
}
\seealso{
\code{\link{spwbInput}}, \code{\link{spwb_day}}, \code{\link{plot.spwb}},
\code{\link{extract}}, \code{\link{summary.spwb}},
\code{\link{forest}}, \code{\link{spwb}}, \code{\link{aspwb}}
}
\author{
\itemize{
\item{Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF}
\item{Nicolas Martin-StPaul, URFM-INRAE}
}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{forest2aboveground}
\alias{forest2aboveground}
\alias{forest2belowground}
\alias{forest2spwbInput}
\alias{forest2growthInput}
\title{Input for simulation models (deprecated)}
\usage{
forest2aboveground(x, SpParams, gdd = NA_real_, loading = FALSE)

forest2belowground(x, soil, SpParams)

forest2spwbInput(x, soil, SpParams, control)

forest2growthInput(x, soil, SpParams, control)
}
\arguments{
\item{x}{An object of class \code{\link{forest}}.}

\item{SpParams}{A data frame with species parameters (see \code{\link{SpParamsDefinition}} and \code{\link{SpParamsMED}}).}

\item{gdd}{Growth degree days to account for leaf phenology effects (in Celsius). This should be left \code{NA} in most applications.}

\item{loading}{A logical flag to indicate that fuel loading should be included (for fire hazard calculations).}

\item{soil}{An object of class \code{\link{data.frame}} or \code{\link{soil}}, containing soil parameters per soil layer.}

\item{control}{A list with default control parameters (see \code{\link{defaultControl}}).}
}
\value{
Function \code{forest2aboveground()} returns a data frame with the following columns (rows are identified as specified by function \code{\link{plant_ID}}):
\itemize{
\item{\code{SP}: Species identity (an integer) (first species is 0).}
\item{\code{N}: Cohort density (ind/ha) (see function \code{\link{plant_density}}).}
\item{\code{DBH}: Tree diameter at breast height (cm).}
\item{\code{H}: Plant total height (cm).}
\item{\code{CR}: Crown ratio (crown length to total height) (between 0 and 1).}
\item{\code{LAI_live}: Live leaf area index (m2/m2) (one-side leaf area relative to plot area), includes leaves in winter dormant buds.}
\item{\code{LAI_expanded}: Leaf area index of expanded leaves (m2/m2) (one-side leaf area relative to plot area).}
\item{\code{LAI_dead}: Dead leaf area index (m2/m2) (one-side leaf area relative to plot area).}
\item{\code{LAI_nocomp}: Leaf area index (m2/m2) (one-side leaf area relative to plot area) assuming no aboveground competition.}
\item{\code{Loading}: Fine fuel loading (kg/m2), only if \code{loading = TRUE}.}
\item{\code{Age}: A numeric vector indicating age of cohorts in years. Used to track cohort age in simulations with \code{\link{fordyn}}.}
\item{\code{ObsID}: A string identifying plant cohorts at the stage of forest sampling. Used to track the fate of particular plant cohorts in simulations with \code{\link{fordyn}}.}
}
}
\description{
Functions \code{forest2spwbInput()} and \code{forest2growthInput()} take an object of class \code{\link{forest}}
and a soil data input to create input objects for simulation functions \code{\link{spwb}} (or \code{\link{pwb}}) and \code{\link{growth}}, respectively.
Function \code{forest2aboveground()} calculates aboveground variables such as leaf area index.
Function \code{forest2belowground()} calculates belowground variables such as fine root distribution.
}
\details{
Function \code{forest2aboveground()} extracts height and species identity from plant cohorts of \code{x},
and calculate leaf area index and crown ratio.

\emph{IMPORTANT NOTE}: Function names \code{forest2spwbInput()} and \code{forest2growthInput()} are now internal and deprecated, but
they can still be used for back-compatibility. They correspond to functions \code{\link{spwbInput}} and \code{\link{growthInput}}
}
\examples{
#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

# Aboveground parameters
forest2aboveground(exampleforest, SpParamsMED)

# Example of aboveground parameters taken from a forest
# described using LAI and crown ratio
data(exampleforest2)
forest2aboveground(exampleforest2, SpParamsMED)

# Define soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

# Bewowground parameters (distribution of fine roots)
forest2belowground(exampleforest, examplesoil, SpParamsMED)


}
\seealso{
\code{\link{spwbInput}}, \code{\link{soil}},
\code{\link{forest}}, \code{\link{SpParamsMED}}, \code{\link{defaultSoilParams}}, \code{\link{plant_ID}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{spwb_day}
\alias{spwb_day}
\title{Single-day soil-plant water balance}
\usage{
spwb_day(
  x,
  date,
  meteovec,
  latitude,
  elevation,
  slope = NA_real_,
  aspect = NA_real_,
  runon = 0,
  lateralFlows = NULL,
  waterTableDepth = NA_real_,
  modifyInput = TRUE
)
}
\arguments{
\item{x}{An object of class \code{\link{spwbInput}} or \code{\link{growthInput}}.}

\item{date}{Date as string "yyyy-mm-dd".}

\item{meteovec}{A named numerical vector with weather data. See variable names in parameter \code{meteo} of \code{\link{spwb}}.}

\item{latitude}{Latitude (in degrees).}

\item{elevation, slope, aspect}{Elevation above sea level (in m), slope (in degrees) and aspect (in degrees from North).}

\item{runon}{Surface water amount running on the target area from upslope (in mm).}

\item{lateralFlows}{Lateral source/sink terms for each soil layer (interflow/to from adjacent locations) as mm/day.}

\item{waterTableDepth}{Water table depth (in mm). When not missing, capillarity rise will be allowed if lower than total soil depth.}

\item{modifyInput}{Boolean flag to indicate that the input \code{x} object is allowed to be modified during the simulation.}
}
\value{
Function \code{spwb_day()} returns a list of class \code{spwb_day} with the
following elements:
\itemize{
\item{\code{"cohorts"}: A data frame with cohort information, copied from \code{\link{spwbInput}}.}
\item{\code{"topography"}: Vector with elevation, slope and aspect given as input.}
\item{\code{"weather"}: A vector with the input weather.}
\item{\code{"WaterBalance"}: A vector of water balance components (rain, snow, net rain, infiltration, ...) for the simulated day, equivalent to one row of 'WaterBalance' object given in \code{\link{spwb}}.}
\item{\code{"EnergyBalance"}: Energy balance of the stand (only returned when \code{transpirationMode = "Sperry"} or  \code{transpirationMode = "Sureau"}; see \code{\link{transp_transpirationSperry}}).}
\item{\code{"Soil"}: A data frame with results for each soil layer:
\itemize{
\item{\code{"Psi"}: Soil water potential (in MPa) at the end of the day.}
\item{\code{"HerbTranspiration"}: Water extracted by herbaceous plants from each soil layer (in mm).}
\item{\code{"HydraulicInput"}: Water entering each soil layer from other layers, transported via plant roots (in mm).}
\item{\code{"HydraulicOutput"}: Water leaving each soil layer (going to other layers or the transpiration stream) (in mm).}
\item{\code{"PlantExtraction"}: Water extracted by woody plants from each soil layer (in mm).}
}
}
\item{\code{"Stand"}: A named vector with with stand values for the simulated day, equivalent to one row of 'Stand' object returned by \code{\link{spwb}}.}
\item{\code{"Plants"}: A data frame of results for each plant cohort (see \code{\link{transp_transpirationGranier}} or \code{\link{transp_transpirationSperry}}).}
}

The following additional items are only returned when \code{transpirationMode = "Sperry"} or  \code{transpirationMode = "Sureau"}:
\itemize{
\item{\code{"RhizoPsi"}: Minimum water potential (in MPa) inside roots, after crossing rhizosphere, per cohort and soil layer.}
\item{\code{"SunlitLeaves"} and \code{"ShadeLeaves"}: For each leaf type, a data frame with values of LAI, Vmax298 and Jmax298 for leaves of this type in each plant cohort.}
\item{\code{"ExtractionInst"}: Water extracted by each plant cohort during each time step.}
\item{\code{"PlantsInst"}: A list with instantaneous (per time step) results for each plant cohort (see \code{\link{transp_transpirationSperry}}).}
\item{\code{"LightExtinction"}: A list of information regarding radiation balance through the canopy, as returned by function \code{\link{light_instantaneousLightExtinctionAbsortion}}.}
\item{\code{"CanopyTurbulence"}: Canopy turbulence (see \code{\link{wind_canopyTurbulence}}).}
}
}
\description{
Function \code{spwb_day} performs water balance for a single day.
}
\details{
Detailed model description is available in the medfate book.

Soil-plant water balance simulations allow using different sub-models for bulk soil water flows and different sub-models of transpiration and photosynthesis:

(1) Sub-models of transpiration and photosynthesis (control parameter \code{transpirationMode}):
\itemize{
\item{The sub-model corresponding to 'Granier' transpiration mode is illustrated by internal function \code{\link{transp_transpirationGranier}} and was described in De Caceres et al. (2015),
and implements an approach originally described in Granier et al. (1999).}
\item{The sub-model corresponding to 'Sperry' transpiration mode is illustrated by internal function \code{\link{transp_transpirationSperry}} and was described in De Caceres et al. (2021), and
implements a modelling approach originally described in Sperry et al. (2017).}
\item{The sub-model corresponding to 'Sureau' transpiration mode is illustrated by internal function \code{\link{transp_transpirationSureau}} and was described for model SurEau-Ecos v2.0 in Ruffault et al. (2022).}
}
Simulations using the 'Sperry' or 'Sureau' transpiration mode are computationally much more expensive than 'Granier' because they
include explicit plant hydraulics and canopy/soil energy balance at subdaily time steps.

(2) Sub-models of bulk soil water flows (control parameter \code{soilDomains}; see internal function \code{\link{hydrology_soilWaterBalance}}):
\itemize{
\item{The submodel corresponding to 'buckets' is a multi-bucket model adds/substracts water to each layer and if content is above field capacity the excess percolates to the layer below.}
\item{The submodel corresponding to 'single' is a single-domain solving 1D Richards equation (Bonan et al. 2019).}
\item{The submodel corresponding to 'dual' is a dual-permeability model from MACRO 5.0 (Jarvis et al. 1991; Larsbo et al. 2005)}
}
}
\examples{
#Load example daily meteorological data
data(examplemeteo)

#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Define soil parameters
examplesoil <- defaultSoilParams(4)

# Day to be simulated
d <- 100
meteovec <- unlist(examplemeteo[d,-1])
date <- as.character(examplemeteo$dates[d])

#Simulate water balance one day only (Granier mode)
control <- defaultControl("Granier")
x1 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)
sd1 <- spwb_day(x1, date, meteovec,  
                latitude = 41.82592, elevation = 100, slope=0, aspect=0) 

#Simulate water balance for one day only (Sperry mode)
control <- defaultControl("Sperry")
x2 <- spwbInput(exampleforest, examplesoil, SpParamsMED, control)
sd2 <-spwb_day(x2, date, meteovec,
              latitude = 41.82592, elevation = 100, slope=0, aspect=0)

#Simulate water balance for one day only (Sureau mode)
control <- defaultControl("Sureau")
x3 <- spwbInput(exampleforest, examplesoil, SpParamsMED, control)
sd3 <-spwb_day(x3, date, meteovec,
              latitude = 41.82592, elevation = 100, slope=0, aspect=0)


}
\references{
Bonan, G. (2019). Climate change and terrestrial ecosystem modeling. Cambridge University Press, Cambridge, UK.

De \enc{Cáceres}{Caceres} M, \enc{Martínez}{Martinez}-Vilalta J, Coll L, Llorens P, Casals P, Poyatos R, Pausas JG, Brotons L. (2015) Coupling a water balance model with forest inventory data to predict drought stress: the role of forest structural changes vs. climate changes. Agricultural and Forest Meteorology 213: 77-90 (doi:10.1016/j.agrformet.2015.06.012).

De \enc{Cáceres}{Caceres} M, Mencuccini M, Martin-StPaul N, Limousin JM, Coll L, Poyatos R, Cabon A, Granda V, Forner A, Valladares F, \enc{Martínez}{Martinez}-Vilalta J (2021) Unravelling the effect of species mixing on water use and drought stress in holm oak forests: a modelling approach. Agricultural and Forest Meteorology 296 (doi:10.1016/j.agrformet.2020.108233).

Granier A, \enc{Bréda}{Breda} N, Biron P, Villette S (1999) A lumped water balance model to evaluate duration and intensity of drought constraints in forest stands. Ecol Modell 116:269–283. https://doi.org/10.1016/S0304-3800(98)00205-1.

Jarvis, N.J., Jansson, P‐E., Dik, P.E. & Messing, I. (1991). Modelling water and solute transport in macroporous soil. I. Model description and sensitivity analysis. Journal of Soil Science, 42, 59–70.

Larsbo, M., Roulier, S., Stenemo, F., Kasteel, R. & Jarvis, N. (2005). An Improved Dual‐Permeability Model of Water Flow and Solute Transport in the Vadose Zone. Vadose Zone Journal, 4, 398–406.

Ruffault J, Pimont F, Cochard H, Dupuy JL, Martin-StPaul N (2022)
SurEau-Ecos v2.0: a trait-based plant hydraulics model for simulations of plant water status and drought-induced mortality at the ecosystem level.
Geoscientific Model Development 15, 5593-5626 (doi:10.5194/gmd-15-5593-2022).

Sperry, J. S., M. D. Venturas, W. R. L. Anderegg, M. Mencuccini, D. S. Mackay, Y. Wang, and D. M. Love. 2017. Predicting stomatal responses to the environment from the optimization of photosynthetic gain and hydraulic cost. Plant Cell and Environment 40, 816-830 (doi: 10.1111/pce.12852).
}
\seealso{
\code{\link{spwbInput}}, \code{\link{spwb}},  \code{\link{plot.spwb_day}},
\code{\link{growth_day}}
}
\author{
\itemize{
\item{Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF}
\item{Nicolas Martin-StPaul, URFM-INRAE}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summary.spwb.R
\name{summary.spwb}
\alias{summary.spwb}
\alias{summary.aspwb}
\alias{summary.pwb}
\alias{summary.growth}
\alias{summary.fordyn}
\title{Summarize simulation results}
\usage{
\method{summary}{spwb}(
  object,
  freq = "years",
  output = "WaterBalance",
  FUN = sum,
  bySpecies = FALSE,
  months = NULL,
  ...
)

\method{summary}{aspwb}(
  object,
  freq = "years",
  output = "WaterBalance",
  FUN = sum,
  bySpecies = FALSE,
  months = NULL,
  ...
)

\method{summary}{pwb}(
  object,
  freq = "years",
  output = "WaterBalance",
  FUN = sum,
  bySpecies = FALSE,
  months = NULL,
  ...
)

\method{summary}{growth}(
  object,
  freq = "years",
  output = "WaterBalance",
  FUN = sum,
  bySpecies = FALSE,
  months = NULL,
  ...
)

\method{summary}{fordyn}(
  object,
  freq = "years",
  output = "WaterBalance",
  FUN = sum,
  bySpecies = FALSE,
  months = NULL,
  ...
)
}
\arguments{
\item{object}{An object of class \code{spwb}, \code{aspwb}, \code{pwb}, \code{growth} or \code{fordyn}.}

\item{freq}{Frequency of summary statistics (see \code{\link{cut.Date}}).}

\item{output}{The data table to be summarized. Accepted values are the path to data tables in \code{object}, such as 'WaterBalance', 'Soil', 'Stand' or 'Plants$LAI'. It is also possible to use strings like 'Transpiration' and the function will interpret it as 'Plants$Transpiration'.}

\item{FUN}{The function to summarize results (e.g., \code{sum}, \code{mean}, ...)}

\item{bySpecies}{Allows aggregating output by species before calculating summaries (only has an effect with some values of \code{output}). Aggregation can involve a sum (as for plant lai or transpiration) or a LAI-weighted mean (as for plant stress or plant water potential).}

\item{months}{A vector of month numbers (1 to 12) to subset the season where summaries apply.}

\item{...}{Additional parameters for function \code{summary}.}
}
\value{
A matrix with dates as row names and the desired summaries in columns
}
\description{
Function \code{summary} summarizes the model's output in different temporal steps (i.e. weekly, annual, ...).
}
\note{
When applied to \code{\link{fordyn}} objects, the summary function can be used to gather the results of different yearly steps into a single table while keeping a daily resolution (i.e. using \code{freq = "days"}.
}
\examples{
\donttest{
#Load example daily meteorological data
data(examplemeteo)

#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Define soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

#Initialize control parameters
control <- defaultControl("Granier")

#Initialize input
x <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)

#Call simulation function
S1<-spwb(x, examplemeteo, latitude = 41.82592, elevation = 100)

#Queries the tables in 'Soil'
names(S1$Soil)

#Monthly summary (averages) of soil relative water content
summary(S1, freq="months",FUN=mean, output="RWC")

#Queries the tables in 'Plants'
names(S1$Plants)

#Monthly summary (averages) of plant stress
summary(S1, freq="months",FUN=mean, output="PlantStress", 
        bySpecies = TRUE)
}

}
\seealso{
\code{\link{spwb}}, \code{\link{pwb}}, \code{\link{growth}}, \code{\link{fordyn}},
\code{\link{plot.spwb}}, \code{\link{extract}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{spwb}
\alias{spwb}
\title{Soil-plant water balance}
\usage{
spwb(
  x,
  meteo,
  latitude,
  elevation,
  slope = NA_real_,
  aspect = NA_real_,
  CO2ByYear = numeric(0),
  waterTableDepth = NA_real_
)
}
\arguments{
\item{x}{An object of class \code{\link{spwbInput}}.}

\item{meteo}{A data frame with daily meteorological data series.
Row names of the data frame should correspond to date strings with format "yyyy-mm-dd" (see \code{\link{Date}}). Alternatively,
a column called \code{"dates"} or \code{"Dates"} can contain \code{\link{Date}} or \code{\link{POSIXct}} classes.
The following columns are required and cannot have missing values:
\itemize{
\item{\code{MinTemperature}: Minimum temperature (in degrees Celsius).}
\item{\code{MaxTemperature}: Maximum temperature (in degrees Celsius).}
\item{\code{Precipitation}: Precipitation (in mm).}
}
The following columns are required but can contain missing values (NOTE: missing values will raise warnings):
\itemize{
\item{\code{MinRelativeHumidity}: Minimum relative humidity (in percent).}
\item{\code{MaxRelativeHumidity}: Maximum relative humidity (in percent).}
\item{\code{Radiation}: Solar radiation (in MJ/m2/day).}
}
The following columns are optional:
\itemize{
\item{\code{WindSpeed}: Above-canopy wind speed (in m/s). This column may not exist, or can be left with \code{NA} values. In both cases simulations will assume a constant value specified in \code{\link{defaultControl}}.}
\item{\code{CO2}: Atmospheric (above-canopy) CO2 concentration (in ppm). This column may not exist, or can be left with \code{NA} values. In both cases simulations will assume a constant value specified in \code{\link{defaultControl}}.}
\item{\code{Patm}: Atmospheric pressure (in kPa). This column may not exist, or can be left with \code{NA} values. In both cases, a value is estimated from elevation.}
}}

\item{latitude}{Latitude (in degrees).}

\item{elevation, slope, aspect}{Elevation above sea level (in m), slope (in degrees) and aspect (in degrees from North).}

\item{CO2ByYear}{A named numeric vector with years as names and atmospheric CO2 concentration (in ppm) as values. Used to specify annual changes in CO2 concentration along the simulation (as an alternative to specifying daily values in \code{meteo}).}

\item{waterTableDepth}{Water table depth (in mm). When not missing, capillarity rise will be allowed if lower than total soil depth.}
}
\value{
Function \code{spwb} returns a list of class 'spwb'. Since lists are difficult to handle, we recommend using
function \code{\link{extract}} to reshape simulation results (including their units) from those objects.

List elements are as follows:
\itemize{
\item{\code{"latitude"}: Latitude (in degrees) given as input.}
\item{\code{"topography"}: Vector with elevation, slope and aspect given as input.}
\item{\code{"weather"}: A copy of the input weather data frame.}
\item{\code{"spwbInput"}: An copy of the object \code{x} of class \code{\link{spwbInput}} given as input.}
\item{\code{"spwbOutput"}: An copy of the final state of the object \code{x} of class \code{\link{spwbInput}}.}
\item{\code{"WaterBalance"}: A data frame where different variables (in columns) are given for each simulated day (in rows):}
\itemize{
\item{\code{"PET"}: Potential evapotranspiration (in mm).}
\item{\code{"Precipitation"}: Input precipitation (in mm).}
\item{\code{"Rain"}: Precipitation as rainfall (in mm).}
\item{\code{"Snow"}: Precipitation as snowfall (in mm).}
\item{\code{"NetRain"}: Net rain, after accounting for interception (in mm).}
\item{\code{"Infiltration"}: The amount of water infiltrating into the soil (in mm).}
\item{\code{"InfiltrationExcess"}: Excess infiltration in the topmost layer leading to an increase in runoff (in mm).}
\item{\code{"SaturationExcess"}: Excess saturation in the topmost layer leading to an increase in runoff (in mm).}
\item{\code{"CapillarityRise"}: Water entering the soil via capillarity rise (mm) from the water table, if \code{waterTableDepth} is supplied.}
\item{\code{"Runoff"}: The amount of water exported via surface runoff (in mm).}
\item{\code{"DeepDrainage"}: The amount of water exported via deep drainage (in mm).}
\item{\code{"Evapotranspiration"}: Evapotranspiration (in mm).}
\item{\code{"SoilEvaporation"}: Bare soil evaporation (in mm).}
\item{\code{"HerbTranspiration"}: Transpiration due to the herbaceous layer (in mm).}
\item{\code{"PlantExtraction"}: Amount of water extracted from soil by woody plants (in mm).}
\item{\code{"Transpiration"}: Woody plant transpiration (in mm).}
\item{\code{"HydraulicRedistribution"}: Water redistributed among soil layers, transported through the plant hydraulic network.}
}
\item{\code{"EnergyBalance"}: A data frame with the daily values of energy balance components for the soil and the canopy (only for \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}).}
\item{\code{"Temperature"}: A data frame with the daily values of minimum/mean/maximum temperatures for the atmosphere (input), canopy and soil (only for \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}).}
\item{\code{"Soil"}: A list with the following subelements:}
\itemize{
\item{\code{"SWC"}: Soil water content (percent of soil volume) in each soil layer (and overall).}
\item{\code{"RWC"}: Relative soil moisture content (relative to field capacity) in each soil layer (and overall).}
\item{\code{"REW"}: Relative extractable water (min. psi = -5 MPa) in each soil layer (and overall).}
\item{\code{"ML"}: Soil water volume in each soil layer (in L/m2) (and overall).}
\item{\code{"Psi"}: Soil water potential in each soil layer (in MPa) (and overall).}
\item{\code{"PlantExt"}: Plant extraction from each soil layer (in mm) (and overall).}
\item{\code{"HydraulicInput"}: Water that entered the layer coming from other layers and transported via the plant hydraulic network (in mm) (and overall).}
}
\item{\code{"Snow"}: A data frame where the following variable (in columns) is given for each simulated day (in rows):}
\itemize{
\item{\code{"SWE"}: Snow water equivalent (mm) of the snow pack.}
}
\item{\code{"Stand"}: A data frame where different variables (in columns) are given for each simulated day (in rows):}
\itemize{
\item{\code{"LAI"}: LAI of the stand (including the herbaceous layer and live + dead leaves of woody plants) (in m2/m2).}
\item{\code{"LAIherb"}: LAI of the herbaceous layer (in m2/m2).}
\item{\code{"LAIlive"}: LAI of the woody plants assuming all leaves are unfolded (in m2/m2).}
\item{\code{"LAIexpanded"}: LAI of the woody plants with leaves actually unfolded (in m2/m2).}
\item{\code{"LAIdead"}: LAI of the woody plants corresponding to dead leaves (in m2/m2).}
\item{\code{"Cm"}: Water retention capacity of the canopy (in mm) (accounting for leaf phenology).}
\item{\code{"LgroundPAR"}: The percentage of PAR that reaches the ground (accounting for leaf phenology).}
\item{\code{"LgroundSWR"}: The percentage of SWR that reaches the ground (accounting for leaf phenology).}
}
\item{\code{"Plants"}: A list of daily results for plant cohorts (see below).}
\item{\code{"SunlitLeaves"}: A list of daily results for sunlit leaves of plant cohorts  (only for \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}; see below).}
\item{\code{"ShadeLeaves"}: A list of daily results for sunlit leaves of plant cohorts  (only for \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}; see below).}
\item{\code{"subdaily"}: A list of objects of class \code{\link{spwb_day}}, one per day simulated (only if required in \code{control} parameters, see \code{\link{defaultControl}}).}
}

When \code{transpirationMode = "Granier"}, element \code{"Plants"} is a list with the following subelements:
\itemize{
\item{\code{"LAI"}: A data frame with the daily leaf area index for each plant cohort.}
\item{\code{"LAIlive"}: A data frame with the daily leaf area index for each plant cohort, assuming all leaves are unfolded (in m2/m2).}
\item{\code{"FPAR"}: A data frame with the fraction of PAR at the canopy level of each plant cohort. }
\item{\code{"AbsorbedSWRFraction"}: A data frame with the fraction of SWR absorbed by each plant cohort. }
\item{\code{"Transpiration"}: A data frame with the amount of daily transpiration (in mm) for each plant cohort.}
\item{\code{"GrossPhotosynthesis"}: A data frame with the amount of daily gross photosynthesis (in g C·m-2) for each plant cohort. }
\item{\code{"PlantPsi"}: A data frame with the average daily water potential of each plant (in MPa).}
\item{\code{"LeafPLC"}: A data frame with the average daily proportion of leaf conductance loss of each plant ([0-1]).}
\item{\code{"StemPLC"}: A data frame with the average daily proportion of stem conductance loss of each plant ([0-1]).}
\item{\code{"PlantWaterBalance"}: A data frame with the daily balance between transpiration and soil water extraction for each plant cohort. }
\item{\code{"LeafRWC"}: A data frame with the average daily leaf relative water content of each plant (in percent).}
\item{\code{"StemRWC"}: A data frame with the average daily stem relative water content of each plant (in percent). }
\item{\code{"LFMC"}: A data frame with the daily live fuel moisture content (in percent of dry weight).}
\item{\code{"PlantStress"}: A data frame with the amount of daily stress [0-1] suffered by each plant cohort (relative whole-plant conductance).}
}
If \code{transpirationMode="Sperry"} or \code{transpirationMode="Sureau"}, element \code{"Plants"} is a list with the following subelements:
\itemize{
\item{\code{"LAI"}: A data frame with the daily leaf area index for each plant cohort.}
\item{\code{"LAIlive"}: A data frame with the daily leaf area index for each plant cohort, assuming all leaves are unfolded (in m2/m2).}
\item{\code{"FPAR"}: A data frame with the fraction of PAR at the canopy level of each plant cohort. }
\item{\code{"AbsorbedSWR"}: A data frame with the daily SWR absorbed by each plant cohort.}
\item{\code{"NetLWR"}: A data frame with the daily net LWR by each plant cohort.}
\item{\code{"Transpiration"}: A data frame with the amount of daily transpiration (in mm) for each plant cohorts.}
\item{\code{"GrossPhotosynthesis"}: A data frame with the amount of daily gross photosynthesis (in g C·m-2) for each plant cohort. }
\item{\code{"NetPhotosynthesis"}: A data frame with the amount of daily net photosynthesis (in g C·m-2) for each plant cohort. }
\item{\code{"dEdP"}: A data frame with mean daily values of soil-plant conductance (derivative of the supply function) for each plant cohort.}
\item{\code{"PlantWaterBalance"}: A data frame with the daily balance between transpiration and soil water extraction for each plant cohort. }
\item{\code{"LeafPsiMin"}: A data frame with the minimum (midday) daily (average) leaf water potential of each plant (in MPa).}
\item{\code{"LeafPsiMax"}: A data frame with the maximum (predawn) daily (average) leaf water potential of each plant (in MPa).}
\item{\code{"LeafRWC"}: A data frame with the average daily leaf relative water content of each plant (in percent).}
\item{\code{"StemRWC"}: A data frame with the average daily stem relative water content of each plant (in percent). }
\item{\code{"LFMC"}: A data frame with the daily live fuel moisture content (in percent of dry weight).}
\item{\code{"StemPsi"}: A data frame with the minimum daily stem water potential of each plant (in MPa). }
\item{\code{"LeafPLC"}: A data frame with the average daily proportion of leaf conductance loss of each plant ([0-1]).}
\item{\code{"StemPLC"}: A data frame with the average daily proportion of stem conductance loss of each plant ([0-1]).}
\item{\code{"RootPsi"}: A data frame with the minimum daily root water potential of each plant (in MPa). }
\item{\code{"RhizoPsi"}: A list of data frames (one per plant cohort) with the minimum daily root water potential of each plant (in MPa).}
\item{\code{"LFMC"}: A data frame with the daily live fuel moisture content (in percent of dry weight).}
\item{\code{"PlantStress"}: A data frame with the amount of daily stress [0-1] suffered by each plant cohort (relative whole-plant conductance).}
}
If \code{transpirationMode="Sperry"} or \code{transpirationMode="Sureau"}, then elements  \code{"SunlitLeaves"} and \code{"ShadeLeaves"} are list with daily results for sunlit
and shade leaves:
\itemize{
\item{\code{"PsiMin"}: A data frame with the minimum (midday) daily sunlit or shade leaf water potential (in MPa). }
\item{\code{"PsiMax"}: A data frame with the maximum (predawn) daily sunlit or shade leaf water potential (in MPa). }
\item{\code{"TempMin"}: A data frame with the minimum daily sunlit or shade leaf temperature (in Celsius). }
\item{\code{"TempMax"}: A data frame with the maximum daily sunlit or shade leaf temperature (in Celsius). }
\item{\code{"GSWMin"}: A data frame with the minimum daily sunlit or shade leaf stomatal conductance (in mol·m-2·s-1). }
\item{\code{"GSWMax"}: A data frame with the maximum daily sunlit or shade leaf stomatal conductance (in mol·m-2·s-1). }
}
}
\description{
Function \code{spwb()} is a water balance model that determines changes in soil moisture,
soil water potentials, plant transpiration and drought stress at daily steps for a given forest stand
during a period specified in the input climatic data. Plant transpiration
and photosynthesis processes are conducted with different level of detail depending on the transpiration mode.
}
\details{
Detailed model description is available in the medfate book.

Soil-plant water balance simulations allow using different sub-models for bulk soil water flows and different sub-models of transpiration and photosynthesis:

(1) Sub-models of transpiration and photosynthesis (control parameter \code{transpirationMode}):
\itemize{
\item{The sub-model corresponding to 'Granier' transpiration mode is illustrated by internal function \code{\link{transp_transpirationGranier}} and was described in De Caceres et al. (2015),
and implements an approach originally described in Granier et al. (1999).}
\item{The sub-model corresponding to 'Sperry' transpiration mode is illustrated by internal function \code{\link{transp_transpirationSperry}} and was described in De Caceres et al. (2021), and
implements a modelling approach originally described in Sperry et al. (2017).}
\item{The sub-model corresponding to 'Sureau' transpiration mode is illustrated by internal function \code{\link{transp_transpirationSureau}} and was described for model SurEau-Ecos v2.0 in Ruffault et al. (2022).}
}
Simulations using the 'Sperry' or 'Sureau' transpiration mode are computationally much more expensive than 'Granier' because they
include explicit plant hydraulics and canopy/soil energy balance at subdaily time steps.

(2) Sub-models of bulk soil water flows (control parameter \code{soilDomains}; see internal function \code{\link{hydrology_soilWaterBalance}}):
\itemize{
\item{The submodel corresponding to 'buckets' is a multi-bucket model adds/substracts water to each layer and if content is above field capacity the excess percolates to the layer below.}
\item{The submodel corresponding to 'single' is a single-domain solving 1D Richards equation (Bonan et al. 2019).}
\item{The submodel corresponding to 'dual' is a dual-permeability model from MACRO 5.0 (Jarvis et al. 1991; Larsbo et al. 2005)}
}
}
\examples{
\donttest{
#Load example daily meteorological data
data(examplemeteo)

#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Define soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

#Initialize control parameters
control <- defaultControl("Granier")

#Initialize input
x1 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)

#Call simulation function
S1 <- spwb(x1, examplemeteo, latitude = 41.82592, elevation = 100)

#Switch to 'Sperry' transpiration mode
control <- defaultControl("Sperry")

#Initialize input
x2 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)

#Call simulation function
S2 <- spwb(x2, examplemeteo, latitude = 41.82592, elevation = 100)

#Switch to 'Sureau' transpiration mode
control <- defaultControl("Sureau")

#Initialize input
x3 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)

#Call simulation function
S3 <- spwb(x3, examplemeteo, latitude = 41.82592, elevation = 100)
}
                
}
\references{
Bonan, G. (2019). Climate change and terrestrial ecosystem modeling. Cambridge University Press, Cambridge, UK.

De \enc{Cáceres}{Caceres} M, \enc{Martínez}{Martinez}-Vilalta J, Coll L, Llorens P, Casals P, Poyatos R, Pausas JG, Brotons L. (2015) Coupling a water balance model with forest inventory data to predict drought stress: the role of forest structural changes vs. climate changes. Agricultural and Forest Meteorology 213: 77-90 (doi:10.1016/j.agrformet.2015.06.012).

De \enc{Cáceres}{Caceres} M, Mencuccini M, Martin-StPaul N, Limousin JM, Coll L, Poyatos R, Cabon A, Granda V, Forner A, Valladares F, \enc{Martínez}{Martinez}-Vilalta J (2021) Unravelling the effect of species mixing on water use and drought stress in holm oak forests: a modelling approach. Agricultural and Forest Meteorology 296 (doi:10.1016/j.agrformet.2020.108233).

Jarvis, N.J., Jansson, P‐E., Dik, P.E. & Messing, I. (1991). Modelling water and solute transport in macroporous soil. I. Model description and sensitivity analysis. Journal of Soil Science, 42, 59–70.

Larsbo, M., Roulier, S., Stenemo, F., Kasteel, R. & Jarvis, N. (2005). An Improved Dual‐Permeability Model of Water Flow and Solute Transport in the Vadose Zone. Vadose Zone Journal, 4, 398–406.

Granier A, \enc{Bréda}{Breda} N, Biron P, Villette S (1999) A lumped water balance model to evaluate duration and intensity of drought constraints in forest stands. Ecol Modell 116:269–283. https://doi.org/10.1016/S0304-3800(98)00205-1.

Ruffault J, Pimont F, Cochard H, Dupuy JL, Martin-StPaul N (2022)
SurEau-Ecos v2.0: a trait-based plant hydraulics model for simulations of plant water status and drought-induced mortality at the ecosystem level.
Geoscientific Model Development 15, 5593-5626 (doi:10.5194/gmd-15-5593-2022).

Sperry, J. S., M. D. Venturas, W. R. L. Anderegg, M. Mencuccini, D. S. Mackay, Y. Wang, and D. M. Love. 2017. Predicting stomatal responses to the environment from the optimization of photosynthetic gain and hydraulic cost. Plant Cell and Environment 40, 816-830 (doi: 10.1111/pce.12852).
}
\seealso{
\code{\link{spwbInput}}, \code{\link{spwb_day}}, \code{\link{plot.spwb}},
\code{\link{extract}}, \code{\link{summary.spwb}},  \code{\link{forest}},
\code{\link{pwb}}, \code{\link{growth}}, \code{\link{aspwb}}
}
\author{
\itemize{
\item{Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF}
\item{Nicolas Martin-StPaul, URFM-INRAE}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dataset_documentation.R
\docType{data}
\name{SFM_metric}
\alias{SFM_metric}
\title{Standard fuel models (Albini 1976, Scott & Burgan 2005)}
\format{
A data frame including standard fuel models as in Albini (1976) and Scott and Burgan (2005), to be used as input of \code{\link{fire_Rothermel}} function. All values converted to metric format.
\describe{
\item{\code{Fuel_Model_Type}}{A factor with levels \code{D} (for dynamic) or \code{S} (for static).}
\item{\code{Load_1h}}{Loading of 1h fuel class [t/ha].}
\item{\code{Load_10h}}{Loading of 10h fuel class [t/ha].}
\item{\code{Load_100h}}{Loading of 100h fuel class [t/ha]}
\item{\code{Load_Live_Herb}}{Loading of herbaceous fuels [t/ha]}
\item{\code{Load_Live_Woody}}{Loading of woody fuels [t/ha]}
\item{\samp{SA/V_1h}}{Surface area to volume ratio of 1h fuel class [m2/m3]}
\item{\samp{SA/V_10h}}{Surface area to volume ratio of 10h fuel class [m2/m3]}
\item{\samp{SA/V_100h}}{Surface area to volume ratio of 100h fuel class [m2/m3]}
\item{\samp{SA/V_Live_Herb}}{Surface area to volume ratio of herbaceous fuels [m2/m3]}
\item{\samp{SA/V_Live_Woody}}{Surface area to volume ratio of woody fuels [m2/m3]}
\item{\code{Fuel_Bed_Depth}}{Fuel bed depth [cm]}
\item{\code{Mx_dead}}{Dead fuel moisture of extinction [percent]}
\item{\code{Heat_1h}}{Heat content of 1h fuel class [kJ/kg]}
\item{\code{Heat_10h}}{Heat content of 10h fuel class [kJ/kg]}
\item{\code{Heat_100h}}{Heat content of 100h fuel class [kJ/kg]}
\item{\code{Heat_Live_Herb}}{Heat content of herbaceous fuels [kJ/kg]}
\item{\code{Heat_Live_Woody}}{Heat content of woody fuels [kJ/kg]}
}
}
\source{
Albini, F. A. (1976). Computer-based models of wildland fire behavior: A users' manual. Ogden, UT: US Department of Agriculture, Forest Service, Intermountain Forest and Range Experiment Station.

Scott, J., and Burgan, R. E. (2005). A new set of standard fire behavior fuel models for use with Rothermel's surface fire spread model. Gen. Tech. Rep. RMRSGTR-153. Fort Collins, CO: US Department of Agriculture, Forest Service, Rocky Mountain Research Station.
}
\description{
Standard fuel models converted to metric system. Copied from package 'Rothermel' (Giorgio Vacchiano, Davide Ascoli).
}
\examples{
data(SFM_metric)
}
\seealso{
\code{\link{fire_Rothermel}}
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R,
%   R/hydraulics_supplyFunctionPlot.R
\name{hydraulics_E2psiBelowground}
\alias{hydraulics_E2psiBelowground}
\alias{hydraulics_E2psiAboveground}
\alias{hydraulics_E2psiNetwork}
\alias{hydraulics_supplyFunctionOneXylem}
\alias{hydraulics_supplyFunctionTwoElements}
\alias{hydraulics_supplyFunctionThreeElements}
\alias{hydraulics_supplyFunctionBelowground}
\alias{hydraulics_supplyFunctionAboveground}
\alias{hydraulics_supplyFunctionNetwork}
\alias{hydraulics_regulatedPsiXylem}
\alias{hydraulics_regulatedPsiTwoElements}
\alias{hydraulics_supplyfunctions}
\alias{hydraulics_EXylem}
\alias{hydraulics_E2psiXylem}
\alias{hydraulics_E2psiXylemUp}
\alias{hydraulics_EVanGenuchten}
\alias{hydraulics_ECrit}
\alias{hydraulics_E2psiVanGenuchten}
\alias{hydraulics_E2psiTwoElements}
\alias{hydraulics_initSperryNetworks}
\alias{hydraulics_supplyFunctionPlot}
\title{Hydraulic supply functions}
\usage{
hydraulics_E2psiBelowground(E, hydraulicNetwork, psiIni = as.numeric(c(0)))

hydraulics_E2psiAboveground(E, psiRootCrown, hydraulicNetwork)

hydraulics_E2psiNetwork(E, hydraulicNetwork, psiIni = as.numeric(c(0)))

hydraulics_supplyFunctionOneXylem(
  psiSoil,
  v,
  kstemmax,
  stemc,
  stemd,
  psiCav = 0,
  maxNsteps = 200L,
  dE = 0.01
)

hydraulics_supplyFunctionTwoElements(
  Emax,
  psiSoil,
  krhizomax,
  kxylemmax,
  n,
  alpha,
  c,
  d,
  psiCav = 0,
  dE = 0.1,
  psiMax = -10
)

hydraulics_supplyFunctionThreeElements(
  Emax,
  psiSoil,
  krhizomax,
  kxylemmax,
  kleafmax,
  n,
  alpha,
  stemc,
  stemd,
  leafc,
  leafd,
  psiCav = 0,
  dE = 0.1,
  psiMax = -10
)

hydraulics_supplyFunctionBelowground(
  hydraulicNetwork,
  minFlow = 0,
  pCrit = 0.001
)

hydraulics_supplyFunctionAboveground(
  Erootcrown,
  psiRootCrown,
  hydraulicNetwork
)

hydraulics_supplyFunctionNetwork(hydraulicNetwork, minFlow = 0, pCrit = 0.001)

hydraulics_regulatedPsiXylem(E, psiUpstream, kxylemmax, c, d, psiStep = -0.01)

hydraulics_regulatedPsiTwoElements(
  Emax,
  psiSoil,
  krhizomax,
  kxylemmax,
  n,
  alpha,
  c,
  d,
  dE = 0.1,
  psiMax = -10
)

hydraulics_EXylem(
  psiPlant,
  psiUpstream,
  kxylemmax,
  c,
  d,
  allowNegativeFlux,
  psiCav
)

hydraulics_E2psiXylem(E, psiUpstream, kxylemmax, c, d, psiCav)

hydraulics_E2psiXylemUp(E, psiDownstream, kxylemmax, c, d, psiCav)

hydraulics_EVanGenuchten(psiRhizo, psiSoil, krhizomax, n, alpha, l)

hydraulics_ECrit(psiUpstream, kxylemmax, c, d, pCrit)

hydraulics_E2psiVanGenuchten(E, psiSoil, krhizomax, n, alpha, psiStep, psiMax)

hydraulics_E2psiTwoElements(
  E,
  psiSoil,
  krhizomax,
  kxylemmax,
  n,
  alpha,
  c,
  d,
  psiCav,
  psiStep,
  psiMax
)

hydraulics_initSperryNetworks(x)

hydraulics_supplyFunctionPlot(
  x,
  draw = TRUE,
  type = "E",
  speciesNames = FALSE,
  ylim = NULL
)
}
\arguments{
\item{E}{Flow per surface unit.}

\item{hydraulicNetwork}{List with the hydraulic characteristics of nodes in the hydraulic network.}

\item{psiIni}{Vector of initial water potential values (in MPa).}

\item{psiRootCrown}{Soil water potential (in MPa) at the root crown.}

\item{psiSoil}{Soil water potential (in MPa). A scalar or a vector depending on the function.}

\item{v}{Proportion of fine roots within each soil layer.}

\item{kstemmax}{Maximum stem xylem hydraulic conductance (defined as flow per leaf surface unit and per pressure drop).}

\item{stemc, stemd}{Parameters of the Weibull function for stems (stem xylem vulnerability curve).}

\item{psiCav}{Minimum water potential (in MPa) experienced (for irreversible cavitation).}

\item{maxNsteps}{Maximum number of steps in the construction of supply functions.}

\item{dE}{Increment of flow per surface unit.}

\item{Emax}{Maximum flow per surface unit.}

\item{krhizomax}{Maximum rhizosphere hydraulic conductance (defined as flow per leaf surface unit and per pressure drop).}

\item{kxylemmax}{Maximum xylem hydraulic conductance (defined as flow per leaf surface unit and per pressure drop).}

\item{n, alpha, l}{Parameters of the Van Genuchten function (rhizosphere vulnerability curve).}

\item{c, d}{Parameters of the Weibull function (generic xylem vulnerability curve).}

\item{psiMax}{Minimum (maximum in absolute value) water potential to be considered (in MPa).}

\item{kleafmax}{Maximum leaf hydraulic conductance (defined as flow per leaf surface unit and per pressure drop).}

\item{leafc, leafd}{Parameters of the Weibull function for leaves (leaf vulnerability curve).}

\item{minFlow}{Minimum flow in supply function.}

\item{pCrit}{Critical water potential (in MPa).}

\item{Erootcrown}{Flow per surface unit at the root crown.}

\item{psiUpstream}{Water potential upstream (in MPa). In a one-component model corresponds to soil potential. In a two-component model corresponds to the potential inside the roots.}

\item{psiStep}{Water potential precision (in MPa).}

\item{psiPlant}{Plant water potential (in MPa).}

\item{allowNegativeFlux}{A boolean to indicate whether negative flux (i.e. from plant to soil) is allowed.}

\item{psiDownstream}{Water potential upstream (in MPa).}

\item{psiRhizo}{Soil water potential (in MPa) in the rhizosphere (root surface).}

\item{x}{An object of class \code{\link{spwbInput}}.}

\item{draw}{A flag to indicate whether the supply function should be drawn or just returned.}

\item{type}{Plot type for \code{hydraulics_supplyFunctionPlot}, either \code{"E"},
\code{"ERhizo"}, \code{"StemPsi"}, \code{"RootPsi"} or \code{"dEdP"}).}

\item{speciesNames}{A flag to indicate the use of species names instead of cohort names in plots.}

\item{ylim}{Graphical parameter to override function defaults.}
}
\value{
Values returned for each function are:
\itemize{
\item{\code{hydraulics_E2psiXylem}: The plant (leaf) water potential (in MPa) corresponding to the input flow, according to the xylem supply function and given an upstream (soil or root) water potential.}
\item{\code{hydraulics_E2psiVanGenuchten}: The root water potential (in MPa) corresponding to the input flow, according to the rhizosphere supply function and given a soil water potential.}
\item{\code{hydraulics_E2psiTwoElements}: The plant (leaf) water potential (in MPa) corresponding to the input flow, according to the rhizosphere and plant supply functions and given an input soil water potential.}
\item{\code{hydraulics_E2psiNetwork}: The rhizosphere, root crown and plant (leaf water potential (in MPa) corresponding to the input flow, according to the vulnerability curves of rhizosphere, root and stem elements in a network.}
\item{\code{hydraulics_Ecrit}: The critical flow according to the xylem supply function and given an input soil water potential.}
\item{\code{hydraulics_EVanGenuchten}: The flow (integral of the vulnerability curve) according to the rhizosphere supply function and given an input drop in water potential (soil and rhizosphere).}
\item{\code{hydraulics_EXylem}: The flow (integral of the vulnerability curve) according to the xylem supply function and given an input drop in water potential (rhizosphere and plant).}
\item{\code{hydraulics_supplyFunctionOneXylem}, \code{hydraulics_supplyFunctionTwoElements} and
\code{hydraulics_supplyFunctionNetwork}: A list with different numeric vectors with information of the two-element supply function:
\itemize{
\item{\code{E}: Flow values (supply values).}
\item{\code{FittedE}: Fitted flow values (for \code{hydraulics_supplyFunctionTwoElements}).}
\item{\code{Elayers}: Flow values across the roots of each soil layer (only for \code{hydraulics_supplyFunctionNetwork}).}
\item{\code{PsiRhizo}: Water potential values at the root surface (only for \code{hydraulics_supplyFunctionNetwork}).}
\item{\code{PsiRoot}: Water potential values inside the root crown (not for \code{hydraulics_supplyFunctionOneXylem}).}
\item{\code{PsiPlant}: Water potential values at the canopy (leaf).}
\item{\code{dEdP}: Derivatives of the supply function.}
}
}
\item{\code{hydraulics_supplyFunctionPlot}: If \code{draw = FALSE} a list with the result of calling \code{hydraulics_supplyFunctionNetwork} for each cohort. }
\item{\code{hydraulics_regulatedPsiXylem}: Plant water potential after regulation (one-element loss function) given an input water potential.}
\item{\code{hydraulics_regulatedPsiTwoElements}: Plant water potential after regulation (two-element loss function) given an input soil water potential.}
}
}
\description{
Set of functions used in the implementation of hydraulic supply functions (Sperry and Love 2015).
}
\details{
Function \code{hydraulics_supplyFunctionPlot} draws a plot of the supply function for the given \code{soil} object and network properties of each plant cohort in \code{x}. Function \code{hydraulics_vulnerabilityCurvePlot} draws a plot of the vulnerability curves for the given \code{soil} object and network properties of each plant cohort in \code{x}.
}
\examples{
kstemmax = 4 # in mmol·m-2·s-1·MPa-1
stemc = 3 
stemd = -4 # in MPa
psiVec = seq(-0.1, -7.0, by =-0.01)

#Vulnerability curve
kstem = unlist(lapply(psiVec, hydraulics_xylemConductance, kstemmax, stemc, stemd))
plot(-psiVec, kstem, type="l",ylab="Xylem conductance (mmol·m-2·s-1·MPa-1)", 
     xlab="Canopy pressure (-MPa)", lwd=1.5,ylim=c(0,kstemmax))

}
\references{
Sperry, J. S., F. R. Adler, G. S. Campbell, and J. P. Comstock. 1998. Limitation of plant water use by rhizosphere and xylem conductance: results from a model. Plant, Cell and Environment 21:347–359.

Sperry, J. S., and D. M. Love. 2015. What plant hydraulics can tell us about responses to climate-change droughts. New Phytologist 207:14–27.
}
\seealso{
\code{\link{hydraulics_psi2K}}, \code{\link{hydraulics_maximumStemHydraulicConductance}}, \code{\link{spwb}}, \code{\link{soil}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{species_values}
\alias{species_values}
\alias{species_basalArea}
\alias{species_cover}
\alias{species_density}
\alias{species_foliarBiomass}
\alias{species_fuelLoading}
\alias{species_LAI}
\alias{species_characterParameter}
\alias{species_parameter}
\title{Species description functions}
\usage{
species_basalArea(x, SpParams)

species_cover(x, SpParams)

species_density(x, SpParams)

species_foliarBiomass(x, SpParams, gdd = NA_real_)

species_fuelLoading(x, SpParams, gdd = NA_real_, includeDead = TRUE)

species_LAI(x, SpParams, gdd = NA_real_, bounded = TRUE)

species_characterParameter(species, SpParams, parName)

species_parameter(
  species,
  SpParams,
  parName,
  fillMissing = TRUE,
  fillWithGenus = TRUE
)
}
\arguments{
\item{x}{An object of class \code{\link{forest}}.}

\item{SpParams}{A data frame with species parameters (see \code{\link{SpParamsMED}}).}

\item{gdd}{Growth degree days (to account for leaf phenology effects).}

\item{includeDead}{A flag to indicate that standing dead fuels (dead branches) are included.}

\item{bounded}{A boolean flag to indicate that extreme values should be prevented (maximum tree LAI = 7 and maximum shrub LAI = 3)}

\item{species}{A character vector of species names.}

\item{parName}{A string with a parameter name.}

\item{fillMissing}{A boolean flag to try imputation on missing values.}

\item{fillWithGenus}{A boolean flag to try imputation of missing values using genus values.}
}
\value{
A vector with values for each species in \code{SpParams}:
\itemize{
\item{\code{species_basalArea}: Species basal area (m2/ha).}
\item{\code{species_cover}: Shrub cover (in percent).}
\item{\code{species_density}: Plant density (ind/ha). Tree density is directly taken from the forest object, while the shrub density is estimated from cover and height by calculating the area of a single individual.}
\item{\code{species_foliarBiomass}: Standing biomass of leaves (in kg/m2).}
\item{\code{species_fuel}: Fine fuel load (in kg/m2).}
\item{\code{species_LAI}: Leaf area index (m2/m2).}
\item{\code{species_phytovolume}: Shrub phytovolume (m3/m2).}
\item{\code{species_parameter}: A numeric vector with the parameter values of each input species.}
\item{\code{species_characterParameter}: A character vector with the parameter values of each input species.}
}
}
\description{
Functions to calculate attributes of a \code{\link{forest}} object by species or to extract species parameters from a species parameter table (\code{\link{SpParamsMED}}).
}
\examples{
# Default species parameterization
data(SpParamsMED)

# Load example plot
data(exampleforest)

# Species basal area in the forest plot
species_basalArea(exampleforest, SpParamsMED)
  
# Value of parameter "Psi_Extract" for two species
species_parameter(c("Pinus halepensis", "Quercus ilex"), SpParamsMED, "Psi_Extract")
    
}
\seealso{
\code{\link{spwb}}, \code{\link{forest}}, \code{\link{plant_basalArea}}, \code{\link{summary.forest}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{pheno_updateLeaves}
\alias{pheno_updateLeaves}
\alias{pheno_leafDevelopmentStatus}
\alias{pheno_leafSenescenceStatus}
\alias{pheno_updatePhenology}
\title{Leaf phenology}
\usage{
pheno_leafDevelopmentStatus(Sgdd, gdd, unfoldingDD = 300)

pheno_leafSenescenceStatus(Ssen, sen)

pheno_updatePhenology(x, doy, photoperiod, tmean)

pheno_updateLeaves(x, wind, fromGrowthModel)
}
\arguments{
\item{Sgdd}{Degree days required for leaf budburst (in Celsius).}

\item{gdd}{Cumulative degree days (in Celsius)}

\item{unfoldingDD}{Degree-days for complete leaf unfolding after budburst has occurred.}

\item{Ssen}{Threshold to start leaf senescence.}

\item{sen}{Cumulative senescence variable.}

\item{x}{An object of class \code{\link{spwbInput}}.}

\item{doy}{Day of the year.}

\item{photoperiod}{Day length (in hours).}

\item{tmean}{Average day temperature (in Celsius).}

\item{wind}{Average day wind speed (in m/s).}

\item{fromGrowthModel}{Boolean flag to indicate that routine is called from \code{\link{growth}} simulation function.}
}
\value{
Function \code{pheno_leafDevelopmentStatus} returns a vector of values between 0 and 1,
whereas function \code{pheno_leafSenescenceStatus} returns a vector of 0 (senescent) and 1 (expanded) values.
The other two functions do not return any value (see note).
}
\description{
Function \code{pheno_leafDevelopmentStatus} returns the expanded status (0 to 1) of leaves according to the growth degree days required to start bud burst and leaf unfolding, as dictated by a simple ecodormancy (one-phase) model (Chuine et al. 2013).
Function \code{pheno_leafSenescenceStatus} returns the 0/1 senescence status of leaves according to the one-phase senescence model of Delpierre et al. (2009) on the basis of photoperiod and temperature.
Function \code{pheno_updateLeaves} updates the status of expanded leaves and dead leaves of object \code{x} given the photoperiod, temperature and wind of a given day. It applies the development model for 1 < doy < 180 and the senescence model for 181 > doy > 365.
}
\note{
Functions \code{pheno_updatePhenology} and \code{pheno_updateLeaves} modify the input object \code{x}. The first modifies phenological state and the second modifies the leaf area accordingly.
}
\references{
Chuine, I., De Cortazar-Atauri, I.G., Kramer, K., \enc{Hänninen}{Hanninen}, H., 2013. Plant development models. Phenology: An Integrative Environmental Science. Springer, pp. 275–293.

Delpierre N, Dufrêne E, Soudani K et al (2009) Modelling interannual and spatial variability of leaf senescence for three deciduous tree species in France. Agric For Meteorol 149:938–948. doi:10.1016/j.agrformet.2008.11.014
}
\seealso{
\code{\link{spwb}}, \code{\link{spwbInput}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/resistances.R
\name{resistances}
\alias{resistances}
\title{Soil-plant resistances}
\usage{
resistances(
  x,
  cohort,
  relative = FALSE,
  draw = FALSE,
  cumulative = FALSE,
  xlab = NULL,
  ylab = NULL
)
}
\arguments{
\item{x}{An object of class \code{\link{spwb}}, \code{\link{pwb}}, \code{\link{growth}} or \code{\link{fordyn}}.
The function only works with the result of simulations with \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}.}

\item{cohort}{An string indicating the cohort for which resistances are desired.}

\item{relative}{A boolean flag to indicate that relative percentages are desired as output.}

\item{draw}{A boolean flag to indicate that a plot should be drawn (only pathway resistances, without discriminating between soil layers).}

\item{cumulative}{A flag to indicate that drawn series should be cumulative.}

\item{xlab}{x-axis label.}

\item{ylab}{y-axis label.}
}
\value{
If \code{draw = FALSE}, the function returns list with three items:
\itemize{
\item{\code{pathway}: A data frame with dates in rows and resistance segments in columns (Rhizosphere, Root, Stem and Leaf). }
\item{\code{root}: A data frame with dates in rows and root resistances for soil layers in columns.}
\item{\code{rhizosphere}: A data frame with dates in rows and rhizosphere resistances for soil layers in columns. }
}
Values depend on whether \code{relative = TRUE} (percentages) or \code{relative = FALSE} (absolute resistance values).

If \code{draw = TRUE}, a plot object is returned showing the time series of pathway resistances.
}
\description{
Calculates and draws rhizosphere, root, stem and leaf resistances for simulation time steps
}
\details{
The function makes internal calls to \code{\link{hydraulics_soilPlantResistancesWeibull}} or
\code{\link{hydraulics_soilPlantResistancesSigmoid}} depending on the value of \code{transpirationMode} in \code{x}.
}
\seealso{
\code{\link{waterUseEfficiency}}, \code{\link{droughtStress}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF

\enc{Léa}{Lea} Veuillen, INRAE-URFM
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transp_maximumTranspirationModel.R
\name{transp_maximumTranspirationModel}
\alias{transp_maximumTranspirationModel}
\title{Maximum transpiration vs. LAI}
\usage{
transp_maximumTranspirationModel(
  x,
  meteo,
  latitude,
  elevation,
  slope,
  aspect,
  LAI_seq = c(0.1, 0.25, seq(0.5, 10, by = 0.5)),
  draw = TRUE
)
}
\arguments{
\item{x}{An object of class \code{\link{spwbInput}}, built using the 'Sperry' transpiration mode.}

\item{meteo}{A data frame with daily meteorological data series.}

\item{latitude}{Latitude (in degrees).}

\item{elevation, slope, aspect}{Elevation above sea level (in m), slope (in degrees) and aspect (in degrees from North).}

\item{LAI_seq}{Sequence of stand LAI values to be tested.}

\item{draw}{Logical flag to indicate plotting of results.}
}
\value{
Returns a list with as many elements as plant cohorts, each element being a \code{\link{glm}} model.
}
\description{
Builds a model of maximum transpiration (Tmax) over potential evapotranspiration (PET) for increasing leaf area index (LAI) values for each plant cohort.
}
\details{
This function performs a meta-modelling exercise using the Sperry transpiration model, with the aim to estimate coefficients
for the equation used in the Granier transpiration model (Granier et al. 1999). The model to be fitted is: \code{y ~ a*LAI + b*LAI^2},
where \code{y} is the ratio between maximum transpiration (Tmax) and Penman's potential evapotranspiration (PET) and \code{LAI} is the stand LAI.
Unlike the original equation of Granier et al. (1999), we fit a zero intercept model so that LAI = 0 translates into zero plant transpiration.

The function fits the model for each cohort separately, assuming it represents the whole stand.
For each stand LAI value in the input sequence, the function uses simulations with Sperry transpiration and the input weather to estimate \code{y = Tmax/PET}
as a function of stand's LAI (deciduous stands include leaf phenology).
Once simulations have been conducted for each stand LAI value, the function fits a Generalized Linear Model with the above equation,
assuming a Gamma distribution of residuals and an identity link.

The coefficients of the model can be used to parametrize Granier's transpiration,
since coefficients \code{a} and \code{b} in the equation above correspond to parameters \code{Tmax_LAI} and \code{Tmax_LAIsq},
respectively (see \code{\link{SpParamsMED}}).
}
\examples{
\donttest{
#Load example daily meteorological data
data(examplemeteo)

# Load example plot plant data
data(exampleforest)

# Load default species parameters
data(SpParamsMED)

# Define soil with default soil params
examplesoil <- defaultSoilParams(4)

# Initialize control parameters for 'Sperry' transpiration mode
control <- defaultControl(transpirationMode="Sperry")

# Initialize input
x2 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)

# Estimate maximum transpiration ratio models for each cohort
# Weather is subset to speed-up results
m <- transp_maximumTranspirationModel(x2, examplemeteo[1:10,], 
                                     41.82592, elevation = 100, 
                                     slope = 0, aspect = 0)

# Inspect the model for first cohort
m[[1]]
}

}
\references{
Granier A, \enc{Bréda}{Breda} N, Biron P, Villette S (1999) A lumped water balance model to evaluate duration and intensity of drought constraints in forest stands. Ecol Modell 116:269–283. https://doi.org/10.1016/S0304-3800(98)00205-1.
}
\seealso{
\code{\link{spwb}}, \code{\link{transp_transpirationGranier}}, \code{\link{transp_transpirationSperry}}, \code{\link{SpParamsMED}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/modifySpParams.R
\name{modifyParams}
\alias{modifyParams}
\alias{modifySpParams}
\alias{modifyCohortParams}
\alias{modifyInputParams}
\title{Modify parameters}
\usage{
modifySpParams(SpParams, customParams, subsetSpecies = TRUE)

modifyCohortParams(x, customParams, verbose = TRUE)

modifyInputParams(x, customParams, verbose = TRUE)
}
\arguments{
\item{SpParams}{A species parameter data frame, typically \code{\link{SpParamsMED}}.}

\item{customParams}{A data frame or a named vector with new parameter values (see details).}

\item{subsetSpecies}{A logical flag to indicate that the output data frame should include only those species mentioned in \code{customParams}.}

\item{x}{A model input object of class \code{\link{spwbInput}} or \code{\link{growthInput}}.}

\item{verbose}{A logical flag to indicate that messages should be printed on the console.}
}
\value{
Function \code{modifySpParams} returns a modified species parameter data frame.

Functions \code{modifyCohortParams} and \code{modifyInputParams} return a modified \code{\link{spwbInput}} or \code{\link{growthInput}} object. Note that modifications may affect other parameters beyond those indicated in \code{customParams}, as a result of parameter dependencies (see examples).
}
\description{
Routines to modify species parameter table or model input objects
}
\details{
When calling function \code{modifySpParams}, \code{customParams} should be a data frame with as many rows as species
and as many columns as parameters to modify, plus a column called 'Name' or 'Species' to match species names between the two tables. In both
cases, the function will match input strings with column 'Name' of \code{x}. Alternatively, \code{customParams} can contain a column 'SpIndex' for
matching of species indices, but this is deprecated.

When calling \code{modifyCohortParams}, \code{customParams} can be a data frame with as many rows as cohorts
and as many columns as parameters to modify, plus a column called 'Cohort' which will be matched with the cohort names
given by \code{\link{spwbInput}} or \code{\link{growthInput}}.
Alternatively, \code{customParams} can be a named list or named numeric vector as for \code{modifyInputParams}.

When calling \code{modifyInputParams}, \code{customParams} must be either a named list or a named numeric vector.
Cohort parameters are specified using the syntax "[cohortName]/[paramName]" for names (e.g. "T2_176/Z50" to modify parameter 'Z50' of cohort 'T2_176').
Soil layer parameters are specified using the syntax "[paramName]@#layer" for names, where #layer is the layer index (e.g. "rfc@1" will modify the rock fragment content of soil layer 1).
Control parameters are specified using either "[paramName]" (e.g "phloemConductanceFactor") or "[paramName]$[subParamName]" (e.g "maximumRelativeGrowthRates$leaf").
It may seem unnecessary to modify soil or control parameters via a function, but \code{modifyInputParams} is called from optimization functions (see \code{\link{optimization}}).
}
\examples{
#Load example daily meteorological data
data(examplemeteo)

#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Define soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

#Initialize control parameters
control <- defaultControl("Granier")

#Initialize input
x1 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)

# Cohort name for Pinus halepensis
PH_coh <- paste0("T1_", SpParamsMED$SpIndex[SpParamsMED$Name=="Pinus halepensis"])
PH_coh 

# Modify Z50 and Z95 of Pinus halepensis cohort 
customParams <- c(200,2000)
names(customParams) <- paste0(PH_coh,c("/Z50", "/Z95"))
x1m <- modifyInputParams(x1, customParams)

# Inspect original and modified objects 
x1$below
x1m$below

# Inspect dependencies: fine root distribution across soil layers
x1$belowLayers$V
x1m$belowLayers$V

# Modify rock fragment content and sand proportion of soil layer 1
x1s <- modifyInputParams(x1, c("rfc@1" = 5, "sand@1" = 10))

# Inspect original and modified soils 
x1$soil
x1s$soil

# When modifying growth input objects dependencies increase
x1 <- growthInput(exampleforest,examplesoil, SpParamsMED, control)
customParams <- c(2000,2)
names(customParams) <- paste0(PH_coh,c("/Al2As", "/LAI_live"))
x1m <- modifyInputParams(x1, customParams)

}
\seealso{
\code{\link{spwbInput}}, \code{\link{SpParamsMED}}, \code{\link{optimization}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/waterUseEfficiency.R
\name{waterUseEfficiency}
\alias{waterUseEfficiency}
\title{Water use efficiency}
\usage{
waterUseEfficiency(
  x,
  type = "Plant Ag/E",
  leaves = "average",
  freq = "days",
  draw = TRUE,
  ylim = NULL
)
}
\arguments{
\item{x}{An object of class \code{\link{spwb}}, \code{\link{pwb}}, \code{\link{growth}} or \code{\link{fordyn}}.}

\item{type}{A string to indicate the scale of WUE calculation. Either:
\itemize{
\item{\code{"Leaf iWUE"}: Leaf intrinsic WUE, i.e. instantaneous ratio between photosynthesis and stomatal conductance (only for simulations with \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"} and \code{subdailyResults = TRUE}). }
\item{\code{"Leaf Ci"}: Leaf intercellular CO2 concentration (only for simulations with \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"} and \code{subdailyResults = TRUE}).}
\item{\code{"Plant An/E"}: Plant (cohort) net photosynthesis over plant transpiration (only for simulations with \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"})}
\item{\code{"Stand An/E"}: Stand net photosynthesis over stand transpiration (only for simulations with \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"})}
\item{\code{"Plant Ag/E"}: Plant (cohort) gross photosynthesis over plant transpiration}
\item{\code{"Stand Ag/E"}: Stand gross photosynthesis over stand transpiration}
}}

\item{leaves}{Either \code{"sunlit"}, \code{"shade"} or \code{"average"}. Refers to the WUE of different leaf types or the average (with weights according to the LAI of sunlit and shade leaves). Only relevant for \code{type = "iWUE"}.}

\item{freq}{Frequency of summary statistics (see \code{\link{cut.Date}}).}

\item{draw}{A boolean flag to indicate that a plot should be returned.}

\item{ylim}{Range of values for y.}
}
\value{
If \code{draw=TRUE} a plot is returned. Otherwise, the function returns a matrix with WUE values,
where rows are dates (at the desired temporal scale), and columns are plant cohorts.
In the case of \code{type = "Plant Ag/E"}, \code{type = "Stand Ag/E"}, \code{type = "Plant An/E"} and \code{type = "Stand An/E"} values are in gC/L.
In the case of \code{type = "Leaf iWUE"} values are in micromol of carbon per mmol of water.
}
\description{
Calculates plant water use efficiency (WUE), at different temporal scales, from simulation results.
}
\details{
Temporal aggregation of WUE values is done differently depending on the value of \code{type}.
For \code{type = "Plant Ag/E"}, \code{type = "Stand Ag/E"}, \code{type = "Plant An/E"} and \code{type = "Stand An/E"} sums
or daily photosynthesis and transpiration are first calculated at the desired temporal scale and the ratio is calculated afterwards.
For \code{type = "Leaf iWUE"} intrinsic WUE values are first calculated at the daily scale (as averages of instantaneous An/gs ratios weighted by An)
and then they are aggregated to the desired scale by calculating weighted averages, where weights are given by daily photosynthesis.
}
\seealso{
\code{\link{droughtStress}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{hydrology_soilWaterBalance}
\alias{hydrology_soilWaterBalance}
\title{Soil water balance}
\usage{
hydrology_soilWaterBalance(
  soil,
  soilFunctions,
  rainfallInput,
  rainfallIntensity,
  snowmelt,
  sourceSink,
  runon = 0,
  lateralFlows = NULL,
  waterTableDepth = NA_real_,
  infiltrationMode = "GreenAmpt1911",
  infiltrationCorrection = 5,
  soilDomains = "buckets",
  nsteps = 24L,
  max_nsubsteps = 3600L,
  modifySoil = TRUE
)
}
\arguments{
\item{soil}{Object of class \code{\link{soil}}.}

\item{soilFunctions}{Soil water retention curve and conductivity functions, either 'SX' (for Saxton) or 'VG' (for Van Genuchten).}

\item{rainfallInput}{Amount of water from rainfall event (after excluding interception), in mm.}

\item{rainfallIntensity}{Rainfall intensity, in mm/h.}

\item{snowmelt}{Amount of water originated from snow melt, in mm.}

\item{sourceSink}{Local source/sink term for each soil layer (from soil evaporation or plant transpiration/redistribution)
as mm/day.}

\item{runon}{Surface water amount running on the target area from upslope (in mm).}

\item{lateralFlows}{Lateral source/sink terms for each soil layer (interflow/to from adjacent locations) as mm/day.}

\item{waterTableDepth}{Water table depth (in mm). When not missing, capillarity rise will be allowed if lower than total soil depth.}

\item{infiltrationMode}{Infiltration model, either "GreenAmpt1911" or "Boughton1989"}

\item{infiltrationCorrection}{Correction for saturated conductivity, to account for increased infiltration due to macropore presence}

\item{soilDomains}{Either "buckets" (multi-bucket domain), "single" (for single-domain Richards) or "dual" (for dual-permeability model).}

\item{nsteps}{Number of time steps per day}

\item{max_nsubsteps}{Maximum number of substeps per time step}

\item{modifySoil}{Boolean flag to indicate that the input \code{soil} object should be modified during the simulation.}
}
\value{
Returns a named vector with different elements, depending on \code{soilDomains}.

If \code{soilDomains == "buckets"}:
\itemize{
\item{\code{Snowmelt}: Snowmelt input (mm).}
\item{\code{Source/sinks}: Sum of source/sink input across layers (mm).}
\item{\code{Infiltration}: Water infiltrated into the soil (mm).}
\item{\code{InfiltrationExcess}: Excess infiltration in the topmost layer (mm) leading to an increase in runoff.}
\item{\code{SaturationExcess}: Excess saturation in the topmost layer (mm) leading to an increase in runoff.}
\item{\code{Runoff}: Surface runoff generated by saturation excess or infiltration excess (mm).}
\item{\code{DeepDrainage}: Water draining from the bottom layer (mm). This quantity is corrected to close the water balance.}
\item{\code{CapillarityRise}: Water entering the soil via capillarity rise (mm) from the water table, if \code{waterTableDepth} is supplied.}
}
If \code{soilDomains == "single"} the named vector contains the following additional elements:
\itemize{
\item{\code{Correction}: Amount of water (mm) added to deep drainage to correct the water balance.}
\item{\code{VolumeChange}: Change in soil water volume (mm).}
\item{\code{Substep}: Time step of the moisture solving (seconds).}
}
If \code{soilDomains == "dual"} the named vector contains the following additional elements:
\itemize{
\item{\code{Lateral flows}: Sum of water circulating between micropores and macropores, positive when filling micropores (mm).}
\item{\code{InfiltrationMatrix}: Water infiltrated into the soil matrix (mm).}
\item{\code{InfiltrationMacropores}: Water infiltrated into the soil macropore domain (mm).}
\item{\code{InfiltrationExcessMatrix/InfiltrationExcessMacropores}: Excess infiltration in the topmost layer (mm) leading to an increase in runoff.}
\item{\code{SaturationExcessMatrix/SaturationExcessMacropores}: Excess saturation in the topmost layer (mm) leading to an increase in runoff.}
\item{\code{DrainageMatrix}: Water draining from the bottom layer of the matrix domain (mm). This quantity is corrected to close water balance in the micropore domain.}
\item{\code{DrainageMacropores}: Water draining from the bottom layer of the macropore domain (mm). This quantity is corrected to close the water balance in the macropore domain.}
\item{\code{CorrectionMatrix}: Amount of water (mm) added to deep drainage of soil matrix to correct the water balance.}
\item{\code{CorrectionMacropores}: Amount of water (mm) added to deep drainage of macropores to correct the water balance.}
\item{\code{MatrixVolumeChange}: Change in soil water volume in the soil matrix domain (mm).}
\item{\code{MacroporeVolumeChange}: Change in soil water volume in the macropore domain (mm).}
}
}
\description{
Function \code{hydrology_soilWaterBalance} estimates water balance of soil layers given water inputs/outputs, including the simulation of water movement within the soil.
}
\details{
The multi-bucket model adds/substracts water to each layer and if content is above field capacity the excess percolates to the layer below.
If there is still an excess for the bottom layer, the model will progressively fill upper layers (generating saturation excess if the first layer
becomes saturated). Every day the some layers are over field capacity, the model simulates deep drainage.

The single-domain model simulates water flows by solving Richards's equation using the predictor-corrector method, as described in
Bonan et al. (2019).

The dual-permeability model is an implementation of the model MACRO 5.0 (Jarvis et al. 1991; Larsbo et al. 2005).

Both the multi-bucket and the single-domain model can apply a correction to the infiltration rate to account for macroporosity in infiltration. In the
dual-permeability model extra infiltration through macropores is simulated explicitly.
}
\examples{
# Define soil parameters
spar <- defaultSoilParams(4)

# Initializes soil hydraulic parameters
examplesoil <- soil(spar)

# Water balance in a multi-bucket model
hydrology_soilWaterBalance(examplesoil, "VG", 10, 5, 0, c(-1,-1,-1,-1), 
                           soilDomains = "buckets", modifySoil = FALSE)
                           
# Water balance in a single-domain model (Richards equation)
hydrology_soilWaterBalance(examplesoil, "VG", 10, 5, 0, c(-1,-1,-1,-1), 
                           soilDomains = "single", modifySoil = FALSE)
                    
# Water balance in a dual-permeability model (MACRO)
hydrology_soilWaterBalance(examplesoil, "VG", 10, 5, 0, c(-1,-1,-1,-1), 
                           soilDomains = "dual", modifySoil = FALSE)
  
}
\references{
Bonan, G. (2019). Climate change and terrestrial ecosystem modeling. Cambridge University Press, Cambridge, UK.

Jarvis, N.J., Jansson, P‐E., Dik, P.E. & Messing, I. (1991). Modelling water and solute transport in macroporous soil. I. Model description and sensitivity analysis. Journal of Soil Science, 42, 59–70.

Larsbo, M., Roulier, S., Stenemo, F., Kasteel, R. & Jarvis, N. (2005). An Improved Dual‐Permeability Model of Water Flow and Solute Transport in the Vadose Zone. Vadose Zone Journal, 4, 398–406.
}
\seealso{
\code{\link{spwb}}, \code{\link{hydrology_waterInputs}}, \code{\link{hydrology_infiltration}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF

\enc{María González Sanchís}{Maria Gonzalez Sanchis}, UPV-CTFC
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{growth_day}
\alias{growth_day}
\title{Single-day forest growth}
\usage{
growth_day(
  x,
  date,
  meteovec,
  latitude,
  elevation,
  slope = NA_real_,
  aspect = NA_real_,
  runon = 0,
  lateralFlows = NULL,
  waterTableDepth = NA_real_,
  modifyInput = TRUE
)
}
\arguments{
\item{x}{An object of class \code{\link{growthInput}}.}

\item{date}{Date as string "yyyy-mm-dd".}

\item{meteovec}{A named numerical vector with weather data. See variable names in parameter \code{meteo} of \code{\link{spwb}}.}

\item{latitude}{Latitude (in degrees).}

\item{elevation, slope, aspect}{Elevation above sea level (in m), slope (in degrees) and aspect (in degrees from North).}

\item{runon}{Surface water amount running on the target area from upslope (in mm).}

\item{lateralFlows}{Lateral source/sink terms for each soil layer (interflow/to from adjacent locations) as mm/day.}

\item{waterTableDepth}{Water table depth (in mm). When not missing, capillarity rise will be allowed if lower than total soil depth.}

\item{modifyInput}{Boolean flag to indicate that the input \code{x} object is allowed to be modified during the simulation.}
}
\value{
Function \code{growth_day()} returns a list of class \code{growth_day} with the
same elements as \code{\link{spwb_day}} and the following:
\itemize{
\item{\code{"CarbonBalance"}: A vector of different stand-level carbon balance components (gross primary production, maintenance respiration, synthesis respiration, net primary production, heterotrophic respiration and net ecosystem exchange), all in g C · m-2.}
\item{\code{"LabileCarbonBalance"}: A data frame with labile carbon balance results for plant cohorts, with elements:}
\itemize{
\item{\code{"GrossPhotosynthesis"}: Daily gross photosynthesis per dry weight of living biomass (g gluc · g dry-1).}
\item{\code{"MaintentanceRespiration"}: Daily maintenance respiration per dry weight of living biomass (g gluc · g dry-1).}
\item{\code{"GrowthCosts"}: Daily growth costs per dry weight of living biomass (g gluc · g dry-1).}
\item{\code{"RootExudation"}: Root exudation per dry weight of living biomass (g gluc · g dry-1).}
\item{\code{"LabileCarbonBalance"}: Daily labile carbon balance (photosynthesis - maintenance respiration - growth costs - root exudation) per dry weight of living biomass (g gluc · g dry-1).}
\item{\code{"SugarLeaf"}: Sugar concentration (mol·l-1) in leaves.}
\item{\code{"StarchLeaf"}: Starch concentration (mol·l-1) in leaves.}
\item{\code{"SugarSapwood"}: Sugar concentration (mol·l-1) in sapwood.}
\item{\code{"StarchSapwood"}: Starch concentration (mol·l-1) in sapwood.}
\item{\code{"SugarTransport"}:  Average instantaneous rate of carbon transferred between leaves and stem compartments via floem (mol gluc·s-1).}
}
\item{\code{"PlantBiomassBalance"}: A data frame with plant biomass balance results for plant cohorts, with elements:}
\itemize{
\item{\code{"StructuralBiomassBalance"}: Daily structural biomass balance (g dry · m-2).}
\item{\code{"LabileBiomassBalance"}: Daily labile biomass balance (g dry · m-2).}
\item{\code{"PlantBiomassBalance"}: Daily plant biomass balance, i.e. labile change + structural change (g dry · m-2).}
\item{\code{"MortalityBiomassLoss"}: Biomass loss due to mortality (g dry · m-2).}
\item{\code{"CohortBiomassBalance"}: Daily cohort biomass balance (including mortality) (g dry · m-2).}
}
\item{\code{"PlantStructure"}: A data frame with area and biomass values for compartments of plant cohorts, with elements:}
\itemize{
\item{\code{"LeafBiomass"}: Leaf structural biomass (in g dry) for an average individual of each plant cohort.}
\item{\code{"SapwoodBiomass"}: Sapwood structural biomass (in g dry) for an average individual of each plant cohort.}
\item{\code{"FineRootBiomass"}: Fine root biomass (in g dry) for an average individual of each plant cohort.}
\item{\code{"LeafArea"}: Leaf area (in m2) for an average individual of each plant cohort.}
\item{\code{"SapwoodArea"}: Sapwood area (in cm2) for an average individual of each plant cohort.}
\item{\code{"FineRootArea"}: Fine root area (in m2) for an average individual of each plant cohort.}
\item{\code{"HuberValue"}: Sapwood area to (target) leaf area (in cm2/m2).}
\item{\code{"RootAreaLeafArea"}: The ratio of fine root area to (target) leaf area (in m2/m2).}
\item{\code{"DBH"}: Diameter at breast height (in cm) for an average individual of each plant cohort.}
\item{\code{"Height"}: Height (in cm) for an average individual of each plant cohort.}
}
\item{\code{"GrowthMortality"}: A data frame with growth and mortality rates for plant cohorts, with elements:}
\itemize{
\item{\code{"LAgrowth"}: Leaf area growth (in m2·day-1) for an average individual of each plant cohort.}
\item{\code{"SAgrowth"}: Sapwood area growth rate (in cm2·day-1) for an average individual of each plant cohort.}
\item{\code{"FRAgrowth"}: Fine root area growth (in m2·day-1) for an average individual of each plant cohort.}
\item{\code{"StarvationRate"}: Mortality rate from starvation (ind/d-1).}
\item{\code{"DessicationRate"}: Mortality rate from dessication (ind/d-1).}
\item{\code{"MortalityRate"}: Mortality rate (any cause) (ind/d-1).}
}
}
}
\description{
Function \code{growth_day} performs water and carbon balance for a single day.
}
\details{
Detailed model description is available in the medfate book.

Forest growth simulations allow using different sub-models for bulk soil water flows and different sub-models of transpiration and photosynthesis (see details in \code{\link{spwb_day}}).
}
\examples{
#Load example daily meteorological data
data(examplemeteo)

#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Define soil parameters
examplesoil <- defaultSoilParams(4)

# Day to be simulated
d <- 100
meteovec <- unlist(examplemeteo[d,-1])
date <- as.character(examplemeteo$dates[d])

#Simulate water and carbon balance for one day only (Granier mode)
control <- defaultControl("Granier")
x4  <- growthInput(exampleforest,examplesoil, SpParamsMED, control)
sd4 <- growth_day(x4, date, meteovec,
                latitude = 41.82592, elevation = 100, slope=0, aspect=0)

#Simulate water and carbon balance for one day only (Sperry mode)
control <- defaultControl("Sperry")
x5  <- growthInput(exampleforest,examplesoil, SpParamsMED, control)
sd5 <- growth_day(x5, date, meteovec,
                latitude = 41.82592, elevation = 100, slope=0, aspect=0)

#Simulate water and carbon balance for one day only (Sureau mode)
control <- defaultControl("Sureau")
x6  <- growthInput(exampleforest,examplesoil, SpParamsMED, control)
sd6 <- growth_day(x6, date, meteovec,
                latitude = 41.82592, elevation = 100, slope=0, aspect=0)

}
\references{
De \enc{Cáceres}{Caceres} M, \enc{Martínez}{Martinez}-Vilalta J, Coll L, Llorens P, Casals P, Poyatos R, Pausas JG, Brotons L. (2015) Coupling a water balance model with forest inventory data to predict drought stress: the role of forest structural changes vs. climate changes. Agricultural and Forest Meteorology 213: 77-90 (doi:10.1016/j.agrformet.2015.06.012).

De \enc{Cáceres}{Caceres} M, Mencuccini M, Martin-StPaul N, Limousin JM, Coll L, Poyatos R, Cabon A, Granda V, Forner A, Valladares F, \enc{Martínez}{Martinez}-Vilalta J (2021) Unravelling the effect of species mixing on water use and drought stress in holm oak forests: a modelling approach. Agricultural and Forest Meteorology 296 (doi:10.1016/j.agrformet.2020.108233).

Granier A, \enc{Bréda}{Breda} N, Biron P, Villette S (1999) A lumped water balance model to evaluate duration and intensity of drought constraints in forest stands. Ecol Modell 116:269–283. https://doi.org/10.1016/S0304-3800(98)00205-1.

Ruffault J, Pimont F, Cochard H, Dupuy JL, Martin-StPaul N (2022)
SurEau-Ecos v2.0: a trait-based plant hydraulics model for simulations of plant water status and drought-induced mortality at the ecosystem level.
Geoscientific Model Development 15, 5593-5626 (doi:10.5194/gmd-15-5593-2022).

Sperry, J. S., M. D. Venturas, W. R. L. Anderegg, M. Mencuccini, D. S. Mackay, Y. Wang, and D. M. Love. 2017. Predicting stomatal responses to the environment from the optimization of photosynthetic gain and hydraulic cost. Plant Cell and Environment 40, 816-830 (doi: 10.1111/pce.12852).
}
\seealso{
\code{\link{spwb_day}}, \code{\link{growthInput}}, \code{\link{growth}},
\code{\link{plot.growth_day}}
}
\author{
\itemize{
\item{Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF}
\item{Nicolas Martin-StPaul, URFM-INRAE}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R,
%   R/moisture_pressureVolumeCurvePlot.R
\name{moisture}
\alias{moisture}
\alias{moisture_sapwoodWaterCapacity}
\alias{plant_water}
\alias{moisture_leafWaterCapacity}
\alias{moisture_turgorLossPoint}
\alias{moisture_symplasticRWC}
\alias{moisture_symplasticPsi}
\alias{moisture_apoplasticRWC}
\alias{moisture_apoplasticPsi}
\alias{moisture_tissueRWC}
\alias{moisture_pressureVolumeCurvePlot}
\title{Tissue moisture functions}
\usage{
moisture_sapwoodWaterCapacity(Al2As, height, V, L, wd)

plant_water(x)

moisture_leafWaterCapacity(SLA, ld)

moisture_turgorLossPoint(pi0, epsilon)

moisture_symplasticRWC(psiSym, pi0, epsilon)

moisture_symplasticPsi(RWC, pi0, epsilon)

moisture_apoplasticRWC(psiApo, c, d)

moisture_apoplasticPsi(RWC, c, d)

moisture_tissueRWC(psiSym, pi0, epsilon, psiApo, c, d, af)

moisture_pressureVolumeCurvePlot(
  x,
  segment = "stem",
  fraction = "all",
  psiVec = seq(-0.1, -8, by = -0.01),
  speciesNames = FALSE
)
}
\arguments{
\item{Al2As}{Leaf area to sapwood area (in m2·m-2).}

\item{height}{Plant height (in cm).}

\item{V}{Vector with the proportion [0-1] of fine roots within each soil layer.}

\item{L}{Vector with the length of coarse roots (mm) for each soil layer.}

\item{wd}{Wood density (g·cm-3).}

\item{x}{An object of class \code{\link{spwbInput}} or \code{\link{growthInput}}.}

\item{SLA}{Specific leaf area (mm2·mg-1).}

\item{ld}{Leaf tissue density (g·cm-3).}

\item{pi0}{Full turgor osmotic potential (MPa).}

\item{epsilon}{Bulk modulus of elasticity (MPa).}

\item{psiSym, psiApo}{Symplastic or apoplastic water potential (MPa).}

\item{RWC}{Relative water content [0-1].}

\item{c, d}{Parameters of the xylem vulnerability curve.}

\item{af}{Apoplastic fraction (proportion) in the segment (e.g. leaf or stem).}

\item{segment}{Segment whose relative water content curve to plot, either \code{"stem"} or \code{"leaf"}
(the latter only available if \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}).}

\item{fraction}{Tissue fraction, either \code{"symplastic"}, \code{"apoplastic"} or \code{"all"}.}

\item{psiVec}{Vector of water potential values to evaluate for the pressure-volume curve.}

\item{speciesNames}{A flag to indicate the use of species names instead of cohort names in plots.}
}
\value{
Values returned for each function are:
\itemize{
\item{\code{moisture_symplasticRWC}: Relative water content [0-1] of the symplastic fraction.}
\item{\code{moisture_apoplasticRWC}: Relative water content [0-1] of the apoplastic fraction.}
\item{\code{moisture_symplasticWaterPotential}: Water potential (in MPa) of the symplastic fraction.}
\item{\code{moisture_apoplasticWaterPotential}: Water potential (in MPa) of the apoplastic fraction.}
\item{\code{moisture_turgorLossPoint}: Water potential (in MPa) corresponding to turgor loss point.}
\item{\code{moisture_segmentRWC}: Segment relative water content [0-1].}
\item{\code{water_plant}: A vector of water content (mm) per plant cohort.}
}
}
\description{
Set of functions used to calculate tissue moisture from water potential and viceversa.
}
\examples{
psi = seq(-10,0, by=0.1)
rwc_s = rep(NA, length(psi))
for(i in 1:length(psi)) rwc_s[i] = moisture_symplasticRWC(psi[i],-3,12)
plot(psi, rwc_s, type="l", xlab="Water potential (MPa)", ylab = "Symplasmic RWC")

}
\references{
Bartlett, M.K., Scoffoni, C., Sack, L. 2012. The determinants of leaf turgor loss point and prediction of drought tolerance of species and biomes: a global meta-analysis. Ecology Letters 15: 393–405.

\enc{Hölttä}{Holtta}, T., Cochard, H., Nikinmaa, E., Mencuccini, M. 2009. Capacitive effect of cavitation in xylem conduits: Results from a dynamic model. Plant, Cell and Environment 32: 10–21.

Martin-StPaul, N., Delzon, S., Cochard, H. 2017. Plant resistance to drought depends on timely stomatal closure. Ecology Letters 20: 1437–1447.
}
\seealso{
\code{\link{hydraulics_psi2K}}, \code{\link{hydraulics_supplyFunctionPlot}}, \code{\link{spwb}}, \code{\link{soil}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{biophysics}
\alias{biophysics}
\alias{biophysics_radiationDiurnalPattern}
\alias{biophysics_temperatureDiurnalPattern}
\alias{biophysics_leafTemperature}
\alias{biophysics_leafTemperature2}
\alias{biophysics_leafVapourPressure}
\alias{biophysics_irradianceToPhotonFlux}
\alias{biophysics_waterDynamicViscosity}
\title{Physical and biophysical utility functions}
\usage{
biophysics_radiationDiurnalPattern(t, daylength)

biophysics_temperatureDiurnalPattern(
  t,
  tmin,
  tmax,
  tminPrev,
  tmaxPrev,
  tminNext,
  daylength
)

biophysics_leafTemperature(absRad, airTemperature, u, E, leafWidth = 1)

biophysics_leafTemperature2(
  SWRabs,
  LWRnet,
  airTemperature,
  u,
  E,
  leafWidth = 1
)

biophysics_leafVapourPressure(leafTemp, leafPsi)

biophysics_irradianceToPhotonFlux(I, lambda = 546.6507)

biophysics_waterDynamicViscosity(temp)
}
\arguments{
\item{t}{Time of the day (in seconds).}

\item{daylength}{Day length (in seconds).}

\item{tmin, tmax}{Minimum and maximum daily temperature (ºC).}

\item{tminPrev, tmaxPrev, tminNext}{Maximum and minimum daily temperatures of the previous and following day (ºC).}

\item{absRad}{Absorbed long- and short-wave radiation (in W·m-2).}

\item{airTemperature}{Air temperature (in ºC).}

\item{u}{Wind speed above the leaf boundary layer (in m/s).}

\item{E}{Transpiration flow (in mmol H20·m-2·s-1) per one sided leaf area basis.}

\item{leafWidth}{Leaf width (in cm).}

\item{SWRabs}{Absorbed short-wave radiation (in W·m-2).}

\item{LWRnet}{Net long-wave radiation balance (in W·m-2).}

\item{leafTemp}{Leaf temperature (ºC).}

\item{leafPsi}{Leaf water potential (MPa).}

\item{I}{Irradiance (in W*m-2).}

\item{lambda}{Wavelength (in nm).}

\item{temp}{Temperature (ºC).}
}
\value{
Values returned for each function are:
\itemize{
\item{\code{biophysics_leafTemperature} and \code{biophysics_leafTemperature2}: leaf temperature (in ºC)}
\item{\code{biophysics_leafVapourPressure}: leaf vapour pressure (in kPa)}
\item{\code{biophysics_radiationDiurnalPattern}: the proportion of daily radiation corresponding to the input time in seconds after sunrise.}
\item{\code{biophysics_temperatureDiurnalPattern}: diurnal pattern of temperature.}
\item{\code{biophysics_waterDynamicViscosity}: Water dynamic viscosity relative to 20ºC.}
}
}
\description{
Internal utility functions for the calculation of biophysical variables.
}
\details{
Functions \code{biophysics_leafTemperature} and \code{biophysics_leafTemperature2} calculate leaf temperature according to energy balance equation given in Campbell and Norman (1988).

Function \code{biophysics_radiationDiurnalPattern} follows the equations given in Liu and Jordan (1960).

Function \code{biophysics_temperatureDiurnalPattern} determines diurnal temperature pattern assuming a sinusoidal pattern with T = Tmin at sunrise and T = (Tmin+Tmax)/2 at sunset and a linear change in temperature between sunset and Tmin of the day after (McMurtrie et al. 1990).

Function \code{biophysics_waterDynamicViscosity} calculates water dynamic viscosity following the Vogel (1921) equation.
}
\references{
Campbell, G. S., and J. M. Norman. 1998. An introduction to environmental biophysics: 2nd edition. (eqns. 14.1 & 14.3)

B. Y. H. Liu and R. C. Jordan, “The interrelationship and characteristic distribution of direct, diffuse and total solar radiation,” Solar Energy, vol. 4, no. 3, pp. 1–19, 1960.

McMurtrie, R. E., D. A. Rook, and F. M. Kelliher. 1990. Modelling the yield of Pinus radiata on a site limited by water and nitrogen. Forest Ecology and Management 30:381–413.

H. Vogel, "Das Temperaturabhangigkeitsgesetz der Viskositat von Flussigkeiten", Physikalische Zeitschrift, vol. 22, pp. 645–646, 1921.
}
\seealso{
\code{\link{spwb}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R, R/summary.soil.R
\name{soil}
\alias{soil}
\alias{summary.soil}
\title{Soil initialization}
\usage{
soil(x, VG_PTF = "Toth")

\method{summary}{soil}(object, model = "SX", ...)
}
\arguments{
\item{x}{A data frame of soil parameters (see an example in \code{\link{defaultSoilParams}}).}

\item{VG_PTF}{Pedotransfer functions to obtain parameters for the van Genuchten-Mualem equations. Either \code{"Carsel"} (Carsel and Parrish 1988) or \code{"Toth"} (Toth et al. 2015).}

\item{object}{An object of class \code{soil}.}

\item{model}{Either 'SX' or 'VG' for Saxton or Van Genuchten pedotransfer models.}

\item{...}{Additional parameters to \code{summary}.}
}
\value{
Function \code{soil} returns a data frame of class \code{soil} with the following columns:
\itemize{
\item{\code{widths}: Width of soil layers (in mm).}
\item{\code{sand}: Sand percentage for each layer (in percent volume).}
\item{\code{clay}: Clay percentage for each layer (in percent volume).}
\item{\code{om}: Organic matter percentage for each layer (in percent volume).}
\item{\code{nitrogen}: Sum of total nitrogen (ammonia, organic and reduced nitrogen) for each layer (in g/kg).}
\item{\code{ph}: pH in water of each layer (0-14).}
\item{\code{rfc}: Percentage of rock fragment content for each layer.}
\item{\code{macro}: Macroporosity for each layer (estimated using Stolf et al. 2011).}
\item{\code{Ksat}: Saturated soil conductivity for each layer (in mmol·m-1·s-1·MPa-1, estimated using function \code{\link{soil_saturatedConductivitySX}}.}
\item{\code{VG_alpha}, \code{VG_n}, \code{VG_theta_res}, \code{VG_theta_sat}: Parameters for van Genuchten's pedotransfer functions, for each layer, corresponding to the USDA texture type.}
\item{\code{W}: State variable with relative water content of each layer (in as proportion relative to FC).}
\item{\code{Temp}: State variable with temperature (in Celsius) of each layer.}
}
}
\description{
Initializes soil parameters and state variables for its use in simulations.
}
\details{
Function \code{summary} prompts a description of soil characteristics and state variables (water content and temperature)
according to a water retention curve (either Saxton's or Van Genuchten's).
Volume at field capacity is calculated assuming a soil water potential equal to fieldCapacityPsi MPa.
Parameter \code{Temp} is initialized as missing for all soil layers.

If available, the user can specify columns \code{VG_alpha}, \code{VG_n}, \code{VG_theta_res}, \code{VG_theta_sat} and \code{K_sat},
to override Van Genuchten parameters an saturated conductivity estimated from pedotransfer functions when calling function \code{soil}.
}
\examples{
# Default parameters
df_soil <- defaultSoilParams()

# Initializes soil
s <- soil(df_soil)
s

# Prints soil characteristics according to Saxton's water retention curve
summary(s, model="SX")

# Prints soil characteristics according to Van Genuchten's water retention curve
summary(s, model="VG")

# Add columns 'VG_theta_sat' and 'VG_theta_res' with custom values
df_soil$VG_theta_sat <- 0.400 
df_soil$VG_theta_res <- 0.040 

# Reinitialize soil (should override estimations)
s2 <- soil(df_soil)
s2
summary(s2, model="VG")
}
\references{
Carsel, R.F., and Parrish, R.S. 1988. Developing joint probability distributions of soil water retention characteristics. Water Resources Research 24: 755–769.

\enc{Tóth}{Toth}, B., Weynants, M., Nemes, A., \enc{Makó}{Mako}, A., Bilas, G., and \enc{Tóth}{Toth}, G. 2015. New generation of hydraulic pedotransfer functions for Europe. European Journal of Soil Science 66: 226–238.

Stolf, R., Thurler, A., Oliveira, O., Bacchi, S., Reichardt, K., 2011. Method to estimate soil macroporosity and microporosity based on sand content and bulk density. Rev. Bras. Ciencias do Solo 35, 447–459.
}
\seealso{
\code{\link{plot.soil}}, \code{\link{soil_redefineLayers}}, \code{\link{soil_psi2thetaSX}}, \code{\link{soil_psi2thetaVG}}, \code{\link{spwb}}, \code{\link{defaultSoilParams}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{aspwbInput}
\alias{aspwbInput}
\alias{aspwb}
\alias{aspwb_day}
\title{Simulation in agricultural areas}
\usage{
aspwbInput(crop_factor, control, soil)

aspwb(
  x,
  meteo,
  latitude,
  elevation,
  slope = NA_real_,
  aspect = NA_real_,
  waterTableDepth = NA_real_
)

aspwb_day(
  x,
  date,
  meteovec,
  latitude,
  elevation,
  slope = NA_real_,
  aspect = NA_real_,
  runon = 0,
  lateralFlows = NULL,
  waterTableDepth = NA_real_,
  modifyInput = TRUE
)
}
\arguments{
\item{crop_factor}{Agriculture crop factor.}

\item{control}{A list with default control parameters (see \code{\link{defaultControl}}).}

\item{soil}{An object of class \code{\link{data.frame}} or \code{\link{soil}}.}

\item{x}{An object of class \code{\link{aspwbInput}}.}

\item{meteo}{A data frame with daily meteorological data series (see \code{\link{spwb}}).}

\item{latitude}{Latitude (in degrees).}

\item{elevation, slope, aspect}{Elevation above sea level (in m), slope (in degrees) and aspect (in degrees from North).}

\item{waterTableDepth}{Water table depth (in mm). When not missing, capillarity rise will be allowed if lower than total soil depth.}

\item{date}{Date as string "yyyy-mm-dd".}

\item{meteovec}{A named numerical vector with weather data. See variable names in parameter \code{meteo} of \code{\link{spwb}}.}

\item{runon}{Surface water amount running on the target area from upslope (in mm).}

\item{lateralFlows}{Lateral source/sink terms for each soil layer (interflow/to from adjacent locations) as mm/day.}

\item{modifyInput}{Boolean flag to indicate that the input \code{x} object is allowed to be modified during the simulation.}
}
\description{
Function \code{aspwb_day} performs water balance for a single day in an agriculture location.
Function \code{aspwb} performs water balance for multiple days in an agriculture location.
}
\examples{

control <- defaultControl()
examplesoil <- defaultSoilParams(4)

x <- aspwbInput(0.75, control, examplesoil)

# Day to be simulated
d <- 100
meteovec <- unlist(examplemeteo[d,-1])
date <- as.character(examplemeteo$dates[d])

#Call simulation function for a single days
sd <- aspwb_day(x, date, meteovec,  
               latitude = 41.82592, elevation = 100) 

#Call simulation function for multiple days
S <- aspwb(x, examplemeteo, latitude = 41.82592, elevation = 100)

}
\seealso{
\code{\link{spwbInput}}, \code{\link{spwb}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{communication}
\alias{communication}
\alias{.copy_model_output}
\title{Internal communication}
\usage{
.copy_model_output(internalCommunication, x, model)
}
\arguments{
\item{internalCommunication}{List for internal communication.}

\item{x}{An object of class \code{\link{spwbInput}} or \code{\link{growthInput}}.}

\item{model}{String for model, either "spwb" or "growth".}
}
\description{
Functions for internal communication. Not to be called by users.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{modelInput}
\alias{modelInput}
\alias{spwbInput}
\alias{growthInput}
\title{Input for simulation models}
\usage{
spwbInput(x, soil, SpParams, control)

growthInput(x, soil, SpParams, control)
}
\arguments{
\item{x}{An object of class \code{\link{forest}}.}

\item{soil}{An object of class \code{\link{data.frame}} or \code{\link{soil}}, containing soil parameters per soil layer.}

\item{SpParams}{A data frame with species parameters (see \code{\link{SpParamsDefinition}} and \code{\link{SpParamsMED}}).}

\item{control}{A list with default control parameters (see \code{\link{defaultControl}}).}
}
\value{
Function \code{spwbInput()} returns a list of class \code{spwbInput} with the following elements (rows of data frames are identified as specified by function \code{\link{plant_ID}}):
\itemize{
\item{\code{control}: List with control parameters (see \code{\link{defaultControl}}).}
\item{\code{soil}: A data frame with initialized soil parameters (see \code{\link{soil}}).}
\item{\code{snowpack}: The amount of snow (in mm) in the snow pack over the soil.}
\item{\code{canopy}: A list of stand-level state variables.}
\item{\code{cohorts}: A data frame with cohort information, with columns \code{SP} and \code{Name}.}
\item{\code{above}: A data frame with columns such as \code{H}, \code{CR} and \code{LAI_live} (see internal function \code{forest2aboveground}).}
\item{\code{below}: A data frame with columns \code{Z50}, \code{Z95} and \code{Z100}.}
\item{\code{belowLayers}: A list. If \code{control$transpirationMode = "Granier"} it contains elements:
\itemize{
\item{\code{V}: A matrix with the proportion of fine roots of each cohort (in rows) in each soil layer (in columns).}
\item{\code{L}: A matrix with the length of coarse roots of each cohort (in rows) in each soil layer (in columns).}
\item{\code{Wpool}: A matrix with the soil moisture relative to field capacity around the rhizosphere of each cohort (in rows) in each soil layer (in columns).}
}
If \code{control$transpirationMode = "Sperry"} or \code{control$transpirationMode = "Sureau"} there are the following additional elements:
\itemize{
\item{\code{VGrhizo_kmax}: A matrix with maximum rhizosphere conductance values of each cohort (in rows) in each soil layer (in columns).}
\item{\code{VGroot_kmax}: A matrix with maximum root xylem conductance values of each cohort (in rows) in each soil layer (in columns).}
\item{\code{RhizoPsi}: A matrix with the water potential around the rhizosphere of each cohort (in rows) in each soil layer (in columns).}
}
}
\item{\code{paramsPhenology}: A data frame with leaf phenology parameters:
\itemize{
\item{\code{PhenologyType}: Leaf phenology type.}
\item{\code{LeafDuration}: Leaf duration (in years).}
\item{\code{Sgdd}: Degree days needed for leaf budburst (for winter decideous species).}
\item{\code{Tbgdd}: Base temperature for the calculation of degree days to leaf budburst.}
\item{\code{Ssen}: Degree days corresponding to leaf senescence.}
\item{\code{Phsen}: Photoperiod corresponding to start counting senescence degree-days.}
\item{\code{Tbsen}: Base temperature for the calculation of degree days to leaf senescence.}
}
}
\item{\code{paramsAnatomy}: A data frame with plant anatomy parameters for each cohort:
\itemize{
\item{\code{Hmax}: Maximum plant height (cm).}
\item{\code{Hmed}: Median plant height (cm).}
\item{\code{Al2As}: Leaf area to sapwood area ratio (in m2·m-2).}
\item{\code{Ar2Al}: Fine root area to leaf area ratio (in m2·m-2).}
\item{\code{SLA}: Specific leaf area (mm2/mg = m2/kg).}
\item{\code{LeafWidth}: Leaf width (in cm).}
\item{\code{LeafDensity}: Density of leaf tissue (dry weight over volume).}
\item{\code{WoodDensity}: Density of wood tissue (dry weight over volume).}
\item{\code{FineRootDensity}: Density of fine root tissue (dry weight over volume).}
\item{\code{SRL}: Specific Root length (cm·g-1).}
\item{\code{RLD}: Root length density (cm·cm-3).}
\item{\code{r635}: Ratio between the weight of leaves plus branches and the weight of leaves alone for branches of 6.35 mm.}
}
}
\item{\code{paramsInterception}: A data frame with rain interception and light extinction parameters for each cohort:
\itemize{
\item{\code{kPAR}: PAR extinction coefficient.}
\item{\code{g}: Canopy water retention capacity per LAI unit (mm/LAI).}
}
If \code{control$transpirationMode = "Sperry"} or \code{control$transpirationMode = "Sureau"} additional columns are:
\itemize{
\item{\code{gammaSWR}: Reflectance (albedo) coefficient for SWR .}
\item{\code{alphaSWR}: Absorbance coefficient for SWR .}
}
}
\item{\code{paramsTranspiration}: A data frame with parameters for transpiration and photosynthesis. If \code{control$transpirationMode = "Granier"}, columns are:
\itemize{
\item{\code{Gswmin}: Minimum stomatal conductance to water vapor (in mol H2O·m-2·s-1).}
\item{\code{Tmax_LAI}: Coefficient relating LAI with the ratio of maximum transpiration over potential evapotranspiration.}
\item{\code{Tmax_LAIsq}: Coefficient relating squared LAI with the ratio of maximum transpiration over potential evapotranspiration.}
\item{\code{Psi_Extract}: Water potential corresponding to 50\% relative transpiration (in MPa).}
\item{\code{Exp_Extract}: Parameter of the Weibull function regulating transpiration reduction.}
\item{\code{VCstem_c}, \code{VCstem_d}: Parameters of the stem xylem vulnerability curve (Weibull).}
\item{\code{WUE}: Daily water use efficiency (gross photosynthesis over transpiration) under no light, water or CO2 limitations and VPD = 1kPa (g C/mm water).}
\item{\code{WUE_par}: Coefficient regulating the influence of \% PAR on gross photosynthesis.}
\item{\code{WUE_co2}: Coefficient regulating the influence of atmospheric CO2 concentration on gross photosynthesis.}
\item{\code{WUE_vpd}: Coefficient regulating the influence of vapor pressure deficit (VPD) on gross photosynthesis.}
}
If \code{control$transpirationMode = "Sperry"} columns are:
\itemize{
\item{\code{Gswmin}: Minimum stomatal conductance to water vapor (in mol H2O·m-2·s-1).}
\item{\code{Gswmax}: Maximum stomatal conductance to water vapor (in mol H2O·m-2·s-1).}
\item{\code{Vmax298}: Maximum Rubisco carboxilation rate at 25ºC (in micromol CO2·s-1·m-2).}
\item{\code{Jmax298}: Maximum rate of electron transport at 25ºC (in micromol photons·s-1·m-2).}
\item{\code{Kmax_stemxylem}: Sapwood-specific hydraulic conductivity of stem xylem (in kg H2O·s-1·m-1·MPa-1).}
\item{\code{Kmax_rootxylem}: Sapwood-specific hydraulic conductivity of root xylem (in kg H2O·s-1·m-1·MPa-1).}
\item{\code{VCleaf_kmax}: Maximum leaf hydraulic conductance (in mmol H2O·s-1·m-2·MPa-1).}
\item{\code{VCleaf_c}, \code{VCleaf_d}: Parameters of the leaf vulnerability curve (Weibull).}
\item{\code{VCstem_kmax}: Maximum stem xylem conductance (in mmol H2O·s-1·m-2·MPa-1).}
\item{\code{VCstem_c}, \code{VCstem_d}: Parameters of the stem xylem vulnerability curve (Weibull).}
\item{\code{VCroot_c}, \code{VCroot_d}: Parameters of the root xylem vulnerability curve (Weibull).}
\item{\code{Plant_kmax}: Maximum whole-plant conductance (in mmol H2O·s-1·m-2·MPa-1).}
\item{\code{FR_leaf}, \code{FR_stem}, \code{FR_root}: Fraction of whole-plant resistance corresponding to each segment.}
}
If \code{control$transpirationMode = "Sureau"} columns are:
\itemize{
\item{\code{Gswmin}: Minimum stomatal conductance to water vapor (in mol H2O·m-2·s-1).}
\item{\code{Gswmax}: Maximum stomatal conductance to water vapor (in mol H2O·m-2·s-1).}
\item{\code{Gsw_AC_slope}: Slope of the Gsw vs Ac/Cs relationship (see \code{\link{photo_photosynthesisBaldocchi}}).}
\item{\code{Gs_P50}, \code{Gs_slope}: Parameters of the curve describing the decrease in stomatal conductance as a function of leaf water potential (sigmoid).}
\item{\code{Vmax298}: Maximum Rubisco carboxylation rate at 25ºC (in micromol CO2·s-1·m-2).}
\item{\code{Jmax298}: Maximum rate of electron transport at 25ºC (in micromol photons·s-1·m-2).}
\item{\code{Kmax_stemxylem}: Sapwood-specific hydraulic conductivity of stem xylem (in kg H2O·s-1·m-1·MPa-1).}
\item{\code{Kmax_rootxylem}: Sapwood-specific hydraulic conductivity of root xylem (in kg H2O·s-1·m-1·MPa-1).}
\item{\code{VCleaf_kmax}: Maximum leaf hydraulic conductance (in mmol H2O·s-1·m-2·MPa-1).}
\item{\code{VCleaf_c}, \code{VCleaf_d}: Parameters of the leaf vulnerability curve (Weibull).}
\item{\code{VCleaf_P50}, \code{VCleaf_slope}: Parameters of the leaf vulnerability curve (sigmoid).}
\item{\code{VCstem_kmax}: Maximum stem xylem conductance (in mmol H2O·s-1·m-2·MPa-1).}
\item{\code{VCstem_c}, \code{VCstem_d}: Parameters of the stem xylem vulnerability curve (Weibull).}
\item{\code{VCstem_P50}, \code{VCstem_slope}: Parameters of the stem xylem vulnerability curve (sigmoid).}
\item{\code{VCroot_c}, \code{VCroot_d}: Parameters of the root xylem vulnerability curve (Weibull).}
\item{\code{VCroot_P50}, \code{VCroot_slope}: Parameters of the root xylem vulnerability curve (sigmoid).}
\item{\code{Plant_kmax}: Maximum whole-plant conductance (in mmol H2O·s-1·m-2·MPa-1).}
\item{\code{FR_leaf}, \code{FR_stem}, \code{FR_root}: Fraction of whole-plant resistance corresponding to each segment.}
}
}
\item{\code{paramsWaterStorage}: A data frame with plant water storage parameters for each cohort:
\itemize{
\item{\code{LeafPI0}: Osmotic potential at full turgor of leaves (MPa).}
\item{\code{LeafEPS}: Modulus of elasticity (capacity of the cell wall to resist changes in volume in response to changes in turgor) of leaves (MPa).}
\item{\code{LeafAF}: Apoplastic fraction (proportion of water outside the living cells) in leaves.}
\item{\code{Vleaf}: Storage water capacity in leaves, per leaf area (L/m2).}
\item{\code{StemPI0}: Osmotic potential at full turgor of symplastic xylem tissue (MPa).}
\item{\code{StemEPS}: Modulus of elasticity (capacity of the cell wall to resist changes in volume in response to changes in turgor) of symplastic xylem tissue (Mpa).}
\item{\code{StemAF}: Apoplastic fraction (proportion of water outside the living cells) in stem xylem.}
\item{\code{Vstem}: Storage water capacity in sapwood, per leaf area (L/m2).}
}
}
\item{\code{internalPhenology} and \code{internalWater}: data frames to store internal state variables.}
\item{\code{internalFCCS}: A data frame with fuel characteristics, according to \code{\link{fuel_FCCS}} (only if \code{fireHazardResults = TRUE}, in the control list).}
}

Function \code{growthInput()} returns a list of class \code{growthInput} with the same elements as \code{spwbInput}, but with additional information.
\itemize{
\item{Element \code{above} includes the following additional columns:
\itemize{
\item{\code{LA_live}: Live leaf area per individual (m2/ind).}
\item{\code{LA_dead}: Dead leaf area per individual (m2/ind).}
\item{\code{SA}: Live sapwood area per individual (cm2/ind).}
}
}
\item{\code{paramsGrowth}: A data frame with growth parameters for each cohort:
\itemize{
\item{\code{RERleaf}: Maintenance respiration rates (at 20ºC) for leaves (in g gluc·g dry-1·day-1).}
\item{\code{RERsapwood}: Maintenance respiration rates (at 20ºC) for sapwood (in g gluc·g dry-1·day-1).}
\item{\code{RERfineroot}: Maintenance respiration rates (at 20ºC) for fine roots (in g gluc·g dry-1·day-1).}
\item{\code{CCleaf}: Leaf construction costs (in g gluc·g dry-1).}
\item{\code{CCsapwood}: Sapwood construction costs (in g gluc·g dry-1).}
\item{\code{CCfineroot}: Fine root construction costs (in g gluc·g dry-1).}
\item{\code{RGRleafmax}: Maximum leaf relative growth rate (in m2·cm-2·day-1).}
\item{\code{RGRsapwoodmax}: Maximum sapwood relative growth rate (in cm2·cm-2·day-1).}
\item{\code{RGRfinerootmax}: Maximum fine root relative growth rate (in g dry·g dry-1·day-1).}
\item{\code{SRsapwood}: Sapwood daily senescence rate (in day-1).}
\item{\code{SRfineroot}: Fine root daily senescence rate (in day-1).}
\item{\code{RSSG}: Minimum relative starch for sapwood growth (proportion).}
\item{\code{fHDmin}: Minimum value of the height-to-diameter ratio (dimensionless).}
\item{\code{fHDmax}: Maximum value of the height-to-diameter ratio (dimensionless).}
\item{\code{WoodC}: Wood carbon content per dry weight (g C /g dry).}
}
}
\item{\code{paramsMortalityRegeneration}: A data frame with mortality/regeneration parameters for each cohort:
\itemize{
\item{\code{MortalityBaselineRate}: Deterministic proportion or probability specifying the baseline reduction of cohort's density occurring in a year.}
\item{\code{SurvivalModelStep}: Time step in years of the empirical survival model depending on stand basal area (e.g. 10).}
\item{\code{SurvivalB0}: Intercept of the logistic baseline survival model depending on stand basal area.}
\item{\code{SurvivalB1}: Slope of the logistic baseline survival model depending on stand basal area.}
\item{\code{RecrTreeDensity}: Density of tree recruits from seeds.}
\item{\code{IngrowthTreeDensity}: Density of trees reaching ingrowth DBH.}
\item{\code{RecrTreeDBH}: DBH for tree recruits from seeds or resprouting (e.g. 1 cm).}
\item{\code{IngrowthTreeDBH}: Ingrowth DBH for trees (e.g. 7.5 cm).}
\item{\code{RespFire}: Probability of resprouting after a fire disturbance.}
\item{\code{RespDist}: Probability of resprouting after undefined disturbance (typically desiccation).}
}
}
\item{\code{paramsAllometry}: A data frame with allometric parameters for each cohort:
\itemize{
\item{\code{Aash}: Regression coefficient relating the square of shrub height with shrub area.}
\item{\code{Absh}, \code{Bbsh}: Allometric coefficients relating phytovolume with dry weight of shrub individuals.}
\item{\code{Acr}, \code{B1cr}, \code{B2cr}, \code{B3cr}, \code{C1cr}, \code{C2cr}: Regression coefficients used to calculate crown ratio of trees.}
\item{\code{Acw}, \code{Bcw}: Regression coefficients used to calculated crown width of trees.}
}
}
\item {\code{internalAllocation}: A data frame with internal allocation variables for each cohort:
\itemize{
\item{\code{allocationTarget}: Value of the allocation target variable.}
\item{\code{leafAreaTarget}: Target leaf area (m2) per individual.}
\item{\code{sapwoodAreaTarget}: Target sapwood area (cm2) per individual.}
\item{\code{fineRootBiomassTarget}: Target fine root biomass (g dry) per individual.}
\item{\code{crownBudPercent}: Percentage of the crown with buds.}
}
}
\item{\code{internalCarbon}: A data frame with the concentration (mol·gluc·l-1) of metabolic and storage carbon compartments for leaves and sapwood.}
\item{\code{internalSnags}: A data frame with characteristics (species identity, height, diameter, age), small branch mass and large wood mass (both in g C/m2) corresponding to decomposing snag cohorts (see \code{\link{forest}}).}
\item{\code{internalLitter}: A data frame with the aboveground and belowground mass (g C/m2) of different litter components: leaves, twigs, small branches, large wood, coarse roots and fine roots.}
\item{\code{internalSOC}: A named numeric vector with surface/soil decomposing carbon pools (g C/m2).}
\item{\code{internalMortality}: A data frame to store the cumulative mortality (density for trees and cover for shrubs) predicted during the simulation,
also distinguishing mortality due to starvation or dessication, the number of resprouting elements and the accumulation of aboveground dead wood (branches and large wood).}
}
}
\description{
Functions \code{spwbInput()} and \code{growthInput()} take an object of class \code{\link{forest}}
and a soil data input to create input objects for simulation functions \code{\link{spwb}} (or \code{\link{pwb}}) and \code{\link{growth}}, respectively.
}
\details{
Functions \code{spwbInput()} and \code{growthInput()} initialize inputs differently depending on control parameters.
}
\examples{
#Load example plot plant data
data(exampleforest)

# Example of aboveground parameters taken from a forest
# described using LAI and crown ratio
data(exampleforest2)

#Default species parameterization
data(SpParamsMED)


# Define soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

# Initialize control parameters using 'Granier' transpiration mode
control <- defaultControl("Granier")

# Prepare spwb input
spwbInput(exampleforest, examplesoil, SpParamsMED, control)
                
# Prepare input for 'Sperry' transpiration mode
control <- defaultControl("Sperry")
spwbInput(exampleforest,examplesoil,SpParamsMED, control)

# Prepare input for 'Sureau' transpiration mode
control <- defaultControl("Sureau")
spwbInput(exampleforest,examplesoil,SpParamsMED, control)

# Example of initialization from a forest 
# described using LAI and crown ratio
control <- defaultControl("Granier")
spwbInput(exampleforest2, examplesoil, SpParamsMED, control)

}
\seealso{
\code{\link{resetInputs}}, \code{\link{spwb}}, \code{\link{growth}}, \code{\link{soil}},
\code{\link{forest}}, \code{\link{SpParamsMED}}, \code{\link{defaultSoilParams}}, \code{\link{plant_ID}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{hydrology_infiltrationRepartition}
\alias{hydrology_infiltrationRepartition}
\alias{hydrology_infiltration}
\alias{hydrology_infiltrationAmount}
\alias{hydrology_infiltrationBoughton}
\alias{hydrology_infiltrationGreenAmpt}
\title{Soil infiltration}
\usage{
hydrology_infiltrationRepartition(I, widths, macro, a = -0.005, b = 3)

hydrology_infiltrationAmount(
  rainfallInput,
  rainfallIntensity,
  soil,
  soilFunctions,
  model = "GreenAmpt1911",
  K_correction = 1
)

hydrology_infiltrationBoughton(input, Ssoil)

hydrology_infiltrationGreenAmpt(t, psi_w, Ksat, theta_sat, theta_dry)
}
\arguments{
\item{I}{Soil infiltration (in mm of water).}

\item{widths}{Width of soil layers (in mm).}

\item{macro}{Macroporosity of soil layers (in \%).}

\item{a, b}{Parameters of the extinction function used for water infiltration.}

\item{rainfallInput}{Water from the rainfall event reaching the soil surface (mm)}

\item{rainfallIntensity}{rainfall intensity rate (mm/h)}

\item{soil}{A list containing the description of the soil (see \code{\link{soil}}).}

\item{soilFunctions}{Soil water retention curve and conductivity functions, either 'SX' (for Saxton) or 'VG' (for Van Genuchten).}

\item{model}{Infiltration model, either "GreenAmpt1911" or "Boughton1989"}

\item{K_correction}{Correction for saturated conductivity, to account for increased infiltration due to macropore presence}

\item{input}{A numeric vector of (daily) water input (in mm of water).}

\item{Ssoil}{Soil water storage capacity (can be referred to topsoil) (in mm of water).}

\item{t}{Time of the infiltration event}

\item{psi_w}{Matric potential at the wetting front}

\item{Ksat}{hydraulic conductivity at saturation}

\item{theta_sat}{volumetric content at saturation}

\item{theta_dry}{volumetric content at the dry side of the wetting front}
}
\value{
Functions \code{hydrology_infiltrationBoughton}, \code{hydrology_infiltrationGreenAmpt} and \code{hydrology_infiltrationAmount}
return the daily amount of water that infiltrates into the soil (in mm of water).

Function \code{hydrology_infiltrationRepartition} returns the amount of infiltrated water that reaches each soil layer.
}
\description{
Soil infiltration functions:
\itemize{
\item{Function \code{hydrology_infiltrationBoughton} calculates the amount of water that infiltrates into the topsoil, according to the USDA SCS curve number method (Boughton 1989).}
\item{Function \code{hydrology_infiltrationGreenAmpt} calculates the amount of water that infiltrates into the topsoil, according to the model by Green & Ampt (1911).}
\item{Function \code{hydrology_infiltrationAmount} uses either Green & Ampt (1911) or Boughton (1989) to estimate infiltration.}
\item{Function \code{hydrology_infiltrationRepartition} distributes infiltration among soil layers depending on macroporosity.}
}
}
\details{
When using function \code{hydrology_infiltrationGreenAmpt}, the units of \code{Ksat}, \code{t} and \code{psi_wat} have to be in the same system (e.g. cm/h, h and cm).
}
\references{
Boughton (1989). A review of the USDA SCS curve number method. - Australian Journal of Soil Research 27: 511-523.

Green, W.H. and Ampt, G.A. (1911) Studies on Soil Physics, 1: The Flow of Air and Water through Soils. The Journal of Agricultural Science, 4, 1-24.
}
\seealso{
\code{\link{spwb}}, \code{\link{hydrology_waterInputs}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{fuel_windAdjustmentFactor}
\alias{fuel_windAdjustmentFactor}
\title{Wind adjustment factor for Rothermel's model}
\usage{
fuel_windAdjustmentFactor(
  topShrubHeight,
  bottomCanopyHeight,
  topCanopyHeight,
  canopyCover
)
}
\arguments{
\item{topShrubHeight}{Shrub stratum top height (in m).}

\item{bottomCanopyHeight}{Canopy base height (in m).}

\item{topCanopyHeight}{Canopy top height (in m).}

\item{canopyCover}{Canopy percent cover.}
}
\value{
A scalar value between 0 and 1
}
\description{
Function fuel_windAdjustmentFactor determines the adjustment factor of wind for surface fires, according to Andrews (2012).
}
\examples{
#Load example plot plant data
 data(exampleforest)
  
#Default species parameterization
data(SpParamsMED)

#Calculate fuel properties according to FCCS
fccs <- fuel_FCCS(exampleforest, SpParamsMED)

# Estimate wind adjustment factor
fuel_windAdjustmentFactor(fccs$htc[2], fccs$hbc[1], fccs$htc[1], fccs$cover[1])

}
\references{
Andrews, P. L. 2012. Modeling wind adjustment factor and midflame wind speed for Rothermel’s surface fire spread model. USDA Forest Service - General Technical Report RMRS-GTR:1–39.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{fire_behaviour}
\alias{fire_behaviour}
\alias{fire_FCCS}
\alias{fire_Rothermel}
\title{Fire behaviour functions}
\usage{
fire_FCCS(
  FCCSpropsSI,
  MliveSI = as.numeric(c(90, 90, 60)),
  MdeadSI = as.numeric(c(6, 6, 6, 6, 6)),
  slope = 0,
  windSpeedSI = 11
)

fire_Rothermel(
  modeltype,
  wSI,
  sSI,
  delta,
  mx_dead,
  hSI,
  mSI,
  u,
  windDir,
  slope,
  aspect
)
}
\arguments{
\item{FCCSpropsSI}{A data frame describing the properties of five fuel strata (canopy, shrub, herbs, dead woody and litter) returned by \code{\link{fuel_FCCS}}.}

\item{MliveSI}{Moisture of live fuels (in percent of dry weight) for canopy, shrub, and herb strata. Live moisture values are drawn from column \code{ActFCM} in \code{FCCSpropsSI} if available (see \code{\link{fuel_FCCS}}). Otherwise, moisture values supplied for \code{MliveSI} are used.}

\item{MdeadSI}{Moisture of dead fuels (in percent of dry weight) for canopy, shrub, herb, woody and litter strata.}

\item{slope}{Slope (in degrees).}

\item{windSpeedSI}{Wind speed (in m/s) at 20 ft (6 m) over vegetation (default 11 m/s = 40 km/h)}

\item{modeltype}{'S'(tatic) or 'D'(ynamic)}

\item{wSI}{A vector of fuel load (t/ha) for five fuel classes.}

\item{sSI}{A vector of surface-to-volume ratio (m2/m3) for five fuel classes.}

\item{delta}{A value of fuel bed depth (cm).}

\item{mx_dead}{A value of dead fuel moisture of extinction (percent).}

\item{hSI}{A vector of heat content (kJ/kg) for five fuel classes.}

\item{mSI}{A vector of percent moisture on a dry weight basis (percent) for five fuel classes.}

\item{u}{A value of windspeed (m/s) at midflame height.}

\item{windDir}{Wind direction (in degrees from north). North means blowing from north to south.}

\item{aspect}{Aspect (in degrees from north).}
}
\value{
Both functions return list with fire behavior variables.

In the case of \code{fire_FCCS}, the function returns the variables in three blocks (lists \code{SurfaceFire}, \code{CrownFire} and \code{FirePotentials}), and the values are:
\itemize{
\item{\code{SurfaceFire$`midflame_WindSpeed [m/s]`}: Midflame wind speed in the surface fire.}
\item{\code{SurfaceFire$phi_wind}: Spread rate modifier due to wind.}
\item{\code{SurfaceFire$phi_slope}: Spread rate modifier due to slope.}
\item{\code{SurfaceFire$`I_R_surf [kJ/m2/min]`}: Intensity of the surface fire reaction.}
\item{\code{SurfaceFire$`I_R_litter [kJ/m2/min]`}: Intensity of the litter fire reaction.}
\item{\code{SurfaceFire$`q_surf [kJ/m2]`}: Heat sink of the surface fire.}
\item{\code{SurfaceFire$`q_litter [kJ/m2]`}: Heat sink of the litter fire.}
\item{\code{SurfaceFire$xi_surf}: Propagating flux ratio of the surface fire.}
\item{\code{SurfaceFire$xi_litter}: Propagating flux ratio of the litter fire.}
\item{\code{SurfaceFire$`ROS_surf [m/min]`}: Spread rate of the surface fire(without accounting for faster spread in the litter layer).}
\item{\code{SurfaceFire$`ROS_litter [m/min]`}: Spread rate of the litter fire.}
\item{\code{SurfaceFire$`ROS_windslopecap [m/min]`}: Maximum surface fire spread rate according to wind speed.}
\item{\code{SurfaceFire$`ROS [m/min]`}: Final spread rate of the surface fire.}
\item{\code{SurfaceFire$`I_b [kW/m]`}: Fireline intensity of the surface fire.}
\item{\code{SurfaceFire$`FL [m]`}: Flame length of the surface fire.}
\item{\code{CrownFire$`I_R_canopy [kJ/m2/min]`}: Intensity of the canopy fire reaction.}
\item{\code{CrownFire$`I_R_crown [kJ/m2/min]`}: Intensity of the crown fire reaction (adding surface and canopy reactions).}
\item{\code{CrownFire$`q_canopy [kJ/m2]`}: Heat sink of the canopy fire.}
\item{\code{CrownFire$`q_crown [kJ/m2]`}: Heat sink of the crown fire (adding surface and canopy heat sinks).}
\item{\code{CrownFire$xi_surf}: Propagating flux ratio of the crown fire.}
\item{\code{CrownFire$`canopy_WindSpeed [m/s]`}: Wind speed in the canopy fire (canopy top wind speed).}
\item{\code{CrownFire$WAF}: Wind speed adjustment factor for crown fires.}
\item{\code{CrownFire$`ROS [m/min]`}: Spread rate of the crown fire.}
\item{\code{CrownFire$Ic_ratio}: Crown initiation ratio.}
\item{\code{CrownFire$`I_b [kW/m]`}: Fireline intensity of the crown fire.}
\item{\code{CrownFire$`FL [m]`}: Flame length of the crown fire.}
\item{\code{FirePotentials$RP}: Surface fire reaction potential ([0-9]).}
\item{\code{FirePotentials$SP}: Surface fire spread rate potential ([0-9]).}
\item{\code{FirePotentials$FP}: Surface fire flame length potential ([0-9]).}
\item{\code{FirePotentials$SFP}: Surface fire potential ([0-9]).}
\item{\code{FirePotentials$IC}: Crown initiation potential ([0-9]).}
\item{\code{FirePotentials$TC}: Crown-to-crown transmission potential ([0-9]).}
\item{\code{FirePotentials$RC}: Crown fire spread rate potential ([0-9]).}
\item{\code{FirePotentials$CFC}: Crown fire potential ([0-9]).}
}
}
\description{
Function \code{fire_FCCS()} implements a modification of the fire behavior models
described for the Fuel Characteristics Classification System (FCCS) in Prichard et al. (2013).
Function \code{fire_Rothermel()} implements Rothermel's (1972) fire behaviour
model (modified from package 'Rothermel' (Giorgio Vacchiano, Davide Ascoli)).
}
\details{
Default moisture, slope and windspeed values are benchmark conditions
used to calculate fire potentials (Sandberg et al. 2007) and map vulnerability to fire.
}
\note{
Default moisture, slope and windspeed values are benchmark conditions used to calculate fire potentials (Sandberg et al. 2007) and map vulnerability to fire.
}
\examples{
#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Calculate fuel properties according to FCCS
fccs <- fuel_FCCS(exampleforest, SpParamsMED)
fccs
  
#Calculate fire behavior according to FCCS
fire_FCCS(fccs)
  
 
}
\references{
Albini, F. A. (1976). Computer-based models of wildland fire behavior: A users' manual. Ogden, UT: US Department of Agriculture, Forest Service, Intermountain Forest and Range Experiment Station.

Rothermel, R. C. 1972. A mathematical model for predicting fire spread in wildland fuels. USDA Forest Service Research Paper INT USA.

Prichard, S. J., D. V Sandberg, R. D. Ottmar, E. Eberhardt, A. Andreu, P. Eagle, and K. Swedin. 2013. Classification System Version 3.0: Technical Documentation.
}
\seealso{
\code{\link{fuel_FCCS}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{carbon_belowgroundSapwoodStructuralBiomass}
\alias{carbon_belowgroundSapwoodStructuralBiomass}
\alias{carbon_sapwoodStructuralBiomass}
\alias{carbon_belowgroundHeartwoodStructuralBiomass}
\alias{carbon_heartwoodStructuralBiomass}
\alias{carbon_sapwoodStarchCapacity}
\alias{carbon_carbonCompartments}
\alias{carbon}
\alias{carbon_sugarStarchDynamicsLeaf}
\alias{carbon_sugarStarchDynamicsStem}
\alias{carbon_osmoticWaterPotential}
\alias{carbon_sugarConcentration}
\alias{carbon_relativeSapViscosity}
\alias{carbon_leafStructuralBiomass}
\alias{carbon_twigStructuralBiomass}
\alias{carbon_leafStarchCapacity}
\alias{carbon_abovegroundSapwoodStructuralBiomass}
\alias{carbon_abovegroundHeartwoodStructuralBiomass}
\title{Carbon-related functions}
\usage{
carbon_belowgroundSapwoodStructuralBiomass(SA, L, V, woodDensity)

carbon_sapwoodStructuralBiomass(SA, H, L, V, woodDensity)

carbon_belowgroundHeartwoodStructuralBiomass(DBH, SA, L, V, woodDensity)

carbon_heartwoodStructuralBiomass(DBH, SA, H, L, V, woodDensity)

carbon_sapwoodStarchCapacity(SA, H, L, V, woodDensity, conduit2sapwood)

carbon_carbonCompartments(x, biomassUnits = "g_m2")

carbon_sugarStarchDynamicsLeaf(sugarConc, starchConc, eqSugarConc)

carbon_sugarStarchDynamicsStem(sugarConc, starchConc, eqSugarConc)

carbon_osmoticWaterPotential(sugarConc, temp, nonSugarConc)

carbon_sugarConcentration(osmoticWP, temp, nonSugarConc)

carbon_relativeSapViscosity(sugarConc, temp)

carbon_leafStructuralBiomass(LAI, N, SLA)

carbon_twigStructuralBiomass(LAI, N, SLA, r635)

carbon_leafStarchCapacity(LAI, N, SLA, leafDensity)

carbon_abovegroundSapwoodStructuralBiomass(SA, H, woodDensity)

carbon_abovegroundHeartwoodStructuralBiomass(DBH, SA, H, woodDensity)
}
\arguments{
\item{SA}{Sapwood area (cm2).}

\item{L}{Coarse root length (mm) for each soil layer.}

\item{V}{Proportion of fine roots in each soil layer.}

\item{woodDensity}{Wood density (dry weight over volume).}

\item{H}{Plant height (cm).}

\item{DBH}{Tree diameter (cm).}

\item{conduit2sapwood}{Proportion of sapwood corresponding to conducive elements (vessels or tracheids) as opposed to parenchymatic tissue.}

\item{x}{An object of class \code{\link{growthInput}}.}

\item{biomassUnits}{A string for output biomass units, either "g_ind" (g per individual) or "g_m2" (g per square meter).}

\item{sugarConc}{Concentration of soluble sugars (mol/l).}

\item{starchConc}{Concentration of starch (mol/l)}

\item{eqSugarConc}{Equilibrium concentration of soluble sugars (mol/l).}

\item{temp}{Temperature (degrees Celsius).}

\item{nonSugarConc}{Concentration of inorganic solutes (mol/l).}

\item{osmoticWP}{Osmotic water potential (MPa).}

\item{LAI}{Leaf area index.}

\item{N}{Density (ind·ha-1).}

\item{SLA}{Specific leaf area (mm2/mg = m2/kg).}

\item{leafDensity}{Density of leaf tissue (dry weight over volume).}
}
\value{
Values returned for each function are:
\itemize{
\item{\code{carbon_leafStarchCapacity}: Capacity of storing starch in the leaf compartment (mol gluc/ind.).}
\item{\code{carbon_leafStructuralBiomass}: Leaf structural biomass (g dry/ind.)}
\item{\code{carbon_sapwoodStarchCapacity}: Capacity of storing starch in the sapwood compartment (mol gluc/ind.).}
\item{\code{carbon_sapwoodStructuralBiomass}: Sapwood structural biomass (g dry/ind.)}
\item{\code{carbon_sapwoodStructuralLivingBiomass}: Living sapwood (parenchyma) structural biomass (g dry/ind.)}
\item{\code{carbon_sugarConcentration}: Sugar concentration (mol gluc/l)}
\item{\code{carbon_osmoticWaterPotential}: Osmotic component of water potential (MPa)}
\item{\code{carbon_relativeSapViscosity}: Relative viscosity of sapwood with respect to pure water (according to Forst et al. (2002)).}
\item{\code{carbon_sugarStarchDynamicsLeaf}: Rate of conversion from sugar to starch in leaf (mol gluc/l/s).}
\item{\code{carbon_sugarStarchDynamicsStem}: Rate of conversion from sugar to starch in leaf (mol gluc/l/s).}
\item{\code{carbon_carbonCompartments}: A data frame with the size of compartments for each plant cohort, in the specified units.}
}
}
\description{
Low-level functions used in the calculation of carbon balance.
}
\examples{
#Load example plot plant data
data(exampleforest)
#Default species parameterization
data(SpParamsMED)
#Initialize control parameters
control <- defaultControl("Granier")
#Initialize soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)
#Initialize model input
x1 <- growthInput(exampleforest, examplesoil, SpParamsMED, control)

# Estimate carbon compartments
carbon_carbonCompartments(x1)

}
\references{
Forst P, Wermer F, Delgado A (2002). On the pressure dependence of the viscosity of aqueous sugar solutions. Rheol Acta 41: 369–374 DOI 10.1007/s00397-002-0238-y
}
\seealso{
\code{\link{growth}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{root}
\alias{root}
\alias{root_conicDistribution}
\alias{root_ldrDistribution}
\alias{root_individualRootedGroundArea}
\alias{root_fineRootAreaIndex}
\alias{root_fineRootBiomass}
\alias{root_rhizosphereMaximumConductance}
\alias{root_coarseRootSoilVolumeFromConductance}
\alias{root_coarseRootLengthsFromVolume}
\alias{root_coarseRootLengths}
\alias{root_coarseRootSoilVolume}
\alias{root_horizontalProportions}
\alias{root_fineRootRadius}
\alias{root_specificRootSurfaceArea}
\alias{root_fineRootSoilVolume}
\alias{root_fineRootHalfDistance}
\title{Root functions}
\usage{
root_conicDistribution(Zcone, d)

root_ldrDistribution(Z50, Z95, Z100, d)

root_individualRootedGroundArea(VolInd, V, d, rfc)

root_fineRootAreaIndex(
  Ksoil,
  krhizo,
  lai,
  specificRootLength,
  rootTissueDensity,
  rootLengthDensity
)

root_fineRootBiomass(
  Ksoil,
  krhizo,
  lai,
  N,
  specificRootLength,
  rootTissueDensity,
  rootLengthDensity
)

root_rhizosphereMaximumConductance(
  Ksoil,
  fineRootBiomass,
  lai,
  N,
  specificRootLength,
  rootTissueDensity,
  rootLengthDensity
)

root_coarseRootSoilVolumeFromConductance(
  Kmax_rootxylem,
  VCroot_kmax,
  Al2As,
  v,
  d,
  rfc
)

root_coarseRootLengthsFromVolume(VolInd, v, d, rfc)

root_coarseRootLengths(v, d, depthWidthRatio = 1)

root_coarseRootSoilVolume(v, d, depthWidthRatio = 1)

root_horizontalProportions(poolProportions, VolInd, N, V, d, rfc)

root_fineRootRadius(specificRootLength, rootTissueDensity)

root_specificRootSurfaceArea(specificRootLength, rootTissueDensity)

root_fineRootSoilVolume(fineRootBiomass, specificRootLength, rootLengthDensity)

root_fineRootHalfDistance(rootLengthDensity)

root_rhizosphereMaximumConductance(
  Ksoil,
  fineRootBiomass,
  lai,
  N,
  specificRootLength,
  rootTissueDensity,
  rootLengthDensity
)
}
\arguments{
\item{Zcone}{A vector of depths (in mm) corresponding to the root cone tip.}

\item{d}{The width (in mm) corresponding to each soil layer.}

\item{Z50}{A vector of depths (in mm) corresponding to 50\% of roots.}

\item{Z95}{A vector of depths (in mm) corresponding to 95\% of roots.}

\item{Z100}{A vector of depths (in mm) corresponding to 100\% of roots.}

\item{VolInd}{Volume of soil (in m3) occupied by coarse roots per individual.}

\item{V}{Matrix of proportions of fine roots (cohorts x soil layers).}

\item{rfc}{Percentage of rock fragment content (volume basis) for each layer.}

\item{Ksoil}{Soil saturated conductivity (mmol·m-1·s-1·MPa-1).}

\item{krhizo}{Rhizosphere maximum conductance per leaf area (mmol·m-2·s-1·MPa-1).}

\item{lai}{Leaf area index.}

\item{specificRootLength}{Specific fine root length (length of fine roots over weight).}

\item{rootTissueDensity}{Fine root tissue density (weight over volume at turgidity).}

\item{rootLengthDensity}{Fine root length density (length of fine roots over soil volume; cm/cm3)}

\item{N}{Density of individuals per hectare.}

\item{fineRootBiomass}{Biomass of fine roots (g).}

\item{Kmax_rootxylem}{Sapwood-specific hydraulic conductivity of root xylem (in kg H2O·s-1·m-1·MPa-1).}

\item{VCroot_kmax}{Root xylem maximum conductance per leaf area (mmol·m-2·s-1·MPa-1).}

\item{Al2As}{Leaf area to sapwood area ratio (in m2·m-2).}

\item{v}{Vector of proportions of fine roots in each soil layer.}

\item{depthWidthRatio}{Ratio between radius of the soil layer with the largest radius and maximum rooting depth.}

\item{poolProportions}{Division of the stand area among plant cohorts (proportions).}
}
\value{
See details.
}
\description{
Functions to calculate properties of fine/coarse roots within the soil, given root system parameters and soil layer definition.
}
\details{
\itemize{
\item{\code{root_conicDistribution()} assumes a (vertical) conic distribution of fine roots, whereas \code{root_ldrDistribution()} distributes fine roots according to the linear dose response model of Schenck & Jackson (2002). Return a matrix of fine root proportions in each layer with as many rows as elements in \code{Z} (or \code{Z50}) and as many columns as soil layers.}
\item{\code{root_coarseRootLengths()} and \code{root_coarseRootLengthsFromVolume()} estimate the length of coarse roots (mm) for each soil layer, including axial and radial lengths.}
\item{\code{root_coarseRootSoilVolume} estimates the soil volume (m3) occupied by coarse roots of an individual.}
\item{\code{root_coarseRootSoilVolumeFromConductance} estimates the soil volume (m3) occupied by coarse roots of an individual from root xylem conductance.}
\item{\code{root_fineRootHalfDistance()} calculates the half distance (cm) between neighbouring fine roots.}
\item{\code{root_fineRootRadius()} calculates the radius of fine roots (cm).}
\item{\code{root_fineRootAreaIndex()} estimates the fine root area index for a given soil conductivity and maximum rhizosphere conductance.}
\item{\code{root_fineRootBiomass()} estimates the biomass of fine roots (g dry/individual) for a given soil conductivity and maximum rhizosphere conductance.}
\item{\code{root_rhizosphereMaximumConductance()} is the inverse of the preceeding function, i.e. it estimates rhizosphere conductance from soil conductivity and fine root biomass.}
\item{\code{root_fineRootSoilVolume()} calculates the soil volume (m3) occupied with fine roots.}
\item{\code{root_specificRootSurfaceArea()} returns the specific fine root area (cm2/g).}
\item{\code{root_individualRootedGroundArea()} calculates the area (m2) covered by roots of an individual, for each soil layer.}
\item{\code{root_horizontalProportions()} calculates the (horizontal) proportion of roots of each cohort in the water pool corresponding to itself and that of other cohorts, for each soil layer. Returns a list (with as many elements as cohorts) with each element being a matrix.}
}
}
\examples{
#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

ntree <- nrow(exampleforest$treeData)

#Initialize soil with default soil params
s <- defaultSoilParams(4)

#Calculate conic root system for trees
V1 <- root_conicDistribution(Z=rep(2000,ntree), s$widths)            
print(V1)
     
#Calculate LDR root system for trees (Schenck & Jackson 2002)
V2 <- root_ldrDistribution(Z50 = rep(200,ntree), 
                           Z95 = rep(1000,ntree),
                           Z100 = rep(NA, ntree), s$widths)
print(V2)     

}
\references{
Schenk, H., Jackson, R., 2002. The global biogeography of roots. Ecol. Monogr. 72, 311–328.

Sperry, J. S., Y. Wang, B. T. Wolfe, D. S. Mackay, W. R. L. Anderegg, N. G. Mcdowell, and W. T. Pockman. 2016. Pragmatic hydraulic theory predicts stomatal responses to climatic water deficits. New Phytologist 212, 577–589.
}
\seealso{
\code{\link{spwb}},  \code{\link{spwbInput}}, \code{\link{soil}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{mortality_dailyProbability}
\alias{mortality_dailyProbability}
\title{Mortality}
\usage{
mortality_dailyProbability(stressValue, stressThreshold)
}
\arguments{
\item{stressValue}{Current value of the stress variable (0 to 1,
with higher values indicate stronger stress).}

\item{stressThreshold}{Threshold to indicate 50\% annual mortality probability.}
}
\value{
Returns a probability (between 0 and 1)
}
\description{
A simple sigmoid function to determine a daily mortality likelihood according
to the value of a stress variable.
}
\seealso{
\code{\link{growth}}, \code{\link{regeneration}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.spwb_day.R
\name{plot.spwb_day}
\alias{plot.spwb_day}
\alias{plot.growth_day}
\alias{plot.pwb_day}
\title{Plots simulation results for one day}
\usage{
\method{plot}{spwb_day}(
  x,
  type = "PlantTranspiration",
  bySpecies = FALSE,
  xlim = NULL,
  ylim = NULL,
  xlab = NULL,
  ylab = NULL,
  ...
)

\method{plot}{growth_day}(
  x,
  type = "PlantTranspiration",
  bySpecies = FALSE,
  xlim = NULL,
  ylim = NULL,
  xlab = NULL,
  ylab = NULL,
  ...
)

\method{plot}{pwb_day}(
  x,
  type = "PlantTranspiration",
  bySpecies = FALSE,
  xlim = NULL,
  ylim = NULL,
  xlab = NULL,
  ylab = NULL,
  ...
)
}
\arguments{
\item{x}{An object of class \code{spwb_day}, \code{growth_day} or \code{pwb_day}.}

\item{type}{The information to be plotted (see details).}

\item{bySpecies}{Allows aggregating output by species, before drawing plots. Aggregation can involve a sum (as for plant LAI or transpiration)
or a LAI-weighted mean (as for plant stress or plant water potential).}

\item{xlim}{Range of values for x.}

\item{ylim}{Range of values for y.}

\item{xlab}{x-axis label.}

\item{ylab}{y-axis label.}

\item{...}{Additional parameters for function \code{plot}.}
}
\value{
An ggplot object
}
\description{
Functions to plot the sub-daily simulation results of \code{\link{spwb_day}}, \code{\link{growth_day}}
or the transpiration calculations of \code{\link{transp_transpirationSperry}} or \code{\link{transp_transpirationSureau}}.
}
\details{
The following plots are available for \code{spwb_day} and \code{pwb_day}:
\itemize{
\item{\code{"LeafPsi"}: Leaf water potential (for shade and sunlit leaves).}
\item{\code{"LeafPsiAverage"}: Average leaf water potential.}
\item{\code{"RootPsi"}: Root crown water potential.}
\item{\code{"StemPsi"}: Stem water potential.}
\item{\code{"StemPLC"}: (Average) percentage of loss conductance in the stem conduits.}
\item{\code{"StemRWC"}: (Average) relative water content in the stem.}
\item{\code{"LeafRWC"}: Relative water content in the leaf.}
\item{\code{"StemSympRWC"}: (Average) relative water content in the stem symplasm.}
\item{\code{"LeafSympRWC"}: Relative water content in the leaf symplasm.}
\item{\code{"SoilPlantConductance"}: Overall soil plant conductance (calculated as the derivative of the supply function).}
\item{\code{"PlantExtraction"}:  Water extracted from each soil layer.}
\item{\code{"PlantTranspiration"}: Plant cohort transpiration per ground area.}
\item{\code{"TranspirationPerLeaf"}: Plant cohort transpiration per leaf area.}
\item{\code{"PlantGrossPhotosynthesis"}: Plant cohort gross photosynthesis per ground area.}
\item{\code{"GrossPhotosynthesisPerLeaf"}: Plant cohort gross photosynthesis per leaf area.}
\item{\code{"PlantNetPhotosynthesis"}: Plant cohort net photosynthesis per ground area.}
\item{\code{"NetPhotosynthesisPerLeaf"}: Plant cohort net photosynthesis per leaf area.}
\item{\code{"LeafTranspiration"}: Instantaneous transpiration per leaf area (differentiates sunlit and shade leaves).}
\item{\code{"LeafGrossPhotosynthesis"}: Instantaneous gross photosynthesis per leaf area (differentiates sunlit and shade leaves).}
\item{\code{"LeafNetPhotosynthesis"}: Instantaneous net photosynthesis per leaf area (differentiates sunlit and shade leaves).}
\item{\code{"LeafAbsorbedSWR"}: Absorbed short wave radiation per leaf area (differentiates sunlit and shade leaves).}
\item{\code{"LeafAbsorbedPAR"}: Absorbed photosynthetically-active radiation per leaf area (differentiates sunlit and shade leaves).}
\item{\code{"LeafNetLWR"}: Net long wave radiation per leaf area (differentiates sunlit and shade leaves).}
\item{\code{"LeafCi"}: Leaf intercellular CO2 concentration (differentiates sunlit and shade leaves).}
\item{\code{"LeafIntrinsicWUE"}: Leaf intrinsic water use efficiency, i.e. the ratio between instantaneous photosynthesis and stomatal conductance (differentiates sunlit and shade leaves).}
\item{\code{"LeafVPD"}: Leaf vapour pressure deficit (differentiates sunlit and shade leaves).}
\item{\code{"LeafStomatalConductance"}: Leaf stomatal conductance to water vapour (differentiates sunlit and shade leaves).}
\item{\code{"LeafTemperature"}: Leaf temperature (differentiates sunlit and shade leaves).}
\item{\code{"Temperature"}: Above-canopy, inside-canopy and soil temperature.}
\item{\code{"CanopyEnergyBalance"}: Canopy energy balance components.}
\item{\code{"SoilEnergyBalance"}: Soil energy balance components.}
\item{\code{"PlantWaterBalance"}: Difference between water extraction from the soil and transpired water per ground area.}
\item{\code{"WaterBalancePerLeaf"}: Difference between water extraction from the soil and transpired water per leaf area.}
}
And the following plots are additionally available for \code{growth_day}:
\itemize{
\item{\code{"GrossPhotosynthesis"}: Gross photosynthesis rate per dry weight.}
\item{\code{"MaintenanceRespiration"}: Maintenance respiration cost per dry weight.}
\item{\code{"RootExudation"}: Root exudation rate per dry weight.}
\item{\code{"LabileCarbonBalance"}: Labile carbon balance per dry weight.}
\item{\code{"SugarLeaf"}: Sugar concentration in leaves.}
\item{\code{"StarchLeaf"}: Starch concentration in leaves.}
\item{\code{"SugarSapwood"}: Sugar concentration in sapwood.}
\item{\code{"StarchSapwood"}: Starch concentration in sapwood.}
\item{\code{"SugarTransport"}: Phloem sugar transport rate.}
}
}
\note{
Only for soil plant water balance simulations using \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}. This function can be used to display subdaily dynamics of corresponding to single days on \code{\link{spwb}} runs, if control option \code{subdailyResults} is set to \code{TRUE}. See also option \code{subdaily} in \code{\link{plot.spwb}}.
}
\examples{
#Load example daily meteorological data
data(examplemeteo)

#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Define soil with default soil params (2 layers)
examplesoil <- defaultSoilParams(4)

#Switch to 'Sperry' transpiration mode
control <- defaultControl("Sperry")

#Enable subdaily results for plotting
control["subdailyResults"] <- TRUE

#Initialize model inputs
x2 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)

#Simulate one day only
d <- 100
date <- examplemeteo$dates[d]
meteovec <- unlist(examplemeteo[d,])
sd2 <- spwb_day(x2, date, meteovec,
              latitude = 41.82592, elevation = 100, slope= 0, aspect = 0)

#Display transpiration for subdaily steps
plot(sd2, "PlantTranspiration")

}
\seealso{
\code{\link{spwb_day}}, \code{\link{growth_day}}, \code{\link{plot.spwb}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/medfate-package.R
\docType{package}
\name{medfate-package}
\alias{medfate-package}
\alias{medfate}
\title{medfate: Mediterranean Forest Simulation}
\description{
Simulate Mediterranean forest functioning and dynamics using cohort-based description of vegetation
}
\references{
\itemize{
\item{De Cáceres et al. (2015) (\doi{10.1016/j.agrformet.2015.06.012})}
\item{De Cáceres et al. (2021) (\doi{10.1016/j.agrformet.2020.108233})}
\item{Ruffault et al. (2022) (\doi{10.5194/gmd-15-5593-2022})}
}
}
\seealso{
Useful links:
\itemize{
\item{\url{https://emf-creaf.github.io/medfate/}}
\item{\url{https://emf-creaf.github.io/medfatebook/}}
}
}
\author{
\strong{Maintainer}: Miquel De Cáceres
\email{miquelcaceres@gmail.com}
\href{https://orcid.org/0000-0001-7132-2080}{ORCID}

Authors: \itemize{
\item{ Nicolas Martin-StPaul
\href{https://orcid.org/0000-0001-7574-0108}{ORCID}}
\item{ Víctor Granda
\href{https://orcid.org/0000-0002-0469-1991}{ORCID}}
\item{ Antoine Cabon
\href{https://orcid.org/0000-0001-6426-1726}{ORCID}}
\item{ Arsène Druel
\href{https://orcid.org/0000-0002-3938-0085}{ORCID}}
\item{ Julien Ruffault
\href{https://orcid.org/0000-0003-3647-8172}{ORCID}}
}
Contributors: \itemize{
\item{ Jordi Martínez-Vilalta
\href{https://orcid.org/0000-0002-2332-7298}{ORCID}}
\item{ Maurizio Mencuccini
\href{https://orcid.org/0000-0003-0840-1477}{ORCID}}
\item{ François Pimont
\href{https://orcid.org/0000-0002-9842-6207}{ORCID}}
\item{ Hervé Cochard
\href{https://orcid.org/0000-0002-2727-7072}{ORCID}}
\item{ Aitor Améztegui
\href{https://orcid.org/0000-0001-6426-1726}{ORCID}}
\item{ Léa Veuillen
\href{https://orcid.org/0000-0002-2790-3627}{ORCID}}
\item{ Shengli Huang
\href{https://orcid.org/0003-3927-7042}{ORCID}}
}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{hydraulics_scalingconductance}
\alias{hydraulics_scalingconductance}
\alias{hydraulics_maximumSoilPlantConductance}
\alias{hydraulics_soilPlantResistancesSigmoid}
\alias{hydraulics_soilPlantResistancesWeibull}
\alias{hydraulics_rootxylemConductanceProportions}
\alias{hydraulics_averageRhizosphereResistancePercent}
\alias{hydraulics_findRhizosphereMaximumConductance}
\alias{hydraulics_taperFactorSavage}
\alias{hydraulics_terminalConduitRadius}
\alias{hydraulics_referenceConductivityHeightFactor}
\alias{hydraulics_maximumStemHydraulicConductance}
\title{Scaling from conductivity to conductance}
\usage{
hydraulics_maximumSoilPlantConductance(krhizomax, krootmax, kstemmax, kleafmax)

hydraulics_soilPlantResistancesSigmoid(
  psiSoil,
  psiRhizo,
  psiStem,
  PLCstem,
  psiLeaf,
  PLCleaf,
  krhizomax,
  n,
  alpha,
  krootmax,
  root_P50,
  root_slope,
  kstemmax,
  stem_P50,
  stem_slope,
  kleafmax,
  leaf_P50,
  leaf_slope
)

hydraulics_soilPlantResistancesWeibull(
  psiSoil,
  psiRhizo,
  psiStem,
  PLCstem,
  psiLeaf,
  PLCleaf,
  krhizomax,
  n,
  alpha,
  krootmax,
  rootc,
  rootd,
  kstemmax,
  stemc,
  stemd,
  kleafmax,
  leafc,
  leafd
)

hydraulics_rootxylemConductanceProportions(L, V)

hydraulics_averageRhizosphereResistancePercent(
  krhizomax,
  n,
  alpha,
  krootmax,
  rootc,
  rootd,
  kstemmax,
  stemc,
  stemd,
  kleafmax,
  leafc,
  leafd,
  psiStep = -0.01
)

hydraulics_findRhizosphereMaximumConductance(
  averageResistancePercent,
  n,
  alpha,
  krootmax,
  rootc,
  rootd,
  kstemmax,
  stemc,
  stemd,
  kleafmax,
  leafc,
  leafd,
  initialValue
)

hydraulics_taperFactorSavage(height)

hydraulics_terminalConduitRadius(height)

hydraulics_referenceConductivityHeightFactor(refheight, height)

hydraulics_maximumStemHydraulicConductance(
  xylemConductivity,
  refheight,
  Al2As,
  height,
  taper
)
}
\arguments{
\item{krhizomax}{Maximum rhizosphere hydraulic conductance (defined as flow per leaf surface unit and per pressure drop).}

\item{krootmax}{Maximum root xylem hydraulic conductance (defined as flow per leaf surface unit and per pressure drop).}

\item{kstemmax}{Maximum stem xylem hydraulic conductance (defined as flow per leaf surface unit and per pressure drop).}

\item{kleafmax}{Maximum leaf hydraulic conductance (defined as flow per leaf surface unit and per pressure drop).}

\item{psiSoil}{Soil water potential (in MPa). A scalar or a vector depending on the function.}

\item{psiRhizo}{Water potential (in MPa) in the rhizosphere (root surface).}

\item{psiStem}{Water potential (in MPa) in the stem.}

\item{PLCstem}{Percent loss of conductance (in \%) in the stem.}

\item{psiLeaf}{Water potential (in MPa) in the leaf.}

\item{n, alpha}{Parameters of the Van Genuchten function (rhizosphere vulnerability curve).}

\item{root_P50, root_slope}{Parameters of the Sigmoid function for roots (root xylem vulnerability curve).}

\item{stem_P50, stem_slope}{Parameters of the Sigmoid function for stems (stem xylem vulnerability curve).}

\item{leaf_P50, leaf_slope}{Parameters of the Sigmoid function for leaves (leaf vulnerability curve).}

\item{rootc, rootd}{Parameters of the Weibull function for roots (root xylem vulnerability curve).}

\item{stemc, stemd}{Parameters of the Weibull function for stems (stem xylem vulnerability curve).}

\item{leafc, leafd}{Parameters of the Weibull function for leaves (leaf vulnerability curve).}

\item{L}{Vector with the length of coarse roots (mm) for each soil layer.}

\item{V}{Vector with the proportion [0-1] of fine roots within each soil layer.}

\item{psiStep}{Water potential precision (in MPa).}

\item{averageResistancePercent}{Average (across water potential values) resistance percent of the rhizosphere, with respect to total resistance (rhizosphere + root xylem + stem xylem).}

\item{initialValue}{Initial value of rhizosphere conductance.}

\item{height}{Plant height (in cm).}

\item{refheight}{Reference plant height of measurement of xylem conductivity (in cm).}

\item{xylemConductivity}{Xylem conductivity as flow per length of conduit and pressure drop (in kg·m-1·s-1·MPa-1).}

\item{Al2As}{Leaf area to sapwood area (in m2·m-2).}

\item{taper}{A boolean flag to indicate correction by taper of xylem conduits (Christoffersen et al. 2017).}
}
\value{
Values returned for each function are:
\itemize{
\item{\code{hydraulics_maximumSoilPlantConductance}: The maximum soil-plant conductance, in the same units as the input segment conductances.}
\item{\code{hydraulics_averageRhizosphereResistancePercent}: The average percentage of resistance due to the rhizosphere, calculated across water potential values.}
\item{\code{hydraulics_findRhizosphereMaximumConductance}: The maximum rhizosphere conductance value given an average rhizosphere resistance and the vulnerability curves of rhizosphere, root and stem elements.}
\item{\code{hydraulics_taperFactorSavage}: Taper factor according to Savage et al. (2010).}
}
}
\description{
Functions used to scale from tissue conductivity to conductance of different elements of the continuum.
}
\details{
Details of the hydraulic model are given in the medfate book
}
\references{
Christoffersen, B. O., M. Gloor, S. Fauset, N. M. Fyllas, D. R. Galbraith, T. R. Baker, L. Rowland, R. A. Fisher, O. J. Binks, S. A. Sevanto, C. Xu, S. Jansen, B. Choat, M. Mencuccini, N. G. McDowell, and P. Meir. 2016. Linking hydraulic traits to tropical forest function in a size-structured and trait-driven model (TFS v.1-Hydro). Geoscientific Model Development Discussions 9: 4227–4255.

Savage, V. M., L. P. Bentley, B. J. Enquist, J. S. Sperry, D. D. Smith, P. B. Reich, and E. I. von Allmen. 2010. Hydraulic trade-offs and space filling enable better predictions of vascular structure and function in plants. Proceedings of the National Academy of Sciences of the United States of America 107:22722–7.

Olson, M.E., Anfodillo, T., Rosell, J.A., Petit, G., Crivellaro, A., Isnard, S., \enc{León-Gómez}{Leon-Gomez}, C., \enc{Alvarado-Cárdenas}{Alvarado-Cardenas}, L.O., and Castorena, M. 2014. Universal hydraulics of the flowering plants: Vessel diameter scales with stem length across angiosperm lineages, habits and climates. Ecology Letters 17: 988–997.
}
\seealso{
\code{\link{hydraulics_psi2K}}, \code{\link{hydraulics_supplyFunctionPlot}}, \code{\link{spwb}}, \code{\link{soil}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{soil_USDAType}
\alias{soil_USDAType}
\alias{soil_thetaFC}
\alias{soil_thetaWP}
\alias{soil_thetaSAT}
\alias{soil_waterFC}
\alias{soil_waterSAT}
\alias{soil_waterWP}
\alias{soil_waterPsi}
\alias{soil_waterExtractable}
\alias{soil_theta}
\alias{soil_water}
\alias{soil_rockWeight2Volume}
\alias{soil_psi}
\alias{soil_conductivity}
\alias{soil_capacitance}
\alias{soil_saturatedWaterDepth}
\alias{soil_vanGenuchtenParamsCarsel}
\alias{soil_campbellParamsClappHornberger}
\alias{soil_vanGenuchtenParamsToth}
\alias{soil_texture}
\alias{soil_saturatedConductivitySX}
\alias{soil_unsaturatedConductivitySX}
\alias{soil_thetaSATSX}
\alias{soil_theta2psiSX}
\alias{soil_psi2thetaSX}
\alias{soil_psi2kVG}
\alias{soil_psi2cVG}
\alias{soil_psi2thetaVG}
\alias{soil_theta2psiVG}
\title{Soil texture and hydraulics}
\usage{
soil_USDAType(clay, sand)

soil_thetaFC(soil, model = "SX")

soil_thetaWP(soil, model = "SX")

soil_thetaSAT(soil, model = "SX")

soil_waterFC(soil, model = "SX")

soil_waterSAT(soil, model = "SX")

soil_waterWP(soil, model = "SX")

soil_waterPsi(soil, psi, model = "SX")

soil_waterExtractable(soil, model = "SX", minPsi = -5)

soil_theta(soil, model = "SX")

soil_water(soil, model = "SX")

soil_rockWeight2Volume(pWeight, bulkDensity, rockDensity = 2.3)

soil_psi(soil, model = "SX")

soil_conductivity(soil, model = "SX", mmol = TRUE)

soil_capacitance(soil, model = "SX")

soil_saturatedWaterDepth(soil, model = "SX")

soil_vanGenuchtenParamsCarsel(soilType)

soil_campbellParamsClappHornberger(soilType)

soil_vanGenuchtenParamsToth(clay, sand, om, bd, topsoil)

soil_saturatedConductivitySX(clay, sand, bd, om, mmol = TRUE)

soil_unsaturatedConductivitySX(theta, clay, sand, bd, om, mmol = TRUE)

soil_thetaSATSX(clay, sand, om)

soil_theta2psiSX(clay, sand, theta, om)

soil_psi2thetaSX(clay, sand, psi, om)

soil_psi2kVG(ksat, n, alpha, theta_res, theta_sat, psi)

soil_psi2cVG(n, alpha, theta_res, theta_sat, psi)

soil_psi2thetaVG(n, alpha, theta_res, theta_sat, psi)

soil_theta2psiVG(n, alpha, theta_res, theta_sat, theta)
}
\arguments{
\item{clay}{Percentage of clay (in percent weight).}

\item{sand}{Percentage of sand (in percent weight).}

\item{soil}{Initialized soil object (returned by function \code{\link{soil}}).}

\item{model}{Either 'SX' or 'VG' for Saxton's or Van Genuchten's water retention models.}

\item{psi}{Water potential (in MPa).}

\item{minPsi}{Minimum water potential (in MPa) to calculate the amount of extractable water.}

\item{pWeight}{Percentage of corresponding to rocks, in weight.}

\item{bulkDensity}{Bulk density of the soil fraction (g/cm3).}

\item{rockDensity}{Rock density (g/cm3).}

\item{mmol}{Boolean flag to indicate that saturated conductivity units should be returned in mmol/m/s/MPa. If \code{mmol = FALSE} then units are cm/day.}

\item{soilType}{A string indicating the soil type.}

\item{om}{Percentage of organic matter (optional, in percent weight).}

\item{bd}{Bulk density (in g/cm3).}

\item{topsoil}{A boolean flag to indicate topsoil layer.}

\item{theta}{Relative water content (in percent volume).}

\item{ksat}{saturated hydraulic conductance}

\item{n, alpha, theta_res, theta_sat}{Parameters of the Van Genuchten-Mualem model (m = 1 - 1/n).}
}
\value{
Depends on the function (see details).
}
\description{
Low-level functions relating soil texture with soil hydraulics and soil water content.
}
\details{
\itemize{
\item{\code{soil_psi2thetaSX()} and \code{soil_theta2psiSX()} calculate water potentials (MPa) and water contents (theta) using texture data the formulae of Saxton et al. (1986) or Saxton & Rawls (2006) depending on whether organic matter is available.}
\item{\code{soil_psi2thetaVG()} and \code{soil_theta2psiVG()} to the same calculations as before, but using the Van Genuchten - Mualem equations (\enc{Wösten}{Wosten} & van Genuchten 1988). }
\item{\code{soil_saturatedConductivitySX()} returns the saturated conductivity of the soil (in mmol/m/s/MPa or cm/day), estimated from formulae of Saxton et al. (1986) or Saxton & Rawls (2006) depending on whether organic matter is available.}
\item{\code{soil_unsaturatedConductivitySX()} returns the unsaturated conductivity of the soil (in mmol/m/s/MPa or cm/day), estimated from formulae of Saxton et al. (1986) or Saxton & Rawls (2006) depending on whether organic matter is available.}
\item{\code{soil_USDAType()} returns the USDA type (a string) for a given texture.}
\item{\code{soil_vanGenuchtenParamsCarsel()} gives parameters for van Genuchten-Mualem equations (alpha, n, theta_res and theta_sat, where alpha is in MPa-1) for a given texture type (Leij et al. 1996) }
\item{\code{soil_vanGenuchtenParamsToth()} gives parameters for van Genuchten-Mualem equations (alpha, n, theta_res and theta_sat, where alpha is in MPa-1) for a given texture, organic matter and bulk density (Toth et al. 2015).}
\item{\code{soil_psi()} returns the water potential (MPa) of each soil layer, according to its water retention model.}
\item{\code{soil_theta()} returns the moisture content (as percent of soil volume) of each soil layer, according to its water retention model.}
\item{\code{soil_water()} returns the water volume (mm) of each soil layer, according to its water retention model.}
\item{\code{soil_conductivity()} returns the conductivity of each soil layer (in mmol/m/s/MPa or cm/day).}
\item{\code{soil_waterExtractable()} returns the water volume (mm) extractable from the soil according to its water retention curves and up to a given soil water potential.}
\item{\code{soil_waterFC()} and \code{soil_thetaFC()} calculate the water volume (in mm) and moisture content (as percent of soil volume) of each soil layer at field capacity, respectively.}
\item{\code{soil_waterWP()} and \code{soil_thetaWP()} calculate the water volume (in mm) and moisture content (as percent of soil volume) of each soil layer at wilting point (-1.5 MPa), respectively. }
\item{\code{soil_waterSAT()}, \code{soil_thetaSATSX()} and \code{soil_thetaSAT()} calculate the saturated water volume (in mm) and moisture content (as percent of soil volume) of each soil layer.}
\item{\code{soil_saturatedWaterDepth()} returns the depth to saturation in mm from surface.}
\item{\code{soil_rockWeight2Volume()} transforms rock percentage from weight to volume basis.}
}
}
\examples{
#Determine USDA soil texture type
type = soil_USDAType(clay=40, sand=10)
type

#Van Genuchten's params (bulk density = 1.3 g/cm)
vg = soil_vanGenuchtenParamsToth(40,10,1,1.3,TRUE)
vg

# Define soil with default params
soil_df <- defaultSoilParams(4)
soil_df

# Initialize soil parameters and state variables
s = soil(soil_df)

# Plot Saxton's and Van Genuchten's water retention curves
plot(s, model="both")

}
\references{
Leij, F.J., Alves, W.J., Genuchten, M.T. Van, Williams, J.R., 1996. The UNSODA Unsaturated Soil Hydraulic Database User’s Manual Version 1.0.

Saxton, K.E., Rawls, W.J., Romberger, J.S., Papendick, R.I., 1986. Estimating generalized soil-water characteristics from texture. Soil Sci. Soc. Am. J. 50, 1031–1036.

Saxton, K.E., Rawls, W.J., 2006. Soil water characteristic estimates by texture and organic matter for hydrologic solutions. Soil Sci. Soc. Am. J. 70, 1569. doi:10.2136/sssaj2005.0117

\enc{Wösten}{Wosten}, J.H.M., & van Genuchten, M.T. 1988. Using texture and other soil properties to predict the unsaturated soil hydraulic functions. Soil Science Society of America Journal 52: 1762–1770.

\enc{Tóth}{Toth}, B., Weynants, M., Nemes, A., \enc{Makó}{Mako}, A., Bilas, G., and \enc{Tóth}{Toth}, G. 2015. New generation of hydraulic pedotransfer functions for Europe. European Journal of Soil Science 66: 226–238.
}
\seealso{
\code{\link{soil}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regeneration.R
\name{regeneration}
\alias{regeneration}
\alias{regeneration_seedproduction}
\alias{regeneration_seedrefill}
\alias{regeneration_seedmortality}
\alias{regeneration_germination}
\alias{regeneration_seedlings_daily}
\alias{regeneration_seedlings}
\alias{regeneration_recruitment}
\alias{regeneration_recruitment_daily}
\alias{regeneration_resprouting}
\title{Plant regeneration}
\usage{
regeneration_seedproduction(forest, SpParams, control)

regeneration_seedrefill(seedBank, refillSpecies, refillPercent = NULL)

regeneration_seedmortality(seedBank, SpParams, minPercent = 1)

regeneration_germination(forest, SpParams, control)

regeneration_seedlings_daily(
  forest,
  SpParams,
  control,
  growthResult,
  verbose = FALSE
)

regeneration_seedlings(
  forest,
  SpParams,
  control,
  minMonthTemp,
  moistureIndex,
  verbose = FALSE
)

regeneration_recruitment(
  forest,
  SpParams,
  control,
  minMonthTemp,
  moistureIndex,
  verbose = FALSE
)

regeneration_recruitment_daily(
  forest,
  SpParams,
  control,
  growthResult,
  verbose = FALSE
)

regeneration_resprouting(
  forest,
  internalMortality,
  SpParams,
  control,
  management_results = NULL
)
}
\arguments{
\item{forest}{An object of class \code{\link{forest}}.}

\item{SpParams}{A data frame with species parameters (see \code{\link{SpParamsMED}} and \code{\link{SpParamsDefinition}}).}

\item{control}{A list with default control parameters (see \code{\link{defaultControl}}).}

\item{seedBank}{A data frame with columns 'Species' and 'Percent', describing a seed bank.}

\item{refillSpecies}{A string vector of species names corresponding to seed rain to refill seed bank.}

\item{refillPercent}{A numeric vector of indicating the percentage of seed bank refilling (if missing then seed bank is set to 100\%).}

\item{minPercent}{A minimum percent of seed bank to retain entry in \code{seedBank} element of \code{forest}.}

\item{growthResult}{An object of class 'growth'.}

\item{verbose}{Boolean flag to indicate console output during calculations.}

\item{minMonthTemp}{Minimum month temperature.}

\item{moistureIndex}{Moisture index (annual precipitation over annual potential evapotranspiration).}

\item{internalMortality}{A data frame with mortality occurred in the last year of simulation.}

\item{management_results}{The result of calling a management function (see \code{\link{defaultManagementFunction}}).}
}
\value{
\itemize{
\item{\code{regeneration_seedproduction} returns a list of species names}
\item{\code{regeneration_seedrefill} and \code{regeneration_seedmortality} return a copy of the input \code{data.frame} object with an update seed bank. }
\item{\code{regeneration_resprouting} and \code{regeneration_recruitment} return a new object of class \code{\link{forest}} with the new plant cohorts.}
}
}
\description{
Functions to simulate annual plant regeneration from seed recruitment or from resprouting
}
\details{
\itemize{
\item{\code{regeneration_seedproduction} evaluates if reproductive individuals (i.e. sufficiently tall individuals) are present.}
\item{\code{regeneration_seedrefill} fills seed bank of input \code{forest} object with seed rain.}
\item{\code{regeneration_seedmortality} updates seed bank of input \code{forest} object according to annual seed mortality.}
\item{\code{regeneration_recruitment} evaluates recruitment from the seed bank (or local seed production if seed bank is missing). Minimum month temperature and moisture index values are used to determine if recruitment was successful.
Species also require a minimum amount of light at the ground level.}
\item{\code{regeneration_resprouting} evaluates resprouting occurs after “mortality” from die-back (including drought- or pathogen-induced dessication),
cutting or burning of the aerial part in a species with resprouting ability,
but not after carbon starvation or baseline mortality (unspecific mortality causes).}
}
}
\examples{
#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Initialize control parameters
control <- defaultControl("Granier")
control$recruitmentMode = "annual/deterministic" 

#Recruitment limits
plant_parameter(exampleforest, SpParamsMED, "MinTempRecr")
plant_parameter(exampleforest, SpParamsMED, "MinMoistureRecr")

#Compare seed recruitment outcomes
regeneration_recruitment(exampleforest, SpParamsMED, control, 0, 0.25)
regeneration_recruitment(exampleforest, SpParamsMED, control, 3, 0.25)

}
\seealso{
\code{\link{fordyn}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{soil_thermodynamics}
\alias{soil_thermodynamics}
\alias{soil_thermalCapacity}
\alias{soil_thermalConductivity}
\alias{soil_temperatureGradient}
\alias{soil_temperatureChange}
\title{Soil thermodynamic functions}
\usage{
soil_thermalCapacity(soil, model = "SX")

soil_thermalConductivity(soil, model = "SX")

soil_temperatureGradient(gradTemp, widths, Temp)

soil_temperatureChange(
  widths,
  Temp,
  sand,
  clay,
  W,
  Theta_SAT,
  Theta_FC,
  Gdown,
  tstep
)

soil_temperatureGradient(gradTemp, widths, Temp)
}
\arguments{
\item{soil}{Soil object (returned by function \code{\link{soil}}).}

\item{model}{Either 'SX' or 'VG' for Saxton's or Van Genuchten's pedotransfer models.}

\item{widths}{Width of soil layers (in mm).}

\item{Temp}{Temperature (in ºC) for each soil layer.}

\item{sand}{Percentage of sand (in percent weight) for each layer.}

\item{clay}{Percentage of clay (in percent weight) for each layer.}

\item{W}{Soil moisture (in percent of field capacity) for each layer.}

\item{Theta_SAT}{Relative water content (in percent volume) at saturation for each layer.}

\item{Theta_FC}{Relative water content (in percent volume) at field capacity for each layer.}

\item{Gdown}{Downward heat flux from canopy to soil (in W·m-2).}

\item{tstep}{Time step (interval) in seconds.}
}
\value{
Function \code{soil_thermalConductivity} returns a vector with values of thermal conductivity (W/m/ºK) for each soil layer.

Function \code{soil_thermalCapacity} returns a vector with values of heat storage capacity (J/m3/ºK) for each soil layer.

Function \code{soil_temperatureGradient} returns a vector with values of temperature gradient between consecutive soil layers.

Function \code{soil_temperatureChange} returns a vector with values of instantaneous temperature change (ºC/s) for each soil layer.
}
\description{
Functions \code{soil_thermalConductivity} and \code{soil_thermalCapacity} calculate thermal conductivity and thermal capacity
for each soil layer, given its texture and water content. Functions \code{soil_temperatureGradient} and \code{soil_temperatureChange}
are used to calculate soil temperature gradients (in ºC/m) and temporal temperature change (in ºC/s)
given soil layer texture and water content (and possibly including heat flux from above).
}
\examples{
#Define soil and complete parameters
examplesoil = soil(defaultSoilParams(4))

soil_thermalConductivity(examplesoil)
soil_thermalCapacity(examplesoil)

#Values change when altering water content (drier layers have lower conductivity and capacity)
examplesoil$W = c(0.1, 0.4, 0.7, 1.0)
soil_thermalConductivity(examplesoil)
soil_thermalCapacity(examplesoil)

}
\references{
Cox, P.M., Betts, R.A., Bunton, C.B., Essery, R.L.H., Rowntree, P.R., and Smith, J. 1999. The impact of new land surface physics on the GCM simulation of climate and climate sensitivity. Climate Dynamics 15: 183–203.

Dharssi, I., Vidale, P.L., Verhoef, A., MacPherson, B., Jones, C., and Best, M. 2009. New soil physical properties implemented in the Unified Model at PS18. 9–12.
}
\seealso{
\code{\link{soil}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.spwb.R
\name{plot.spwb}
\alias{plot.spwb}
\alias{plot.aspwb}
\alias{plot.pwb}
\alias{plot.growth}
\alias{plot.fordyn}
\title{Plots simulation results}
\usage{
\method{plot}{spwb}(
  x,
  type = "PET_Precipitation",
  cohorts = NULL,
  bySpecies = FALSE,
  dates = NULL,
  subdaily = FALSE,
  xlim = NULL,
  ylim = NULL,
  xlab = NULL,
  ylab = NULL,
  summary.freq = NULL,
  ...
)

\method{plot}{aspwb}(
  x,
  type = "PET_Precipitation",
  dates = NULL,
  xlim = NULL,
  ylim = NULL,
  xlab = NULL,
  ylab = NULL,
  summary.freq = NULL,
  ...
)

\method{plot}{pwb}(
  x,
  type = "PlantTranspiration",
  cohorts = NULL,
  bySpecies = FALSE,
  dates = NULL,
  subdaily = FALSE,
  xlim = NULL,
  ylim = NULL,
  xlab = NULL,
  ylab = NULL,
  summary.freq = NULL,
  ...
)

\method{plot}{growth}(
  x,
  type = "PET_Precipitation",
  cohorts = NULL,
  bySpecies = FALSE,
  dates = NULL,
  subdaily = FALSE,
  xlim = NULL,
  ylim = NULL,
  xlab = NULL,
  ylab = NULL,
  summary.freq = NULL,
  ...
)

\method{plot}{fordyn}(
  x,
  type = "StandBasalArea",
  cohorts = NULL,
  bySpecies = FALSE,
  dates = NULL,
  xlim = NULL,
  ylim = NULL,
  xlab = NULL,
  ylab = NULL,
  summary.freq = NULL,
  ...
)
}
\arguments{
\item{x}{An object of class \code{spwb}, \code{pwb}, \code{growth} or \code{fordyn}.}

\item{type}{The information to be plotted (see details)}

\item{cohorts}{An integer, boolean or character vector to select the plant cohorts to be plotted. If \code{cohorts = "T"} (resp. \code{cohorts = "S"}) then all tree (resp. shrub) cohorts will be displayed.}

\item{bySpecies}{Allows aggregating output by species, before drawing plots (only has an effect with some values of \code{type}). Aggregation can involve a sum (as for plant lai or transpiration) or a LAI-weighted mean (as for plant stress or plant water potential), where LAI values are those of \code{LAIlive}.}

\item{dates}{A Date vector with a subset of dates to be plotted.}

\item{subdaily}{Whether subdaily results should be shown, only for simulations using \code{transpirationMode = "Sperry"} and having set \code{subdailyResults = TRUE} in the simulation control object. If \code{subdaily = TRUE}, then the valid strings for \code{type} are listed in \code{\link{plot.spwb_day}}.}

\item{xlim}{Range of values for x.}

\item{ylim}{Range of values for y.}

\item{xlab}{x-axis label.}

\item{ylab}{y-axis label.}

\item{summary.freq}{Frequency of summary statistics (see \code{\link{cut.Date}}).}

\item{...}{Additional parameters for function \code{plot} (not used).}
}
\value{
An ggplot object
}
\description{
Function \code{plot} plots time series of the results of the soil plant water balance model (see \code{\link{spwb}}),
plant water balance model (see \code{\link{pwb}}), the forest growth model (see \code{\link{growth}})
or the forest dynamics model (see \code{\link{fordyn}}).
}
\details{
The following plots are currently available for \code{\link{spwb}} (most of them also for \code{\link{pwb}}):
\itemize{
\item{\code{"PET_Precipitation"}: Potential evapotranspiration and Precipitation.}
\item{\code{"PET_NetRain"}: Potential evapotranspiration and Net rainfall.}
\item{\code{"Snow"}: Snow precipitation and snowpack dynamics.}
\item{\code{"Export"}: Water exported through deep drainage and surface runoff.}
\item{\code{"Evapotranspiration"}: Plant transpiration and soil evaporation.}
\item{\code{"SoilPsi"}: Soil water potential.}
\item{\code{"SoilRWC"}: Soil relative water content (in percent of field capacity).}
\item{\code{"SoilTheta"}: Soil moisture water content (in percent volume).}
\item{\code{"SoilVol"}: Soil water volumetric content (in mm).}
\item{\code{"PlantExtraction"}: Water extracted by plants from each soil layer.}
\item{\code{"HydraulicRedistribution"}: Water added to each soil layer coming from other soil layers, transported through the plant hydraulic network.}
\item{\code{"LAI"}: Expanded and dead leaf area index of the whole stand.}
\item{\code{"PlantLAI"}: Plant cohort leaf area index (expanded leaves).}
\item{\code{"PlantLAIlive"}: Plant cohort leaf area index ("live" leaves).}
\item{\code{"PlantStress"}: Plant cohort average daily drought stress.}
\item{\code{"PlantTranspiration"}: Plant cohort transpiration.}
\item{\code{"TranspirationPerLeaf"}: Plant cohort transpiration per leaf area.}
\item{\code{"PlantGrossPhotosynthesis"}: Plant cohort photosynthesis.}
\item{\code{"GrossPhotosynthesisPerLeaf"}: Plant cohort photosynthesis per leaf area.}
\item{\code{"StemRWC"}: Average daily stem relative water content.}
\item{\code{"LeafRWC"}: Average daily leaf relative water content.}
\item{\code{"LFMC"}: Live fuel moisture content.}
}
The following plots are available for \code{\link{spwb}} and \code{\link{pwb}} \emph{only if} \code{transpirationMode = "Granier"}:
\itemize{
\item{\code{"PlantPsi"}: Plant cohort water potential.}
\item{\code{"FPAR"}: Fraction of PAR at the canopy level of each plant cohort.}
\item{\code{"AbsorbedSWRFraction"}: Fraction of SWR absorbed by each plant cohort.}
}
The following plots are available for \code{\link{spwb}} and \code{\link{pwb}} \emph{only if} \code{transpirationMode = "Sperry"}:
\itemize{
\item{\code{"SoilPlantConductance"}: Average instantaneous overall soil plant conductance (calculated as the derivative of the supply function).}
\item{\code{"LeafPsiMin"}:  Midday leaf water potential.}
\item{\code{"LeafPsiMax"}:  Pre-dawn leaf water potential.}
\item{\code{"LeafPsiRange"}:  Range of leaf water potential.}
\item{\code{"LeafPsiMin_SL"}: Minimum water potential of sunlit leaves.}
\item{\code{"LeafPsiMax_SL"}: Maximum water potential of sunlit leaves.}
\item{\code{"LeafPsiMin_SH"}: Minimum water potential of shade leaves.}
\item{\code{"LeafPsiMax_SH"}: Maximum water potential of shade leaves.}
\item{\code{"TempMin_SL"}: Minimum temperature of sunlit leaves.}
\item{\code{"TempMax_SL"}: Maximum temperature of sunlit leaves.}
\item{\code{"TempMin_SH"}: Minimum temperature of shade leaves.}
\item{\code{"TempMax_SH"}: Maximum temperature of shade leaves.}
\item{\code{"GSWMin_SL"}: Minimum stomatal conductance of sunlit leaves.}
\item{\code{"GSWMax_SL"}: Maximum stomatal conductance of sunlit leaves.}
\item{\code{"GSWMin_SH"}: Minimum stomatal conductance of shade leaves.}
\item{\code{"GSWMax_SH"}: Maximum stomatal conductance of shade leaves.}
\item{\code{"StemPsi"}:  Midday (upper) stem water potential.}
\item{\code{"RootPsi"}:  Midday root crown water potential.}
\item{\code{"PlantNetPhotosynthesis"}:  Plant cohort net photosynthesis.}
\item{\code{"NetPhotosynthesisPerLeaf"}:  Plant cohort net photosynthesis per leaf area.}
\item{\code{"PlantWUE"}:  Plant cohort daily water use efficiency.}
\item{\code{"PlantAbsorbedSWR"}:  Plant cohort absorbed short wave radiation.}
\item{\code{"AbsorbedSWRPerLeaf"}:  Plant cohort absorbed short wave radiation per leaf area.}
\item{\code{"PlantNetLWR"}:  Plant cohort net long wave radiation.}
\item{\code{"NetLWRPerLeaf"}:  Plant cohort net long wave radiation per leaf area.}
\item{\code{"AirTemperature"}:  Minimum/maximum/mean daily temperatures above canopy.}
\item{\code{"CanopyTemperature"}:  Minimum/maximum/mean daily temperatures inside canopy.}
\item{\code{"SoilTemperature"}:  Minimum/maximum/mean daily temperatures inside the first soil layer.}
\item{\code{"CanopyEnergyBalance"}:  Canopy energy balance components.}
\item{\code{"SoilEnergyBalance"}:  Soil energy balance components.}
}
In addition to the former, the following plots are available for objects \code{\link{growth}} or \code{\link{fordyn}}:
\itemize{
\item{\code{"CarbonBalance"}:  Stand-level carbon balance components.}
\item{\code{"BiomassBalance"}:  Stand-level biomass balance components.}
\item{\code{"GrossPhotosynthesis"}:  Gross photosynthesis rate per dry weight.}
\item{\code{"MaintenanceRespiration"}:  Maintenance respiration cost per dry weight.}
\item{\code{"PhotosynthesisMaintenanceRatio"}:  The ratio of gross photosynthesis over maintenance respiration.}
\item{\code{"RootExudation"}:  Root exudation rate per dry weight.}
\item{\code{"LabileCarbonBalance"}:  Labile carbon balance per dry weight.}
\item{\code{"SugarLeaf"}:  Sugar concentration in leaves.}
\item{\code{"StarchLeaf"}:  Starch concentration in leaves.}
\item{\code{"SugarSapwood"}:  Sugar concentration in sapwood.}
\item{\code{"StarchSapwood"}:  Starch concentration in sapwood.}
\item{\code{"SugarTransport"}:  Phloem sugar transport rate.}
\item{\code{"StructuralBiomassBalance"}:  Daily structural biomass balance (g dry · ind-2).}
\item{\code{"LabileBiomassBalance"}:  Daily labile biomass balance (g dry · ind-2).}
\item{\code{"PlantBiomassBalance"}:  Daily plant biomass balance, i.e. labile change + structural change (g dry · ind-2).}
\item{\code{"MortalityBiomassLoss"}:  Biomass loss due to mortality (g dry · m-2).}
\item{\code{"PlantBiomassBalance"}:  Daily cohort biomass balance (including mortality) (g dry · m-2).}
\item{\code{"LeafBiomass"}: Leaf structural dry biomass per individual.}
\item{\code{"SapwoodBiomass"}: Sapwood dry biomass per individual.}
\item{\code{"FineRootBiomass"}: Fine root dry biomass per individual.}
\item{\code{"SapwoodArea"}:  Sapwood area per individual.}
\item{\code{"LeafArea"}:  Leaf area per individual.}
\item{\code{"FineRootArea"}: Fine root area per individual (only for \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}).}
\item{\code{"DBH"}: Diameter at breast height (in cm) for an average individual of each plant cohort.}
\item{\code{"Height"}: Height (in cm) for an average individual of each plant cohort.}
\item{\code{"SAgrowth"}:  Sapwood area growth rate.}
\item{\code{"LAgrowth"}:  Leaf area growth rate.}
\item{\code{"FRAgrowth"}:  Fine root area growth rate (only for \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}).}
\item{\code{"HuberValue"}:  Ratio of leaf area to sapwood area.}
\item{\code{"RootAreaLeafArea"}:  Ratio of fine root area to leaf area (only for \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}).}
}
Finally, the following plots are only available for \code{\link{fordyn}} simulation results:
\itemize{
\item{\code{"StandBasalArea"}: Stand basal area of living trees.}
\item{\code{"StandDensity"}: Stand density of living trees.}
\item{\code{"SpeciesBasalArea"}: Basal area of living trees by species.}
\item{\code{"SpeciesDensity"}: Density of living trees by species.}
\item{\code{"CohortBasalArea"}: Basal area of living trees by plant cohort.}
\item{\code{"CohortDensity"}: Density of living trees by plant cohort.}
}
}
\examples{
\donttest{
#Load example daily meteorological data
data(examplemeteo)

#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Define soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

#Initialize control parameters
control <- defaultControl("Granier")

#Initialize input
x <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)

#Call simulation function
S1 <- spwb(x, examplemeteo, latitude = 41.82592, elevation = 100)

#Plot results
plot(S1)
}
}
\seealso{
\code{\link{spwb}}, \code{\link{pwb}}, \code{\link{growth}}, \code{\link{fordyn}}, \code{\link{summary.spwb}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{fuel_properties}
\alias{fuel_properties}
\alias{fuel_stratification}
\alias{fuel_FCCS}
\title{Fuel stratification and fuel characteristics}
\usage{
fuel_stratification(
  object,
  SpParams,
  gdd = NA_real_,
  heightProfileStep = 10,
  maxHeightProfile = 5000,
  bulkDensityThreshold = 0.05
)

fuel_FCCS(
  object,
  SpParams,
  cohortFMC = as.numeric(c()),
  loadingOffset = as.numeric(c(0, 0, 0, 0, 0)),
  gdd = NA_real_,
  heightProfileStep = 10,
  maxHeightProfile = 5000,
  bulkDensityThreshold = 0.05,
  depthMode = "crownaverage"
)
}
\arguments{
\item{object}{An object of class \code{\link{forest}}}

\item{SpParams}{A data frame with species parameters (see \code{\link{SpParamsMED}}).}

\item{gdd}{Growth degree-days.}

\item{heightProfileStep}{Precision for the fuel bulk density profile.}

\item{maxHeightProfile}{Maximum height for the fuel bulk density profile.}

\item{bulkDensityThreshold}{Minimum fuel bulk density to delimit fuel strata.}

\item{cohortFMC}{A numeric vector of (actual) fuel moisture content by cohort.}

\item{loadingOffset}{A vector of length five with fine fuel loading values (canopy, shrub, herb, woody and litter) to be added to loading estimations from \code{forest}.}

\item{depthMode}{Specifies how fuel depth (and therefore canopy and understory bulk density) should be estimated:
\itemize{
\item{\code{"crownaverage"}: As weighed average of crown lengths using loadings as weights.}
\item{\code{"profile"}: As the difference of base and top heights in bulk density profiles.}
\item{\code{"absoluteprofile"}: As the difference of absolute base and absolute top heights in bulk density profiles.}
}}
}
\value{
Function \code{fuel_FCCS} returns a data frame with five rows corresponding to  fuel layers:
\code{canopy}, \code{shrub}, \code{herb}, \code{woody} and \code{litter}. Columns correspond fuel properties:
\itemize{
\item{\code{w}: Fine fuel loading (in kg/m2).}
\item{\code{cover}: Percent cover.}
\item{\code{hbc}: Height to base of crowns (in m).}
\item{\code{htc}: Height to top of crowns (in m).}
\item{\code{delta}: Fuel depth (in m).}
\item{\code{rhob}: Fuel bulk density (in kg/m3).}
\item{\code{rhop}: Fuel particle density (in kg/m3).}
\item{\code{PV}: Particle volume (in m3/m2).}
\item{\code{beta}: Packing ratio (unitless).}
\item{\code{betarel}: Relative packing ratio (unitless).}
\item{\code{etabetarel}: Reaction efficiency (unitless).}
\item{\code{sigma}: Surface area-to-volume ratio (m2/m3).}
\item{\code{pDead}: Proportion of dead fuels.}
\item{\code{FAI}: Fuel area index (unitless).}
\item{\code{h}: High heat content (in kJ/kg).}
\item{\code{RV}: Reactive volume (in m3/m2).}
\item{\code{MinFMC}: Minimum fuel moisture content (as percent over dry weight).}
\item{\code{MaxFMC}: Maximum fuel moisture content (as percent over dry weight).}
\item{\code{ActFMC}: Actual fuel moisture content (as percent over dry weight). These are set to \code{NA} if parameter \code{cohortFMC} is empty.}
}

Function \code{fuel_stratification} returns a list with the following items:
\itemize{
\item{\code{surfaceLayerBaseHeight}: Base height of crowns of shrubs in the surface layer (in cm).}
\item{\code{surfaceLayerTopHeight}: Top height of crowns of shrubs in the surface layer (in cm).}
\item{\code{understoryLAI}: Cumulated LAI of the understory layer (i.e. leaf area comprised between surface layer base and top heights).}
\item{\code{canopyBaseHeight}: Base height of tree crowns in the canopy (in cm).}
\item{\code{canopyTopHeight}: Top height of tree crowns in the canopy (in cm).}
\item{\code{canopyLAI}: Cumulated LAI of the canopy (i.e. leaf area comprised between canopy base and top heights).}
}
}
\description{
Function \code{fuel_stratification} provides a stratification of the stand into understory and canopy strata.
Function \code{fuel_FCCS} calculates fuel characteristics from a \code{forest} object
following an adaptation of the protocols described for the Fuel Characteristics Classification System (Prichard et al. 2013).
}
\examples{
#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Show stratification of fuels
fuel_stratification(exampleforest, SpParamsMED)
  
#Calculate fuel properties according to FCCS
fccs <- fuel_FCCS(exampleforest, SpParamsMED)
fccs


}
\references{
Prichard, S. J., D. V Sandberg, R. D. Ottmar, E. Eberhardt, A. Andreu, P. Eagle, and K. Swedin. 2013. Classification System Version 3.0: Technical Documentation.

Reinhardt, E., D. Lutes, and J. Scott. 2006. FuelCalc: A method for estimating fuel characteristics. Pages 273–282.
}
\seealso{
\code{\link{fire_FCCS}}, \code{\link{spwb}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils_ldrOptimization.R
\name{utils_ldrExploration}
\alias{utils_ldrExploration}
\alias{utils_ldrOptimization}
\title{Optimization of root distribution}
\usage{
utils_ldrExploration(
  x,
  meteo,
  cohorts = NULL,
  RZmin = 301,
  RZmax = 4000,
  V1min = 0.01,
  V1max = 0.94,
  resolution = 10,
  heat_stop = 0,
  transformation = "identity",
  verbose = FALSE,
  ...
)

utils_ldrOptimization(y, psi_crit, opt_mode = 1)
}
\arguments{
\item{x}{An object of class \code{\link{spwbInput}}.}

\item{meteo}{A data frame with daily meteorological data series (see \code{\link{spwb}}).}

\item{cohorts}{A character string with the names of cohorts to be explored. If \code{NULL} then all cohorts are explored.}

\item{RZmin}{The minimum value of RZ (the rooting depth) to be explored (in mm)}

\item{RZmax}{The maximum value of RZ (the rooting depth) to be explored (in mm)}

\item{V1min}{The minimum value of V1 (the root proportion in the first soil layer) to be explored}

\item{V1max}{The maximum value of V1 (the root proportion in the first soil layer) to be explored}

\item{resolution}{An integer defining the number of values to obtain by discretization of the root parameters RZ and V1. The number of parameter combinations and therefore the computation cost increases increase with the square of resolution}

\item{heat_stop}{An integer defining the number of days during to discard from the calculation of the optimal root distribution. Usefull if the soil water content initialization is not certain}

\item{transformation}{Function to modify the size of Z intervals to be explored (by default, bins are equal).}

\item{verbose}{A logical value. Print the internal messages of the function?}

\item{...}{Additional parameters to function \code{\link[medfate]{spwb}}.}

\item{y}{The result of calling \code{utils_ldrExploration}.}

\item{psi_crit}{A numerical vector of length iqual to the number of species in the plot containing the species values of water potential inducing hydraulic failure (in MPa). Use \code{NA} values to skip optimization for particular plant cohorts.}

\item{opt_mode}{Optimization mode:
\itemize{
\item{\code{opt_mode = 1} maximizes transpiration along the line of stress equal to \code{psi_crit} (Cabon et al. 2018). The optimization is based on the eco-hydrological equilibrium hypothesis (Eagleson, 1982), which is formulated here as the root distribution for which plant transpiration is maximized while the plant water potential is close to the species-defined critical value \code{psi_crit} (Cabon et al.,2018).}
\item{\code{opt_mode = 2} maximizes transpiration among combinations with stress according to \code{psi_crit}).}
\item{\code{opt_mode = 3} maximizes photosynthesis among combinations with stress according to \code{psi_crit}).}
\item{\code{opt_mode = 4} maximizes transpiration, subject to root construction constrains, among combinations with stress according to \code{psi_crit}).}
\item{\code{opt_mode = 5} maximizes photosynthesis, subject to root construction constrains, among combinations with stress according to \code{psi_crit}).}
}}
}
\value{
Function \code{utils_ldrExploration} returns a list containing a list containing
the explored RZ and V1 combinations as well as arrays with the values of average daily plant transpiration,
average daily net photosynthesis and the minimum plant water potential for each cohort and parameter combination.

Function \code{utils_ldrOptimization}  returns a data frame with containing
the species index used in medfate, \code{psi_crit} and the optimized values of V1
and the LDR parameters Z50 and Z95 (see \code{\link{root_ldrDistribution}})
and as many rows as the number of species.
}
\description{
Functions \code{utils_ldrExploration} and \code{utils_ldrOptimization} are used to
find optimum the species root distribution within \code{spwb}, given the arguments
\code{x}, \code{meteo} and \code{psi_crit}.
}
\details{
For each combination of the parameters RZ and V1 the function \code{utils_ldrExploration} runs \code{spwb},
setting the total soil depth equal to RZ. The root proportion in each soil layer is derived from V1,
the depth of the first soil layer and RZ using the LDR root distribution model (Schenk and Jackson, 2002)
and assuming that the depth containing 95 percent of the roots is equal to RZ.
Function \code{utils_ldrOptimization} takes the result of the exploration and tries
to find optimum root distribution parameters. \code{psi_crit}, the species specific
water potential inducing hydraulic failure, can be approached by the water potential
inducing 50 percent of loss of conductance for the and gymnosperms and 88 percent for
the angiosperms (Urli et al., 2013, Brodribb et al., 2010). Details of the hypothesis
and limitations of the optimization method are given in Cabon et al. (2019).
}
\references{
Brodribb, T.J., Bowman, D.J.M.S., Nichols, S., Delzon, S., Burlett, R., 2010. Xylem function and growth rate interact to determine recovery rates after exposure to extreme water deficit. New Phytol. 188, 533–542. doi:10.1111/j.1469-8137.2010.03393.x

Cabon, A., \enc{Martínez-Vilalta}{Martinez-Vilalta}, J., Poyatos, R., \enc{Martínez de Aragón}{Martinez de Aragon}, J., De \enc{Cáceres}{Caceres}, M. (2018) Applying the eco-hydrological equilibrium hypothesis to estimate root ditribution in water-limited forests. Ecohydrology 11: e2015.

Eagleson, P.S., 1982. Ecological optimality in water-limited natural soil-vegetation systems: 1. Theory and hypothesis. Water Resour. Res. 18, 325–340. doi:10.1029/WR018i002p00325

Schenk, H.J., Jackson, R.B., 2002. The Global Biogeography of Roots. Ecol. Monogr. 72, 311. doi:10.2307/3100092

Urli, M., Porte, A.J., Cochard, H., Guengant, Y., Burlett, R., Delzon, S., 2013. Xylem embolism threshold for catastrophic hydraulic failure in angiosperm trees. Tree Physiol. 33, 672–683. doi:10.1093/treephys/tpt030
}
\seealso{
\code{\link{utils_rockOptimization}},  \code{\link{spwb}}, \code{\link{soil}}, \code{\link{root_ldrDistribution}}
}
\author{
Antoine Cabon, WSL

Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{hydrology_soilEvaporation}
\alias{hydrology_soilEvaporation}
\alias{hydrology_herbaceousTranspiration}
\alias{hydrology_soilEvaporationAmount}
\title{Bare soil evaporation and herbaceous transpiration}
\usage{
hydrology_soilEvaporation(
  soil,
  snowpack,
  soilFunctions,
  pet,
  LgroundSWR,
  modifySoil = TRUE
)

hydrology_herbaceousTranspiration(
  pet,
  LherbSWR,
  herbLAI,
  soil,
  soilFunctions,
  modifySoil = TRUE
)

hydrology_soilEvaporationAmount(DEF, PETs, Gsoil)
}
\arguments{
\item{soil}{An object of class \code{\link{soil}}.}

\item{snowpack}{The amount of snow (in water equivalents, mm) in the snow pack.}

\item{soilFunctions}{Soil water retention curve and conductivity functions, either 'SX' (for Saxton) or 'VG' (for Van Genuchten).}

\item{pet}{Potential evapotranspiration for a given day (mm)}

\item{LgroundSWR}{Percentage of short-wave radiation (SWR) reaching the ground.}

\item{modifySoil}{Boolean flag to indicate that the input \code{soil} object should be modified during the simulation.}

\item{LherbSWR}{Percentage of short-wave radiation (SWR) reaching the herbaceous layer.}

\item{herbLAI}{Leaf area index of the herbaceous layer.}

\item{DEF}{Water deficit in the (topsoil) layer.}

\item{PETs}{Potential evapotranspiration at the soil surface.}

\item{Gsoil}{Gamma parameter (maximum daily evaporation).}
}
\value{
Function \code{hydrology_soilEvaporationAmount} returns the amount of water evaporated from the soil.

Function \code{hydrology_soilEvaporation} returns a vector of water evaporated from each soil layer.
}
\description{
Functions:
\itemize{
\item{Function \code{hydrology_soilEvaporationAmount} calculates the amount of evaporation from bare soil, following Ritchie (1972).}
\item{Function \code{hydrology_soilEvaporation} calculates the amount of evaporation from bare soil and distributes it among soil layers.}
\item{Function \code{hydrology_herbaceousTranspiration} calculates the amount of transpiration due to herbaceous plants.}
}
}
\references{
Ritchie (1972). Model for predicting evaporation from a row crop with incomplete cover. - Water resources research.
}
\seealso{
\code{\link{spwb}}, \code{\link{hydrology_waterInputs}}, \code{\link{hydrology_infiltration}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/defaultControl.R
\name{defaultControl}
\alias{defaultControl}
\title{Control parameters for simulation models}
\usage{
defaultControl(
  transpirationMode = "Granier",
  soilDomains = "buckets",
  rhizosphereOverlap = "partial"
)
}
\arguments{
\item{transpirationMode}{String containing transpiration model (either 'Granier', 'Sperry' or 'Sureau'). See \code{\link{spwbInput}}.}

\item{soilDomains}{String containing soil hydrology model (either 'buckets', 'single', 'dual' or 'none'). Option 'none' is meant to be used when flows in the bulk soil are dealt with externally. For the remaining options, see \code{\link{hydrology_soilWaterBalance}}.}

\item{rhizosphereOverlap}{String indicating the assumption with respect to rhizosphere overlap:
\itemize{
\item{\code{total}: All plants extract water from the same pools.}
\item{\code{partial}: Plants partially share water pools, depending on soil moisture.}
\item{\code{none}: Plants extract water from totally-independent water pools.}
}}
}
\value{
A list, with the following options (default values in brackets):
\itemize{
\bold{General}:
\itemize{
\item{\code{verbose [= TRUE]}: Boolean flag to indicate console output during calculations. In function \code{fordyn} \code{verbose} is always set to FALSE.}
\item{\code{fillMissingRootParams [= TRUE]}: Boolean flag to indicate that initializing functions should provide estimates for Z50 and Z95 if these are missing in the forest data. Note that if \code{fillMissingRootParams} is set to \code{FALSE} then simulations may fail if the user does not provide values for Z50 and Z95 in tree or shrub data.}
\item{\code{fillMissingSpParams [= TRUE]}: Boolean flag to indicate that initializing functions should provide estimates for functional parameters if these are missing in the species parameter table \code{\link{SpParams}}. Note that if \code{fillMissingSpParams} is set to \code{FALSE} then simulations may fail if the user does not provide values for required parameters.}
\item{\code{fillMissingWithGenusParams [=TRUE]}: Boolean flag to indicate that initializing functions should provide estimates from genus value, if species-level values are missing in the species parameter table \code{\link{SpParams}} but genus-level ones are not.}
\item{\code{standResults [= TRUE]}: Boolean flag to keep stand-level results (in a data frame called 'Stand').}
\item{\code{soilResults [= TRUE]}: Boolean flag to keep soil-level results (in a list called 'Soil').}
\item{\code{soilPoolResults [= FALSE]}: Boolean flag to keep soil pool-level results (in a list called 'SoilPools'), if \code{rhizosphereOverlap!="total"}.}
\item{\code{snowResults [= TRUE]}: Boolean flag to keep snow results (in a data frame called 'Snow').}
\item{\code{plantResults [= TRUE]}: Boolean flag to keep plant-level water/energy/photosynthesis results (in a list called 'Plants').}
\item{\code{labileCarbonBalanceResults [= TRUE]}: Boolean flag to keep plant-level labile carbon balance results (in a list called 'LabileCarbonBalance').}
\item{\code{plantStructureResults [= TRUE]}: Boolean flag to keep plant-level structure results (in a list called 'PlantStructure').}
\item{\code{growthMortalityResults [= TRUE]}: Boolean flag to keep plant-level growth and mortality results (in a list called 'GrowthMortality').}
\item{\code{decompositionPoolResults [= TRUE]}: Boolean flag to keep decomposition pool results (in a data frame called 'DecompositionPools').}
\item{\code{leafResults [= TRUE]}: Boolean flag to keep leaf-level results (in elements called 'SunlitLeaves' and 'ShadeLeaves').}
\item{\code{temperatureResults [= TRUE]}: Boolean flag to keep temperature results (in elements called 'Temperature' and 'TemperatureLayers').}
\item{\code{subdailyResults [= FALSE]}: Boolean flag to force subdaily results to be stored (as a list called 'subdaily' of \code{\link{spwb_day}} objects, one by simulated date) in calls to \code{\link{spwb}}. In function \code{fordyn} \code{subdailyResults} is always set to FALSE.}
\item{\code{fireHazardResults [= FALSE]}: Boolean flag to force calculation of daily fire hazard.}
\item{\code{fireHazardStandardWind [= NA]}: Wind speed (in m/s) for fire-hazard estimation. If missing, actual wind-speed is used.}
\item{\code{fireHazardStandardDFMC [= NA]}: Dead fuel moisture content for fire-hazard estimation. If missing, estimation from current weather is used.}
}
\bold{Water balance} (functions \code{\link{spwb}}, \code{\link{pwb}} or \code{\link{spwb_day}}):
\itemize{
\item{\code{transpirationMode [= "Granier"]}: Transpiration model (either 'Granier', 'Sperry' or 'Sureau'). See \code{\link{spwbInput}}.}
\item{\code{soilFunctions [= "VG"]}: Soil water retention curve and conductivity functions, either 'SX' (for Saxton) or 'VG' (for Van Genuchten).
If \code{transpirationMode} is 'Sperry' or 'Sureau' then soilFunctions is forced to \code{'VG'}.
Only simulations with 'Granier' are allowed to use Saxton functions.}
\item{\code{truncateRootDistribution [= FALSE]}: Boolean flag to indicate that fine root distribution is to be truncated (i.e. Z100 is estimated from Z95 when not provided).}
\item{\code{VG_PTF}: String indicating the pedotransfer functions for van Genuchten parameters (either 'Toth' or 'Carsel').}
\item{\code{ndailysteps [= 24]}: Number of steps into which each day is divided for determination of soil water balance, stomatal conductance, transpiration and photosynthesis (24 equals 1-hour intervals).}
\item{\code{max_nsubsteps_soil [= 300]}: Maximum number of substeps for soil water balance solving.}
\item{\code{defaultWindSpeed [= 2.5]}: Default wind speed value (in m/s) to be used when missing from data. }
\item{\code{defaultCO2 [= 386]}: Default atmospheric (abovecanopy) CO2 concentration (in micromol·mol-1 = ppm). This value will be used whenever CO2 concentration is not specified in the weather input. }
\item{\code{defaultRainfallIntensityPerMonth [= c(1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 5.6, 5.6, 5.6, 5.6, 5.6, 1.5)]}: A vector of twelve values indicating the rainfall intensity (mm/h) per month.
By default synoptic storms (1.5 mm/h) are assumed between December and June, and convective storms (5.6 mm/h) are assumed between July and November.}
\item{\code{leafPhenology [= TRUE]}: Boolean flag to indicate the simulation of leaf phenology for winter-deciduous species.}
\item{\code{bareSoilEvaporation [= TRUE]}: Boolean flag to indicate the simulation of evaporation from bare soil.}
\item{\code{unlimitedSoilWater [= FALSE]}: Boolean flag to indicate the simulation of plant transpiration assuming that soil water is always at field capacity.}
\item{\code{unfoldingDD [= 300]}: Degree-days for complete leaf unfolding after budburst has occurred.}
\item{\code{interceptionMode [= "Gash1995"]}: Infiltration model, either "Gash1995" or "Liu2001".}
\item{\code{infiltrationMode [= "GreenAmpt1911"]}: Infiltration model, either "GreenAmpt1911" or "Boughton1989".}
\item{\code{infiltrationCorrection [= 5.0]}: Factor to correct infiltration amount in the GreenAmpt1911 model in single-domain simulations.}
\item{\code{soilDomains [= "buckets"]}: Either 'buckets' (for multi-bucket model), 'single' (for single-domain Richards model) or 'dual' (for dual-permeability model). See \code{\link{hydrology_soilWaterBalance}}.}
\item{\code{rhizosphereOverlap [= "partial"]}: A string indicating the degree of rhizosphere spatial overlap between plant cohorts:
\itemize{
\item{"none" - no overlap (independent water pools).}
\item{"partial" - plants partially share water pools, depending on soil moisture.}
\item{"total" - total overlap (plants extract from common soil pools).}
}
}
\item{\code{fullRhizosphereOverlapConductivity [= 0.01]}: The minimum soil hydraulic conductivity (in cm/day) allowing a full connectivity of water pools, when \code{rhizosphereOverlap = "partial"}.}
\item{\code{verticalLayerSize [= 100]}: Size of vertical layers (in cm) for the calculation of light extinction (and photosynthesis).}
\item{\code{windMeasurementHeight [= 200]}: Height (in cm) over the canopy corresponding to wind measurements.}
\item{\code{segmentedXylemVulnerability [= TRUE/FALSE]}: If \code{FALSE} leaf and root vulnerability curves will be equal to those of stem. By default, \code{segmentedXylemVulnerability = TRUE} for \code{transpirationMode = "Sperry"} and \code{segmentedXylemVulnerability = FALSE} for \code{transpirationMode = "Sureau"}.}
\item{\code{leafCavitationEffects, stemCavitationEffects [= FALSE/TRUE]}: A flag indicating whether cavitation effects on conductance of leaves and stem are applied. Only relevant for \code{transpirationMode = "Sperry"}.}
\item{\code{leafCavitationRecovery, stemCavitationRecovery [= "rate"]}: A string indicating how recovery of previous cavitation leaf/stem xylem is done (only relevant for functions \code{\link{spwb}} and \code{\link{spwb_day}}):
\itemize{
\item{"none" - no recovery.}
\item{"annual" - every first day of the year.}
\item{"rate" - following a rate of new leaf or sapwood formation.}
\item{"total" - instantaneous complete recovery.}
}
}
\item{\code{cavitationRecoveryMaximumRate [= 0.05]}: Maximum rate of daily refilling of embolized conduits as sapwood area per leaf area (in cm2·m-2·day-1).}
\item{\code{cavitationInducedDefoliation [= TRUE]}: Whether leaf hydraulic impairment induces defoliation (88 \% PLC will correspond to 50 \% defoliation).}
\item{\code{lfmcComponent [= "fine"]}: Plant component used to estimate LFMC, either "leaf" or "fine" (for fine fuel).}
}
\bold{Water balance} (functions \code{\link{spwb}}, \code{\link{pwb}} or \code{\link{spwb_day}} when \code{traspirationMode = "Granier"} only):
\itemize{
\item{\code{hydraulicRedistributionFraction [= 0.1]}: Fraction of plant transpiration corresponding to hydraulic redistribution.}
}
\bold{Water balance} (functions \code{\link{spwb}}, \code{\link{pwb}} or \code{\link{spwb_day}} when \code{traspirationMode = "Sperry"} or \code{traspirationMode = "Sureau"}):
\itemize{
\item{\code{nsubsteps_canopy [= 3600]}: Number of substeps into which each step is divided for multi-layer canopy energy balance solving.}
\item{\code{multiLayerBalance [= FALSE]}: Flag to indicate multiple canopy energy balance. If \code{FALSE}, canopy is considered a single layer for energy balance.}
\item{\code{sapFluidityVariation [= TRUE]}: Flag to indicate that temperature affects sap fluidity (and indirectly plant conductance).}
\item{\code{TPhase_gmin [= 37.5]}: Temperature for transition phase of gmin.}
\item{\code{Q10_1_gmin [= 1.2]}: Temperature dependance of gmin when T less than or equal to TPhase.}
\item{\code{Q10_2_gmin [= 4.8]}: Temperature dependance of gmin when T greater than TPhase.}
\item{\code{taper [= TRUE]}: Whether taper of xylem conduits is accounted for when calculating aboveground stem conductance from xylem conductivity.}
\item{\code{thermalCapacityLAI [= 1000000]}: Thermal canopy capacitance per LAI unit.}
\item{\code{rootRadialConductance [= 4]}: Radial conductance in roots (mmol·s-1·m-2·MPa-1).}
\item{\code{averageFracRhizosphereResistance [= 0.15]}: Fraction to total continuum (leaf+stem+root+rhizosphere) resistance that corresponds to rhizosphere (averaged across soil water potential values).}
\item{\code{boundaryLayerSize [= 2000]}: Size of the boundary layer (in cm) over the canopy (relevant for multi-layer canopy energy balance).}
}

\bold{Water balance} (functions \code{\link{spwb}}, \code{\link{pwb}} or \code{\link{spwb_day}} when \code{traspirationMode = "Sperry"} only):
\itemize{
\item{\code{numericParams}: A list with the following elements:
\itemize{
\item{\code{maxNsteps [= 400]}: Maximum number of steps in supply function.}
\item{\code{ntrial [= 200]}: Number of iteration trials when finding root of equation system.}
\item{\code{psiTol [= 0.0001]}: Tolerance value for water potential.}
\item{\code{ETol [= 0.0001]}: Tolerance value for flow.}
}
}
}

\bold{Water balance} (functions \code{\link{spwb}}, \code{\link{pwb}} or \code{\link{spwb_day}} when \code{traspirationMode = "Sureau"} only):
\itemize{
\item{\code{plantCapacitance [= TRUE]}: Whether the effect of (symplasmic) plant water compartments is considered in simulations.}
\item{\code{cavitationFlux [= TRUE]}: Whether the effect of water flux generated by cavitation of apoplasmic tissues is considered in simulations.}
\item{\code{leafCuticularTranspiration [= TRUE]}: Whether the effect of leaf cuticular transpiration is considered in simulations.}
\item{\code{stemCuticularTranspiration [= FALSE]}: Whether the effect of stem cuticular transpiration is considered in simulations.}
\item{\code{C_SApoInit [= 2.0e-5]}: Maximum capacitance of the stem apoplasm (mmol·m-2).}
\item{\code{C_LApoInit [= 1.0e-5]}: Maximum capacitance of the leaf apoplasm (mmol·m-2).}
\item{\code{k_SSym [= 0.26]}: Conductance from stem apoplasm to stem symplasm (mmol·s-1·m-2·MPa-1).}
\item{\code{fractionLeafSymplasm [= 0.5]}: Fraction of the leaf resistance from leaf apoplasm to leaf symplasm ([0-1]).}
\item{\code{gs_NightFrac [= 0.05]}: Stomatal conductance at night as fraction of maximum stomatal conductance ([0-1]).}
\item{\code{stomatalSubmodel [= "Baldocchi"]}: Stomatal regulation sub-model, either "Jarvis" or "Baldocchi".}
\item{\code{JarvisPAR [= 0.003]}: Parameter regulating the response of stomatal conductance to light (PAR) in the Jarvis model.}
\item{\code{fTRBToLeaf [= 0.8]}: Fraction of surface of bark exposed to air per leaf area.}
}

\bold{Forest growth} (functions \code{\link{growth}} or \code{\link{growth_day}}):
\itemize{
\item{\code{subdailyCarbonBalance [= FALSE]}: Boolean flag to indicate that labile carbon balance should be conducted at sub-daily steps (applies only to transpirationMode = "Sperry").}
\item{\code{allowDessication [= TRUE]}: Boolean flag to indicate that mortality by dessication is allowed.}
\item{\code{allowStarvation [= TRUE]}: Boolean flag to indicate that mortality by starvation is allowed.}
\item{\code{sinkLimitation [= TRUE]}: Boolean flag to indicate that temperature and turgor limitations to growth are applied.}
\item{\code{shrubDynamics [= TRUE]}: Boolean flag to allow the application of demographic processes to shrubs.}
\item{\code{herbDynamics [= TRUE]}: Boolean flag to allow dynamic herb leaf area as a function of shading due to leaf area of woody cohorts.}
\item{\code{allocationStrategy [= "Al2As"]}: Strategy for allocation (either "Plant_kmax", for constant maximum plant conductance, or "Al2As" for constant Huber value).}
\item{\code{phloemConductanceFactor [= 0.2])}: Factor to transform stem xylem conductance to stem phloem conductance (only for transpirationMode = "Sperry").}
\item{\code{nonSugarConcentration [= 0.25]}: Non-sugar (inorganic) solute concentration  (mol·l-1) in cells.}
\item{\code{equilibriumOsmoticConcentration [=  c(leaf = 0.8, sapwood = 0.6)]}: Equilibrium osmotic concentrations (mol·l-1) for leaf and sapwood cells. The difference between leaf and sapwood values helps maintaining phloem transport. The equilibrium sugar concentration is \code{equilibriumOsmoticConcentration - nonSugarConcentration} defaults to \code{[= c(leaf = 0.55, sapwood = 0.35)]}. }
\item{\code{minimumRelativeStarchForGrowth [= 0.50]}: Default minimum concentration of storage carbon (starch), relative to the maximum storage capacity, for sapwood growth to occur, when not specified via SpParams (\code{RSSG}). }
\item{\code{constructionCosts [= c(leaf = 1.5, sapwood = 1.47, fineroot = 1.30)]}: Default construction costs, including respiration and structural carbon, per dry weight of new tissue (g gluc · g dry -1) when not specified via SpParams (\code{CCleaf}, \code{CCsapwood} and \code{CCfineroot}).}
\item{\code{senescenceRates [= c(sapwood = 0.0001261398, fineroot = 0.001897231)]}: Default senescence rates (day-1) for sapwood and fineroots when not specified via SpParams (\code{SRsapwood} and \code{SRfineroot}). Defaults are equivalent to 9\%, 5\% and 50\% annual turnover for gymnosperm sapwood, angiosperm sapwood and fine roots, respectively.}
\item{\code{maximumRelativeGrowthRates [=   c(leaf = 0.09, cambium = 0.005, sapwood = 0.002, fineroot = 0.1)]}: Default maximum relative growth rates for leaves (m2 leaf ·cm-2 sapwood· day-1), tree sapwood (cm2 sapwood· cm-1 cambium · day-1), shrub sapwood (cm2 sapwood ·cm-2 sapwood· day-1) and fine roots (g dw · g dw -1 · day -1) when not specified via SpParams (\code{RGRleafmax}, \code{RGRcambiummax} , \code{RGRsapwoodmax} and \code{RGRfinerootmax}, respectively).}
\item{\code{mortalityMode [= "density/deterministic"]}: String describing how mortality is applied. Current accepted values are combinations of "cohort" vs "density" (for whole-cohort mortality vs reduction of stem density) and "deterministic" vs. "stochastic".}
\item{\code{mortalityBaselineRate [= 0.0015]}: Default deterministic proportion or probability specifying the baseline reduction of cohort's density occurring in a year (for \code{mortalityMode = "density/deterministic" or "density/stochastic").}}
\item{\code{mortalityRelativeSugarThreshold [= 0.4]}: Threshold of stem sugar concentration relative to the equilibrium sugar concentration, resulting in an increased starvation mortality rate/probability whenever levels are below.}
\item{\code{mortalityRWCThreshold [= 0.4]}: Threshold of stem relative water content resulting in increased mortality rate/probability whenever levels are below.}
\item{\code{recrTreeDBH [= 1]}: Default DBH (cm) for recruited trees  (when species parameter \code{RecrTreeDBH} is missing).}
\item{\code{recrTreeDensity [= 3000]}: Default density (ind·ha-1) for recruited trees  (when species parameter \code{RecrTreeDensity} is missing).}
\item{\code{ingrowthTreeDBH [= 7.5]}: Default DBH (cm) for ingrowth trees  (when species parameter \code{IngrowthTreeDBH} is missing).}
\item{\code{ingrowthTreeDensity [= 127]}: Default density (ind·ha-1) for ingrowth trees  (when species parameter \code{IngrowthTreeDensity} is missing).}
\item{\code{decompositionAnnualBaseRates}: Vector of base annual decomposition rates (in yr-1) for different pools.}
\item{\code{decompositionAnnualTurnoverRate [= 0.1]}: Annual turnover time for biome in the CENTURY model.}
}
\bold{Forest dynamics} (function \code{\link{fordyn}}):
\itemize{
\item{\code{allowSeedBankDynamics [= TRUE]}: Boolean flag to indicate that seed production and seed bank dynamics is simulated.}
\item{\code{allowRecruitment [= TRUE]}: Boolean flag to indicate that recruitment from seeds is allowed.}
\item{\code{allowResprouting [= TRUE]}: Boolean flag to indicate that resprouting is allowed.}
\item{\code{recruitmentMode [= "annual/stochastic"]}: String describing how recruitment from seeds is applied. Current accepted values are "annual/deterministic", "annual/stochastic", "daily/deterministic" or "daily/stochastic".}
\item{\code{removeEmptyCohorts [= TRUE]}: Boolean flag to indicate the removal of cohorts whose density is too low.}
\item{\code{minimumTreeCohortDensity [= 1]}: Threshold of tree density resulting in cohort removal.}
\item{\code{minimumShrubCohortCover [= 0.01]}: Threshold of shrub cover resulting in cohort removal.}
\item{\code{dynamicallyMergeCohorts [= TRUE]}: Boolean flag to indicate that cohorts should be merged when possible. This option speeds up calculations but results in a loss of cohort identity and reinitialization of many state variables.}
\item{\code{keepCohortsWithID [= TRUE]}: Boolean flag to indicate that cohorts having a non-missing value in a column \code{"ID"} (if present) should not be merged or removed.}
\item{\code{seedRain [= NULL]}: Vector of species names whose seed rain is to be added to seed bank, regardless of local seed production.}
\item{\code{seedProductionTreeHeight [= 300]}: Default minimum tree height for producing seeds (when species parameter \code{SeedProductionHeight} is missing).}
\item{\code{seedProductionShrubHeight [= 30]}: Default minimum shrub height for producing seeds (when species parameter \code{SeedProductionHeight} is missing).}
\item{\code{probRecr [= 0.05]}: Default annual probability of seed-recruitment (when species parameter \code{ProbRecr} is missing).}
\item{\code{minTempRecr [= 0]}: Default threshold of minimum average temperature of the coldest month necessary for recruiting from seeds (when species parameter \code{MinTempRecr} is missing).}
\item{\code{minMoistureRecr [= 0.3]}: Default threshold of minimum moisture index (annual precipitation over annual ETP) necessary for seed-recruiting (when species parameter \code{MinMoistureRecr} is missing).}
\item{\code{minFPARRecr [= 10]}: Default threshold of minimum fraction of PAR (in \%)  reaching the ground necessary for recruiting (when species parameter \code{MinFPARRecr} is missing).}
\item{\code{recrAge [= 5]}: Default recruitment age (in yrs).}
\item{\code{recrTreeHeight [= 620]}: Default height (cm) for recruited trees  (when species parameter \code{RecrTreeHeight} is missing).}
\item{\code{recrShrubCover [= 1]}: Default cover (\%) for shrubs recruited from seed  (when species parameter \code{RecrShrubCover} is missing).}
\item{\code{recrShrubHeight [= 25]}: Default height (cm) for recruited shrubs  (when species parameter \code{RecrShrubHeight} is missing).}
}
}
}
\description{
Creates a list control parameters default values for simulations
}
\details{
The function returns a list with default parameters.
Users can change those defaults that need to be set to other values and use the list as input for model functions.
The relevant parameters are different for each model function.
}
\seealso{
\code{\link{spwbInput}}, \code{\link{spwb}}, \code{\link{growth}}, \code{\link{fordyn}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{hydraulics_defoliation}
\alias{hydraulics_defoliation}
\alias{hydraulics_proportionDefoliationSigmoid}
\alias{hydraulics_proportionDefoliationWeibull}
\title{Hydraulic-related defoliation}
\usage{
hydraulics_proportionDefoliationSigmoid(
  psiLeaf,
  P50,
  slope,
  PLC_crit = 0.88,
  P50_cv = 10
)

hydraulics_proportionDefoliationWeibull(
  psiLeaf,
  c,
  d,
  PLC_crit = 0.88,
  P50_cv = 10
)
}
\arguments{
\item{psiLeaf}{Leaf water potential (in MPa).}

\item{P50, slope}{Parameters of the Sigmoid function.}

\item{PLC_crit}{Critical leaf PLC corresponding to defoliation}

\item{P50_cv}{Coefficient of variation (in percent) of leaf P50, to describe the
variability in hydraulic vulnerability across crown leaves.}

\item{c, d}{Parameters of the Weibull function.}
}
\value{
The proportion of crown defoliation.
}
\description{
Functions to calculate the proportion of crown defoliation due to hydraulic disconnection.
}
\details{
The functions assume that crowns are made of a population of leaves whose
hydraulic vulnerability (i.e. the water potential corresponding to 50\% loss of conductance)
follows a Gaussian distribution centered on the input P50 and with a known coefficient of variation (\code{P50_cv}).
The slope parameter (or the c exponent in the case of a Weibull function) is considered constant.
Leaves are hydraulically disconnected, and shedded, when their embolism rate exceeds a critical value (\code{PLC_crit}).
}
\seealso{
\code{\link{hydraulics_conductancefunctions}}
}
\author{
Hervé Cochard, INRAE

Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/defaultSoilParams.R
\name{defaultSoilParams}
\alias{defaultSoilParams}
\title{Default soil parameters}
\usage{
defaultSoilParams(n = 4)
}
\arguments{
\item{n}{An integer with the number of soil layers (between two and five).}
}
\value{
A data frame with layers in rows and the following columns (and default values):
\itemize{
\item{\code{widths (= c(300,700,1000,2000)}: Width of soil layers (in mm).}
\item{\code{clay (= 25)}: Clay percentage for each layer (in \%).}
\item{\code{sand (= 25)}: Sand percentage for each layer (in \%).}
\item{\code{om (= NA)}: Organic matter percentage for each layer (in \%) (optional).}0
\item{\code{nitrogen (= NA)}: Sum of total nitrogen (ammonia, organic and reduced nitrogen) for each layer (in g/kg) (optional).}
\item{\code{ph (=NA)}: pH in water (0-14) (optional).}
\item{\code{bd (= 1.5)}: Bulk density for each layer (in g/cm3).}
\item{\code{rfc (= c(20,40,60,85))}: Percentage of rock fragment content (volume basis) for each layer.}
}
}
\description{
Creates a data frame with default soil physical and chemical description for model functions
}
\details{
The function returns a data frame with default physical and chemical soil description, with soil layers in rows.
Users can change those that need to be set to other values and use the list as input for function \code{\link{soil}}.
}
\note{
While this function is limited to five soil layers, user defined data frames can discretize soils using an unlimited number of soil layers.
}
\examples{
defaultSoilParams(4)

}
\seealso{
\code{\link{soil}}, \code{\link{soil_redefineLayers}},  \code{\link{defaultControl}}, \code{\link{SpParamsMED}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{light_advanced}
\alias{light_advanced}
\alias{light_leafAngleBetaParameters}
\alias{light_layerDirectIrradianceFraction}
\alias{light_layerDiffuseIrradianceFraction}
\alias{light_cohortSunlitShadeAbsorbedRadiation}
\alias{light_layerSunlitFraction}
\alias{light_instantaneousLightExtinctionAbsortion}
\alias{light_longwaveRadiationSHAW}
\alias{light_leafAngleCDF}
\alias{light_directionalExtinctionCoefficient}
\title{Advanced radiation transfer functions}
\usage{
light_leafAngleBetaParameters(leafAngle, leafAngleSD)

light_layerDirectIrradianceFraction(
  LAIme,
  LAImd,
  LAImx,
  kb,
  ClumpingIndex,
  alpha,
  gamma,
  trunkExtinctionFraction = 0.1
)

light_layerDiffuseIrradianceFraction(
  LAIme,
  LAImd,
  LAImx,
  K,
  ClumpingIndex,
  ZF,
  alpha,
  gamma,
  trunkExtinctionFraction = 0.1
)

light_cohortSunlitShadeAbsorbedRadiation(
  Ib0,
  Id0,
  LAIme,
  LAImd,
  LAImx,
  kb,
  K,
  ClumpingIndex,
  ZF,
  alpha,
  gamma,
  trunkExtinctionFraction = 0.1
)

light_layerSunlitFraction(LAIme, LAImd, kb, ClumpingIndex)

light_instantaneousLightExtinctionAbsortion(
  LAIme,
  LAImd,
  LAImx,
  p,
  q,
  ClumpingIndex,
  alphaSWR,
  gammaSWR,
  ddd,
  ntimesteps = 24L,
  trunkExtinctionFraction = 0.1
)

light_longwaveRadiationSHAW(
  LAIme,
  LAImd,
  LAImx,
  LWRatm,
  Tsoil,
  Tair,
  trunkExtinctionFraction = 0.1
)

light_leafAngleCDF(leafAngle, p, q)

light_directionalExtinctionCoefficient(p, q, solarElevation)
}
\arguments{
\item{leafAngle}{Average leaf inclination angle (in radians).}

\item{leafAngleSD}{Standard deviation of leaf inclination angle (in radians).}

\item{LAIme}{A numeric matrix of live expanded LAI values per vegetation layer (row) and cohort (column).}

\item{LAImd}{A numeric matrix of dead LAI values per vegetation layer (row) and cohort (column).}

\item{LAImx}{A numeric matrix of maximum LAI values per vegetation layer (row) and cohort (column).}

\item{kb}{A vector of direct light extinction coefficients.}

\item{ClumpingIndex}{The extent to which foliage has a nonrandom spatial distribution.}

\item{alpha}{A vector of leaf absorbance by species.}

\item{gamma}{A vector of leaf reflectance values.}

\item{trunkExtinctionFraction}{Fraction of extinction due to trunks (for winter deciduous forests).}

\item{K}{A vector of light extinction coefficients.}

\item{ZF}{Fraction of sky angles.}

\item{Ib0}{Above-canopy direct incident radiation.}

\item{Id0}{Above-canopy diffuse incident radiation.}

\item{p, q}{Parameters of the beta distribution for leaf angles}

\item{alphaSWR}{A vecfor of hort-wave absorbance coefficients for each cohort.}

\item{gammaSWR}{A vector of short-wave reflectance coefficients (albedo) for each cohort.}

\item{ddd}{A dataframe with direct and diffuse radiation for different subdaily time steps (see function \code{radiation_directDiffuseDay} in package meteoland).}

\item{ntimesteps}{Number of subdaily time steps.}

\item{LWRatm}{Atmospheric downward long-wave radiation (W/m2).}

\item{Tsoil}{Soil temperature (Celsius).}

\item{Tair}{Canopy layer air temperature vector (Celsius).}

\item{solarElevation}{Solar elevation (in radians).}
}
\value{
Functions \code{light_layerDirectIrradianceFraction}, \code{light_layerDiffuseIrradianceFraction}
and \code{light_layerSunlitFraction} return a numeric vector of length equal to the number of vegetation layers.

Function \code{light_cohortSunlitShadeAbsorbedRadiation} returns a list with
two elements (matrices): \code{I_sunlit} and \code{I_shade}.
}
\description{
Functions \code{light_layerDirectIrradianceFraction} and \code{light_layerDiffuseIrradianceFraction} calculate
the fraction of above-canopy direct and diffuse radiation reaching each vegetation layer.
Function \code{light_layerSunlitFraction} calculates the proportion of sunlit leaves in each vegetation layer.
Function \code{light_cohortSunlitShadeAbsorbedRadiation} calculates the amount of radiation absorbed
by cohort and vegetation layers, while differentiating between sunlit and shade leaves.
}
\details{
Functions for short-wave radiation are adapted from Anten & Bastiaans (2016),
whereas long-wave radiation balance follows Flerchinger et al. (2009).
Vegetation layers are assumed to be ordered from bottom to top.
}
\examples{
solarElevation <- 0.67 # in radians
SWR_direct <- 1100
SWR_diffuse <- 300
PAR_direct <- 550
PAR_diffuse <- 150

LAI <- 2
nlayer <- 10
LAIlayerlive <- matrix(rep(LAI/nlayer,nlayer),nlayer,1)
LAIlayerdead <- matrix(0,nlayer,1)
meanLeafAngle <- 60 # in degrees
sdLeafAngle <- 20

beta <- light_leafAngleBetaParameters(meanLeafAngle*(pi/180), sdLeafAngle*(pi/180))

## Extinction coefficients
kb <- light_directionalExtinctionCoefficient(beta["p"], beta["q"], solarElevation)
kd_PAR <- 0.5
kd_SWR <- kd_PAR/1.35
}
\references{
Anten, N.P.R., Bastiaans, L., 2016. The use of canopy models to analyze light competition among plants, in: Hikosaka, K., Niinemets, U., Anten, N.P.R. (Eds.), Canopy Photosynthesis: From Basics to Application. Springer, pp. 379–398.

Flerchinger, G. N., Xiao, W., Sauer, T. J., Yu, Q. 2009. Simulation of within-canopy radiation exchange. NJAS - Wageningen Journal of Life Sciences 57 (1): 5–15. https://doi.org/10.1016/j.njas.2009.07.004.
}
\seealso{
\code{\link{spwb}}, \code{\link{light_basic}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fordyn.R
\name{fordyn}
\alias{fordyn}
\title{Forest dynamics}
\usage{
fordyn(
  forest,
  soil,
  SpParams,
  meteo,
  control,
  latitude,
  elevation = NA,
  slope = NA,
  aspect = NA,
  CO2ByYear = numeric(0),
  management_function = NULL,
  management_args = NULL
)
}
\arguments{
\item{forest}{An object of class \code{\link{forest}}. Alternatively, the output of a previous run (an object of class \code{fordyn}), if continuing a previous simulation.}

\item{soil}{An object of class \code{\link{data.frame}} or \code{\link{soil}}.}

\item{SpParams}{A data frame with species parameters (see \code{\link{SpParamsMED}} and \code{\link{SpParamsDefinition}}).}

\item{meteo}{A data frame with daily weather data series (see \code{\link{spwb}}).}

\item{control}{A list with default control parameters (see \code{\link{defaultControl}}).}

\item{latitude}{Latitude (in degrees).}

\item{elevation, slope, aspect}{Elevation above sea level (in m), slope (in degrees) and aspect (in degrees from North).}

\item{CO2ByYear}{A named numeric vector with years as names and atmospheric CO2 concentration (in ppm) as values. Used to specify annual changes in CO2 concentration along the simulation (as an alternative to specifying daily values in \code{meteo}).}

\item{management_function}{A function that implements forest management actions (see details).}

\item{management_args}{A list of additional arguments to be passed to the \code{management_function}.}
}
\value{
A list of class \code{fordyn} with the following elements:
\itemize{
\item{\code{"StandSummary"}: A data frame with stand-level summaries (tree basal area, tree density, shrub cover, etc.) at the beginning of the simulation and after each simulated year.}
\item{\code{"SpeciesSummary"}: A data frame with species-level summaries (tree basal area, tree density, shrub cover, etc.) at the beginning of the simulation and after each simulated year.}
\item{\code{"CohortSummary"}: A data frame with cohort-level summaries (tree basal area, tree density, shrub cover, etc.) at the beginning of the simulation and after each simulated year.}
\item{\code{"TreeTable"}: A data frame with tree-cohort data (species, density, diameter, height, etc.) at the beginning of the simulation (if any) and after each simulated year.}
\item{\code{"DeadTreeTable"}: A data frame with dead tree-cohort data (species, density, diameter, height, etc.) at the beginning of the simulation and after each simulated year.}
\item{\code{"CutTreeTable"}: A data frame with cut tree data (species, density, diameter, height, etc.) after each simulated year.}
\item{\code{"ShrubTable"}: A data frame with shrub-cohort data (species, density, cover, height, etc.) at the beginning of the simulation and after each simulated year.}
\item{\code{"DeadShrubTable"}: A data frame with dead shrub-cohort data (species, density, cover, height, etc.) at the beginning of the simulation (if any) and after each simulated year.}
\item{\code{"CutShrubTable"}: A data frame with cut shrub data (species, density, cover, height, etc.) after each simulated year.}
\item{\code{"ForestStructures"}: A list with the \code{\link{forest}} object of the stand at the beginning of the simulation and after each simulated year.}
\item{\code{"GrowthResults"}: A list with the results of calling function \code{\link{growth}} for each simulated year.}
\item{\code{"ManagementArgs"}: A list of management arguments to be used in another call to \code{fordyn}.}
\item{\code{"NextInputObject"}: An object of class \code{growthInput} to be used in a subsequent simulation.}
\item{\code{"NextForestObject"}: An object of class \code{forest} to be used in a subsequent simulation.}
}
}
\description{
Function \code{fordyn} implements a forest dynamics model that simulates
growth, mortality, recruitment and (optionally) management actions in a given forest stand
during a period specified in the input climatic data.
}
\details{
Function \code{fordyn} simulates forest dynamics for annual time steps, building on other simulation functions. For each simulated year, the function performs the following steps:
\enumerate{
\item{Calls function \code{\link{growth}} to simulate daily water/carbon balance, growth and mortality processes and update the forest object.}
\item{If required, calls function \code{management_function}, using as parameters the forest object and \code{management_args}, which may result in a density reduction for existing plant cohorts and/or a set of new planted cohorts.}
\item{Simulate natural recruitment (for species present in the stand or given in a seed rain input).}
\item{Prepares the input of function \code{\link{growth}} for the next annual time step.}
\item{Store forest status, management arguments, and summaries.}
}

To enable forest management, the user needs to provide a function that implements it, which is passed to \code{fordyn} via its argument \code{management_function}. Such function should have  the following arguments:
\itemize{
\item{\code{"x"}: the \code{\link{forest}} object representing the stand to be managed.}
\item{\code{"args"}: a list of parameters regulating the behavior of the management function.}
\item{\code{"verbose"}: a logical flag to enable console output during the execution of the management function.}
}
and return a list with the following elements:
\itemize{
\item{\code{"action"}: A string identifying the action performed (e.g. "thinning").}
\item{\code{"N_tree_cut"}: A vector with the density of trees removed.}
\item{\code{"Cover_shrub_cut"}: A vector with the cover of shrubs removed.}
\item{\code{"planted_forest"}: An object of class \code{\link{forest}} with the new plant cohorts resulting from tree/shrub planting.}
\item{\code{"management_args"}: A list of management arguments to be used in the next call to the management function.}
}

An example of management function is provided in \code{\link{defaultManagementFunction}}.
}
\examples{
\donttest{
#Load example daily meteorological data
data(examplemeteo)
#Prepare a two-year meteorological data with half precipitation during 
#the second year
meteo2001 <- examplemeteo
meteo2002 <- examplemeteo
meteo2002$Precipitation <- meteo2002$Precipitation/2
meteo2002$dates <- seq(as.Date("2002-01-01"), 
                           as.Date("2002-12-31"), by="day")
meteo_01_02 <- rbind(meteo2001, meteo2002)

#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Initialize control parameters
control <- defaultControl("Granier")

#Define soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

#Call simulation function
fd<-fordyn(exampleforest, examplesoil, 
           SpParamsMED, meteo_01_02, control,
           latitude = 41.82592, elevation = 100)

#Stand-level summaries
fd$StandSummary

#Tree table by annual steps
fd$TreeTable

#Dead tree table by annual steps
fd$DeadTreeTable
}

}
\references{
De Cáceres M, Molowny-Horas R, Cabon A, Martínez-Vilalta J, Mencuccini M, García-Valdés R, Nadal-Sala D, Sabaté S,
Martin-StPaul N, Morin X, D'Adamo F, Batllori E, Améztegui A (2023) MEDFATE 2.9.3: A trait-enabled model to simulate
Mediterranean forest function and dynamics at regional scales.
Geoscientific Model Development 16: 3165-3201 (https://doi.org/10.5194/gmd-16-3165-2023).
}
\seealso{
\code{\link{growth}}, \code{\link{regeneration}}, \code{\link{plot.growth}}, \code{\link{defaultManagementFunction}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/defaultManagementFunction.R
\name{defaultManagementFunction}
\alias{defaultManagementFunction}
\alias{defaultManagementArguments}
\title{Default forest management actions}
\usage{
defaultManagementFunction(x, args, verbose = FALSE)

defaultManagementArguments()
}
\arguments{
\item{x}{An object of class \code{\link{forest}}}

\item{args}{A list of arguments regulating management actions, e.g. the list returned by \code{defaultManagementArguments}}

\item{verbose}{A logical flag enabling console printing}
}
\value{
Function \code{defaultManagementFunction} returns a list with the following items:
\itemize{
\item{\code{"action"}: A string identifying the action performed (e.g. "thinning").}
\item{\code{"N_tree_cut"}: A vector with the density of trees removed.}
\item{\code{"Cover_shrub_cut"}: A vector with the cover of shrubs removed.}
\item{\code{"planted_forest"}: An object of class \code{\link{forest}} with the new plant cohorts resulting from tree/shrub planting.}
\item{\code{"management_args"}: A list of management arguments to be used in the next call to the management function.}
}

Function \code{defaultManagementArguments} returns a list with default arguments:
\itemize{
\item{\code{"type"}: Management model, either 'regular' or 'irregular'.}
\item{\code{"targetTreeSpecies"}: Either \code{"all"} for unspecific cuttings or a numeric vector of target tree species to be selected for cutting operations.}
\item{\code{"thinning"}: Kind of thinning to be applied in irregular models or in regular models before the final cuts. Options are 'below', 'above', 'systematic', 'below-systematic', 'above-systematic' or a string with the proportion of cuts to be applied to different diameter sizes (see details).}
\item{\code{"thinningMetric"}: The stand-level metric used to decide whether thinning is applied, either 'BA' (basal area), 'N' (density) or 'HB' (Hart-Becking index).}
\item{\code{"thinningThreshold"}: The threshold value of the stand-level metric causing the thinning decision.}
\item{\code{"thinningPerc"}: Percentage of stand's basal area to be removed in thinning operations.}
\item{\code{"minThinningInterval"}: Minimum number of years between thinning operations.}
\item{\code{"yearsSinceThinning"}: State variable to count the years since the last thinning ocurred.}
\item{\code{"finalMeanDBH"}: Mean DBH threshold to start final cuts.}
\item{\code{"finalPerc"}: String with percentages of basal area to be removed in final cuts, separated by '-' (e.g. "40-60-100").}
\item{\code{"finalPreviousStage"}: Integer state variable to store the stage of final cuts ('0' before starting final cuts).}
\item{\code{"finalYearsBetweenCuts"}: Number of years separating final cuts.}
\item{\code{"finalYearsToCut"}: State variable to count the years to be passed before new final cut is applied.}
\item{\code{"plantingSpecies"}: Species code to be planted. If missing, planting does not occur and only natural regeneration is allowed.}
\item{\code{"plantingDBH"}: Initial DBH (cm) of planted species.}
\item{\code{"plantingHeight"}: Initial height (cm) of planted species.}
\item{\code{"plantingDensity"}: Initial density (ind./ha) of the planted species.}
\item{\code{"understoryMaximumCover"}: Percentage of overall shrub cover to be left after any silvicultural intervention.
If missing, shrub cover will not be left unmodified.}
}
}
\description{
Function \code{defaultManagementFunction} implements actions for 'regular' and 'irregular' management models of monospecific or mixed stands,
whereas function \code{defaultManagementArguments} returns a list with default values for the parameters regulating management.
Both functions are meant to be used in simulations with \code{\link{fordyn}}.
}
\details{
This function implements silvicultural actions following either 'regular' or 'irregular' management models.
Irregular models are implemented by executing thinning operations only, whereas regular models include both thinning and a set of final cuts.
Thinning occurs anytime a stand-level metric (e.g. basal area) crosses a given threshold, and different kinds of thinning operations are allowed.
Unrealistic high frequency thinning can be avoided by setting a minimum number of years to happen between thinning operations.
Final cuts start whenever mean DBH exceeds a given threshold, and may include different cuts separated a number of years.
The function can be applied to target management of specific taxa (instead of assuming a monospecific stand), but the thresholds that determine
thinning operations apply to stand-level metrics. Mean DBH will be calculated for the target species only.
Planting is only allowed under regular management models, and is applied after the last final cut.
Understory clearings are assumed to occur anytime there is an intervention on trees, an only a residual shrub cover is left.

\emph{Thinning types}:
\itemize{
\item{\code{above}: Extract largest trees (according to DBH) until thinning objective is met.}
\item{\code{below}: Extract smallest trees (according to DBH) until thinning objective is met.}
\item{\code{systematic}: Extract equally from all size classes until thinning objective is met.}
\item{\code{above-systematic}: Extract half the objective as systematic thinning and the other hald as above thinning.}
\item{\code{below-systematic}: Extract half the objective as systematic thinning and the other hald as below thinning.}
\item{\code{free string}: A string specifying the proportion of tree cuts from size classes, with size classes separated by "/" and each one composed of a number specifying the upper limit and a number indicating its proportion, separated by "-" (e.g. "10-50/40-30/60-20").}
}
}
\examples{
# Load example forest object
data(exampleforest)
  
# Define arguments
args = defaultManagementArguments()
  
# Call management function
f = defaultManagementFunction(exampleforest, args)
  
#list names
names(f)
  
# Action performed
f$action
  
# Number of trees cut for each cohort
f$N_tree_cut
  
# Percent cover of shrubs removed
f$Cover_shrub_cut
  
}
\seealso{
\code{\link{fordyn}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF

Aitor \enc{Améztegui}{Caceres}, UdL

Jose-Ramon Gonzalez Olabarria, CTFC
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{decomposition_pHEffect}
\alias{decomposition_pHEffect}
\alias{decomposition_annualLitterDecompositionRate}
\alias{decomposition_snagFallProbability}
\alias{decomposition_litterMetabolicFraction}
\alias{decomposition_moistureEffect}
\alias{decomposition_temperatureEffect}
\title{Low-level decomposition functions}
\usage{
decomposition_pHEffect(x, pool)

decomposition_annualLitterDecompositionRate(AET, lignin)

decomposition_snagFallProbability(DBH, decayClass, durability = 1)

decomposition_litterMetabolicFraction(ligninPercent, Nmass)

decomposition_moistureEffect(sand, clay, soilMoisture)

decomposition_temperatureEffect(soilTemperature)
}
\arguments{
\item{x}{Soil water pH (0-14)}

\item{pool}{String indicating the decomposition pool}

\item{AET}{Actual evapotranspiration (mm)}

\item{lignin}{Lignin percent}

\item{DBH}{Diameter at breast height}

\item{decayClass}{Decay class, from 1 to 5}

\item{durability}{Wood durability, from 0 (less resistant) to 4 (see Oberle et al. 2018)}

\item{ligninPercent}{lignin content (\% of dry)}

\item{Nmass}{nitrogen content (mg N / g dry)}

\item{sand, clay}{Soil texture values in percent volume.}

\item{soilMoisture}{Soil moisture content, relative to saturation.}

\item{soilTemperature}{Soil temperature (in Celsius).}
}
\value{
Functions \code{decomposition_moistureEffect}, \code{decomposition_pHEffect} and \code{decomposition_temperatureEffect} return
a scalar value representing a factor that should modify a decomposition rate. Function \code{decomposition_annualLitterDecompositionRate}
directly returns a scalar value with the annual decomposition rate (yr-1). Function \code{decomposition_litterMetabolicFraction} returns
a scalar with the fraction of litter that corresponds to metabolic carbon.
}
\description{
Functions related to litter and soil carbon decomposition processes
}
\details{
Function \code{decomposition_moistureEffect} follows Kelly et al. (2000)
Function \code{decomposition_snagFallProbability} follows Vanderwell et al. (2006)
}
\references{
Bonan, G. (2019). Climate change and terrestrial ecosystem modeling. Cambridge University Press, Cambridge, UK.

Vanderwel et al. (2006) Snag dynamics in partially harvested and unmanaged northern hardwood forests. Canadian Journal of Forest Research 36: 2769-2779.

Meentemeyer (1978)

Kelly et al (2000)
}
\seealso{
\code{\link{decomposition_DAYCENT}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{decomposition_DAYCENT}
\alias{decomposition_DAYCENT}
\title{DAYCENT decomposition}
\usage{
decomposition_DAYCENT(
  snags,
  litter,
  SOC,
  paramsLitterDecomposition,
  paramsAnatomy,
  baseAnnualRates,
  annualTurnoverRate,
  environmentalConditions,
  litterProduction,
  sand,
  clay,
  soilPH,
  soilO2 = 1,
  cultfac = 1,
  tstep = 1,
  balanceCheck = FALSE
)
}
\arguments{
\item{snags}{A data frame with initial dead standing (snag) cohort information (see \code{\link{growthInput}}).}

\item{litter}{A data frame with initial aboveground and belowground structural carbon pools corresponding to plant cohorts, in g C/m2  (see \code{\link{growthInput}}).}

\item{SOC}{A named numeric vector with initial metabolic, active, slow and passive carbon pools for surface and soil, in g C/m2  (see \code{\link{growthInput}}).}

\item{paramsLitterDecomposition}{A data frame of species-specific litter decomposition parameters (see \code{\link{growthInput}}).}

\item{paramsAnatomy}{A data frame of species-specific anatomy parameters (see \code{\link{growthInput}}).}

\item{baseAnnualRates}{A named vector of annual decomposition rates, in yr-1 (see \code{\link{defaultControl}}).}

\item{annualTurnoverRate}{Annual turnover rate, in yr-1  (see \code{\link{defaultControl}}).}

\item{environmentalConditions}{A data frame containing environmental conditions for each time step to simulate:
\itemize{
\item{\code{AirTempperature}: Mean air temperature (in Celsius).}
\item{\code{AirRelativeHumidity}: Mean relative humidity (percent).}
\item{\code{SoilTemperature}: Mean soil temperature (in Celsius).}
\item{\code{SoilMoisture}: Mean soil moisture, relative to saturation (0-1).}
}}

\item{litterProduction}{A data frame containing litter inputs corresponding to time steps:
\itemize{
\item{\code{Step}: Integer indicating the time step where litter is generated, corresponding to a row in \code{environmentalConditions}.}
\item{\code{Species}: Mean relative humidity (percent).}
\item{\code{Leaves}: Leaf litter production (g C·m-2).}
\item{\code{Twigs}: Twig litter production (g C·m-2).}
\item{\code{SmallBranches}: Small branch litter production (g C·m-2).}
\item{\code{LargeWood}: Large wood litter production (g C·m-2).}
\item{\code{CoarseRoots}: Coarse root litter production (g C·m-2).}
\item{\code{FineRoots}: Fine root litter production (g C·m-2).}
}}

\item{sand, clay}{Soil texture (sand and sand) in percent volume (percent).}

\item{soilPH}{Soil pH (0-14).}

\item{soilO2}{Soil oxygen factor (0-1).}

\item{cultfac}{Cultivation factor (0-1).}

\item{tstep}{Time step in days. By default, one day. For annual time steps, use \code{tstep = 365.25}.}

\item{balanceCheck}{Flag to print carbon balance check (for debugging).}
}
\value{
A list with two elements:
\itemize{
\item{\code{"HeterotrophicRespiration"}: A numeric matrix with the heterotrophic respiration (g C·m-2) corresponding to the decomposition in each time step corresponding to different carbon pools:
\itemize{
\item{\code{"SurfaceSnags"}: Respiration from decomposing snags (i.e. small branches and large wood).}
\item{\code{"SurfaceLitter"}: Respiration from decomposing litter in the surface (i.e. leaves, twigs, small branches and large wood).}
\item{\code{"SoilLitter"}: Respiration from decomposing litter belowground (i.e. coarse roots and fine roots).}
\item{\code{"SurfaceMetabolic"}: Respiration from surface metabolic pool.}
\item{\code{"BelowgroundMetabolic"}: Respiration from belowground metabolic pool.}
\item{\code{"SurfaceActive"}: Respiration from surface active pool.}
\item{\code{"BelowgroundActive"}: Respiration from belowground active pool.}
\item{\code{"SurfaceSlow"}: Respiration from surface slow pool.}
\item{\code{"BelowgroundSlow"}: Respiration from belowground slow pool.}
\item{\code{"BelowgroundPassive"}: Respiration from belowground passive pool.}
}
}
\item{\code{"DecompositionPools"}: A numeric matrix with the carbon mass of different carbon pools, all in g C · m-2:
\itemize{
\item{\code{"SmallBranchSnags"}: Carbon of (standing) small dead branches (diameters between 0.635 cm and 7.5 cm; 10h and 100h fuels).}
\item{\code{"LargeWoodSnags"}: Carbon of (standing) large dead wood (diameters larger than 7.5 cm; 1000h and 10000h fuels).}
\item{\code{"LeafLitter"}: Carbon of leaf litter.}
\item{\code{"TwigLitter"}: Carbon of twig litter.}
\item{\code{"SmallBranchLitter"}: Carbon of (downed) small dead branches (diameters between 0.635 cm and 7.5 cm; 10h and 100h fuels).}
\item{\code{"LargeWoodLitter"}: Carbon of (downed) large dead wood (diameters larger than 7.5 cm; 1000h and 10000h).}
\item{\code{"CoarseRootLitter"}: Carbon of dead coarse roots.}
\item{\code{"FineRootLitter"}: Carbon of fine root litter.}
\item{\code{"SurfaceMetabolic"}: Metabolic carbon in the surface.}
\item{\code{"BelowgroundMetabolic"}: Metabolic carbon in the soil.}
\item{\code{"SurfaceActive"}: Active decomposition carbon pool in the surface.}
\item{\code{"BelowgroundActive"}: Belowground active decomposition carbon pool.}
\item{\code{"SurfaceSlow"}: Slow decomposition carbon pool in the surface.}
\item{\code{"BelowgroundSlow"}: Belowground slow decomposition carbon pool.}
\item{\code{"BelowgroundPassive"}: Belowground passive decomposition carbon pool.}
}
}
}
}
\description{
Function implementing a modification of the DAYCENT carbon decomposition model (Parton et al. 1988, 1993, 1998), inspired by the description given in Chapter 18 of Bonan (2019).
}
\details{
Species names must match between inputs \code{paramsLitterDecomposition}, \code{litter} and \code{litterProduction}.

\emph{IMPORTANT NOTE}: Decomposition functions modify the input data (i.e. \code{snags}, \code{litter} and/or \code{SOC}) according to decomposition rates and carbon transfer rates. When used as part of \code{\link{growth}} simulations,
soil physical and chemical parameters correspond to the uppermost soil layer.
}
\references{
Bonan, G. (2019). Climate change and terrestrial ecosystem modeling. Cambridge University Press, Cambridge, UK.

Parton WJ, Steward JWB, Cole CV (1988). Dynamics of C, N, P and S in grassland soils: a model. Biogeochemistry 5: 109-131.

Parton WJ, Scurlock JMO, Ojima DS, Gilmanov TG, Scoles RJ et al. (1993). Observations and modeling of biomass and soil organic matter dynamics for the grassland biome worldwide. Global Biogeochemical Cycles 7: 785-809.

Parton WJ, Hartman M, Ojima DS, Schimel D (1998). DAYCENT and its land surface submodel: Description and testing. Global and Planetary Change, 19: 35-48.
}
\seealso{
\code{\link{decomposition_temperatureEffect}}, \code{\link{growthInput}}, \code{\link{growth}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF

Roberto Molowny-Horas, CREAF

Inés Delsman Valderrama, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{transp_transpirationSperry}
\alias{transp_transpirationSperry}
\alias{transp_transpirationSureau}
\alias{transp_modes}
\alias{transp_transpirationGranier}
\title{Transpiration modes}
\usage{
transp_transpirationSperry(
  x,
  meteo,
  day,
  latitude,
  elevation,
  slope,
  aspect,
  canopyEvaporation = 0,
  snowMelt = 0,
  soilEvaporation = 0,
  herbTranspiration = 0,
  stepFunctions = NA_integer_,
  modifyInput = TRUE
)

transp_transpirationSureau(
  x,
  meteo,
  day,
  latitude,
  elevation,
  slope,
  aspect,
  canopyEvaporation = 0,
  snowMelt = 0,
  soilEvaporation = 0,
  herbTranspiration = 0,
  modifyInput = TRUE
)

transp_transpirationGranier(
  x,
  meteo,
  day,
  latitude,
  elevation,
  slope,
  aspect,
  modifyInput = TRUE
)
}
\arguments{
\item{x}{An object of class \code{\link{spwbInput}} or \code{\link{growthInput}}, built using the 'Granier', 'Sperry' or 'Sureau' transpiration modes.}

\item{meteo}{A data frame with daily meteorological data series (see \code{\link{spwb}}).}

\item{day}{An integer to identify a day (row) within the \code{meteo} data frame.}

\item{latitude}{Latitude (in degrees).}

\item{elevation, slope, aspect}{Elevation above sea level (in m), slope (in degrees) and aspect (in degrees from North).}

\item{canopyEvaporation}{Canopy evaporation (from interception) for \code{day} (mm).}

\item{snowMelt}{Snow melt values  for \code{day} (mm).}

\item{soilEvaporation}{Bare soil evaporation for \code{day} (mm).}

\item{herbTranspiration}{Transpiration of herbaceous plants for \code{day} (mm).}

\item{stepFunctions}{An integer to indicate a simulation step for which photosynthesis and profit maximization functions are desired.}

\item{modifyInput}{Boolean flag to indicate that the input \code{x} object is allowed to be modified during the simulation.}
}
\value{
A list with the following elements:
\itemize{
\item{\code{"cohorts"}: A data frame with cohort information, copied from \code{\link{spwbInput}}.}
\item{\code{"Stand"}: A vector of stand-level variables.}
\item{\code{"Plants"}: A data frame of results for each plant cohort. When using \code{transp_transpirationGranier}, element \code{"Plants"} includes:
\itemize{
\item{\code{"LAI"}: Leaf area index of the plant cohort.}
\item{\code{"LAIlive"}: Leaf area index of the plant cohort, assuming all leaves are unfolded.}
\item{\code{"AbsorbedSWRFraction"}: Fraction of SWR absorbed by each cohort.}
\item{\code{"Transpiration"}: Transpirated water (in mm) corresponding to each cohort.}
\item{\code{"GrossPhotosynthesis"}: Gross photosynthesis (in gC/m2) corresponding to each cohort.}
\item{\code{"psi"}: Water potential (in MPa) of the plant cohort (average over soil layers).}
\item{\code{"DDS"}: Daily drought stress [0-1] (relative whole-plant conductance).}
}
When using \code{transp_transpirationSperry} or \code{transp_transpirationSureau}, element \code{"Plants"} includes:
\itemize{
\item{\code{"LAI"}: Leaf area index of the plant cohort.}
\item{\code{"LAIlive"}: Leaf area index of the plant cohort, assuming all leaves are unfolded.}
\item{\code{"Extraction"}: Water extracted from the soil (in mm) for each cohort.}
\item{\code{"Transpiration"}: Transpirated water (in mm) corresponding to each cohort.}
\item{\code{"GrossPhotosynthesis"}: Gross photosynthesis (in gC/m2) corresponding to each cohort.}
\item{\code{"NetPhotosynthesis"}: Net photosynthesis (in gC/m2) corresponding to each cohort.}
\item{\code{"RootPsi"}: Minimum water potential (in MPa) at the root collar.}
\item{\code{"StemPsi"}: Minimum water potential (in MPa) at the stem.}
\item{\code{"StemPLC"}: Proportion of conductance loss in stem.}
\item{\code{"LeafPsiMin"}: Minimum (predawn) water potential (in MPa) at the leaf (representing an average leaf).}
\item{\code{"LeafPsiMax"}: Maximum (midday) water potential (in MPa) at the leaf (representing an average leaf).}
\item{\code{"LeafPsiMin_SL"}: Minimum (predawn) water potential (in MPa) at sunlit leaves.}
\item{\code{"LeafPsiMax_SL"}: Maximum (midday) water potential (in MPa) at sunlit leaves.}
\item{\code{"LeafPsiMin_SH"}: Minimum (predawn) water potential (in MPa) at shade leaves.}
\item{\code{"LeafPsiMax_SH"}: Maximum (midday) water potential (in MPa) at shade leaves.}
\item{\code{"dEdP"}: Overall soil-plant conductance (derivative of the supply function).}
\item{\code{"DDS"}: Daily drought stress [0-1] (relative whole-plant conductance).}
\item{\code{"StemRWC"}: Relative water content of stem tissue (including symplasm and apoplasm).}
\item{\code{"LeafRWC"}: Relative water content of leaf tissue (including symplasm and apoplasm).}
\item{\code{"LFMC"}: Live fuel moisture content (in percent of dry weight).}
\item{\code{"WaterBalance"}: Plant water balance (extraction - transpiration).}
}
}
\item{\code{"Extraction"}: A data frame with mm of water extracted from each soil layer (in columns) by each cohort (in rows). The sum of a given row is equal to the total extraction of the corresponding plant cohort.}
\item{\code{"ExtractionPools"}: A named list with as many elements as plant cohorts, where each element is a matrix data with mm of water extracted from each layer (in columns) of the water pool of each cohort (in rows). The sum of a given matrix is equal to the total extraction of the corresponding plant cohort.}

The remaining items are only given by \code{transp_transpirationSperry} or \code{transp_transpirationSureau}:
\item{\code{"EnergyBalance"}: A list with the following elements:
\itemize{
\item{\code{"Temperature"}: A data frame with the temperature of the atmosphere ('Tatm'), canopy ('Tcan') and soil ('Tsoil.1', 'Tsoil.2', ...) for each time step.}
\item{\code{"CanopyEnergyBalance"}: A data frame with the components of the canopy energy balance (in W/m2) for each time step.}
\item{\code{"SoilEnergyBalance"}: A data frame with the components of the soil energy balance (in W/m2) for each time step.}
}
}
\item{\code{"RhizoPsi"}: Minimum water potential (in MPa) inside roots, after crossing rhizosphere, per cohort and soil layer.}
\item{\code{"Sunlitleaves"} and \code{"ShadeLeaves"}: Data frames for sunlit leaves and shade leaves and the following columns per cohort:
\itemize{
\item{\code{"LAI"}: Cumulative leaf area index of sunlit/shade leaves.}
\item{\code{"Vmax298"}: Average maximum carboxilation rate for sunlit/shade leaves.}
\item{\code{"Jmax298"}: Average maximum electron transport rate for sunlit/shade leaves.}
}
}
\item{\code{"ExtractionInst"}: Water extracted by each plant cohort during each time step.}
\item{\code{"PlantsInst"}: A list with instantaneous (per time step) results for each plant cohort:
\itemize{
\item{\code{"E"}: A data frame with the cumulative transpiration (mm) for each plant cohort during each time step. }
\item{\code{"Ag"}: A data frame with the cumulative gross photosynthesis (gC/m2) for each plant cohort during each time step. }
\item{\code{"An"}: A data frame with the cumulative net photosynthesis (gC/m2) for each plant cohort during each time step. }
\item{\code{"Sunlitleaves"} and \code{"ShadeLeaves"}: Lists with instantaneous (for each time step) results for sunlit leaves and shade leaves and the following items:
\itemize{
\item{\code{"Abs_SWR"}: A data frame with instantaneous absorbed short-wave radiation (SWR).}
\item{\code{"Net_LWR"}: A data frame with instantaneous net long-wave radiation (LWR).}
\item{\code{"An"}: A data frame with instantaneous net photosynthesis (in micromol/m2/s). }
\item{\code{"Ci"}: A data frame with instantaneous intercellular CO2 concentration (in ppm). }
\item{\code{"GW"}: A data frame with instantaneous stomatal conductance (in mol/m2/s). }
\item{\code{"VPD"}: A data frame with instantaneous vapour pressure deficit (in kPa). }
\item{\code{"Temp"}: A data frame with leaf temperature (in degrees Celsius). }
\item{\code{"Psi"}: A data frame with leaf water potential (in MPa). }
}
}
\item{\code{"dEdP"}: A data frame with the slope of the plant supply function (an estimation of whole-plant conductance).}
\item{\code{"RootPsi"}: A data frame with root crown water potential (in MPa) for each plant cohort during each time step.}
\item{\code{"StemPsi"}: A data frame with stem water potential (in MPa) for each plant cohort during each time step.}
\item{\code{"LeafPsi"}: A data frame with leaf (average) water potential (in MPa) for each plant cohort during each time step. }
\item{\code{"StemPLC"}: A data frame with the proportion loss of conductance [0-1] for each plant cohort during each time step. }
\item{\code{"StemRWC"}: A data frame with the (average) relative water content of stem tissue [0-1] for each plant cohort during each time step. }
\item{\code{"LeafRWC"}: A data frame with the relative water content of leaf tissue [0-1] for each plant cohort during each time step. }
\item{\code{"StemSympRWC"}: A data frame with the (average) relative water content of symplastic stem tissue [0-1] for each plant cohort during each time step. }
\item{\code{"LeafSympRWC"}: A data frame with the relative water content of symplastic leaf tissue [0-1] for each plant cohort during each time step. }
\item{\code{"PWB"}: A data frame with plant water balance (extraction - transpiration).}
}
}
\item{\code{"LightExtinction"}: A list of information regarding radiation balance through the canopy, as returned by function \code{\link{light_instantaneousLightExtinctionAbsortion}}.}
\item{\code{"CanopyTurbulence"}: Canopy turbulence (see \code{\link{wind_canopyTurbulence}}).}
\item{\code{"SupplyFunctions"}: If \code{stepFunctions} is not missing, a list of supply functions, photosynthesis functions and profit maximization functions.}
}
}
\description{
High-level sub-models representing transpiration, plant hydraulics, photosynthesis and water relations
within plants.
}
\details{
Three sub-models are available:
\itemize{
\item{Sub-model in function \code{transp_transpirationGranier} was described in De \enc{Cáceres}{Caceres} et al. (2015),
and implements an approach originally described in Granier et al. (1999).}
\item{Sub-model in function \code{transp_transpirationSperry} was described in De \enc{Cáceres}{Caceres} et al. (2021), and
implements a modelling approach originally described in Sperry et al. (2017).}
\item{Sub-model in function \code{transp_transpirationSureau} was described for SurEau-Ecos v2.0 model in Ruffault et al. (2022).}
}
}
\examples{
#Load example daily meteorological data
data(examplemeteo)

#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Define soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

#Initialize control parameters
control <- defaultControl("Granier")

#Initialize input
x1 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)

# Transpiration according to Granier's model, plant water potential 
# and plant stress for a given day
t1 <- transp_transpirationGranier(x1, examplemeteo, 1, 
                                 latitude = 41.82592, elevation = 100, slope = 0, aspect = 0, 
                                 modifyInput = FALSE)

#Switch to 'Sperry' transpiration mode
control <- defaultControl("Sperry")

#Initialize input
x2 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)

# Transpiration according to Sperry's model
t2 <- transp_transpirationSperry(x2, examplemeteo, 1, 
                                latitude = 41.82592, elevation = 100, slope = 0, aspect = 0,
                                modifyInput = FALSE)
                                
#Switch to 'Sureau' transpiration mode
control <- defaultControl("Sureau")

#Initialize input
x3 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)

# Transpiration according to Sureau model
t3 <- transp_transpirationSureau(x3, examplemeteo, 1, 
                                  latitude = 41.82592, elevation = 100, slope = 0, aspect = 0,
                                  modifyInput = FALSE)
                                
}
\references{
De \enc{Cáceres}{Caceres} M, \enc{Martínez}{Martinez}-Vilalta J, Coll L, Llorens P, Casals P, Poyatos R, Pausas JG, Brotons L. (2015) Coupling a water balance model with forest inventory data to predict drought stress: the role of forest structural changes vs. climate changes. Agricultural and Forest Meteorology 213: 77-90 (doi:10.1016/j.agrformet.2015.06.012).

De \enc{Cáceres}{Caceres} M, Mencuccini M, Martin-StPaul N, Limousin JM, Coll L, Poyatos R, Cabon A, Granda V, Forner A, Valladares F, \enc{Martínez}{Martinez}-Vilalta J (2021) Unravelling the effect of species mixing on water use and drought stress in holm oak forests: a modelling approach. Agricultural and Forest Meteorology 296 (doi:10.1016/j.agrformet.2020.108233).

Granier A, \enc{Bréda}{Breda} N, Biron P, Villette S (1999) A lumped water balance model to evaluate duration and intensity of drought constraints in forest stands. Ecol Modell 116:269–283. https://doi.org/10.1016/S0304-3800(98)00205-1.

Ruffault J, Pimont F, Cochard H, Dupuy JL, Martin-StPaul N (2022)
SurEau-Ecos v2.0: a trait-based plant hydraulics model for simulations of plant water status and drought-induced mortality at the ecosystem level.
Geoscientific Model Development 15, 5593-5626 (doi:10.5194/gmd-15-5593-2022).

Sperry, J. S., M. D. Venturas, W. R. L. Anderegg, M. Mencuccini, D. S. Mackay, Y. Wang, and D. M. Love. 2017. Predicting stomatal responses to the environment from the optimization of photosynthetic gain and hydraulic cost. Plant Cell and Environment 40, 816-830 (doi: 10.1111/pce.12852).
}
\seealso{
\code{\link{spwb_day}}, \code{\link{plot.spwb_day}}
}
\author{
\itemize{
\item{Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF}
\item{Nicolas Martin-StPaul, URFM-INRAE}
}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{hydrology_verticalInputs}
\alias{hydrology_verticalInputs}
\alias{hydrology_waterInputs}
\alias{hydrology_agricultureWaterInputs}
\alias{hydrology_snowMelt}
\title{Water vertical inputs}
\usage{
hydrology_waterInputs(
  x,
  prec,
  rainfallIntensity,
  pet,
  tday,
  rad,
  elevation,
  Cm,
  LgroundPAR,
  LgroundSWR,
  modifyInput = TRUE
)

hydrology_agricultureWaterInputs(
  x,
  prec,
  tday,
  rad,
  elevation,
  LgroundSWR,
  modifyInput = TRUE
)

hydrology_snowMelt(tday, rad, LgroundSWR, elevation)
}
\arguments{
\item{x}{An object of class \code{\link{spwbInput}} or \code{\link{growthInput}}.}

\item{prec}{Precipitation for the given day (mm)}

\item{rainfallIntensity}{Rainfall intensity rate (mm/h).}

\item{pet}{Potential evapotranspiration for the given day (mm)}

\item{tday}{Average day temperature (ºC).}

\item{rad}{Solar radiation (in MJ/m2/day).}

\item{elevation}{Altitude above sea level (m).}

\item{Cm}{Canopy water storage capacity.}

\item{LgroundPAR}{Percentage of photosynthetically-active radiation (PAR) reaching the ground.}

\item{LgroundSWR}{Percentage of short-wave radiation (SWR) reaching the ground.}

\item{modifyInput}{Boolean flag to indicate that the input \code{x} object should be modified during the simulation.}
}
\value{
Function \code{hydrology_waterInputs} returns a named vector with the following elements, all in mm:
\item{Rain}{Precipitation as rainfall.}
\item{Snow}{Precipitation as snow.}
\item{Interception}{Rainfall water intercepted by the canopy and evaporated.}
\item{Snowmelt}{Snow melted during the day, and added to the water infiltrated.}
\item{NetRain}{Rainfall reaching the ground.}
}
\description{
High-level functions to define water inputs into the soil of a stand:

\itemize{
\item{Function \code{hydrology_waterInputs} performs canopy water interception and snow accumulation/melt.}
\item{Function \code{hydrology_snowMelt} estimates snow melt using a simple energy balance, according to Kergoat (1998).}
}
}
\details{
The function simulates different vertical hydrological processes, which are described separately in other functions.
If \code{modifyInput = TRUE} the function will modify the \code{x} object (including both soil moisture and
the snowpack on its surface) as a result of simulating hydrological processes.
}
\references{
Kergoat L. (1998). A model for hydrological equilibrium of leaf area index on a global scale. Journal of Hydrology 212–213: 268–286.
}
\seealso{
\code{\link{spwb_day}}, \code{\link{hydrology_rainInterception}}, \code{\link{hydrology_soilEvaporation}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

\encoding{UTF-8}
\docType{data}
\name{Parameter means}
\alias{trait_family_means}
\title{
Parameter average values
}
\description{
Internal data set with parameter averages for taxonomic families. This is used by input initialization functions to provide suitable parameter values when missing from species parameter tables.
}
\format{
Data frame \code{trait_family_means} has taxonomic families in rows and parameter names as columns.
}
\source{
Same sources as \code{\link{SpParamsMED}}
}
\seealso{\code{\link{SpParamsMED}}, \code{\link{spwbInput}}}
\keyword{datasets}
\examples{
medfate::trait_family_means
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.soil.R
\name{plot.soil}
\alias{plot.soil}
\title{Soil water curves}
\usage{
\method{plot}{soil}(
  x,
  type = "RetentionCurve",
  model = "SX",
  layer = 1,
  relative = TRUE,
  to = "SAT",
  ...
)
}
\arguments{
\item{x}{Initialized soil object (returned by function \code{\link{soil}}).}

\item{type}{A string of the plot type: "RetentionCurve" or "ConductivityCurve".}

\item{model}{model Either 'SX' or 'VG' for Saxton's or Van Genuchten's water retention models; or 'both' to plot both retention models.}

\item{layer}{Soil layer to be plotted.}

\item{relative}{Boolean flag to indicate that retention curve should be relative to field capacity or saturation.}

\item{to}{Either 'SAT' (saturation) or 'FC' (field capacity).}

\item{\dots}{Additional parameters to specific functions}
}
\value{
An object of class ggplot.
}
\description{
Function for plotting water retention or conductivity curves for soil layers.
}
\details{
The function is a common wrapper to specialized internal functions (see \code{\link{soil_retentionCurvePlot}}).
}
\examples{
# Initializes soil
s = soil(defaultSoilParams())
plot(s)

}
\seealso{
\code{\link{soil}}, \code{\link{summary.soil}}, \code{\link{soil_retentionCurvePlot}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{sureau_ecos}
\alias{sureau_ecos}
\alias{initSureauNetworks}
\alias{semi_implicit_integration}
\title{Sureau-ECOS inner functions for testing only}
\usage{
initSureauNetworks(x)

semi_implicit_integration(
  network,
  dt,
  opt,
  stemCavitationRecovery = "annual",
  leafCavitationRecovery = "total"
)
}
\arguments{
\item{x}{An object of class \code{\link{spwbInput}} or \code{\link{growthInput}} created using \code{transpirationMode = "Sureau"}.}

\item{network}{A hydraulic network element of the list returned by \code{initSureauNetworks}}

\item{dt}{Smallest time step (seconds)}

\item{opt}{Option flag vector}

\item{stemCavitationRecovery, leafCavitationRecovery}{A string indicating how refilling of embolized conduits is done:
\itemize{
\item{"none" - no refilling.}
\item{"annual" - every first day of the year.}
\item{"rate" - following a rate of new sapwood formation.}
\item{"total" - instantaneous complete refilling.}
}}
}
\value{
Function \code{initSureauNetworks} returns a vector of length equal to the number of cohorts. Each element is a list with Sureau-ECOS parameters.
Function \code{semi_implicit_integration} does not return anything, but modifies input parameter \code{network}.
}
\description{
Function \code{initSureauNetworks} initializes hydraulic networks for all plant cohorts in x
Function \code{semi_implicit_integration} updates water potentials and cavitation across the hydraulic network
}
\references{
Ruffault J, Pimont F, Cochard H, Dupuy JL, Martin-StPaul N (2022)
SurEau-Ecos v2.0: a trait-based plant hydraulics model for simulations of plant water status and drought-induced mortality at the ecosystem level.
Geoscientific Model Development 15, 5593-5626 (doi:10.5194/gmd-15-5593-2022).
}
\seealso{
\code{\link{spwb}}
}
\author{
\itemize{
\item{Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF}
\item{Nicolas Martin-StPaul, URFM-INRAE}
}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{resetInputs}
\alias{resetInputs}
\title{Reset simulation inputs}
\usage{
resetInputs(x)
}
\arguments{
\item{x}{An object of class \code{\link{spwbInput}} or \code{\link{growthInput}}.}
}
\value{
Does not return any value. Instead, it modifies input object \code{x}.
}
\description{
Function \code{resetInputs()} allows resetting state variables in \code{x} to their defaults.
}
\seealso{
\code{\link{spwbInput}}, \code{\link{growthInput}}, \code{\link{spwb}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/soil_redefineLayers.R
\name{soil_redefineLayers}
\alias{soil_redefineLayers}
\title{Redefine soil layer widths}
\usage{
soil_redefineLayers(x, widths = c(300, 700, 1000, 2000))
}
\arguments{
\item{x}{A data frame of soil parameters (see an example in \code{\link{defaultSoilParams}}) or an object of class \code{\link{soil}}.}

\item{widths}{A numeric vector indicating the desired layer widths, in mm.}
}
\value{
A data frame or \code{\link{soil}} object with soil parameters, depending on the class of \code{x}.
}
\description{
Allows redefining soil layer widths of an input data frame of soil parameters.
}
\details{
If an initialized \code{\link{soil}} is supplied, its hydraulic parameters will be recalculated and the value of state variables will be lost.
}
\examples{
# Define initial soil with 5 layers
spar <- defaultSoilParams(5)
spar

# Redefine to four layers
soil_redefineLayers(spar)

# Same but after soil parameter initialization
examplesoil <- soil(spar)
examplesoil

soil_redefineLayers(examplesoil)

}
\seealso{
\code{\link{soil}}, \code{\link{defaultSoilParams}}
}
\author{
\enc{Víctor}{Victor} Granda, EMF-CREAF

Miquel De \enc{Cáceres}{Caceres} Ainsa, EMF-CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{transp_stomatalregulation}
\alias{transp_stomatalregulation}
\alias{transp_profitMaximization}
\title{Stomatal regulation}
\usage{
transp_profitMaximization(
  supplyFunction,
  photosynthesisFunction,
  Gswmin,
  Gswmax
)
}
\arguments{
\item{supplyFunction}{Water supply function (see \code{\link{hydraulics_supplyFunctionNetwork}}).}

\item{photosynthesisFunction}{Function returned by \code{photo_photosynthesisFunction()}.}

\item{Gswmin, Gswmax}{Minimum and maximum stomatal conductance to water vapour (mol·m-2·s-1).}
}
\value{
Function \code{transp_profitMaximization} returns a list with the following elements:
\itemize{
\item{\code{Cost}: Cost function [0-1].}
\item{\code{Gain}: Gain function [0-1].}
\item{\code{Profit}: Profit function [0-1].}
\item{\code{iMaxProfit}: Index corresponding to maximum profit (starting from 0).}
}
}
\description{
Set of high-level functions used in the calculation of stomatal conductance and transpiration.
Function \code{transp_profitMaximization} calculates gain and cost functions,
as well as profit maximization from supply and photosynthesis input functions.
Function \code{transp_stomatalRegulationPlot} produces a plot with the cohort supply functions against water potential
and a plot with the cohort photosynthesis functions against water potential, both with the maximum profit values indicated.
}
\references{
Sperry, J. S., M. D. Venturas, W. R. L. Anderegg, M. Mencuccini, D. S. Mackay, Y. Wang, and D. M. Love. 2017. Predicting stomatal responses to the environment from the optimization of photosynthetic gain and hydraulic cost. Plant Cell and Environment 40, 816-830 (doi: 10.1111/pce.12852).
}
\seealso{
\code{\link{transp_transpirationSperry}}, \code{\link{hydraulics_supplyFunctionNetwork}}, \code{\link{biophysics_leafTemperature}}, \code{\link{photo_photosynthesis}}, \code{\link{spwb_day}}, \code{\link{plot.spwb_day}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/evaluation.R
\name{evaluation}
\alias{evaluation}
\alias{evaluation_table}
\alias{evaluation_stats}
\alias{evaluation_plot}
\alias{evaluation_metric}
\title{Evaluation of simulations results}
\usage{
evaluation_table(
  out,
  measuredData,
  type = "SWC",
  cohort = NULL,
  temporalResolution = "day"
)

evaluation_stats(
  out,
  measuredData,
  type = "SWC",
  cohort = NULL,
  temporalResolution = "day"
)

evaluation_plot(
  out,
  measuredData,
  type = "SWC",
  cohort = NULL,
  temporalResolution = "day",
  plotType = "dynamics"
)

evaluation_metric(
  out,
  measuredData,
  type = "SWC",
  cohort = NULL,
  temporalResolution = "day",
  metric = "loglikelihood"
)
}
\arguments{
\item{out}{An object of class \code{\link{spwb}}, \code{\link{growth}} or \code{\link{pwb}}.}

\item{measuredData}{A data frame with observed/measured values. Dates should be in row names, whereas columns should be named according to the type of output to be evaluated (see details).}

\item{type}{A string with the kind of model output to be evaluated. Accepted values are:
\itemize{
\item{\code{"SWC"}: Soil water content (percent volume). See details for specific soil layers.}
\item{\code{"RWC"}: Relative water content (relative to field capacity). See details for specific soil layers.}
\item{\code{"REW"}: Relative extractable water. See details for specific soil layers.}
\item{\code{"ETR"}: Total evapotranspiration.}
\item{\code{"SE+TR"}: Modelled soil evaporation + plant transpiration against observed total evapotranspiration}
\item{\code{"E"}: Transpiration per leaf area}
\item{\code{"LE"}: Latent heat (vaporisation) turbulent flux}
\item{\code{"H"}: Canopy sensible heat turbulent flux}
\item{\code{"GPP"}: Stand-level gross primary productivity}
\item{\code{"LFMC"}: Live fuel moisture content}
\item{\code{"WP"}: Plant water potentials}
\item{\code{"BAI"}: Basal area increment}
\item{\code{"DI"}: Diameter increment}
\item{\code{"DBH"}: Diameter at breast height}
\item{\code{"Height"}: Plant height}
}}

\item{cohort}{A string of the cohort to be compared (e.g. "T1_68"). If \code{NULL} results for the first cohort will be evaluated.}

\item{temporalResolution}{A string to indicate the temporal resolution of the model evaluation, which can be "day", "week", "month" or "year". Observed and modelled values are aggregated temporally (using either means or sums) before comparison.}

\item{plotType}{Plot type to draw, either \code{"dynamics"}, \code{"pointdynamics"}  or \code{"scatter"}.}

\item{metric}{An evaluation metric:
\itemize{
\item{\code{"MAE"}: Mean absolute error.}
\item{\code{"MAE.rel"}: Mean absolute error in relative terms.}
\item{\code{"r"}: Pearson's linear correlation coefficient.}
\item{\code{"NSE"}: Nash-Sutcliffe model efficiency coefficient.}
\item{\code{"NSE.abs"}: Modified Nash-Sutcliffe model efficiency coefficient (L1 norm) (Legates & McCabe 1999).}
\item{\code{"loglikelihood"}: Logarithm of the likelihood of observing the data given the model predictions, assuming independent Gaussian errors.}
}}
}
\value{
\itemize{
\item{Function \code{evaluation_table} returns a data frame with dates, observed and predicted values.}
\item{Function \code{evaluation_stats} returns evaluation statistics (a vector or a data frame depending on \code{type}):
\itemize{
\item{\code{Bias}: Mean deviation (positive values correspond to model overestimations).}
\item{\code{Bias.rel}: Bias in relative terms (\%).}
\item{\code{MAE}: Mean absolute error.}
\item{\code{MAE.rel}: Mean absolute error in relative terms (\%).}
\item{\code{r}: Pearson's linear correlation coefficient.}
\item{\code{NSE}: Nash-Sutcliffe model efficiency coefficient.}
\item{\code{NSE.abs}: Modified Nash-Sutcliffe model efficiency coefficient (L1 norm) (Legates & McCabe 1999).}
}
}
\item{Function \code{evaluation_plot} returns a ggplot object.}
\item{Function \code{evaluation_metric} returns a scalar with the desired metric.}
}
}
\description{
Functions to compare model predictions against observed values.
}
\details{
Users should provide the appropriate columns in \code{measuredData}, depending on the type of output to be evaluated:
\itemize{
\item{\code{"SWC", "RWC", "REW"}: A column with the same name should be present. By default, the first soil layer is compared. Evaluation can be done for specific soil layers, for example using "RWC.2" for the relative water content of the second layer.}
\item{\code{"ETR"} or \code{"SE+TR"}: A column named \code{"ETR"} should be present, containing stand's evapotranspiration in mm/day (or mm/week, mm/month, etc, depending on the temporal resolution). If \code{type="ETR"} observed values will be compared against modelled evapotranspiration (i.e. sum of transpiration, soil evaporation and interception loss), whereas if \code{type= "SE+TR"} observed values will be compared against the sum of transpiration and soil evaporation only.}
\item{\code{"LE"}: A column named \code{"LE"} should be present containing daily latent heat turbulent flux in MJ/m2.}
\item{\code{"H"}: A column named \code{"H"} should be present containing daily sensible heat turbulent flux in MJ/m2.}
\item{\code{"E"}: For each plant cohort whose transpiration is to be evaluated, a column starting with \code{"E_"} and continuing with a cohort name (e.g. \code{"E_T1_68"}) with transpiration in L/m2/day on a leaf area basis (or L/m2/week, L/m2/month, etc, depending on the temporal resolution).}
\item{\code{"GPP"}: A column named \code{"GPP"} should be present containing daily gross primary productivity in gC/m2.}
\item{\code{"LFMC"}: For each plant cohort whose transpiration is to be evaluated, a column starting with \code{"LFMC_"} and continuing with a cohort name (e.g. \code{"LFMC_T1_68"}) with fuel moisture content as percent of dry weight.}
\item{\code{"WP"}: For each plant cohort whose transpiration is to be evaluated, two columns, one starting with \code{"PD_"} (for pre-dawn) and the other with \code{"MD_"} (for midday), and continuing with a cohort name (e.g. \code{"PD_T1_68"}). They should contain leaf water potential values in MPa. These are compared against sunlit water potentials.}
\item{\code{"BAI"}: For each plant cohort whose growth is to be evaluated, a column starting with \code{"BAI_"} and continuing with a cohort name (e.g. \code{"BAI_T1_68"}) with basal area increment in cm2/day, cm2/week, cm2/month or cm2/year, depending on the temporal resolution.}
\item{\code{"DI"}: For each plant cohort whose growth is to be evaluated, a column starting with \code{"DI_"} and continuing with a cohort name (e.g. \code{"DI_T1_68"}) with basal area increment in cm/day, cm/week, cm/month or cm/year, depending on the temporal resolution.}
\item{\code{"DBH"}: For each plant cohort whose growth is to be evaluated, a column starting with \code{"DBH_"} and continuing with a cohort name (e.g. \code{"DBH_T1_68"}) with DBH values in cm.}
\item{\code{"Height"}: For each plant cohort whose growth is to be evaluated, a column starting with \code{"Height_"} and continuing with a cohort name (e.g. \code{"Height_T1_68"}) with Height values in cm.}
}
Additional columns may exist with the standard error of measured quantities. These should be named as the referred quantity, followed by \code{"_err"} (e.g. \code{"PD_T1_68_err"}), and are used to draw confidence intervals around observations.

Row names in \code{measuredData} indicate the date of measurement (in the case of days). Alternatively, a column called \code{"dates"} can contain the measurement dates.
If measurements refer to months or years, row names should also be in a "year-month-day" format, although with "01" for days and/or months (e.g. "2001-02-01" for february 2001, or "2001-01-01" for year 2001).
}
\examples{
\donttest{
#Load example daily meteorological data
data(examplemeteo)

#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Define soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

#Initialize control parameters
control <- defaultControl("Granier")

#Initialize input
x1 <- spwbInput(exampleforest, examplesoil, SpParamsMED, control)

#Call simulation function
S1 <- spwb(x1, examplemeteo, latitude = 41.82592, elevation = 100)

#Load observed data (in this case the same simulation results with some added error)  
data(exampleobs)

#Evaluation statistics for soil water content
evaluation_stats(S1, exampleobs)

#NSE only
evaluation_metric(S1, exampleobs, metric="NSE")

#Comparison of temporal dynamics
evaluation_plot(S1, exampleobs)

#Loglikelihood value
evaluation_metric(S1, exampleobs)
}

}
\references{
Legates, D.R., McCabe, G.J., 1999. Evaluating the use of “goodness-of-fit” measures in hydrologic and hydroclimatic model validation. Water Resour. Res. 35, 233–241.
}
\seealso{
\code{\link{spwb}}, \code{\link{growth}}, \code{\link{optimization}}, \code{\link{exampleobs}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/optimization.R
\name{optimization}
\alias{optimization}
\alias{multiple_runs}
\alias{optimization_function}
\alias{optimization_evaluation_function}
\alias{optimization_multicohort_function}
\alias{optimization_evaluation_multicohort_function}
\title{Multiple model runs and function factories for optimization routines}
\usage{
multiple_runs(
  parMatrix,
  x,
  meteo,
  latitude,
  elevation = NA,
  slope = NA,
  aspect = NA,
  summary_function = NULL,
  args = NULL,
  verbose = TRUE
)

optimization_function(
  parNames,
  x,
  meteo,
  latitude,
  elevation = NA,
  slope = NA,
  aspect = NA,
  summary_function,
  args = NULL
)

optimization_evaluation_function(
  parNames,
  x,
  meteo,
  latitude,
  elevation = NA,
  slope = NA,
  aspect = NA,
  measuredData,
  type = "SWC",
  cohorts = NULL,
  temporalResolution = "day",
  metric = "loglikelihood"
)

optimization_multicohort_function(
  cohortParNames,
  cohortNames,
  x,
  meteo,
  latitude,
  otherParNames = NULL,
  elevation = NA,
  slope = NA,
  aspect = NA,
  summary_function,
  args = NULL
)

optimization_evaluation_multicohort_function(
  cohortParNames,
  cohortNames,
  x,
  meteo,
  latitude,
  otherParNames = NULL,
  elevation = NA,
  slope = NA,
  aspect = NA,
  measuredData,
  type = "SWC",
  cohorts = cohortNames,
  temporalResolution = "day",
  metric = "loglikelihood"
)
}
\arguments{
\item{parMatrix}{A matrix of parameter values with runs in rows and parameters in columns. Column names should follow parameter modification naming rules (see examples and naming rules in \code{\link{modifyInputParams}}).}

\item{x}{An object of class \code{\link{spwbInput}} or \code{\link{growthInput}}.}

\item{meteo, latitude, elevation, slope, aspect}{Additional parameters to simulation functions \code{\link{spwb}} or \code{\link{growth}}.}

\item{summary_function}{A function whose input is the result of \code{\link{spwb}} or \code{\link{growth}}. The function must return a numeric scalar in the case of \code{optimization_function}, but is not restricted in the case of \code{multiple_runs}.}

\item{args}{A list of additional arguments of \code{optimization_function}.}

\item{verbose}{A flag to indicate extra console output.}

\item{parNames}{A string vector of parameter names (see examples and naming rules in \code{\link{modifyInputParams}}).}

\item{measuredData}{A data frame with observed/measured values. Dates should be in row names, whereas columns should be named according to the type of output to be evaluated (see details).}

\item{type}{A string with the kind of model output to be evaluated. Accepted values are \code{"SWC"} (soil moisture content), \code{"REW"} relative extractable water, \code{"ETR"} (total evapotranspiration), \code{"E"} (transpiration per leaf area), \code{"LFMC"} (live fuel moisture content) and \code{"WP"} (plant water potentials).}

\item{cohorts}{A string or a vector of strings with the cohorts to be compared (e.g. "T1_68"). If several cohort names are provided, the function \code{optimization_cohorts_function} evaluates the performance for each one and provides the mean value. If \code{NULL} results for the first cohort will be evaluated.}

\item{temporalResolution}{A string to indicate the temporal resolution of the model evaluation, which can be "day", "week", "month" or "year". Observed and modelled values are aggregated temporally (using either means or sums) before comparison.}

\item{metric}{An evaluation metric (see \code{\link{evaluation_metric}}).}

\item{cohortParNames}{A string vector of vegetation parameter names for cohorts (e.g. 'Z95' or 'psiExtract').}

\item{cohortNames}{A string vector of cohort names. All cohorts will be given the same parameter values for each parameter in 'cohortParNames'.}

\item{otherParNames}{A string vector of parameter names (see examples and naming rules in \code{\link{modifyInputParams}}) for non-vegetation parameters (i.e. control parameters and soil parameters).}
}
\value{
Function \code{multiple_runs} returns a list, whose elements are either the result of calling simulation models
or the result of calling \code{summary_function} afterwards.

Function \code{optimization_function} returns a function whose parameters are parameter values
and whose return is a prediction scalar (e.g. total transpiration).

Function \code{optimization_evaluation_function} returns a function whose parameters are parameter values
and whose return is an evaluation metric (e.g. loglikelihood of the data observations given model predictions).
If evaluation data contains information for different cohorts (e.g. plant water potentials or transpiration rates)
then the evaluation is performed for each cohort and the metrics are averaged.

Function \code{optimization_multicohorts_function} returns a function whose parameters are parameter values
and whose return is a prediction scalar (e.g. total transpiration). The difference with \code{optimization_function}
is that multiple cohorts are set to the same parameter values.

Function \code{optimization_evaluation_multicohort_function} returns a function whose parameters are parameter values
and whose return is an evaluation metric (e.g. loglikelihood of the data observations given model predictions).
If evaluation data contains information for different cohorts (e.g. plant water potentials or transpiration rates)
then the evaluation is performed for each cohort and the metrics are averaged. The difference with \code{optimization_evaluation_function}
is that multiple cohorts are set to the same parameter values.
}
\description{
Function factories to generate functions to be used in model calibration, uncertainty or sensitivity analysis.
}
\details{
See \code{\link{evaluation}} for details regarding how to specify measured data.

Functions produced by these function factories should be useful for sensitivity analyses using package 'sensitivity'.

Parameter naming (i.e. \code{parNames}) should follow the rules specified in section details of \code{\link{modifyInputParams}}.
The exception to the naming rules applies when multiple cohorts are to be modified to the same values with functions
\code{optimization_multicohort_function} and \code{optimization_evaluation_multicohort_function}.
Then, only a vector of parameter names is supplied for \code{cohortParNames}.
}
\examples{
\donttest{
#Load example daily meteorological data
data(examplemeteo)

#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Define soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

#Initialize control parameters
control <- defaultControl("Granier")

#Initialize input
x1 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)

# Cohort name for Pinus halepensis
PH_coh <- paste0("T1_", SpParamsMED$SpIndex[SpParamsMED$Name=="Pinus halepensis"])
PH_coh 

#Parameter names of interest
parNames <- c(paste0(PH_coh,"/Z50"), paste0(PH_coh,"/Z95"))

#Specify parameter matrix
parMatrix <- cbind(c(200,300), c(500,1000))
colnames(parMatrix) <- parNames

#Define a summary function as the total transpiration over the simulated period
sf<-function(x) {sum(x$WaterBalance$Transpiration, na.rm=TRUE)}

#Perform two runs and evaluate the summary function
multiple_runs(parMatrix, 
              x1, examplemeteo, latitude = 42, elevation = 100,
              summary_function = sf)

#Load observed data (in this case the same simulation results with some added error)  
# Generate a prediction function for total transpiration over the simulated period
# as a function of parameters "Z50" and "Z95" for Pinus halepensis cohort 
of<-optimization_function(parNames = parNames,
                          x = x1,
                          meteo = examplemeteo, 
                          latitude = 41.82592, elevation = 100,
                          summary_function = sf)

# Evaluate for the values of the parameter matrix
of(parMatrix[1, ])
of(parMatrix)


# Generate a loglikelihood function for soil water content
# as a function of parameters "Z50" and "Z95" for Pinus halepensis cohort 
data(exampleobs)
oef<-optimization_evaluation_function(parNames = parNames,
                                      x = x1,
                                      meteo = examplemeteo, latitude = 41.82592, elevation = 100,
                                      measuredData = exampleobs, type = "SWC", 
                                      metric = "loglikelihood")

# Loglikelihood for the values of the parameter matrix
oef(parMatrix[1, ])
oef(parMatrix)
}

}
\seealso{
\code{\link{evaluation_metric}}, \code{\link{modifyInputParams}}, \code{\link{spwb}}, \code{\link{growth}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/droughtStress.R
\name{droughtStress}
\alias{droughtStress}
\title{Drought stress indicators}
\usage{
droughtStress(x, index = "NDD", freq = "years", bySpecies = FALSE, draw = TRUE)
}
\arguments{
\item{x}{An object of class \code{\link{spwb}}, \code{\link{pwb}}, \code{\link{growth}} or \code{\link{fordyn}}.}

\item{index}{A string with the index to be calculated, either \code{"DI"}, \code{"NDD"}, \code{"ADS"}, \code{"MDS"} or \code{"WSI"} (see details).}

\item{freq}{Frequency of stress statistics (see \code{\link{cut.Date}}). Normally, either \code{"years"} or \code{"months"} for yearly-based or monthly-based indices.}

\item{bySpecies}{Allows aggregating output by species.}

\item{draw}{A boolean flag to indicate that a plot should be returned.}
}
\value{
A data frame with periods (e.g., years or months) in rows and plant cohorts (or species) in columns.
Values are the calculated stress index. If \code{draw=TRUE} a ggplot is returned instead.
}
\description{
Calculates plant drought stress indices, at different temporal scales, from simulation results.
}
\details{
The currently available drought stress indices are:
\itemize{
\item{\code{"ADS"}: Average of daily drought stress values for the period considered.}
\item{\code{"MDS"}: Maximum daily drought stress during the period considered.}
\item{\code{"DI"}: Drought intensity, as defined in De \enc{Cáceres}{Caceres} et al. (2015).}
\item{\code{"NDD"}: Number of drought days, as defined in De \enc{Cáceres}{Caceres} et al. (2015).}
\item{\code{"WSI"}: Water stress integral, as defined in Myers (1988).}
}
}
\references{
De \enc{Cáceres}{Caceres} M, \enc{Martínez}{Martinez}-Vilalta J, Coll L, Llorens P, Casals P, Poyatos R, Pausas JG, Brotons L. (2015) Coupling a water balance model with forest inventory data to predict drought stress: the role of forest structural changes vs. climate changes. Agricultural and Forest Meteorology 213: 77-90 (doi:10.1016/j.agrformet.2015.06.012).

Myers BJ (1988) Water stress integral - a link between short-term stress and long-term growth. Tree Physiology 4: 315–323 (doi: 10.1093/treephys/4.4.315)
}
\seealso{
\code{\link{summary.spwb}}, \code{\link{waterUseEfficiency}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dataset_documentation.R
\docType{data}
\name{poblet_trees}
\alias{poblet_trees}
\title{Example forest inventory data}
\source{
\itemize{
\item{Data table \code{poblet_trees} corresponds to field data sampled by the Catalan Forest Ownership Center (Centre de la Propietat Forestal; CPF).}
}
}
\description{
Example data to illustrate the creation of forest objects from inventory data,
coming from a forest inventory survey, used to illustrate the general function \code{\link{forest_mapTreeTable}}:
\itemize{
\item \code{poblet_trees} - Data frame with example tree plot data from Poblet, Catalonia (717 observations and 4 variables).
\itemize{
\item Plot.Code - Plot ID (character)
\item Indv.Ref - Tree individual (integer)
\item Species - Species name (character)
\item Diameter.cm - Tree diameter at breast height (cm)
}
}
}
\seealso{
\code{\link{forest_mapTreeTable}}
}
\keyword{data}

\name{runners}
\alias{runners}
\title{
	Rcpp module: Running simulations
}
\description{
	This Rcpp module allows running simulations using C++ background objects. They are intended for non-standard users.
}
\details{
	The module contains the following items: 

	classes: \describe{
        \item{single_runner}{An S4 class to run spwb_day() or growth_day() simulations on a single site.}
        \item{multiple_runner}{An S4 class to run spwb_day() or growth_day() simulations on multiple sites, if required using parallelization.}
        \item{watershed_runner}{An S4 class to run one day of watershed simulations.}
		}
}
\examples{
show( runners )
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fireHazard.R
\name{fireHazard}
\alias{fireHazard}
\title{Fire hazard}
\usage{
fireHazard(
  x,
  SpParams,
  forest = NULL,
  standardConditions = FALSE,
  freq = "days",
  fun = "max"
)
}
\arguments{
\item{x}{An object of class \code{\link{spwb}}, \code{\link{spwb_day}}, \code{\link{pwb}}, \code{\link{growth}}, \code{\link{growth_day}} or \code{\link{fordyn}}.}

\item{SpParams}{A data frame with species parameters (see \code{\link{SpParamsDefinition}} and \code{\link{SpParamsMED}}).}

\item{forest}{An object of class \code{\link{forest}} (needed if \code{x} is not of class \code{\link{fordyn}}).}

\item{standardConditions}{A logical flag to indicate that standard fire weather conditions are to be used (instead of deriving fuel moisture and windspeed from \code{x}).}

\item{freq}{Frequency of summary statistics (see \code{\link{cut.Date}}).}

\item{fun}{Summary function (by default, maximum values).}
}
\value{
A matrix with fire behaviour variables (columns) for each simulated day (rows) or coarser time steps if summaries are requested.
}
\description{
Estimates potential fire behaviour at each daily step of a simulation
}
\details{
Live fuel moisture of shrub and canopy layers is estimated from plant water status.
Dead fuel moisture is estimated following Resco-de-Dios et al. (2015).
}
\examples{
\donttest{
#Load example daily meteorological data
data(examplemeteo)

#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Define soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

#Initialize control parameters
control <- defaultControl("Granier")

#Initialize input
x1 <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)

#Call simulation function
S1 <- spwb(x1, examplemeteo, latitude = 41.82592, elevation = 100)

#Evaluate fire hazard
F1 <- fireHazard(S1, SpParamsMED, exampleforest)
}
}
\references{
Resco de Dios, V., A. W. Fellows, R. H. Nolan, M. M. Boer, R. A. Bradstock, F. Domingo, and M. L. Goulden. 2015. A semi-mechanistic model for predicting the moisture content of fine litter. Agricultural and Forest Meteorology 203:64–73.

Ruffault J, Limousin JM, Pimont F, Dupuy JL, De Cáceres M, Cochard H, Mouillot F, Blackman C, Torres-Ruiz JM, Parsons R,
Moreno M, Delzon S, Jansen S, Olioso A, Choat B, Martin-StPaul N. 2023. Plant hydraulic modelling of leaf and canopy fuel moisture content reveals increasing vulnerability of a Mediterranean forest to wildfires under extreme drought.
New Phytologist. (10.1111/nph.18614).
}
\seealso{
\code{\link{spwb}}, \code{\link{fuel_FCCS}}, \code{\link{fire_FCCS}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{growth}
\alias{growth}
\title{Forest growth}
\usage{
growth(
  x,
  meteo,
  latitude,
  elevation,
  slope = NA_real_,
  aspect = NA_real_,
  CO2ByYear = numeric(0),
  waterTableDepth = NA_real_
)
}
\arguments{
\item{x}{An object of class \code{\link{growthInput}}.}

\item{meteo}{A data frame with daily meteorological data series (see \code{\link{spwb}}).}

\item{latitude}{Latitude (in degrees).}

\item{elevation, slope, aspect}{Elevation above sea level (in m), slope (in degrees) and aspect (in degrees from North).}

\item{CO2ByYear}{A named numeric vector with years as names and atmospheric CO2 concentration (in ppm) as values. Used to specify annual changes in CO2 concentration along the simulation (as an alternative to specifying daily values in \code{meteo}).}

\item{waterTableDepth}{Water table depth (in mm). When not missing, capillarity rise will be allowed if lower than total soil depth.}
}
\value{
Function \code{growth} returns a list of class 'growth'. Since lists are difficult to handle, we recommend using
function \code{\link{extract}} to reshape simulation results (including their units) from those objects.

List elements are as follows:
\itemize{
\item{\code{"latitude"}: Latitude (in degrees) given as input.}
\item{\code{"topography"}: Vector with elevation, slope and aspect given as input.}
\item{\code{"weather"}: A copy of the input weather data frame.}
\item{\code{"growthInput"}: A copy of the object \code{x} of class \code{\link{growthInput}} given as input.}
\item{\code{"growthOutput"}: An copy of the final state of the object \code{x} of class \code{\link{growthInput}}.}
\item{\code{"WaterBalance"}: A data frame where different water balance variables (see \code{\link{spwb}}).}
\item{\code{"EnergyBalance"}: A data frame with the daily values of energy balance components for the soil and the canopy (only for \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}; see \code{\link{spwb}}).}
\item{\code{"CarbonBalance"}: A data frame where different stand-level carbon balance components (gross primary production, maintenance respiration, synthesis respiration, net primary production, heterotrophic respiration and net ecosystem exchange.), all in g C · m-2.}
\item{\code{"BiomassBalance"}: A data frame with the daily values of stand biomass balance components (in g dry · m-2.}
\item{\code{"Temperature"}: A data frame with the daily values of minimum/mean/maximum temperatures for the atmosphere (input), canopy and soil (only for \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}; see \code{\link{spwb}}).}
\item{\code{"Soil"}: A data frame where different soil variables  (see \code{\link{spwb}}).}
\item{\code{"Stand"}: A data frame where different stand-level variables (see \code{\link{spwb}}).}
\item{\code{"Plants"}: A list of daily results for plant cohorts (see \code{\link{spwb}}).}
\item{\code{"SunlitLeaves"} and \code{"ShadeLeaves"}: A list with daily results for sunlit and shade leaves (only for \code{transpirationMode = "Sperry"} or \code{transpirationMode = "Sureau"}; see \code{\link{spwb}}).}
\item{\code{"LabileCarbonBalance"}: A list of daily labile carbon balance results for plant cohorts, with elements:}
\itemize{
\item{\code{"GrossPhotosynthesis"}: Daily gross photosynthesis per dry weight of living biomass (g gluc · g dry-1).}
\item{\code{"MaintentanceRespiration"}: Daily maintenance respiration per dry weight of living biomass (g gluc · g dry-1).}
\item{\code{"GrowthCosts"}: Daily growth costs per dry weight of living biomass (g gluc · g dry-1).}
\item{\code{"RootExudation"}: Root exudation per dry weight of living biomass (g gluc · g dry-1).}
\item{\code{"LabileCarbonBalance"}: Daily labile carbon balance (photosynthesis - maintenance respiration - growth costs - root exudation) per dry weight of living biomass (g gluc · g dry-1).}
\item{\code{"SugarLeaf"}: Sugar concentration (mol·l-1) in leaves.}
\item{\code{"StarchLeaf"}: Starch concentration (mol·l-1) in leaves.}
\item{\code{"SugarSapwood"}: Sugar concentration (mol·l-1) in sapwood.}
\item{\code{"StarchSapwood"}: Starch concentration (mol·l-1) in sapwood.}
\item{\code{"SugarTransport"}:  Average instantaneous rate of carbon transferred between leaves and stem compartments via floem (mol gluc·s-1).}
}
\item{\code{"PlantBiomassBalance"}: A list of daily plant biomass balance results for plant cohorts, with elements:}
\itemize{
\item{\code{"StructuralBiomassBalance"}: Daily structural biomass balance (g dry · m-2).}
\item{\code{"LabileBiomassBalance"}: Daily labile biomass balance (g dry · m-2).}
\item{\code{"PlantBiomassBalance"}: Daily plant biomass balance, i.e. labile change + structural change (g dry · m-2).}
\item{\code{"MortalityBiomassLoss"}: Biomass loss due to mortality (g dry · m-2).}
\item{\code{"CohortBiomassBalance"}: Daily cohort biomass balance (including mortality) (g dry · m-2).}
}
\item{\code{"PlantStructure"}: A list of daily area and biomass values for compartments of plant cohorts, with elements:}
\itemize{
\item{\code{"LeafBiomass"}: Daily amount of leaf structural biomass (in g dry) for an average individual of each plant cohort.}
\item{\code{"SapwoodBiomass"}: Daily amount of sapwood structural biomass (in g dry) for an average individual of each plant cohort.}
\item{\code{"FineRootBiomass"}: Daily amount of fine root biomass (in g dry) for an average individual of each plant cohort.}
\item{\code{"LeafArea"}: Daily amount of leaf area (in m2) for an average individual of each plant cohort.}
\item{\code{"SapwoodArea"}: Daily amount of sapwood area (in cm2) for an average individual of each plant cohort.}
\item{\code{"FineRootArea"}: Daily amount of fine root area (in m2) for an average individual of each plant cohort.}
\item{\code{"HuberValue"}: The ratio of sapwood area to (target) leaf area (in cm2/m2).}
\item{\code{"RootAreaLeafArea"}: The ratio of fine root area to (target) leaf area (in m2/m2).}
\item{\code{"DBH"}: Diameter at breast height (in cm) for an average individual of each plant cohort.}
\item{\code{"Height"}: Height (in cm) for an average individual of each plant cohort.}
}
\item{\code{"GrowthMortality"}: A list of daily growth and mortality rates for plant cohorts, with elements:}
\itemize{
\item{\code{"LAgrowth"}: Leaf area growth (in m2·day-1) for an average individual of each plant cohort.}
\item{\code{"SAgrowth"}: Sapwood area growth rate (in cm2·day-1) for an average individual of each plant cohort.}
\item{\code{"FRAgrowth"}: Fine root area growth (in m2·day-1) for an average individual of each plant cohort.}
\item{\code{"StarvationRate"}: Daily mortality rate from starvation (ind/d-1).}
\item{\code{"DessicationRate"}: Daily mortality rate from dessication (ind/d-1).}
\item{\code{"MortalityRate"}: Daily mortality rate (any cause) (ind/d-1).}
}
\item{\code{"DecompositionPools"}: A data frame with the mass of different decomposition carbon pools, all in g C · m-2.}
\item{\code{"subdaily"}: A list of objects of class \code{\link{growth_day}}, one per day simulated (only if required in \code{control} parameters, see \code{\link{defaultControl}}).}
}
}
\description{
Function \code{growth} is a process-based model that performs energy, water and carbon balances;
and determines changes in water/carbon pools, functional variables (leaf area, sapwood area, root area)
and structural ones (tree diameter, tree height, shrub cover) for woody plant cohorts in a given forest stand
during a period specified in the input climatic data.
}
\details{
Detailed model description is available in the medfate book.

Forest growth simulations allow using different sub-models for bulk soil water flows and different sub-models of transpiration and photosynthesis (see details in \code{\link{spwb}}).
}
\examples{
\donttest{
#Load example daily meteorological data
data(examplemeteo)

#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)
  
#Initialize control parameters
control <- defaultControl("Granier")
  
#Initialize soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

#Initialize model input
x1 <- growthInput(exampleforest, examplesoil, SpParamsMED, control)

#Call simulation function
G1 <- growth(x1, examplemeteo, latitude = 41.82592, elevation = 100)
 
#Switch to 'Sperry' transpiration mode
control <- defaultControl("Sperry")

#Initialize model input
x2 <- growthInput(exampleforest,examplesoil, SpParamsMED, control)

#Call simulation function
G2 <-growth(x2, examplemeteo, latitude = 41.82592, elevation = 100)

#Switch to 'Sureau' transpiration mode
control <- defaultControl("Sureau")

#Initialize model input
x3 <- growthInput(exampleforest,examplesoil, SpParamsMED, control)

#Call simulation function
G3 <-growth(x3, examplemeteo, latitude = 41.82592, elevation = 100)
}
      
}
\references{
De Cáceres M, Molowny-Horas R, Cabon A, Martínez-Vilalta J, Mencuccini M, García-Valdés R, Nadal-Sala D, Sabaté S,
Martin-StPaul N, Morin X, D'Adamo F, Batllori E, Améztegui A (2023) MEDFATE 2.9.3: A trait-enabled model to simulate
Mediterranean forest function and dynamics at regional scales.
Geoscientific Model Development 16: 3165-3201 (https://doi.org/10.5194/gmd-16-3165-2023).
}
\seealso{
\code{\link{growthInput}}, \code{\link{growth_day}}, \code{\link{plot.growth}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shinyplot.R
\name{shinyplot}
\alias{shinyplot}
\alias{shinyplot.growth}
\alias{shinyplot.aspwb}
\alias{shinyplot.spwb}
\alias{shinyplot.pwb}
\alias{shinyplot.fordyn}
\alias{shinyplot.growth_day}
\alias{shinyplot.spwb_day}
\alias{shinyplot.pwb_day}
\title{Shiny app with interactive plots}
\usage{
shinyplot(x, ...)

\method{shinyplot}{growth}(x, measuredData = NULL, ...)

\method{shinyplot}{aspwb}(x, measuredData = NULL, ...)

\method{shinyplot}{spwb}(x, measuredData = NULL, ...)

\method{shinyplot}{pwb}(x, measuredData = NULL, ...)

\method{shinyplot}{fordyn}(x, measuredData = NULL, ...)

\method{shinyplot}{growth_day}(x, ...)

\method{shinyplot}{spwb_day}(x, ...)

\method{shinyplot}{pwb_day}(x, ...)
}
\arguments{
\item{x}{An object of the right class.}

\item{...}{Additional parameters.}

\item{measuredData}{A data frame with observed/measured values (see \code{\link{evaluation_plot}}).}
}
\value{
An object that represents the shiny app
}
\description{
Creates a shiny app with interactive plots for simulation results and evaluation
}
\details{
Only run this function in interactive mode. When \code{measuredData} is not \code{NULL}, an additional panel is shown for evaluation plots.
}
\seealso{
\code{\link{plot.spwb}}, \code{\link{evaluation_plot}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dataset_documentation.R
\docType{data}
\name{exampleobs}
\alias{exampleobs}
\title{Example observed data}
\format{
A data frame containing daily 'observed' values for year 2001:
\describe{
\item{\code{dates}}{Measurement dates.}
\item{\code{SWC}}{Soil moisture content (in m3/m3).}
\item{\code{ETR}}{Total evapotranspiration (mm).}
\item{\code{E_T1_148}}{Transpiration of Pinus halepensis cohort 'T1_148' (L/m2 of leaf area).}
\item{\code{E_T2_168}}{Transpiration of Quercus ilex cohort 'T2_168' (L/m2 of leaf area).}
\item{\code{FMC_T1_148}}{Fuel moisture content of Pinus halepensis cohort 'T1_148'  (in percent).}
\item{\code{FMC_T2_168}}{Fuel moisture content of Quercus ilex cohort 'T2_168' (in percent).}
\item{\code{BAI_T1_148}}{Basal area increment for Pinus halepensis cohort 'T1_148'  (in cm2).}
\item{\code{BAI_T2_168}}{Basal area increment for Quercus ilex cohort 'T2_168' (in cm2).}
\item{\code{DI_T1_148}}{Diameter increment for Pinus halepensis cohort 'T1_148'  (in cm).}
\item{\code{DI_T2_168}}{Diameter increment for Quercus ilex cohort 'T2_168' (in cm).}
}
}
\source{
This data set was actually created by running a simulation and adding some gaussian error to the outputs.
}
\description{
Example (fake) data set of variables measured in a plot.
}
\examples{
data(exampleobs)
}
\seealso{
\code{\link{evaluation}}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R,
%   R/hydraulics_vulnerabilityCurvePlot.R
\name{hydraulics_averagePsi}
\alias{hydraulics_averagePsi}
\alias{hydraulics_psi2Weibull}
\alias{hydraulics_conductancefunctions}
\alias{hydraulics_psi2K}
\alias{hydraulics_K2Psi}
\alias{hydraulics_xylemConductance}
\alias{hydraulics_xylemConductanceSigmoid}
\alias{hydraulics_xylemPsi}
\alias{hydraulics_psiCrit}
\alias{hydraulics_vanGenuchtenConductance}
\alias{hydraulics_correctConductanceForViscosity}
\alias{hydraulics_vulnerabilityCurvePlot}
\title{Hydraulic conductance functions}
\usage{
hydraulics_averagePsi(psi, v, exp_extract, psi_extract)

hydraulics_psi2Weibull(psi50, psi88 = NA_real_, psi12 = NA_real_)

hydraulics_psi2K(psi, psi_extract, exp_extract = 3)

hydraulics_K2Psi(K, psi_extract, exp_extract = 3)

hydraulics_xylemConductance(psi, kxylemmax, c, d)

hydraulics_xylemConductanceSigmoid(psi, kxylemmax, P50, slope)

hydraulics_xylemPsi(kxylem, kxylemmax, c, d)

hydraulics_psiCrit(c, d, pCrit = 0.001)

hydraulics_vanGenuchtenConductance(psi, krhizomax, n, alpha)

hydraulics_correctConductanceForViscosity(kxylem, temp)

hydraulics_vulnerabilityCurvePlot(
  x,
  soil = NULL,
  type = "leaf",
  vulnerabilityFunction = "Weibull",
  psiVec = seq(-0.1, -8, by = -0.01),
  relative = FALSE,
  speciesNames = FALSE,
  draw = TRUE,
  ylim = NULL,
  xlab = NULL,
  ylab = NULL
)
}
\arguments{
\item{psi}{A scalar (or a vector, depending on the function) with water potential (in MPa).}

\item{v}{Proportion of fine roots within each soil layer.}

\item{exp_extract}{Exponent of the whole-plant relative transpiration Weibull function.}

\item{psi_extract}{Soil water potential (in MPa) corresponding to 50\% whole-plant relative transpiration.}

\item{psi50, psi88, psi12}{Water potentials (in MPa) corresponding to 50\%, 88\% and 12\% percent conductance loss.}

\item{K}{Whole-plant relative conductance (0-1).}

\item{kxylemmax}{Maximum xylem hydraulic conductance (defined as flow per leaf surface unit and per pressure drop).}

\item{c, d}{Parameters of the Weibull function (generic xylem vulnerability curve).}

\item{kxylem}{Xylem hydraulic conductance (defined as flow per surface unit and per pressure drop).}

\item{pCrit}{Proportion of maximum conductance considered critical for hydraulic functioning.}

\item{krhizomax}{Maximum rhizosphere hydraulic conductance (defined as flow per leaf surface unit and per pressure drop).}

\item{n, alpha}{Parameters of the Van Genuchten function (rhizosphere vulnerability curve).}

\item{temp}{Temperature (in degrees Celsius).}

\item{x}{An object of class \code{\link{spwbInput}}.}

\item{soil}{A list containing the description of the soil (see \code{\link{soil}}).}

\item{type}{Plot type for \code{hydraulics_vulnerabilityCurvePlot}, either \code{"leaf"},
\code{"stem"}, \code{"root"} or \code{"rhizosphere"}).}

\item{vulnerabilityFunction}{String indicating the function used to represent vulnerability in plant segments, either "Weibull" or "Sigmoid".}

\item{psiVec}{Vector of water potential values to evaluate for the vulnerability curve.}

\item{relative}{A flag to relativize vulnerability curves to the [0-1] interval.}

\item{speciesNames}{A flag to indicate the use of species names instead of cohort names in plots.}

\item{draw}{A flag to indicate whether the vulnerability curve should be drawn or just returned.}

\item{ylim, xlab, ylab}{Graphical parameters to override function defaults.}
}
\value{
Values returned for each function are:
\itemize{
\item{\code{hydraulics_psi2K}: Whole-plant relative conductance (0-1).}
\item{\code{hydraulics_K2Psi}: Soil water potential (in MPa) corresponding to the given whole-plant relative conductance value (inverse of \code{hydraulics_psi2K()}).}
\item{\code{hydraulics_averagePsi}: The average water potential (in MPa) across soil layers.}
\item{\code{hydraulics_vanGenuchtenConductance}: Rhizosphere conductance corresponding to an input water potential (soil vulnerability curve).}
\item{\code{hydraulics_xylemConductance}: Xylem conductance (flow rate per pressure drop) corresponding to an input water potential (plant vulnerability curve).}
\item{\code{hydraulics_xylemPsi}: Xylem water potential (in MPa) corresponding to an input xylem conductance (flow rate per pressure drop).}
\item{\code{hydraulics_psi2Weibull}: Parameters of the Weibull vulnerability curve that goes through the supplied psi50 and psi88 values.}
}
}
\description{
Set of functions used in the calculation of soil and plant hydraulic conductance.
}
\details{
Details of plant hydraulic models are given the medfate book.
Function \code{hydraulics_vulnerabilityCurvePlot} draws a plot of the vulnerability curves for the given \code{soil} object and network properties of each plant cohort in \code{x}.
}
\examples{

#Manual display of vulnerability curve
kstemmax = 4 # in mmol·m-2·s-1·MPa-1
stemc = 3 
stemd = -4 # in MPa
psiVec = seq(-0.1, -7.0, by =-0.01)
kstem = unlist(lapply(psiVec, hydraulics_xylemConductance, kstemmax, stemc, stemd))
plot(-psiVec, kstem, type="l",ylab="Xylem conductance (mmol·m-2·s-1·MPa-1)", 
     xlab="Canopy pressure (-MPa)", lwd=1.5,ylim=c(0,kstemmax))

#Load example dataset
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Initialize soil with default soil params (4 layers)
examplesoil <- defaultSoilParams(4)

#Initialize control parameters
control <- defaultControl("Granier")

#Switch to 'Sperry' transpiration mode
control <- defaultControl("Sperry")

#Initialize input
x <- spwbInput(exampleforest,examplesoil, SpParamsMED, control)

#Leaf vulnerability curves
hydraulics_vulnerabilityCurvePlot(x, type="leaf")

#Stem vulnerability curves
hydraulics_vulnerabilityCurvePlot(x, type="stem")
             
}
\references{
Sperry, J. S., F. R. Adler, G. S. Campbell, and J. P. Comstock. 1998. Limitation of plant water use by rhizosphere and xylem conductance: results from a model. Plant, Cell and Environment 21:347–359.

Sperry, J. S., and D. M. Love. 2015. What plant hydraulics can tell us about responses to climate-change droughts. New Phytologist 207:14–27.
}
\seealso{
\code{\link{hydraulics_supplyFunctionPlot}}, \code{\link{hydraulics_maximumStemHydraulicConductance}}, \code{\link{spwb}}, \code{\link{soil}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R, R/hydrology_interception.R
\name{hydrology_rainfallIntensity}
\alias{hydrology_rainfallIntensity}
\alias{hydrology_interception}
\alias{hydrology_rainInterception}
\alias{hydrology_interceptionPlot}
\title{Rainfall interception}
\usage{
hydrology_rainfallIntensity(month, prec, rainfallIntensityPerMonth)

hydrology_rainInterception(Rainfall, Cm, p, ER = 0.05, model = "Gash1995")

hydrology_interceptionPlot(
  x,
  SpParams,
  ER = 0.05,
  gdd = NA,
  throughfall = FALSE,
  model = "Gash1995"
)
}
\arguments{
\item{month}{Month of the year (from 1 to 12).}

\item{prec}{Precipitation for a given day (mm).}

\item{rainfallIntensityPerMonth}{A vector with twelve positions with average intensity of rainfall (in mm/h) for each month.}

\item{Rainfall}{A numeric vector of (daily) rainfall.}

\item{Cm}{Canopy water storage capacity.}

\item{p}{Proportion of throughfall (normally 1 - c, where c is the canopy cover).}

\item{ER}{The ratio of evaporation rate to rainfall rate.}

\item{model}{Rainfall interception model (either \code{"Gash1995"} or \code{"Liu2001"}).}

\item{x}{An object of class \code{\link{spwbInput}}.}

\item{SpParams}{A data frame with species parameters (see \code{\link{SpParamsMED}} and \code{\link{SpParamsMED}}).}

\item{gdd}{Growth degree days (in Celsius).}

\item{throughfall}{Boolean flag to plot relative throughfall instead of percentage of intercepted rainfall.}
}
\value{
Function \code{hydrology_rainInterception} returns a vector of the same length as \code{Rainfall} containing intercepted rain values.

Function \code{hydrology_rainfallIntensity} returns a scalar with the rainfall intensity.
}
\description{
Function \code{hydrology_rainInterception} calculates the amount of rainfall intercepted daily by the canopy, given a rainfall and canopy characteristics.
Two canopy interception models are currently available: the sparse Gash (1995) model and the Liu (2001) model.
In both cases the current implementation assumes no trunk interception.
}
\details{
Function \code{hydrology_rainInterception} can accept either vectors or scalars as parameters \code{Cm}, \code{p} and \code{ER}. If they are supplied as vectors they should be of the same length as \code{Rainfall}.

Function \code{hydrology_rainfallIntensity} estimates the rainfall intensity (mm/h) for input values of rainfall and seasonal variation in rainfall intensity (mm/h).
}
\examples{
#Load example plot plant data
data(exampleforest)

#Default species parameterization
data(SpParamsMED)

#Draw rainfall interception for two values of the E/R ratio
hydrology_interceptionPlot(exampleforest, SpParamsMED, ER = c(0.05, 0.2))

}
\references{
Liu (2001). Evaluation of the Liu model for predicting rainfall interception in forests world-wide. - Hydrol. Process. 15: 2341-2360.

Gash (1979). An analytical model of rainfall interception by forests. - Quarterly Journal of the Royal Meteorological Society.

Gash et al. (1995). Estimating sparse forest rainfall interception with an analytical model. - Journal of Hydrology.
}
\seealso{
\code{\link{spwb}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/forest_mergeTrees.R
\name{forest_simplification}
\alias{forest_simplification}
\alias{forest_mergeTrees}
\alias{forest_mergeShrubs}
\alias{forest_mergeHerbs}
\alias{forest_reduceToDominant}
\title{Forest complexity reduction}
\usage{
forest_mergeTrees(x, byDBHclass = TRUE, keepCohortsWithObsID = FALSE)

forest_mergeShrubs(x, byHeightclass = TRUE, keepCohortsWithObsID = FALSE)

forest_mergeHerbs(x, byHeightclass = TRUE, keepCohortsWithObsID = FALSE)

forest_reduceToDominant(x, SpParams)
}
\arguments{
\item{x}{An object of class \code{\link{forest}}.}

\item{byDBHclass}{Logical flag to indicate that 5-cm tree DBH classes should be kept separated.}

\item{keepCohortsWithObsID}{Logical flag to indicate that cohorts with non-missin ObsID should be spared from merging.}

\item{byHeightclass}{Boolean flag to indicate that 10-cm shrub height classes should be kept separated.}

\item{SpParams}{A data frame with species parameters (see \code{\link{SpParamsDefinition}} and \code{\link{SpParamsMED}}).}
}
\value{
Another \code{\link{forest}} object with simplified structure/composition, depending on the function.
}
\description{
Functions \code{forest_mergeTrees}, \code{forest_mergeShrubs} and \code{forest_mergeHerbs} merge cohorts of a \code{\link{forest}} object.
Function \code{forest_reduceToDominant} performs a strongest simplification of plant cohorts (see details).
}
\details{
Tree DBH classes are defined in 5-cm intervals, whereas shrub/herb height classes are defined in 10-cm intervals.
Tree DBH and shrub/herb height classes are defined up to a specific size (i.e. larger plants are not merged)
corresponding to 52.5 cm and 90 cm, respectively.

Function \code{forest_reduceToDominant} simplifies the input forest to the tree cohort of highest LAI, among those of the tree species with highest LAI.
The leaf area index of the whole tree layer will be attributed to the chosen cohort. The same is performed for the shrub and herb layers.
}
\examples{
# Example forest data
data("exampleforest")

# Reduce to dominant tree and dominant shrub
reduced <- forest_reduceToDominant(exampleforest, SpParamsMED)

# Check that overall LAI does not change
stand_LAI(exampleforest, SpParamsMED)
stand_LAI(reduced, SpParamsMED)
}
\seealso{
\code{\link{spwb}}, \code{\link{forest}},  \code{\link{forest_mapWoodyTables}}, \code{\link{fordyn}}, \code{\link{summary.forest}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dataset_documentation.R
\docType{data}
\name{SpParams}
\alias{SpParams}
\alias{SpParamsDefinition}
\alias{SpParamsMED}
\title{Data tables with species parameter definitions and values}
\format{
\itemize{
\item{Data frame \code{SpParamsDefinition} has parameters in rows and columns 'ParameterName', 'ParameterGroup', 'Definition', 'Type' and 'Units'.}
\item{Data frames \code{SpParamsMED} has species or genus as rows and column names equal to parameter names in \code{SpParamsDefinition}.}
}
}
\description{
A data sets of species parameter definition and values, the latter resulting from existing databases, fit to empirical data or expert-based guesses.
}
\details{
\code{SpParamsMED} was the official species parameter for package versions up to v.4.0.0, but will not be maintained in the future. Additional
species parameter tables for different countries are distributed via package \href{https://emf-creaf.github.io/traits4models/}{traits4models}.
}
\examples{
data(SpParamsDefinition)
data(SpParamsMED)
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{herb_values}
\alias{herb_values}
\alias{herb_foliarBiomass}
\alias{herb_fuelLoading}
\alias{herb_LAI}
\title{Herbaceous description functions}
\usage{
herb_foliarBiomass(x, SpParams)

herb_fuelLoading(x, SpParams)

herb_LAI(x, SpParams)
}
\arguments{
\item{x}{An object of class \code{\link{forest}}.}

\item{SpParams}{A data frame with species parameters (see \code{\link{SpParamsMED}}).}
}
\value{
A single scalar:
\itemize{
\item{\code{herb_foliarBiomass}: Herbaceous biomass of leaves (in kg/m2).}
\item{\code{herb_fuelLoading}: Herbaceous fine fuel loading (in kg/m2).}
\item{\code{herb_LAI}: Herbaceous leaf area index (m2/m2).}
}
}
\description{
Functions to calculate attributes of the herbaceous component of a \code{\link{forest}} object
}
\seealso{
\code{\link{spwb}}, \code{\link{forest}}, \code{\link{plant_basalArea}}, \code{\link{summary.forest}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{wind}
\alias{wind}
\alias{wind_canopyTurbulenceModel}
\alias{wind_canopyTurbulence}
\title{Models for canopy turbulence}
\usage{
wind_canopyTurbulenceModel(zm, Cx, hm, d0, z0, model = "k-epsilon")

wind_canopyTurbulence(
  zmid,
  LAD,
  canopyHeight,
  u,
  windMeasurementHeight = 200,
  model = "k-epsilon"
)
}
\arguments{
\item{zm}{A numeric vector with height values (m).}

\item{Cx}{Effective drag = Cd x leaf area density.}

\item{hm}{Canopy height (m).}

\item{d0}{Zero displacement height (m).}

\item{z0}{Momentum roughness height (m).}

\item{model}{Closure model.}

\item{zmid}{A numeric vector of mid-point heights (in cm) for canopy layers.}

\item{LAD}{A numeric vector of leaf area density values (m3/m2).}

\item{canopyHeight}{Canopy height (in cm).}

\item{u}{Measured wind speed (m/s).}

\item{windMeasurementHeight}{Height of wind speed measurement with respect to canopy height (cm).}
}
\value{
Function \code{wind_canopyTurbulenceModel} returns a data frame of vertical profiles for variables:
\itemize{
\item{\code{z1}: Height values.}
\item{\code{U1}: U/u*, where U is mean velocity and u* is friction velocity.}
\item{\code{dU1}: dUdz/u*, where dUdz is mean velocity gradient and u* is friction velocity.}
\item{\code{epsilon1}: epsilon/(u^3/h) where epsilon is the turbulent kinetic dissipation rate, u* is friction velocity and h is canopy height.}
\item{\code{k1}: k/(u*^2), where k is the turbulent kinetic energy and u* is friction velocity.}
\item{\code{uw1}: uw/(u*^2), where uw is the Reynolds stress and u* is friction velocity.}
\item{\code{Lmix1}: Mixing length.}
}

Function \code{wind_canopyTurbulence} returns a data frame of vertical profiles for transformed variables:
\itemize{
\item{\code{zmid}: Input mid-point heights (in cm) for canopy layers.}
\item{\code{u}: Wind speed (m/s).}
\item{\code{du}: Mean velocity gradient (1/s).}
\item{\code{epsilon}: Turbulent kinetic dissipation rate.}
\item{\code{k}: Turbulent kinetic energy.}
\item{\code{uw}: Reynolds stress.}
}
}
\description{
Models for canopy turbulence by Katul et al (2004).
}
\details{
Implementation in Rcpp of the K-epsilon canopy turbulence models by Katul et al (2004) originally in Matlab code (https://nicholas.duke.edu/people/faculty/katul/k_epsilon_model.htm).
}
\examples{
#Default species parameterization
data(SpParamsMED)

#Load example plot plant data
data(exampleforest)

#Canopy height (in m)
h= max(exampleforest$treeData$Height/100) 
d0 = 0.67*h
z0 = 0.08*h

#Height values (cm)
z = seq(50,1000, by=50)
zm = z/100 # (in m)

# Leaf area density
lad = vprofile_leafAreaDensity(exampleforest, SpParamsMED, draw = FALSE,
                               z = c(0,z))
  
# Effective drag
Cd = 0.2
Cx = Cd*lad
  
# canopy turbulence model
wind_canopyTurbulenceModel(zm, Cx,h,d0,z0)

}
\references{
Katul GG, Mahrt L, Poggi D, Sanz C (2004) One- and two-equation models for canopy turbulence. Boundary-Layer Meteorol 113:81–109. https://doi.org/10.1023/B:BOUN.0000037333.48760.e5
}
\seealso{
\code{\link{vprofile_windExtinction}}
}
\author{
Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{fire_severity}
\alias{fire_severity}
\alias{fire_plumeTemperature}
\alias{fire_barkThermalDiffusivity}
\alias{fire_radialBoleNecrosis}
\alias{fire_leafThermalFactor}
\alias{fire_necrosisCriticalTemperature}
\alias{fire_necrosisHeight}
\title{Fire severity functions}
\usage{
fire_plumeTemperature(Ib_surf, z, T_air = 25, rho_air = 1.169)

fire_barkThermalDiffusivity(fmc_bark, rho_bark = 500, T_air = 25)

fire_radialBoleNecrosis(
  Ib_surf,
  t_res,
  bark_diffusivity,
  T_air = 25,
  rho_air = 1.169
)

fire_leafThermalFactor(SLA, h = 130, c = 2500)

fire_necrosisCriticalTemperature(t_res, thermal_factor, T_air = 25)

fire_necrosisHeight(
  Ib_surf,
  t_res,
  thermal_factor,
  T_air = 25,
  rho_air = 1.169
)
}
\arguments{
\item{Ib_surf}{Surface fireline intensity (kW/m).}

\item{z}{height (m).}

\item{T_air}{Air temperature (degrees Celsius).}

\item{rho_air}{Air density (kg/m3).}

\item{fmc_bark}{Bark moisture content (\% dry weight).}

\item{rho_bark}{Bark density (kg/m3).}

\item{t_res}{fire residence time (seconds).}

\item{bark_diffusivity}{Bark thermal diffusivity (m2/s).}

\item{SLA}{Specific leaf area (m2/kg).}

\item{h}{Heat transfer coefficient}

\item{c}{Specific heat capacity}

\item{thermal_factor}{Tissue thermal factor.}
}
\value{
\itemize{
\item{Function \code{fire_plumeTemperature} returns the plume temperature at a given height.}
\item{Function \code{fire_barkThermalDiffusivity} returns the bark thermal diffusivity given a bark moisture value.}
\item{Function \code{fire_radialBoleNecrosis} returns the depth of radial bole necrosis in cm.}
\item{Function \code{fire_leafThermalFactor} returns the thermal factor of leaves as a function of specific leaf area.}
\item{Function \code{fire_necrosisCriticalTemperature} returns the (plume) temperature yielding necrosis for a given residence time and tissue thermal factor.}
\item{Function \code{fire_necrosisHeight} returns the height (in m) of necrosis for tissues with given thermal factor.}
}
}
\description{
Functions to estimate fire effects on foliage, buds and cambium, based on the model
by Michaletz & Johnson (2008)
}
\references{
Michaletz, S.T., and Johnson, E.A. 2006. A heat transfer model of crown scorch in forest fires. Can. J. For. Res. 36: 2839–2851. doi:10.1139/X06-158.

Michaletz ST, Johnson EA. 2008. A biophysical process model of tree mortality in surface fires. Canadian Journal of Forest Research 38: 2013–2029.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R,
%   R/woodformation_relativeGrowthRate.R
\name{woodformation}
\alias{woodformation}
\alias{woodformation_initRing}
\alias{woodformation_growRing}
\alias{woodformation_temperatureEffect}
\alias{woodformation_relativeExpansionRate}
\alias{woodformation_relativeGrowthRate}
\title{Wood formation}
\usage{
woodformation_initRing()

woodformation_growRing(
  ring,
  psi,
  Tc,
  Nc = 8.85,
  phi0 = 0.13,
  pi0 = -0.8,
  CRD0 = 8.3,
  Y_P = 0.05,
  Y_T = 5,
  h = 0.043 * 1.8,
  s = 1.8
)

woodformation_temperatureEffect(
  Tc,
  Y_T = 5,
  DHa = 87500,
  DSd = 1090,
  DHd = 333000
)

woodformation_relativeExpansionRate(psi, Tc, pi, phi, Y_P, Y_T)

woodformation_relativeGrowthRate(dbh1, dbh2, yeardiff, lower = -2, upper = 8)
}
\arguments{
\item{ring}{An object of class \code{\link{ring}} returned by function \code{woodformation_initRing}.}

\item{psi}{Water potential (in MPa).}

\item{Tc}{Temperature in Celsius.}

\item{Nc}{Number of active cells in the cambium.}

\item{phi0}{Initial value of cell extensibility (in MPa-1 day-1)}

\item{pi0}{Initial value of cell osmotic potential (in MPa)}

\item{CRD0}{Initial value of cell radial diameter}

\item{Y_P}{Turgor pressure yield threshold (in MPa)}

\item{Y_T}{Temperature yield threshold (in Celsius)}

\item{h}{Cell wall hardening coefficient (in day-1)}

\item{s}{Cell wall softening coefficient (unitless)}

\item{DHa, DSd, DHd}{Enthalpy of activation, enthalpy difference and entropy difference between the catalytically active and inactive states of the enzymatic system (Parent et al. 2010).}

\item{pi}{Osmotic potential (in MPa)}

\item{phi}{Cell extensibility (in MPa-1 day-1)}

\item{dbh1, dbh2}{Initial and final diameter at breast height.}

\item{yeardiff}{Interval between dbh measurements, in years.}

\item{lower, upper}{Lower and upper bounds for root finding.}
}
\value{
Function \code{woodformation_initRing()} returns a list of class 'ring',
that is a list containing a data frame \code{cells} and two vectors: \code{P} and \code{SA}.
Dataframe \code{cells} contains the columns "formation_date", "phi", "pi" and "CRD" and as many rows as dates processed.
Vectors \code{P} and \code{SA} contain, respectively, the number of cells produced and the sapwood area
corresponding to the ring of cells (assuming a tangencial radius of 20 micrometers).

Function \code{woodformation_growRing()} modifies the input 'ring' object according to the environmental conditions given as input.

Function \code{woodformation_relativeExpansionRate()} returns a numeric scalar with the relative expansion rate.

Function \code{woodformation_temperatureEffect()} returns a scalar between 0 and 1 reflecting the temperature effect on tissue formation rate.

Function \code{woodformation_relativeGrowthRate} returns the annual growth rate, relative to cambium perimeter, estimated from initial and final diameter values.
}
\description{
Functions to initialize and expand a ring of tracheids to simulate secondary growth.
}
\note{
Code modified from package xylomod by Antoine Cabon, available at GitHub
}
\references{
Cabon A, \enc{Fernández-de-Uña}{Fernandez-de-Una} L, Gea-Izquierdo G, Meinzer FC, Woodruff DR, \enc{Martínez-Vilalta}{Martinez-Vilalta} J, De \enc{Cáceres}{Caceres} M. 2020a. Water potential control of turgor-driven tracheid enlargement in Scots pine at its xeric distribution edge. New Phytologist 225: 209–221.

Cabon A, Peters RL, Fonti P, \enc{Martínez-Vilalta}{Martinez-Vilalta}  J, De \enc{Cáceres}{Caceres} M. 2020b. Temperature and water potential co-limit stem cambial activity along a steep elevational gradient. New Phytologist: nph.16456.

Parent, B., O. Turc, Y. Gibon, M. Stitt, and F. Tardieu. 2010. Modelling temperature-compensated physiological rates, based on the co-ordination of responses to temperature of developmental processes. Journal of Experimental Botany 61:2057–2069.
}
\seealso{
\code{\link{growth}}
}
\author{
Antoine Cabon, CTFC

Miquel De \enc{Cáceres}{Caceres} Ainsa, CREAF
}
\keyword{internal}
